﻿/*
 * 动画数据
 * 一个动作的数据提供类，包含多个方向
 * 提供动画的基本信息和动画实际帧
 * tyevlag
 */
var MAnimationDataDir = MAnimationDataDir || cc.Class.extend({
	oOwner:null,
		
	sUrl:null,
	sKey:null,

	nInterval:0,
	nBlend:0,
	
	// 方向数
	nNumdir:0,
	// 单方向帧数
	nDirFrameNum:0,

	nMaxFrameNum:0,
	
	bLoop:false,
	bDispose:false,
	
	aDirAnimList:null,
	
	fCallbackResLoaded:null,
	
	bNoRes:false,
	
	// 不能被销毁，比如默认资源
	bCanNotDispose:false,
	
	// 加载状态
	nLoadState:0,
	
	ctor:function(){
		this.aDirAnimList = [];
		this.oOwner = [];
	},
	
	SetData:function(owner){
		if( this.oOwner.indexOf( owner ) == -1 ){
			this.oOwner.push(owner);
		}
		else{
			cc.log( " ***************************************************** oh shit, it's impossible!" );
		}
	},

	ReleaseData:function(owner){
		var index = this.oOwner.indexOf( owner );
		if( index != -1 )
			this.oOwner.splice(index, 1);
		else
			cc.log( " ***************************************************** wtf, it's impossible!" );

		if( this.oOwner.length == 0 )
			MAnimationMgr.ReleaseAnimation(this);
	},
	
	SetResName:function(url){
		if (this.bDispose){
			return;
		}
		
		this.sUrl = url;
		this.sKey = url;

		 // zz.Log("@@ SetResNameSetResNameSetResName fullurl 0:" + url + " " + this.aDirAnimList.length);
		MAnimationMgr.GetAnimation(url, this.CallbackFrameLoaded, this);
		if( !this.IsLoaded() )	//没有的才callback
			this.needCallBack = true;
	},

	// 这里是动画资源加载好的回调
	// 多个方向不一定一次性加载完成
	// （目前为一个动作的全部方向，如果要分方向的话，这里可能只能填部分帧）
	// 这里按理说还有一个动画配置文件的加载回调
	CallbackFrameLoaded:function(frames, animjson){
		this.nLoadState = 1;
		
		if (this.bDispose){
			return;
		}
		
		this.nNumdir = animjson.mdirnum;
		this.bLoop = (animjson.mloop == "1");
		this.nInterval = (animjson.minterval / 1000);//0.07;
		this.nBlend = animjson.blendMode;
		// ToolBase.Log("@@ CallbackFrameLoaded frames.length:" + frames.length + " sActionName:" + this.sActionName + " nNumdir:" + this.nNumdir);
//		animmeta.mactionname;
//		animmeta.mver;
//		animmeta.mblend;

		if ((frames.length % this.nNumdir) != 0){
			ToolBase.LogError("方向和帧数不一致>" + this.sUrl);
			return;
		}

		this.nDirFrameNum = frames.length / this.nNumdir;
		for (var i = 0; i < this.nNumdir; i++){
			var tmpFrames = [];
			for ( var j = 0; j < this.nDirFrameNum; j++ ){
				tmpFrames[j] = frames[i * this.nDirFrameNum + j];
			}
			this.aDirAnimList[i] = new cc.Animation(tmpFrames, this.nInterval);
			this.aDirAnimList[i].retain();	//不用cc.animationCache了 一会cocos的一会自己的内存管理 太乱了
		}

		// 通知动画播放类资源下载完成，便于生成动画
		if (this.needCallBack){
			for( var i = 0; i < this.oOwner.length; i++ ){
				var owner = this.oOwner[i];
				if( owner.CallbackResLoaded )
					owner.CallbackResLoaded.call(owner, this);
			}
		}
	},
	
	CallbackFrameLoadError:function(frames){
		this.nLoadState = 2;
		ToolBase.Log("@@ CallbackFrameLoadError :" + this.sUrl);
		if (this.bDispose){
			return;
		}
		
		this.bNoRes = true;
		// 通知动画播放类资源下载失败，便于处理
		if (this.oOwner != null && this.oOwner.CallbackResLoadError != undefined){
			this.oOwner.CallbackResLoadError.call(this.oOwner, this);
		}
	},

	Dispose:function(){
		if (this.bCanNotDispose)
			return;
		
		this.oOwner = null;
		for( var i = 0; i < this.aDirAnimList.length; i++ )
			this.aDirAnimList[i].release();
		this.aDirAnimList = null;
		this.bDispose = true;
	},
	
	IsLoaded:function(){
		return this.nLoadState == 1;
	},
	
	IsLoadEnd:function(){
		return this.nLoadState != 0;
	},
	
	GetDirAnim:function(dir){
		if (dir < 0 || dir >= this.aDirAnimList.length){
			return null;
		}
		return this.aDirAnimList[dir];
	},
});