﻿
/*
 * 动画对象（动画显示播放类）
 * 包含多个动画动作的切换
 * tyevlag
 */

var MAnimationObject = MAnimationObject || DisplayObject.extend({
	// 引用动画集合类
	oAnimCombineRef:null,
    actionChangeMap:null,

    oAnimGroupRef:null,

	oAnimDataDir:null,
	oAnimDefaultDataDir:null,
	
	nCurDirection:0,
	sCurActionName:null,
	sResUrlBase:null,
	nPlaySpeed:1,
	nPlaySpeedScale:1,

	bPause:false,
	nBlendMode:0,
	nAlpha:1,
	_isGray:false,
	oDataDir:null,
	
	// 动画控制
	oCCAnimte:null,
	// 实际动画资源
	//oCCAnim:null,
	aPartSortLevelArr:null,

	// 是否在池中
	bCahce:false,
	_height:0,
	_width:0,

    _isForever:false,
    _playEnd:false,

	loadCallback:null,

	Init:function() {
		this._super();
		this.setName("MAnimationObject");
		this.setScale( MGameDefine.ANIMATION_SCALE );
	},
	
	SetData:function(animCombineRef){
		this.oAnimCombineRef = animCombineRef;
	},

	Clear:function(){
		this.SetGray(false);
		this.SetResUrlBase(null);
		this.ClearCCAnimation();
		this.setTexture(null);
        this.nPlaySpeedScale = 1;
	},

    OnBound:function(target){
        this.oAnimGroupRef = target;
    },

	OnRecycle:function(){
		this.Clear();
		this.bCahce = true;
	},
	
	Dispose:function(){
		this.Clear();
		this.oAnimCombineRef = null;
		this.oAnimDefaultDataDir = null;
        	this.oAnimGroupRef = null;
	        this.loadCallback = null;
		this._super();
	},

	SetResUrlBase:function(url){
		this.sResUrlBase = url;
		this.sCurActionName = null;
		this.nCurDirection = 0;
		if( this.oDataDir )
			this.oDataDir.ReleaseData(this);
		this.oDataDir = null;
	},

	OnRevert:function(){
		this.bCahce = false;
	},
	
	SetPlaySpeed:function(v){
		if (v < 0.1)
			v = 0.1;
		//MbcAnimDir.setnPlaySpeed(nPlaySpeed);
	},

    SetPlaySpeedScale:function(v){
        this.nPlaySpeedScale = v;
    },

	SetAlpha:function(thealpha){
		if (thealpha < 0)
			thealpha = 0;
		if (thealpha > 1)
			thealpha = 1;
		this.nAlpha = thealpha;
		this.setOpacity(255 * thealpha);
	},
	
	SetBlendMode:function(e){
		this.nBlendMode = e;
	},

	SetPause:function(v){
		this.bPause = v;
	},

	DoAction:function(actionkey, direction, defaulttype){

		if (this.bCahce || this.bDispose)
			return;

		if (direction == undefined)
			direction = this.nCurDirection;
		if (actionkey != this.sCurActionName){
			// cc.log( "=========obj = DoAction DO  ！！sCurActionName:" + this.sCurActionName + " actionkey:" + actionkey + " direction:" + direction + " defaulttype:" + defaulttype + " sResUrlBase:" + this.sResUrlBase);
			this.ClearCCAnimation();

			this.sCurActionName = actionkey;
			var url  = this.sResUrlBase + "/" + this.sCurActionName + "/" + this.sCurActionName;
			if( this.oDataDir ){
				if( this.oDataDir.sUrl != url ){
					this.oDataDir.ReleaseData(this);
					this.oDataDir = MAnimationMgr.GetActionData( url , this);
				}
			}
			else{
				this.oDataDir = MAnimationMgr.GetActionData( url , this);
			}

			// 总是把默认资源准备好
			if (defaulttype == EnumDefaultResType.SCENE_OBJ) {
				this.oAnimDefaultDataDir = MAnimationMgr.GetDefaultDataDir(this.sCurActionName);
			} else {
				this.oAnimDefaultDataDir = null;
			}
		}
		this.SetDirection(direction < 0 ? this.nCurDirection : direction);
	},

	// 强制播放动作，目前用于挂件更新
	ForceDoAction:function(actionkey, direction, defaulttype){
		if (this.bCahce || this.bDispose)
			return;
		
		// 临时修改，破坏DoAction的判断规则
		this.sCurActionName = null;
		this.DoAction(actionkey, direction, defaulttype);
	},
	
	ClearCCAnimation:function(){
		
		if (this.oCCAnimte != null){
			this.stopAction(this.oCCAnimte);
//			ToolBase.Log("============成功停止动画！！" + this.oCCAnimte);
			this.oCCAnimte.release();
			this.oCCAnimte = null;
			this._width = 0;
			this._height = 0;
		}
	},

	CreateCCAnimation:function(datadir, dir){
		if (this.bCahce || this.bDispose)
			return;

		this.ClearCCAnimation();
		// zz.Log("============开始运行动画！！" + datadir.sActionName + datadir.bLoop);

		var useDataDir = datadir;
		if (useDataDir.IsLoaded() == false && this.oAnimDefaultDataDir != null)
			useDataDir = this.oAnimDefaultDataDir;

		// 这里只修改表现方向，不修改实际方向
		if (dir >= useDataDir.nNumdir) {
			dir = useDataDir.nNumdir - 1;
		}
		var ccAnim = useDataDir.GetDirAnim(dir);
		if (ccAnim != null){
            // TODO DELETE this is test code.
            // ccAnim.setDelayPerUnit(0.5);
            ccAnim.__baseDelayPerUnit = ccAnim.__baseDelayPerUnit || ccAnim.getDelayPerUnit();
            ccAnim.setDelayPerUnit(this.nPlaySpeedScale * ccAnim.__baseDelayPerUnit);
            if (useDataDir.bLoop){
                this._isForever = true;
                this.oCCAnimte = new cc.RepeatForever(cc.sequence([
                    new cc.Animate(ccAnim),
                    cc.callFunc(this.CallbackAnimationPlayEnd, this)
                ]));
			}
            else {
                this._isForever = false;
                this._playEnd = false;
                this.oCCAnimte = cc.sequence([new cc.Animate(ccAnim),
                    new cc.CallFunc(this.CallbackAnimationPlayEnd, this)
                ]);
            }
			this.oCCAnimte.retain();
			this.runAction(this.oCCAnimte);
			if( ccAnim.getFrames().length > 0)
				this.setSpriteFrame(ccAnim.getFrames()[0].getSpriteFrame());

			if( useDataDir.nBlend )
				this.setBlendFunc(cc.BlendFunc.ADDITIVE);
			else
				this.setBlendFunc( cc.BlendFunc.ALPHA_NON_PREMULTIPLIED );

			if( this._isGray )
				Filter.GrayScale(this);
			// cc.log( this.__instanceId + "============成功运行动画:" + " url:" + useDataDir.sUrl + " flen:" + ccAnim.getFrames().length + " loop:" + useDataDir.bLoop + "time: " + TimerUtil.GetTimer());

            /// 恢复动画
            var elaspsed = this.oAnimGroupRef ? this.oAnimGroupRef.GetActionElaspsed() : 0;
            if(elaspsed != 0){
                this.oCCAnimte.step(0);
                this.oCCAnimte.step(elaspsed);
            }
			return true;
		} else {
			// 资源还没准备好，等回调
			// zz.Log("============失败运行动画 资源还没准备好！！" + datadir.sUrl + " loop:" + datadir.bLoop);
			return false;
		}
	},

	SetDirection:function(direction){
		if (this.bCahce || this.bDispose)
			return;
		
		if (MDirection.IsValid(direction) == false){
			return;
		}
	
		if (this.sCurActionName == null){
			return;
		}
		
		if (this.oDataDir == null){
			return;
		}
		// ToolBase.Log("=========obj = SetDirection Get  ！！" + this.sCurActionName + " ** " + datadir.sActionName + " same dir: " + (this.nCurDirection == direction));
		
		// 换动作和方向这个肯定清空的
		if (this.oCCAnimte != null && this.nCurDirection == direction){
			return;
		}
		
		this.nCurDirection = direction;
		
		var virDir = this.nCurDirection;
		if (virDir == 5)
			virDir = 3;
		else if (virDir == 6)
			virDir = 2;
		else if (virDir == 7)
			virDir = 1;

		this.CreateCCAnimation(this.oDataDir, virDir);

		if (this.nCurDirection >= 0 && this.nCurDirection <= 4)
			this.setFlippedX(false);
		else
			this.setFlippedX(true);
	},

	CallbackAnimationPlayEnd:function(){
		if (this.bCahce || this.bDispose)
			return;

		if(!this._isForever)
			this._playEnd = true;
		
		if (this.oAnimCombineRef != null){
			this.oAnimCombineRef.CallbackAnimationPlayEnd(this);
		}
	},

	CallbackResLoaded:function(datadir){
		if (this.bCahce || this.bDispose)
			return;

		//这里应该接着当前帧数开始播放的 需要重写cc.Animate （如果不用默认动画的话 就可以不管）
        // if (this.oAnimCombineRef != null){
        //     // 是在组里的话就等组统一执行吧
        //     this.oAnimCombineRef.CallbackResLoaded.call(this.oAnimCombineRef, this);
        // } else {
        //     if (datadir == this.oDataDir){
        //         this.SetDirection(this.nCurDirection);
        //     }
        // }

        /// 清除动画，重新播放新的
        if (datadir == this.oDataDir){
           this.ClearCCAnimation();
           this.SetDirection(this.nCurDirection);
        }

		if(this.loadCallback){
			this.loadCallback();
		}
	},

	CallbackResLoadError:function(datadir){
	},

	GotoNextFrame:function(){
	},

	GotoPreFrame:function(){
	},

	GotoBeginFrame:function(){
	},

	GotoEndFrame:function(){
	},

	SetGray:function(value){
		if( this._isGray == value )
			return;
		this._isGray = value;
		value ? Filter.GrayScale(this) : Filter.UnGray(this);
	},

	GetWidth:function(){
		if( !this._width ){
			var sp = this.getSpriteFrame();
			if( sp ){
				this._width = parseInt( sp.getRect().width * MGameDefine.ANIMATION_SCALE );
			}
		}
		return this._width;
	},
	GetHeight:function(){
		if( !this._height ){
			var sp = this.getSpriteFrame();
			if( sp ){
				this._height = parseInt(( sp.getOffset().y + sp.getRect().height * 0.5 ) * MGameDefine.ANIMATION_SCALE);
			}
		}
		return this._height;
	},
	GetHitRect:function(){
		var sp = this.getSpriteFrame();
		if( sp ){
			var rect = sp.getRect();
			var offset = sp.getOffset();
			var objHeight = offset.y + rect.height * 0.5;		//原点之上的高度
			return cc.rect( -offset.x - rect.width * 0.5, -objHeight, rect.width, Math.max( rect.height, objHeight ) );	//考虑到骑马变高, 点脚下也响应, 因为暂时没考虑挂件
		}
		return cc.rect();
	}
});