﻿/**
 * Created by zj on 2015/10/27 0027.
 */

var MLLayer = cc.Layer.extend({
    ctor:function(){
        this._super();
        this._render_flag = MLLayer.LAYER_BASE;
        this._oWaveFull = null;
        this._oBloom = null;
        this._oSpecia = null;
        this._oGray = null;
        this._oGlowFilter = null;
        this._oPointLight = null;
        this._oNegative = null;
        this._textureSize = {width:cc.winSize.width, height:cc.winSize.height};
        this.OnWinResize(this._textureSize.width, this._textureSize.height);
    },

//    _createRenderCmd : function(){
//        return new MLLayer.WebGLRenderCmd(this);
//    },

    OnWinResize:function(w, h){
        this._textureSize.width = w;
        this._textureSize.height = h;

        if (this._oWaveFull != null){
            this._oWaveFull.OnWinResize(this._textureSize.width, this._textureSize.height);
        }
        if (this._oPointLight != null){
            this._oPointLight.OnWinResize(this._textureSize.width, this._textureSize.height);
        }
        if ( this._renderCmd != null )
        	this._renderCmd._ReCreateRenderTexture();
    },

    OnFrame:function(){
        var flag = this._render_flag & ~(MLLayer.LAYER_BASE);

        if (flag & MLLayer.LAYER_WAVE){
            this._oWaveFull.OnFrame();
        }
        if (flag & MLLayer.LAYER_BLOOM){
            this._oBloom.OnFrame();
        }
        if (flag & MLLayer.LAYER_SPECIA){
            this._oSpecia.OnFrame();
        }
        if (flag & MLLayer.LAYER_POINTLIGHT){
            this._oPointLight.OnFrame();
        }
        if (flag & MLLayer.LAYER_GLOWFILTER){
            this._oGlowFilter.OnFrame();
        }
        if (flag & MLLayer.LAYER_NEGATIVE){
            this._oNegative.OnFrame();
        }
    },

    WaveFullMe:function(active){
        if (active){
            if (this._oWaveFull == null){
                this._oWaveFull = new EffectWave();
            }
            this._render_flag |= MLLayer.LAYER_WAVE;
        }else{
            this._render_flag &= ~MLLayer.LAYER_WAVE;
        }

        this._oWaveFull.OnWinResize(this._textureSize.width, this._textureSize.height);
        this._oWaveFull.Active(active);
        cc.renderer.childrenOrderDirty = true;
    },

    BloomMe:function(active){
        if (active){
            if (this._oBloom == null){
                this._oBloom = new EffectBloom();
            }
            this._render_flag |= MLLayer.LAYER_BLOOM;
        }else{
            this._render_flag &= ~MLLayer.LAYER_BLOOM;
        }

        this._oBloom.Active(active);
        cc.renderer.childrenOrderDirty = true;
    },

    SpeciaMe:function(active){
        if (active){
            if (this._oSpecia == null){
                this._oSpecia = new EffectSpecia();
            }
            this._render_flag |= MLLayer.LAYER_SPECIA;
        }else{
            this._render_flag &= ~MLLayer.LAYER_SPECIA;
        }

        this._oSpecia.Active(active);
        cc.renderer.childrenOrderDirty = true;
    },

    GrayMe:function(active){
        if (active){
            if (this._oGray == null){
                this._oGray = new EffectGray();
            }
            this._render_flag |= MLLayer.LAYER_GRAY;
        }else{
            this._render_flag &= ~MLLayer.LAYER_GRAY;
        }

        this._oGray.Active(active);
        cc.renderer.childrenOrderDirty = true;
    },

    PointLightMe:function(active){
        if (active){
            if (this._oPointLight == null){
                this._oPointLight = new EffectPointLight();
            }
            this._render_flag |= MLLayer.LAYER_POINTLIGHT;
        }
        else{
            this._render_flag &= ~MLLayer.LAYER_POINTLIGHT;
        }

        this._oPointLight.Active(active);
        cc.renderer.childrenOrderDirty = true;
    },

    GlowFilterMe:function(active){
        if (active){
            if (this._oGlowFilter == null){
                this._oGlowFilter = new EffectGlowFilter();
            }
            this._render_flag |= MLLayer.LAYER_GLOWFILTER;
        }
        else{
            this._render_flag &= ~MLLayer.LAYER_GLOWFILTER;
        }

        this._oGlowFilter.Active(active);
        cc.renderer.childrenOrderDirty = true;
    },

    NegativeMe:function(active){
        if (active){
            if (this._oNegative == null){
                this._oNegative = new EffectNegative();
            }
            this._render_flag |= MLLayer.LAYER_NEGATIVE;
        }
        else{
            this._render_flag &= ~MLLayer.LAYER_NEGATIVE;
        }

        this._oNegative.Active(active);
        cc.renderer.childrenOrderDirty = true;
    },

    IsRenderTexture:function(){
        return (this._render_flag & ~(MLLayer.LAYER_BASE)) > 0;
    }
});

MLLayer.LAYER_BASE = 1<<0;
MLLayer.LAYER_WAVE = 1<<1;
MLLayer.LAYER_BLOOM = 1<<2;
MLLayer.LAYER_SPECIA = 1<<3;
MLLayer.LAYER_GRAY = 1<<4;
MLLayer.LAYER_POINTLIGHT = 1<<5;
MLLayer.LAYER_GLOWFILTER = 1<<6;
MLLayer.LAYER_NEGATIVE = 1<<7;