﻿/// <summary>
/// 对象池，任意类型
/// </summary>

var MCachePool = cc.Class.extend({
	cache:null,
	maxLen:0,
	
	ctor:function(){
		this.cache = [];
	},

	Recycle:function(o) {
		if (this.cache.length >= this.maxLen) {
			o.Dispose();
			return false;
		} else {
			o.OnRecycle();
			this.cache.push(o);
			return true;
		}
	}, 

	Gain:function(){
		if (this.cache.length > 0){
			var ret = this.cache.pop();
			ret.OnRevert();
			return ret;
		}
		return null;
	},

	GainShift:function(){
		if (this.cache.length > 0){
			var ret = this.cache.shift();
			ret.OnRevert();
			return ret;
		}
		return null;
	},

	GetItems:function () {
		return this.cache;
	},

	GetNum:function(){
		return this.cache.length;
	},

	GetMax:function(){
		return this.maxLen;
	},
	Clear:function()
	{
		if(this.GetNum()>0)
		{
			for(var i = 0; i <this.cache.length;i++)
			{
				this.cache[i].removeFromParent();
			}
		}
		this.cache.splice(0);
	},
	SetSize:function(m){
		if (m < 0)
			m = 0;

		this.maxLen = m;
		var len = this.cache.length;
		var outNum = len - m;
		if (outNum > 0){
			for (var i = m; i < len; ++i){
				this.cache[i].Dispose();
			}
			this.cache.splice(m, outNum);
		}
	}
});

