﻿/**
 * 这里存放一些扩展用的类
 * 主要是存放纯兼容的类，不做过多逻辑
 **/
var Position = cc.Class.extend({
	ctor:function(ptx, pty){
		this.x = ptx || 0;
		this.y = pty || 0;
	},
	
	writing:function( _buf ){
		_buf.WriteShort(this.x);
		_buf.WriteShort(this.y);	
	},

	reading:function( _buf ){
		this.x = _buf.ReadShort();
		this.y = _buf.ReadShort();		
	},
});

var LongUtil = LongUtil || {
	//64位后端唯一ID映射为32位前端GID
	oSID2GID:{},
	SIM_SID:0x70000001,
	GID_MAGIC:1000,
	ZERO:"0000000000000000",
	MAX:"ffffffffffffffff",
	MAX_UINT:0xffffffff,
	
	GetLong:function(){
		var l = new Long();
		l.IntValue(this.SIM_SID++);
		return l;
    },
    _add:function(a,b){
        var maxLen = Math.max(a.length,b.length) + 1;
        var result =[];
        for(var i=0;i!=maxLen;++i){
             result[maxLen - i - 1] = i < a.length ? parseInt(a[a.length - i - 1]) : 0;
        }
        for(var i=0;i!=maxLen-1;++i){
            var v = i < b.length  ? parseInt(b[b.length - i - 1]) : 0;

            result[maxLen - i - 1] += v;
            if(result[maxLen - i - 1] > 9){
                var temp = result[maxLen - i - 1];
                result[maxLen - i - 1] %= 10;
                result[maxLen - i - 2] += Math.floor(temp / 10);
            }
        }
        return result;
    },
    /// TODO 支持10进制字符串，添加更多支持
    Add: function(a, b) {
       a = a.toString();
       b = b.toString();

       var result = this._add(a,b);
       var temp = result.join('');
       return temp.replace(/\b(0+)/gi,'');
    },
    /// TODO 支持10进制字符串，添加更多支持
    Multi: function(a, b) {
        a = a.toString();
        b = b.toString();

        var maxLen = a.length + b.length;
        var base =[],result = [];
        for(var i=0;i!=maxLen;++i){
            base[maxLen - i - 1] = i < a.length ? parseInt(a[a.length - i - 1]) : 0;
            result[i] = 0;
        }

        for(var i=0;i!=b.length;++i){
           var v = i < b.length  ? parseInt(b[b.length - i - 1]) : 0;

           var temp = [];
           for(var j=maxLen - 1;j!=-1;--j){
                temp[j] = 0;
           }
           for(var j=maxLen - 1 - i;j!=-1;--j){
                temp[j] = base[j + i] * v;
           }
           result = this._add(temp,result)
        }
        var temp = result.join('');
        return temp.replace(/\b(0+)/gi,'');
    }
};

var Long = cc.Class.extend({
	hValue:0,
	lValue:0,
	hexValue:null,
	
	ctor:function(value){
		this.hValue = 0;
		this.lValue = 0;
		if( typeof value == "string" )
			this.StringValue(value);
		else if( parseInt( value ) === value ){
			this.IntValue( value );
		}
	},
	
	Equal:function( value ){
		if(!value)
			return false;
		return(this.hValue == value.hValue && this.lValue == value.lValue);
	},

	IsZero:function(){
		return ( this.lValue == 0 && this.hValue == 0 );
	},

	IsMax:function(){
		return ( this.lValue == LongUtil.MAX_UINT && this.hValue == LongUtil.MAX_UINT );
	},

	IntValue:function( value ){
		if( value < 0 ){
			this.hexValue = (LongUtil.MAX + (LongUtil.MAX_UINT + value).toString(16) ).substr(-16, 16);
			this.hValue = LongUtil.MAX_UINT;
			this.lValue = value;
		}
		else{
			this.hexValue = (LongUtil.ZERO + value.toString(16) ).substr(-16, 16);
			this.hValue = parseInt( this.hexValue.substr( 0, 8 ),16 );
			this.lValue = parseInt( this.hexValue.substr( 8, 8 ),16 );
		}
	},

	writing:function( _buf ){
		_buf.WriteInt(this.hValue);
		_buf.WriteInt(this.lValue);
	},

	reading:function( _buf ){
		this.hValue = _buf.ReadInt();
		this.lValue = _buf.ReadUint();
		this.hexValue = (LongUtil.ZERO + this.hValue.toString(16) ).substr(-8, 8) + (LongUtil.ZERO + this.lValue.toString(16)).substr(-8, 8);
	},
	
	toString:function(r){
        if(r == 10) {
            return LongUtil.Add(this.lValue,LongUtil.Multi(LongUtil.MAX_UINT + 1,this.hValue))
        }
		return this.hexValue;
	},
    /// 支持16进制的格式
	StringValue:function (str) {
		this.hexValue = (LongUtil.ZERO + str ).substr(-16, 16);
		this.hValue = parseInt( this.hexValue.substr( 0, 8 ),16);
		this.lValue = parseInt( this.hexValue.substr( 8, 8 ),16);
	},
	
	toGID:function(){
		var ret = LongUtil.oSID2GID[this.hexValue];
		if (!ret){
			ret = LongUtil.GID_MAGIC++;
			LongUtil.oSID2GID[this.hexValue] = ret;
		}
		return ret;
	},

	ToNumber:function(){
		return this.hValue * (LongUtil.MAX_UINT + 1) + this.lValue;
	},

	clone:function(){
		var l = new Long();
		l.hValue = this.hValue;
		l.lValue = this.lValue;
		l.hexValue = this.hexValue;
		return l;
	}
});