﻿/**
 * Created by zj on 2015/10/27 0027.
 * 全屏泛光
 */
var EffectBloom = cc.Class.extend({
    ctor:function(){
        this.blendFunc = {src: cc.BLEND_SRC, dst: cc.BLEND_DST};
        this.renderIdx = 0;
        this.lastT = 0;
        this.defaultParam =[0.25, 1, 1 , 1, 1];
        this.usedParam = [0.25, 1, 1, 1,1];
        this._CreateProgram();
        //参数
        //this.bloomParam = {
        //    Default:    [0.25,  1.25,  1,    1,       1],
        //    Soft:       [0,     1,     1,    1,       1],
        //    Saturated:  [0.25,  2,     1,    2,       0],
        //    Blurry:     [0,     1,     0.1,  1,       1],
        //    Subtle:     [0.5,   1,     1,    1,       1]};
        //BloomThreshold     // 饱和度（0-1，若为0：曝光是整图同时曝光， 若大于0：值越大，暗色曝光越慢，亮色曝光越快）
        //BloomIntensity;    // 模糊剧烈度（值越高，曝光越强， 15左右已经曝光很大了）
        //BaseIntensity;     // 原始剧烈度
        //BloomSaturation;   // 模糊饱和度
        //BaseSaturation;    // 原始饱和度
    },

    _CreateProgram:function(){
        this.highShaderProgram = Filter.GetLightExtractionProgram();
        this.highShaderUniforThreshold = this.highShaderProgram.getUniformLocationForName("u_bloomThreshold");

        this.bloomShaderProgram = Filter.GetBloomBlendTextureProgram();
        this.bloomShaderUniformBloomIntensity = this.bloomShaderProgram.getUniformLocationForName("u_BloomIntensity");
        this.bloomShaderUniformBloomSaturation = this.bloomShaderProgram.getUniformLocationForName("u_BloomSaturation");
        this.bloomShaderUniformBaseIntensity = this.bloomShaderProgram.getUniformLocationForName("u_BaseIntensity");
        this.bloomShaderUniformBaseSaturation = this.bloomShaderProgram.getUniformLocationForName("u_BaseSaturation");
    },

    Active:function(active){
        this.isActive = active;
        this.lastT = 0;
        this.renderIdx = 0;
    },

    OnFrame:function(){
        var idx = this.renderIdx % 3;
        if (idx == 0){
            this._DoNormalBloom();
        }else if(idx == 1){
            this._DoOverExposed();
        }else if(idx == 2){
            this._DoBlackWhite();
        }
    },

    _DoNormalBloom:function(){
        this._BackDefault();
    },

    /**
     * 暗色趋近黑色，亮色趋近白色
     **/
    _DoBlackWhite:function(){
        var curTime = TimerUtil.GetTimer();
        if (this.lastT == 0)
        {
            this.lastT = curTime;
            this._BackDefault();
        }

        var dec = curTime - this.lastT;
        if (dec > 100){

            this.usedParam[3] += 0.1;
            this.usedParam[4] += 0.1;
            this.usedParam[3] = this.usedParam[3] > 2.8 ? 1 : this.usedParam[3];
            this.usedParam[4] = this.usedParam[4] > 2.8 ? 1 : this.usedParam[4];
            this.lastT = curTime;
        }
    },

    _BackDefault:function(){
        this.usedParam[0] = this.defaultParam[0];
        this.usedParam[1] = this.defaultParam[1];
        this.usedParam[2] = this.defaultParam[2];
        this.usedParam[3] = this.defaultParam[3];
        this.usedParam[4] = this.defaultParam[4];
    },
    /**
     * 暗色慢慢曝光，亮色急速曝光
     **/
    _DoOverExposed:function(){
        var curTime = TimerUtil.GetTimer();
        if (this.lastT == 0)
        {
            this.lastT = curTime;
            this._BackDefault();
        }

        var dec = curTime - this.lastT;
        if (dec > 100){

            this.usedParam[1] += 0.5;
            this.usedParam[2] += 0.5;
            this.usedParam[1] = this.usedParam[1] > 15.0 ? 1 : this.usedParam[1];
            this.usedParam[2] = this.usedParam[2] > 15.0 ? 1 : this.usedParam[2];
            this.lastT = curTime;
            //cc.log("0:" + this.usedParam[0] + " 1:" + this.usedParam[1] + " 2:" + this.usedParam[2] + " 3:" + this.usedParam[3]+ " 4:" + this.usedParam[4]);
        }
    },

    TakeParam:function(){
        return this.usedParam;

    },

    Dispose:function(){
        this.highShaderProgram = null;
        this.highShaderUniforThreshold = null;

        this.bloomShaderProgram = null;
        this.bloomShaderUniformBloomIntensity = null;
        this.bloomShaderUniformBloomSaturation = null;
        this.bloomShaderUniformBaseIntensity = null;
        this.bloomShaderUniformBaseSaturation = null;
    }
});