﻿/**
 * 与服务器网络通信模块
 * 使用 自实现的jsb版本 socket通信
 * yq 2016年5月3日
 */





var MessageMgr_JSB = cc.Class.extend( {

	_socket:null,

	_ip:null,
	_port:null,

	ctor:function(){
//		this._super();
	},

	/**
	 * 连接服务器
	 * ip: IP地址
	 * port:端口号
	 * callbackTarget：服务器连接事件处理目标对象，至少需要实现以下方法 callbackTarget = { OnOpen:function(evt), // 连接成功 
	 *                                                     OnError:function( evt ), // 连接错误
	 *                                                     OnClose:function( evt ), // 连接关闭
	 *                                                     OnMeesage:function( evt ), // 接收到服务器消息   }
	 * isCross:是否跨服
	 * timeout 超时秒数
	 * */
	Connect:function( ip, port, callbackTarget, isCross, timeout ){
		this.Close();
		this._ip = ip;
		this._port = port;
		this._socket = new cc.CCNetDelegate();
        //var adder = new cc.CCInetAddress( ip, port );
        //cc.log( "begin connect server ip:" + ip + ":" + port + "...");
        //cc.log( adder.getHostAddress() + "   ---   " +  adder.getIp() + "  ----   " +  adder.getPort());
        //this._socket.setInetAddress( adder );
		timeout = timeout || 10;
		this._socket.setSoTimeout(timeout);	//超时
		var self = this;

		this._socket.on("connect", function() {
            self.ClearConnectTimer();
			callbackTarget.OnOpen(isCross);
		});

		this._socket.on("disconnect", function() {
            self.ClearConnectTimer();
            callbackTarget.OnClose(isCross);
		});

		this._socket.on("error", function() {
            self.ClearConnectTimer();
            callbackTarget.OnError(isCross);
		});

		this._socket.on("message", function( data ) {
			callbackTarget.OnMessage( data, isCross );
		});

        //针对链接错误没有通知JS的情况。底层没改的兼容
        this.ClearConnectTimer();
        this._timer4timeout = TimerUtil.SetTimeout(this,function(){
            callbackTarget.OnError(isCross);
        },(timeout + 2) * 1000);

        //this._socket.connect();
        this._socket.connectAsync(ip, port);
	},

	// 接收服务器消息
//	OnRecv:function(event){
//		var data = event.data;
//		cc.log( "OnRecvMsg:" );
//		cc.log( event );
//	},

	Send:function( datas, len ){

		if( !this.IsConnected() )
			return false;

//		zz.Log( "=========send data============len:" + len );
//		zz.Log( datas );
		this._socket.senddata( datas, len );
		return true;
	},


	Close:function(){
		if (this._socket){
			cc.log("server socket close...");
			this._socket.on("connect", MessageMgr_JSB.EMPTY_FUNCTION);
			this._socket.on("message", MessageMgr_JSB.EMPTY_FUNCTION);
			this._socket.on("disconnect", MessageMgr_JSB.EMPTY_FUNCTION);
			this._socket.on("error", MessageMgr_JSB.EMPTY_FUNCTION);

			this._socket.close();
			this._socket = null;
		}
	},


	IsConnected:function(){
		return this._socket && this._socket.isConnected();
    },

    ClearConnectTimer:function(){
        if(this._timer4timeout) TimerUtil.ClearTimeUpdate(this._timer4timeout);
        this._timer4timeout = null;
    },
} );
MessageMgr_JSB.EMPTY_FUNCTION = function(){};