﻿/**
 * Created by zj on 2015/10/19 0019.
 */
var StarlingAtlas = cc.Class.extend({

    ctor:function(xmlDoc){
        this._regions = {};
        this._frames = {};
        this._names = new Array();
        var region = new cc.Rect(0, 0, 0, 0);
        var frame = new cc.Rect(0, 0, 0, 0);

        var scale = 1.0;
        this._url = ParseUtil.GetXmlNodeValue(xmlDoc, "TextureAtlas");
        var elements = xmlDoc.getElementsByTagName("SubTexture");
        for (var i = 0; i < elements.length; i++) {
            var name = ParseUtil.GetXmlNodeAttrValue(elements[i], "name");
            var x = parseFloat(ParseUtil.GetXmlNodeAttrValue(elements[i], "x"));
            var y = parseFloat(ParseUtil.GetXmlNodeAttrValue(elements[i], "y"));
            var w = parseFloat(ParseUtil.GetXmlNodeAttrValue(elements[i], "width") / scale);
            var h = parseFloat(ParseUtil.GetXmlNodeAttrValue(elements[i], "height") / scale);
            var frameX = parseFloat(ParseUtil.GetXmlNodeAttrValue(elements[i], "frameX") / scale);
            var frameY = parseFloat(ParseUtil.GetXmlNodeAttrValue(elements[i], "frameY") / scale);
            var frameW = parseFloat(ParseUtil.GetXmlNodeAttrValue(elements[i], "frameWidth") / scale);
            var frameH = parseFloat(ParseUtil.GetXmlNodeAttrValue(elements[i], "frameHeight") / scale);

            region.x = x; region.y = y; region.width = w; region.height = h;
            frame.x = frameX; frame.y = frameY; frame.width = frameW; frame.height = frameH;

            this._names.push(name);
            this._regions[name] = cc.clone(region);
            this._frames[name] = cc.clone(frame);
        }
    },

    GetNames:function(prefix){
        var ret = new Array();
        if (prefix == undefined){
            prefix = "";
        }
        for( var i=0; i < this._names.length; ++i){
            if (this._names[i].indexOf(prefix) == 0){
                ret.push(this._names[i]);
            }
        }
        return ret;
    },

    GetRegion:function(name){
        return this._regions[name];
    },

    GetFrame:function(name){
        return this._frames[name];
    }
})