﻿/**
 * Created by zj on 2015/10/22 0022.
 */
var ParticleFilterBase = cc.Class.extend({
    _className:"ParticleFilterBase",
    ctor:function(){
        this._shaderName = "ParticleFilterBase";
        this._program = null;
        this._sHelpAlpha = [1, 1, 1, 1];
        this._uniforms = {};
    },

    Init:function(){
        this.CreateProgram(ParticleFilterCode.DEFAULT_VERTEX, ParticleFilterCode.DEFAULT_FRAGMENT);
        this._uniforms["u_DecY"] = this._program.getUniformLocationForName("u_DecY");
        this._uniforms["u_Alpha"] = this._program.getUniformLocationForName("u_Alpha");
        //this._uniforms["u_time"] = this._program.getUniformLocationForName("u_time");
        this._uniforms[cc.UNIFORM_PMATRIX_S] = this._program.getUniformLocationForName(cc.UNIFORM_PMATRIX_S);
        this._uniforms[cc.UNIFORM_MVMATRIX_S] = this._program.getUniformLocationForName(cc.UNIFORM_MVMATRIX_S);
    },

    CreateProgram:function(vertexCode, fragCode){

        this._program = cc.shaderCache.getProgram(this._shaderName);
        if (this._program != null){
            return;
        }

        this._program = new cc.GLProgram();
        this._program.initWithString(vertexCode, fragCode);
        this._program.addAttribute("a_position", 0);
        this._program.addAttribute("a_color", 1);
        this._program.addAttribute("a_texCoord", 2);
        this._program.addAttribute("a_realPos", 3);
        this._program.addAttribute("a_emitData", 4);
        this._program.link();
        this._program.updateUniforms();

        cc.shaderCache.addProgram(this._program, this._shaderName);
    },

    lastTime:0,
    fTime:0,
    OnFrame:function(){
        var curTime = TimerUtil.GetTimer();
        if (this.lastTime == 0){
            this.lastTime = curTime;
        }
        if (curTime - this.lastTime > 50){
            this.fTime += 0.1;
        }
    },

    SetUniformValue:function(key, value){
        var loc = this._uniforms[key];
        if (loc != null){
            if (key == "u_DecY" || key == "u_Z" /*|| key == "u_time"*/){
                this._program.setUniformLocationWith1f(loc, value);
            }
            else if (key == "u_Alpha"){
                this._sHelpAlpha[3] = value;
                this._program.setUniformLocationWith4f(loc, this._sHelpAlpha[0], this._sHelpAlpha[1], this._sHelpAlpha[2], this._sHelpAlpha[3]);
            }else if (key == cc.UNIFORM_PMATRIX_S){
                this._program.setUniformLocationWithMatrix4fv(loc, value);
            }else if (key == cc.UNIFORM_MVMATRIX_S){
                this._program.setUniformLocationWithMatrix4fv(loc, value);
            }
        }
    },

    Use:function(mv){
        this._program.use();
        this._program._setUniformForMVPMatrixWithMat4(mv);
    },

    Dispose:function(){
        this._program = null;
        this._uniforms = null;
    }
})