﻿/**
 * Created by zj on 2015/10/22 0022.
 */

var EmitterAreaProxy = cc.Class.extend({

    ctor:function(){
        this._iPointXNum = 0;
        this._iPointYNum = 0;
        this._oWidth = null;
        this._oHeight = null;
        this._listPoints = null;
    },

    SetInitData:function(config){
        this._iPointXNum = config.emitterPointW;
        this._iPointYNum = config.emitterPointH;
        if (this._iPointXNum > 0 || this._iPointYNum > 0){
            this._iPointXNum = this._iPointXNum < 1 ? 1 : this._iPointXNum;
            this._iPointYNum = this._iPointYNum < 1 ? 1 : this._iPointYNum;
        }

        this._oWidth = config.emitterAreaWidth;
        this._oHeight = config.emitterAreaHeigth;
        if (this._iPointXNum > 0){
            this._listPoints = [];
            var len = this._iPointXNum * this._iPointYNum;
            for ( var i=0; i < len; ++i){
                this._listPoints.push(new cc.p(0, 0));
            }
        }
    },

    InitParticle:function(p, life){
        var w = this._oWidth.ToValue(life);
        var h = this._oHeight.ToValue(life);
        if (this._listPoints != null){
            var offx = (this._iPointXNum > 1 ? (w/(this._iPointXNum-1)) : 0);
            var offy = (this._iPointYNum > 1 ? (h/(this._iPointYNum-1)) : 0);
            var left = (this._iPointXNum > 1 ? -(w>>1) : 0);
            var top = (this._iPointYNum > 1 ? -(h>>1) : 0);
            for (var i=0; i < this._listPoints.length; ++i){
                this._listPoints[i].x = left + offx * (i%this._iPointXNum);
                this._listPoints[i].y = top + offy * (parseInt(i/this._iPointXNum) % this._iPointYNum);
            }

            p.emitterOffX = this._listPoints[p.pointIndex].x;
            p.emitterOffY = this._listPoints[p.pointIndex].y;
        }else{
            var random = Math.random();
            p.emitterOffX = random * w - (w>>1);
            random = Math.random();
            p.emitterOffY = random * h - (h>>1);
        }
    },

    GetNumPoint:function(){
        return this._listPoints != null ? this._listPoints.length : 1;
    }
})