﻿/**
 * Created by zj on 2015/10/22 0022.
 */
var GravityProxy = cc.Class.extend({
    ctor:function(){},

    DoMove:function(particle, passedTime, bindEmitter){
        if (bindEmitter.config.particleBindEmitter)
        {
            var offsetX = bindEmitter.emitterX + particle.emitterOffX - particle.startX;
            var offsetY = bindEmitter.emitterY + particle.emitterOffY - particle.startY;

            particle.x += offsetX;
            particle.y += offsetY;
            particle.emitX = bindEmitter.emitterX;
            particle.emitY = bindEmitter.emitterY;
            particle.startX = bindEmitter.emitterX + particle.emitterOffX;
            particle.startY = bindEmitter.emitterY + particle.emitterOffY;
            particle.emitRotateZAngle = bindEmitter.emitRotateZAngle;
        }

        var lifePer = particle.LifePer();

        var distanceX = particle.x - particle.startX;
        var distanceY = particle.y - particle.startY;
        var distanceScalar = Math.sqrt(distanceX*distanceX + distanceY*distanceY);
        if (distanceScalar < 0.01) distanceScalar = 0.01;

        var radialX = distanceX / distanceScalar;
        var radialY = distanceY / distanceScalar;
        var tangentialX = radialX;
        var tangentialY = radialY;

        radialX *= particle.radialAcceleration;
        radialY *= particle.radialAcceleration;

        var newY = tangentialX;
        tangentialX = -tangentialY * particle.tangentialAcceleration;
        tangentialY = newY * particle.tangentialAcceleration;

        var gravityX = particle.gravityX * bindEmitter.config.particleGravityXPer.ToValue(lifePer);
        var gravityY = particle.gravityY * bindEmitter.config.particleGravityYPer.ToValue(lifePer);

        var vx = particle.velocityX * bindEmitter.config.particleSpeedPer.ToValue(lifePer);
        var vy = particle.velocityY * bindEmitter.config.particleSpeedPer.ToValue(lifePer);

        vx += particle.currentTime * (gravityX + radialX + tangentialX);
        vy += particle.currentTime * (gravityY + radialY + tangentialY);

        particle.x += passedTime * vx;
        particle.y += passedTime * vy;
    }
})