﻿/**
 * Created by zj on 2015/10/16 0016.
 */

var ParseUtil = ParseUtil || {
    GetAllTexturePath:function(strXML){
        try{
            var ret = new Array();
            var xml = new DOMParser();
            var xmlDoc = xml.parseFromString(strXML, "text/xml");
            var elements = xmlDoc.getElementsByTagName(ParseUtil.NODE_NAME_EMITER);
            for (var i = 0; i < elements.length; i++) {
                ret.push(elements[i].getElementsByTagName(ParseUtil.NODE_TEXTURE)[0].attributes[0].value);
            }
            return ret;
        }
        catch (e){}

    },

    GetXmlParser:function(strXML){
        var xml = new DOMParser();
        var xmlDoc = xml.parseFromString(strXML, "text/xml");
        return xmlDoc;
    },

    GetXmlNodeValue:function(xmlDoc, nodeName){
        return xmlDoc.getElementsByTagName(nodeName)[0].attributes[0].value;
    },

    GetXmlNodeAttrValue:function(xmlDoc, attrName){
        return xmlDoc.getAttribute(attrName);
    },

    GetStringValue:function(xmlDoc, nodeName){
        return this.GetXmlNodeValue(xmlDoc, nodeName);
    },

    GetFloatValue:function(xmlDoc, nodeName){
        return parseFloat(this.GetXmlNodeValue(xmlDoc, nodeName));
    },

    GetIntValue:function(xmlDoc, nodeName){
        return parseInt(ParseUtil.GetXmlNodeValue(xmlDoc, nodeName));
    },

    GetParticleVariance:function(xmlDoc, nodeName, valueType, lifeType){
        var ret = new ParticleVariance(ParseUtil.GetStringValue(xmlDoc, nodeName), valueType, lifeType);
        return ret;
    },

    GetBlendFunc:function(value){
        switch(value){
            case 0: return cc.ZERO;
            case 1: return cc.ONE;
            case 0x300: return cc.SRC_COLOR;
            case 0x301: return cc.ONE_MINUS_SRC_COLOR;
            case 0x302: return cc.SRC_ALPHA;
            case 0x303: return cc.ONE_MINUS_SRC_ALPHA;
            case 0x304: return cc.DST_ALPHA;
            case 0x305: return cc.ONE_MINUS_DST_ALPHA;
            case 0x306: return cc.DST_COLOR;
            case 0x307: return cc.ONE_MINUS_DST_COLOR;
            default :
                throw new Error("unsupported blending function: " + value);
        }
    },

    HasTextureAtlas:function(xmlDoc){
        var e = xmlDoc.getElementsByTagName("TextureAtlas");
        if (e != null && e.length > 0){
            e = e[0].getElementsByTagName("SubTexture");
            if (e != null && e.length > 0){
                return true;
            }
        }
        return false;
    },

    TransformPoint:function(mat, pt){
        var x = mat[0] * pt.x + mat[4] * pt.y + mat[12];
        var y = mat[1] * pt.x + mat[5] * pt.y + mat[13];
        pt.x = x;
        pt.y = y;
        return pt;
    },

    FormatFastJsonStr:function( str ){
        if(!str){
            return null;
        }
    	var reg = /([^\:\{\}\[\]\,]+)\:([^\:\,\{\}\[\]]*)/g;
    	str = str.replace(reg,'"$1":"$2"');
    	reg = /\,[\s]*\}$/;
    	str = str.replace (reg, "}");
    	return str;
    },

    /**
     * 解析物品表 装备属性 {xx:{xx:xx},xx:{xx:xx}}
     */
    DecodAttribute:function (attributeStr){
        var attArr = [];
        if(attributeStr != null && attributeStr.length > 0)
        {
            var arrStr = attributeStr.substring(1,attributeStr.length - 1);
            var arr = arrStr.split(",");//[ xx:{xx:xx,xx:xx}, xx:{xx:xx} ]
            var info;
            for(var i = 0;i< arr.length;i++)
            {
                var str = arr[i];
                var spliteIndex = str.indexOf(":");
                //var type = parseInt(str.substring(0,spliteIndex-1));
                var atrArr = str.substring(spliteIndex+2,str.length-1).split(",");//[xx:xx, xx:xx]
                for(var j = 0;j < atrArr.length;j++)
                {
                    var finalArr = atrArr[j].split(":");
                    if(finalArr && finalArr.length == 2)
                    {
                        info = new AttributeInfo();
                        //info.type = 10000 + type*1000 + parseInt(finalArr[0]);//-------万分比属性 10000+类型*1000+属性类型  （比如角色基础生命万分比属性：角色类型0，属性7，就是10007  坐骑基础生命万分比属性：坐骑类型1，属性7，就是11007）
                        info.type = parseInt(finalArr[0]);
                        info.value = finalArr[1];
                        attArr.push(info);
                    }
                }
            }
        }
        // if(attArr.length > 1)
        //     attArr.sort(sortEquipAttByType);
        return attArr;
    }


}

ParseUtil.NODE_NAME_EMITER = "particleEmitterConfig";
ParseUtil.NODE_TEXTURE = "particleTexture";
ParseUtil.NODE_EMITTERNAME = "emitterName";