﻿/*
/*
 * 工具，基础对象的生成，判断
 * tyevlag
 */

var ToolBase = ToolBase || {
    PCall : function(callback){
        try{
            callback();
        }catch(err){
            this.LogError(err);
            return false;
        }
        return true;
    },

	// 输出信息日志
	Log:function(s){
		if (s == undefined)
			s = "undefined!!!!!!!";
		else if (s == null)
			s = "null!!!!!!!";
		else if (s == "")
			s = "empty!!!!!!";
		else if (  typeof s == 'object'){
			cc.log( "obj_______" );
			for ( var key in s ){
				cc.log( key + ":" );
				if ( s[key] === s )
					continue
				this.Log( s[key] );
			}
			cc.log( "obj_______end" );
			return;
		}
			
		cc.log(s);
	},

	// 输出错误日志
	LogError:function(s){
		if (s == undefined)
			s = "undefined!!!!!!!";
		else if (s == null)
			s = "null!!!!!!!";
		else if (s == "")
			s = "empty!!!!!!";

        var stack = ToolBase.GetStacktraceText(-1);
        if(typeof buglyReportException == "function"){
            // @1 错误信息 @2堆栈
            buglyReportException(s,stack);
        }
		cc.error("[[ERROR]] " + s + "\n" + stack);
	},

	// 中断
	Assert:function(v, s){
		cc.assert(v, s);
	},
		
	// 得到系统运行时间返回秒
	GetTimerS:function(){
		return parseInt(new Date().getTime() / 1000);
	},

	// 得到系统运行时间返回毫秒
	GetTimer:function(){
		return new Date().getTime();
	},

	// 得到游戏帧时间
	GetFrameTimerS:function(){
		return this.GetTimerS();
		//return Time.time;
	},
	
	// 得到游戏屏幕宽度
	GetWinWidth:function(){
		return cc.winSize.width;
	},
	
	// 得到游戏屏幕高度
	GetWinHeight:function(){
		return cc.winSize.height;
	},
	
	/////////////////////////////////////////////////////////////////////
	// 数学相关
	/////////////////////////////////////////////////////////////////////	
	// 随机整数区间
	RamdonRangeInt:function(v1, v2){
		var int1 = parseInt(v1);
		var int2 = parseInt(v2);
		return int1 + parseInt(Math.random() * (int2 - int1));
	},
	
	// 随机小数区间
	RamdonRangeFloat:function(v1, v2){
		return v1 + Math.random() * (v1 - v2);
	},
	
	Distance:function( p1, p2 ){
		return this.Distance2( p1.x, p1.y, p2.x, p2.y );
	},
	
	Distance2:function( x1, y1, x2, y2 ){
		var dx = Math.abs(x2 - x1);
		var dy = Math.abs(y2 - y1);
		return Math.sqrt(dx * dx + dy * dy);
	},
	
	/////////////////////////////////////////////////////////////////////
	// 路径相关
	/////////////////////////////////////////////////////////////////////	
	sResPathRoot:null,
	
	// 根据相对路径返回完整路径
	// 例：GetResURL("map/10000/chunk/data.res") 返回 "res/map/10000/chunk/data.res";
	GetResURL:function(path){
		return this.GetResURLRoot() + "/" + path;
	},

	GetResURLRoot:function(){
		if (this.sResPathRoot == null)
		{
//			if (isInEditor)
//			{
			this.sResPathRoot = "res";
//			}
//			else
//			{
//				#if UNITY_ANDROID
//				ResPathRoot = "mlres_android";    
//				#elif UNITY_IPHONE
//				ResPathRoot = "mlres_iphone";    
//				#else
//					ResPathRoot = "mlres";    
//				#endif
//			}
		}

		return this.sResPathRoot;
	},
	
	

	/////////////////////////////////////////////////////////////////////
	// 对象帮助相关
	/////////////////////////////////////////////////////////////////////
		
	// 两点是否相同
	IsEqualPoint:function(pt1, pt2){
		return (pt1.x == pt2.x && pt1.y === pt2.y);
	},

	// 矩形是否包含点
	IsContainsPoint:function(rect, pt){
		return (pt.x >= rect.x 
				&& pt.x <= (rect.x + rect.width) 
				&& pt.y >= rect.y 
				&& pt.y <= (rect.y + rect.height));
	},
	
	// 数组是否包含某元素
	// 因为indexof据说某些IE版本不兼容
	ArrayContains:function (arr, obj) {
		var i = arr.length;
		while (i--) {
			if (arr[i] === obj) {
				return true;  
			}
		}
		return false;  
	},
	
	/////////////////////////////////////////////////////////////////////
	// 对象创建
	/////////////////////////////////////////////////////////////////////
	
	// 创建一个二维数组
	CreateTwoArray:function(i, j, v) {
		var ret = [];
		for(var k = 0; k < i; k++){
			ret[k] = [];
			for(var m = 0; m < j; m++){
				ret[k][m] = v;
			}
		}
		return ret;
	},

	// 创建一个矩形显示node
	CreateRectNode:function(w, h, color) {
		var nod = new cc.DrawNode();
		nod.drawRect(cc.p(0, 0), cc.p(w, h), color);
		return nod;
	},
	
	// 创建一个游戏内嵌调薪信息输出面板
	ShowDebugPanel:function( stage ){		

		if ( this._txtLable == null ){
			
			var fontDef = new cc.FontDefinition();
//			fontDef.fontName = "Arial";
			fontDef.fontSize = "16";
			this._txtLable = new cc.LabelTTF( "debug info", fontDef);
			this._txtLable.setPosition( 100, cc.winSize.height - 50 );
			stage.addChild( this._txtLable );
		}
	},

	/**
	 * 必须使用 functioon A(){};的形式才能取得A的名字 	A:function(){]会返回空字符串
	 * @param log
	 * @returns {string}
	 * @constructor
	 */
	GetFunctionName:function(fun){
		fun = fun || arguments.callee;
		var tmp = fun.toString();
		var re = /function\s*(\w*)/i;
		var matches = re.exec(tmp);
		return matches && matches[1];
	},

	GetStackTrace:function(log){

		// var err = new Error();
		// return err.stack;

		if( log != false )
			log = true;
		var stack = [],
		caller = arguments.callee.caller;

		while (caller) {
			stack.unshift(this.GetFunctionName(caller));
			caller = caller && caller.caller;
			if( stack.length > 10 )
				break;
		}
		var info = 'GetStackTrace:' + stack.join('.');
		if( log )
			cc.log(info);
		return  info;
	},

	GetDebugStackTrace:function(fun, target){
		return function () {
			try {
				getdebugstacktracefunction();
			} catch (e) {
				zz.Error("get debug stack trace:		" + e.message + "   " + JSON.stringify(arguments) + "\n" + e.stack.substr(0, e.stack.length - 1));
			}
			fun.apply( target, arguments );
		};
	},
	GetStacktraceText:function(level){
        level = level || 0;
        level = (-level)  + 1;
        try {
            getdebugstacktracefunction();
        } catch (e) {
            var stack = e.stack.substr(0, e.stack.length - 1);
            var arr = stack.split("\n");
            arr.splice(0,level);
            var ret = arr.join("\n")
            return ret;
        }
        return "";
	},
};

// 快捷类
var zz = zz || {
};

zz.Log = ToolBase.Log;
zz.Error = ToolBase.LogError;
zz.Assert = ToolBase.Assert;
zz.ShowDebug = ToolBase.ShowDebugPanel;
