﻿/**
 * backgroundimage 图片显示 支持九宫格
 */
var MUIBackgroundImage = cc.Node.extend( {
	_className:"MUIBackgroundImage",
	_scale9Enabled:false,
	_imageRenderer:null,
	_url:null,
	ctor:function(){
		this._super();
	},
	//设置图片显示
	SetData:function (url , scale9Enabled , data ){
		this._url = url;
		if(UIUtil.ObjIsString( url )){
			this._scale9Enabled = scale9Enabled;
			if (this._scale9Enabled) {
				this._imageRenderer = new ccui.Scale9Sprite();
			} else {
				this._imageRenderer = new cc.Sprite();
			}
			this.addChild( this._imageRenderer );
			var imageRenderer = this._imageRenderer;
			if(this._scale9Enabled){
				var rect = data;
				imageRenderer.initWithSpriteFrameName( url );
				imageRenderer.setCapInsets(rect);
			}else{
				imageRenderer.initWithSpriteFrameName( url );
			}
		}else{
			this._imageRenderer = url;
			this.addChild( this._imageRenderer );
		}
		this._imageRenderer.setAnchorPoint( cc.p(0,0));
	},
	SetSize:function ( size ){
		if( !this._imageRenderer )
			return;
		var wid = size.width;
		var hei = size.height;
		if(!this._scale9Enabled){
			var iContentSize = this._imageRenderer.getContentSize();
			this._imageRenderer.setScaleX(wid / iContentSize.width);
			this._imageRenderer.setScaleY(hei / iContentSize.height);
		}else{
			this._imageRenderer.setContentSize(cc.size(wid, hei));
		}
		this.setContentSize(this._imageRenderer.width, this._imageRenderer.height);
		this.uiWidth = this.width;
		this.uiHeight = this.height;
	},
	// 更新图片
	UpdateData:function ( url , scale9Enabled , data){
		this._url = url;
		if(UIUtil.ObjIsString( url )){
			if(this._scale9Enabled != scale9Enabled){
				this._scale9Enabled = scale9Enabled;
				if (this._scale9Enabled) {
					this._imageRenderer = new ccui.Scale9Sprite();
				} else {
					this._imageRenderer = new cc.Sprite();
				}
				this._imageRenderer.setAnchorPoint( cc.p(0,0));
			}
			if(this._imageRenderer != null){
				if(this._imageRenderer.parent == null)
					this.addChild( this._imageRenderer );
				var imageRenderer = this._imageRenderer;
				if(this._scale9Enabled){
					var rect = data.scale9Rect;
					imageRenderer.initWithSpriteFrameName( url );
					imageRenderer.setCapInsets(rect);
				}else{
					imageRenderer.initWithSpriteFrameName( url );
				}
			}else{
				this.SetData( url , scale9Enabled, data)
			}
		}else{
			if(this._imageRenderer != null) {
                // url.shaderProgram=this._imageRenderer.shaderProgram;
                // if (this._imageRenderer.parent == this)
                //     this.removeChild(this._imageRenderer);
                this._imageRenderer.setTexture(url.getTexture());
                this._imageRenderer.setTextureRect(url.getTextureRect());
            }
            else {
                this._imageRenderer = url;
                this.addChild( this._imageRenderer );
                this._imageRenderer.setAnchorPoint( cc.p(0,0));
			}
		}
	},
	CallLoaded:function (img, self){
		var sprite = new cc.Sprite();
		var texture2d;
		if ( EngineCost.engieType == EngineCost.TYPE_WEB ){
			texture2d = new cc.Texture2D();
			texture2d.initWithElement( img );
			texture2d.handleLoadedTexture();
		}
		else {
			texture2d = img;
		}

		sprite.initWithTexture(texture2d);
		this.UpdateData( sprite );
		this.SetSize( cc.size(img.width , img.height));
	}
} );