﻿/**  布局位置 无  */
MLLAYOUT_NON = 0;
/**  布局位置 上  */
MLLAYOUT_U = 1;
/**  布局位置 右上  */
MLLAYOUT_RU = 2;
/** 布局位置 右  */
MLLAYOUT_R = 3;
/**  布局位置  右下 */
MLLAYOUT_RB = 4;
/**  布局位置  下 */
MLLAYOUT_B = 5;
/** 布局位置  左下 */
MLLAYOUT_LB = 6;
/** 布局位置  左 */
MLLAYOUT_L = 7;
/** 布局位置  左上 */
MLLAYOUT_LU = 8;
/** 布局位置  中 */
MLLAYOUT_C = 9;

var LayoutComponent = cc.Class.extend( {
	// 布局类型
	layoutType:MLLAYOUT_NON,
	// 布局偏好  负靠左，正靠右, 目前只用于面板居中
	layoutDir:0,
	// 布局偏移
	layoutOffx:0,
	layoutOffy:0
});
/**
 * 得到控件的布局坐标 
 * @param parentRc 区域范围
 * @param comp 目标控件
 * @param type 布局类型
 * @return 坐标点
 * 
 */
var MLGetLayoutPos = function (parentRc, comp , type)
{
	if (parentRc == null || comp == null)
	{
		return null;
	}
	var pt = null;
	var oldPt = {x:comp.x, y:comp.y};
	switch (type)
	{
	case MLLAYOUT_U: pt = { x:parentRc.width / 2 - comp.width / 2, y:parentRc.height - comp.height}; break;
	case MLLAYOUT_RU: pt = { x:parentRc.width - comp.width, y:parentRc.height - comp.height}; break;
	case MLLAYOUT_R: pt = { x:parentRc.width - comp.width, y:parentRc.height / 2 - comp.height / 2}; break;
	case MLLAYOUT_RB: pt = { x:parentRc.width - comp.width, y:0}; break;
	case MLLAYOUT_B: pt = {x:parentRc.width / 2 - comp.width / 2, y:0}; break;
	case MLLAYOUT_LB: pt = {x:0, y:0}; break;
	case MLLAYOUT_L: pt = {x:0, y:parentRc.height / 2 - comp.height / 2}; break;
	case MLLAYOUT_LU: pt = {x:0, y:parentRc.height - comp.height}; break;
	case MLLAYOUT_C: pt = {x:parentRc.width / 2 - comp.width / 2, y:parentRc.height / 2 - comp.height / 2}; break;
	default:
		return null;
	}

	if (comp.layoutCom != null && (pt.x + comp.layoutCom.layoutOffx) != oldPt.x)
		pt.x = parseInt(pt.x + comp.layoutCom.layoutOffx);
	else
		pt.x = (oldPt.x);

	if (comp.layoutCom != null && (pt.y + comp.layoutCom.layoutOffy) !=  oldPt.y)
		pt.y = parseInt(pt.y + comp.layoutCom.layoutOffy);
	else
		pt.y = (oldPt.y);
	return pt;
}