﻿/**
 * UIGrid UI图片显示 支持九宫格
 */
var MUIGrid = ccui.Widget.extend( {
	ptype : "",
	_bgImage : null,
	gridType:-1,
	uiWidth:84,
	uiHeight:84,
	_gridId:0,
	_isInitGrid:false,
	_backChilds: null,
	_gridIcon: null,
	_childs: null,
	_fixedChilds:null,
	_gridActive:null,
	_gridTextField:null,
	_gridTextField01:null,
	_coolDown:null,
	_gridEffect:null,
	isSwallow:false,
	isSkillUp:false,//技能可升级
    background:null,// 背景图片   （品质框）
	ctor:function(){
		this.ptype = EnumPanelType.GRID;
		this._super();
		this._gridTextField = LabelRender.Create();
		this._gridTextField.enableOutline(UIUtil.GetCCColor( 0x0, 120 ), 1);
		this._gridTextField01 = LabelRender.Create();
		this._gridTextField01.enableOutline(UIUtil.GetCCColor( 0x0, 120 ), 1);
		this._backChilds = [];
		this._childs = [];
		this._fixedChilds = [];
	},
	Init:function(){
		//解析GRID数据
		UIParseUtil.ParseGrid( this , this.jsonobj);
		this.AddChildren();
//		var imgBg = EngineMgr.uiMgr.GetRes( this._normalSprStr ,this._name );
		this.setSwallowTouches(false);
	},
	InitGrid:function (type,id){
		this._gridId = id;
		this.gridType = type;
		this._isInitGrid = true;
	},
	SetGridText:function ( text, color ){
		text = text == 0 ? text:(text || "");
		color = color || 0x00ff32;
		if(text.length > 4)
            this._gridTextField.SetFontSize(16);
		else
            this._gridTextField.SetFontSize(20);
		this._gridTextField.SetText( text );
		this._gridTextField.SetColor( UIUtil.GetCCColor( color ) );
		this._gridTextField.x = this.uiWidth - this._gridTextField.width - 7;
		this._gridTextField.y = this._gridTextField.height + 6;
		if(!this._gridTextField.parent)
		{
			this.addChild(this._gridTextField);
		}
		this.SortImage();
	},
	SetGridText01:function( text, color ){
		text = text == 0 ? text:(text || "");
		color = color || 0x00ff32;
		this._gridTextField01.SetText( text );
		this._gridTextField01.SetColor( UIUtil.GetCCColor( color ) );
		this._gridTextField01.x = 7;
		this._gridTextField01.y = this.uiHeight - this._gridTextField01.height/2+5;
		if(!this._gridTextField01.parent)
		{
			this.addChild(this._gridTextField01,10);
		}
		this.SortImage();
	},
	SetGridIcon:function (icon){
		icon.retain();
		// icon.retain();
		if( UIUtil.ObjIsString( icon ) ){
			if(this._gridIcon == null){
				this._gridIcon = new MUIBackgroundImage();
				this.addChild( this._gridIcon );
			}
		}else{
			this._gridIcon = icon;
			if(icon.parent != null)
				icon.parent.removeChild( icon );
		}
		this.SortImage();
	},
	//添加背景显示对象
	AddBgImage:function ( img ){
		if(UIUtil.ObjIsString( img )){
			if(img === "")
				return ;

			var image = new MUIBackgroundImage();
			EngineMgr.uiMgr.GetAsynResByUrl(img, function(url, b){
				b.SetData(url, false);
				// b.SetSize( self.getSize() );
			}, image, img, image );

			image.retain();
			this._backChilds.push( image );
			this.SortImage();
			return image;
		}else{
			//var idx = this._backChilds.indexof( img );
			var idx = this._getBackChildsItemIndex( img );
			if(idx == -1)
			{
				this._backChilds.push( img );
				this.SortImage();
			}
		}
	},

	AddGridQuality:function(type){
        if(!this.background){
            var image = new MUIBackgroundImage();
            EngineMgr.uiMgr.GetAsynResByUrl("public/grid/74x74.png", function(url, b){
                b.SetData(url, false);
            }, image, "public/grid/74x74.png", image );
            this.background = image;
        }
        var url = "";
        switch (type){/** 物品品质颜色（0白色，1绿色，2蓝色，3紫色，4橙色，5红色） */
            case 0:
                break;
            case 1:
            	url = "public/grid/lv.png";
                break;
            case 2:
                url = "public/grid/lan.png";
                break;
            case 3:
                url = "public/grid/zhi.png";
                break;
            case 4:
                url = "public/grid/huang.png";
                break;
            case 5:
                url = "public/grid/hong.png";
                break;
			case 6:
				url = "public/grid/fen.png";
				break;
        }
        if(url == "")
        	return;
        EngineMgr.uiMgr.GetAsynResByUrl(url, function(url, b){
            b.UpdateData(url, false);
        }, this.background, url, this.background );

        // EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
        //     this.background._imageRenderer.initWithSpriteFrameName(url);
        // },this);
        this.background.setScale(this.uiWidth/84);
        this.background.setPosition(this.uiWidth / 2, this.uiHeight / 2);
        // box.scale = grid.uiWidth / box.getVirtualRendererSize().width;
        // grid.addChild(grid.background);
        // grid.qualityFrame = box;
	},

	_getBackChildsItemIndex:function(target)
	{
		for ( var i = 0; i < this._backChilds.length; i++ )
		{
			if ( this._backChilds[i] == target )
			{
				return i;
			}
		}
		return -1;
	},
	//添加固定显示对象到格子里，固定对象在clear的时候不会被删除
	AddFixedDisplay:function (child)
	{
		this._fixedChilds.push(child);
		this.SortImage();
	},
	//添加附加显示对象
	AddDisplay:function (child){
		this._childs.push(child);
		this.SortImage();
	},
	//移除附加显示对象
	RemoveDisplay:function ( child ){
		if (child.parent == this)
			this.removeChild(child);
		var idx = _childs.indexOf(child);
		if (idx != -1){
			_childs.splice(idx, 1);
		}
	},
	SortImage:function (){
		// 背景对象最低
		var i = 0;
		var len = this._backChilds.length;
		var temp;
		for (; i < len; i++){
			temp = this._backChilds[i];
			if ( !temp ){break;}
			if( temp.parent != null)
				temp.parent.removeChild( temp );
			this.addChild( temp );
			if(temp.setSwallowTouches){
				temp.setSwallowTouches(this.isSwallow);
			}
		}
		// 格子图标
		if (this._gridIcon != null){
			if(this._gridIcon.parent != null)
				this._gridIcon.parent.removeChild( this._gridIcon );
			this.addChild( this._gridIcon );
			if(this._gridIcon.setSwallowTouches)
			this._gridIcon.setSwallowTouches(this.isSwallow);
		}
		// 固定对象
		len = this._fixedChilds.length;
		for (; i < len; i++){
			temp = this._fixedChilds[i];
			if( temp.parent != null)
				temp.parent.removeChild( temp );
			this.addChild( temp );
			if(temp.setSwallowTouches){
				temp.setSwallowTouches(this.isSwallow);
			}
		}
		// 图标上层对象
		i = 0;
		len = this._childs.length;
		for (i = 0; i < len; i++){
			temp = this._childs[i];
			if( temp.parent != null)
				temp.parent.removeChild( temp );
			this.addChild( temp );
			if(temp.setSwallowTouches){
				temp.setSwallowTouches(this.isSwallow);
			}
		}
	// 冷却显示
		if (this._coolDown != null){
			if( this._cooldown.parent != null)
				this._cooldown.parent.removeChild( this._cooldown );
			this.addChild( this._cooldown );
			if(this._cooldown.setSwallowTouches){
				this._cooldown.setSwallowTouches(this.isSwallow);
			}
		}
	// 格子激活光效
		if ( this._gridActive != null ){
			if( this._gridActive.parent != null)
				this._gridActive.parent.removeChild( this._gridActive );
			this.addChild( this._gridActive );
			if(this._gridActive.setSwallowTouches){
				this._gridActive.setSwallowTouches(this.isSwallow);
			}
		}
		// 文字层
		if( this._gridTextField != null ){
			if( this._gridTextField.parent != null) {
				this._gridTextField.parent.removeChild(this._gridTextField);
			}
			this.addChild(this._gridTextField);
			if(this._gridTextField.setSwallowTouches){
				this._gridTextField.setSwallowTouches(this.isSwallow);
			}
		}
		if( this._gridTextField01 != null ){
			if( this._gridTextField01.parent != null) {
				this._gridTextField01.parent.removeChild(this._gridTextField01);
			}
			this.addChild(this._gridTextField01);
			if(this._gridTextField01.setSwallowTouches){
				this._gridTextField01.setSwallowTouches(this.isSwallow);
			}
		}

		if(this._gridEffect != null){
			if( this._gridEffect.parent != null)
				this._gridEffect.parent.removeChild( this._gridEffect );
			this.addChild( this._gridEffect );
			if(this._gridEffect.setSwallowTouches){
				this._gridEffect.setSwallowTouches(this.isSwallow);
			}
		}

        if(this.qualityFrame != null && sys.isObjectValid(this.qualityFrame)){
            this.qualityFrame.retain();
            if( this.qualityFrame.parent != null)
                this.qualityFrame.parent.removeChild( this.qualityFrame );

            this.addChild( this.qualityFrame );
            this.qualityFrame.release();
            if(this.qualityFrame.setSwallowTouches){
                this.qualityFrame.setSwallowTouches(this.isSwallow);
            }
        }
	},
	//清除格子所有内容
	Clear:function (){
		var i = 0;
		var len = this._backChilds.length;
		var temp;
        this.Clean();
		for (; i < len; i++){
			temp = this._backChilds[i];
			if( temp.parent != null)
				temp.parent.removeChild( temp );
			temp.release();
		}
		this._backChilds.length = 0;
		LabelRender.Delete(this._gridTextField);
	},
	Clean:function (){
		//边框
		GridUtil.CleanGridQuality(this);
        GridUtil.ClearLock(this);
        GridUtil.ClearOverdueTime(this);
		// 格子图标
		if (this._gridIcon != null){
			if(this._gridIcon.parent != null)
				this._gridIcon.parent.removeChild( this._gridIcon );
			// this._gridIcon.release();	这里不能release 有可能icon还没加载完 看怎么处理下(理论上把加载回调的地方try catch起来就行了	反正都销毁了 无所谓设置上没 只是资源的引用要删掉)	--merlin
		}
		this._gridIcon = null;
		// 固定对象
		var len = this._fixedChilds.length;
		var i, temp;
		for (; i < len; i++){
			temp = this._fixedChilds[i];
			if( temp.parent != null)
				temp.parent.removeChild( temp );
		}
		this._fixedChilds.length = 0;
		// 图标上层对象
		i = 0;
		len = this._childs.length;
		for (i = 0; i < len; i++){
			temp = this._childs[i];
			if( temp.parent != null)
				temp.parent.removeChild( temp );
		}
		this._childs.length = 0;
		// 冷却显示
		if (this._coolDown != null){
			if( this._coolDown.parent != null)
				this._coolDown.parent.removeChild( this._coolDown );
		}
		this._coolDown = null;
		// 格子激活光效
		if ( this._gridActive != null ){
			if( this._gridActive.parent != null)
				this._gridActive.parent.removeChild( this._gridActive );
		}
		this._gridActive = null;
		// 文字层
		this._gridTextField.SetText( "" );
		if( this._gridTextField.parent != null)
			this._gridTextField.parent.removeChild( this._gridTextField );
		this._gridTextField01.SetText( "" );
		if( this._gridTextField01.parent != null)
			this._gridTextField01.parent.removeChild( this._gridTextField01 );

		if(this._gridEffect != null){
			if( this._gridEffect.parent != null)
				this._gridEffect.parent.removeChild( this._gridEffect );
		}
		this._gridEffect = null;
	},
	Clone:function (){
		var grid = new MUIGrid();
        grid.topPanel = grid;
		grid.ParseJson( this.jsonobj );
		grid.Init();
		return grid;
	},
	SetSwallow:function(bool){
		this.isSwallow=bool;
		this.setSwallowTouches(bool);
		this.SortImage();
	}
} );