﻿/**
 * UIImageLabel控件，按钮控件
 */
var LableEffect = LableEffect || {
	UP : 1,
	DOWN : 2,
};
var LableAlign = {
	LEFT:0,
	CENTER:1,
	RIGHT:2
}

var MUIImageLabel = ccui.Widget.extend( {
	_className:"MUIImageLabel",
	ptype:"",

	_sprites:null,
	_spritesShade:null,
	_strMark:null,
	_actionStyle:null,

	_timerNum:null,

	_urlroot:"",
	_ext:"",

	_align:0,
	text:"",
	ctor:function(){
		this.ptype = EnumPanelType.IMAGE_LABEL;
		this._super();

		this._sprites = [];
		this._spritesShade = [];
		this._strMark = 0;
		this._timerNum = 0;
		this._scale = 1;
	},
	Init:function(){
		//解析 图片LABEL
		UIParseUtil.ParseImageLabel( this , this.jsonobj);
		this.AddChildren();
		this.ignoreContentAdaptWithSize( true );
		var render = EngineCost.engieType == EngineCost.TYPE_WEB ? this._labelAtlasRenderer : this.getVirtualRenderer();
		render.setAnchorPoint(cc.p(0, 0));
	},
	SetAlign:function( align ){
		this._align = align;
	},
	SetScale:function(scale)
	{
		this._scale = scale;
	},
	SetImageUrl:function( orgurl ){
		this._urlroot = "";
		this._ext = "";

		if (orgurl != null)
		{
			var ids = orgurl.lastIndexOf("/");
			var endIds = orgurl.lastIndexOf(".");
			if (ids != -1)
			{
//				this._urlroot = orgurl.substring(0, ids) + "/";
				this._urlroot = orgurl.substring(0, ids)+ "/";
				this._ext = orgurl.substring(endIds);
			}
		}
	},

	_addShade:function (spr, i) {
		if(!spr.getParent())
		{
			this.addChild(spr);
		}
		spr.x = spr.getContentSize().width * i;
		spr.y = 0;
		this._spritesShade.push(spr);
		// 遮罩
		//var sprShade;
		//if ( this._spritesShade.length > i ) {
		//	sprShade = this._spritesShade[i];
		//	//sprShade.removeAllChildren(true);
		//}
		//else {
		//	sprShade = new ccui.Layout();
		//	sprShade.setAnchorPoint(0, 0);
		//	sprShade.setContentSize(spr.getContentSize());
		//	sprShade.x = spr.getContentSize().width * i;
		//	sprShade.y = 0;
		//	this.addChild(sprShade);
		//	this._spritesShade.push(sprShade);
        //
		//	var shape = new cc.DrawNode();
		//	var rectangle = [];
		//	rectangle[0] = cc.p(0, 0);
		//	rectangle[1] = cc.p(sprShade.width, 0);
		//	rectangle[2] = cc.p(sprShade.width, sprShade.height);
		//	rectangle[3] = cc.p(0, sprShade.height);
		//	var green = cc.color(0, 255, 0, 255);
		//	shape.drawPolygon(rectangle,4, green, 0, green);
		//	shape.setPosition(0,0);
        //
		//	var clipper = new cc.ClippingNode();
		//	clipper.stencil = shape;
		//	clipper.setPosition(0,0);
		//	sprShade.addChild( clipper );
		//	sprShade.clipper = clipper;
		//}
        //
		//if ( spr.getParent() == null ) {
		//	sprShade.clipper .addChild(spr);
		//}
        //
        //if ( this._actionStyle == null )
			//spr.setPosition(0,0);
		//else {
		//	if ( this._actionStyle == LableEffect.UP ) {
		//		//spr.setPosition(0, (0 - spr.getContentSize().height));
		//	}
		//	else if ( this._actionStyle == LableEffect.DOWN ){
		//		//spr.setPosition(0, (0 + spr.getContentSize().height));
		//	}
		//}
	},

	/***
	 * 所有资源加载完成回调
	 * @private
     */
	_resLoadCallBack:function () {
		var len = this._sprites.length;
		var strlen = this.text.toString().length;
		var i = strlen;
		for( ; i < len; i++ ){
			var child = this._sprites[i];
			if ( child && child.getParent() )
				child.removeFromParent();
		}

		// action
		//this._strMark = 0;
		//if ( this._timerNum != 0 ) {
		//	TimerUtil.ClearTimeUpdate(this._timerNum, this);
		//	this._timerNum = 0;
		//}
		//this._timerNum = TimerUtil.TimeUpdate(this._lableMovie, this, 0.1);
        //
		//var parent = this.getParent();
		//if ( parent != null ) {//json暂时没法设先这样处理
		//	var reOffx = 0;
		//	var offX = strlen * this._sprites[0].getContentSize().width;
		//	//align
		//	if (this._align == 1)
		//		reOffx = parent.uiWidth / 2 - offX / 2;
		//	else if (this._align == 2)
		//		reOffx = parent.uiWidth - offX;
        //
		//	if (reOffx > 0) {
		//		for (i = 0; i < len; i++) {
		//			var child = this._sprites[i];
		//			if (child && child.getParent()) {
		//				child.x = reOffx;
		//				reOffx += child.getContentSize().width;
		//			}
		//		}
		//	}
		//}
	},

	_setNumberImage:function() {
		//for (var m = 0; m < this._sprites.length; m++)
		//{
		//	this._sprites[m].removeFromParent();
		//}
		//this._sprites.splice(0);
		var self = this;
		var str = this.text.toString();
		var spr;
		var path = self._urlroot;
		var len = str.length;
		for (var i = 0; i < len; i++) {
			if (self._sprites.length > i) {
				spr = self._sprites[i];
				spr.visible = true;
			} else {
				spr = new cc.Sprite();
				spr.retain();
				spr.setAnchorPoint(cc.p(0, 0));
				self._sprites.push(spr);
			}
			spr.scale = this._scale;
			var imgUrl = path + str.substr(i, 1) + self._ext;
			if(str.substr(i,1)=="+")
			{
				imgUrl = path + "add" + self._ext;
			}
			if(str.substr(i,1)==":"){
				imgUrl = path + "maohao" + self._ext;
			}
			(function (target, img, url, i, len) {
				EngineMgr.uiMgr.GetAsynResByUrl(url, function (img, i) {
					img.setSpriteFrame(EngineMgr.uiMgr.GetResByUrl(url));
					target._addShade(img,i);
					if ( i + 1 == len )
					{
						target._relayout();
						//target._resLoadCallBack();
					}
				}, target, img, i, len);
			})(self, spr, imgUrl, i, len);
		}
		for( ; i < self._sprites.length; i++ ){
            self._sprites[i].visible = false;
		}
	},
	_relayout:function()
	{
		var align = this._align;
		var spr = this._sprites;
		var scale = this._scale;
		if(spr.length>0)
		{
			var len = this.text.toString().length;
            var totalWidth = 0;
            var maxHeight = 0;
            for(var i = 0; i < len; i++){
                totalWidth += spr[i].width*scale;
                if(maxHeight < spr[i].height*scale)
                    maxHeight = spr[i].height*scale;
            }
            if(align == LableAlign.LEFT)//左对齐
            {
                var curWidth = 0;
                for(var i = 0;i<len; i++){
                    spr[i].x = curWidth;
                    curWidth += spr[i].width*scale;
                }
            }
            else if (align == LableAlign.RIGHT)//右对齐
            {
                var curWidth = 0;
                for(var j = len - 1; j >= 0; j--){
                    curWidth += spr[j].width*scale;
                    spr[j].x = this.uiWidth - curWidth;
                }
            }
            else//居中
            {
                var curWidth = 0;
                for(var i = 0;i<len; i++){
                    spr[i].x = this.uiWidth/2 - totalWidth/2 + curWidth;
                    curWidth += spr[i].width*scale;
                }
            }
            //高度不同的img居中对齐
            for(var i = 0;i<len; i++){
                spr[i].y = (maxHeight - spr[i].height)/2;
            }

            this.contentWidth = totalWidth;
            this.contentHeight = maxHeight;
		}
	},

	_getWidth:function(){
		if( this.contentWidth )
			return this.contentWidth;
		return this._super();
	},

	_getHeight:function(){
		if( this.contentWidth )
			return this.contentWidth;
		return this._super();
	},

	_lableMovie:function () {
		var str = this.text.toString();
		var len = str.length;
		var idx = this._strMark;
		var spr = this._sprites[idx];
		var pos1 = cc.p(0,0);
		var pos2 = cc.p(0,0);
		if ( idx < len ) {
			if ( this._actionStyle == LableEffect.UP ) {
				// pos1.y = spr.getContentSize().height + spr.getContentSize().height/2;
				// pos2.y = (0 - spr.getContentSize().height/2);

				pos1.y = spr.getContentSize().height + spr.getContentSize().height/2;
				pos2.y = 0;
			}
			else if ( this._actionStyle == LableEffect.DOWN ) {
				pos1.y = (0 - spr.getContentSize().height) + (0 - spr.getContentSize().height/2);
				pos2.y = 0;
			}
			var move1 = cc.moveTo(0.1, pos1);
			var move2 = cc.moveTo(0.1, pos2);
			var rep = new cc.Sequence(move1, move2);
			spr.runAction(rep);
			++this._strMark;
		}
		else {
			TimerUtil.ClearTimeUpdate(this._timerNum, this);
			this._timerNum = 0;
			this._strMark = 0;
		}
	},
	
	SetString:function (text, style){
		// ccui.TextAtlas.prototype.setString.call(this , text);
		style = style || null;
        if( this.text !== text ){
			this._actionStyle = style;
			this.text = text;
			this._setNumberImage();
		}
	},
	SetText:function (text){
		this.SetString( text );
	},
	_labelAtlasScaleChangedWithSize: function () {
		ccui.TextAtlas.prototype._labelAtlasScaleChangedWithSize.call( this );
		var render = EngineCost.engieType == EngineCost.TYPE_WEB ? this._labelAtlasRenderer : this.getVirtualRenderer();
		render.setPosition(0 , 0);
	},
} );
cc.defineGetterSetter(MUIImageLabel.prototype, "width", MUIImageLabel.prototype._getWidth, MUIImageLabel.prototype._setWidth);
cc.defineGetterSetter(MUIImageLabel.prototype, "height", MUIImageLabel.prototype._getHeight, MUIImageLabel.prototype._setHeight);