﻿/**
 * UI界面-面板
 * UI组件的主要容器，
 */
var MUIPanelModelType = //0：背景无，1：背景模糊，2：黑色背景半透明
{
	NONE:0,
	BLUR:1,
	ALPHABLACK:2
}
var MUIPanel = ccui.Layout.extend ( {
	_className : "UIPanel",
	_dragEnable : false,	//是否允许拖拽
	_lastPosition : null,
	_mouseDown : false,
	uiListener : null,
	//显示层级
	showLayerType : 0,
	layoutCom : null,
	inited:false,
	_soundName:null,
	isShowTween:false,		//打开时是否缓动滚出	暂且先做个从左滚动
	modelPanelType:0,		//0：背景无，1：背景模糊，2：黑色背景半透明
	isClosePanel:false,	//当modelPanelType为2的时候，点击任意处关闭面板
	ctor:function(){
		var self = this;
//		BaseUI.prototype.ctor.call(self);
		this._super();
		this._lastPosition = { x:0, y:0 };
		this._mouseDown = false;
//		cc.log("UIPanel  ctor");
		this.layoutCom = new LayoutComponent();
		this.showLayerType = 0;
	},
	SetDragEnable:function (drag){
		this._dragEnable = drag;
	},
	_OnMouseDown:function ( event ){
		var pos = event.getLocation(); //当前事件发生的光标位置
		var target = event.getCurrentTarget(); //事件绑定的目标
//		if(target.hasOwnProperty( "id" ))
//			cc.log("_onMouseDown "+target.id);
//		if(target.PanelName)
//			cc.log("_onMousedown "+target.PanelName());
		
		//判断当前事件发生的位置是否在事件目标区域内
		if( cc.rectContainsPoint(target.getBoundingBox(), pos) ) {
			target._lastPosition.x = pos.x;
			target._lastPosition.y = pos.y;
			return true;
		}
		return true;
	},
	_OnMouseUp:function ( event ){
		var target = event.getCurrentTarget(); //事件绑定的目标
		target._StopDragPanel();
		target.uiListener.onMouseMove = null;
		return true;
	},
	_OnMouseMove:function ( event ){
		var pos = event.getLocation(); //当前事件发生的光标位置
		var target = event.getCurrentTarget(); //事件绑定的目标
		if(target._mouseDown && target._dragEnable){
			var movex = pos.x - target._lastPosition.x;
			var movey = pos.y - target._lastPosition.y;
			target.x += movex;
			target.y += movey;
			target._lastPosition.x = pos.x;
			target._lastPosition.y = pos.y;
			return true;
		}
		return true;
	},
	_onMouseScroll1:function ( event ){
		return true;
	},
	_StartDragPanel:function (){
		this._mouseDown = true;
	},
	_StopDragPanel:function (){
		this._mouseDown = false;
	},
	_UILayerMouseMove:function (){
//		cc.log("_UILayerMouseMove");
	},

	Init:function(){
//		cc.log("UIPanel  Init");
		//解析面板数据
		UIParseUtil.ParsePanel( this , this.jsonobj);
		this.AddChildren();
        this._soundName="panel";
		if(this.topPanel && this.topPanel == this){
//			this.uiListener = new cc._EventListenerMouse();
//			this.uiListener.onMouseDown = this._OnMouseDown;
//			this.uiListener.onMouseUp = this._OnMouseUp;
//			cc.eventManager.addListener( this.uiListener , this );
//			this.addTouchEventListener( this._TouchEvent );
			this.setTouchEnabled( true );
			
			var self = this;

			this.uiListener = cc.EventListener.create( {
				event: cc.EventListener.TOUCH_ONE_BY_ONE,
				swallowTouches : true,		//面板默认不穿透
				
				//实现 onTouchBegan 事件回调函数
				onTouchBegan: function (touch, event) {
					self._TouchEvent(self, ccui.Widget.TOUCH_BEGAN);
				},
				
				// 触摸移动时触发
				onTouchMoved: function (touch, event) {
					self._TouchEvent(self, ccui.Widget.TOUCH_MOVED);
				},
				
				// 点击事件结束处理
				onTouchEnded: function (touch, event) {
					self._TouchEvent(self, ccui.Widget.TOUCH_ENDED);
				},
				
			} );
		}
		this.inited = true;
	},
	_TouchEvent:function(self , type){
		if(type == ccui.Widget.TOUCH_BEGAN){
			self.MouseDown();
		}else if(type == ccui.Widget.TOUCH_MOVED){
			cc.log(type)
		}else if(type == ccui.Widget.TOUCH_ENDED){
			
		}else if(type == ccui.Widget.TOUCH_CANCELED){

		}
	},
	MouseDown:function ()
	{
		this._StartDragPanel();
		this.uiListener.onMouseMove = this._OnMouseMove;
		this.ToFront();
	},
	ToFront:function (){
		if(this.showLayerType == UIMgr.PANEL_LAYER_FIX)
			return ;
		if(this.parent != null){
			var par = this.parent;
			this.retain();
			this.parent.removeChild( this , false);
			par.addChild( this );
			this.release();
		}
	},
	Update:function (){

	},
	OnShow:function (){
		if(this._soundName)
            Mgr.gameSoundMgr.PlaySound(this._soundName,SoundType.UI,false);
	},
	OnHide:function(){
		if( this.onHideHandler )
			this.onHideHandler();
	},
	GetLayoutPos:function(isDefaultMid)
	{
		isDefaultMid = (isDefaultMid !== false);
		var ret = null;
		if (this.parent != null)
		{
			var lt = this.layoutCom.layoutType;
			if (lt == MLLAYOUT_NON && isDefaultMid)
				lt = MLLAYOUT_C; 
			ret = MLGetLayoutPos(new cc.rect(0, 0, this.parent.width, this.parent.height), this, lt);
			if (ret != null)
			{
				if (ret.x + this.width > this.parent.width)
					ret.x = this.parent.width - this.width;
				if (ret.y + this.height > this.parent.height)
					ret.y = this.parent.height - this.height;
				if (ret.x < 0)
					ret.x = 0;
				if (ret.y < 0)
					ret.y = 0;
			}
			return ret;
		}
		return null;
	},
	SetSoundName:function (name) {
		this._soundName=name;
	},

	// ********************** 吊坠效果 *************************************
	SetPendantMovie:function (widget) {
		var pt = cc.p(widget.x + widget.width/2, widget.y + widget.height);
		widget.setAnchorPoint(0.5,1);
		widget.setPosition(pt);

		var angle = 30;
		var time = 0.5;
		this.StartMovie(widget, angle, time);
	},

	StartMovie:function (widget, angle, time, delayTime) {
		if ( delayTime == undefined )
			delayTime = 0;

		var self = this;
		var callfunc = cc.callFunc(function()
		{
			angle = angle * 0.6;
			time = time * 0.6;

			if ( angle <= 5 ) {
				angle = 30;
				time = 0.5;
				self.StartMovie(widget,angle, time, 2.0 );
			}
			else
				self.StartMovie(widget,angle, time);
		}, this);

		var act1 = cc.RotateBy(time, angle);
		var act2 = cc.RotateBy(time*0.6, -angle);
		widget.runAction( cc.sequence(cc.delayTime(delayTime), act1,act2,callfunc) );
	},

} );