﻿/**
 * UI 控件添加组件
 * 
 */
var UIComponentUtil  = UIComponentUtil || {
	//
	AddMouseEventComponent:function( uiobj ){
		if( uiobj._addMouseEvent )
			return ;
		uiobj._mouseEventList = {};
		uiobj._addMouseEvent = true;
		if(!uiobj.hasOwnProperty( "_TouchEvent" )){
			uiobj._TouchEvent = this._TouchEvent;
		}
		uiobj.AddClickEventListener = function( func , selector){
			uiobj.AddMouseEventListener( ccui.Widget.TOUCH_ENDED , func , selector)
		};
		
		uiobj.AddMouseEventListener = function( type , func , selector){
			if(selector == null){
				throw Error("UI 组件 AddClickEventListener方法 selector 参数不能为空");
				ToolBase.LogError( "UI 组件 AddClickEventListener方法 selector 参数不能为空" );
			}
			if(uiobj._mouseEventList[type] == null)
				uiobj._mouseEventList[type] = {};
			var inid = selector.__instanceId;
			uiobj._mouseEventList[type][inid]=[func , selector];
		};
		
//		uiobj.AddTouchEventListener = function (selector, target) {
//			uiobj.addTouchEventListener( selector , target);
//		}
		
//		uiobj.AddTouchEventListener( uiobj._TouchEvent );
		uiobj.addTouchEventListener( uiobj._TouchEvent );
	},
	_TouchEvent:function(self , type){
		if(type == ccui.Widget.TOUCH_BEGAN){
			try{
				if(self.MouseDown != null)
					self.MouseDown();
			}catch (e) {
				ToolBase.LogError("UIComponentUtil AddMouseEventComponent _TouchEvent ccui.Widget.TOUCH_ENDED MouseDown error.");
			}
		}else if(type == ccui.Widget.TOUCH_MOVED){
			try{
				if(self.MouseMove != null)
					self.MouseMove();
			}catch (e) {
				ToolBase.LogError("UIComponentUtil AddMouseEventComponent _TouchEvent ccui.Widget.TOUCH_ENDED MouseMove error.");
			}
		}else if(type == ccui.Widget.TOUCH_ENDED){
			try{
				if(self.MouseUp != null)
					self.MouseUp();
			}catch (e) {
				ToolBase.LogError("UIComponentUtil AddMouseEventComponent _TouchEvent ccui.Widget.TOUCH_ENDED MouseUp error.");
			}
		}else if(type == ccui.Widget.TOUCH_CANCELED){
			try{
				if(self.MouseCancel != null)
					self.MouseCancel();
			}catch (e) {
				ToolBase.LogError("UIComponentUtil AddMouseEventComponent _TouchEvent ccui.Widget.TOUCH_ENDED MouseCancel error.");
			}
		}
		var arr = this._mouseEventList[type];
		if(arr != null)
			UIComponentUtil.CallMouseEvent( arr , self);
	},
	CallMouseEvent:function (arr , self){
		var tarr;
		for( var key in arr){
			try{
				tarr = arr[key];
				if(tarr.length > 1)
						tarr[0].call(tarr[1] , self )
					else
						tarr[0].call( self );
			}catch (e) {
				cc.log(e);
			}
		}
	},
	//设置需要显示TIPS的UI对象
	AddTipsComponent:function( uiobj ){
		if(uiobj.SetTips == null)
		{
			uiobj.SetTips = UIComponentUtil._SetTips;
			uiobj.CanShowTips = UIComponentUtil._CanShowTips;
			uiobj.ShowTips = UIComponentUtil._ShowTips;
			uiobj.HideTips = UIComponentUtil._HideTips;
		}
	},
	_SetTips:function ( tipsStr ,  data , panel ){
		if(tipsStr == null || (data == null && panel)){
			this.isHaveTips = false;
			return ;
		}
		this.isHaveTips = true;
		if(panel == null)
			panel = EngineMgr.uiMgr.GetDefaultTipsPanel();
		this.tipsInfo = tipsStr;
		this.tipsData = data;
		this.tipsPanel = panel;
		var mspt = cc.p( TipsCheckMgr.mouseX, TipsCheckMgr.mouseY);
		if(UIUtil.HitTestPoint( this , mspt )){
			TipsCheckMgr.CheckShowTips( mspt );
		}
	},
	_CanShowTips:function (){
		return true;
	},
	_ShowTips:function (){
		
		if(this.tipsPanel != null)
		{
			this.tipsPanel.TipsShow();
			this.tipsPanel.UpdateTipsPanel( UIUtil.GetTextByHtmlText( this.tipsInfo )  , this.tipsData);
			this.tipsPanel.TipsSetPos(TipsCheckMgr.mouseX + TIPS_PANEL_DEFAULT_OFF_X , TipsCheckMgr.mouseY - this.tipsPanel.uiHeight + TIPS_PANEL_DEFAULT_OFF_Y);
		}
	},
	_HideTips:function (){
		if(this.tipsPanel != null)
		{
			this.tipsPanel.TipsHide();
		}
	},
	//给面板添加TIPS面板接口使之可以作为TIPS面板使用
	AddTipsPanel:function ( tipspanel){
		if(tipspanel.TipsUpdateInfo == null){
			tipspanel.TipsUpdateInfo = UIComponentUtil._TipsUpdateInfo;
			tipspanel.TipsSetPos = UIComponentUtil._TipsSetPos;
			tipspanel.TipsShow = UIComponentUtil._TipsShow;
			tipspanel.TipsHide = UIComponentUtil._TipsHide;
			tipspanel.showTipsLayer = EngineMgr.uiMgr.GetTipsLayer();
			if(tipspanel.UpdateTipsPanel == null)
				tipspanel.UpdateTipsPanel = UIComponentUtil._TipsUpdateInfo;
		}
	},
	_TipsUpdateInfo:function (tipsInfo , tipsData , updateAttr){
	},
	_TipsSetPos:function (xPos , yPos){
		var stageW = EngineMgr.uiMgr.stageWidth;
		var stageH = EngineMgr.uiMgr.stageHeight;
		if (this._tipsPosSetType == 0)
		{
				if (xPos > (stageW - this.uiWidth))
				{
					//xPos = stage.stageWidth - this.uiWidth;
					xPos -= (this.uiWidth + TIPS_PANEL_DEFAULT_OFF_X * 2);
				}
				
				if (xPos < 0) 
				{
					xPos = 0;
				}
				
				if (yPos > (stageH - this.uiHeight))
				{
					//yPos = stage.stageHeight - this.uiHeight;
					yPos -= (this.uiHeight + TIPS_PANEL_DEFAULT_OFF_Y * 2);
				}
				
				if (yPos < 0)
				{
					yPos = 0;
				}
		}
		else
		{
				if (xPos > (stageW - this.uiWidth))
				{
					xPos = stageW - this.uiWidth;
				}
				
				if (xPos < 0) 
				{
					xPos = 0;
				}
				
				if (yPos > (stageH - this.uiHeight))
				{
					yPos = stageH - this.uiHeight;
				}
				
				if (yPos < 0)
				{
					yPos = 0;
				}
		}
		this.setPosition( xPos , yPos);
	},
	_TipsShow:function (){
		this.showTipsLayer.removeAllChildren( false );
		this.showTipsLayer.addChild( this );  
	},
	_TipsHide:function (){
		this.showTipsLayer.removeAllChildren( false );
	}
};

var TIPS_PANEL_DEFAULT_OFF_X = 5;
var TIPS_PANEL_DEFAULT_OFF_Y = -5;