﻿/**
 * 时间相关工具集合
 */
var TimerUtil = TimerUtil || {
    updateHash: null,
    _lastTime: 0,
    _nowTime: 0,
    _runStartTime: 0,

    /// TIP 增加KEY的复用，最大支持长度0xffffffff
    _keyArr: [],
    _keyIndex:1,
    _maxLength: 0,
    /// TIP 链表版本
    _startListener: null,
    _endListener: null,
    _lengthOfListener: 0,

    /// fix 为了保证执行顺序添加缓存链
    _startTmpListener : null,
    _endTmpListener : null,

    // 统计相关
    _maxRunTimeArr: [],
    _aveRunTimeArr: [],
    _st_maxLengh: 0,
    _st_runTime: 0,

    _deleteData: function(v) {
        if (this._maxLength == v.__key) {
            --this._maxLength;
        } else {
            this._keyArr.push(v.__key);
        }

        /// delete
        if (v.__next) {
            v.__next.__last = v.__last;
        } else {
            this._endListener = v.__last;
            if (v.__last) v.__last.__next = null;
        }
        if (v.__last) {
            v.__last.__next = v.__next;
        } else {
            this._startListener = v.__next;
            if (v.__next) v.__next.__last = null;
        }
        this._lengthOfListener--;
    },
    _getNewKey: function() {
        return this._keyIndex++;;
    },
    _insertData: function(v) {
        this._lengthOfListener++;
        if (!this._endTmpListener) {
            this._endTmpListener = this._startTmpListener = v;
        } else {
            this._endTmpListener.__next = v;
            v.__last = this._endTmpListener;
            this._endTmpListener = v;
        }
    },
    _removeData:function(keyIndex){
        var v = this._startTmpListener;
        while (v) {
            if (v.__key == keyIndex) {
                v.__mark_del = true;
                return;
            }
            v = v.__next;
        }

        var v = this._startListener;
        while (v) {
            if (v.__key == keyIndex) {
                v.__mark_del = true;
                return;
            }
            v = v.__next;
        }
    },

    Init: function() {
        this._lastTime = this._nowTime = this._runStartTime = new Date().getTime();
    },
    GetTimer: function() {
        return Date.now();
    },
    /// 获取当前帧的时间
    GetGameTimer:function(){
        return this._nowTime;
    },

    OnFrame: function(dt) {
        this._lastTime = this._nowTime;
        this._nowTime = new Date().getTime();
//        var dt = this._nowTime - this._lastTime;
//        dt /= 1000;

        /// 添加任务链
        if(this._startTmpListener){
            if(this._startListener){
                this._endListener.__next = this._startTmpListener;
                this._startTmpListener.__last = this._endListener;
                this._endListener = this._endTmpListener;
            }else{
                this._startListener = this._startTmpListener;
                this._endListener = this._endTmpListener;
            }
            this._startTmpListener = null;
            this._endTmpListener = null;
        }
        /// 遍历
        var v = this._startListener;
        while (v) {
            /// mark delete
            if (v.__mark_del) {
                this._deleteData(v);
                v = v.__next;
                continue;
            }
            v.dt += dt;
            /// 没过延迟时间
            v.delay -= dt;
            if (v.delay > 0) {
                v = v.__next;
                continue;
            }
            /// 没过间隔时间
            v._interval -= dt;
            if (v._interval > 0) {
                v = v.__next;
                continue;
            }
            if( v.repeat == 0 )
                Profiler.LogTimeout();
            // this.GatherStatistics(v);
            
            try {
               if(v.callback.call(v.target)){
                   v.__mark_del = true;
               }
            } catch (e) {
                var errLog = "TimerUtil OnFrame error:		" + e.message + "\n" + e.stack.substr(0, e.stack.length - 1);   
                errLog = errLog.replace(/\n/g, "\nERROR : ");
                zz.Error( errLog + "\n");
            }
            v.dt = 0;
            if (v.repeat != cc.REPEAT_FOREVER) --v.repeat;
            /// finish delete
            if (v.repeat <= 0) {
                this._deleteData(v);
                Profiler.LogTimeout(v, true);
                v = v.__next;
                continue;
            }

            v._interval = v.interval;
            v = v.__next;
        }
        TimeTaskMgr.OnFrame();
    },
    ///
    /// @callback   执行任务函数 参数格式 function(dt) return ret,
    /////// @dt 里上一次执行间隔，从创建后第一帧开始计时
    /////// @return ret 如果为true 的话这个任务将被终止
    /// @target
    /// @interval 时间间隔，单位秒
    /// @repeat 重复次数，永久循环为cc.REPEAT_FOREVER=0xFFFFFFFF
    /// @delay 延迟多少秒后执行，默认为0，如果值不为0，将在delay后调用一次callback
    TimeUpdate: function(callback, target, interval, repeat, delay) {
        if(typeof callback != "function"){
            ToolBase.LogError("TimerUtils.TimeUpdate callback 不是的方法");
            return
        }
        if (this._lengthOfListener == 0xffffffff) return;

        this._st_runTime++;

        var key = this._getNewKey();
        var v = {
            callback: callback,
            target: target,
            interval: interval || 0,
            _interval: interval || 0,   //第一次应该是间隔后再执行, 而不是加进来立马执行
            repeat: (repeat == null) ? cc.REPEAT_FOREVER : repeat,
            delay: delay || 0,
            dt : 0,
            __mark_del: false,
            __key: key,
            __last: null,
            __next: null,
        }
        // this.PrepareStatistics(v, callback, target);
        this._insertData(v);

        return key;
    },
    ClearTimeUpdate: function(keyIndex, target) {
        this._removeData(keyIndex);
    },

    //  NOTED 修改为自定义管理
    //    TimeUpdate1:function( callback, target, interval, repeat, delay ){
    //        if ( this._scheduler == null )
    //            this._scheduler = cc.director.getScheduler();
    //
    //        interval = interval || 0;
    //        repeat = (repeat == null) ? cc.REPEAT_FOREVER : repeat;
    //        delay = delay || 0;
    //
    //        this._keyIndex = _windowTimeIntervalId++;
    //
    //        this._scheduler.schedule(callback, target, interval, repeat, delay, false, this._keyIndex + "" );
    //        if( !this.updateHash )
    //            this.updateHash = new HashMap();
    //        if( repeat > 1 )
    //            this.updateHash.Put(this._keyIndex, {callback:callback, target:target, interval:interval, repeat:repeat});
    //        return this._keyIndex;
    //    },
    //
    //    ClearTimeUpdate1:function( keyIndex, target ){
    //        if( keyIndex <= 0 )
    //            return;
    //        this.updateHash.Remove(keyIndex);
    //        this._scheduler.unschedule( keyIndex + "", target );
    //    },

    /**
     * 封装一下 cocos里默认this指针是Global
     * @param target
     * @param callback
     * @param delay
     * @constructor
     */
    SetTimeout: function(target, callback, delay) {
        if (delay < 50 && delay != 0) {
            cc.log("************************ The delay param is too small, please sure that delay unit is ms. ********************");
        }
        var args;
        if (arguments.length > 3)
            args = Array.prototype.slice.call(arguments, 3);

        var newCB = function() {
            callback.apply(target, args);
        };
        newCB.original = callback;

        return this.TimeUpdate(newCB, target, 0, 0, delay / 1000);
               // return setTimeout(function(param){
               //     callback.apply(target, param);
               // }, delay, args);
    },

    ClearTimeout: function(timeId) {
        if (timeId < 0)
            return;
        this.ClearTimeUpdate(timeId);
        //clearTimeout(timeId);
    },

    _blockHash:{},
    BlockTime:function(id, time){
        var old = this._blockHash[id];
        if( !old || Date.now() > (old + time) ){
            this._blockHash[id] = Date.now();
            return false;
        }
        return true;
    },

    /**
     * 下一帧触发 一般用于避免重复渲染(应该没必要做取消) --merlin
     * @param callback
     * @param target
     * @constructor
     */
    NextFrame: function(callback, target) {
        this.TimeUpdate(callback, target, 0, 0);
    },

    GatherStatistics: function(v) {
        var startTime = new Date().getTime();
        try {
            if (v.callback.call(v.target,v.dt)) {
               v.__mark_del = true;
            }
        } catch (err) {
            v.__mark_del = true;
            ToolBase.LogError(err);
        }

        var endTime = new Date().getTime();

        var interval = endTime - startTime;
        if (interval == 0) return;

        if (!v._st_max_run_time || !v._st_ave_run_time) {
            v._st_max_run_time = v._st_ave_run_time = interval;
        } else {
            v._st_max_run_time = Math.max(v._st_max_run_time, interval);
            v._st_ave_run_time = (v._st_ave_run_time + interval) / 2;
        }

        /// 最大
        if (this._maxRunTimeArr.length == 0) {
            this._maxRunTimeArr.splice(0, 0, v);
            this._maxRunTimeArr.splice(20, 1);
        } else {
            for (var i = 0; i < this._maxRunTimeArr.length; i++) {
                var vv = this._maxRunTimeArr[i];
                if (vv._st_max_run_time < v._st_max_run_time) {
                    this._maxRunTimeArr.splice(i, 0, v);
                    this._maxRunTimeArr.splice(20, 1);
                    break;
                }
            }
        }

        /// 平均
        if (this._aveRunTimeArr.length == 0) {
            this._aveRunTimeArr.splice(0, 0, v);
            this._aveRunTimeArr.splice(20, 1);
        } else {
            for (var i = 0; i < this._aveRunTimeArr.length; i++) {
                var vv = this._aveRunTimeArr[i];
                if (vv._st_ave_run_time < v._st_ave_run_time) {
                    this._aveRunTimeArr.splice(i, 0, v);
                    this._aveRunTimeArr.splice(20, 1);
                    break;
                }
            }
        }
    },
    PrepareStatistics: function(v, callback, target) {
        // 统计相关
        var name = ""
        for (var k in target) {
            if (target[k] == callback) {
                name = k;
                break
            }
        }
        v._st_name = target.__instanceId + "." + (target._className || "") + "." + name;
        v._st_max_run_time = null;
        v._st_ave_run_time = null;

    },
    PrintStatistics: function() {
        cc.log("==========TimerUtil.PrintStatistics=====================");
        cc.log("==== 当前监听数量：", this._lengthOfListener);
        cc.log("==== 历史同时最大监听数量：", this._st_maxLengh, "历史总监听数量", this._st_runTime);
        cc.log("==== 单个平均执行时间排行：");
        for (var i = 0; i < this._aveRunTimeArr.length; i++) {
            var v = this._aveRunTimeArr[i];
            cc.log("======", v._st_name, "最大", v._st_max_run_time, "平均", v._st_ave_run_time)
        }
    },
};

var ListNode = cc.Class.extend({
    pre:null,
    next:null,
    data:null,
    ctor:function(data){
        data = data || null;
        this.data = data;
        this.pre = this;
        this.next = this;
    },
    Push:function( node ){
        node.pre = this;
        node.next = this.next;
        this.next.pre = node;
        this.next = node;
    },
    UnShift:function( node ){
        node.pre = this.pre;
        node.next = this;
        this.pre.next = node;
        this.pre = node;
    },
    UnLink:function(){
        this.pre.next = this.next;
        this.next.pre = this.pre;
        this.next = this;
        this.pre = this;
    }
});

var TimeTaskMgr = TimeTaskMgr || {
    FIRST_PRIORITY:1,       //最高优先级
    NORMAL_PRIORITY:2,
    LOW_PRIORITY:3,            //最低优先级, 累积多了甚至可以直接删除跳过
    SINGLE_PRIORITY:4,     //单帧只执行一个任务

    MAX_RUN_TIME:6,    //单帧最大执行时间

    TYPE_SCENE:1,      //场景相关 如: 创建怪物, 技能特效, 掉血    切场景时需要根据type移除

    _firstTask:null,
    _normalTask:null,
    _lowTask:null,
    _singleTask:null,
    //添加分帧任务
    AddTask:function( priority, func, params, target, delay, type ){
        target = target || null;
        delay = delay || 0;
        type = type || 1;
        var task = {func:func, params:params, target:target, time:delay + Date.now(), type:type};
        switch ( priority ){
            case this.FIRST_PRIORITY:
                this._firstTask.Push( new ListNode(task) );
                break;
            case this.NORMAL_PRIORITY:
                this._normalTask.Push( new ListNode(task) );
                break;
            case this.SINGLE_PRIORITY:
                this._singleTask.Push( new ListNode(task) );
                break;
            case this.LOW_PRIORITY:
            default:
                this._lowTask.Push( new ListNode(task) );
                break;
        }
    },

    OnFrame:function(){
        var endTime = this.MAX_RUN_TIME + Date.now();
        var isEnd = this.RunTask(endTime, this.FIRST_PRIORITY);
        if( !isEnd )
            isEnd = this.RunTask(endTime, this.NORMAL_PRIORITY);
        if( !isEnd )
            isEnd = this.RunTask(endTime, this.SINGLE_PRIORITY);
        if( !isEnd )
            this.RunTask(endTime, this.LOW_PRIORITY);
    },

    RunTask:function(endTime, priority){
        var list;
        switch ( priority ){
            case this.FIRST_PRIORITY:
                list = this._firstTask;
                break;
            case this.NORMAL_PRIORITY:
                list = this._normalTask;
                break;
            case this.SINGLE_PRIORITY:
                list = this._singleTask;
                break;
            case this.LOW_PRIORITY:
            default:
                list = this._lowTask;
                break;
        }

        var curNode = list.next;
        while( curNode.data && curNode != list ){       //暂时先这样  后面要根据任务数长度 动态调整执行时间与次数
            var next = curNode.next;
            var task = curNode.data;
            if( task.time < Date.now() ){
                curNode.UnLink();
                try{
                    task.func.apply(task.target, task.params);
                }
                catch(e){
                    var errLog = "TimeTaskMgr RunTask error:		" + e.message + "\n" + e.stack.substr(0, e.stack.length - 1);
                    errLog = errLog.replace(/\n/g, "\nERROR : ");
                    zz.Error( errLog + "\n");
                }
            }
            if( Date.now() > endTime )
                return true;
            curNode = next;
        }
        return false;
    },
    RemoveTaskByType:function(type){
        this._RemoveType(this._firstTask, type);
        this._RemoveType(this._normalTask, type);
        this._RemoveType(this._singleTask, type);
        this._RemoveType(this._lowTask, type);
    },
    _RemoveType:function( list, type ){
        var curNode = list.next;
        while( curNode.data && curNode != list ){
            var next = curNode.next;
            var task = curNode.data;
            if( task.type == type )
                curNode.UnLink();
            curNode = next;
        }
    }
};
TimeTaskMgr._firstTask = new ListNode();
TimeTaskMgr._normalTask = new ListNode();
TimeTaskMgr._singleTask = new ListNode();
TimeTaskMgr._lowTask = new ListNode();