﻿/*
 * 
 * 场景技能特效
 * tyevlag
 * 
 */


var SkillEffect = SkillEffect || MAnimationObject.extend({
	STATE_UNINIT:0,
	STATE_INITED:1,
	STATE_DISPOSE:-1,
	
	nId:0,
	nType:0,
	bStand5:false,
	nDir:-1,
	nLifetime:0,
	nSpeed:0,
	
	nDelayInitTime:0,
	nEndTime:-1,
	nState:0,
	sCurAction:null,
	nCurDir:0,
	
	nCstomid:0,
	nInitTime:0,
	
	bNeedRotate:false,
	
	nTweenType:0,
	oTweenskillm:null,
	nTweensrcgid:0,
	nTweenTime:0,
	nTweenstartTime:0,
	
	nTweendstgid:0,
	
	oTweenStartPos:null,
	oTweenToPos:null,
	_timeId:-1,

	Init:function() {
		this._super();
		this.setName("SkillEffect");

	},

	Start:function(){
		this.nState = this.STATE_UNINIT;
		this._timeId = TimerUtil.TimeUpdate( this.OnFrame, this );
	},

	Clear:function(){
		this._super();
	},

	OnRecycle:function(){
		this._super();
		if( this._timeId >= 0 )
			TimerUtil.ClearTimeUpdate( this._timeId, this );
		this._timeId = -1;
		this.oTweenskillm = null;
		this.rotation = 0;
		this.SetScale(1);
		this.nDelayInitTime = 0;
		this.nEndTime = -1;
		this.x = this.y = 0;
		this.setSpriteFrame(Mgr.uiMgr.GetResByUrl("public/image/touming.png"));
		this.removeFromParent(true);
	},

	OnRevert:function(){
		this._super();
	},
	
	Dispose:function(){
		if( this._timeId >= 0 )
			TimerUtil.ClearTimeUpdate( this._timeId, this );
		this._timeId = -1;
		if (this.bDispose == false){
			this.nState = this.STATE_DISPOSE;
			this.oTweenskillm = null;
			this._super();
			this.release();
		}
	},

	SetResUrlBase:function(url){
		this._super(url);
	},
	
	OnFrame:function(){
		//this._super();
		if (this.nEndTime > 0 && (ToolBase.GetTimer() > this.nEndTime) ){
			SkillEffect.Delete(this);
		} else {
			if (this.nState == this.STATE_UNINIT) {
				if (this.nDelayInitTime > 0 && ToolBase.GetTimer() > this.nDelayInitTime) {
					this.InitSkill();
					this.nDelayInitTime = 0;
				}
			} else {
				if (this.bDispose == false) {
					var lp = (ToolBase.GetTimer() - this.nTweenstartTime) / this.nTweenTime;
					if (lp > 1)
						lp = 1;

					if (this.nTweenType == 1){
						var taro = Mgr.sceneObj.FindObject(this.nTweendstgid);
						if (taro != null) {
							var curPixPos = this.GetPixPt();
							var curTarPos = taro.GetPixPt();
							curTarPos.y -= (taro.GetStandHeight() / 2);
							// 线性插值
							var v2pt = ToolMap.LerpPoint(this.oTweenStartPos, curTarPos, lp);
							if (ToolMap.CalcDistance(curTarPos, curPixPos) > 40) {
								this.SkillRotate(this.GetRotation(curTarPos));
								this.SetPixPt(v2pt);
							} else {
								taro = null;
							}
						}

						if (ToolBase.GetTimer() >= (this.nTweenstartTime + this.nTweenTime) || taro == null){
							Mgr.fight.CallbackEffectTweenEnd(this, this.oTweenskillm, this.nTweensrcgid, this.nTweendstgid);
							SkillEffect.Delete(this);
						}
					} else if (this.nTweenType == 2 && this.nTweenstartTime > 0) {
						// 线性插值
						var v2pt = ToolMap.LerpPoint(this.oTweenStartPos, this.oTweenToPos, lp);
						this.x = v2pt.x;
						this.y = -v2pt.y;

						if (ToolBase.GetTimer() >= (this.nTweenstartTime + this.nTweenTime)){
							Mgr.fight.CallbackEffectTweenEnd(this, this.oTweenskillm, this.nTweensrcgid, this.nTweendstgid);
							SkillEffect.Delete(this);
						}
					}
				}
			}
		}
	},
	
	CallbackAnimationPlayEnd:function(){
		this._super();
		if (this.nLifetime == 0){
			SkillEffect.Delete(this);
		}
	},
	
	//DoAction:function(actionkey, direction, defaulttype){
		//base.DoAction (key, direction);
	//},
	
	InitSkill:function(){
		if (this.nState != this.STATE_UNINIT)
			return;
		
		this.nState = this.STATE_INITED;
		this.SetResUrlBase(EffectUtil.GetEffectUrl(this.nType, this.nId));
		this.sCurAction = this.bStand5 ? EnumActionName.STAND5 : EnumActionName.STAND;

		//name = "skilleffect " + url;
		if (this.nLifetime == 0) {
			this.nEndTime = ToolBase.GetTimer() + 3000;		//3秒顶天了
		} else if (this.nLifetime < 0) {
			this.nEndTime = -1;
		} else {
			this.nEndTime = ToolBase.GetTimer() + this.nLifetime;
		}

		if (this.nDir < 0)
			this.nDir = MDirection.UP;

		this.nInitTime = ToolBase.GetTimer();
		this.nCurDir = this.nDir;
		this.SetPlaySpeed(this.nSpeed);
		this.DoAction(this.sCurAction, this.nCurDir);
	},

	SetTweenMoveToTarget:function(src, dst, skillm, ttime){
		if (dst == null)
			return;

		this.SkillRotate(this.GetRotation(dst.GetPixPt()));
		this.nTweenType = 1;
		this.oTweenStartPos = this.GetPixPt();
		this.nTweenTime = ttime;
		this.nTweensrcgid = src != null ? src.nGid : 0;
		this.nTweendstgid = dst.nGid;
		this.oTweenskillm = skillm;
		this.nTweenstartTime = ToolBase.GetTimer();
	},

	SetTweenMoveToDir:function(src, toPos, skillm, ttime){
		this.nTweenType = 2;

		this.SkillRotate(this.GetRotation(toPos));

		this.oTweenStartPos = this.GetPixPt();
		this.nTweenTime = ttime;
		this.oTweenToPos = toPos;
		this.nTweensrcgid = ((src != null) ? src.nGid : 0);
		this.oTweenskillm = skillm;
		this.nTweenstartTime = ToolBase.GetTimer();
	},

	GetRotation:function(toPos){
		var v = this.GetPixPt();
		var fAngle = 0;
		var add = 0;

		if (toPos.x == v.x && toPos.y == v.y)
			return 0;

		if (toPos.x > v.x){
			if (toPos.y > v.y){
				fAngle = Math.atan((v.x - toPos.x) / (toPos.y - v.y));
				add = 180;
			} else {
				fAngle = Math.atan((toPos.y - v.y) / (toPos.x - v.x));
				add = 90;
			}
		} else {
			if (toPos.y > v.y){
				fAngle = Math.atan((v.y - toPos.y) / (v.x - toPos.x));
				add = 270;
			} else {
				fAngle = Math.atan((toPos.x - v.x) / (v.y - toPos.y)); 
			}
		}

		return (((fAngle * 180) / Math.PI)) + add;
	},

	/**
	 * 选择角度并设置偏移 
	 * @param angle
	 * 
	 */		
	SkillRotate:function(angle){ 
		if (this.bNeedRotate == false)
			return;
		
		this.setRotation(angle);
	},

	SetScale:function( scale ){
		this.setScale(scale * MGameDefine.ANIMATION_SCALE);
	}
	
//	public override void onResLoadedCallback(AnimationFrameWithDir afwd)
//	{
//		float passTime = ToolBase.GetTimer() - this.nInitTime;
//		if (passTime > afwd.showTime && this.nEndTime > 0)
//		{
//			dispose();
//		}
//		else
//		{
//			if (passTime > afwd.showTime)
//			{
//				passTime = (passTime % afwd.showTime);
//			}
//
//			MbcAnimDir.setPlayerPercent(passTime / afwd.showTime);
//		}
//	}
	
});

SkillEffect.oPool = new MCachePool();
SkillEffect.oPool.SetSize( 200 );
SkillEffect.Delete = function(o){
	if( o ){
		SkillEffect.oPool.Recycle(o);
	}
};

SkillEffect.Create = function(id, type, isStand5, dir, lifetime, speed, delaytime){
	if (isStand5 == undefined)
		isStand5 = true;

	if (type == undefined)
		return null;
	if (dir == undefined)
		dir = MDirection.UP;
	if (lifetime == undefined )
		lifetime = isStand5 ? -1 : 0;
	if (speed == undefined)
		speed = 1;
	if (delaytime == undefined)
		delaytime = 0;
	var ret  = SkillEffect.oPool.Gain();
	if( !ret ){
		ret = new SkillEffect();
		ret.retain();
	}
	ret.nId = id;
	ret.nType = type;
	ret.bStand5 = isStand5;
	ret.nDir = dir;
	ret.nLifetime = lifetime;
	ret.nSpeed = speed;
	ret.Start();
	if (delaytime <= 0){
		Profiler.LogFight("SkillEffect.InitSkill");
		ret.InitSkill();
		Profiler.LogFight("SkillEffect.InitSkill", true);
	} else {
		ret.nDelayInitTime = ToolBase.GetTimer() + delaytime;
	}
	return ret;
}