/**
 * Created by merlin on 2018/3/28.
 */
var UIModel = UIModel || cc.Node.extend({

        _animGroup:null,
        bDispose:false,
        _bodyId:0,
        _modelType:0,

        ctor:function(id, type) {
            this._super();
            this.setName("UIModel");
            type = type || 0;
            this.scale = ( type == 0 ? 1.1 : 1.2 );
            this._animGroup = new MAnimationGroup();
            this.addChild(this._animGroup);
            if(id) this.SetModelId(id, type);
        },

        SetModelId:function(id, type){
            type = type == null ? this._modelType : type;
            this._bodyId = id;
            this._modelType = type;
            var url = SceneObjUtil.GetUIModelUrl( id, type );
            this._animGroup.SetResUrlNoAction(url);
            var actionKey = this.GetUIActionKey(type);
            this._animGroup.DoAction(actionKey);
            this.UpdatePos(id);
        },

        UpdatePos:function(id){
            if(!id){
                return;
            }
            switch(this._modelType){
                case EnumResline.GUANGWU:
                case EnumResline.SHUTONG:
                    this._animGroup.y  = -80;
                    break;
                case EnumResline.BAOQI:
                    if(id > 3){
                        this._animGroup.x = 40;
                        this._animGroup.y = -30;
                    }else {
                        this._animGroup.x = 0;
                        this._animGroup.y = -80;
                    }
                    break;
                case EnumResline.HORSE:
                    if(id == 4){
                        this._animGroup.y = 50;
                    }else if(id == 6){
                        this._animGroup.x = -30;
                        this._animGroup.y = 30;
                    }else if(id == 10){
                        this._animGroup.x = -50;
                        this._animGroup.y = 50;
                    }else {
                        this._animGroup.x = 0;
                        this._animGroup.y = 0;
                    }
                    break;
                case EnumResline.WUXUE:
                    if(id == 11){
                        this._animGroup.y = -50;
                    }else if(id == 10){
                        this._animGroup.y = -40;
                    }else if(id == 9){
                        this._animGroup.y = -30;
                    }else if(id == 8){
                        this._animGroup.y = -30;
                    }else if(id == 7){
                        this._animGroup.y = -50;
                    }else if(id == 6){
                        this._animGroup.y = -25;
                    }else if(id == 5){
                        this._animGroup.y = -20;
                    }else if(id == 4){
                        this._animGroup.y = -35;
                    }else if(id == 3){
                        this._animGroup.y = -50;
                    }else if(id == 2){
                        this._animGroup.y = -60;
                    }else if(id == 1){
                        this._animGroup.y = -20;
                    }
                    break;
                case HuanhuaType.TYPE_WEAPON:
                    if( id == 30 ){
                        this._animGroup.x = -50;
                        this._animGroup.y = 80;
                    }
                    break;
                default:
                    this._animGroup.x = 0;
                    this._animGroup.y = 0;
                    break;
            }
        },

        AddWeapon:function(id, job){
            job = job || 1;
            var sex = SceneObjUtil.MODEL_SEX_HASH.Get(this._bodyId);
            sex = sex || job;
            this._animGroup.AddBindPart( SceneObjUtil.UIGuangWuPath + ( sex * 100 + id ) );
        },

        AddWing:function(id){
            this._animGroup.AddBindPart( SceneObjUtil.UIWingPath + id ,[-1], null, cc.p(0, 135));
        },

        AddTaiChi:function(id){
            this._animGroup.AddBindPart( SceneObjUtil.UITaiChiPath + id, [-1], {"stand": "stand5"} );
            this._animGroup.AddBindPart( SceneObjUtil.UITaiChiPath + (1000 + id),  [1], {"stand": "stand5"} );
        },

        RemoveAll:function () {
            this._animGroup.RemoveAllBindPart();
        },

        GetUIActionKey:function(type){
            switch (type){
                case EnumResline.DRAGON:
                case EnumResline.GUANGWU:
                case EnumResline.WUXUE:
                case EnumResline.ZHAOSHI:
                case HuanhuaType.TYPE_WEAPON:
                case EnumResline.MARRIAGE_HALO:
                    return "stand5";
            }
            return "stand";
        },

        Dispose:function(){
            if (this._animGroup != null){
                this._animGroup.Dispose();
                this._animGroup = null;
            }
            this.cleanup();
            this.removeFromParent(true);
            this.bDispose = true;
        }
});
