﻿/*
 * 
 * 自动寻路管理模块
 * （高层寻路控制，带跨地图）
 * tyevlag
 * --todo
 */


var AutoPathParam = AutoPathParam || cc.Class.extend({
	// 结束触发类型
		//callBackFunction:null,            //加个寻路完了以后的回调
	nType:0,
	data:null,
	ctor:function(value){
		this.nType = value || 0;
	},
	Execute:function(){
		switch (this.nType){
			case AutoPathParam.ENDDO_AUTO_FIGHT:
				if( !Mgr.player.isAutoFight )
					Mgr.player.TryStartAutoFight();
				break;
			case AutoPathParam.ENDDO_SELECT_NPC:
					Mgr.npc.SelectNpcByMid(this.data);
				break;
			case AutoPathParam.ENDDO_SELECT_NPCINFO:
				Mgr.npc.SelectNpc(this.data);
				break;
			case AutoPathParam.ENDDO_CALLBACK:
				this.data.func.call( this.data.target );
				break;
		}
		// zz.Log( "AutoPathParam Execute: " + this.nType + "   " + this.data );
	},
	GetNearDis:function(){
		switch (this.nType){
			case AutoPathParam.ENDDO_SELECT_NPC:
				return NpcUtil.GetNpcTalkDis(this.data);
			case AutoPathParam.ENDDO_SELECT_NPCINFO:
				return NpcUtil.GetNpcTalkDis(this.data.nBodyModelId);
		}
		return 0;
	}
});
AutoPathParam.ENDDO_NORMAL_ATTACK = 1;
AutoPathParam.ENDDO_TRY_MOVE_ATTACK = 2;
AutoPathParam.ENDDO_SELECT_NPC = 3;
AutoPathParam.ENDDO_AUTO_FIGHT = 4;
AutoPathParam.ENDDO_CALLBACK = 5;
AutoPathParam.ENDDO_SELECT_NPCINFO = 6;
AutoPathParam.CreateSelectNpc = function( modelId ){
	var p = new AutoPathParam( AutoPathParam.ENDDO_SELECT_NPC );
	p.data = modelId;
	return p;
};
AutoPathParam.CreateSelectNpcInfo = function( npc ){
	var p = new AutoPathParam( AutoPathParam.ENDDO_SELECT_NPCINFO );
	p.data = npc;
	return p;
};
AutoPathParam.CreateAutoFight = function(){
	return new AutoPathParam( AutoPathParam.ENDDO_AUTO_FIGHT );
};
AutoPathParam.CreateCallBack = function( func, target ){
	var p = new AutoPathParam( AutoPathParam.ENDDO_CALLBACK );
	p.data = { func:func, target:target };
	return p;
};

AutoPathParam.AutoPathParamNONE = new AutoPathParam();

var AutoPathControl = AutoPathControl || cc.Class.extend({
	oCo:null,
	aMovePaths:null, 
	oCurToPt:null,
	bAutoPath:false,
	oAutoParam:null,
	nMoveLockTime:-1,
	bDispose:false,

	ctor:function() {
		this.taskMovePath = null;
	},

	StartControl:function(tar){
		this.oCo = tar;
	},

	ReleaseControl:function(){
		this.Dispose();
	},

	Dispose:function(){
		this.oCo = null;
		this.StopAutoPath();
		this.bDispose = true;
	},

	// 向某个点跑动，不带是否立即执行检测，需要外部检测，调用后立刻走
	// <param name="param">结束参数</param>
	RunToPt:function(topt, param, isFight){
		if (param == undefined)
			param = null;
		if( cc.pointEqualToPoint(topt, this.oCo.GetGridPt()) ){
			if( param )
				param.Execute();
			this.MoveToNextTaskStep();
			return;
		}
		isFight = isFight || false;
		Mgr.map.bFight = isFight;
		var moveResult = this.CalcMovePath(topt, param ? param.GetNearDis() : 0);
		this.oAutoParam = null;
		if( moveResult.type === EnumActionType.RUN || Mgr.convoy.isHuSong){
			if (moveResult.path != null){
				this.oAutoParam = param;
				moveResult.path.shift();
				// if( moveResult.pathLen > this.FLY_DISTANCE )
				// 	Mgr.resline.EquipResline(EnumResline.HORSE);
				this.ExcutePath(moveResult.path, false);
			}
		}
		else if( moveResult.type === EnumActionType.JUMP ){
			if (moveResult.path != null){
				this.oAutoParam = param;
				this.ExcuteJump(moveResult.path, false);
			}
		}
		else{
			this.oAutoParam = param;
			this.aMovePaths = [];
			Mgr.map.SendReqSameMapFlyMoveMessage(new Position(moveResult.path[0].x, moveResult.path[0].y));
		}
		
	},

	JumpToPt:function(topt, param){
		param = param || null;
		if( cc.pointEqualToPoint(topt, this.oCo.GetGridPt()) ){
			if( param )
				param.Execute();
			return;
		}

		this.oAutoParam = null;
		var jumpDis = MMoveRule.JUMP_MAX_DISTANCE[0] / 50;	//手游没有跳 都按一跳处理
		var begin = this.oCo.GetGridPt();
		var distance = ToolMap.CalcDistance( begin, topt );
		if( this.isCrossFly && distance > this.FLY_DISTANCE ){	//超过距离飞过去
			var targetPixel = ToolMap.GridPt2PixPt(topt.x, topt.y, true);
			this.oAutoParam = param;
			this.aMovePaths = [];
			Mgr.map.SendReqSameMapFlyMoveMessage(new Position(targetPixel.x, targetPixel.y));
		}
		else{
			var path = this._GetFlyPath(begin, topt, jumpDis);
			if (path != null && path.length > 0){
				path = ToolMap.ArrayGridPt2PixPt(path);
				this.oAutoParam = param;
				this.ExcuteJump(path, false);
			}
		}
	},

	RunToPtAuto:function(topt, param, isFight){
		if (param == undefined)
			param = null;
		isFight = isFight || false;
		Mgr.map.bFight = isFight;
		var moveResult = this.CalcMovePath(topt, param ? param.GetNearDis() : 0);
		this.oAutoParam = null;
		if (moveResult.path != null){
			
		}
		if( moveResult.type === EnumActionType.RUN ){
			if (moveResult.path != null){
				this.oAutoParam = param;
				this.ExcutePath(moveResult.path, true);
			}
		}
		else if( moveResult.type === EnumActionType.JUMP ){
			if (moveResult.path != null){
				this.oAutoParam = param;
				this.ExcuteJump(moveResult.path, true);
			}
		}
		else{
			this.oAutoParam = param;
			Mgr.map.SendReqSameMapFlyMoveMessage(new Position(moveResult.path[0].x, moveResult.path[0].y));
		}
	},
	
	// 执行路径
	// <param name="path">路径</param>
	// <param name="isAuto"></param>
	ExcutePath:function(path, isAuto) {
		if (path != null && path.length > 0) {
			this.aMovePaths = path;
			this.bAutoPath = isAuto;
			this.CheckDoNext();
		}
	},

	ExcuteJump:function(path, isAuto){
		if(Mgr.map.ServerCheck()){
			if (this.oCo instanceof SceneMainPlayer){
				this.aMovePaths = [];
				Mgr.map.SendReqJumpMessage(path);
			}
		}
	},

	_GetFlyPath:function(begin, topt, jumpDis){
		var path = Mgr.sceneMap.FindFlyPath(begin, topt, jumpDis);
		while( path.length ){		//如果顺序遍历的话还可以加入是否穿越阻挡的判断
			var point = path[path.length - 1];
			if( Mgr.sceneMap.IsGridCanMove(point[0], point[1]))
				break;
			path.pop();
		}
		if( path.length > 2 ){
			path.splice(1,path.length -2);
		}
		return path;
	},

	CalcMovePath:function(topt, neardis){
		var begin = this.oCo.GetGridPt();

		/********************* new find path start ************************/
		var result = {};
		var path;
		result.type = EnumActionType.RUN;
		result.path = null;
		if(!Mgr.sceneMap.IsGridCanMove(topt.x, topt.y)){			//阻挡先修正
			topt = Mgr.sceneMap.oMapGrid.FixBlockPoint(begin, topt);
		}
		var isSameRegion = Mgr.sceneMap.IsSameConnectType( begin, topt );
		var jumpDis = MMoveRule.JUMP_MAX_DISTANCE[0] / 50;	//手游没有跳 都按一跳处理
		if( isSameRegion || !Mgr.sceneMap.IsGridCanMove(topt.x, topt.y)){	//修正后还是阻挡点则不跳
			result.path = Mgr.sceneMap.FindPath( begin, topt);		//不带平滑 平滑放到外面来做 这样超过一定长度比例检测跳
			result.type = EnumActionType.RUN;
			if( result.path ){
				var dis = Math.abs(begin.x - topt.x) + Math.abs(begin.y - topt.y);
				if( (result.path.length - 1) > dis * 1.2 && ToolMap.CalcDistance(begin, topt) < jumpDis){	//中间有阻挡绕路了 这样判定在斜边会有一定漏判 为了效率 就不判断平滑后的直线路径相加了
					path = this._GetFlyPath(begin, topt, jumpDis);
					if( path.length == 2 ){
						result.path = path;
						result.type = EnumActionType.JUMP;
					}
				}
			}
		}
		else{
			var distance = ToolMap.CalcDistance( begin, topt );
			if( distance >= jumpDis ){
				result.type = EnumActionType.JUMP_FLY;
				result.path = [[topt.x, topt.y]];
			}
			else{
				result.path = this._GetFlyPath(begin, topt, jumpDis);	//先全部按跳来处理
				result.type = EnumActionType.JUMP;
				if(result.path.length < 2 ){	//无法跳就走寻路
					result.path = Mgr.sceneMap.FindPath( begin, topt);
					result.type = EnumActionType.RUN;
				}
			}
		}

		path = result.path;
		if(result.type === EnumActionType.RUN && path != null){
			if(path.length > 0){
				if(path[path.length - 1][0] == begin.x && path[path.length - 1][1] == begin.y){	//终点等于起点
					path.pop();
				}
			}

            if(!this.targetMapId || !this.targetPos || ( this.targetMapId == Mgr.sceneMap.nMapId )){
                for( var i = path.length - 2; i > 0; i-- ){
                    var test = new cc.p(path[i][0], path[i][1]);
                    if( ToolMap.CalcDistance( test, topt ) <= neardis ){
                        path.pop();	//倒数第二个满足就把最后一个删了
                    }
                    else{
                        break;
                    }
                }
            }
			result.pathLen = path.length;
			if( path.length > 1)
				result.path = Util.smoothenPath(Mgr.sceneMap.oMapGrid.oAstarGrid, path);
		}

		if(result.path && result.path.length > 0){
			result.path = ToolMap.ArrayGridPt2PixPt(result.path);

			if( result.type === EnumActionType.RUN ){	//跑不使用格子中心点
				result.path[0].x = this.oCo.x;
				result.path[0].y = -this.oCo.y;
			}
		}

		return result;
		
		/********************** new find path end *************************/


		// var path = Mgr.sceneMap.FindPath( begin, topt);

		if (path != null) {
			if( path.length > 0 ){
				if(path[path.length - 1][0] == begin.x && path[path.length - 1][1] == begin.y){	//终点等于起点
					path.pop();
				}
			}
			var len = path.length;
			if( len > 0 ){
				if( neardis > 0 && len > 1 ){	//沿着路径一个个点的去检测是否在允许范围内
					for( var i = 1; i < len; i++ ){
						var test = new cc.p(path[i][0], path[i][1]);
						if( ToolMap.CalcDistance( test, topt ) <= neardis ){
							var temp = new cc.p(path[i - 1][0], path[i - 1][1]);
							var maxDis = Math.ceil( ToolMap.CalcDistance( test, temp ) );
							var radian = FightUtil.PosToRadian( temp, test );
							for( var j = 1; j <= maxDis; j++ ){
								if( temp.x < 0 || temp.y < 0 )
									break;
								var newTar = FightUtil.GetTargetPoint( temp, radian, j );
								if( ToolMap.CalcDistance( newTar, topt ) <= neardis ){
									temp = newTar;
									break;
								}
							}
							path = path.slice(0, i + 1);
							path[i][0] = temp.x;
							path[i][1] = temp.y;
							break;
						}
					}
				}
				var fPath = ToolMap.ArrayGridPt2PixPt(path);
				fPath[0].x = this.oCo.x;
				fPath[0].y = -this.oCo.y;
				return fPath;
			}
		}

		return null;
	},

	OnFrame:function(){
		if (this.bAutoPath){
			if (this.oCo.IsCanDoRun() && this.oCo.IsMoving() == false){
				this.CheckDoNext();
			}
		}
	},

	// 移动开始会调用，移动结束会调用
	CheckDoNext:function() {
		var oldPath = this.aMovePaths;	//为了避免flyParam里改变path 先保存一个
		if( this.flyParam ){
			//为了避免flyParam里面调用到移动操作 引起死循环
			var fp = this.flyParam;
			this.flyParam = null;
			fp.Execute();
		}
		if (oldPath == null) {
			return false;
		}

		if (this.aMovePaths.length > 0) {

			if( Mgr.map.ServerCheck() ){	//服务器是按格子验证的 所以这里先验证下 不然客户端自己跑了就不同步了  --merlin
				this.oCo.SetRunWay(this.aMovePaths);

				// 往服务器发送路径
				if (this.oCo instanceof SceneMainPlayer){
					Mgr.map.SendReqNewRunningMessage(this.oCo.x, this.oCo.y, this.aMovePaths);
					CustomControl.isWaitRunSuccess = false;
				}

				// 一次性给移动策略
				this.aMovePaths = [];

				return true;
			}
			// 一次性给移动策略
			this.aMovePaths = [];
		} else {
			this.bAutoPath = false;
			var beforeParam = this.oAutoParam;
			this.oAutoParam = null;
			this.aMovePaths = null;
			this.oCo.OnAutoPathEnd(beforeParam);
			this.MoveToNextTaskStep();
			if (this.oCo.IsMoving()) {
				return true;
			}
		}

		return false;
	},

	StopAutoPath:function() {
		this.bAutoPath = false;
		this.aMovePaths = null;
		this.oAutoParam = null;
		this.flyParam = null;

		this.StopAutoMapPath();
		this.taskMovePath = null;
	},

	SetMoveSendLock:function(){
		this.nMoveLockTime = TimerUtil.GetTimer() + 300;
	},

	ClearMoveSendLock:function(){
		this.nMoveLockTime = -1;
	},

	IsMoveSendLock:function(){
		if (this.nMoveLockTime > TimerUtil.GetTimer())
			return true;

		return false;
	},

	FlyToPath:function( path, param, mintime ){
		this.flyParam = param || AutoPathParam.CreateCallBack(this.OnFlyEnd, this)	//传送点结束特殊处理下 如果是自动寻路则继续跑
		this.oCo.SetMoveMoment(path, mintime);
	},

	OnFlyEnd:function(){
		var self = this;
		if( self.targetMapId && self.targetPos ){
			self.oCo.SetStateShowStand();	//先切站立 不然瞬移无法切走
			self.MoveByCrossMap( self.targetMapId, self.targetPos, self.autoMapParam );
		}
	},

	/*****************************************************************************************************************************
	 ******************************************************	 跨地图寻路  *********************************************************
	 *****************************************************************************************************************************/
	mapCrossPath : null,
	targetMapId:0,
	targetPos:null,
	autoMapParam:null,
	isCrossFly:false,		//是否开启远距离飞行模式
	FLY_DISTANCE:15,
	MoveByCrossMap:function (targetMapId, targetPoint, autoParam, taskPath, isFly) {
		autoParam = autoParam || AutoPathParam.AutoPathParamNONE;
		this.autoMapParam = autoParam;
		this.SetTaskMovePath(taskPath);

		if( !isFly && this.MoveToNextTaskStep(true) )	//有任务路径 则走任务路径
			return;

		var curMapId = Mgr.sceneMap.nMapId;     
		var targetPixel;
		if( (taskPath != null && curMapId != targetMapId) || isFly ){
			if( !Mgr.zone.IsInZoneMap() ){
				targetPixel = ToolMap.GridPt2PixPt(targetPoint.x, targetPoint.y, true);
				Mgr.map.SendReqSmallFlyShoesMessage( targetMapId, targetPixel );
			}
			this.targetMapId = targetMapId;
			this.targetPos = targetPoint;
			return;
		}


		if( curMapId == targetMapId ){
			var begin = Mgr.mainPlayer.GetGridPt();
			var checkdis = autoParam.GetNearDis();
			if( autoParam.nType == AutoPathParam.ENDDO_SELECT_NPC ){
				var npc = NpcUtil.GetNpcInfoByMid( autoParam.data );
				if( npc ){
					var dis = ToolMap.CalcDistance( begin, npc.GetGridPt() );
					if( dis < checkdis ){
						autoParam.Execute();
						return;
					}
				}
			}
			var distance = ToolMap.CalcDistance( begin, targetPoint );
			if( this.isCrossFly && distance > this.FLY_DISTANCE * 2 ){	//超过距离飞过去
				if( checkdis > 0 ){
					var radian = FightUtil.PosToRadian( targetPoint, begin );
					var newTarPos;
					for( var i = checkdis; i >= 0; i-- ){
						newTarPos = FightUtil.GetTargetPoint( targetPoint, radian, i );
						if( Mgr.sceneMap.IsGridCanMove(newTarPos.x, newTarPos.y) && ToolMap.CalcDistance( newTarPos, targetPoint ) < checkdis )
							break;
					}
					targetPixel = ToolMap.GridPt2PixPt(newTarPos.x, newTarPos.y, true);
				}
				else{
					targetPixel = ToolMap.GridPt2PixPt(targetPoint.x, targetPoint.y, true);
				}
				this.aMovePaths = [];
				this.oAutoParam = this.autoMapParam;
				Mgr.map.SendReqSameMapFlyMoveMessage(new Position(targetPixel.x, targetPixel.y));
			}
			else{
				this.RunToPt(targetPoint, autoParam );
			}
			this.targetMapId = targetMapId;
			this.targetPos = targetPoint;
		}
		else{
			if( this.isCrossFly && !Mgr.convoy.isHuSong ){
				Mgr.map.SendReqGoldMapTransMessage(targetMapId);
				this.targetMapId = targetMapId;
				this.targetPos = targetPoint;
			}
			else{
				this.mapCrossPath = Mgr.sceneMap.SearchRoad( curMapId, targetMapId );
				if ( this.mapCrossPath !=  null && this.mapCrossPath.length > 0 ) {
					this.targetMapId = targetMapId;
					this.targetPos = targetPoint;
					this.MoveToNextMap();
				}
			}
		}
	},

	StopAutoMapPath:function(){
		if( this.mapCrossPath )
			this.mapCrossPath.length = 0;
		this.targetMapId = 0;
		this.targetPos = null;
		this.autoMapParam = null;
	},

	MoveToNextMap:function () {

		if( this.MoveToNextTaskStep() )	//有任务路径 则走任务路径
			return;

		var curMapId = Mgr.sceneMap.nMapId;
		if ( this.mapCrossPath && this.mapCrossPath.length > 0 ) {
			var nextMapID = this.mapCrossPath.shift();
			var curTranferInfo = Mgr.sceneMap.GetTranferListByMapId(curMapId);
			if (curTranferInfo.length == 0)
				return;

			for  ( var i = 0; i != curTranferInfo.length; i++ ) {
				if ( curTranferInfo[i].q_tran_to_map == nextMapID ) {
					var transPos = new cc.p( parseInt(curTranferInfo[i].q_tran_from_x), parseInt(curTranferInfo[i].q_tran_from_y));
					if ( this.oCo.GetPixPt().x != transPos.x || this.oCo.GetPixPt().y != transPos.y ) {
						//移动至
						this.RunToPt(transPos, this.autoMapParam);
						break;
					}
				}
			}
		}
		else{
			if( curMapId == this.targetMapId && this.targetPos ){
				var distance = ToolMap.CalcDistance( Mgr.mainPlayer.GetGridPt(), this.targetPos );
				if( this.isCrossFly && distance > this.FLY_DISTANCE * 2 &&!Mgr.convoy.isHuSong){	//超过距离飞过去
					var targetPixel = ToolMap.GridPt2PixPt(this.targetPos.x, this.targetPos.y, true);
					this.aMovePaths = [];
					this.oAutoParam = this.autoMapParam;
					Mgr.map.SendReqSameMapFlyMoveMessage(new Position(targetPixel.x, targetPixel.y));
				}
				else{
					this.RunToPt(this.targetPos, this.autoMapParam );
				}
				//this.StopAutoMapPath();	//执行一次够了 这里可以清了 其他移动的地方就可以不清
			}
		}
	},

	taskMovePath:null,
	SetTaskMovePath:function(path){
		this.taskMovePath = null;
		if( path ){
			this.taskMovePath = [];
			var playerPos = Mgr.mainPlayer.GetGridPt();
			var nearDis = 9999;
			var pathArr = JSON.parse(path);
			for( var i = 0; i < pathArr.length; i++ ){
				var mapId = pathArr[i][0];
				if( mapId != Mgr.sceneMap.nMapId && pathArr.length > 1 && i != pathArr.length - 1 )	//不是当前图 也不是目标图 则跳过  目的是直接飞到目标图
					continue;
				var posArr = pathArr[i][1];
				for( var j = 0; j < posArr.length; j+=2 ){
					var moveType = posArr[j];
					var pos = cc.p(posArr[j+1][0], posArr[j+1][1]);
					if( mapId == Mgr.sceneMap.nMapId ){
						var dis = ToolMap.CalcDistance(playerPos, pos);
						if( dis == 0 )		//选最近的点开始
							continue;
						else if( nearDis > dis ){
							nearDis = dis;
							if( this.taskMovePath.length )
								this.taskMovePath.shift();
						}
					}
					this.taskMovePath.push({mapId:mapId, moveType:moveType, pos:pos});
				}

                // 上面的规则，感觉怪怪的,例如shift的使用。只有一层数据？
                // 只添加简单的择优吧。
                if(this.taskMovePath.length > 1){
                    var pos1 = this.taskMovePath[0].pos;
                    var pos2 = this.taskMovePath[1].pos;

                    var dis1 = ToolMap.CalcDistance(pos1, pos2);
                    var dis2 = ToolMap.CalcDistance(playerPos, pos2);
                    var dis3 = ToolMap.CalcDistance(playerPos, pos1);
                    if(dis1 >= dis2){
                        this.taskMovePath.shift();
                    }
                }
			}
		}
	},

	MoveToNextTaskStep:function(begin){
		begin = begin || false;
		// cc.log( "MoveToNextTaskStep   --->  " + ( this.taskMovePath ? this.taskMovePath.length : "null" ) );
		if( this.taskMovePath && this.taskMovePath.length ){

			var curMove = this.taskMovePath.shift();
			if( curMove.mapId != Mgr.sceneMap.nMapId ){
//				if( begin ){
					Mgr.map.SendReqSmallFlyShoesMessage( curMove.mapId, ToolMap.GridPt2PixPt(curMove.pos.x, curMove.pos.y, true) );
//				}
//				else{		策划又把传送点删了
//					//跑到一半的时候不是当前地图 那就是走的传送点 等传送完自己跑就行了
//				}
			}
			else{
				curMove.pos = this.GetNearRandomPos( curMove.pos );
				if( !begin && curMove.moveType % 2 == 1 ){		//首次移动没有跳 中断也不跳 不然距离不够可能会找不到跳跃落点导致路径非法
					if( curMove.moveType == 3 ){	//不骑马 跳
						Mgr.resline.UnEquipResline(EnumResline.HORSE);
					}
					this.JumpToPt( curMove.pos );
				}
				else{
					var distance = ToolMap.CalcDistance( Mgr.mainPlayer.GetGridPt(), curMove.pos );
					if(curMove.moveType == 2 ){		//不骑马 走
						Mgr.resline.UnEquipResline(EnumResline.HORSE);
					}
					else{
						// if( distance > this.FLY_DISTANCE )
						// 	Mgr.resline.EquipResline(EnumResline.HORSE);
					}
					if( this.isCrossFly && distance > this.FLY_DISTANCE * 2 ){	//超过距离飞过去
						var targetPixel = ToolMap.GridPt2PixPt(curMove.pos.x, curMove.pos.y, true);
						this.aMovePaths = [];
						this.oAutoParam = this.autoMapParam;
						Mgr.map.SendReqSameMapFlyMoveMessage(new Position(targetPixel.x, targetPixel.y));
					}
					else
						this.RunToPt( curMove.pos );
				}
			}
			return true;
		}
		else{
			if( this.taskMovePath != null ){
				this.taskMovePath = null;
				var p = this.autoMapParam;
				this.autoMapParam = null;
				if( p )
					p.Execute();
			}
		}
		return false;
	},

	GetNearRandomPos:function( pos ){
		if( this.taskMovePath == null || this.taskMovePath.length || this.autoMapParam == null )	//只有任务寻路最后一段才随机 并且在autoMapParam的距离范围内随机
			return pos;
		var randomArr = [];
		var begin = Mgr.mainPlayer.GetGridPt();
		var dis = this.autoMapParam.GetNearDis();
		var checkdis = ToolMap.CalcDistance( begin, pos );
		for( var x = -dis; x < dis; x++ ){
			for( var y = -dis; y < dis; y++ ){
				var p = cc.p(pos.x + x, pos.y + y);
				if( Mgr.sceneMap.IsGridCanMove(p.x, p.y) && ToolMap.CalcDistance( begin, p ) < checkdis ){
					randomArr.push(p);
				}
			}
		}
		if( randomArr.length )
			return randomArr[ToolBase.RamdonRangeInt(0, randomArr.length)];
		return pos;
	}
	
});

