﻿/**
 * 
 * 场景对象身体布局小挂件
 * 
 * 
 */

var EnumSceneDecorLayout = EnumSceneDecorLayout || {};

EnumSceneDecorLayout.Top = 0;
EnumSceneDecorLayout.RightBottom = 1;
EnumSceneDecorLayout.Center = 2;

var EnumDecorTopIdx = EnumDecorTopIdx || {};
EnumDecorTopIdx.SpouseName = 0;
EnumDecorTopIdx.GuildName = 1;
EnumDecorTopIdx.Name = 2;
EnumDecorTopIdx.BloodBar = 3;
EnumDecorTopIdx.Title = -1;
EnumDecorTopIdx.Belong = -2;

var EnumDecorRightBottomIdx = EnumDecorRightBottomIdx || {};
EnumDecorRightBottomIdx.TeamGuildHang = 1;

var EnumDecorCenterIdx = EnumDecorCenterIdx || {};
EnumDecorCenterIdx.Guild = 2;



// 场景名字显示
var SceneNameBar = SceneNameBar || DisplayNode.extend({
	oNameShow:null,
	Init:function(){
		this._super();
		this.setName("SceneNameBar");
	},

	SetParent:function(decorlayout){
	},

	SetNameShow:function(name,headTitleId,isPlayer){
		if (this.oNameShow == null && this.bDispose == false){
			this.oNameShow = new MUILabel();
			this.oNameShow.SetFontSize(20);
			this.oNameShow.setAnchorPoint(cc.p(0,0.5));
			this.oNameShow.EnableOutline();
			this.addChild(this.oNameShow, 1);
		}

		if( headTitleId ){
			var monicker = Q_monicker.Get( headTitleId );
			if( monicker ){
				this._AddTouXian(monicker.q_level);
			}
			else{
				this._HideTouXian();
			}
		}
		else{
			this._HideTouXian();
		}

		this.oNameShow.SetString(name);
		this.oNameShow.SetColor( isPlayer ? 0xececec : 0xffd776);

        if(this.oTitleImg && this.oTitleImg.visible){
			var realImgWidth = this.oTitleImg.getSpriteFrame().getRect().width;
            var width = realImgWidth - 20 + this.oNameShow.GetWidth();
            this.oNameShow.x = width / 2 - this.oNameShow.GetWidth();
            this.oTitleImg.x = -width / 2 + realImgWidth / 2 - 10;
        }else{
            this.oNameShow.x = -this.oNameShow.GetWidth() / 2;
        }
	},
	UpdateNameColor:function(killNum, isGray){
		var color = 0xffd776;
		if( isGray ){
			color = 0xa1a1a1;
		}
		else if( killNum > 0 ){
			if( killNum >= 3 ){
				color = 0xff0000;
			}
			else{
				color = 0xf0ff00;
			}
		}
		if( this.oNameShow )
			this.oNameShow.SetColor( color );
	},
	_AddTouXian:function(level){
		if( !this.oTitleImg && !this.bDispose ){
			this.oTitleImg = new cc.Sprite( EngineMgr.uiMgr.GetResByUrl( "other/touxian/word/" + level + ".png" ) );
			this.addChild(this.oTitleImg);
		}
		else{
			this.oTitleImg.setSpriteFrame( EngineMgr.uiMgr.GetResByUrl( "other/touxian/word/" + level + ".png" ) );
			this.oTitleImg.visible = true;
		}
	},
	_HideTouXian:function(){
		if( this.oTitleImg )
			this.oTitleImg.visible = false;
	},
	Dispose:function(){
		if (this.oNameShow != null){
			//this.oNameShow.Dispose();
			this.oNameShow = null;
		}
		this.oTitleImg = null;
		this._super();
	},

	// 子对象自动居中
	GetWidth:function(){
		return 0;
	},

	GetHeight:function(){
		return 17;
	},

	GetSortIdx:function(){
		return EnumDecorTopIdx.Name;
	},

	IsVisible:function(){
		return true;
	}

});

// 血条
var SceneBloodBar = SceneBloodBar || DisplayNode.extend({
	oBloodShow:null,
	oBloodBg:null,
	Init:function(){
		this._super();
		this.setName("SceneBloodBar");
	},

	SetParent:function(decorlayout){        
	},

	SetHp:function(cur, max){
		if( !this.oBloodShow )
		{
			this.oBloodBg = new cc.Sprite( EngineMgr.uiMgr.GetResByUrl( "public/image/redbg.png" ) );
			this.oBloodBg.setAnchorPoint(0, 0.5);
			this.oBloodBg.x = -1;
			this.addChild(this.oBloodBg);
			this.oBloodShow = new cc.Sprite( EngineMgr.uiMgr.GetResByUrl( "public/image/red.png" ) );
			this.oBloodShow.setAnchorPoint(0, 0.5);
			this.addChild(this.oBloodShow);
		}
		if ( cur == undefined || max == undefined )
		{
			return;
		}
		this.oBloodShow.setScaleX( Math.min( 1, cur / max ) );
	},

	Dispose:function(){
		if( this.oBloodShow )
			this.removeChild( this.oBloodShow );
		this.oBloodShow = null;
		if( this.oBloodBg )
			this.removeChild( this.oBloodBg );
		this.oBloodBg = null;
		this._super();
	},

	GetWidth:function(){
		return 77;
	},

	GetHeight:function(){
		return 25;
	},

	GetSortIdx:function(){
		return EnumDecorTopIdx.BloodBar;
	},

	IsVisible:function(){
		return true;
	}
});

// 场景公会名字显示
var SceneGuildNameBar = SceneGuildNameBar || DisplayNode.extend({
	oGuildNameShow:null,
	Init:function(){
		this._super();
		this.setName("SceneGuildNameBar");
	},

	SetParent:function(decorlayout){
	},

	SetNameShow:function(nam){
		if (this.oGuildNameShow == null && this.bDispose == false){
			//this.oNameShow = SceneTextV3.create();
			this.oGuildNameShow = new ccui.Text(nam, GameFont.DEFAULT, 20);
			this.oGuildNameShow.setTextColor(UIUtil.GetCCColor( 0x76fd56 ));
			this.oGuildNameShow.enableOutline(new cc.Color(0,0,0,255), 1);
			this.oGuildNameShow.x = this.oGuildNameShow.boundingWidth / 2;
			this.addChild(this.oGuildNameShow);
		}

		if (this.oGuildNameShow != null)
			this.oGuildNameShow.text = nam;
	},

	Dispose:function(){
		if (this.oGuildNameShow != null){
			//this.oNameShow.Dispose();
			this.oGuildNameShow = null;
		}
		this._super();
	},

	// 子对象自动居中
	GetWidth:function(){
		return 0;
	},

	GetHeight:function(){
		return 22;
	},

	GetSortIdx:function(){
		return EnumDecorTopIdx.GuildName;
	},

	IsVisible:function(){
		return true;
	}

});

// 场景公会名字显示
var SceneSpouseNameBar = SceneSpouseNameBar || SceneGuildNameBar.extend({
		Init:function(){
			this._super();
			this.setName("SpouseNameBar");
		},
		GetSortIdx:function(){
			return EnumDecorTopIdx.SpouseName;
		},
	});

// 大家好，我只管布局。
var SceneDecorLayout = SceneDecorLayout || cc.Class.extend({
	
	nLayoutType:0,
	aList:null,
	nOffY:0,
	nRendderid:0,

	nPosY:0,
	nPosX:0,

	oContainerRef:null,

	ctor:function(enumdecorlayout) {
		this.aList = [];
		this.nLayoutType = enumdecorlayout;
	},
	
	SortFunc:function(a, b) {
		if (a.GetSortIdx() > b.GetSortIdx())
			return 1;
		else if (a.GetSortIdx() < b.GetSortIdx())
			return -1;

		return 0;
	},
	
	Clear:function(){
		this.aList.length = 0;
		this.aList = null;
	},

	Add:function(scenedecor){
		if (scenedecor == null)
			return;

		if (this.aList.indexOf(scenedecor) != -1)
			return;

		this.oContainerRef.addChild(scenedecor);
		this.aList.push(scenedecor);
		this.Layout();
	},

	ChildSizeChange:function(scenedecor){
		this.Layout();
	},

	RemoveAll:function() {
		this.aList.length = 0;
		this.aList = null;
	},

	Remove:function(scenedecor){
		if (scenedecor == null)
			return;

		var idx = this.aList.indexOf(scenedecor);
		if (idx != -1){
			this.aList.splice(idx, 1);
            scenedecor.Dispose();
            //this.oContainerRef.removeChild(scenedecor);
			this.Layout();
		}
	},

	Layout:function(){
		this.aList.sort(this.SortFunc);

		var i;
		var offX = this.nPosX;
		this.nOffY = this.nPosY;

		var length = this.aList.length;
		var decor;
		if (this.nLayoutType == EnumSceneDecorLayout.Center){
			i = length;
			while ( --i > -1 ){
				decor = this.aList[i];
				this.nOffY += decor.GetHeight();
			}

			this.nOffY /= 2;
			this.nOffY -= 10;
			i = length;
			while ( --i > -1 ){
				decor = this.aList[i];
				this.nOffY -= decor.GetHeight();
				decor.setPosition(-decor.GetWidth() / 2, this.nOffY);
			}
		} else if ( this.nLayoutType == EnumSceneDecorLayout.Top ) {
			i = length;
			while ( --i > -1 ){
				decor = this.aList[i];
				this.nOffY -= decor.GetHeight();
				decor.setPosition(-decor.GetWidth() / 2, -this.nOffY);
			}
		} else if ( this.nLayoutType == EnumSceneDecorLayout.RightBottom ) {
			i = length;
			/*			while ( --i > -1 )
			{
				display = this.aList[i].go;
				display.y = CONTAINER_HEIGHT - display.height;
				display.x = offX;
				offX += display.GetWidth();
			}*/
		}

		/*		if( TOP_TYPE == _type )			// 通知自动战斗位置调整
		{
			Mgr.onHookMgr.updateAutoFightByTopLayer();
		}*/
	},

	GetOffY:function(){
		return this.nOffY;
	}
});

// 管理显示容器
var SceneBodyDecorControl = SceneBodyDecorControl || DisplayNode.extend({
	oCtrlObject:null,
	
	oTop:null,
	oCenter:null,
	oRightbottom:null,

	Init:function(){
		this._super();
		this.oTop = new SceneDecorLayout(EnumSceneDecorLayout.Top);
		this.oTop.oContainerRef = this;
		this.oCenter = new SceneDecorLayout(EnumSceneDecorLayout.Center);
		this.oCenter.oContainerRef = this;
		this.oRightbottom = new SceneDecorLayout(EnumSceneDecorLayout.RightBottom);
		this.oRightbottom.oContainerRef = this;
		
//		var nd = ToolBase.CreateRectNode(3, 3, cc.color(255,0,0, 255));
//		this.addChild(nd);
	},

	Dispose:function(){
		this.oTop.Clear();
		this.oCenter.Clear();
		this.oRightbottom.Clear();
		this.oCtrlObject = null;
		this._super();
	},

	SetControl:function(o){
		if (this.bDispose)
			return;
		this.oCtrlObject = o;
	},

	AddTop:function(decor){
		if (this.bDispose)
			return;
		this.oTop.Add(decor);
	},

	RemoveTop:function(decor){
		this.oTop.Remove(decor);
	},

	AddRB:function(decor) {
		if (this.bDispose)
			return;
		this.oRightbottom.Add(decor);
	},

	RemoveRB:function(decor){
		this.oRightbottom.Remove(decor);
	},

	AddCenter:function(decor) {
		if (this.bDispose)
			return;
		this.oCenter.Add(decor);
	},

	RemoveCenter:function(decor) {
		this.oCenter.Remove(obj);
	},

	RemoveAll:function() {
		this.oTop.RemoveAll();
		this.oRightbottom.RemoveAll();
		this.oCenter.RemoveAll();
	},

	ReSize:function(w, h, topOffx) {
		this.oTop.nPosY = -(h);
		this.oTop.nPosX = topOffx;
	
		this.oRightbottom.nPosY = -( 100 );
		this.oRightbottom.nPosX = w;
	
		this.oCenter.nPosY = -(h / 2) + 20;
		this.oCenter.nPosX = topOffx;
	},
	
	ShowTop:function(b){
		//if (topLayer.visible != b)
		//	topLayer.visible = b;
	},
	
	ShowRightBottom:function(b){
		/*if (rightBottomLayer.visible != b)
			rightBottomLayer.visible = b;*/
	}
});

// 场景称号显示
var SceneTitleBar = SceneTitleBar || DisplayNode.extend({
	oTitleShow:null,
	_titleData:null,
	Init:function(){
		this._super();
		this.setName("SceneTitleBar");
	},

	SetParent:function(decorlayout){
	},

	SetTitleShow:function(titleId){
		var titleData = Q_title.Get(titleId);
		if(!titleData){return;}
		this._titleData = titleData;
		var nam = TextUtil.RemoveHTMLTag(titleData.q_name);
		this.titleId = titleId;
		if (this.oTitleShow == null && this.bDispose == false)
		{
			this._AddTitle(titleId);
		}
		else if (this.oTitleShow != null)
		{
			this.oTitleShow.Dispose();
			this.oTitleShow = null;
			this._AddTitle(titleId);
		}
	},
	_AddTitle:function()
	{
		cc.log(JSON.stringify(this._titleData));
		if(this._titleData.q_art_type == 1)
		{
			var title = EffectUtil.GetShowEffect(this._titleData.q_art, EffectUtil.ENUM_TYPE_UI, true ,-1);
		}
		else
		{
			var url = "other/zhujiemian/chenghao/"+this._titleData.q_art+".png";
			var title = new DisplayObject();
			EngineMgr.uiMgr.GetAsynResByUrl( url, function(){
				title.initWithSpriteFrameName(url);
			}, this)
		}
		title.y = 10;
		this.addChild(title);
		this.oTitleShow = title;
	},

	Dispose:function(){
		if (this.oTitleShow != null){
			this.oTitleShow.Dispose();
			this.oTitleShow = null;
		}
		this._super();
	},

	// 子对象自动居中
	GetWidth:function(){
		return 0;
	},

	GetHeight:function(){
		return 40;
	},

	GetSortIdx:function(){
		return EnumDecorTopIdx.Title;
	},

	IsVisible:function(){
		return true;
	}

});


