﻿/*
 * 场景活动对象，包括动画和移动
 * tyevlag
 */

var SceneActiveObject = SceneBaseObject.extend({
	oAnimGroup:null,
	oMoveRule:null,
	
	oTopContainer:null,
	oBottomContainer:null,
	
	oShadow:null,
	oSelShowEff:null,
	oNameBar:null,
	oGuildNameBar:null,
	oCtrlDecor:null,
	otitleBar:null,
	obelongToBar:null,

	nBodyModelId:0,
	nBodyResId:0,
	sBodyResUrl:null,
	
	nMoveSpeed:0,
	nCurDirection:-1,

	oChangeColor:null,
	nCurActionType:-1,
	nLastActionTime:0,
	oCtrlAutoPath:null,
	// 当前动画结束时触发的回调
	// callbackFrameEnd:null,
	Init:function() {
		this._super();
		this.setName("SceneActiveObject");
		this.oChangeColor = cc.color(255,255,255,255);
		this.oMoveRule = new MMoveRule(this);
		this.oShadow = new cc.Sprite( EngineMgr.uiMgr.GetResByUrl( "public/image/shadow.png" ) );
		this.oAnimGroup = new MAnimationGroup();
		this.oAnimGroup.SetData(this);
		this.oTopContainer = new DisplayNode();
		this.oBottomContainer = new DisplayNode();
		if (this.oShadow != null){
			// this.oShadow.setScale( 1.5, 1 );
			// this.oShadow.setRotationSkewX (30);
			// this.oShadow.setColor(cc.color(0,0,0));
			// this.oShadow.setOpacity(100);
			this.oShadow.setLocalZOrder(-100);	//
			this.oShadow.retain();
		}
		
		this.oCtrlDecor = new SceneBodyDecorControl();
		this.oCtrlDecor.ReSize(70, 120, 0);
		
		this.oCtrlAutoPath = new AutoPathControl();
		this.oCtrlAutoPath.StartControl(this);

		this.addChild(this.oBottomContainer);
		this.addChild(this.oAnimGroup);
		this.addChild(this.oTopContainer);
		this.addChild(this.oCtrlDecor);
	},

	onEnter:function(){
		this._super();
		if( this.oShadow.parent == null )
			this.parent.addChild(this.oShadow);
	},
	
	Dispose:function(){
		this.InvaildCheck("SceneActiveObject Dispose!!!");
		if (this.oAnimGroup != null){
			this.oAnimGroup.Dispose();
			this.oAnimGroup = null;
		}

		this.RemoveAllSkillEffect();

		if (this.oCtrlAutoPath != null){
			this.oCtrlAutoPath.ReleaseControl();
			this.oCtrlAutoPath = null;
		}

		if (this.oTopContainer != null){
			this.oTopContainer.Dispose();
			this.oTopContainer = null;
		}

		if (this.oBottomContainer != null){
			this.oBottomContainer.Dispose();
			this.oBottomContainer = null;
		}

		if (this.oNameBar != null){
			this.oNameBar.Dispose();
			this.oNameBar = null;
		}

		if (this.otitleBar != null){
			this.otitleBar.Dispose();
			this.otitleBar = null;
		}

		if (this.obelongToBar != null){
			this.obelongToBar.Dispose();
			this.obelongToBar = null;
		}

		if (this.oGuildNameBar != null){
			this.oGuildNameBar.Dispose();
			this.oGuildNameBar = null;
		}

        if (this.oCtrlDecor != null){
            this.oCtrlDecor.Dispose();
            this.oCtrlDecor = null;
        }

		if (this.oShadow != null){
			this.oShadow.removeFromParent();
			this.oShadow.release();
			this.oShadow = null;
		}

		this._super();
	},
	
	OnRecycle:function(){
		this.nBodyModelId = 0;
		this.nBodyResId = 0;
		this.sBodyResUrl = null;
		this.SetModelReverse(false);
		this.oAnimGroup.OnRecycle();
		this.oMoveRule.OnRecycle();
		this.nCurActionType = -1;
		if (this.oShadow != null) {
			this.oShadow.removeFromParent();
		}
		this.RemoveAllSkillEffect();
		this._super();
	},

	OnRevert:function(){
		this.oAnimGroup.OnRevert();
		this.oMoveRule.OnRevert();
		this._super();
	},
	
	OnFrame:function(curTime){
		this._super(curTime);
		if (this.oMoveRule != null)
			this.oMoveRule.OnFrame(curTime);

		if (this.oCtrlAutoPath != null)
			this.oCtrlAutoPath.OnFrame();

		// if ( this.oShadow ){
		// 	this.oShadow.setSpriteFrame( this.oAnimGroup.oBaseAnimObj.getSpriteFrame() );
		// 	this.oShadow.setFlippedX( this.oAnimGroup.oBaseAnimObj.isFlippedX() );
		// }
	},

	setPositionX:function(value){
		this._super(value);
		this.oShadow.x = value;
	},

	setPositionY:function(value){
		this._super(value);
		this.oShadow.y = value;
	},

    GetHide:function(){
        return this.bHided;
    },

    SetHide:function (type) {
        this.bHided = !type;
    },

    SetCantSetState:function(state){
        this.bCantSetState = state;
    },

	SetDataWithBean:function(msgb){
		this.bMouseIn = false;
		this.CheckAlpha();
		this.SetMoveSpeed( msgb.speed );
		this._super(msgb);

		this.SetScale(1, 1);
		this.SetObjectHeightPos(0);
		this.UpdateNameShow();
	},

	SetGridPt:function(pt){
		this.oMoveRule.SetGridPt(pt);
	},

	SetPixPt:function(pt){
		this.oMoveRule.SetPixPt(pt);
	},

	SetRunWay:function(way){
		if (way == null || way.length == 0)
			return;

		this.oMoveRule.Run(way);
	},

	SetJumpWay:function(way, isFly){
		if (way == null || way.length != 2)
			return;
		this.oMoveRule.Jump(way, isFly);
	},

	SetDownHillWay:function(way){
		if (way == null || way.length != 2)
			return;

		this.oMoveRule.DownHill(way);
	},

	SetMoveMoment:function(way)
	{
		if (way == null || way.length != 1)
			return;
        /// 屏蔽
        if(!this.GetHide()){
            BlurShadowEffect.StartShadow( this );
        }
		this.oMoveRule.Fly(way);
	},

	SetBackOutWay:function(way)
	{
		if (way == null || way.length != 1)
			return;
		this.oMoveRule.BackOut(way);
	},

	SetMoveSpeed:function(speed){
		this.nMoveSpeed = speed;
		this.oMoveRule.SetMoveSpeed( speed );
	},

	StopMove:function(notify){
		notify = ( notify != false );
		//击退等击退完毕自己切
		if( this.oMoveRule.nCurMoveActionType == EnumActionType.BACKOUT)
			return;
		this.oMoveRule.StopMove(notify);
		//this.SetGridPt(this.oServPt);
	},

	IsMoving:function(){
		return this.oMoveRule.IsMoving();
	},

	CheckState:function(v){
		return (this.nCurActionType == v);
	},

	CheckStateArray:function(arr){
		for (var i = 0; i < arr.length; ++i){
			if (this.CheckState(i))
				return true;
		}
		return false;
	},

	// 转向某个点
	TurnToPoint:function(targetPt, isSlant){
		var gridPt = this.GetGridPt();
		var dir = (isSlant ? ToolMap.CalcDirSlant(gridPt, targetPt) : ToolMap.CalcDir(gridPt, targetPt));
		this.SetDirection(dir);
	},

	// 转向目标对象
	TurnToObj:function(target, isSlant){
		isSlant = isSlant != false;
		if (target != null){
			this.TurnToPoint(target.GetGridPt(), isSlant);
		}
	},

	SetStateShowStand:function(){
		return this.SetStateShow(EnumActionType.STAND);
	},

	SetStateShowAttack:function(id, dir){
		if (MDirection.IsValid(dir) == false)
			dir = this.nCurDirection;

		var at = EnumActionType.ATTACK;
		if (id == 2)
			at = EnumActionType.ATTACK2;
		else if (id == 3)
			at = EnumActionType.ATTACK3;
		else if (id == 4)
			at = EnumActionType.ATTACK4;
		else if (id == 5)
			at = EnumActionType.ATTACK5;
		else if (id == 6)
			at = EnumActionType.ATTACK6;
		else if (id == 7)
			at = EnumActionType.ATTACK7;
		return this.SetStateShow(at, dir);
	},

	CanCounterAttack:function(){
		var curState = this.nCurActionType;
		switch( curState ){
			case EnumActionType.RUN:
			case EnumActionType.JUMP:
			case EnumActionType.JUMP_FLY:
			case EnumActionType.MOVEMOMENT:
			case EnumActionType.DEAD:
			case EnumActionType.ATTACK:
			case EnumActionType.ATTACK2:
			case EnumActionType.ATTACK3:
			case EnumActionType.ATTACK4:
			case EnumActionType.ATTACK5:
			case EnumActionType.ATTACK6:
			case EnumActionType.ATTACK7:
				return false;
			break;
		};
		return true;
	},

	CanSetState:function(at){
		var curState = this.nCurActionType;

		if( ( TimerUtil.GetTimer() - this.nLastActionTime ) > MAnimationDefine.MAX_CHANGE_TIME && !this.IsMoving() && curState != EnumActionType.DEAD )	//移动结束后才允许超时切换 不然飞行等长状态有问题
			return true;

        if(this.bCantSetState) return false;

		if( at == EnumActionType.DEAD )
			return true;
		else if( at == EnumActionType.WOUND ){		//只有站立才能切受伤
			switch( curState ){
				case EnumActionType.STAND:
					return true;
			}
			return false;
		}
		// else if( at == EnumActionType.RUN ){
		// 	switch (curState){
		// 		case EnumActionType.ATTACK:
		// 		case EnumActionType.ATTACK2:
		// 		case EnumActionType.ATTACK3:
		// 		case EnumActionType.ATTACK4:
		// 		case EnumActionType.ATTACK5:
		// 		case EnumActionType.ATTACK6:
		// 		case EnumActionType.ATTACK7:
		// 			return false;
		// 	}
		// }

		if( curState == EnumActionType.DEAD ){
			switch( at ){
				case EnumActionType.WOUND:
				case EnumActionType.RUN:
				case EnumActionType.ATTACK:
				case EnumActionType.ATTACK2:
				case EnumActionType.ATTACK3:
				case EnumActionType.ATTACK4:
				case EnumActionType.ATTACK5:
				case EnumActionType.ATTACK6:
				case EnumActionType.ATTACK7:
					return false;
			}
		}
		else if( curState == EnumActionType.MOVEMOMENT || curState == EnumActionType.JUMP || curState == EnumActionType.JUMP_FLY || curState == EnumActionType.JUMP_SKY2 ){
			if( at != EnumActionType.STAND )
				return false;
		}

		return true;
	},

	SetStateShow:function(at, dir, defaultrestype, bForce){//增加一个在同状态下强制刷新主要用于同一状态下对象特殊动作切换
		if (dir == undefined)
			dir = MDirection.NONE;
		if (defaultrestype == undefined)
			defaultrestype = EnumDefaultResType.SCENE_OBJ;

		if ( !bForce && this.CanSetState(at) == false)
			return false;

		if (MDirection.IsValid(dir) == false){
			//DebugTool.Log("setStateShow : Direction.isValid");
			dir = this.nCurDirection;
		}

		var curState = this.nCurActionType;
		if( curState == at && !bForce ){
			if(this.nCurDirection == dir){
				if( this.IsAttackAction() )
					this.oAnimGroup.ForceDoAction( this.GetCurActionName(), dir, defaultrestype);
			}
			else
				this.SetDirection(dir);
			return true;
		}

		switch (at) {
			case EnumActionType.DEAD:
				dir = MDirection.UP;
				break;
			case EnumActionType.STAND:
			case EnumActionType.WATERSTAND:
			case EnumActionType.SIT:
			case EnumActionType.SITDOUBLE:
				this.StopMove(false);
				break;
			default:
				break;
		}

		this.nCurDirection = dir;
		this.nCurActionType = at;

		// var actionKey = MAnimationDefine.GetActionName(at);
		this.nLastActionTime = TimerUtil.GetTimer();
		var actionKey = this.GetCurActionName();
		this.oAnimGroup.DoAction( actionKey, dir, defaultrestype);
		return true;
	},
	GetCurActionName:function(){
		if( this.nBodyResId == 27 && this.nCurActionType == EnumActionType.ATTACK )
			return EnumActionName.STAND;
		return MAnimationDefine.GetActionName( this.nCurActionType );
	},

	// 移动策略开始，不一定是普通走动
	OnMoveBegin:function(dir, moveat){
		var actionType = EnumActionType.STAND;
		if (moveat == EnumActionType.RUN){
			if( this.IsActionAttacking() ){	//把攻击动作播完再切走
				this.nCurDirection = dir;
				return;
			}
			actionType = EnumActionType.RUN;
		} else if (moveat == EnumActionType.JUMP){
			actionType = EnumActionType.JUMP;
		} else if (moveat == EnumActionType.JUMP_SKY2){
			actionType = EnumActionType.JUMP_SKY2;
		} else if (moveat == EnumActionType.DOWNHILL){
			actionType = EnumActionType.RUN;
		} else if (moveat == EnumActionType.MOVEMOMENT){
			actionType = EnumActionType.MOVEMOMENT;
		} else if (moveat == EnumActionType.JUMP_FLY){
			actionType = EnumActionType.JUMP_FLY;
		}
		//this.oAnimGroup.DoAction(MAnimationDefine.GetActionName(actiontype), dir, 0);
		//this.nCurDirection = dir;
		this.SetStateShow(actionType, dir, EnumDefaultResType.SCENE_OBJ, true);	//移动切的话就强制切了
	},

	// 移动策略结束，不一定是普通走动
	// 这里移动状态已经被清除啦，需要判断什么加参数吧
	OnMoveEnd:function(dir, movetype) {
		if (Mgr.sceneAction.CheckDoControlMove(this)) {
		} else if (Mgr.sceneAction.CheckDoRush(this)) {
		} else {
			if (movetype == EnumActionType.JUMP || movetype == EnumActionType.JUMP_SKY2){
				// 备注：这里其实应该要判断服务器状态来设置动作
				if (movetype == this.nCurActionType)
					this.SetStateShow(EnumActionType.STAND, dir);
			} else if (movetype == EnumActionType.DOWNHILL) {
				if (movetype == this.nCurActionType)
					this.SetStateShow(EnumActionType.DEAD);
			} else if (movetype == EnumActionType.BACKOUT ) {		//击退其实也是移动结束 run的话要切站立
				if (EnumActionType.RUN == this.nCurActionType)
					this.SetStateShow(EnumActionType.STAND);
			}
			else{
					// if (movetype == this.nCurActionType)		不管动作是否一致 都要切站立
						this.SetStateShow(EnumActionType.STAND, dir);
			}

//				if (isAttackAction == false) {
//				nCurDirection = dir;
//				setDelayToStand(this is CMainPlayer ? GameConfig.MOVE_END_STAND_DELAY_TIME_MAIN : GameConfig.MOVE_END_STAND_DELAY_TIME);
//				////////tryDoStand();
//				}
		}
		this.oCtrlAutoPath.CheckDoNext();	//改为切了动作在检测下一步吧  不然现在跳走的组合 不切站立切不到走的动作

	},

	SetDirection:function(dir){
		if( MDirection.IsValid(dir) && this.nCurDirection != dir) {
			this.nCurDirection = dir;
			this.oAnimGroup.SetDirection(dir);
		}
	},

	CheckAlpha:function(){
		var toAlpha = 1;
		var gdpt = this.GetGridPt();
		if (Mgr.sceneMap.IsGridCover(gdpt.x, gdpt.y)){
			toAlpha = 0.5;
		} else {
			toAlpha = 1;
		}

		if (toAlpha != this.oChangeColor.a) {
			this.oAnimGroup.SetAlpha(toAlpha);
			//this.oChangeColor.a = toAlpha;
			//this.oAnimGroup.ChangeColor(this.oChangeColor);
		}
	},

	IsAttackAction:function(){
		return (  this.nCurActionType == EnumActionType.ATTACK
				|| this.nCurActionType == EnumActionType.ATTACK2
				|| this.nCurActionType == EnumActionType.ATTACK3
				|| this.nCurActionType == EnumActionType.ATTACK4
				|| this.nCurActionType == EnumActionType.ATTACK5
				|| this.nCurActionType == EnumActionType.ATTACK6
				|| this.nCurActionType == EnumActionType.ATTACK7  );
	},

	IsActionAttacking:function(){
		return this.IsAttackAction();
	},

	IsActionAttackingEnd:function(){
		return this.IsAttackAction();
	},

//	IsActionAttackingNormalEnd:function(){
//		return this.oAnimGroup.isPlayingEnd(EnumActionName.ATTACK);
//	},
//
//	IsActionAttackingCastEnd:function(){
//		return this.oAnimGroup.isPlayingEnd(EnumActionName.ATTACK2);
//	},

	OnMoveEnterGird:function(newGridPos){
		this.nLastMoveTime = TimerUtil.GetTimer();
		this.CalcZOrder();
		this.CheckAlpha();
		Mgr.map.UpdatePanelPos(this.nGid, newGridPos.x, newGridPos.y);
	},

	OnAnimationPlayEnd:function(){
		if (this.nCurActionType == EnumActionType.JUMP_DOWN){
			this.TryDoStand();
		} else if (this.nCurActionType == EnumActionType.ATTACK
				|| this.nCurActionType == EnumActionType.ATTACK2
				|| this.nCurActionType == EnumActionType.ATTACK3
				|| this.nCurActionType == EnumActionType.ATTACK4
				|| this.nCurActionType == EnumActionType.ATTACK5
				|| this.nCurActionType == EnumActionType.ATTACK6
				|| this.nCurActionType == EnumActionType.ATTACK7
				|| this.nCurActionType == EnumActionType.WOUND){
			if( this.IsMoving() )
				this.SetStateShow(EnumActionType.RUN);
			else
				this.TryDoStand();
		}
	},

//	TryDoDelayStand:function(){
//		if (this.nCurActionType == EnumActionType.WALK 
//				|| this.nCurActionType == EnumActionType.RUN 
//				|| this.nCurActionType == EnumActionType.COLLIDE 
//				|| this.nCurActionType == EnumActionType.BACKOUT)
//		{
//			tryDoStand();//setStateShow(EnumActionType.STAND);
//		}
//		delaySetStandTime = 0;
//	},

//	SetDelayToStand:function(t){
//		delaySetStandTime = ToolBase.GetTimerS() + t;
//	},

//	DoCurActionNextFrame:function(moveat){
//		if (moveat != nCurActionType){
//			this.SetStateShow(moveat, this.nCurDirection);
//		}
//		else{
//			this.oAnimGroup.animObj().GotoNextFrame();
//		}
//	},
//
//	DoCurActionPreFrame:function(moveat){
//		if (moveat != this.nCurActionType){
//			this.SetStateShow(moveat, this.nCurDirection);
//		}
//		else{
//			this.oAnimGroup.animObj.GotoPreFrame();
//		}
//	},

	TryDoStand:function(){
		this.SetStateShow(EnumActionType.STAND);
	},

	OnGroupOver:function(){
	},

	GetBodyResUrl:function(){
		return null;
	},

	// 传奇的函数，非传奇游戏可能不会用到了
	FixPtByServPt:function(){
		if (this.IsMoving()){
			if (ToolBase.IsEqualPoint(this.GetServPt(), this.oMoveRule.moveTarPt) == false){
				this.StopMove(false);
				this.SetGridPt(this.GetServPt());
			}
		} else {
			if (ToolBase.IsEqualPoint(this.GetGridPt, this.GetServPt()) == false){
				this.SetGridPt(this.GetServPt());
			}
		}
	},

	// 是否能跑步
	IsCanDoRun:function(ignoreAttack) {
		ignoreAttack = ignoreAttack == true;
//		if (this.IsMoving())
//			return false;
		if(!this.oCtrlAutoPath)
			return false;

		if (this.oCtrlAutoPath.IsMoveSendLock())
			return false;

		return this.CanSetState(EnumActionType.RUN);
	},

	StartAutoPath:function(pt, param) {
		this.oCtrlAutoPath.MoveToPtAuto(pt, param, this.IsCanDoRun());
	},

	IsAutoPath:function() {
		return this.oCtrlAutoPath.IsAutoPath();
	},

	StopAutoPath:function() {
		this.oCtrlAutoPath.StopAutoPath();
	},

	OnAutoPathEnd:function(param){
		if (param != null)
			param.Execute();
	},

	GetStandHeight:function(){
		return this.oBoundingBox.height;
	},

	GetStandWidth:function(){
		return this.oBoundingBox.width;
	},

	SetNameShow:function(n, isPlayer){
		if (n != null && this.oNameBar == null){
			this.oNameBar = new SceneNameBar();
			this.oCtrlDecor.AddTop(this.oNameBar);
		} else if (n == null && this.oNameBar != null){
            this.oCtrlDecor.RemoveTop(this.oNameBar);
			this.oNameBar = null;
		}
		if (this.oNameBar != null)
		{
			this.oNameBar.SetNameShow(n,this.oHeadTitleId, isPlayer);
		}
	},
	//称号
	SetTitleShow:function(titleId)
	{
		if (titleId != 0 && this.otitleBar == null){
			this.otitleBar = new SceneTitleBar();
			this.oCtrlDecor.AddTop(this.otitleBar);
		} else if (titleId == 0 && this.otitleBar != null){
			this.oCtrlDecor.RemoveTop(this.otitleBar);
			this.otitleBar = null;
			return;
		}
		if(this.otitleBar)
		{
			this.otitleBar.visible = true;
			this.otitleBar.SetTitleShow(titleId);
		}
	},

	SetGuildNameShow:function(n){
		if (n != null && this.oGuildNameBar == null){
			this.oGuildNameBar = new SceneGuildNameBar();
			this.oCtrlDecor.AddTop(this.oGuildNameBar);
		} else if (n == null && this.oGuildNameBar != null){
			this.oCtrlDecor.RemoveTop(this.oGuildNameBar);
			this.oGuildNameBar = null;
		}

		if (this.oGuildNameBar != null){
			var str = n.split(".");
			n = "[帮派]" + str[1];
			this.oGuildNameBar.SetNameShow(n);
		}
	},

	/*	public override void setSortOrder(short id)
	{
		if (sortingOrderId != id)
		{
			base.setSortOrder(id);
			MbcAnimGroup.setSortOrder(id);
		}
	}

	public override void setSortLayer(int id)
	{
		if (sortingLayerId != id)
		{
			base.setSortLayer(id);
			MbcAnimGroup.setSortLayer(id);
		}
	}*/

	AddTopChild:function(dis) {
		this.oTopContainer.addChild(dis);
	},

	AddBottomChild:function(dis) {
		var num = this.oBottomContainer.getChildrenCount();
		this.oBottomContainer.addChild(dis, num);
	},

	RemoveAllSkillEffect:function(){
		var children = this.oBottomContainer.getChildren();
		children = children.concat( this.oTopContainer.getChildren() );
		for( var i = 0, len = children.length; i < len; i++ ){
			var child = children[i];
			if( child.getName() == "SkillEffect" ){
				SkillEffect.Delete(child)
			}
		}
	},

	IsSelectState:function() {
		return (this.oSelShowEff != null);
	},

	SetSelShow:function(v) {
		// if (v && this.oSelShowEff == null) {
		// 	this.oSelShowEff = SkillEffect.Create(2, EffectUtil.ENUM_TYPE_OTHER, true);
		// 	this.oBottomContainer.addChild(this.oSelShowEff);
		// 	this.UpdateNameShow();
		// 	return true;
		// } else if (v == false && this.oSelShowEff != null){
		// 	this.oSelShowEff.Dispose();
		// 	this.oSelShowEff = null;
		// 	this.UpdateNameShow();
		// 	return true;
		// }
		return false;
	},

	CheckLocalBounding:function(worldPt){
		var localPt = new cc.p(worldPt.x - this.x, worldPt.y + this.y);
		var hitRect = this.oAnimGroup.GetHitRect();
		if( cc.rectEqualToRect( hitRect, cc.RectZero() )){
			if (ToolBase.IsContainsPoint(this.oBoundingBox, localPt)){
				return true;
			}
		}
		else{
			var scaleY = this.oAnimGroup.getScaleY();
			hitRect.x *= scaleY;
			hitRect.y *= scaleY;
			hitRect.width *= scaleY;
			hitRect.height *= scaleY;
			if (ToolBase.IsContainsPoint(hitRect, localPt)){
				return true;
			}
		}

		return false;
	},

	// 临时写的，先放这吧 ty
	DEFAULT_VERTEX_SHADER: 
		"attribute vec4 a_position; \n" 
		+ "attribute vec2 a_texCoord; \n" 
		+ "varying mediump vec2 v_texCoord; \n" 
		+ "void main() \n" 
		+ "{ \n" 
		+ "    gl_Position = (CC_PMatrix * CC_MVMatrix) * a_position;  \n" 
		+ "    v_texCoord = a_texCoord; \n" 
		+ "}", 
	GRAY_SCALE_FRAGMENT_SHADER: 
		"varying vec2 v_texCoord;   \n"
		+ "uniform vec2 u_TextureCoordOffset[9];							\n"
		+ "void main(void)													\n"
		+ "{																\n"
		+ "vec4 sample;\n"
		+ "vec4 sample4 = texture2D(CC_Texture0, v_texCoord.st);		\n"			
		+ "int find = 0;	\n"
		+ "int find2 = 0;	\n"
		+ "if (sample4.a > 0.001) {\n"
		+ " find2 = 1;	\n"
		+ "	for (int i = 0; i < 9; i++)	{																\n"
		+ "		if (i != 4){\n"
		+ "			sample = texture2D(CC_Texture0, v_texCoord.st + u_TextureCoordOffset[i]);	\n"
		+ "			if (sample.a < 0.00001){  \n"
		+ "				find = 1;\n"
		+ "				break;\n"
		+ "			}	\n"
		+ "		}\n"
		+ "	}\n"
		+ "}\n"
		+ "if (false)									\n"
		+ "gl_FragColor = vec4(0,0,0,0);						\n"
		+ "else													\n"
		+ "gl_FragColor = vec4(sample4.r * 1.5, sample4.g * 1.5, sample4.b * 1.2, sample4.a);	\n"
		+ "}",

		GRAY_SCALE_FRAGMENT_SHADER2: 
			"varying vec2 v_texCoord;   \n"
			+ "uniform vec2 u_TextureCoordOffset[9];							\n"
			+ "void main(void)													\n"
			+ "{                                                                                                   \n"
			+ "                                                                                                   \n"
			+ "vec4 sample = texture2D(CC_Texture0, v_texCoord.st);													\n"			
			+ "                                                                                                  \n"
			+ "vec2 tc2 = vec2(v_texCoord.x + u_TextureCoordOffset[1].x, v_texCoord.y + u_TextureCoordOffset[1].y);                                                                                                          \n"
			+ "vec4 sample2 = texture2D(CC_Texture0, tc2);                                                                                                    \n"
			+ "vec2 posmid = vec2(0.5, 0.5);                                                                                                   \n"
			+ "                                                                                                   \n"
			+ "vec2 p = vec2(v_texCoord.xy);                                                                                                   \n"
			+ "                                                                                                 \n"
			+ "float checkdis = distance(p, posmid);                                                                                                   \n"
			+ "                                                                                                   \n"
			+ "                                                                                                   \n"
			+ "                                                                                                   \n"
			+ "float alph = sample.a;                                                                                                   \n"
			+ " //if ((v_texCoord.x % 2) == 1.0)                                                                                                  \n"
			+ "//     alph = 0.0;                                                                                             \n"
			+ "gl_FragColor = vec4(sample.r * sample2.r, sample.g * sample2.g , sample.b * sample2.b, alph);	                                                                                                   \n"
			+ "                                                                                                   \n"
			+ "                                                                                                   \n"
			+ "                                                                                                   \n"
			+ "                                                                                                   \n"
			+ "                                                                                                   \n"
			+ "                                                                                                   \n"
			+ "}",
		
	OnMouseIn:function(){
		//this.oAnimGroup.SetAlpha(0.5);
		//this.oAnimGroup.oBaseAnimObj.setColor(cc.color(228,0,0));
//		var program = cc.shaderCache.getProgram("HighLightShader");
//		if(!program){ 
//			program = new cc.GLProgram(); 
//			program.initWithVertexShaderByteArray(this.DEFAULT_VERTEX_SHADER, this.GRAY_SCALE_FRAGMENT_SHADER); 
//			program.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);        //cocos会做初始化的工作 
//			program.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS); 
//			program.link(); 
//			program.updateUniforms(); 
//			cc.shaderCache.addProgram(program, "HighLightShader");
//		} 
		//gl.useProgram(this.program.getProgram()); 
		//sprite.shaderProgram = program; 
//		this.oAnimGroup.oBaseAnimObj.setShaderProgram(program);

		this._super();
		this.UpdateNameShow();
	},

	OnMouseOut:function(){
		//this.oAnimGroup.SetAlpha(1);
		//this.oAnimGroup.oBaseAnimObj.setColor(cc.color(255,255,255));
//		this.oAnimGroup.oBaseAnimObj.setShaderProgram(cc.shaderCache.programForKey(cc.SHADER_POSITION_TEXTURECOLOR));

		this._super();
		this.UpdateNameShow();
	},

	UpdateNameShow:function() {
		if (this.oNameBar == null)
			return;

//		if (this.bMouseIn || isSelectState)
//			this.oNameBar.visible = true;
//		else
//			this.oNameBar.visible = false;
	},
	
	// 设置对象跳跃高度，跟显示对象没有移动位置，移动的只是相关显示容器
	SetObjectHeightPos:function(value) {
		// this.oBottomContainer.y = value;
		this.oAnimGroup.y = value;
		// this.oTopContainer.y = value;
		if (this.oCtrlDecor != null) {
			this.oCtrlDecor.y = value;
		}
	},
	
	SetScale:function(sx, sy){
		if (sx != null) {
			this.oAnimGroup.setScaleX(sx);
		}
		if (sy != null) {
			this.oAnimGroup.setScaleY(sy);
		}
	},

	SetModelReverse:function(value){
		this.oAnimGroup.setScaleX(value ? -1 : 1);
	},

	GetHeight:function(){
		return this.oAnimGroup.GetHeight();
	}
});
var _proto = SceneActiveObject.prototype;
cc.defineGetterSetter(_proto, "x", _proto.getPositionX, _proto.setPositionX);
cc.defineGetterSetter(_proto, "y", _proto.getPositionY, _proto.setPositionY);