﻿
/*
 * 
 * 场景角色对象基类
 * tyevlag
 */
var SceneBaseObject = DisplayNode.extend({
	nGid:0,
	oSid:null,
	sBaseName:null,
	oBoundingBox:null,
	oServPt:null,
	bCahce:false,
	bNonMouseHit:false,
	bMouseIn:false,
	objType:0,
	nDelayDelTime:0,
	
	Init:function(){
		this._super();
		this.setName("SceneBaseObject");
		this.oBoundingBox = cc.rect(-30, -100, 60, 100);
		this.oServPt = cc.p(0, 0);
		this.sBaseName = "";
		this.retain();	//直接保留引用  不会被释放 dispose再释放掉
	},
	
	Dispose:function(){
		this.oBoundingBox = null;
		this.oServPt = null;
		this.oSid = null;
		this.release();		//释放
		this._super();
	},

	OnRecycle:function(){
		this.bCahce = true;
		this.nGid = 0;
		this.removeFromParent();
	},

	OnRevert:function(){
		this.bCahce = false;
	},

	OnFrame:function(curTime){	
		if (this.nDelayDelTime != 0){
			if (ToolBase.GetTimer() > this.nDelayDelTime){
				Mgr.sceneObj.DeleteObject(this.nGid);
			}
		}
	},
	
	SetDataWithBean:function(msgb){
		this.CalcZOrder();
	},
	
	FillWorldBounding:function(rect){
		rect.x = this.oBoundingBox.x + this.x;
		rect.y = this.oBoundingBox.y - this.y;
		rect.width = this.oBoundingBox.width;
		rect.height = this.oBoundingBox.height;
	},

    CheckLocalBounding:function(worldPt){
    	var localPt = cc.p(worldPt.x - this.x, worldPt.y + this.y);
    	if (ToolBase.IsContainsPoint(this.oBoundingBox, localPt))
    		return true;
    	return false;
    },
	
	GetServPt:function(){
		return cc.p(this.oServPt.x, this.oServPt.y);
	},
	
	SetServPt:function(sPt){
		this.oServPt.x = sPt.x;
		this.oServPt.y = sPt.y;
    },
    
    GetGridPt:function(){
    	return ToolMap.PixPt2GridPt(this.x, -this.y);
    },

	SetGridPt:function(pt){
		pt = ToolMap.GridPt2PixPt(pt.x, pt.y, true)
		this.x = pt.x;
		this.y = -pt.y;
	},
	
	GetPixPt:function(){
		return new cc.p( this.x, -this.y );
	},
	
	OnMouseIn:function(){
		this.bMouseIn = true;
	},
	
	OnMouseOut:function(){
		this.bMouseIn = false;
	},
	
	SetDelayDel:function(t){
		if (t <= 0)
			this.nDelayDelTime = 0;
		else
			this.nDelayDelTime = ToolBase.GetTimer() + t;
	},
	
	CalcZOrder:function() {
		var gridpt = this.GetGridPt();
		var order = gridpt.x + gridpt.y * 10000;
		this.setLocalZOrder(order);
	}
});
