﻿/*
 * 场景战斗对象
 * tyevlag
 */

var SceneFightObject = SceneActiveObject.extend({
	nMaxHp:0,
	nMaxMp:0,
	nCurHp:0,
	nCurMp:0,
	nSexId:0,
	nCurLevel:0,
	nGameState:0,
	nBuffState:0,

	oBloodBar:null,
	oCtrlAutoFight:null,
	oCtrlBuff:null,
	bDeadState:false,
	buffs:null,
	
	Init:function() {
		this._super();
		this.buffs = [];
		this.setName("SceneFightObject");
		this.oBloodBar = new SceneBloodBar();
		this.oCtrlDecor.AddTop(this.oBloodBar);
	},

	Dispose:function() {
		if (this.oCtrlAutoFight != null) {
			this.oCtrlAutoFight.ReleaseControl();
			this.oCtrlAutoFight = null;
		}
		
		if (this.oCtrlBuff != null){
			this.oCtrlBuff.ReleaseControl();
			this.oCtrlBuff = null;
		}

		if( this.oBloodBar )
		{
			this.oBloodBar.Dispose();
			this.oBloodBar = null;
		}
		this.buffs = null;

		this._super();
	},

	OnRecycle:function(){
		this.nMaxHp = 0;
		this.nMaxMp = 0;
		this.nCurHp = 0;
		this.nCurMp = 0;
		this.nSexId = 0;
		this.nCurLevel = 0;
		this.nGameState = 0;
		this.nBuffState = 0;
		this.buffs.length = 0;
		this._super();
	},

	OnRevert:function(){
		this._super();
	},
	
	OnFrame:function(curTime){
		this._super(curTime);
		
		if (this.oCtrlAutoFight != null) {
			this.oCtrlAutoFight.OnFrame();
		}
	},
	
	SetDataWithBean:function(msgb){
		this._super(msgb);
		if (msgb.objinfotype != SceneObjectInfoType.MAINPLAYER)
			this.buffs = BuffUtil.BuffInfoToVo(msgb.buffs);
		this.bDeadState = false;
	},
	
	InitAction:function(){
		this.SetStateShow(EnumActionType.STAND);
	},

	IsCanDoRun:function(ignoreAttack){
		ignoreAttack = ignoreAttack == true;
		if (this._super(ignoreAttack) == false)
			return false;

		if (this.oCtrlAutoFight != null && this.oCtrlAutoFight.IsAttackLock())
			return false;

		if (!ignoreAttack && this.IsActionAttacking())	//任务走的话不判定攻击状态
			return false;

		return true;
	},
	
	OnAutoPathEnd:function(param){
		this._super(param);
		if (this.oCtrlAutoFight != null)
			this.oCtrlAutoFight.OnMoveEnd(param);
	},
	
	CheckLocalBounding:function(worldPt){
		if (this.bDeadState)
			return false;

		return this._super(worldPt);
	},
	
	
	IsDeadState:function(){
		return this.bDeadState;
	},
	
	DoDeadState:function(){
		this.bDeadState = true;
		this.SetStateShow(EnumActionType.DEAD);
		this.CalcZOrder();
	},

	DoReviveState:function(){
		this.bDeadState = false;
		this.SetStateShow(EnumActionType.STAND);
	},
	
	DoAttack:function(dir, type) {
		this.SetStateShowAttack(type, dir);
	},

	ChangeFlyAction:function(){

	},

	UpdateHp:function(cur, max){
		if( !max )
			max = this.nMaxHp;
		if( this.oBloodBar && this.oBloodBar.visible ){
			this.oBloodBar.SetHp(cur, max);
		}
		this.nCurHp = cur;
		this.nMaxHp = max;
	},

	UpdateLevel:function(level)
	{
		this.nCurLevel = level;
	},

	AddBuff:function (vo) {
		var len = this.buffs.length;
		var i;
		var buff;
		for( i = 0; i < len; i++ ){
			buff = this.buffs[i];
			//重复的删除掉
			if(buff.Sid().Equal(vo.Sid()) || ( buff.ModelId() == vo.ModelId() && buff.Model().q_overlay == 1 ) ){
				this.buffs.splice(i,1);
				break;
			}
		}
		this.buffs.push(vo);
	},

	UpdateBuff:function (vo) {
		this.AddBuff(vo);
	},

	DelBuff:function (sid) {
		var del = null;
		var len = this.buffs.length;
		for( var i = 0; i < len; i++ ){
			if( this.buffs[i].Sid().Equal(sid) ){
				del = this.buffs.splice(i,1)[0];
				break;
			}
		}
		
		return del;
	},

	RemoveAllBuff:function () {
		this.buffs.length = 0;
	},

	HideBody:function(time){
		this.oAnimGroup.visible = false;
		if( time ){
			TimerUtil.SetTimeout(this, this.ShowBody, time);
		}
	},

	ShowBody:function(){
		if( this.oAnimGroup )	//显示的时候可能已经dispose了
			this.oAnimGroup.visible = true;
	}
});