﻿/*
 * 场景主玩家
 * tyevlag
 */

var SceneMainPlayer = ScenePlayer.extend({
	isInFightState:false,
	curPkMode:0,

	Init:function() {
		this._super();
		this.setName("SceneMainPlayer");
		Mgr.mainPlayer = this;
		Mgr.sceneMap.SetLookMapMiddle(this);
		if (this.oCtrlAutoFight == null){
			this.oCtrlAutoFight = new AutoFightControl();
			this.oCtrlAutoFight.StartControl(this);
		}
	},

	Dispose:function(){
		this._super();
	},

	OnRecycle:function(){
		this._super();
	},

	OnRevert:function(){
		this._super();
	},

	OnFrame:function(curTime){
		this._super(curTime);
		Mgr.task.CheckAutoTask();
		Mgr.player.OnAutoFight();
		if( curTime > this._autoRideTime && !Mgr.zone.IsInZoneMap() ){
			Mgr.resline.EquipResline(EnumResline.HORSE);
			this._autoRideTime = Number.MAX_SAFE_INTEGER;
		}
	},

	SetDataWithBean:function(msgb){
		var info = msgb;
		if (msgb.objinfotype == SceneObjectInfoType.MAINPLAYER) {
			this.oSid = info.sid;
			this.nGid = this.oSid.toGID();
			this.oHeadTitleId = info.headTitleId;
			this.killNum = info.killnum;
			this.pkValue = info.isGreyname;
			this.sBaseName = SceneObjUtil.GetScenePlayerName(info.name);
			this.attributeData = info.attributeData;
			this.setName(this.sBaseName + info.sid.toString());
			this.nJobId = info.job;
			this.nCurLevel = info.level;
			msgb.speed = info.attributeData.moveSpeed;
//			gameState = info.state;
//			jobId = info.job;
//			sexId = info.sex;
//
//			sexId = 1;
//			curLevel = info.level;
//			maxHp = info.hp;
//			maxMp = info.mp;
//			curHp = info.hp;
//			curMp = info.mp;
//			curExp = info.exp;
//
//			updateAttr(info.abilityinfo);
//			updateEquips(info.equips);
// 			var sceneShowData = SceneObjUtil.GetShowDataByEquips([]);//(info.equips);
// //			if (sexId == 1)
// //				sceneShowData.bodyModelId = 99991;
// //			else
// //				sceneShowData.bodyModelId = 99990;
//
// 			sceneShowData.nBodyModelId = 1;
//			//sceneShowData.wepModelId = 99995;
			this.spouseName = info.spouseName;
			this.marryExteriorId = info.marryExteriorId;
            this.aureoleId = info.aureoleId;
            this.marriageId = info.marriageId;

			this.serverKey = info.serverKey;
			this.guildId = info.guildId;
			this.nHorseUpState = 1;
			this.nBodyModelId = info.job;
			this.nWepModelId = info.job;
			this.nDisguiseId=info.disguiseId;
			this.nTaijiModelId=info.gossipLevel;
			this.UpdateFashionId(info.curFashion);
			// this.nWepModelId = sceneShowData.nWepModelId;
			// this.nWingModelId = sceneShowData.nWingModelId;
			this.nCurDirection = info.nDirection;
			this.RefreshShowBody();
			this.RefreshShowWep();

			//this.RefreshResline();

//			var draw = new cc.DrawNode();
//			draw.drawRect(cc.p(0, 0), cc.p(3, 3), cc.color(100, 255, 100, 80));
//			this.addChild(draw);
			
//			this.oPosLabel = new cc.LabelTTF("111", "", 12);
			
			//draw.addChild(this.oPosLabel);
//			// 测试服务器位置
//			serverptgo = DisplayObject.create("serverptgo");
//			SpriteRenderer sprrender = serverptgo.GetComponent<SpriteRenderer>();
//			sprrender.sprite = Resources.Load<Sprite>("playerpoint");
//			Mgr.sceneLayer.addBottom(serverptgo);
//
//			setMoveSpeed(info.abilityinfo.speed);
			var gridpt = ToolMap.PixPt2GridPt(info.x, info.y);
			if( this.nCurActionType != EnumActionType.MOVEMOMENT && !Mgr.sceneMap.bChangingState ){		//只能是跨服 和跨服退出才有可能 等切完地图自己会设置坐标跟状态
				this.SetServPt(gridpt);
				this.SetGridPt(gridpt);
				this.InitAction();
			}
			zz.Log("((())) create CMainPlayer ((()))" + info.sid.hexValue + " name:" + info.name + "  pt:" + gridpt);
			this.SetNameShow(info.name, true);
			this.SetTitleShow(info.titleId);
			this.UpdateHp(info.attributeData.curHp, info.attributeData.maxBaseHp);
//			setShowBloodBar(1, false);
		}

		this._super(msgb);
	},
	
	// 进入场景设置坐标
	SetPosByEnterMap:function(gridpt){
		this.SetServPt(gridpt);
		this.StopMove(false);
		this.SetGridPt(gridpt);
	},

	OnMoveEnd:function(dir, type) {
		this._super(dir, type);
//		Mgr.sceneMap.SimCheckChangeMap(this.GetPixPt());
	},

	OnMoveEnterGird:function( newGridPos ){
		this._super(newGridPos);
		Mgr.npc.TurnToMainplayer();
		Mgr.map.CheckJumTransfer(newGridPos);
	},

	//设置手动操作
	nActiveTime:0,
	SetActiveState:function(){
		this.nActiveTime = TimerUtil.GetTimer() + 3000;
		//Mgr.player.isAutoTask = false;
		Mgr.task.listerCallBack = false; // 如果不清除，目标
	},
	ClearActiveState:function () {
		this.nActiveTime = 0;
	},
	IsActiveState:function(){
		return TimerUtil.GetTimer() < this.nActiveTime;
	},

	SetStateShow:function(at, dir, defaultrestype, bForce){
		var success = this._super(at, dir, defaultrestype, bForce);
		if( success ){
			if( this.nCurActionType === EnumActionType.RUN ){
				if( this._autoRideTime === Number.MAX_SAFE_INTEGER)
					this._autoRideTime = Date.now() + 1000;
			}
			else{
				this._autoRideTime = Number.MAX_SAFE_INTEGER;
			}
			Mgr.gameSoundMgr.PlaySoundAction(this.nCurActionType);
		}
	},

	//采集
	_aCollectBar:null,
	_aCollectBg:null,
	StartCollect:function(atime) {
		if (!this._aCollectBar) {
			//bg
			this._aCollectBg = new cc.Sprite(EngineMgr.uiMgr.GetResByUrl( "public/image/redbg.png" ));
			this._aCollectBg.setAnchorPoint(0.5,0.5);
			this._aCollectBg.x = Mgr.mainPlayer.GetPixPt().x;
			this._aCollectBg.y = -Mgr.mainPlayer.GetPixPt().y + 200;
			Mgr.sceneLayer.oLayerMap.addChild(this._aCollectBg);

			//progress
			this._aCollectBar = new cc.ProgressTimer(new cc.Sprite(EngineMgr.uiMgr.GetResByUrl( "public/image/green.png" )));
			this._aCollectBar.type = cc.ProgressTimer.TYPE_BAR;
			this._aCollectBar.midPoint = cc.p(0, 0);
			this._aCollectBar.barChangeRate = cc.p(1, 0);
			this._aCollectBar.setAnchorPoint(0.5,0.5);
			this._aCollectBg.addChild(this._aCollectBar);
			this._aCollectBar.x = this._aCollectBg.getContentSize().width / 2;
			this._aCollectBar.y = this._aCollectBg.getContentSize().height / 2;
		}

		if (atime == 0)
			atime = 3000;

		var ts = atime / 1000;
		var func=cc.callFunc(function () {
			Mgr.sceneLayer.oLayerMap.removeChild(this._aCollectBg);
			this._aCollectBar = null;
		},this);
		var to1 = cc.sequence(cc.progressTo(ts, 100), cc.progressTo(0, 100), func);
		this._aCollectBar.runAction(to1);
	},
	StopCollect:function () {
		if (this._aCollectBar) {
			Mgr.sceneLayer.oLayerMap.removeChild(this._aCollectBg);
			this._aCollectBar = null;
		}
	},

	OnMoveBegin:function(dir, moveat){
		this._super(dir, moveat);
	},

	StopMove:function (notify) {
		notify = ( notify != false );
		this._super(notify);
		if ( !Mgr.team.followState )
			Mgr.team.lastActiveTime = TimerUtil.GetTimer();
	},
});