﻿/**
 * 场景地图管理
 * tyevlag
 */

var EnumExtraGridType = EnumExtraGridType || {
	//1:不准穿人
	GRID_PLAYER_BLOCK:0x1,
	//2:不准穿怪
	GRID_MONSTER_BLOCK:0x2,
	//4:不增加PK值
	GRID_NO_PKVALUE:0x4,
	//8:死亡不掉落身上物品
	GRID_NO_DEADDROP_BODY:0x8,
	//16:死亡不掉落背包物品
	GRID_NO_DEADDROP_BAG:0x10,
	//32:不准使用记忆
	GRID_NO_USE_REMEMBER:0x20,
	//64:不准使用地面持续魔法
	GRID_NO_USE_GROUNDMAGIC:0x40,
	//128:不准使用妙影无踪
	GRID_NO_USE_MIAOYIN:0x80,
	//256:不准复活
	GRID_NO_REVIVE:0x100,
	//512:不准骑马
	GRID_NO_RIDING:0x200,
	//1024:不准挂机
	GRID_NO_AUTOFIGHT:0x400,
	//2048:攻城区域
	GRID_CITYAREA:0x800,
	//4096:矿点
	GRID_MINE:0x1000,
	//8192:显示传送区域
	GRID_SHOW_TRANS:0x2000,
	//16384:答题区域 A
	GRID_QUESTIONA:0x4000,
	//32768:答题区域 B
	GRID_QUESTIONB:0x8000,
	//65536:怪物攻城区域
	GRID_MONSTERCITY:0x10000,
	// 攻城经验5倍区
	GRID_CITYEXP5:0x80000,
	// 攻城经验10倍区
	GRID_CITYEXP10:0x100000,
	// 攻城经验15倍区
	GRID_CITYEXP15:0x200000

};

var SceneMapMgr = SceneMapMgr || {
	// 传送过地图
	CHANGE_MAP_TYPE_TRANS:1,

	oMapLayer:null,
	oMapShow:null,
	oMapGrid:null,

	nMapId:0,
	nMapResId:0,
	sMapName:"",
	nCurSceneW:0,
	nCurSceneH:0,

	// 是否安全区地图
	bSelf:false,
	// 是否可以打新人
	bPkNewBee:false,
	// 是否可以越级打
	bPkNoLevel:false,

	bUseRose:false,
	bFreePk:false,
	bCityArea:false,
	bFightArea:false,
	bAddPk:false,
	bRememEqu:false,
	bMonsterBlock:false,
	bBannerWarMap:false,
	bDBQBMap:false,

	// 地图资源延迟加载 阻挡数据必须加载
	bLoadMapData:true,
	bLoadMapThumnails:true,
	// 是否加载场景特效
	bLoadMapEffect:false,
	// 是否副本地图
	bMapZoneMap:false,

	sPathChunks:"",
	sUrlData:"",
	sUrlThumbnails:"",

	sKeyData:"",
	sKeyThumbnails:"",

	bChangingState:false,
	nChangeMapType:-1,

	// 地图资源持有对象
	bMapResObject:null,

	oGridResData:null,
	//跨地图路劲列表
	_resultList : [],
	_targetMapId : 0,
	_zoneMapIdHash:null,

	line:null,

	Init:function(){
		this.oMapGrid = MMapGrid.Init();
		this.oMapShow = MMapChunk.Init(Mgr.sceneLayer.oLayerMap, Mgr.sceneLayer.oLayerTop);

		// 测试不需要阻挡
		this.oMapGrid.NO_BLOCK = false;
		return this;
	},

	OnFrame:function(){
		this.oMapShow.OnFrame();
	},

	SetLookMapMiddle:function(tar){
		this.oMapShow.SetLookTarget(tar);
	},

	GetMapShowSpr:function(){
		return this.oMapShow.oThumbnails;
	},
	DoChangeMap:function(id, ctype){
	    Mgr.map.waitChangeMapTimer = null;
		if( ctype >= 0 ){
			var loginPanel = Mgr.uiMgr.ShowPanelByType( DengLuPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP );
			loginPanel.ShowProgress(3);
		}
		EngineMgr.uiMgr.HidePanelByType( TaskNpcTalkMainExt.PanelName );
		ToolBase.Log("doChangeMap ctype:" + ctype.toString() + " curId:" + this.nMapId + " toid:" + id.toString());
		TimeTaskMgr.RemoveTaskByType(TimeTaskMgr.TYPE_SCENE);
		Mgr.sceneObj.RemoveAllRoundObject();
		this.RemoveSceneTransport();
		this.RemovebossDieEffect();
		this.nChangeMapType = ctype;
		Mgr.map.SelTarget(null);
		if (this.bMapResObject != null) {
			this.bMapResObject.bDispose = true;
		}
		this.bMapResObject = {bDispose:false};
		Mgr.sceneAction.oCtrlObject = null;
		if (this.nMapId == id){
			// 同场景切换
			cc.log("this.bChangingState = true;");
			this.OnChangeMapEnd();
		} else {
			// 直接切换
			this.ChangeMap(id);
		}
	},

	ChangeMap:function(mid){
		//Mgr.uiMgr.showPanel<ChangeMapProgressPanelExt>();
		this.ClearCurMap();
		cc.log("ChangeMap:this.bChangingState = true;");
		this.nMapId = mid;

		if( EnterGameMgr.isSingleGame )
		{
			mid = 1004;

			var mapm = Q_map.Get(mid);
			if (mapm == null) {
				zz.Error("mapm isNull !!!!!!!  " + mid.toString());
				return;
			}

			this.sMapName = mapm.q_map_name;
			this.nCurSceneW = mapm.q_map_width;
			this.nCurSceneH = mapm.q_map_height;
			this.nMapResId = mapm.q_mapresid;
		}
		else
		{

			var mapm = Q_map.Get(mid);
			if (mapm == null) {
				AlertExt.Show("Q_map isNull !!!!!!!  " + mid.toString());
				return;
			}

			this.sMapName = mapm.q_map_name;
			this.nCurSceneW = mapm.q_map_width;
			this.nCurSceneH = mapm.q_map_height;
			this.nMapResId = mapm.q_mapresid;
		}



		this.bMapSelf = (mapm.q_map_safe == 1);
//		bMapPkNewBee = (mapm.q_map_pkprotection == 0);
//		bMapPkNoLevel = (mapm.q_map_pklevel == 0);
//		bMapUseRose = (mapm.q_rose_resurrection == 0);
//		bMapFreePk = (mapm.q_map_class == 1);
//		bMapCityArea = (mapm.q_map_class == 2);
//		bMapFightArea = (mapm.q_map_class == 3);
//		bMapAddPk = (mapm.q_map_pk == 0);
//		bMapRememEqu = (mapm.q_map_recall == 0);
//		bMapMonsterBlock = (mapm.q_map_monster == 1);
//		bMapZoneMap = (mapm.q_map_zones == 1);

//		if (mapm.q_mapres_str != null && mapm.q_mapres_str != "")
//		{
//			string[] arr = mapm.q_mapres_str.Split(new char[] { ',' });
//			if (arr.Length == 3)
//			{
//				bLoadMapThumnails = (int.Parse(arr[1]) == 1);
//				bLoadMapEffect = (int.Parse(arr[2]) == 1);
//			}
//		}

		var pathName = "res/map/" + this.nMapResId;

		this.sPathChunks = pathName + "/chunks/";
		this.sUrlData = "res/data/map/" + this.nMapResId + ".res";
		this.sUrlThumbnails = pathName + "/thumbnails.jpg";

		this.sKeyData = this.sUrlData;
		this.sKeyThumbnails = this.sUrlThumbnails;
		Mgr.gameSoundMgr.StopAllSound();
		this.PrepareMapRes();
	},

	ClearCurMap:function(){
		if (this.nMapId == 0)
			return;

		this.oMapGrid.Clear();
		this.oMapShow.Clear();

		Mgr.gameSoundMgr.CleanAllSound();
        this.nMapId = 0;
	},

	// 开始下载地图数据资源
	PrepareMapRes:function() {
		LoadMgr.LoadBinary(this.sUrlData, this.bMapResObject, LoadPriority_Prior, {complete:this.CallbackMapResLoaded, error:this.CallbackMapResLoadError} )
	},

	// 开始下载地图缩略图资源
	PrepareMapThumbnails:function() {
		LoadMgr.LoadImage(this.sUrlThumbnails, this.bMapResObject, LoadPriority_Prior, {complete:this.CallbackMapThumbLoaded, error:this.CallbackMapThumbLoadError});
	},

	CallbackMapResLoadError:function(s) {
		AlertExt.Show("缺少地图资源 : " + Mgr.sceneMap.nMapId + "  resId: " + Mgr.sceneMap.nMapResId);
	},

	CallbackMapThumbLoadError:function(s) {
		Mgr.sceneMap.OnMapThumbLoaded(null);
	},

	CallbackMapResLoaded:function(asset) {
		Mgr.sceneMap.OnMapResLoaded(asset);
	},

	CallbackMapThumbLoaded:function(spr) {
		Mgr.sceneMap.OnMapThumbLoaded(spr);
	},

	OnMapResLoaded:function(asset) {
		var res = asset;
		this.oGridResData = res;
		Mgr.login.AddProgress();
		if (res != null){
			this.PrepareMapThumbnails();
		} else {
			ToolBase.LogError("map grids is null");
		}
	},

	OnMapResError:function(errorInfo){
		ToolBase.LogError(errorInfo);
	},

	OnMapThumbLoaded:function(texture){
		if (texture != null) {
			this.oMapShow.SetThumbnails(texture);
		}
		//Sprite tex = Sprite.Create(spr.texture, spr.rect, new Vector2(0, 1), 1, 0, SpriteMeshType.FullRect) ;
		//Mod.minimap.updateMinimap();
		if (true)
			this.PrepareMapFootLight();
		else
			this.PrepareMapResComplete(this.oGridResData);
	},

	PrepareMapFootLight:function(){
		LoadMgr.LoadImage("res/other/foot.png", this, LoadPriority_Prior, {complete:this.CallbackFootImageLoaded, error:this.CallbackMapFootImageError});
	},

	CallbackFootImageLoaded:function(texture){
		if (texture != null){
			this.oMapShow.SetFootLight(texture);
		}
		this.PrepareMapResComplete(this.oGridResData);
	},

	CallbackMapFootImageError:function(){
		zz.Error("FootImageError Load Error : " + this.nMapId);
		this.PrepareMapResComplete(this.oGridResData);
	},

	OnMapThumbError:function(errorInfo){
		zz.Error("OnMapThumbError : " + errorInfo);
	},

	// 加载地图资源完成
	PrepareMapResComplete:function(griddata){
		
		Mgr.login.AddProgress();

		var outDatas = null;
//		if ( EngineCost.engieType == EngineCost.TYPE_WEB ){
			var zlibData = new Zlib.Inflate(griddata);
			outDatas = zlibData.decompress();
//		}
//		else{
//			var str = Base64Util.encode( griddata );
//			var customClass = cc.CustomClass.create();
//			
//			var len = customClass.UnZlibData( str );
//			if ( len > 0 )
//				outDatas = customClass.GetUnpackBase64Str(); 
//			outDatas = Base64Util.decode( outDatas );
//		}

		this.LoadMapData(outDatas);
		Mgr.login.AddProgress();
	},

	// 加载地图数据
	LoadMapData:function(griddata){
		this.oMapGrid.LoadMap(this.nMapResId, this.nCurSceneW, this.nCurSceneH, griddata);
		this.oMapShow.ChangeMap(this.nMapResId, this.nCurSceneW, this.nCurSceneH, 1024, 1024);
		this.OnChangeMapEnd();
	},

	// 加载地图数据完成
	OnChangeMapEnd:function(){
		if( EnterGameMgr.isSingleGame || this.isTestChange )
		{
			// 测试直接进入地图，这里要把主玩家创建啦
			if (Mgr.mainPlayer == null) {
				var resMyPlayerInfoMsg = SceneObjUtil.SimCreateSceneObjInfo(SceneObjectInfoType.MAINPLAYER);
				resMyPlayerInfoMsg.attributeData = new AttributeData();
				resMyPlayerInfoMsg.attributeData.moveSpeed = 230;
				resMyPlayerInfoMsg.attributeData.curHp = 5000;
				resMyPlayerInfoMsg.attributeData.maxBaseHp = 6000;
				Mgr.sceneObj.CreateObject(resMyPlayerInfoMsg);
			}
			this.isTestChange = false;
			//UpgradeProgress.dispose();

			// 模拟收到消息
			var recvmsg = new ResEnterMapMessage();
			recvmsg.line = 1;
			recvmsg.pos = new Position();

			if (this.simtestpt != null){
				recvmsg.pos.x = this.simtestpt.x;
				recvmsg.pos.y = this.simtestpt.y;
			} else {
				recvmsg.pos.x = 55 * 50 + 25;
				recvmsg.pos.y = 25 * 50 + 25;
			}
			if( Mgr.mainPlayer )
			{
				recvmsg.pos.x = Mgr.mainPlayer.x;
				recvmsg.pos.y = -Mgr.mainPlayer.y;
			}


			Mgr.map.RecvResEnterMapMessage(recvmsg);
		}
		else
		{
			if (this.nChangeMapType == -1){
				Mgr.login.SendReqLoadFinishMessage();
			} else {
				Mgr.map.SendReqLoadFinishForChangeMapMessage();
			}
		}
	},
	enterMapTime:0,
	// 真正进入地图
	EnterMap:function(line, gridpt){
		this.line = line;
		this.enterMapTime = 0;
		this.bChangingState = false;
        Mgr.task._taskTrackPanel.isInBoss = false;
		Mgr.map.ServerCheckReset();
		var pixedPt = ToolMap.GridPt2PixPt(gridpt.x, gridpt.y, true);
		pixedPt.y = -pixedPt.y;
		this.SetLookMapMiddle(pixedPt);

		// 因为有准确坐标，设置可以开始加载地图块
		this.oMapShow.bLoadChunkLock = false;

		// 场景表现类对象也放这里吧，因为有主角坐标比较好处理
		Mgr.map.UpdatePanelPos( Mgr.mainPlayer.nGid, gridpt.x, gridpt.y );
		this.CreateSceneTransport();
		Mgr.zone.IsInXinMoMap();
		if(Mgr.zone.IsInZoneMap()){
			//进入副本操作（任务数据重置，切换小地图为退出副本按钮）
			Mgr.resline.UnEquipResline();	//进副本下马
			Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName).ShowZoneState();
			if(!Mgr.sword.IsInZoneMap() && Mgr.task._taskTrackPanel){
//				Mgr.task._taskTrackPanel.ShowRightPanel(true);
//				Mgr.task._taskTrackPanel.ShowZoneData();
			}
			Mgr.uiMgr.CheckShowInZone(this.ZoneType() <= 5);	//单人副本界面那几个

			// hide active mark
			var panels = Mgr.activeMark.GetPanels();
			for ( var i = 0; i != panels.length; i++ ) {
				panels[i].visible = false;
			}

			if(Mgr.sword.IsInZoneMap()){
				Mgr.sword.BeginShowArrow();
				if(Mgr.uiMgr.IsPanelShowByName(TaijiPanelExt.PanelName))
					Mgr.uiMgr.HidePanelByType(TaijiPanelExt.PanelName);
			}
			if(Mgr.uiMgr.IsPanelShowByName(HusongTimeCueExt.PanelName))
			{
				EngineMgr.uiMgr.HidePanelByType(HusongTimeCueExt.PanelName);
			}
		}else{
			if(Mgr.sword.IsShowArrow())
				Mgr.sword.HideShowArrow();
			Mgr.uiMgr.CheckShowInZone(false);
			Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName).ShowOutZoneState();
			Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName).OnOutZone();
			if(Mgr.task._taskTrackPanel){
				if(Mgr.sceneMap.nMapId != 20005){
//					Mgr.task._taskTrackPanel.HideActiveData();
				}
//				Mgr.task._taskTrackPanel.HideZoneData();
			}
			if(Mgr.uiMgr.IsPanelShowByName(FubenTimeCueExt.PanelName)){
				Mgr.uiMgr.HidePanelByType(FubenTimeCueExt.PanelName);
				Mgr.uiMgr.GetPanelByType(FubenTimeCueExt.PanelName).ClearTime();
			}
			if(Mgr.uiMgr.IsPanelShowByName(FubenWinExt.PanelName)){
				Mgr.uiMgr.HidePanelByType(FubenWinExt.PanelName);
			}
			if(Mgr.uiMgr.IsPanelShowByName(FubenDefeatedExt.PanelName)){
				Mgr.uiMgr.HidePanelByType(FubenDefeatedExt.PanelName);
			}
			if(Mgr.uiMgr.IsPanelShowByName(ExpFubenWinExt.PanelName)){
				Mgr.uiMgr.HidePanelByType(ExpFubenWinExt.PanelName);
			}
			if(Mgr.uiMgr.IsPanelShowByName(WendingCueExt.PanelName)){
				Mgr.uiMgr.HidePanelByType(WendingCueExt.PanelName);
			}
			if(Mgr.uiMgr.IsPanelShow(Mgr.luckydraw.guangwuPanel)){
				Mgr.uiMgr.HidePanel(Mgr.luckydraw.guangwuPanel);
			}

			//进入世界BOSS打怪
			if(Mgr.monster.IsInMonsterMap())
			{
				Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName).ShowZoneState();
				Mgr.task._taskTrackPanel.isInBoss = true;
			}
		}

        var gridOffset = cc.director.getWinSize().height/(2*ToolMap.dgh) + 4;//动态改变偏差值
        var enterPos = new cc.p(gridpt.x, gridpt.y - gridOffset);//修改为垂直进入地图
		Mgr.mainPlayer.SetPosByEnterMap(enterPos);



        Mgr.kingneutral.OnMapReadyChanged();
        Mgr.kingguild.OnMapReadyChanged();

        Mgr.task._taskTrackPanel.UpdateView();
        var zonetype = Mgr.sceneMap.ZoneType();
        if(zonetype == EnumZoneType.TYPE_KFDR){
            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
            panel.__panel.InitView();
            panel.__teamPanel.InitView();
        }
        else if(zonetype == EnumZoneType.TYPE_LFDR){
            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
            panel.__panel.InitView();
            panel.__teamPanel.InitView();
        }
		else if( zonetype != EnumZoneType.TYPE_JY) {
			var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
			panel.visible = true;
		}
		Mgr.player.ShowShortChatState();

		var self = this;
		//加个延迟 主要是加载地图和卡顿
		Mgr.map.enterMapTimer = TimerUtil.SetTimeout( this, function(){
			var flyEnd = function(){
				Mgr.mainPlayer.SetStateShowStand();
				Mgr.mainPlayer.SetPosByEnterMap(gridpt);
				Mgr.mainPlayer.CalcZOrder();
				Mgr.sceneMap.SetLookMapMiddle(Mgr.mainPlayer);
				// 设置可以控制主玩家
				Mgr.sceneAction.oCtrlObject = Mgr.mainPlayer;
				// if( self.nChangeMapType ) {
				Mgr.mainPlayer.oCtrlAutoPath.MoveToNextMap();
				// }
				if( Mgr.task.zoneWaitTaskId != 0 ){
					Mgr.task.AutoTask( Mgr.task.zoneWaitTaskId == -1 ? Mgr.task.aCurTaskId : Mgr.task.zoneWaitTaskId );
					Mgr.task.zoneWaitTaskId = 0;
				}
				if ( Mgr.team.followState ) {
					Mgr.team.StartFollow();
				}

                Mgr.zone.OnMapChanged();
                Mgr.convoy.OnMapChanged();
                Mgr.kingneutral.OnMapChanged();
                Mgr.kingguild.OnMapChanged();
                Mgr.activeMark.OnMapChanged();

				//铸剑天下
				if(Mgr.sceneMap.nMapId == 1002 || Mgr.sceneMap.nMapId == 1003){
					var nextBoss = Mgr.monster.GetNextBossInfo();
					if( nextBoss ){
						Mgr.mainPlayer.oCtrlAutoPath.RunToPt(cc.p(nextBoss.x, nextBoss.y), AutoPathParam.CreateAutoFight());
					}
				}

				// 帮会boss副本  自动挂机
				if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_GUILDBOSS && Mgr.guild.isExistGuildBoss) {
					// boss 坐标后端写死了的  cc.p(24, 16)
					Mgr.mainPlayer.oCtrlAutoPath.RunToPt(cc.p(24, 16), AutoPathParam.CreateAutoFight());
				}
			};
			var flyInMap = function(){
				//这里后面可能加判断 不展示飞行的情况直接调用flyEnd
				if( ConnectMgr.isReconnect ){
					flyEnd.call(self, null);
					ConnectMgr.isReconnect = false;
					if( Mgr.player.isAutoFight )
						Mgr.player.TryStartAutoFight();
				}
				else{
					//给落地动作加个缓冲
                    var action = cc.EaseOut.create(cc.MoveBy.create(1.5,cc.p(0,-gridOffset*ToolMap.dgh)),1.5);
					if( Mgr.mainPlayer ){		//过图中logout会报错
						Mgr.mainPlayer.runAction(action);
						Mgr.mainPlayer.SetStateShow(EnumActionType.JUMP_SKY2);
						Mgr.map.flyInMapEndTimer = TimerUtil.SetTimeout(self, flyEnd, 1500);
					}
				}
			};
			if( self.enterMapTime )
				Mgr.map.flyInMapTimer = TimerUtil.SetTimeout(self, flyInMap, self.enterMapTime);
			else
				flyInMap.call(self, null);
			Mgr.uiMgr.HidePanelByType(DengLuPanelExt.PanelName);
		}, ConnectMgr.isReconnect ? 0 : 500);
		// Mgr.task.ShowRightPanel();
		//Mgr.sceneCam.LookAt(Mgr.mainPlayer.transform);
		Mgr.gameSoundMgr.PlayBGM();
		Mgr.gameSoundMgr.PlaySoundScene();
		Mgr.zone.IsInZoneMapTwo();
	},

	GetSceneWidth:function(){
		return this.nCurSceneW;
	},

	GetSceneHeight:function(){
		return this.nCurSceneH;
	},

	GetGridWidth:function(){
		return this.oMapGrid.GetGridWidth();
	},

	GetGridHeight:function(){
		return this.oMapGrid.GetGridHeight();
	},

//	public void setObjMark(int oldx, int oldy, int newx, int newy, IGirdObjectCheck check)
//	{
//		oMapGrid.setMark(oldx, oldy, newx, newy, check);
//	}
//
//	public void removeobjMark(int x, int y, IGirdObjectCheck check)
//	{
//		oMapGrid.removeMark(x, y, check);
//	}

	IsGridCanMove:function(x, y){
		if (this.oMapGrid != null)
			return this.oMapGrid.GridIsWork(x, y, true);

		return false;
	},

	IsInWater:function(x, y){
		if (x == -1 || y == -1)
			return false;

		return this.oMapGrid.GridIsWater(x, y);
	},

	IsInWaterless:function(x, y){
		if (x == -1 || y == -1)
			return false;

		return this.oMapGrid.GridIsWaterless(x, y);
	},

	IsGridSafe:function(x, y){
		if (this.bMapSelf)
			return true;

		if (this.oMapGrid != null){
			return this.oMapGrid.GridIsSafeable(x, y);
		}

		return false;
	},

	IsGridNotAddPkValueArea:function(x, y){
		if (this.bMapAddPk == false)
			return true;

		return ((this.GetExtraGridType(x, y) & EnumExtraGridType.GRID_NO_PKVALUE) != 0);
	},

	IsGridCover:function(x, y){
		if (this.oMapGrid != null){
			return this.oMapGrid.GridIsCov(x, y);
		}

		return false;
	},

	// 得到特殊格子类型
	GetExtraGridType:function(x, y){
		if (this.oMapGrid != null){
			return this.oMapGrid.GetExtraType(x, y);
		}

		return 0;
	},

	aSceneTransportEff:[],
	jumpTransferArr:[],
	transferArr:[],
	bossDieEffect:[],

	// 创建场景传送点显示对象
	CreateSceneTransport:function(){
		var translist = Q_map_transfer.GetList();
		var len = translist.length;
		for (var i = 0; i < len; ++i){
			var model = translist[i];
			if (model.q_tran_from_map == this.nMapId){
				var eo = new SceneEffectObject();
				var thept = ToolMap.GridPt2PixPt(model.q_tran_from_x, model.q_tran_from_y, true);
				eo.SetData({mod:model, type:0, effectid:model.q_tran_icon, effecttype:EffectUtil.ENUM_TYPE_OTHER, pt:thept});
				Mgr.sceneLayer.AddBottom(eo);
				this.aSceneTransportEff.push(eo);
				if( model.q_tran_type == 1 )
					this.jumpTransferArr.push( model );
				this.transferArr.push(model);
			}
		}
	},

	RefreshbossDieEffect:function(bossInfos){
		for(var i = 0; i < bossInfos.length; i++){
			if(!this.bossDieEffect[i]){
                var oAnimObject = new MAnimationObject();
                oAnimObject.SetPixPt(ToolMap.GridPt2PixPt(bossInfos[i].x, bossInfos[i].y, true));
                Mgr.sceneLayer.AddBottom(oAnimObject);
                oAnimObject.SetResUrlBase(EffectUtil.GetEffectUrl(EffectUtil.ENUM_TYPE_OTHER, 8));
                oAnimObject.DoAction("stand5");
                (function(i){
                    oAnimObject.loadCallback = function(){
                        var label = new MUILabel();
                        label.SetFontSize(20);
                        var monsterInfo = Q_monster.Get(bossInfos[i].modeldId);
                        label.SetText(monsterInfo.q_name + "\n等待刷新");
                        label.SetColor("0x01ab25");
                        label.x = MMapChunk.nChunkWidth/2 - this.GetWidth()/2 + label.getContentSize().width/2;
                        label.y = MMapChunk.nChunkHeight/2 - this.GetHeight()/2;
                        // label.SetColor("0xf2a757");
                        this.addChild(label);
					};
                })(i);
                this.bossDieEffect.push(oAnimObject);
			}
			if(this.bossDieEffect[i]){
				if(bossInfos[i].alive != 1)
                    this.bossDieEffect[i].visible = true;
				else
                	this.bossDieEffect[i].visible = false;
			}
		}
	},

	// 删除场景传送点显示对象
	RemoveSceneTransport:function(){
		for (var i = 0; i < this.aSceneTransportEff.length; ++i){
			this.aSceneTransportEff[i].Dispose();
		}
		this.aSceneTransportEff.length = 0;
		this.jumpTransferArr.length = 0;
		this.transferArr.length = 0;
	},

	RemovebossDieEffect:function(){
        for (var i = 0; i < this.bossDieEffect.length; i++){
            this.bossDieEffect[i].Dispose();
        }
        this.bossDieEffect.length = 0;
	},

	// 前端模拟走传送点切地图
	SimCheckChangeMap:function(pixpt) {
		for (var i = 0; i < this.aSceneTransportEff.length; ++i){
			if (ToolMap.CalcDistance(pixpt, this.aSceneTransportEff[i].GetPixPt()) < 100){
				this.simtestpt = ToolMap.GridPt2PixPt(this.aSceneTransportEff[i].oData.mod.q_tran_to_x, this.aSceneTransportEff[i].oData.mod.q_tran_to_y, true);
				this.simtestpt.x += 150;
				this.simtestpt.y += 150;
				this.DoChangeMap(this.aSceneTransportEff[i].oData.mod.q_tran_to_map, 0);
				break;
			}
		}
	},

	simtestpt:null,


//	// 设置动态遮挡
//	SetDyCovings(ArrayList pts, bool b)
//	{
//		if (oMapGrid != null && pts != null)
//		{
//			foreach (Vector2 i in pts)
//			{
//				oMapGrid.setDyCoving((int)i.x, (int)i.y, b);
//			}
//		}
//	}

//			/// <summary>
//			/// 置动态阻挡
//			/// </summary>
//			/// <param name="pts">Pts.</param>
//			/// <param name="b">If set to <c>true</c> b.</param>
//			public void setDyBlocks(ArrayList pts, bool b)
//			{
//				if (oMapGrid != null && pts != null)
//				{
//					foreach (Vector2 i in pts)
//					{
//						oMapGrid.setDyBlock((int)i.x, (int)i.y, b);
//					}
//				}
//			}


//			/// <summary>
//			/// 清除所有地图动态点
//			/// </summary>
//			public void clearDyAllMark()
//			{
//				if (oMapGrid != null)
//				{
//					oMapGrid.clearDyAllMark();
//				}
//			}

	FindPath:function(begin, end){
		return this.oMapGrid.FindPaths(begin, end);
	},
	FindFlyPath:function(begin, end, distance){
		return this.oMapGrid.FindFlyPath(begin, end, distance);
	},
	IsSameConnectType:function(begin, end){
		return this.oMapGrid.IsSameConnectType(begin, end);
	},

	bShowGridState:false,
	// 调试功能，显示格子阻挡
	DebugShowGrid:function(){

		var showlayer = Mgr.sceneLayer.oDebugLayer;
		if (this.bShowGridState){
			showlayer.removeAllChildren(true);
			this.bShowGridState = false;
		} else {
			this.bShowGridState = true;
			var xMax = this.oMapGrid.nGridHMax;
			var yMax = this.oMapGrid.nGridWMax;

			cc.log( "xMax:" + xMax + " yMax:" + yMax );
			var gw = MGameDefine.GRID_WIDTH;
			var gh = MGameDefine.GRID_HEIGHT;

			var draw = new cc.DrawNode();
			for ( var x = 0; x < xMax; x++ ){
				for ( var y = 0; y < yMax; y++ ){
					var sx = x * gw;
					var sy = y * gh;
					var ex = sx + gw;
					var ey = sy + gh;
					if ( !this.IsGridCanMove(x, y) ){
	//					cc.log( "x:" + x + " y:" + y + " isWake:" + this._scene.GetGridBlock( x, y ) );
						draw.drawRect(cc.p(sx, -sy), cc.p(ex, -ey), cc.color(255, 0, 0, 80 ));
					}
					else{
						draw.drawRect(cc.p(sx, -sy), cc.p(ex, -ey), cc.color(0, 255, 0, 80 ));
					}

				}
			}
			showlayer.addChild(draw);
		}
	},

	//取得两点间的距离
	CalcDistanceByPoint:function (pt1, pt2)
	{
		return Math.sqrt((pt1.x - pt2.x) * (pt1.x - pt2.x) + (pt1.y - pt2.y) * (pt1.y - pt2.y));
	},

	//取得两点间距离目标最近的点（限定长度）
	CalcPointByDes:function (spt, ept, des)
	{
		var l = this.CalcDistanceByPoint(spt, ept);
		//cc.log("=========================================== st1: " + spt.x + " " + spt.y  + "  et1: "  + ept.x + " " + ept.y + " l: " + l + " des: " + des )

		//差量
		var dx = parseInt(Math.abs(ept.x - spt.x) / l * des);
		var dy = parseInt(Math.abs(ept.y - spt.y) / l * des);

		var ax = null;
		var ay = null;
		ept.x > spt.x ? (ax = ept.x - dx) : (ax = ept.x + dx);
		ept.y > spt.y ? (ay = ept.y - dy) : (ay = ept.y + dx);

		//cc.log("=========================================== ax: ay: " + ax + " " + ay);
		return cc.p(ax, ay);
	},

	//取得当前地图的所有传送点信息
	GetTranferListByMapId:function (mapid) {
		var tempList = [];
		var translist = Q_map_transfer.GetList();
		for (var i = 0; i < translist.length; ++i) {
			var model = translist[i];
			if (model.q_tran_from_map == mapid)
				tempList.push(model);
		}

		return tempList;
	},

	/**
	 * 尋路方法
	 * @param currentMapId 起始地圖id
	 * @param targetMapId 目標地圖id
	 * @return 到達目的地所經歷的地圖列表
	 *
	 */
	SearchRoad:function (currentMapId,targetMapId) {
		this._resultList.length = 0;
		this._targetMapId = targetMapId;
		var curTranferList = this.GetTranferListByMapId(currentMapId);
		var desTranferList = this.GetTranferListByMapId(targetMapId);
		cc.log("===================================================tranferList:" + curTranferList.length + " " + desTranferList.length )
		if (curTranferList.length > 0 && desTranferList.length > 0) {
			var haveSearchedList = [];
			this.SearchMap(curTranferList, haveSearchedList, haveSearchedList.concat());
		}

		if (this._resultList.length > 0)
			return this._resultList[0];
		else
			return null;
	},

	/**
	 * 核心尋路方法
	 * @param focusMap 當前操作的地圖
	 * @param tmpList 已經尋址過的地圖列表
	 * @param result 地圖尋址結果列表
	 *
	 */
	SearchMap:function (focusMap,tmpList,result) {
		if (focusMap == null)
			return;

		for (var i = 0; i != focusMap.length; i++) {
			var tmpResult = result.concat();
			var id = focusMap[i].q_tran_to_map;
			if (tmpList.indexOf(id) == -1) {
				if (id == this._targetMapId) {
					tmpResult.push(id);
					this._resultList.push(tmpResult);
					break;
				}
				else {
					var temp = tmpList.concat();
					for (var b = 0; b != focusMap.length; b++){
						// cc.log("=================================== focusMap[b].q_tran_to_map :" + focusMap[b].q_tran_to_map)
						temp.push(focusMap[b].q_tran_to_map);
					}
					var tempR = result.concat();
					tempR.push(id);
					var list = this.GetTranferListByMapId(id);
					this.SearchMap(list, temp, tempR);
					temp = null;
					tempR = null;
				}
			}
			tmpResult = null;
		}
		result = null;
		tmpList = null;
	},

	ZoneType:function() {
		return this.GetZoneTypeByMapId(this.nMapId);
	},

    GetZoneTypeByMapId:function(mapId){
    	if (!this._zoneMapIdHash) {
            this._zoneMapIdHash = new HashMap();
            var zoneList = Mgr.dataMgr.GetZoneList();
            for (var i = 0; i < zoneList.length; i++) {
                var q_zone = zoneList[i];
                var mapArr = JSON.parse(q_zone.q_mapid);
                for (var j = 0; j < mapArr.length; j++) {
                    this._zoneMapIdHash.Put(mapArr[j], q_zone);
                }
            }
        }
        var zoneType = 0;
        if( this._zoneMapIdHash.Get(mapId) )
        {
            zoneType = this._zoneMapIdHash.Get(mapId).q_zone_type;
        }
        return zoneType;
    },

    GetZoneModelIdByMapId:function(mapId){
        if (!this._zoneMapIdHash) {
            this._zoneMapIdHash = new HashMap();
            var zoneList = Mgr.dataMgr.GetZoneList();
            for (var i = 0; i < zoneList.length; i++) {
                var q_zone = zoneList[i];
                var mapArr = JSON.parse(q_zone.q_mapid);
                for (var j = 0; j < mapArr.length; j++) {
                    this._zoneMapIdHash.Put(mapArr[j], q_zone);
                }
            }
        }
        var zoneModelId = 0;
        if( this._zoneMapIdHash.Get(mapId) )
        {
            zoneModelId = this._zoneMapIdHash.Get(mapId).q_id;
        }
        return zoneModelId;
	}
};