﻿/*
 * 
 * 场景实体对象管理
 * tyevlag
 * 
 */

var SceneObjectHashList = cc.Class.extend({
	oHash:null,
    aList:null,

    ctor:function(){
    	this.oHash = {};
    	this.aList = [];
    },

	Get:function(k){
		var ret = this.oHash[k];
		return ret;
	},

	GetCount:function(){
		return this.aList.length;
	},

	Add:function(k, o){
		this.oHash[k] = o;
		this.aList.push(o);
	},

	Remove:function(k){
		var ret = null;
		if (k in this.oHash){
			ret = this.oHash[k];
			delete this.oHash[k];
			for (var i = this.aList.length - 1; i >= 0; --i){
				if (this.aList[i] == ret){
					this.aList.splice(i, 1);
					break;
				}
			}
		}

		return ret;
	},

	Clear:function()
	{
		this.oHash = {};
		this.aList.length = 0;
	}
});


var SceneObjFactoryList = cc.Class.extend({
	oPool:null,
	// 自己管理器
	oHashList:null,
	// 引用的主管理器
	oRefHashList:null,
	// 构造实例的方法
	fCreateFunc:null,

	ctor:function(){
		this.oPool = new MCachePool();
		this.oHashList = new SceneObjectHashList();
	},

	Create:function(gid){
		var ret = null;
		if (this.oPool != null){
			ret = this.oPool.Gain();
		}

		if (ret == null){
			ret = this.fCreateFunc.apply(this);
		}
		return ret;
	},

	GetCacheNum:function(){
		return this.oPool.getNum();
	},

	GetistNum:function(){
		return this.oHashList.GetCount();
	},

	SetPoolSize:function(num){
		this.oPool.SetSize(num);
	},

	Remove:function(gid){
		var o = this.oHashList.Remove(gid);
		if (o != null){
			var or = this.oRefHashList.Remove(gid);
			if ((or === o) == false){
				ToolBase.LogError("Error SceneObjectMgr remove but (or != o)");
			}

			this.oPool.Recycle(o);
		}
	},

	RemoveAll:function(func){
		var so = null;
		var len = this.oHashList.GetCount();
		for (var i = 0; i < len; ++i){
			so = this.oHashList.aList[i];
            if(func) func(so);
			var rso = this.oRefHashList.Remove(so.nGid);
			if (rso != so){
				ToolBase.LogError("Error SceneObjectMgr removeAll but (rso != o)" + this.tag );
			}

			this.oPool.Recycle(so);
		}

//		if (this.oHashList.GetCount() > 0){
//			ToolBase.LogError("Error SceneObjectMgr removeAll but (hashList.hash.Count > 0)");
//		}
		this.oHashList.Clear();
	},
    Find:function(callback){
        var so = null;
        var len = this.oHashList.GetCount();
        for (var i = 0; i < len; ++i){
            so = this.oHashList.aList[i];
            if(callback(so)) return so;
        }

        return null;
    },
	GetCreate:function(gid){
		var ret = this.oHashList.Get(gid);
		if (ret == null){
			ret = this.Create(gid);
			this.oHashList.Add(gid, ret);
			this.oRefHashList.Add(gid, ret);
		}

		return ret;
	}
});

SceneObjFactoryList.New = function(createfunc, reflist){
	if (createfunc == null || reflist == null)
		ToolBase.LogError("SceneObjFactoryList params is null");
	
	var ret = new SceneObjFactoryList();
	ret.fCreateFunc = createfunc;
	ret.oRefHashList = reflist;
	return ret;
};

var SceneObjectMgr = SceneObjectMgr || {
	oAllObjectHashList:null,// SceneObjectHashList
	// 周围特效列表
	oRoundEffectList:null,
	// 周围玩家列表
	oRoundPlayerList:null,
	// 周围怪物列表
	oRoundMonsterList:null,
	// 周围宠物列表
	oRoundPetList:null,
	//周围跟物列表
	oRoundIllusionPetList:null,
    //周围剑灵列表
	oRountJianLingList:null,
	// 周围物品列表
	oRoundItemList:null,
	// 周围npc列表
	oRoundNpcList:null,
	// 周围魔法列表
	oRoundMagicList:null,

	oMouseObj:null,

	sCachePlayerState:null,
	sCacheMonsterState:null,
	sCachePetState:null,
	sCacheNpcState:null,
	sCacheItemState:null,

	Init:function(){
		this.oAllObjectHashList = new SceneObjectHashList();
		
		this.oRoundPlayerList = SceneObjFactoryList.New(function(){return new ScenePlayer();}, this.oAllObjectHashList);
		this.oRoundMonsterList = SceneObjFactoryList.New(function(){return new SceneMonster();}, this.oAllObjectHashList);
		this.oRoundPetList = SceneObjFactoryList.New(function(){return new ScenePet();}, this.oAllObjectHashList);
		this.oRoundItemList = SceneObjFactoryList.New(function(){return new SceneItem();}, this.oAllObjectHashList);
		this.oRoundNpcList = SceneObjFactoryList.New(function(){return new SceneNpc();}, this.oAllObjectHashList);
		this.oRoundIllusionPetList = SceneObjFactoryList.New(function(){return new ScenePet();}, this.oAllObjectHashList);
        this.oRountJianLingList = SceneObjFactoryList.New(function(){return new ScenePet();}, this.oAllObjectHashList);
		this.oRoundMagicList = SceneObjFactoryList.New(function(){return new SceneEffect();}, this.oAllObjectHashList);
		this.oRoundEffectList = SceneObjFactoryList.New(function(){return new SceneEffect();}, this.oAllObjectHashList);
		this.oRoundHaloList = SceneObjFactoryList.New(function(){return new SceneHalo();}, this.oAllObjectHashList);

		this.oRoundPlayerList.SetPoolSize(100);
		this.oRoundMonsterList.SetPoolSize(200);
		this.oRoundPetList.SetPoolSize(100);
        this.oRoundIllusionPetList.SetPoolSize(100);
		this.oRoundNpcList.SetPoolSize(100);
		this.oRoundItemList.SetPoolSize(50);
		this.oRoundMagicList.SetPoolSize(100);

		this._selectedMonsterHash = new HashMap();

		/*	
		this.oRoundPlayerList.SetPoolSize(0);
		this.oRoundMonsterList.SetPoolSize(0);
		this.oRoundPetList.SetPoolSize(0);
		this.oRoundNpcList.SetPoolSize(0);
		this.oRoundItemList.SetPoolSize(0);
		this.oRoundMagicList.SetPoolSize(0);
		*/
		return this;
	},

	OnFrame:function() {
		var curTime = ToolBase.GetTimer();
        var l = this.oAllObjectHashList.aList;
		var len = l.length;

		for (var i = 0; i < len; ++i){
			if (l.length != len){
				zz.Error("SceneObjMgr OnFrame length error l.length:" +l.length + " len:" + len + " i:" + i);
			}

			if (l[i] == undefined){
				zz.Error("SceneObjMgr OnFrame undefined error l.length:" +l.length + " len:" + len + " i:" + i);
			}
			try{
				if ( l[i] )
					l[i].OnFrame(curTime);
			}
			catch (e){
				var errLog = "SceneObjectMgr OnFrame error:		" + e.message + "\n" + e.stack.substr(0, e.stack.length - 1);
				errLog = errLog.replace(/\n/g, "\nERROR : ");
				zz.Error( errLog + "\n");
			}
		}

//		#if UNITY_EDITOR
//		sCachePlayerState = oRoundPlayerList.listNum + "(" + oRoundPlayerList.cacheNum + ")";
//		sCacheMonsterState = oRoundMonsterList.listNum + "(" + oRoundMonsterList.cacheNum + ")";
//		sCachePetState = oRoundPetList.listNum + "(" + oRoundPetList.cacheNum + ")";
//		sCacheNpcState = oRoundNpcList.listNum + "(" + oRoundNpcList.cacheNum + ")";
//		sCacheItemState = oRoundItemList.listNum + "(" + oRoundItemList.cacheNum + ")";
//		#endif
	},

	GetMouseObj:function(){
		return this.oMouseObj;
	},

	FindMouseObj:function(mouseWorldPt){
		var l = this.oAllObjectHashList.aList;
		var len = l.length;
		var bo = null;
		for (var i = 0; i < len; ++i){
			bo = l[i];
			//bo.fillBounding(ref bounding);
			if (bo.bNonMouseHit == false && bo.CheckLocalBounding(mouseWorldPt)){
				return bo;
			}
		}
		return null;
	},

	CheckMouseObj:function(mouseWorldPt){
		var so = this.FindMouseObj(mouseWorldPt);
		if (so != null){
			if (this.oMouseObj != so)
			{
				if (this.oMouseObj != null)
					this.oMouseObj.OnMouseOut();

				this.oMouseObj = so;
				this.oMouseObj.OnMouseIn();
			}
		} else {
			if (this.oMouseObj != null){
				this.oMouseObj.OnMouseOut();
				this.oMouseObj = null;
			}
		}
	},

	FindObject:function(gid){
		if (gid == 0)
			return null;
		
		if(Mgr.mainPlayer && gid == Mgr.mainPlayer.nGid)
			return Mgr.mainPlayer;

		return this.oAllObjectHashList.Get(gid);
	},

	CreateObject:function(msgdata){
		var isMainPlayer = msgdata.objinfotype == SceneObjectInfoType.MAINPLAYER;
		// ToolBase.Log(" Mgr.sceneObj.CreateObject : " + msgdata.sceneobjgid + " type:" + msgdata.objinfotype + "time: " + TimerUtil.GetTimer());
		if (Mgr.sceneMap.bChangingState && isMainPlayer == false){
			cc.error(" Mgr.sceneMap.isChangingState createObject : " + msgdata);
			return;
		}

		var addo = null;
		var tolayer = 0;
		if (msgdata.objinfotype == SceneObjectInfoType.PLAYER) {
			addo = this.oRoundPlayerList.GetCreate(msgdata.sceneobjgid);
		} else if (msgdata.objinfotype == SceneObjectInfoType.MONSTER) {
			addo = this.oRoundMonsterList.GetCreate(msgdata.sceneobjgid);
		} else if (msgdata.objinfotype == SceneObjectInfoType.NPC) {
			addo = this.oRoundNpcList.GetCreate(msgdata.sceneobjgid);
		} else if (msgdata.objinfotype == SceneObjectInfoType.PET) {
			addo = this.oRoundPetList.GetCreate(msgdata.sceneobjgid);
		} else if (msgdata.objinfotype == SceneObjectInfoType.ITEM) {
			tolayer = 1;
			addo = this.oRoundItemList.GetCreate(msgdata.sceneobjgid);
		} else if (msgdata.objinfotype == SceneObjectInfoType.ILLUSIONPET) {
            addo = this.oRoundIllusionPetList.GetCreate(msgdata.sceneobjgid);
        }else if (msgdata.objinfotype == SceneObjectInfoType.JIANLING) {
            addo = this.oRountJianLingList.GetCreate(msgdata.sceneobjgid);
        }
		else if (msgdata.objinfotype == SceneObjectInfoType.MAGIC) {
			addo = this.oRoundMagicList.GetCreate(msgdata.sceneobjgid);
		} else if (msgdata.objinfotype == SceneObjectInfoType.EFFECT) {
			this.oRoundEffectList.GetCreate(msgdata.sceneobjgid);
        } else if (msgdata.objinfotype == SceneObjectInfoType.HALO) {
            addo = this.oRoundHaloList.GetCreate(msgdata.sceneobjgid);
		} else if (isMainPlayer) {
			if (Mgr.mainPlayer == null) {
				addo = new SceneMainPlayer();
				ToolBase.Log("创建了主玩家啦！！！！");
			} else {
				addo = this.oAllObjectHashList.Get(msgdata.sceneobjgid);
				// ToolBase.LogError("createObject ResMyPlayerInfoMessage complex!!");
			}
			// 主玩家单独添加
			//this.oAllObjectHashList.Add(msg.personId, addo);
			if( !this.oAllObjectHashList.Get(msgdata.sceneobjgid) )
				this.oAllObjectHashList.Add(msgdata.sceneobjgid, addo);
			Mgr.gameSoundMgr.SetBindFocus( addo );// 音效管理注册主玩家
		}

		if (addo != null){
            addo.SetDataWithBean(msgdata);

            if(msgdata.objinfotype == SceneObjectInfoType.PLAYER
                || msgdata.objinfotype == SceneObjectInfoType.MAINPLAYER
            ){
                this.CreateHalo(addo);
            }

            /// 初始化的时候屏蔽
            if (msgdata.objinfotype == SceneObjectInfoType.PLAYER) {
                var flag = Mgr.map.IsPlayerAndPetHide(addo);
                addo.SetPartHide(!flag, Mgr.map.isShowDragon, Mgr.map.isShowPet, Mgr.map.isShowTitle);
            }else if (msgdata.objinfotype == SceneObjectInfoType.MONSTER) {
                var flag = Mgr.map.IsMonsterHide(addo);
                addo.SetHide(!flag);
            }else if(msgdata.objinfotype == SceneObjectInfoType.NPC){
                if(NpcUtil.IsNpcNameBlocked(addo)){
                    addo.SetNameShow();
                }
            }

			if( !addo.getParent() )
			{
				if (tolayer == 0) {
                    Mgr.sceneLayer.AddMiddle(addo);
				}
				else {
					Mgr.sceneLayer.AddBottom(addo);
				}
			}

			if(tolayer != 0) {
                Mgr.pickMgr.AddItem(addo);
            }
		} else {
			ToolBase.LogError("createObject unknow obj!!");
		}
	},

	RemoveAllRoundObject:function(){
		Mgr.monster.RemoveBossDamageBelongTag();
		this.oRoundPlayerList.RemoveAll();

		this.oRoundItemList.RemoveAll();
		this.oRoundMonsterList.RemoveAll(function(v){
            if(v) Mgr.monster.StopTweenDel(v.nGid, true);
		});
		this.oRoundMagicList.RemoveAll();
		this.oRoundNpcList.RemoveAll();
		//this.oRoundPetList.RemoveAll();
		this.oRoundEffectList.RemoveAll();
		this.oRoundHaloList.RemoveAll();

		Mgr.robotMgr.ClearAll();

		FlyBackEffect.DisposeAll();
//		if (oAllObjectHashList.hash.Count > 1)
//		{
//			ToolBase.LogError("removeAllRoundObject but not Clear!!!!!!! " + oAllObjectHashList.hash.Count);
//		}
//
//		DebugTool.Log("removeAllRoundObject 44");
//		if (oAllObjectHashList.list.Count != oAllObjectHashList.hash.Count)
//		{
//		ToolBase.LogError("removeAllRoundObject objHash.Count != objList.Count!!!!!!!  hash:" + oAllObjectHashList.hash.Count + " list:" + oAllObjectHashList.list.Count);
//		}

		//if (Mgr.mainPlayer != null)
		//	Mgr.mainPlayer.gameObject.SetActive(false);
	},
	
	DeleteObjects:function( sids ){
		var len = sids.length;
		for( var i = 0; i < len; i++ )
			this.DeleteObject(sids[i].toGID());
	},

	DeleteObject:function(gid) {
		var so = this.oAllObjectHashList.Get(gid);
		if (so != null){
			Mgr.map.CheckTargetOnRemove(so);	//这个要放到前面 不然nGid都清零了 并且对象也回收对象池了	--merlin
			//Mod.target.checkTargetOnRemove(so as SceneActiveObject);

			if (so instanceof SceneMainPlayer){
                this.DeleteHalo(so)
                so.Dispose();
			}else if (so instanceof ScenePlayer)
			{
                this.DeleteHalo(so)

				Mgr.monster.RemoveBossDamageBelongTag(so);
				this.oRoundPlayerList.Remove(gid);
				//Mod.minimap.removeMiniMapPoint(so);
			} else if (so instanceof SceneMonster){
                // FIX 删除同时删除死亡事件。避免由于复用产生的问题
                Mgr.monster.StopTweenDel(gid, true);
				this.oRoundMonsterList.Remove(gid);
				//Mod.minimap.removeMiniMapPoint(so);
			} else if (so instanceof SceneNpc){
				this.oRoundNpcList.Remove(gid);
			} else if (so instanceof ScenePet){
			    if(so.nType == EnumResline.SHUTONG){
                    this.oRoundPetList.Remove(gid);
                }
                else if(so.nType == HuanhuaType.TYPE_PET){
                    this.oRoundIllusionPetList.Remove(gid);
                }
                else if(so.nType == EnumResline.JIANLING){
                    this.oRountJianLingList.Remove(gid);
                }
			} else if (so instanceof SceneEffect){
				if (so.oObjTypeId == 0){
					this.oRoundEffectList.Remove(gid);
				} else if (so.oObjTypeId == 1){
					this.oRoundMagicList.Remove(gid);
				}
			} else if (so instanceof SceneItem){
				Mgr.pickMgr.DeleteItem(so.nGid);
				this.oRoundItemList.Remove(gid);
//				Mgr.sceneLayer.RemoveBottom(so);
//				return;
            }else if (so instanceof SceneHalo){
                this.oRoundHaloList.Remove(gid);
            }

//			Mgr.sceneLayer.RemoveMiddle(so);
		}
	},

	SynObjPos:function(gid, tarPos){
		var sao = this.FindObject(gid);
		if (sao != null){
			var tarpt = ToolMap.Pos2GridPt(tarPos);
			sao.SetServPt(tarpt);
			//sao.CtrlAutoPathRun.clearMoveSendLock();
			sao.StopMove(false);
		}
	},

	SynObjWay:function(gid, tarPos, path){
//		var sao = this.FindObject(gid);
//		if (sao != null){
//			var tarpt = ToolMap.Pos2GridPt(tarPos);
//			sao.SetServPt(tarpt);
//			//sao.CtrlAutoPathRun.clearMoveSendLock();
//
//			var beginpt = ToolMap.CalcBeginPtByPath(path, tarpt);
//			var step = ToolMap.CalcDistanceS(beginpt, tarpt);
//			var way = ToolMap.PathToWay(path, beginpt);
//
//			if (sao instanceof SceneMainPlayer){
//				if (sao.IsMoving()){
//					var moveEndPt = sao.MoveEndpt;
//					if (moveEndPt.Equals(way[way.Count - 1]) == false)
//					{
//						if (beginpt.Equals(sao.gridPt) == false)
//						{
//							sao.setGridPt(beginpt);
//						}
//						sao.stopMove();
//						sao.setMoveWay(way, ((step == 1) ? EnumActionType.WALK : EnumActionType.RUN));
//						//Debug.Log("$$$$$$$$$$ mainPlayer recv way 1: " + moveEndPt + "  " + way[way.Count - 1]);
//					}
//				}
//				else
//				{
//					if (beginpt.Equals(sao.gridPt) == false)
//					{
//						sao.setGridPt(beginpt);
//					}
//					sao.setMoveWay(way, ((step == 1) ? EnumActionType.WALK : EnumActionType.RUN));
//					//Debug.Log("$$$$$$$$$$ mainPlayer recv way 2: " + way.ToArray().ToString());
//				}
//			}
//			else
//			{
//				if (beginpt.Equals(sao.gridPt) == false)
//				{
//					sao.setGridPt(beginpt);
//				}
//				//Debug.Log("$$$$$$$$$$ mainPlayer recv way 3: " + way.ToArray().ToString());
//				sao.setMoveWay(way, ((step == 1) ? EnumActionType.WALK : EnumActionType.RUN));
//			}
//			//Mgr.mainPlayer.setGridPos(tarpt);
//		}
	},

//	/// <summary>
//	/// 对象倒退
//	/// </summary>
//	/// <returns>The object backout.</returns>
//	/// <param name="">.</param>
//	public void synObjBackout(long gid, Vector2 dstPtServ, int persondir, int movedir, int movetype)
//	{
//		SceneFightObject fightV = findObject(gid) as SceneFightObject;
//		if (fightV == null || fightV.isDeadState)
//			return;
//
//		fightV.setServPt(dstPtServ);
//
//		// 神马东西
//		//if ( fightV is MainPlayerV )
//		//	Mgr.fightMgr.backoutLastTime = getTimer() + 500;
//
//		if (fightV.isMoving && !fightV.checkStateMove(EnumActionType.BACKOUT))
//		{
//			Vector2 movendPt = fightV.moveEndpt;
//			fightV.setStateShowStand();
//			if (movendPt != null)
//				fightV.setGridPt(movendPt);
//		}
//
//		Vector2 beginPt = fightV.gridPt;
//		if (beginPt.Equals(dstPtServ))
//		{
//			fightV.setStateShowStand();
//		}
//		else
//		{
//			int len = 1;
//			Vector2 srcPtSerV = ToolMap.calcBeginPtByDir(dstPtServ, movedir, len);
//			if (!srcPtSerV.Equals(fightV.gridPt))
//				fightV.setGridPt(srcPtSerV);
//
//			beginPt = srcPtSerV;
//			if (beginPt.Equals(dstPtServ))
//			{
//				fightV.setStateShowStand();
//			}
//			else
//			{
//				srcPtSerV = ToolMap.calcBeginPtByDir(dstPtServ, movedir, len);
//				if (srcPtSerV.Equals(fightV.gridPt) == false)
//				{
//					fightV.setGridPt(srcPtSerV);
//				}
//
//				if (fightV.isMoving)
//				{
//					fightV.stopMove();
//				}
//				List<Vector2> path = new List<Vector2>();
//				path.Add(dstPtServ);
//				fightV.setStateShowBackout(path, persondir);
//			}
//		}
//	}

//		private int testlastCollide = 0;
//
//		/// <summary>
//		/// 同步对象冲撞 ty
//		/// </summary>
//		/// <param name="">.</param>
//
//		public void synObjCollide(long gid, Vector2 dstPtServ, int movedir, int len)
//		{
//	DebugTool.Log("synObjCollide " + dstPtServ.ToString() + " " + ((int)(ToolBase.getTimerS()* 1000) - testlastCollide).ToString());
//	testlastCollide =(int) (ToolBase.getTimerS()* 1000);
//
//			SceneFightObject fightV = findObject(gid) as SceneFightObject;
//			if (fightV == null || fightV.isDeadState)
//				return;
//
//			//if (fightV is MainPlayerV)
//			//	Mgr.mainPlayerV.clearDelayToStand();
//			fightV.setServPt(dstPtServ);
//
//			Vector2 srcPtSerV = ToolMap.calcBeginPtByDir(dstPtServ, movedir, len);
//			Vector2 srcPt = fightV.gridPt;
//
//			if (fightV.isMoving)
//			{
//				if (fightV.checkStateMove(EnumActionType.COLLIDE))
//				{
//					if (fightV.isMoving && fightV.moveEndpt.Equals(dstPtServ) == false)
//					{
//						fightV.stopMove();
//					}
//				}
//				else
//				{
//					fightV.stopMove();
//				}
//			}
//
//			if (fightV is CMainPlayer && srcPt.Equals(dstPtServ))
//				return;
//
//			if (srcPtSerV.Equals(srcPt) == false)
//				fightV.setGridPt(srcPtSerV);
//
//			List<Vector2> path = new List<Vector2>();
//			path.Add(dstPtServ);
//			fightV.setStateShowCollide(path, movedir);
//		}

		/// <summary>
		/// 同步对象采集对象
		/// </summary>
		/// <param name="srcgid">Srcgid.</param>
		/// <param name="targid">Targid.</param>
		/// <param name="dir">Dir.</param>
		//private static int _gatherId = 0;
//		public void synObjGather(long srcgid, long targid, int dir)
//		{
//			ScenePlayer playerV = findObject(srcgid) as ScenePlayer;
//			SceneMonster monsterV = findObject(targid) as SceneMonster;
//			if (playerV != null)
//			{
//				if (MDirection.isValid(dir) == false)
//				{
//					if (monsterV != null)
//						dir = ToolMap.calcDir(playerV.ServPt, monsterV.ServPt);
//					else
//						dir = MDirection.DOWN;
//				}
//
//				if (playerV.isMoving)
//				{
//					playerV.stopMove();
//				}
//
//				//playerV.setStateShowGather(true, dir);
//
//				/*			if ( _gatherId != 0 )
//					FrameDispatcher.clearTimeout( _gatherId );
//
//				_gatherId = FrameDispatcher.setTimeout( 
//				                                       function():void
//				                                       { 
//					if ( playerV != null && playerV.checkState( GlobalConsts.EA_GATHER ) ) 
//						playerV.setStateShowStand( true ); 
//				},
//				2000
//				);*/
//			}
//		}
	
	CreatePlayer:function(info)
	{
		info.objinfotype = SceneObjectType.PLAYER;
		info.sceneobjgid = info.personId.toGID();
		this.CreateObject( info );
		if( info.positions.length > 0 ){
			Mgr.map.SynWayPath(info.personId, new Position(info.x, info.y), info.positions);
		}
	},

	CreateMonster:function(info)
	{
		info.objinfotype = SceneObjectType.MONSTER;
		info.sceneobjgid = info.monsterId.toGID();
		Mgr.monster.StopTweenDel(info.sceneobjgid, true);
		this.CreateObject( info );
		if( info.positions.length > 0 ){
			Mgr.map.SynWaySPath(info.monsterId, new Position(info.x, info.y), info.positions);
		}
	},

	CreateNpc:function(info)
	{
		info.objinfotype = SceneObjectType.NPC;
		info.sceneobjgid = info.npcId.toGID();
		this.CreateObject( info );
		if( info.positions.length > 0 ){
			Mgr.map.SynWaySPath(info.npcId, new Position(info.x, info.y), info.positions);
		}
	},

	CreatePet:function(info)
	{
		info.objinfotype = SceneObjectType.PET;
		info.sceneobjgid = info.petId.toGID();
		this.CreateObject( info );
	},

	CreateIllusionPet:function(info){
        info.objinfotype = SceneObjectType.ILLUSIONPET;
        info.sceneobjgid = info.petId.toGID();
        this.CreateObject( info );
    },

    CreateJianLing:function(info){
        info.objinfotype = SceneObjectType.JIANLING ;
        info.sceneobjgid = info.petId.toGID();
        this.CreateObject( info );
    },

	CreateEffect:function(info)
	{
		info.objinfotype = SceneObjectType.EFFECT;
		info.sceneobjgid = info.effectId.toGID();
		this.CreateObject( info );
	},

	CreateItem:function(info)
	{
		info.objinfotype = SceneObjectType.ITEM;
		info.sceneobjgid = info.dropGoodsId.toGID();
		this.CreateObject( info );
	},

		GetNearestNpc:function (midArr) {
			var list =this.oRoundNpcList.oHashList.aList;

			var len = list.length;
			var lessDis = 20;
			var dis;
			var obj;
			var sel;
			for( var i = 0; i < len; i++ ){
				obj = list[i];
				if( midArr && midArr.indexOf(obj.nBodyModelId) == -1 )
					continue;
				dis = ToolMap.CalcDistance( obj.GetGridPt(), Mgr.mainPlayer.GetGridPt() )
				if( dis < lessDis ) {
					lessDis = dis;
					sel = obj;
				}
			}
			return sel;
		},

	GetNearestMonster:function (checkFun, mid) {
		var list =this.oRoundMonsterList.oHashList.aList;
		// //如果任务状态，指定任务怪物
		// if (Mgr.task.isAutoTask) {
		// 	var taskData = Q_mission_base.Get(Mgr.task.aCurTaskId);
		// 	//完成信息
		// 	var finnishC = taskData.q_finish_information_str.split(",");
		// 	if (!finnishC || finnishC.length == 0)
		// 		return;
        //
		// 	var monsterId = finnishC[0];
		// 	list = TaskUtil.GetItemsByMid(monsterId);
		// }

		var len = list.length;
		var lessDis = Mgr.zone.IsInZoneMap() ? 99 : 20;
		var dis;
		var obj;
		var sel;
		for( var i = 0; i < len; i++ ){
			obj = list[i];
			if( mid && mid != obj.nBodyModelId )
				continue;
			//帮旗只在领地战期间能攻击
			if( obj.nBodyModelId == 6000 )
				continue;
			if( obj.IsFriend() )
				continue;
			if( obj.IsDeadState() )
				continue;
			if(checkFun && !checkFun.call(this, obj))
				continue;
			dis = ToolMap.CalcDistance( obj.GetGridPt(), Mgr.mainPlayer.GetGridPt() )
			if( dis < lessDis ) {
				lessDis = dis;
				sel = obj;
			}
		}
		return sel;
	},

	GetNearestPlayer:function (checkFun) {
		var list =this.oRoundPlayerList.oHashList.aList;
		var len = list.length;
		var lessDis = 30;
		var dis;
		var obj;
		var sel;
		for( var i = 0; i < len; i++ ){
			obj = list[i];
			if( obj.IsDeadState() )
				continue;
			if(checkFun && !checkFun.call(this, obj))
				continue;
			dis = ToolMap.CalcDistance( obj.GetGridPt(), Mgr.mainPlayer.GetGridPt() )
			if( dis < lessDis ) {
				lessDis = dis;
				sel = obj;
			}
		}
		return sel;
	},

    CreateHalo:function(addo){
        if(!addo.marriageId) return;
        if(addo.marriageId.IsZero()) return;

        /// 查找伴侣
        var player  = null
        do{
            /// 主玩家
            var MP = Mgr.sceneObj.FindObject(Mgr.mainPlayer.nGid);
            if(MP
                && MP.marriageId
                && MP.marriageId.Equal(addo.marriageId)
                && !addo.oSid.Equal(MP.oSid)
            ){
                player = MP;
                break;
            }

            player = this.oRoundPlayerList.Find(function(v){
                return v.marriageId.Equal(addo.marriageId) && !addo.oSid.Equal(v.oSid)
            })
        }while(false)

        if(!player) return;

        var info = {}
        info.objinfotype = SceneObjectType.HALO;
        info.sceneobjgid = addo.marriageId.toGID();
        info.oSid = addo.marriageId
        info.nGid = addo.marriageId.toGID();
        info.couple = [addo,player]
        this.CreateObject( info );
    },
    DeleteHalo:function(so){
        if(!so.marriageId) return;
        if(so.marriageId.IsZero()) return;

        this.DeleteObject(so.marriageId.toGID())
    },
	_selectedMonsterHash:null,
	SelNeerMonster:function(){

		var list =this.oRoundMonsterList.oHashList.aList;

		var len = list.length;
		var lessDis = 20;
		var dis;
		var obj;
		var resel;
		var sel;
		for( var i = 0; i < len; i++ ){
			obj = list[i];
			// if( mid && mid != obj.nBodyModelId )
			// 	continue;
			//帮旗只在领地战期间能攻击
			if( obj.nBodyModelId == 6000 )
				continue;
			if( obj.IsFriend() )
				continue;
			if( obj.IsDeadState() )
				continue;
			// if(checkFun && !checkFun.call(this, obj))
			// 	continue;
			dis = ToolMap.CalcDistance( obj.GetGridPt(), Mgr.mainPlayer.GetGridPt() )
			if( dis < lessDis ) {
				resel = obj;
				if( !this._selectedMonsterHash.ContainsKey(obj.nGid) ){
					lessDis = dis;
					sel = obj;
				}
			}
		}
		if( sel ){
			this._selectedMonsterHash.Put( sel.nGid );
		}
		else {
			this._selectedMonsterHash.Clear();
			if( resel ){
				sel = resel;
				this._selectedMonsterHash.Put( sel.nGid );
			}
		}
		return sel;
	}
};