﻿/**
 * 游戏数据配置管理器
 * pbk 2015年10月26日
 */
var GameDataMgr = GameDataMgr || {
	
	Init:function(){
		var self = this;
		
		self._isLoadPackData = true;// true加载整包资源；false加载分包资源
		
		return self;
	},

	GetServerLanguageStr:function(id){
		//old modified by jyj 3-29
		// var str;
		// var bean = this.GetServerLanguage(id);
		// if (bean)
		// 	str = bean.q_str;
		// else
		// 	str = 'ERROR Q_lan id：' + id;
		// return str;
		return id;
	},

	GetServerLanguage:function(id){
		return Q_lan.Get(id);
	},

	GetConfig:function(id){
		return Q_global.Get(id);
	},
	
	GetZoneData:function(id){
		return Q_zone.Get(id);
	},
	
	GetZoneList:function(){
		return Q_zone.GetList();
	},
	
	GetSkillModel:function(id, level){
		if (level == null)
			level = 1;
		return Q_skill_model.Get(id + "_" + level);
	},
	
	/**
	 * 加载游戏数据配置
	 */
	LoadData:function( target, fComplete, fError, fProgress ){

		if ( this._isLoadPackData ){
			// 整包加载
			LoadMgr.LoadBinary( "res/data/configGmData.res", this, LoadPriority_Common, {
				complete:this._LoadPackDataComplete,
				completeParam:{"target":target, "cb":fComplete, "cbPro":fProgress},

				error:this._LoadPackDataError,
				errorParam:{"target":target, "cb":fError},
			} );
		} else {
			// 分包加载
			var nameList = [
			    "q_achievement", "q_achievement_type", "q_arena", "q_attribute_rise", "q_backpack_grid", 
			    "q_beauty", "q_beauty_addition", "q_beauty_skills", "q_beauty_up", "q_boss_world", "q_buff", 
			    "q_character", "q_character_attribute", "q_demonstar", "q_earthemperor", "q_escort","q_func_guide",
			    "q_ghost", "q_ghost_addition", "q_ghost_up", "q_gift", "q_global", "q_glyph_warding", "q_goldenbody", 
			    "q_goldenbody_up", "q_guild", "q_horse", "q_horse_addition", "q_horse_skills", "q_horse_up", 
			    "q_item", "q_item_forge", "q_item_simpact", "q_kreed", "q_lan", "q_manor", "q_map", "q_map_transfer", 
			    "q_minimapshow", "q_mission_base", "q_mission_bubble", "q_mission_reword", "q_mission_section", 
			    "q_mission_segment", "q_monster", "q_monster_dropprob", "q_monster_introduce", "q_newfuc_hint",
			    "q_newfunc", "q_npc", "q_operator_level", "q_quest_guide", "q_raid", "q_ranking_guild",
				"q_resources_recovery", "q_role_random_name", "q_seven_land", "q_shop_base", "q_shop_describe","q_disguise","q_fashion",

				"q_title","q_monicker","q_equipt_compound",
			    "q_sign", "q_skill_model", "q_skill_public", "q_story", "q_suit", "q_target", "q_timing", "q_system_activity",
			    "q_tipconfig", "q_treasurehunt", "q_treasuretype", "q_upgrade", "q_vacant", "q_vip", "q_vitality", 
			    "q_vitality_bonus", "q_weaponride", "q_weaponride_addition", "q_weaponride_skills", "q_weaponride_up", 
			    "q_zone", "q_exp_zone", "q_tujian", "q_temple", "q_taijizhidian", "q_taijizhidian_type", "q_resources_recovery"
			];
			
			var urlList = new Array();
			var len = nameList.length;
			for ( var i = 0; i < len; ++i ){
				urlList[i] = "res/data/" + nameList[i] + ".res";
			}
			
			LoadMgr.LoadBulk( urlList, this, LoadPriority_Common, {
				complete:this._LoadSubPackComplete,
				completeParam:{"target":target, "cb":fComplete, "list":nameList},
				error:this._LoadSubPackError,
				errorParam:{"target":target, "cb":fError},
				progress:this._LoadSubPackProgress,
				progressParam:{"target":target, "cb":fProgress, "list":nameList}
			} );
		}
	},
	
	// ========================================================================================================
	// =========================================================================================== 注册配置数据
	// ========================================================================================================
	// 添加一个配置文件数据
	_AddConfigData:function( name, data ){

		var config = null;
		if ( name == "q_achievement" ) {
			config = Q_achievement;
		} else if ( name == "q_achievement_type" ) {
			config = Q_achievement_type;
		} else if ( name == "q_arena" ) {
			config = Q_arena;
		} else if ( name == "q_attribute_rise" ) {
			config = Q_attribute_rise;
		} else if ( name == "q_backpack_grid" ) {
			config = Q_backpack_grid;
		} else if ( name == "q_beauty" ) {
			config = Q_beauty;
		} else if ( name == "q_beauty_addition" ) {
			config = Q_beauty_addition;
		} else if ( name == "q_beauty_skills" ) {
			config = Q_beauty_skills;
		} else if ( name == "q_beauty_up" ) {
			config = Q_beauty_up;
		} else if ( name == "q_boss_world" ) {
			config = Q_boss_world;
		} else if ( name == "q_buff" ) {
			config = Q_buff;
		} else if ( name == "q_character" ) {
			config = Q_character;
		} else if ( name == "q_character_attribute" ) {
			config = Q_character_attribute;
		} else if ( name == "q_demonstar" ) {
			config = Q_demonStar;
		} else if ( name == "q_earthemperor" ) {
			config = Q_earthemperor;
		} else if ( name == "q_equip_holy" ) {
			config = Q_equip_holy;
		} else if ( name == "q_equip_forge" ) {
			config = Q_equip_forge;
		} else if ( name == "q_equip_suit_bonus" ) {
			config = Q_equip_suit_bonus;
		} else if ( name == "q_func_guide" ) {
			config = Q_func_guide;
		} else if ( name == "q_first_charge" ) {
			config = Q_first_charge;
		} else if ( name == "q_ghost" ) {
			config = Q_ghost;
		} else if ( name == "q_ghost_addition" ) {
			config = Q_ghost_addition;
		} else if ( name == "q_ghost_up" ) {
			config = Q_ghost_up;
		} else if ( name == "q_gift" ) {
			config = Q_gift;
		} else if ( name == "q_global" ) {
			config = Q_global;
		} else if ( name == "q_glyph_warding" ) {
			config = Q_glyph_warding;
		} else if ( name == "q_goldenbody" ) {
			config = Q_goldenbody;
		} else if ( name == "q_goldenbody_up" ) {
			config = Q_goldenbody_up;
		} else if ( name == "q_guild" ) {
			config = Q_guild;
		} else if ( name == "q_guild_skill" ) {
			config = Q_guild_skill;
		} else if ( name == "q_investment" ) {
			config = Q_investment;
		} else if ( name == "q_item" ) {
			config = Q_item;
		} else if ( name == "q_item_forge" ) {
			config = Q_item_forge;
		} else if ( name == "q_item_simpact" ) {
			config = Q_item_simpact;
		} else if ( name == "q_kreed" ) {
			config = Q_kreed;
		} else if ( name == "q_lan" ) {
			config = Q_lan;
		} else if ( name == "q_lucky_draw" ) {
			config = Q_lucky_draw;
		} else if ( name == "q_lucky_draw_total" ) {
			config = Q_lucky_draw_total;
		} else if ( name == "q_manor" ) {
			config = Q_manor;
		} else if ( name == "q_map" ) {
			config = Q_map;
		} else if ( name == "q_map_transfer" ) {
			config = Q_map_transfer;
		} else if ( name == "q_minimapshow" ) {
			config = Q_minimapshow;
		} else if ( name == "q_mission_base" ) {
			config = Q_mission_base;
		} else if ( name == "q_mission_bubble" ) {
			config = Q_mission_bubble;
		} else if ( name == "q_mission_reword" ) {
			config = Q_mission_reword;
		} else if ( name == "q_mission_section" ) {
			config = Q_mission_section;
		} else if ( name == "q_mission_segment" ) {
			config = Q_mission_segment;
		} else if ( name == "q_monster" ) {
			config = Q_monster;
		} else if ( name == "q_monster_dropprob" ) {
			config = Q_monster_dropprob;
		} else if ( name == "q_monster_introduce" ) {
			config = Q_monster_introduce;
		} else if ( name == "q_newfuc_hint" ) {
			config = Q_newfuc_hint;
		} else if ( name == "q_newfunc" ) {
			config = Q_newfunc;
		} else if ( name == "q_npc" ) {
			config = Q_npc;
		} else if ( name == "q_operator_level" ) {
			config = Q_operator_level;
		} else if ( name == "q_quest_guide" ) {
			config = Q_quest_guide;
		} else if ( name == "q_raid" ) {
			config = Q_raid;
		} else if ( name == "q_ranking_guild" ) {
			config = Q_ranking_guild;
		} else if ( name == "q_resources_recovery" ) {
			config = Q_resources_recovery;
		} else if ( name == "q_role_random_name" ) {
			config = Q_role_random_name;
		} else if ( name == "q_seven_land" ) {
			config = Q_seven_land;
		} else if ( name == "q_shop_base" ) {
			config = Q_shop_base;
		} else if ( name == "q_shop_describe" ) {
			config = Q_shop_describe;
		} else if ( name == "q_sign" ) {
			config = Q_sign;
		} else if ( name == "q_skill_model" ) {
			config = Q_skill_model;
		} else if ( name == "q_skill_public" ) {
			config = Q_skill_public;
		} else if ( name == "q_story" ) {
			config = Q_story;
		} else if ( name == "q_suit" ) {
			config = Q_suit;
		} else if ( name == "q_target" ) {
			config = Q_target;
		} else if ( name == "q_timing" ) {
			config = Q_timing;
        } else if ( name == "q_system_activity" ) {
            config = Q_system_activity;
		} else if ( name == "q_tipconfig" ) {
			config = Q_tipconfig;
		} else if ( name == "q_treasurehunt" ) {
			config = Q_treasurehunt;
		} else if ( name == "q_treasuretype" ) {
			config = Q_treasuretype;
		} else if ( name == "q_upgrade" ) {
			config = Q_upgrade;
		} else if ( name == "q_vacant" ) {
			config = Q_vacant;
		} else if ( name == "q_vip" ) {
			config = Q_vip;
		} else if ( name == "q_vitality" ) {
			config = Q_vitality;
		} else if ( name == "q_vitality_bonus" ) {
			config = Q_vitality_bonus;
		} else if ( name == "q_weaponride" ) {
			config = Q_weaponride;
		} else if ( name == "q_weaponride_addition" ) {
			config = Q_weaponride_addition;
		} else if ( name == "q_weaponride_skills" ) {
			config = Q_weaponride_skills;
		} else if ( name == "q_weaponride_up" ) {
			config = Q_weaponride_up;
		} else if ( name == "q_zone" ) {
			config = Q_zone;
		} else if ( name == "q_resline" ) {
			config = Q_resline;
		} else if ( name == "q_resline_addition" ) {
			config = Q_resline_addition;
		} else if ( name == "q_resline_up" ) {
			config = Q_resline_up;
		} else if ( name == "q_resline_remove" ) {
			config = Q_resline_remove;
		} else if ( name == "q_resline_skills" ) {
			config = Q_resline_skills;
		} else if ( name == "q_ghost_story" ) {
			config = Q_ghost_story;
		} else if ( name == "q_melt_attribute" ) {
			config = Q_melt_attribute;
		} else if ( name == "q_exp_zone" ) {
			config = Q_exp_zone;
		}else if ( name == "q_tujian" ) {
			config = Q_tujian;
		}else if ( name == "q_melt_attribute" ) {
			config = Q_melt_attribute;
		}else if ( name == "q_escort" ) {
			config = Q_escort;
		}else if ( name == "q_temple" ) {
			config = Q_temple;
		}else if ( name == "q_taijizhidian" ) {
			config = Q_taijizhidian;
		}else if ( name == "q_taijizhidian_type" ) {
			config = Q_taijizhidian_type;
		}else if ( name == "q_disguise" ) {
			config = Q_disguise;
        }else if ( name == "q_disguise_upgrade" ) {
            config = Q_disguise_upgrade;
        }else if ( name == "q_disguise_advance" ) {
            config = Q_disguise_advance;
		}else if ( name == "q_fashion" ) {
			config = Q_fashion;
		}
		else if ( name == "q_title" ) {
			config = Q_title;
		}else if ( name == "q_monicker" ) {
			config = Q_monicker;
		}else if ( name == "q_equipt_compound" ) {
			config = Q_equipt_compound;
		}else if ( name == "q_rest" ) {
            config = Q_rest;
        }else if( name == "q_retinue_skill" ){
			config = Q_retinue_skill;
		}
		else if( name == "q_play_freely" ){
            		config = Q_play_freely;
		}
		else if( name == "q_special"){
			config = Q_special;
		}
        else if( name == "q_illusion"){
                config = Q_illusion;
		}
        else if( name == "q_disguise_upgrade"){
                config = Q_disguise_upgrade;
		}
        else if( name == "q_scene_monter_zone"){
                config = Q_scene_monter_zone;
		}
        else if( name == "q_online"){
                config = Q_online;
		}
        else if( name == "q_godarms_up"){
                config = Q_godarms_up;
		}
        else if( name == "q_godarms_base"){
                config = Q_godarms_base;
            }
        else if( name == "q_marry_aureole")			config = Q_marry_aureole;
        else if( name == "q_marry_aureole_base")	config = Q_marry_aureole_base;
        else if( name == "q_marry_base")			config = Q_marry_base;
        else if( name == "q_marry_proposal")		config = Q_marry_proposal;
        else if( name == "q_marry_ring")			config = Q_marry_ring;
        else if( name == "q_marry_tree")			config = Q_marry_tree;
		else {
			// cc.error( "Not regist config:" + name );
			return;
		}
		try{
			//先写个异步解析的在这 		--  merlin
			config.bindata = data;
			config.isZip = true;
			config.RealGetList = config.GetList;
			config.RealGet = config.Get;
			config.Get = function(id){
				if( config.isZip ){
					var stream = new BinStream(null)
					config.bindata = new Zlib.Inflate( config.bindata ).decompress();
					stream.SetData( config.bindata );

					config.SetData( stream );
					config.isZip = false;
				}
				return config.RealGet(id);
			};
			config.GetList = function(){
				if( config.isZip ){
					var stream = new BinStream(null)
					config.bindata = new Zlib.Inflate( config.bindata ).decompress();
					stream.SetData( config.bindata );

					config.SetData( stream );
					config.isZip = false;
				}
				return config.RealGetList();
			};
			// config.SetData( data );

		} catch ( e ) {
			zz.Error( "配置表填入数据出错：" + name );
		}
	},

	// ========================================================================================================
	// =========================================================================================== 整包加载
	// ========================================================================================================
	// 加载整包数据配置成功
	_LoadPackDataComplete:function( bigData, args ){
		var parseData = new Zlib.Inflate( bigData ).decompress();
		var stream = new BinStream( parseData );
		stream.endian = BinStream.LITTLE_ENDIAN;
		var subStream = new BinStream( null );
		
		var fileName = null;
		var fileLen = null;
		while ( stream.bytesAvailable() > 0 ){
			fileName = stream.ReadString();
			fileLen = stream.ReadInt();
			var subData = stream.ReadBytes( fileLen );
			// subData = new Zlib.Inflate( subData ).decompress();
			// subStream.SetData( subData );
			// stream.endian = BinStream.LITTLE_ENDIAN;
			try{
				this._AddConfigData( fileName, subData );
				
			} catch( e ) {
				var errLog = "_AddConfigData error:		" + e.message + "\n" + e.stack.substr(0, e.stack.length - 1);
				errLog = errLog.replace(/\n/g, "\nERROR : ");
				zz.Error( errLog + "\n");
			}
		}
		var oldGet = Q_attribute_rise.Get;
		Q_attribute_rise.Get = function(id){
			var rise = oldGet(id);
			if( !rise ){
				var arr = id.split("_");
				var item = Q_item.Get(arr[0]);
				if( item ){
					rise = Q_attribute_rise.Get(item.q_type + "_" + item.q_kind + "_" + arr[1]);
				}
			}
			return rise;
		}
		GlobalParse.Init();
		args.cbPro.call( args.target, "", 1, 1 );
		args.cb.call( args.target );
	},

	// 加载整包数据配置失败
	_LoadPackDataError:function(args){
		args.cb.call( args.target );
	},
	
	// ========================================================================================================
	// =========================================================================================== 分包加载
	// ========================================================================================================
	// 加载分包数据配置进度
	_LoadSubPackProgress:function( data, index, max, cur, args ){
		args.cb.call( args.target, args.list[index], max, cur );
	},
	
	// 加载分包数据配置完成
	_LoadSubPackComplete:function( dataList, args ){
		try{
			var nameList = args.list;
			var len = nameList.length;
			var parseData = null;
			var stream = new BinStream( null );
			
			for ( var i = 0; i < len; ++i ){
				parseData = new Zlib.Inflate( dataList[i] ).decompress();
				stream.SetData( parseData );
				
				this._AddConfigData( nameList[i], stream );
			}
			
			args.cb.call( args.target );
		} catch ( e ) {
			var errLog = "_LoadSubPackComplete error:		" + e.message + "\n" + e.stack.substr(0, e.stack.length - 1);
			errLog = errLog.replace(/\n/g, "\nERROR : ");
			zz.Error( errLog + "\n");
		}
	},
	
	// 加载分包数据配置错误
	_LoadSubPackError:function( args ){
		args.cb.call( args.target );
	},
};