﻿
var AttributeData = cc.Class.extend({
	_attributeHash:null,//老的不要了，直接利用枚举EnumAttribute试用map
	/**
	 * 更新属性
	 * 为了配合服务器偷懒的消息数组序列，所以这里解出结构来保存好
	 * @param type 类型参见 EnumAttribute
	 * @param value
	 * @param attType	属性类型附加索引 战斗 基础 货币
	 * @return 返回新数据和老数据的差值
	 */
	UpdateAttribute:function( type, value, attType )
	{
		var ret = this.GetAttribute(type, attType) - value;
		this.PutAttribute(type, value, attType);
		return ret;
	},
	PutAttribute:function( type, value, attType )
	{
		if ( this._attributeHash == null )
		{
			this._attributeHash = new HashMap();
		}
		this._attributeHash.Put( type + attType, value );
	},
	GetAttribute:function( type, attType )
	{
		if ( this._attributeHash == null )
		{
			this._attributeHash = new HashMap();
			return 0;
		}
		var ret = this._attributeHash.Get(type + attType);
		if ( ret == null )
			return 0;
		return ret;
	},
	/**
	 * 获取总共元宝（限时+绑定）
	 * @return
	 *
	 */
	AllBindGold:function()
	{
		var ret1 = this.GetAttribute(EnumMoney.BIND_GOLD);
		var ret2 = 0;//this.GetAttribute(EnumAttribute.BIND_GOLD_CLEAR);
		return ret1 + ret2;
	},
	/**
	 * 获取总共元宝（限时+非绑定）
	 * */
	Allgold:function()
	{
		var ret1 = this.GetAttribute(EnumMoney.GOLD, AttributeData.Money);
		var ret2 = this.GetAttribute(EnumMoney.TIME_GOLD,AttributeData.Money);
		return ret1 + ret2;
	},
	/**
	 * 获取总共元宝（绑定+非绑定）
	 * @return
	 *
	 */
	TotalGold:function()
	{
		var ret1 = this.GetAttribute(EnumMoney.GOLD, AttributeData.Money);
		var ret2 = this.GetAttribute(EnumMoney.TIME_GOLD,AttributeData.Money);
		var ret3 = this.GetAttribute(EnumMoney.BIND_GOLD, AttributeData.Money);
		return ret1 + ret2 + ret3;
	},

	_GetMoveSpeed:function(){
		return this.GetAttribute(EnumAttribute.MOVE_SPEED, AttributeData.Fight);
	},

	_GetCurHp:function(){
		return this.GetAttribute(EnumBaseAttribute.HP, AttributeData.Base);
	},

	_GetMaxBaseHp:function(){
		return this.GetAttribute(EnumAttribute.MAX_BASEHP, AttributeData.Fight);
	},

	_GetLevel:function(){
		return this.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base);
	},

	_GetNuqi:function(){
		return this.GetAttribute(EnumBaseAttribute.NUQI, AttributeData.Base);
	},

	_GetNuqiPercent:function(){
		return parseInt(this.GetAttribute(EnumBaseAttribute.NUQI, AttributeData.Base) * 100 / AttributeData.Nuqi_Max_Value);
	}
});
//不同类型属性的索引 因为存在同一个地方 用于区分
AttributeData.Fight = 0;
AttributeData.Base = 10000;
AttributeData.Money = 100000;
AttributeData.Nuqi_One_Value = 5;
AttributeData.Nuqi_Max_Value = 100;
var _p = AttributeData.prototype;
cc.defineGetterSetter( _p, "moveSpeed", _p._GetMoveSpeed );
cc.defineGetterSetter( _p, "curHp", _p._GetCurHp );
cc.defineGetterSetter( _p, "maxBaseHp", _p._GetMaxBaseHp );
cc.defineGetterSetter( _p, "level", _p._GetLevel );
cc.defineGetterSetter( _p, "gold", _p.Allgold );
cc.defineGetterSetter( _p, "bind_gold", _p.AllBindGold );
cc.defineGetterSetter( _p, "nuqi", _p._GetNuqi );
cc.defineGetterSetter( _p, "nuqiPercent", _p._GetNuqiPercent );