var AchievementFrameExt = AchievementFrame.extend ( {
	_className:"AchievementFrameExt",
	_idArr:null,
	_isShowing:false,
    showId:null,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_B;
		this.layoutCom.layoutOffy = 100;
		this._idArr = new Array();
	},

	Init:function(){
        AchievementFrame.prototype.Init.call(this);

        var self = this;
        this.setTouchEnabled(true);
        this.addTouchEventListener( function (target , state)
        {
            if ( state == ccui.Widget.TOUCH_ENDED )
            {
            	var panel = Mgr.uiMgr.ShowPanelByType(AchievementPanelExt.PanelName);
            	if(panel){
            		panel.ShowPanelById(this.showId)
				}
            }
        } );
	},
	
	SetData:function(idArr){
		this._idArr = this._idArr.concat(idArr);
		if( !this._isShowing ){
			var tween = new cc.Spawn( new cc.FadeOut(0) );
			this.imgFrame.runAction( cc.Sequence( cc.DelayTime(0), tween ) );
            this.showId = this._idArr.shift();
			this._ShowAchivement(this.showId);
			this._isShowing = true;
		}
	},
	
	_ShowAchivement:function(id){
		var data = Q_achievement.Get(id);
		if(data){
			this.labTask.SetText(TextUtil.FormatStr( this.labTask.GetHtmlText(), [ data.q_name ] ));
			if(data.q_num)
				this.labNumber.SetText(TextUtil.FormatStr( this.labNumber.GetHtmlText(), [ data.q_num ] ));
			else
                this.labNumber.SetText(TextUtil.FormatStr( this.labNumber.GetHtmlText(), [ data.q_value ] ));
		}
		var tween = new cc.Spawn( new cc.FadeIn(0.3) );
		this.imgFrame.runAction( cc.Sequence( cc.DelayTime(0), tween, cc.callFunc(this._HideAchivement, this) ) );
	},
	
	_HideAchivement:function(){
		var tween = new cc.Spawn( new cc.FadeOut(0.3) );
		this.imgFrame.runAction( cc.Sequence( cc.DelayTime(3), tween, cc.callFunc(this._ShowOver, this) ) );
	},

	_ShowOver:function () {
		if( this._idArr.length > 0 ){
			var showId = this._idArr.shift();
			this._ShowAchivement(showId);
		}else{
			this._isShowing = false;
			Mgr.uiMgr.HidePanelByType(AchievementFrameExt.PanelName);
		}
	}
} );
AchievementFrameExt.PanelName = "AchievementFrameExt";
PanelClassDic["AchievementFrameExt"] = AchievementFrameExt;
