///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ArenaInfo 竞技场详细信息
//ArenaReportInfo 竞技场战报

// 请求消息
//185201,ReqArenaInfo 请求竞技场详细信息
//185202,ReqStartArena 开始竞技场
//185203,ReqRefreshArena 刷新竞技场
//185204,ReqClearArenaCoolDown 清除竞技场冷却时间
//185205,ReqBuyJoinArenaCount 购买参加竞技场次数
//185206,ReqArenaMonsterInfo 请求竞技场机器人信息
//185207,ReqArenaFightOver 竞技场战斗完成
//185208,ReqArenaRankReward 请求领取竞技场排行奖励
//185209,ReqArenalistToGame 前端请求排行榜列表

// 接收消息
//185101,ResArenaInfos 竞技场详细信息
//185102,ResStartArena 开始竞技场
//185103,ResArenaTopRankReward 竞技场历史最高排名奖励
//185104,ResArenaMonsterInfo 返回竞技场怪物信息
//185105,ResArenaCooleDownTime 竞技场冷却时间
//185106,ResJoinArenaCount 返回竞技场挑战次数
//185107,ResArenalistToClient 返回前端排行榜列表


var ArenaInfo = cc.Class.extend({
	ctor:function(){
		this.playerid = null; // playerid
        this.name = null; // 玩家名字
        this.level = 0; // 玩家等级
        this.rank = 0; // 竞技场排名
        this.fightpower = 0; // 战斗力
        this.job = 0; // 职业
        this.type = 0; // 类型 0怪物 1玩家
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteString(this.name);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.rank);
        _buf.WriteVarInt(this.fightpower);
        _buf.WriteVarInt(this.job);
        _buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
		this.playerid = _buf.ReadLong();
        this.name = _buf.ReadString();
        this.level = _buf.ReadVarInt();
        this.rank = _buf.ReadVarInt();
        this.fightpower = _buf.ReadVarInt();
        this.job = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
	},
});
var ArenaReportInfo = cc.Class.extend({
	ctor:function(){
		this.time = 0; // 挑战时间
        this.srcPlayerId = null; // 挑战者Id
        this.desPlayerId = null; // 被挑战者Id
        this.srcName = null; // 挑战者名字
        this.desName = null; // 被挑战者名字
        this.srcLv = 0; // 挑战者等级
        this.desLv = 0; // 被挑战者等级
        this.result = 0; // 结果(0.失败 1.胜利)
        this.srcRank = 0; // 玩家原先排名
        this.rank = 0; // 玩家排名
        this.srcJob = 0; // 挑战者job
        this.desJob = 0; // 被挑战者job
        this.destype = 0; // 被挑战者类型 0怪物 1玩家
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.time);
        _buf.WriteLong(this.srcPlayerId);
        _buf.WriteLong(this.desPlayerId);
        _buf.WriteString(this.srcName);
        _buf.WriteString(this.desName);
        _buf.WriteVarInt(this.srcLv);
        _buf.WriteVarInt(this.desLv);
        _buf.WriteByte(this.result);
        _buf.WriteVarInt(this.srcRank);
        _buf.WriteVarInt(this.rank);
        _buf.WriteByte(this.srcJob);
        _buf.WriteByte(this.desJob);
        _buf.WriteByte(this.destype);
	},
	
	reading:function( _buf ){
		this.time = _buf.ReadVarInt();
        this.srcPlayerId = _buf.ReadLong();
        this.desPlayerId = _buf.ReadLong();
        this.srcName = _buf.ReadString();
        this.desName = _buf.ReadString();
        this.srcLv = _buf.ReadVarInt();
        this.desLv = _buf.ReadVarInt();
        this.result = _buf.ReadByte();
        this.srcRank = _buf.ReadVarInt();
        this.rank = _buf.ReadVarInt();
        this.srcJob = _buf.ReadByte();
        this.desJob = _buf.ReadByte();
        this.destype = _buf.ReadByte();
	},
});
////////////////////
// 竞技场详细信息 //
////////////////////
var ResArenaInfosMessage = cc.Class.extend( {
	ctor:function(){
		this.arenaInfos = []; // 竞技场详细信息 ArenaInfo
        this.arenaReportInfos = []; // 战报 ArenaReportInfo
        this.rank = 0; // 玩家排名
        this.maxTopRank = 0; // 历史最高排名
        this.joinCount = 0; // 参加次数
        this.buyJoinCount = 0; // 购买参加次数
        this.coolDown = 0; // 冷却时间
        this.time = 0; // 发奖剩余时间
        this.needClearCool = 0; // 是否需要清除冷却时间(0不需要 1需要)
        this.awardRank = 0; // 玩家结算后领奖的排名（0就是没排名）
        this.awardState = 0; // 领奖状态 0未领奖 1已领奖
	},

	getId:function(){
		return 185101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.arenaInfos.length );
        for (var i = 0; i < this.arenaInfos.length; i++) {
            _buf.WriteBean(this.arenaInfos[i]);
        }
        _buf.WriteShort( this.arenaReportInfos.length );
        for (var i = 0; i < this.arenaReportInfos.length; i++) {
            _buf.WriteBean(this.arenaReportInfos[i]);
        }
        _buf.WriteVarInt(this.rank);
        _buf.WriteVarInt(this.maxTopRank);
        _buf.WriteByte(this.joinCount);
        _buf.WriteByte(this.buyJoinCount);
        _buf.WriteVarInt(this.coolDown);
        _buf.WriteVarInt(this.time);
        _buf.WriteByte(this.needClearCool);
        _buf.WriteVarInt(this.awardRank);
        _buf.WriteByte(this.awardState);
	},
	
	reading:function( _buf ){
        var arenaInfos_length = _buf.ReadShort();
        for (var i = 0; i < arenaInfos_length; i++) {
            this.arenaInfos[i] = _buf.ReadBean(ArenaInfo);
        }
        var arenaReportInfos_length = _buf.ReadShort();
        for (var i = 0; i < arenaReportInfos_length; i++) {
            this.arenaReportInfos[i] = _buf.ReadBean(ArenaReportInfo);
        }
        this.rank = _buf.ReadVarInt();
        this.maxTopRank = _buf.ReadVarInt();
        this.joinCount = _buf.ReadByte();
        this.buyJoinCount = _buf.ReadByte();
        this.coolDown = _buf.ReadVarInt();
        this.time = _buf.ReadVarInt();
        this.needClearCool = _buf.ReadByte();
        this.awardRank = _buf.ReadVarInt();
        this.awardState = _buf.ReadByte();
	},

	action:function(){
		Mgr.arena.RecvResArenaInfosMessage(this);
	},

});
////////////////////
// 开始竞技场 //
////////////////////
var ResStartArenaMessage = cc.Class.extend( {
	ctor:function(){
		this.result = 0; // 1胜 0负
        this.round = 0; // 回合数
        this.arenaInfo = null; // 对手信息
        this.itemInfos = []; // 奖励信息 TempItemInfo
	},

	getId:function(){
		return 185102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.result);
        _buf.WriteVarInt(this.round);
        _buf.WriteBean(this.arenaInfo);
        _buf.WriteShort( this.itemInfos.length );
        for (var i = 0; i < this.itemInfos.length; i++) {
            _buf.WriteBean(this.itemInfos[i]);
        }
	},
	
	reading:function( _buf ){
        this.result = _buf.ReadVarInt();
        this.round = _buf.ReadVarInt();
        this.arenaInfo = _buf.ReadBean(ArenaInfo);
        var itemInfos_length = _buf.ReadShort();
        for (var i = 0; i < itemInfos_length; i++) {
            this.itemInfos[i] = _buf.ReadBean(TempItemInfo);
        }
	},

	action:function(){
		Mgr.arena.RecvResStartArenaMessage(this);
	},

});
////////////////////
// 竞技场历史最高排名奖励 //
////////////////////
var ResArenaTopRankRewardMessage = cc.Class.extend( {
	ctor:function(){
		this.srcTopRank = 0; // 原来的最高排名
        this.desTopRank = 0; // 现在的最高排名
        this.itemInfos = []; // 奖励信息 TempItemInfo
	},

	getId:function(){
		return 185103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.srcTopRank);
        _buf.WriteVarInt(this.desTopRank);
        _buf.WriteShort( this.itemInfos.length );
        for (var i = 0; i < this.itemInfos.length; i++) {
            _buf.WriteBean(this.itemInfos[i]);
        }
	},
	
	reading:function( _buf ){
        this.srcTopRank = _buf.ReadVarInt();
        this.desTopRank = _buf.ReadVarInt();
        var itemInfos_length = _buf.ReadShort();
        for (var i = 0; i < itemInfos_length; i++) {
            this.itemInfos[i] = _buf.ReadBean(TempItemInfo);
        }
	},

	action:function(){
		Mgr.arena.RecvResArenaTopRankRewardMessage(this);
	},

});
////////////////////
// 返回竞技场怪物信息 //
////////////////////
var ResArenaMonsterInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.name = null; // 名字
        this.job = 0; // 职业
        this.fightpower = 0; // 战斗力
        this.level = 0; // level
        this.hp = 0; // hp
        this.attack = 0; // 攻击
        this.defence = 0; // 防御
        this.hit = 0; // 命中
        this.dodge = 0; // 闪避
        this.crit = 0; // 暴击
        this.antiCrit = 0; // 抗暴击
	},

	getId:function(){
		return 185104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.name);
        _buf.WriteVarInt(this.job);
        _buf.WriteVarInt(this.fightpower);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.hp);
        _buf.WriteVarInt(this.attack);
        _buf.WriteVarInt(this.defence);
        _buf.WriteVarInt(this.hit);
        _buf.WriteVarInt(this.dodge);
        _buf.WriteVarInt(this.crit);
        _buf.WriteVarInt(this.antiCrit);
	},
	
	reading:function( _buf ){
        this.name = _buf.ReadString();
        this.job = _buf.ReadVarInt();
        this.fightpower = _buf.ReadVarInt();
        this.level = _buf.ReadVarInt();
        this.hp = _buf.ReadVarInt();
        this.attack = _buf.ReadVarInt();
        this.defence = _buf.ReadVarInt();
        this.hit = _buf.ReadVarInt();
        this.dodge = _buf.ReadVarInt();
        this.crit = _buf.ReadVarInt();
        this.antiCrit = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.arena.RecvResArenaMonsterInfoMessage(this);
	},

});
////////////////////
// 竞技场冷却时间 //
////////////////////
var ResArenaCooleDownTimeMessage = cc.Class.extend( {
	ctor:function(){
		this.time = 0; // 剩余时间
	},

	getId:function(){
		return 185105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.time);
	},
	
	reading:function( _buf ){
        this.time = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.arena.RecvResArenaCooleDownTimeMessage(this);
	},

});
////////////////////
// 返回竞技场挑战次数 //
////////////////////
var ResJoinArenaCountMessage = cc.Class.extend( {
	ctor:function(){
		this.joinCount = 0; // 参加次数
        this.buyJoinCount = 0; // 购买参加次数
	},

	getId:function(){
		return 185106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.joinCount);
        _buf.WriteByte(this.buyJoinCount);
	},
	
	reading:function( _buf ){
        this.joinCount = _buf.ReadByte();
        this.buyJoinCount = _buf.ReadByte();
	},

	action:function(){
		Mgr.arena.RecvResJoinArenaCountMessage(this);
	},

});
////////////////////
// 返回前端排行榜列表 //
////////////////////
var ResArenalistToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.meArenaInfo = null; // 当前玩家的排行信息
        this.arenaInfolist = []; // 排行榜列表 ArenaInfo
        this.length = 0; // 总长度
	},

	getId:function(){
		return 185107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.meArenaInfo);
        _buf.WriteShort( this.arenaInfolist.length );
        for (var i = 0; i < this.arenaInfolist.length; i++) {
            _buf.WriteBean(this.arenaInfolist[i]);
        }
        _buf.WriteVarInt(this.length);
	},
	
	reading:function( _buf ){
        this.meArenaInfo = _buf.ReadBean(ArenaInfo);
        var arenaInfolist_length = _buf.ReadShort();
        for (var i = 0; i < arenaInfolist_length; i++) {
            this.arenaInfolist[i] = _buf.ReadBean(ArenaInfo);
        }
        this.length = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.arena.RecvResArenalistToClientMessage(this);
	},

});
////////////////////
// 请求竞技场详细信息 //
////////////////////
var ReqArenaInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 185201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 开始竞技场 //
////////////////////
var ReqStartArenaMessage = cc.Class.extend( {
	ctor:function(){
		this.index = 0; // 被挑战者排名索引
        this.personId = null; // 挑战者唯一Id
	},

	getId:function(){
		return 185202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.index);
        _buf.WriteLong(this.personId);
	},
	
	reading:function( _buf ){
        this.index = _buf.ReadVarInt();
        this.personId = _buf.ReadLong();
	},

});
////////////////////
// 刷新竞技场 //
////////////////////
var ReqRefreshArenaMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 185203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 清除竞技场冷却时间 //
////////////////////
var ReqClearArenaCoolDownMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 185204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 购买参加竞技场次数 //
////////////////////
var ReqBuyJoinArenaCountMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 185205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求竞技场机器人信息 //
////////////////////
var ReqArenaMonsterInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.arenaId = null; // 竞技场机器人唯一Id
	},

	getId:function(){
		return 185206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.arenaId);
	},
	
	reading:function( _buf ){
        this.arenaId = _buf.ReadLong();
	},

});
////////////////////
// 竞技场战斗完成 //
////////////////////
var ReqArenaFightOverMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 185207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取竞技场排行奖励 //
////////////////////
var ReqArenaRankRewardMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 185208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 前端请求排行榜列表 //
////////////////////
var ReqArenalistToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 排行榜总类型(0本国,1连服)
        this.start = 0; // 开始位置
        this.length = 0; // 长度
	},

	getId:function(){
		return 185209;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.start);
        _buf.WriteVarInt(this.length);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.start = _buf.ReadVarInt();
        this.length = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(185101, ResArenaInfosMessage);
MESSAGE_POOL.Add(185102, ResStartArenaMessage);
MESSAGE_POOL.Add(185103, ResArenaTopRankRewardMessage);
MESSAGE_POOL.Add(185104, ResArenaMonsterInfoMessage);
MESSAGE_POOL.Add(185105, ResArenaCooleDownTimeMessage);
MESSAGE_POOL.Add(185106, ResJoinArenaCountMessage);
MESSAGE_POOL.Add(185107, ResArenalistToClientMessage);

