var ArenaFightPlayer = ScenePlayer.extend({
    ctor:function(){
        this._super();

        this.Init();

        this.nJobId = 1;
        this.nBodyModelId = 1;
        this.nDisguiseId = 0;
        this.RefreshShowBody();
        this.RefreshShowWep();
        this.nCurDirection = 2;
        this.SetObjectHeightPos(0);
        this.SetScale(1,1);

    },
    OnAnimationPlayEnd:function(){
        var t = this.nCurActionType;
        switch(t){
            case EnumActionType.ATTACK:
            case EnumActionType.ATTACK2:
            case EnumActionType.ATTACK3:
            case EnumActionType.ATTACK4:
            case EnumActionType.ATTACK5:
                this.TryDoStand();
                if(this._autoAttack)TimerUtil.NextFrame(this.Attack,this);
                break;
        }

    },

    Attack:function(){
        this._autoAttack = true;
        var fightId = Math.floor(Math.random() * 4) + 2;
        this.SetStateShowAttack(fightId,this.nCurDirection);
        FightUtil.DoRoleBaseSkill(this,fightId);
    },
    EndAttack:function(){
        this._autoAttack = false;
    },
    UpdateWithMainPlayer:function(){
        var self = Mgr.mainPlayer;
        this.nJobId = self.nJobId;
        this.nBodyModelId = self.nBodyModelId;
        this.nWeaponModelId = self.nWeaponModelId;
        this.nBaoqiModelId = self.nBaoqiModelId;
        this.nWingId = self.nWingId;
        this.nDisguiseId = self.nDisguiseId;

        this.RefreshShowBody();
        this.RefreshShowWep();
        this._RefreshGuangyuRes();
    },
    UpdateWithData:function(player){
        this.nJobId = player.job;
        this.nBodyModelId = player.job;
        this.nDisguiseId = 0;

        if(player.brief){
            this.nBodyModelId = player.brief.job;

            for( var i = 0; i < player.brief.reslineInfo.length; i++ ){
                var resline = player.brief.reslineInfo[i];
                if( resline.reslineType == EnumResline.GUANGWU )
                    this.UpdateReslineModelid(resline.reslineType,resline.reslineModelId);
            }

            this.nWingId = player.brief.armorShowId;
            this.nDisguiseId = player.brief.disguiseId;

        }else{
            this.nWeaponModelId = 1;
        }

        this.RefreshShowBody();
        this.RefreshShowWep();
        this._RefreshGuangyuRes();
    },
});

var ArenaFightPet = ScenePet.extend({
    ctor:function(){
        this._super();

        this.nBodyModelId = 1;
        this.nType = EnumResline.SHUTONG;
        this.nHorseModelId =  1;
        this.RefreshShowBody();
    },
    OnAnimationPlayEnd:function(){
        var t = this.nCurActionType;
        switch(t){
            case EnumActionType.ATTACK:
            case EnumActionType.ATTACK2:
            case EnumActionType.ATTACK3:
            case EnumActionType.ATTACK4:
            case EnumActionType.ATTACK5:
                this.TryDoStand();
                if(this._autoAttack)TimerUtil.NextFrame(this.Attack,this);
                break;
        }

    },

    Attack:function(){
        this._autoAttack = true;
        var fightId = 1;//Math.floor(Math.random() * 2) + 1;
        this.SetStateShowAttack(fightId,this.nCurDirection);
//        FightUtil.DoRoleBaseSkill(this,fightId);
    },
    EndAttack:function(){
        this._autoAttack = false;
    },

    UpdateWithMainPlayer:function(){
        var self = Mgr.mainPlayer;
        var nresid = SceneObjUtil.GetSceneReslineId( EnumResline.SHUTONG, self);

        this.nBodyModelId = nresid;
        this.nType = EnumResline.SHUTONG;
        this.nHorseModelId = self.nBaoqiModelId;

        this.RefreshShowBody();
        // 上面的函数在nBodyModelId没变的时候不会刷新坐骑
        this.RefreshResline(EnumResline.BAOQI);
    },
    UpdateWithData:function(player){
        if(player.brief){
            var petId,horseId
            for( var i = 0; i < player.brief.reslineInfo.length; i++ ){
                var resline = player.brief.reslineInfo[i];
                if( resline.reslineType == EnumResline.SHUTONG )
                    petId = resline.reslineModelId;
                else if( resline.reslineType == EnumResline.BAOQI )
                    horseId = resline.reslineModelId;
            }

            this.nBodyModelId = petId || 1;
            this.nType = EnumResline.SHUTONG;
            this.nHorseModelId =  horseId ||1;
            this.RefreshShowBody()
        }else{
            this.nBodyModelId = 1;
            this.nType = EnumResline.SHUTONG;
            this.nHorseModelId =  1;
            this.RefreshShowBody()
        }
    },
});