///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ArmorEquipInfo 装备道具信息
//ArmorDataInfo 战甲基本数据信息

// 请求消息
//237201,ReqArmorDataInfoToGame 请求战甲信息
//237202,ReqArmorCuilianToGame 请求战甲淬炼
//237203,ReqArmorChangeShowToGame 请求战甲穿戴
//237204,ReqArmorEquipSetToGame 穿戴装备
//237205,ReqArmorEquipClearToGame 卸下装备

// 接收消息
//237101,ResArmorDataInfoToClient 发送战甲基本数据 
//237102,ResArmorCuilianResultToClient 发送战甲淬炼结果
//237103,ResArmorChangeShowClient 发送当前战甲ID给地图周围的玩家(改变外观)
//237104,ResArmorActiveClient 战甲第一次激活发送给前段
//237105,ResArmorEquipChangeToClient 光羽装备改变


var ArmorEquipInfo = cc.Class.extend({
	ctor:function(){
		this.equipModelId = 0; // 装备模板ID
        this.isbind = 0; // 是否绑定(1是绑定0是不绑定)
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.equipModelId);
        _buf.WriteVarInt(this.isbind);
	},
	
	reading:function( _buf ){
		this.equipModelId = _buf.ReadVarInt();
        this.isbind = _buf.ReadVarInt();
	},
});
var ArmorDataInfo = cc.Class.extend({
	ctor:function(){
		this.showModelId = 0; // 当前穿戴的战甲ID 
        this.attList = []; // 淬炼的属性丹数量列表(索引0表示道具ID，1表示数量，依次类推) int
        this.activateTime = 0; // 激活的时间（单位秒，-1表示永久获得,0表示未激活，否则这个时间+24h之后会过期） 
        this.equips = []; // 装备列表(4个格子) ArmorEquipInfo
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.showModelId);
        _buf.WriteShort( this.attList.length );
        for (var i = 0; i < this.attList.length; i++) {
            _buf.WriteVarInt(this.attList[i]);
        }
        _buf.WriteVarInt(this.activateTime);
        _buf.WriteShort( this.equips.length );
        for (var i = 0; i < this.equips.length; i++) {
            _buf.WriteBean(this.equips[i]);
        }
	},
	
	reading:function( _buf ){
		this.showModelId = _buf.ReadVarInt();
        var attList_length = _buf.ReadShort();
        for (var i = 0; i < attList_length; i++) {
            this.attList[i] = _buf.ReadVarInt();
        }
        this.activateTime = _buf.ReadVarInt();
        var equips_length = _buf.ReadShort();
        for (var i = 0; i < equips_length; i++) {
            this.equips[i] = _buf.ReadBean(ArmorEquipInfo);
        }
	},
});
////////////////////
// 发送战甲基本数据  //
////////////////////
var ResArmorDataInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.armorDataInfo = null; // 坐骑基本数据信息
	},

	getId:function(){
		return 237101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.armorDataInfo);
	},
	
	reading:function( _buf ){
        this.armorDataInfo = _buf.ReadBean(ArmorDataInfo);
	},

	action:function(){
		Mgr.armor.RecvResArmorDataInfoToClientMessage(this);
	},

});
////////////////////
// 发送战甲淬炼结果 //
////////////////////
var ResArmorCuilianResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.result = 0; // 淬炼结果（1是成功0是失败）
	},

	getId:function(){
		return 237102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.result);
	},
	
	reading:function( _buf ){
        this.result = _buf.ReadByte();
	},

	action:function(){
		Mgr.armor.RecvResArmorCuilianResultToClientMessage(this);
	},

});
////////////////////
// 发送当前战甲ID给地图周围的玩家(改变外观) //
////////////////////
var ResArmorChangeShowClientMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 玩家ID
        this.showModelId = 0; // 战甲ID
	},

	getId:function(){
		return 237103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteVarInt(this.showModelId);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.showModelId = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.armor.RecvResArmorChangeShowClientMessage(this);
	},

});
////////////////////
// 战甲第一次激活发送给前段 //
////////////////////
var ResArmorActiveClientMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 237104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.armor.RecvResArmorActiveClientMessage(this);
	},

});
////////////////////
// 光羽装备改变 //
////////////////////
var ResArmorEquipChangeToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 操作类型(0穿戴1脱下)
        this.pos = 0; // 位置(0到3)
        this.equipInfo = null; // 装备信息
	},

	getId:function(){
		return 237105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteByte(this.pos);
        _buf.WriteBean(this.equipInfo);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.pos = _buf.ReadByte();
        this.equipInfo = _buf.ReadBean(ArmorEquipInfo);
	},

	action:function(){
		Mgr.armor.RecvResArmorEquipChangeToClientMessage(this);
	},

});
////////////////////
// 请求战甲信息 //
////////////////////
var ReqArmorDataInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 237201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求战甲淬炼 //
////////////////////
var ReqArmorCuilianToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.itemModelId = 0; // 道具ID
        this.itemNum = 0; // 淬炼数量
	},

	getId:function(){
		return 237202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.itemModelId);
        _buf.WriteVarInt(this.itemNum);
	},
	
	reading:function( _buf ){
        this.itemModelId = _buf.ReadVarInt();
        this.itemNum = _buf.ReadVarInt();
	},

});
////////////////////
// 请求战甲穿戴 //
////////////////////
var ReqArmorChangeShowToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.showModelId = 0; // 战甲ID
	},

	getId:function(){
		return 237203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.showModelId);
	},
	
	reading:function( _buf ){
        this.showModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 穿戴装备 //
////////////////////
var ReqArmorEquipSetToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.pos = 0; // 位置(0到3)
        this.itemmodelid = null; // 要穿戴的装备唯一ID
	},

	getId:function(){
		return 237204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.pos);
        _buf.WriteLong(this.itemmodelid);
	},
	
	reading:function( _buf ){
        this.pos = _buf.ReadByte();
        this.itemmodelid = _buf.ReadLong();
	},

});
////////////////////
// 卸下装备 //
////////////////////
var ReqArmorEquipClearToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.pos = 0; // 位置(0到3))
	},

	getId:function(){
		return 237205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.pos);
	},
	
	reading:function( _buf ){
        this.pos = _buf.ReadByte();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(237101, ResArmorDataInfoToClientMessage);
MESSAGE_POOL.Add(237102, ResArmorCuilianResultToClientMessage);
MESSAGE_POOL.Add(237103, ResArmorChangeShowClientMessage);
MESSAGE_POOL.Add(237104, ResArmorActiveClientMessage);
MESSAGE_POOL.Add(237105, ResArmorEquipChangeToClientMessage);

