﻿/**
 * 格子数量 描述信息
 */
var BackpackGridNumInfo = BackpackGridNumInfo || cc.Class.extend({
	/** 起始开启格子编号**/
	BEGIN_GRID_INDEX:60,
	/** 格子每行个数**/
	GRID_LINE_NUM:5,
	/** 格子每页列数**/
	LINE_PER_PAGE:6,
	/** 每页格子数**/
	GRID_PER_PAGE:0,
	/** 最大页**/
	GRID_MAX_PAGE:3,
	/** 最大格子数**/
	MAX_GRID_NUM:0,
	/** 起始编号**/
	beginId:1,
	/** 正在开启格号**/
	_opening:60,
	/** 未开启格数量**/
	_lockNum:6,
//	正在开启的格子的 剩余时间
//	private var remainTime : int,
	/** 第一次查询不弹开格面板**/
	isFirst:true,
	/** 当前格子剩余时间**/
	openingRemainTime:0,
	/** 本地的更新时间  用于计算 过去时间**/
	begainTime:0,
	ctor:function() {
		this.GRID_PER_PAGE = this.GRID_LINE_NUM * this.LINE_PER_PAGE;
		this.MAX_GRID_NUM = this.GRID_PER_PAGE * this.GRID_MAX_PAGE;
		this.openingRemainTime = 60 * 10 * 1000;
	},
	SetMaxConfig:function(value){
		if ( value == null || value == 0 )
			value = 100;
		cc.log( "SETMAXCONFIG:" + value );
		this.MAX_GRID_NUM = value;//this.GetInt(18);
		this.GRID_PER_PAGE = value;//this.GetInt(18);不做分页先这样
	},
	/**
	 * 返回格子的行数
	 */
	GetGridLineNum:function(){
		return this.MAX_GRID_NUM/this.GRID_LINE_NUM;//全部显示
	},
	GetUpdataVO:function (){
		var re = [];
		var len = this.GetOpendNum();
		for (var i = 0; i < len  ; i++)
		{
			re[i] = GridOpenTypeEnum.opened;
		}

		re[i] = GridOpenTypeEnum.opening;

		for (var j = i; j < this._lockNum + j ; j++)
		{
			re[j] = GridOpenTypeEnum.locked;
		}
		return re;
	},
	GetShowGridNum:function (){
		return this.GetOpendNum() + 1 + this._lockNum;
	},
	SetOpening:function(value){
		if (value > this.MAX_GRID_NUM)
		{
			// 开最后一格
			this._opening = 0;
			this._lockNum = 0;
			return;
		}

		this._opening = value;
		// 刷新当前剩余时间
		// 补格数
		var page = Math.ceil(this.GetOpening() /  this.GRID_PER_PAGE);
		this._lockNum = page* this.GRID_PER_PAGE - this.GetOpening();
	},
	GetOpendNum:function(){
		if (this.GetOpening() == 0)
		{
			return this.MAX_GRID_NUM;
		}
		return this.GetOpening() - 1;
	},
	// 正在开启格子id
	GetOpening:function(){
		return this._opening;
	},
	// 锁格子数量
	GetLockNum:function(){
		return this._lockNum;
	},
	// 格子行数 
	GetRowNum:function(){
		return this.GetShowGridNum() / this.GRID_LINE_NUM;
	},
	GetOpeningRemainTime:function(){
		var re  = this._openingRemainTime - (new Date().getTime() - this.begainTime) / 1000;
		if ( re < 0 )
			re = 0;
		return re;
	},
	SetOpeningRemainTime:function(openingRemainTime){
		this._openingRemainTime = openingRemainTime;
		// 刷新显示
		// BackpackMgr.getInstance().get
		this.begainTime = new Date().getTime();
	},

	SetOpeningRemainTime:function(openingRemainTime){
		this._openingRemainTime = openingRemainTime;
		// 刷新显示
		// BackpackMgr.getInstance().get
		this.begainTime = time//getTimer();
	},
	//读取当前正在开启格子的时间
	GetOpeningNeedTime:function(){
		var q = Q_backpack_grid.Get(1+"_"+this._opening);
		if (q)
		{
			return q.q_time;
		}
		else
		{
			return 0;
		}
	}
})

