﻿
var ItemUtil = ItemUtil || {
		//品质判定区间
		QT_JUDAGE_WRITE:30,
		QT_JUDAGE_GREEN:55,
		QT_JUDAGE_BLUE:75,
		QT_JUDAGE_PURPLE:90,
		// 物品品质
		ITEM_QT_WRITE:0,
		//        ITEM_QT_YELLOW:1,
		ITEM_QT_GREEN:1,
		ITEM_QT_BLUE:2,
		ITEM_QT_PURPLE:3,
		ITEM_QT_ORANGE:4,
		ITEM_QT_RED:5,
		ITEM_QT_PINK:6,

	ItemIdToItem:function ( itemId, num , itemBind ){
		if(num == null)
			num = 1;
		if(itemBind == null )
			itemBind = 0;
		var itemm = Q_item.Get(itemId);
		var item = new Item();
		item.itemModelId = itemId;
		item.itemNum = num;
		item.itemBind = itemBind;
		if ( itemm )
			item.job = itemm.q_job;
		return item;
	},

	GetItemRewards:function(arr){
		var rewards = [];
		for(var i=0;i!=arr.length;++i){
			var v = arr[i];
			var item = (v instanceof Array ? this.GetItemRewards(v) : ItemUtil.ItemConfigToItem(v));
			rewards.push(item);
		}

		return rewards;
	},

    ParseReward:function(rewardStr){
        var rewardJson = JSON.parse(rewardStr);

        return this.GetItemRewards(rewardJson);
    },

    //{ mod, num, bind, ldate}
    ItemConfigToItem:function(conf){
        if(!conf) conf = { mod : 0, num : 1, bind : 0, ldate : "", }

        var itemC = Q_item.Get(conf.mod);
        var ret = new Item();
        ret.itemModelId = conf.mod || 0;
        ret.itemNum = conf.num || 1;
        ret.itemBind = conf.bind || 0;
        if ( itemC )
            ret.job = conf.job || itemC.q_job;

        // 时限
        var lostTime = 0;
        do{
            if(!conf.ldate) break;

            // 检查xxxx-xx-xx xx:xx:xx格式
            var rr = conf.ldate.match(/(\d+)-(\d+)+(\d+) (\d+):(\d+):(\d+)/);
            if(rr){
                var dd = new Date()
                dd.setFullYear(rr[1]);
                dd.setMonth(rr[2]);
                dd.setDate(rr[3]);
                dd.setHours(rr[4]);
                dd.setMinutes(rr[5]);
                dd.setSeconds(rr[6]);
                lostTime = Math.floor(dd.getTime() / 1000);
                break;
            }
            // 检查XDAY格式
            var rr = conf.ldate.match(/(\d+)DAY/);
            if(rr){
                var serverTime = Mgr.login.GetServerTime();
                var dd = new Date(serverTime + (rr[1] - 1) * 86400000);
                dd.setHours(23);
                dd.setMinutes(59);
                dd.setSeconds(59);
                lostTime = Math.floor(dd.getTime() / 1000);
                break;
            }
        }while(false);

        //过期时间
        ret.SetOverdueTime(lostTime);

        ret.ParseParams(conf.paras);

        return ret;
    },
    /// 获取道具对应战斗力
    GetItemFightPower:function(mod){
        var itemC = Q_item.Get(mod);
        var fightpower = 0;

        if(!itemC) return fightpower;

        /// special
        switch(itemC.q_id){
            case 50007: /// 婚戒
                var ringC = Q_marry_ring.Get(1)
                fightpower = Mgr.fightpower.GetFightPower(ringC.q_attribute)
                break;
        }
        if(fightpower != 0) return fightpower;

        /// 类型
        switch(itemC.q_type){
            case EnumItemType.TiTle:{
                let titleC = Mgr.title.GetTitleByItemId(itemC.q_id);
                fightpower = Mgr.fightpower.GetFightPower(titleC.q_attribute);
                break;
            }
            case EnumItemType.Fashion:{
                let titleC = Mgr.disguise.GetDisguiseByItemItem(itemC.q_id);
                fightpower = Mgr.fightpower.GetFightPower(titleC.q_attribute);
                break;
            }
            case EnumItemType.GUANGWU:{
                let titleC = Mgr.illusion.GetIllusionByItemItem(itemC.q_id);
                fightpower = Mgr.fightpower.GetFightPower(titleC.q_attribute);
                break;
            }
        }
        return fightpower;
    },

	GetItemIcon:function (mid , sizetype, isGround )
	{
		var url = ResUrl.GetItemIconKey(mid);
		var defaultUrl = ResUrl.GetDefaultItemUrl();
		var bmp = UIUtil.GetIconByUrl(url, defaultUrl);
		return bmp;
	},
	GetItemName:function(mid){
		var itemm = Q_item.Get(mid);
		var nam = "未知";
		if (itemm != null)
		{
			nam = this.GetItemNameByModel(itemm);
		}
		return nam;
	},
	GetItemNameByModel:function(model){
		var nam = ((model == null) ? "未知道具" : model.q_name);
		var pos = nam.indexOf("_");
		if (pos != -1)
		{
			nam = nam.substring(0, pos);
		}
		return nam;
	},
	IsEquip:function ( qtype ){
		//还是现在挪过来用用
		switch (qtype){
			case EnumItemType.Equip:
			case EnumItemType.Equip_Holy:
			case EnumItemType.MountEquip:
			case EnumItemType.GuangWuEquip:
			case EnumItemType.GirlEquip:
			case EnumItemType.FaqiEquip:
            case EnumItemType.BaoQiEquip:
            case EnumItemType.EQUIP_MARTIALARTS:
            // case EnumItemType.EQUIP_GUANGYU://光羽装备
            case EnumItemType.EQUIP_STEP:
            case EnumItemType.EQUIP_ZHAOSHI:
            case EnumItemType.EQUIP_JIANLING:
            case EnumItemType.Equip_Shutong:
				return true;
		}
		return false;
	},
    TempItemInfoToItem:function(ii){
        var itemC = Q_item.Get( ii.mod );
        var item  = new Item();
        //物品唯一Id
        item.itemId = ii.itemId;
        //物品模板Id
        item.itemModelId = ii.mod;
        //物品数量
        item.itemNum = ii.num;
        //是否绑定 1是 0否
        item.itemBind = ii.isbind;

        //过期时间
        item.SetOverdueTime(ii.ltime);

        //参数，额外信息
        item.SetParameters(ii.parameters);
        if(itemC) item.job = itemC.q_job;
        return item;
    },

	ItemInfoToItem:function ( ii ) {
		var itemm = Q_item.Get( ii.itemModelId );
		var item  = new Item();
		//物品唯一Id
		item.itemId = ii.itemId;
		//物品模板Id
		item.itemModelId = ii.itemModelId;
		//物品数量
		item.itemNum = ii.num;
		//是否绑定 1是 0否
		item.itemBind = ii.isbind;
		//道具所在格子Id
		item.gridId = ii.gridId;
		//过期时间
		item.SetOverdueTime(ii.lostTime);
		//强化等级
		item.itemLevel = ii.strenthenLv;
        item.reinLv = ii.reincarnateLv;
		//附加属性
		//item.SetItemAttributes(ii.attributeInfos);
		//附加属性条数
		item.SetItemAppendNum(ii.extraNum);
		//参数，额外信息
		item.SetParameters(ii.parameters);
		if(itemm)
			item.job = itemm.q_job;
		return item;
	},
	IsAutoUse:function( mid )
	{
		var model = Q_item.Get(mid);
		if (model != null && model.q_auto_use == 1 )
			return true;
		return false;
	},
	ITEMMODELID_DRAWGOLDCARD:[],
	IsDrawGoldCard:function(mid)
	{
		if(this.ITEMMODELID_DRAWGOLDCARD)
		{
			return this.ITEMMODELID_DRAWGOLDCARD.indexOf(mid) != -1;
		}
		return false;
	},
	GetItemNamecolor:function(item)
	{
		var qt = this.ITEM_QT_WRITE;
		qt = this.GetItemQualityId(item);
		return this.baseItemColorArr[qt];
	},
	GetNameColorById:function(id){
		var type=Q_item.Get(id).q_default;
		/** 物品天生的名字颜色（0白色，1绿色，2蓝色，3紫色，4橙色，5红色,6粉色） */
		switch (type){
			case 0:
				return [EnumFontFormat.COMMON_COLOR01,EnumFontFormat.COMMON_COLOR01];
			case 1:
				return [EnumFontFormat.COMMON_COLOR04,0x295d1d];                       //绿色
			case 2:
				return [EnumFontFormat.LINK_NAME_COLOR,0x1a4b78];
			case 3:
				return [EnumFontFormat.LINK_ITEM_COLOR,0x5e1c73];
			case 4:
                return [EnumFontFormat.LINK_OTHER_COLOR,0x5e1c73];
			case 5:
				return [EnumFontFormat.COMMON_COLOR09,0x761a16];                     //红
            case 6:
                return [0xffed88,0xffed88];                     //粉色???
			default:
				return [EnumFontFormat.COMMON_COLOR01,EnumFontFormat.COMMON_COLOR01];
		}
	},
	GetItemQualityId:function(item)
	{
		var eqInfo = item;
		if ( eqInfo._isShowHighQt )
		{
			return this.ITEM_QT_ORANGE;
		}
		if ( eqInfo._showQuality > -1 )
		{
			return eqInfo._showQuality;
		}
		//if ( eqInfo.model != null )
		//{
		//	if ( eqInfo.model.q_default == ITEM_QT_RED || eqInfo.model.q_default == ITEM_QT_ORANGE )
		//		return eqInfo.model.q_default;
        //
		//	if (!isEquip(eqInfo.model.q_type) )
		//		return eqInfo.model.q_default;
		//	else
		//		return getItemRealQualityId(eqInfo);
		//}
		return this.ITEM_QT_WRITE;
	},

	GetItemQuality:function (item) {
		var id = item.itemModelId;
        var itemC = Q_item.Get(id);
        if(!itemC) return 0;
        var type=itemC.q_default;
        /** 物品品质颜色（0白色，1绿色，2蓝色，3紫色，4橙色，5红色） */
        switch (type){
			case 0:
				return this.ITEM_QT_WRITE;
			case 1:
                return this.ITEM_QT_GREEN;
			case 2:
                return this.ITEM_QT_BLUE;
			case 3:
                return this.ITEM_QT_PURPLE;
			case 4:
                return this.ITEM_QT_ORANGE;
			case 5:
                return this.ITEM_QT_RED;
            case 6:
                return this.ITEM_QT_PINK;
            default:
                return type;
		}
    },

	GetItemDescribe:function(model){
        if ( !model)
            return "未配置道具";
		if ( !model.q_describe)
			return "神秘物品";
		var ret = null;
		var desArr = model.q_describe.split("|");
		var des = desArr[ 0 ];//Mgr.mainPlayer.reinLevel
		return des;
	},
		//跟当前装备的战斗力差
		GetFightPowerFromCurrent:function(item){
            if (item instanceof ItemInfo) {
                item = ItemUtil.ItemInfoToItem(item);
            }

			var q_item=Q_item.Get(item.itemModelId);
			var equip = Mgr.equip.GetEquipByType(  q_item.q_type ,q_item.q_kind );	//如果涉及到坐骑装备了 这里要根据q_type去不同的地方取
			var curFightPower, itemFightPower = 0;
			if(q_item.q_type == 1 || q_item.q_type == EnumItemType.Equip_Shutong){
                curFightPower = equip ? DuanzaoUtil.GetEquipFighting(equip.itemModelId,equip.strenthenLv) : 0;
                // 装备后会继承装备等级
                itemFightPower = DuanzaoUtil.GetEquipFighting(item.itemModelId,equip ? equip.strenthenLv : item.itemLevel);
			}else {
                curFightPower = equip ? DuanzaoUtil.GetEquipFighting(equip.itemModelId,equip.strenthenLv) : 0;
                itemFightPower = DuanzaoUtil.GetEquipFighting(item.itemModelId,item.itemLevel);
			}

			return itemFightPower - curFightPower;
		},
		//把物品和对应的格子放在map 里面
		ArrangeItem:function(itemList,bool){
            var itemHs=new HashMap();
			if(!bool){
                for(var i=0;i<itemList.length;++i){
                    for(var j=i+1;j<itemList.length;++j){
                        if(itemList[i].gridId>itemList[j].gridId){
                            var temp=itemList[i];
                            itemList[i]=itemList[j];
                            itemList[j]=temp;
                        }
                    }
                    itemHs.Put(i,itemList[i]);
                }
			}
			else {
                for (var i = 0; i < itemList.length; ++i) {
                    itemHs.Put(itemList[i].gridId - 1, itemList[i]);
                }
            }
			return itemHs;
		},
		GetAttributeMap:function(item){
            var info=Q_item_simpact.Get(item.itemModelId);
            var attr = ParseUtil.FormatFastJsonStr(info.q_attribute);
           	var attrList = JSON.parse(attr);
			var aa=new HashMap();
			for(var key in attrList){
				aa.Put(this.GetStrByAttrType(parseInt(key)),parseInt(attrList[key]));
			}
			if(item.itemLevel>0){
				var levelAttr=Q_attribute_rise.Get(item.itemModelId+"_"+item.itemLevel).q_attribute;
                attrList=JSON.parse(ParseUtil.FormatFastJsonStr(levelAttr));
                for(var key in attrList){
                	var value=parseInt(attrList[key]);
                	var old=aa.Get(this.GetStrByAttrType(parseInt(key)));
                	if(old!=null){
                		value+=old;
					}
                    aa.Put(this.GetStrByAttrType(parseInt(key)),value);
                }
			}
			return aa;
		},
        GetAttributeMapByAttr:function (attrList) {
            var aa=new HashMap();
            for(var key in attrList){
                let ret = Mgr.attributeMgr.GetAttrDes(parseInt(key),parseInt(attrList[key]));
                aa.Put(ret[0],ret[1]);
                // aa.Put(this.GetStrByAttrType(parseInt(key)),parseInt(attrList[key]));
            }
            return aa;
        },
		GetStrByAttrType:function(type){
		    var ret = Mgr.attributeMgr.GetAttrDes(parseInt(type),0);
		    return ret[0]

		},

        GetValueByAttrType:function(type, value){
            var ret = Mgr.attributeMgr.GetAttrDes(parseInt(type),value);
            return ret[1]
        },
        GetAttrTypeByStr:function (str) {
            var type=null;
            if(str == "攻击"){
                type = EnumAttribute.ATTACK;
            }
            else if(str == "防御"){
                type = EnumAttribute.DEFEND;
            }
            else if(str == "暴击"){
                type = EnumAttribute.CRIT;
            }
            else if(str == "抗暴击"){
                type = EnumAttribute.ANTI_CRIT;
            }
            else if(str == "闪避"){
                type = EnumAttribute.DODGE;
            }
            else if(str == "命中"){
                type = EnumAttribute.HIT;
            }
            else if(str == "生命上限"){
                type = EnumAttribute.MAX_BASEHP;
            }
            else if(str == "攻击速度"){
                type = EnumAttribute.ATTACK_SPEED;
            }
            else if(str == "移动速度"){
                type = EnumAttribute.MOVE_SPEED;
            }
            else if(str == "神圣伤害"){
                type = EnumAttribute.HOLY_DAMAGE;
            }
            else if(str == "伤害加成"){
                type = EnumAttribute.DAMAGE_BONUS;
            }
            else if(str == "伤害减免"){
                type = EnumAttribute.DAMAGE_REDUCE;
            }
            else if(str == "生命回复"){
                type = EnumAttribute.AUTO_RECOVER_HP;
            }
            else if(str == "暴击伤害加成"){
                type = EnumAttribute.CRIT_DAMAGE_BONUS;
            }
            else if(str == "暴击减免"){
                type = EnumAttribute.CRIT__REDUCE;
            }
            else if(str == "经验加成"){
                type = EnumAttribute.EXP_BONUS;
            }
            else if(str == "技能伤害加成"){
                type = EnumAttribute.SKILL_BONUS;
            }
            else if(str == "神武伤害"){
                type = EnumAttribute.BRILLIANT_DAMAGE;
            }
            else if(str == "角色基础攻击"){
                type = EnumAttribute.ATTACK_PERCENT;
            }
            else if(str == "角色基础防御"){
                type = EnumAttribute.DEFEND_PERCENT;
            }
            else if(str == "角色基础暴击"){
                type = EnumAttribute.CRIT_PERCENT;
            }
            else if(str == "角色基础抗暴击"){
                type = EnumAttribute.ANTI_CRIT_PERCENT;
            }
            else if(str == "角色基础闪避"){
                type = EnumAttribute.DODGE_PERCENT;
            }
            else if(str == "角色基础命中"){
                type = EnumAttribute.HIT_PERCENT;
            }
            else if(str == "角色最大血量"){
                type = EnumAttribute.MAXHP_PERCENT;
            }
            else if(str == "角色攻击速度"){
                type = EnumAttribute.ATTACK_SPEED_PERCENT;
            }
            else if(str == "角色攻击速度"){
                type = EnumAttribute.MOVE_SPEED_PERCENT;
            }
            else if(str == "麻痹属性"){
                type = EnumAttribute.PALSY_PERCENT;
            }
            else if(str == "麻痹抗性"){
                type = EnumAttribute.ANTI_PALSY_PERCENT;
            }
            return type;
		},

        GetPosStrByType:function (type) {                  //限角色装备(*^__^*)
            switch (type){
                case 0:
                    return "武器";
                case 1:
                    return "衣服";
                case 2:
                    return "手镯";
                case 3:
                    return "头盔";
                case 4:
                    return "护腿";
                case 5:
                    return "鞋子";
                case 6:
                    return "护符·左";
                case 7:
                    return "护符·右";
                case 8:
                    return "戒指·左";
                case 9:
                    return "戒指·右";
				case 10:
				case 11:
				case 12:
				case 13:
					return "宝物"
            }
        },

        GetPosStr:function (equipType, posType) {
            var str = "";
            switch (equipType){
                case 1:
                case 201:
                    str = this.GetPosStrByType(posType);
                    break;
                default:
                    str = this.GetResPosByType(equipType, posType);
            }
            return str;
        },
        zuoqi:["坐鞍", "挂件", "缰绳", "脚蹬"],//31
        guangwu:["光武护鞘", "光武利刃", "光武护柄", "光武玉璇"],//32
        shutong:["书童头饰", "书童衣服", "书童鞋子", "书童护手"],//33
        baqqi:["宝骑首凯", "宝骑蹬具", "宝骑蹄铁", "宝骑护垫"],//34
        faqi:["法器肩羽", "法器飞羽", "法器覆角", "法器覆羽"],//35
        wuxue:["内功", "外功", "心法", "技击"],//36
        guangyu:["光羽肩羽", "光羽飞羽", "光羽覆角", "光羽覆羽"],//37
        yirong:["易容天启", "易容七星", "易容瞒天", "易容过海"],//38
        jianqiao:["剑鞘鞘口", "剑鞘护环", "剑鞘名牌", "剑鞘剑镖"],//39
        jiaoyin:["勇气", "力量", "愤怒", "无畏"],//40
        jianzhao:["贯通", "青炉", "化神", "奥义"],//41
        jianling:["魂心", "魂精", "魂气", "魂魄"],//42
        tongling:["童灵魂心", "童灵魂精", "童灵魂气", "童灵魂魄"],//43

        GetResPosByType:function (equipType, posType) {
            var str = "";
            switch (equipType){
                case 31:
                    str = this.zuoqi[posType];
                    break;
                case 32:
                    str = this.guangwu[posType];
                    break;
                case 33:
                    str = this.shutong[posType];
                    break;
                case 34:
                    str = this.baqqi[posType];
                    break;
                case 35:
                    str = this.faqi[posType];
                    break;
                case 36:
                    str = this.guangyu[posType];
                    break;
                case 37:
                    str = this.yirong[posType];
                    break;
                case 38:
                    str = this.jianqiao[posType];
                    break;
                case 39:
                    str = this.jiaoyin[posType];
                    break;
                case 40:
                    str = this.jianzhao[posType];
                    break;
                case 41:
                    str = this.jianling[posType];
                    break;
                case 42:
                    str = this.tongling[posType];
                    break;
                case 43:
                    str = this.guangwu[posType];
                    break;
            }
            return str;
        },

		GetFightPowerByAttr:function(attr){
			var pow=0;
			for(var key in attr){
				var fo = Mgr.attributeMgr.GetAttributeRate(parseInt(key), 0);
				pow+=fo*parseInt(attr[key]);
			}
			return pow;
		},
		ShowTips:function (item,type) {
            if(item == null || type == null){
				return;
			}
            var info = Q_item.Get(item.itemModelId);
            var panelName=ItemTipsExt.PanelName;
            if(ItemUtil.IsEquip( info.q_type )) {
                panelName=EquipTipsPanelExt.PanelName;
                // if(info.q_type==EnumItemType.Equip)
				// {
				// 	cc.log("equip");
				// 	panelName=EquipTipsPanelExt.PanelName;
				// }
                // else
				// {
				// 	panelName=ItemTipsPanelExt.PanelName;
				// }
            }else{
                switch(info.q_type){
                    case EnumItemType.Fashion:
                    case EnumItemType.GUANGWU:
                        panelName=WenXinExt.PanelName;
                        break;
                }
            }
            var gem = Mgr.gem.GetInlayStones(info.q_kind);
            var refine = DuanzaoUtil.GetRefineStoneHash(item.itemModelId);
            var equips = Mgr.equip.GetEquipsByType(info.q_type);
            var suit = SuitMakeUtil.GetSuitAttr(equips);
            var addition = {gem: gem, refine: refine, suit: suit};
            var panel = Mgr.uiMgr.ShowPanelByType(panelName, UIMgr.PANEL_LAYER_TOP);
            cc.log("addition   " + JSON.stringify(addition));
            panel.Updatedata(item, type, addition);
        }
}











