///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ExtraResInfo 聊天返回的附加信息
//ChatGoodInfo 超链接物品信息
//HyperInfo 超链接信息
//ExtraReqInfo 发送聊天的附加参数
//ChatRecordInfo 聊天记录

// 请求消息
//112201,ReqChat 聊天消息
//112202,ReqReportPlayer 举报玩家发言问题
//112203,ReqChatRecord 申请消息记录

// 接收消息
//112101,ResChat 聊天消息
//112102,ResChatRecord 发送聊天记录
//112103,ResOfflineChatCount 发送离线信息条数


var ExtraResInfo = cc.Class.extend({
	ctor:function(){
		this.targetPlayerName = null; // 目标玩家名称
        this.viplevel = 0; // 发送者vip等级,-1表示引导员(优先显示),-2=GM
        this.guildOfficial = 0; // 发送者帮会职位
        this.plamtVip = 0; // 平台VIP
        this.domain = 0; // 腾讯渠标识
        this.job = 0; // 玩家角色类型（职业类型）
        this.sendlevel = 0; // 发起者的玩家等级
        this.hyperInfos = []; // 展示内容列表 HyperInfo
        this.itemInfos = []; // 物品信息  ChatGoodInfo
	},

	writing:function( _buf ){
		_buf.WriteString(this.targetPlayerName);
        _buf.WriteByte(this.viplevel);
        _buf.WriteByte(this.guildOfficial);
        _buf.WriteByte(this.plamtVip);
        _buf.WriteByte(this.domain);
        _buf.WriteByte(this.job);
        _buf.WriteVarInt(this.sendlevel);
        _buf.WriteShort( this.hyperInfos.length );
        for (var i = 0; i < this.hyperInfos.length; i++) {
            _buf.WriteBean(this.hyperInfos[i]);
        }
        _buf.WriteShort( this.itemInfos.length );
        for (var i = 0; i < this.itemInfos.length; i++) {
            _buf.WriteBean(this.itemInfos[i]);
        }
	},
	
	reading:function( _buf ){
		this.targetPlayerName = _buf.ReadString();
        this.viplevel = _buf.ReadByte();
        this.guildOfficial = _buf.ReadByte();
        this.plamtVip = _buf.ReadByte();
        this.domain = _buf.ReadByte();
        this.job = _buf.ReadByte();
        this.sendlevel = _buf.ReadVarInt();
        var hyperInfos_length = _buf.ReadShort();
        for (var i = 0; i < hyperInfos_length; i++) {
            this.hyperInfos[i] = _buf.ReadBean(HyperInfo);
        }
        var itemInfos_length = _buf.ReadShort();
        for (var i = 0; i < itemInfos_length; i++) {
            this.itemInfos[i] = _buf.ReadBean(ChatGoodInfo);
        }
	},
});
var ChatGoodInfo = cc.Class.extend({
	ctor:function(){
		this.index = 0; // 序号
        this.itemInfos = null; // 物品信息 
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.index);
        _buf.WriteBean(this.itemInfos);
	},
	
	reading:function( _buf ){
		this.index = _buf.ReadVarInt();
        this.itemInfos = _buf.ReadBean(ItemInfo);
	},
});
var HyperInfo = cc.Class.extend({
	ctor:function(){
		this.hyperType = 0; // 超链接类型
        this.index = 0; // 序号
        this.clientUseText = null; // 前端用的类容
        this.params_ = null; // 附加参数
	},

	writing:function( _buf ){
		_buf.WriteByte(this.hyperType);
        _buf.WriteVarInt(this.index);
        _buf.WriteString(this.clientUseText);
        _buf.WriteString(this.params_);
	},
	
	reading:function( _buf ){
		this.hyperType = _buf.ReadByte();
        this.index = _buf.ReadVarInt();
        this.clientUseText = _buf.ReadString();
        this.params_ = _buf.ReadString();
	},
});
var ExtraReqInfo = cc.Class.extend({
	ctor:function(){
		this.targetPlayerName = null; // 私聊目标玩家名称
        this.hyperInfos = []; // 展示内容列表 HyperInfo
	},

	writing:function( _buf ){
		_buf.WriteString(this.targetPlayerName);
        _buf.WriteShort( this.hyperInfos.length );
        for (var i = 0; i < this.hyperInfos.length; i++) {
            _buf.WriteBean(this.hyperInfos[i]);
        }
	},
	
	reading:function( _buf ){
		this.targetPlayerName = _buf.ReadString();
        var hyperInfos_length = _buf.ReadShort();
        for (var i = 0; i < hyperInfos_length; i++) {
            this.hyperInfos[i] = _buf.ReadBean(HyperInfo);
        }
	},
});
var ChatRecordInfo = cc.Class.extend({
	ctor:function(){
		this.who = 0; // 0 发送者 1接收者
        this.content = null; // 聊天内容
        this.time = null; // 消息时间
	},

	writing:function( _buf ){
		_buf.WriteByte(this.who);
        _buf.WriteString(this.content);
        _buf.WriteLong(this.time);
	},
	
	reading:function( _buf ){
		this.who = _buf.ReadByte();
        this.content = _buf.ReadString();
        this.time = _buf.ReadLong();
	},
});
////////////////////
// 聊天消息 //
////////////////////
var ResChatMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 玩家ID
        this.name = null; // 玩家名字
        this.type = 0; // 聊天类型
        this.chatText = null; // 聊天内容
        this.targetPlayerId = null; // 聊天目标id
        this.extraResInfo = null; // 返回的其余数据
	},

	getId:function(){
		return 112101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.name);
        _buf.WriteByte(this.type);
        _buf.WriteString(this.chatText);
        _buf.WriteLong(this.targetPlayerId);
        _buf.WriteBean(this.extraResInfo);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.name = _buf.ReadString();
        this.type = _buf.ReadByte();
        this.chatText = _buf.ReadString();
        this.targetPlayerId = _buf.ReadLong();
        this.extraResInfo = _buf.ReadBean(ExtraResInfo);
	},

	action:function(){
		Mgr.chat.RecvResChatMessage(this);
	},

});
////////////////////
// 发送聊天记录 //
////////////////////
var ResChatRecordMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 发送者或接受者的id
        this.chatRecordList = []; // 聊天记录列表 ChatRecordInfo
	},

	getId:function(){
		return 112102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteShort( this.chatRecordList.length );
        for (var i = 0; i < this.chatRecordList.length; i++) {
            _buf.WriteBean(this.chatRecordList[i]);
        }
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        var chatRecordList_length = _buf.ReadShort();
        for (var i = 0; i < chatRecordList_length; i++) {
            this.chatRecordList[i] = _buf.ReadBean(ChatRecordInfo);
        }
	},

	action:function(){
		Mgr.chat.RecvResChatRecordMessage(this);
	},

});
////////////////////
// 发送离线信息条数 //
////////////////////
var ResOfflineChatCountMessage = cc.Class.extend( {
	ctor:function(){
		this.sourceId = null; // 来源者id
        this.count = 0; // 离线留言条数
	},

	getId:function(){
		return 112103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.sourceId);
        _buf.WriteVarInt(this.count);
	},
	
	reading:function( _buf ){
        this.sourceId = _buf.ReadLong();
        this.count = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.chat.RecvResOfflineChatCountMessage(this);
	},

});
////////////////////
// 聊天消息 //
////////////////////
var ReqChatMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 聊天类型
        this.chatText = null; // 聊天内容
        this.extraReqInfo = null; // 发送聊天的其余数据
	},

	getId:function(){
		return 112201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteString(this.chatText);
        _buf.WriteBean(this.extraReqInfo);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.chatText = _buf.ReadString();
        this.extraReqInfo = _buf.ReadBean(ExtraReqInfo);
	},

});
////////////////////
// 举报玩家发言问题 //
////////////////////
var ReqReportPlayerMessage = cc.Class.extend( {
	ctor:function(){
		this.reportid = null; // 被举报角色id
        this.type = 0; // 举报类型
        this.content = null; // 详细内容(玩家填写)
	},

	getId:function(){
		return 112202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.reportid);
        _buf.WriteVarInt(this.type);
        _buf.WriteString(this.content);
	},
	
	reading:function( _buf ){
        this.reportid = _buf.ReadLong();
        this.type = _buf.ReadVarInt();
        this.content = _buf.ReadString();
	},

});
////////////////////
// 申请消息记录 //
////////////////////
var ReqChatRecordMessage = cc.Class.extend( {
	ctor:function(){
		this.targetId = null; // 对象id
	},

	getId:function(){
		return 112203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.targetId);
	},
	
	reading:function( _buf ){
        this.targetId = _buf.ReadLong();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(112101, ResChatMessage);
MESSAGE_POOL.Add(112102, ResChatRecordMessage);
MESSAGE_POOL.Add(112103, ResOfflineChatCountMessage);

