var ConvoyModMgr = ConvoyModMgr || cc.Class.extend({
    isDouble: false,
    isHuSong: false,
    monsterId: null,

    leftTime: 0,
    convoyType: 0,
    peroid: 0,
    remainTime: 0,
    convoyConfig: null,
    ctor: function() {},

    RecvResConvoyInfoToClientMessage: function(msg) {
        cc.log("convoy---------------1 " + JSON.stringify(msg));
        this.leftTime = msg.lefttime;
        var panel = Mgr.uiMgr.GetPanelByType(HuSongPanelExt.PanelName);
        if(panel)
            panel.Update();
    },

    RecvResConvoyStatusToClientMessage: function(msg) {
        cc.log("convoy---------------2 " + JSON.stringify(msg));

        this.period = msg.period;
        this.remainTime = msg.remainTime;
        /// 如果状态到0 视为结束
        if(this.period == 0){
            this.OnConvoyEnded()
        }else{
            this.OnConvoyStatusUpdated();
        }
    },

    RecvResConvoyResultToClientMessage: function(msg) {
        cc.log("convoy---------------3 " + JSON.stringify(msg));
        this.leftTime = msg.lefttime;

        this.OnConvoyEnded()

        if (msg.type == 1) {
            var panel = Mgr.uiMgr.ShowPanelByType(HuSongResultExt.PanelName, UIMgr.PANEL_LAYER_POP);
            panel.SetDataInfo(msg);
        } else {
            var panel = Mgr.uiMgr.ShowPanelByType(HuSongDefeatedExt.PanelName, UIMgr.PANEL_LAYER_POP);
            panel.SetTimes(msg.lefttime);
        }
    },

    RecvResConvoyMidToClientMessage: function(msg) {
        cc.log("convoy---------------4 " + JSON.stringify(msg));
        this.convoyType = msg.convoytype;
        this.period = msg.period;

        this.OnConvoyPeroidUpdated();
    },

    SendReqConvoyToGameMessage: function(msg) {
        var msg = new ReqConvoyToGameMessage();
        Mgr.msgMgr.Send(msg);
    },

    SendReqConvoyStartToGameMessage: function(convoytype, auto) {
        this.convoyType = convoytype;
        this.convoyDouble = this.isDouble;

        var msg = new ReqConvoyStartToGameMessage();
        msg.convoytype = convoytype;
        msg.auto = auto;
        Mgr.msgMgr.Send(msg);
    },

    SendReqConvoyDianzanToGameMessage: function(playerid) {
        var msg = new ReqConvoyDianzanToGameMessage();
        msg.playerid = playerid;
        Mgr.msgMgr.Send(msg);
    },

    SendReqConvoyTransferToGameMessage: function(msg) {
        var msg = new ReqConvoyTransferToGameMessage();
        Mgr.msgMgr.Send(msg);
    },

    SendReqConvoyGiveupToGameMessage: function(msg) {
        var msg = new ReqConvoyGiveupToGameMessage();
        Mgr.msgMgr.Send(msg);
    },

    SendReqConvoyOpenMidToGameMessage: function(period) {
        var msg = new ReqConvoyOpenMidToGameMessage();
        msg.period = period;
        Mgr.msgMgr.Send(msg);
    },

    /// 继续完成护送
    ContinueConvoy: function(synPos) {
        if (!this.isHuSong) return;

        var obj = this.GetOrCreateZhanche();
        if (!obj) return;

        if (synPos) {
            obj.x = Mgr.mainPlayer.x;
            obj.y = Mgr.mainPlayer.y;
        }

        var data = JSON.parse(Q_global.Get(1113).q_string_value);
        var npc, sData;
        switch (Mgr.convoy.period) {
            case 1:
                sData = data[1];
                break;
            case 2:
                sData = data[2];
                break;
        }

        npc = Q_npc.Get(sData);

        if (npc) {
            if (npc.q_map == Mgr.sceneMap.nMapId) {
                obj.oCtrlAutoPath.RunToPt(cc.p(npc.q_x, npc.q_y));
                Mgr.mainPlayer.oCtrlAutoPath.RunToPt(cc.p(npc.q_x, npc.q_y), AutoPathParam.CreateSelectNpc(sData));

            } else {
                obj.oCtrlAutoPath.MoveByCrossMap(npc.q_map, cc.p(npc.q_x, npc.q_y));
                Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(
                    npc.q_map, cc.p(npc.q_x, npc.q_y),
                    AutoPathParam.CreateSelectNpc(sData));
            }
        }
    },
    DeleteZhanche: function() {
        Mgr.sceneObj.DeleteObject(Mgr.convoy.monsterId);
    },
    //请求护送
    FlyNpc: function() {
        if (this.isHuSong) return;
        if (Mgr.sceneMap.bChangingState) return;

        var id = JSON.parse(Q_global.Get(1113).q_string_value)[0];
        var npc=Q_npc.Get(id);
        if(npc.q_map == Mgr.sceneMap.nMapId){
            var curPos = Mgr.mainPlayer.GetPixPt();
            var target = ToolMap.GridPt2PixPt(npc.q_x,npc.q_y,true);
            // 同一地图内，并且距离小于1000 走过去
            if(ToolMap.CalcDistance(curPos, target) < 1000){
                this.isFindNpc = true;
                this.CheckFindNpc();
                return true;
            }
        }
        /// 飞过去
        this.isFindNpc = true;
        this.SendReqConvoyTransferToGameMessage();
    },

    CheckInActivityMap:function(){
        var list = JSON.parse(Q_global.Get(1113).q_string_value);
        for(var i=0;i<list.length;++i){
            var npc=Q_npc.Get(list[i]);
            if(npc.q_map == Mgr.sceneMap.nMapId){
                return true;
            }
        }
        return false;
    },

    CheckFindNpc:function(){
        if(!this.isFindNpc) return;
        this.isFindNpc = false;

        var id = JSON.parse(Q_global.Get(1113).q_string_value)[0];
        var npc=Q_npc.Get(id);
        Mgr.mainPlayer.oCtrlAutoPath.RunToPt(cc.p(npc.q_x,npc.q_y),AutoPathParam.CreateSelectNpc(id));
    },

    GetOrCreateZhanche: function() {
        var obj = Mgr.sceneObj.FindObject(Mgr.convoy.monsterId);
        if (!obj) {
            var config = this.convoyConfig
            var monster = Q_monster.Get(config.q_monsterID);

            var mst = new MonsterInfo();
            mst.monsterId = SceneObjUtil.CreateSimSID();
            Mgr.convoy.monsterId = mst.monsterId.toGID();
            mst.monsterModelId = config.q_monsterID;
            mst.speed = monster.q_speed;
            mst.monsterName = monster.q_name;
            mst.mapId = Mgr.sceneMap.nMapId;

            var p = Mgr.mainPlayer.GetGridPt();
            mst.x = p.x;
            mst.y = p.y;

            Mgr.sceneObj.CreateMonster(mst);
        }
        obj = Mgr.sceneObj.FindObject(Mgr.convoy.monsterId);

        return obj;
    },
    // 获取模拟的护送任务信息
    GetConvoyTaskInfo: function() {
        if (this.isHuSong) {
            var data = JSON.parse(Q_global.Get(1113).q_string_value);
            var npc
            switch (Mgr.convoy.period) {
                case 1:
                    npc = Q_npc.Get(data[1]);
                    break;
                case 2:
                    npc = Q_npc.Get(data[2]);
                    break;
            }
            return {
                q_mission_mainType: EnumTaskType.CLIENT_CONVOY,
                title: "【运】护送任务",
                des: "护送到<font color='#76fd56'>" + (npc ? npc.q_name : "终点") + "</font>",
            }
        }
        return null;
    },

    GetConvoyReward:function(){
        var exp = Q_rest.Get(Mgr.mainPlayer.attributeData.level).q_exp;
        var data = JSON.parse(Q_global.Get(1102).q_string_value);
        exp *= data[0];

        var data = JSON.parse(Q_global.Get(1103).q_string_value);
        var gold = data[0].num;

        return { exp : exp, gold : gold};
    },

    GetThisTimeConvoyReward:function(){
        var exp = Q_rest.Get(Mgr.mainPlayer.attributeData.level).q_exp;
        var data = JSON.parse(Q_global.Get(1102).q_string_value);
        exp *= data[0];

        var data = JSON.parse(Q_global.Get(1103).q_string_value);
        var gold = data[0].num;

        if(this.convoyType == 2) {
            exp *= 3;
            gold *= 3;
        }
        if(this.convoyDouble){
            exp *= 2;
            gold *= 2;
        }
        return { exp : exp, gold : gold};
    },


    OnConvoyStarted: function() {
        this.isHuSong = true;
        this.period = 1;

        this.convoyConfig = Q_escort.Get(this.convoyType || 1) || {
            q_id: this.convoyType || 1,
            q_name: "我是这是战车",
            q_speed: 100,
            q_monsterID: this.convoyType || 1 ? 1011 : 1012,

        };
        /// 调整位置，害怕下面报错
        this.ContinueConvoy(true);

        Mgr.task._taskTrackPanel.UpdateTaskTrack();
    },
    OnConvoyPeroidUpdated: function() {
        this.isHuSong = true;
        this.period = 2;

        Mgr.task._taskTrackPanel.UpdateTaskTrack();
        this.ContinueConvoy(true);
    },
    OnConvoyStatusUpdated: function() {
        if (this.remainTime > 0 && !this.isHuSong) {
            this.OnConvoyStarted();
        }

        if (!this.isHuSong) return;

        if (!Mgr.uiMgr.IsPanelShowByName(HusongTimeCueExt.PanelName))
            this.timePanel = Mgr.uiMgr.ShowPanelByType(HusongTimeCueExt.PanelName);

        this.timePanel.UpdateTime(this.remainTime);
    },

    OnConvoyEnded: function() {
        this.isHuSong = false;
        this.convoyType = 1;
        this.convoyDouble = false;

        this.DeleteZhanche();
        Mgr.task._taskTrackPanel.UpdateTaskTrack();

        EngineMgr.uiMgr.HidePanelByType(HusongTimeCueExt.PanelName);
        this.timePanel = null;
        Mgr.map.miniMapPanel.OnActivityEnded();
    },

    OnMapChanged: function() {
        this.CheckFindNpc();
        if (!this.isHuSong) return;
        if (!this.CheckInActivityMap()) return;

        this.ContinueConvoy(true);
    },

    OnMainPlayerChangePosition:function(){
        this.CheckFindNpc();
    },
});