///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//CrossZoneDamageInfo 伤害信息
//CrossZonePanelInfo 跨服组队面板Bean

// 请求消息
//253201,ResCrossZoneFirstAwardFlagFightToGame Boss状态(战斗到原服)
//253202,ReqCrossZonePanel 请求跨服组队副本面板信息

// 接收消息
//253101,ResCrossZoneDamageFightToClient 伤害榜(战斗到客户端)
//253102,ResCrossZoneBossStateFightToClient Boss状态(战斗到客户端)
//253103,ResCrossZonePanel 跨服组队面板


var CrossZoneDamageInfo = cc.Class.extend({
	ctor:function(){
		this.playerName = null; // 玩家姓名
        this.damage = 0; // 伤害
        this.fightPower = 0; // 战斗力
	},

	writing:function( _buf ){
		_buf.WriteString(this.playerName);
        _buf.WriteVarInt(this.damage);
        _buf.WriteVarInt(this.fightPower);
	},
	
	reading:function( _buf ){
		this.playerName = _buf.ReadString();
        this.damage = _buf.ReadVarInt();
        this.fightPower = _buf.ReadVarInt();
	},
});
var CrossZonePanelInfo = cc.Class.extend({
	ctor:function(){
		this.zoneModelId = 0; // 副本ModelId
        this.isOver = 0; // 今日是否通关(0未通关 1通关)
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelId);
        _buf.WriteByte(this.isOver);
	},
	
	reading:function( _buf ){
		this.zoneModelId = _buf.ReadVarInt();
        this.isOver = _buf.ReadByte();
	},
});
////////////////////
// 伤害榜(战斗到客户端) //
////////////////////
var ResCrossZoneDamageFightToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.damageList = []; // 伤害榜 CrossZoneDamageInfo
	},

	getId:function(){
		return 253101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.damageList.length );
        for (var i = 0; i < this.damageList.length; i++) {
            _buf.WriteBean(this.damageList[i]);
        }
	},
	
	reading:function( _buf ){
        var damageList_length = _buf.ReadShort();
        for (var i = 0; i < damageList_length; i++) {
            this.damageList[i] = _buf.ReadBean(CrossZoneDamageInfo);
        }
	},

	action:function(){
		Mgr.crosszone.RecvResCrossZoneDamageFightToClientMessage(this);
	},

});
////////////////////
// Boss状态(战斗到客户端) //
////////////////////
var ResCrossZoneBossStateFightToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelId = 0; // 副本ModelId
        this.allBossIdList = []; // Boss的唯一Id long
        this.allBossModelIdList = []; // BossModelId int
        this.deadBossIdList = []; // 被击杀的BossId long
	},

	getId:function(){
		return 253102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelId);
        _buf.WriteShort( this.allBossIdList.length );
        for (var i = 0; i < this.allBossIdList.length; i++) {
            _buf.WriteLong(this.allBossIdList[i]);
        }
        _buf.WriteShort( this.allBossModelIdList.length );
        for (var i = 0; i < this.allBossModelIdList.length; i++) {
            _buf.WriteVarInt(this.allBossModelIdList[i]);
        }
        _buf.WriteShort( this.deadBossIdList.length );
        for (var i = 0; i < this.deadBossIdList.length; i++) {
            _buf.WriteLong(this.deadBossIdList[i]);
        }
	},
	
	reading:function( _buf ){
        this.zoneModelId = _buf.ReadVarInt();
        var allBossIdList_length = _buf.ReadShort();
        for (var i = 0; i < allBossIdList_length; i++) {
            this.allBossIdList[i] = _buf.ReadLong();
        }
        var allBossModelIdList_length = _buf.ReadShort();
        for (var i = 0; i < allBossModelIdList_length; i++) {
            this.allBossModelIdList[i] = _buf.ReadVarInt();
        }
        var deadBossIdList_length = _buf.ReadShort();
        for (var i = 0; i < deadBossIdList_length; i++) {
            this.deadBossIdList[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.crosszone.RecvResCrossZoneBossStateFightToClientMessage(this);
	},

});
////////////////////
// 跨服组队面板 //
////////////////////
var ResCrossZonePanelMessage = cc.Class.extend( {
	ctor:function(){
		this.panelInfos = []; // 面板Infos CrossZonePanelInfo
        this.remainCount = 0; // 剩余可挑战次数
        this.remainCountEm = 0; // 噩梦模式剩余可挑战次数
	},

	getId:function(){
		return 253103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.panelInfos.length );
        for (var i = 0; i < this.panelInfos.length; i++) {
            _buf.WriteBean(this.panelInfos[i]);
        }
        _buf.WriteVarInt(this.remainCount);
        _buf.WriteVarInt(this.remainCountEm);
	},
	
	reading:function( _buf ){
        var panelInfos_length = _buf.ReadShort();
        for (var i = 0; i < panelInfos_length; i++) {
            this.panelInfos[i] = _buf.ReadBean(CrossZonePanelInfo);
        }
        this.remainCount = _buf.ReadVarInt();
        this.remainCountEm = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.crosszone.RecvResCrossZonePanelMessage(this);
	},

});
////////////////////
// Boss状态(战斗到原服) //
////////////////////
var ResCrossZoneFirstAwardFlagFightToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelId = 0; // 副本ModelId
	},

	getId:function(){
		return 253201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelId);
	},
	
	reading:function( _buf ){
        this.zoneModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求跨服组队副本面板信息 //
////////////////////
var ReqCrossZonePanelMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 253202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(253101, ResCrossZoneDamageFightToClientMessage);
MESSAGE_POOL.Add(253102, ResCrossZoneBossStateFightToClientMessage);
MESSAGE_POOL.Add(253103, ResCrossZonePanelMessage);

