var BuBuGaoShengMainExt = (function(){
    var TMainPlayer = ScenePlayer.extend({
        ctor:function(panel){
            this._super();
            this.$panel = panel;
            this.$locked = false
        },

        Init:function(){
            this._super();

            this.nJobId = 1;
            this.nBodyModelId = 1;
            this.nDisguiseId = 0;
            this.RefreshShowBody();
            this.RefreshShowWep();
            this.nCurDirection = 2;
            this.SetObjectHeightPos(0);
            this.SetScale(1,1);

            this.UpdateWithMainPlayer()
        },

        OnAnimationPlayEnd:function(){
            var t = this.nCurActionType;
            switch(t){
                case EnumActionType.ATTACK:
                case EnumActionType.ATTACK2:
                case EnumActionType.ATTACK3:
                case EnumActionType.ATTACK4:
                case EnumActionType.ATTACK5:
                    this.TryDoStand();
                    if(this._autoAttack)TimerUtil.NextFrame(this.Attack,this);
                    break;
            }

        },

        Attack:function(){
            this._autoAttack = true;
            var fightId = Math.floor(Math.random() * 4) + 2;
            this.SetStateShowAttack(fightId,this.nCurDirection);
            FightUtil.DoRoleBaseSkill(this,fightId);
        },
        EndAttack:function(){
            this._autoAttack = false;
        },
        UpdateWithMainPlayer:function(){
            var self = Mgr.mainPlayer;
            this.nJobId = self.nJobId;
            this.nBodyModelId = self.nBodyModelId;
            this.nWeaponModelId = self.nWeaponModelId;
            this.nBaoqiModelId = self.nBaoqiModelId;
            this.nWingId = self.nWingId;
            this.nDisguiseId = self.nDisguiseId;

            this.RefreshShowBody();
            this.RefreshShowWep();
            this._RefreshGuangyuRes();
        },
        UpdateWithData:function(player){
            this.nJobId = player.job;
            this.nBodyModelId = player.job;
            this.nDisguiseId = 0;

            if(player.brief){
                this.nBodyModelId = player.brief.job;

                for( var i = 0; i < player.brief.reslineInfo.length; i++ ){
                    var resline = player.brief.reslineInfo[i];
                    if( resline.reslineType == EnumResline.GUANGWU )
                        this.UpdateReslineModelid(resline.reslineType,resline.reslineModelId);
                }

                this.nWingId = player.brief.armorShowId;
                this.nDisguiseId = player.brief.disguiseId;

            }else{
                this.nWeaponModelId = 1;
            }

            this.RefreshShowBody();
            this.RefreshShowWep();
            this._RefreshGuangyuRes();
        },

        doFlyIn:function(boxId,callback){
            var p = this.$panel.getPositionByBoxId(boxId)
            this.x = p.x
            this.y = p.y + 500

            this.stopAllActions()
            this.runAction(cc.sequence(
                cc.EaseOut.create(cc.MoveTo.create(1,p),1.5),
                cc.callFunc(function(target){
                    target.SetStateShowStand()
                }),
                cc.callFunc(function(){
                    if(callback) callback()
                })
            ));
            this.SetStateShow(EnumActionType.JUMP_SKY2);
        },
        ///
        doFlyOut:function(callback){
            this.SetStateShow(EnumActionType.JUMP_SKY2);
            this.stopAllActions()
            this.runAction(cc.sequence(
                cc.EaseIn.create(cc.MoveBy.create(1,cc.p(0,500)),1.5),
                cc.callFunc(function(target){
                    target.SetStateShowStand()
                }),
                cc.callFunc(function(){
                    if(callback) callback()
                })
            ));
        },
        doWalkTo:function(oldBoxId,boxId,callback){
            //var p = this.$panel.getPositionByBoxId(boxId)
            var arr = []
            for(let i = oldBoxId;i<=boxId;++i){
                var p = this.$panel.getPositionByBoxId(i)
                arr.push(p)
            }

            var speed = 200
            arr = arr.map((v,k)=>{
                return k == 0 ? cc.moveBy(0,cc.p(0,0))
                    : cc.spawn(
                        cc.callFunc(function(target){
                            target.SetStateShow(EnumActionType.RUN,ToolMap.CalcDirSlant(target.x, -target.y, v.x, -v.y));
                        }),
                        cc.MoveTo.create( ToolMap.CalcDistance(arr[k - 1],v) / speed,v)
                    )
            })
            arr.push(cc.callFunc(function(target){
                target.SetStateShowStand()
            }))
            arr.push(cc.callFunc(function(target){
                if(callback) callback()
            }))

            this.stopAllActions()
            this.runAction(cc.sequence.apply(cc,arr))
        },
    })

    return BuBuGaoShengMain.extend ( {
        _className:"BuBuGaoShengMainExt",
        ctor:function(){
           this._super();
        },

        Init:function(){
            this._super()

            this.gridArr = Array.from({length:23},(v,k)=>this["cell" + (k + 1)])

            this.btnGo.addClickEventListener(this.RequestThrow.bind(this))
            this.btnJia.addClickEventListener(_=>{
                ActivityUtil.OpenGuidePanel(EnumActivityKey.M_BBGS);
            })
            this.btnJiangLi.addClickEventListener(_=>{
                EngineMgr.uiMgr.ShowPanelByType(BuBuGaoShengFrame1Ext.PanelName)
            })
            var tip = UIUtil.AddButtonRedTip(this.btnJia);
            tip.x -= 12;
            tip.y -= 12;
            this.panPreview.setLocalZOrder(10)
        },
        OnShow:function(){
            this._super()
            GameEventMgr.AddEventListener(this,new ResStepDataInfoToClientMessage().getId(),this.UpdateView.bind(this))
            GameEventMgr.AddEventListener(this,new ResThrowResultToClientMessage().getId(),this.doActionThrow.bind(this))
            UIUtil.SetRedTipVisible(this.btnJia.redWarm, ActivityUtil.IsRewardStatus(Mgr.dailyactivity.GetActivityByKey(EnumActivityKey.M_BBGS)));
            this.RequestUpdateView()
        },
        OnHide:function(){
            GameEventMgr.RemoveEventListener(this);
            this._super()
        },

        RequestUpdateView:function(){
            this.setOperationLocked(true)
            Mgr.step.SendReqStepDataInfoToGameMessage()
        },
        RequestThrow:function(){
            if(this.$locked) return;

            this.setOperationLocked(true)
            Mgr.step.SendReqThrowToGameMessage()
        },
        SetActivityList:function(infoList){
            this.OnShow()

            this.UpdateSingleActivity(infoList[0])
        },
        UpdateSingleActivity:function(activity){
            if( activity.tabKey == 302 ){
                var amount = Mgr.step.GetRequestItemAmount()
                UIUtil.ConnectLabelHtmlText(this.labTime1,[amount])

                var activityTime = activity && activity.durationStr || "???"
                UIUtil.ConnectLabelHtmlText(this.labTime,[activityTime])
            }
            UIUtil.SetRedTipVisible(this.btnJia.redWarm, ActivityUtil.IsRewardStatus(Mgr.dailyactivity.GetActivityByKey(EnumActivityKey.M_BBGS)));
        },

        UpdateView:function(){
            var stepDataInfo = Mgr.step.stepDataInfo;

            this.imgNum.SetString(stepDataInfo.layer)

            var defaultUrl = ResUrl.GetDefaultItemUrl();

            stepDataInfo.awardInfos.forEach((v,k)=>{
                var itemIcon = this.getItemIcon(v.mod)
                itemIcon.setAnchorPoint(cc.p(0.5,0.5))
                itemIcon.x = this.gridArr[k + 1].width / 2
                itemIcon.y = this.gridArr[k + 1].height / 2
                this.gridArr[k + 1].removeAllChildren()
                this.gridArr[k + 1].addChild(itemIcon)
            })

            if(!this.playerModel){
                this.playerModel = new TMainPlayer(this);
                this.playerModel.SetStateShow(EnumActionType.STAND);
                this.panPreview.addChild(this.playerModel);
            }

            var param = Mgr.step.throwResultParam
            if(param && param.upgraded){
                this.playerModel.doFlyIn(0,_=>{
                    this.playerModel.doWalkTo(0,param.boxId,_=>{
                        this.setOperationLocked(false)
                        EngineMgr.uiMgr.ShowPanelByType(BuBuGaoShengAwardExt.PanelName)
                    })
                })
            }else{
                this.playerModel.doFlyIn(stepDataInfo.boxId,_=>{
                    this.setOperationLocked(false)
                })
            }
        },

        createAutoFallAction:function(height,jumps){
            var g = 1200.0
            function t(height) {
                return Math.sqrt( height * 2 / g)
            }

            var array = []
            array.push(cc.moveBy(t(height),0,-height).easing(cc.easeSineIn(1.5)))

            var f = 1 / jumps
            for(let i = 1;i<=jumps;++i){
                let h = height * Math.pow(f,i)
                array.push(cc.moveBy(t(h),0,h).easing(cc.easeSineOut()))
                array.push(cc.moveBy(t(h),0,-h).easing(cc.easeSineIn()))
            }
            return cc.sequence.apply(cc,array)
        },

        runActionThrowDice:function(num,callback){
            if(this.$ani){
                this.$ani.removeFromParent()
                this.$ani = null
            }

            var animation = new cc.Animation();
            for (var i = 3; i <= 18; i++) {
                let f = "00000" + i.toString()
                var frameName = "other/huodong/bubugaosheng/animation/" + f.substr(-5,5) + ".png";
                var frame = cc.spriteFrameCache.getSpriteFrame(frameName)
                animation.addSpriteFrame(frame);
            }
            animation.setDelayPerUnit(0.04);
            animation.setRestoreOriginalFrame(false);

            var animal = cc.animate(animation);

            var pp = new cc.Sprite();
            pp.setAnchorPoint(0.5,0.5);
            this.$ani = pp
            this.imgShaizi.parent.addChild(pp);


            var action = cc.repeatForever( animal );
            pp.x = this.imgShaizi.x + this.imgShaizi.width / 2;
            pp.y = this.imgShaizi.y + this.imgShaizi.height / 2 + 100;
            pp.opacity = 0
            pp.runAction(action)
            pp.runAction(cc.spawn(
                cc.fadeIn(0.3)
                ,cc.sequence(this.createAutoFallAction(100,3)
                    ,cc.delayTime(0.5)
                    ,cc.spawn(cc.fadeOut(0.2),cc.scaleTo(0.2,0))
                    ,cc.delayTime(0.1)
                    ,cc.callFunc(function(s){
                        s.stopAction(action)
                        s.setSpriteFrame("other/huodong/bubugaosheng/image/touzi" + num + ".png")
                    })
                    ,cc.spawn(cc.fadeIn(0.2),cc.scaleTo(0.2,1))
                    ,cc.callFunc(function(){
                        if(callback) callback()
                    })
                )
            ));
        },

        getItemIcon:function(mod){
            if(mod == 888){
                var image = new MUIImage()
                UIUtil.LoadImage(image,"other/huodong/bubugaosheng/image/cheng2.png",false,true)
                return image
            }else if(mod == 1002){
                var image = new MUIImage();
                UIUtil.LoadImage(image,"other/huodong/bubugaosheng/image/touzixiao.png",false,true)
                return image
            }else{
                var image = ItemUtil.GetItemIcon(mod);
                image.setScale(46/image.width);
                return image
            }
        },
        getPositionByBoxId:function(boxId){
            var grid = this.gridArr[boxId]
            return cc.p(grid.x + grid.width / 2,grid.y + grid.height / 2)
        },
        doActionThrow:function(){
            var amount = Mgr.step.GetRequestItemAmount()
            UIUtil.ConnectLabelHtmlText(this.labTime1,[amount])

            var param = Mgr.step.throwResultParam

            /// 骰子动画
            this.imgShaizi.visible = false
            //UIUtil.LoadImage(this.imgShaizi,"other/huodong/bubugaosheng/image/touzi" + param.num + ".png")
            this.runActionThrowDice(param.num,_=>{
                if(param.upgraded){
                    this.playerModel.doWalkTo(param.oldBoxId,this.gridArr.length - 1,_=>{
                        this.playerModel.doFlyOut(_=>{
                            this.RequestUpdateView()
                        })
                    })
                }else{
                    this.playerModel.doWalkTo(param.oldBoxId,param.boxId,_=>{
                        this.setOperationLocked(false)
                        EngineMgr.uiMgr.ShowPanelByType(BuBuGaoShengAwardExt.PanelName)
                    })
                }
            })
        },

        setOperationLocked:function(locked){
            this.$locked = locked
        },
    } );
}())

BuBuGaoShengMainExt.PanelName = "BuBuGaoShengMainExt";
PanelClassDic["BuBuGaoShengMainExt"] = BuBuGaoShengMainExt;
