var CommonPanel = CommonPanel || cc.Node.extend({
    cellPanel:null,
    cellList:null,
    totalNum:null,
    activityList:null,

    LoadPanel:function(){
        this.uiWidth = 801;
        this.uiHeight = 503;

        if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.uiWidth, this.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.uiWidth=this.uiWidth;
            tableView.uiHeight=this.uiHeight;
            this.cellPanel=tableView;
            this.addChild(tableView);
        }
    },

    SetActivityList:function (infoList, isOpen) {
        this.activityList = infoList;

        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        this.cellList = ActivityUtil.GetListByCorrelation(this.activityList);
        if( this.cellList.length > 0 ){
            var subType = this.cellList[0].subPanelType;
            if( subType == 13 ){    //天天返利
                this.cellList = ActivityUtil.GetLimitList(this.cellList);
                this.cellList.sort(ActivityUtil.SortByStatus);
            }
        }
        this.totalNum = this.cellList.length;
        if( isOpen ){
            this.cellPanel.reloadData();
        }
        else{
            this.ReloadData();
        }
    },

    UpdateSingleActivity:function(info){
        this.UpdateActivityInfo(false);     //有的不会发简要信息 直接重刷吧
        if(info.subPanelType == 5){//兑换活动
            var acHash = ActivityUtil.GetHashByTabKey(info.mainPanelKey);
            var infoList = acHash.Get(info.tabKey);
            var reqIds = [];
            for(var i = 0, len = infoList.length; i < len; i++) {
                var ac = infoList[i];
                reqIds[i] = ac.activityId;
            }

            Mgr.dailyactivity.SendReqDailyActivitiesDetailedInfoMessage(reqIds);
        }
    }
    ,

    ReloadData:function(){
        for( var i = 0, len = this.cellList.length; i < len; i++ ){
            var cell = this.cellPanel.cellAtIndex(i);
            if( cell && cell.item ){
                cell.item.SetData( this.cellList[i] );
            }
        }
    },

    OnHide:function () {//勿删
    },

    tableCellSizeForIndex: function (table, idx) {
        var vo = this.cellList[idx];
        if(vo.subPanelType == EnumActivityType.S_DOUBLE_RECHARGE){
            return cc.size(805,115);
        }else if(vo.subPanelType == 17){
            return cc.size(791, 497);
        }else {
            return cc.size(805,150);
        }
    },
    tableCellAtIndex: function (table, idx) {
        var item;
        var ac = this.cellList[idx];
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            switch (ac.subPanelType){
                case 1:     //进阶类
                    item = new LeiChongListExt();
                    break;
                case 4:     //每日累充
                    item = new LeiChongListExt();
                    break;
                case 5:     //太极赠礼(兑换)
                    item = new DuihuanListExt();
                    break;
                case 6:     //连续充值
                    item = new LeiChongListExt();
                    break;
                case 8:     //限购商城
                    item = new ZhekouListExt();
                    break;
                case 12:    //双倍充值
                    item = new DanbiMainExt();
                    break;
                case 13:    //天天返利
                    item = new TianTianFanliListExt();
                    break;
                default:
                    item = new JinJieListExt();
                    break;
            }
            item.LoadPanel();
            item.SetData(ac);
            item.setTouchEnabled(false);
            cell.item = item;
            cell.addChild(item);
        }
        cell.item.SetData(ac);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.totalNum;
    }
});
CommonPanel.PanelName = "CommonPanel";
PanelClassDic["CommonPanel"] = CommonPanel;