///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//BossInfo Boss血量信息

// 请求消息
//156201,ReqDemonStarOpen 请求赤贯妖星副本开启
//156202,ReqDemonStarAward 请求本次赤贯妖星通关奖励
//156203,ReqDemonStarInfo 请求赤贯妖星副本信息

// 接收消息
//156101,ResDemonStarInfo 发送赤贯妖星副本信息
//156102,ResDemonStarFinishInfo 发送赤贯妖星副本完成信息
//156103,ResBossInfoToClient 返回副本BOSS信息


var BossInfo = cc.Class.extend({
	ctor:function(){
		this.bossModelid = 0; // BOSSID
        this.hp = 0; // 怪物血量百分比
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.bossModelid);
        _buf.WriteVarInt(this.hp);
	},
	
	reading:function( _buf ){
		this.bossModelid = _buf.ReadVarInt();
        this.hp = _buf.ReadVarInt();
	},
});
////////////////////
// 发送赤贯妖星副本信息 //
////////////////////
var ResDemonStarInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.openId = 0; // 今日开启ID
        this.hard = 0; // 当前最高挑战难度
        this.count = 0; // 今日剩余挑战次数
	},

	getId:function(){
		return 156101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.openId);
        _buf.WriteVarInt(this.hard);
        _buf.WriteVarInt(this.count);
	},
	
	reading:function( _buf ){
        this.openId = _buf.ReadVarInt();
        this.hard = _buf.ReadVarInt();
        this.count = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.demonstar.RecvResDemonStarInfoMessage(this);
	},

});
////////////////////
// 发送赤贯妖星副本完成信息 //
////////////////////
var ResDemonStarFinishInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelId = 0; // 副本ID
        this.time = 0; // 通关时间(秒)
	},

	getId:function(){
		return 156102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelId);
        _buf.WriteVarInt(this.time);
	},
	
	reading:function( _buf ){
        this.zoneModelId = _buf.ReadVarInt();
        this.time = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.demonstar.RecvResDemonStarFinishInfoMessage(this);
	},

});
////////////////////
// 返回副本BOSS信息 //
////////////////////
var ResBossInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.bossInfo = []; // BOSS信息列表 BossInfo
        this.time = 0; // 用时
        this.zoneModelId = 0; // 副本ID
	},

	getId:function(){
		return 156103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.bossInfo.length );
        for (var i = 0; i < this.bossInfo.length; i++) {
            _buf.WriteBean(this.bossInfo[i]);
        }
        _buf.WriteVarInt(this.time);
        _buf.WriteVarInt(this.zoneModelId);
	},
	
	reading:function( _buf ){
        var bossInfo_length = _buf.ReadShort();
        for (var i = 0; i < bossInfo_length; i++) {
            this.bossInfo[i] = _buf.ReadBean(BossInfo);
        }
        this.time = _buf.ReadVarInt();
        this.zoneModelId = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.demonstar.RecvResBossInfoToClientMessage(this);
	},

});
////////////////////
// 请求赤贯妖星副本开启 //
////////////////////
var ReqDemonStarOpenMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelId = 0; // 副本ID
	},

	getId:function(){
		return 156201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelId);
	},
	
	reading:function( _buf ){
        this.zoneModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求本次赤贯妖星通关奖励 //
////////////////////
var ReqDemonStarAwardMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 156202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求赤贯妖星副本信息 //
////////////////////
var ReqDemonStarInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 156203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(156101, ResDemonStarInfoMessage);
MESSAGE_POOL.Add(156102, ResDemonStarFinishInfoMessage);
MESSAGE_POOL.Add(156103, ResBossInfoToClientMessage);

