var HechengMainExt = function() {
    var CellOne = cc.Node.extend({
        ctor: function() {
            this._super();
        },

        UpdateView:function(target,tableView,idx){
            var container = this._container;
            if(!this._container){
                container = UIUtil.CloneUI(target.btnHpGem);
                this.addChild(container);
                container.setTouchEnabled(false);
                container.y = 0;
                container.visible = true;
                this._container = container;
            }

            var data = target.data[idx].data;
            container.sbtn1.setTouchEnabled(false);
            container.sbtn1.SetButtonState(target.selectedMain == data.type ? MUICheckBox.STATE_CHECK : MUICheckBox.STATE_UNCHECK);
            container.imgHpGem.SetText(data.name);
            container.imgtanhao.visible = DuanzaoUtil.IsItemComposableWithinCondition(EnumItemForgeType.STONE,data.type);
        },
    });
    var CellTwo = cc.Node.extend({
        ctor: function() {
            this._super();
        },
        UpdateView:function(target,tableview,idx){
            if(!this.mainView){
                var item = new HechengFrameExt();
                item.LoadPanel();
                item.x = 50;
                this.addChild(item);
                this.mainView = item;
            }

            var itemForgeC = target.data[idx].data;
            var itemId = itemForgeC.q_item_id;
            var itemC = Q_item.Get(itemId);

            //this.mainView.SetSelect(target.selectedSub == data.type);

            this.mainView.SetName(itemC.q_name);
            this.mainView.SetWarn(DuanzaoUtil.IsItemComposableWithConfig(itemForgeC));
            this.mainView.SetSelect(target.selectedItem.q_item_id == itemId);
        },

    });
    var CellThree = cc.Node.extend({
        ctor: function() {
            this._super();
        },
        UpdateView:function(target,tableview,idx){
            if(!this.labelDes){
                var label = new MUILabel();
                label.SetFontSize(20);
                label.SetText("????????");
                label.SetColor("0x000000");
                label.x = 70,
                label.y = 20,
                this.addChild(label);
                this.labelDes = label;
            }

            var itemForgeC = target.data[idx].data;

            var itemId = itemForgeC.q_item_id;
            var itemC = Q_item.Get(itemId);

            var composable = DuanzaoUtil.IsItemComposableWithConfig(itemForgeC);
            this.labelDes.SetText(itemC.q_name + (composable ? "(可合成)" : ""));
            this.labelDes.SetColor(target.selectedItem.q_item_id == itemId ? "0x01ab25" : "0x000000");
        },
    });
    var Cell = cc.Node.extend({
        ctor: function() {
            this._super();
        },
        UpdateView: function(sender,tableview,idx) {
            //if (this._cell1) this._cell1.visible = false;
            //if (this._cell2) this._cell2.visible = false;
            //if (this._cell3) this._cell3.visible = false;

            this._cell1 = null;
            this._cell2 = null;
            this._cell3 = null;
            this.removeAllChildren();

            var data = sender.data[idx];

            var cell;
            switch(data.category){
                case 1 :
                    if(!this._cell1){
                        this._cell1  = new CellOne();
                        this.addChild(this._cell1);
                    }
                    cell = this._cell1;
                    break;
                default :
                    if(!this._cell2){
                        this._cell2  = new CellTwo();
                        this.addChild(this._cell2);
                    }
                    cell = this._cell2;
                    break;
                //default :
                //    if(!this._cell3){
                //        this._cell3  = new CellThree();
                //        this.addChild(this._cell3);
                //    }
                //    cell = this._cell3;
                //    break;
            }
            cell.visible = true;
            cell.UpdateView.apply(cell,arguments);
        },
    });

    var HechengMainExt = HechengMain.extend({
        _className: "HechengMainExt",
        ctor: function() {
            this._super();
            this.effects_stone = [];
            this.effects_equip = [];
        },

        tableCellSizeForIndex: function(table, idx) {
            var data = this.data[idx];
            var height = 0;
            switch(data.category){
                case 1: height = 86;break;
                default : height = 82;break;
                //case 3: height = 50;break;
            }
            return cc.size(table.width, height);
        },
        tableCellAtIndex: function(table, idx) {
            var cell = table.dequeueCell();
            if (!cell) {
                cell = new cc.TableViewCell();
            }

            if (!cell.item) {
                cell.item = new Cell();
                cell.addChild(cell.item)
            }
            cell.item.UpdateView(this,table,idx);

            return cell;
        },
        tableCellTouched: function(table, cell) {
            var index = cell.getIdx();
            var data = this.data[index];

            /// 用于优化界面选择
            this.selectedData = data;

            switch(data.category){
                case 1:
                    this.selectedSub = this.selectedMain == data.data.type ? -2 : this.selectedSub;
                    this.selectedMain = this.selectedMain == data.data.type ? -2 : data.data.type;
                    this.ReloadData();
                break;
                case 2:
                    this.selectedSub = this.selectedSub == data.data.type ? -2 : data.data.type;
                    this.ReloadData();
                break;
                default:
                    this.selectedItem = data.data;
                    this.ReloadData();
                    this.UpdateSelectedItem();
                break;
            }

        },
        numberOfCellsInTableView: function(table) {
            return this.data ? this.data.length : 0;
        },
        ReloadData:function(force) {
            var viewSize = this.tableView.getViewSize();
            var oldOffset = this.tableView.getContentOffset();
            var oldSize = this.tableView.getContentSize();

            var y = viewSize.height - oldSize.height - oldOffset.y;

            /// 数据刷新
            this._ReloadData(force);

            /// 位置偏移的自动适应
            var offset = this.tableView.getContentOffset();
            var size = this.tableView.getContentSize();
            do{
                // 小于viewSize则必须这么大
                if(viewSize.height >= size.height){
                     offset.y = viewSize.height - size.height;
                     break;
                }

                /// 模拟自动选择
                var selectedData = force ? {category : 3,data : this.selectedItem, id:this.selectedItem.q_item_id} :this.selectedData;
                /// 如果是先选3级按钮，恢复不变
                if(!force && selectedData.category == 3){
                    offset.y = oldOffset.y;
                    break;
                }

                /// 其他选中的直接网往上顶
                var yTop = 0;
                var findCell = false;
                for(var i=0;i!=this.data.length;++i){
                    var v = this.data[i];
                    var tempSize = this.tableCellSizeForIndex(this.tableView,i);
                    if(v.category == selectedData.category && v.id == selectedData.id){
                        findCell = true;
                        break;
                    }
                    yTop += tempSize.height;;
                }
                /// 没找到就算了
                if(!findCell) break;

                /// 不再可视范围内
                offset.y = viewSize.height - size.height + yTop;

                // 范围修正
                var range = [viewSize.height - size.height,0]
                offset.y = Math.min(range[1],Math.max(offset.y,range[0]));
            }while(false);
            this.tableView.setContentOffset(offset);
        },

        _ReloadData:function(force) {
            this.selectedMain = this.selectedMain || -1;
            this.selectedSub = this.selectedSub || -1;
            var selectedItem = this.selectedItem;

            //var list = DuanzaoUtil.FilterItemForgeWithConfig(EnumItemForgeType.STONE);
            var list = DuanzaoUtil.FilterItemForgeWithConfig(this.forgeType);

            // 组织数据
            var root = {};
            list.forEach(v=>{
                let types = [
                    {type : v.q_level, name : v.q_name},
                    // {type : v.q_second_type, name : v.q_second_name},
                    // {type : v.q_third_type, name : v.q_third_name},
                ]

                let itr = root;
                types.forEach((vv,kk)=>{
                    if(!itr[vv.type]){
                        itr[vv.type] = {
                            type : vv.type,
                            name : vv.name,
                            data : kk == types.length - 1 ? [] : {},
                        }
                    }

                    itr = itr[vv.type].data;
                })

                let itemId = v.q_item_id;
                let itemC = Q_item.Get(itemId);

                itr.push(v);
            })

            /// 强制刷新，并择优
            if(force){
                this.selectedItem = null;

                let autoSelect = list.find(v=>DuanzaoUtil.IsItemComposableWithConfig(v)) || list[0];

                if(autoSelect){
                    selectedItem = autoSelect;
                    this.selectedMain = autoSelect.q_level;
                    this.selectedSub =  autoSelect.q_level;
                }
            }
            /// 如果无优择一
            var array = [];
            for(var k in root){
                var v = root[k];

                array.push({
                    category : 1,
                    data : v,
                    id : v.type,
                })

                if(this.selectedMain == -1) this.selectedMain = v.type;
                if(this.selectedMain != v.type) continue;


                v.data.forEach(vv=>{

                    array.push({
                        category : 3,
                        data : vv,
                        id : vv.q_item_id,
                    })
                })

//                for(var kk in v.data){
//                    var vv = v.data[kk];
//                    array.push({
//                        category : 2,
//                        data : vv,
//                        id : vv.type,
//                    })
//
//                    if(this.selectedSub == -1) this.selectedSub = vv.type;
//                    if(this.selectedSub != vv.type) continue;
//
//                    for(var i=0;i!=vv.data.length;++i){
//                        if(!selectedItem) selectedItem = vv.data[i];
//                        array.push({
//                            category : 3,
//                            data : vv.data[i],
//                            id : vv.data[i].q_item_id,
//                        })
//                    }
//                }
            }

            if(selectedItem != this.selectedItem){
                this.selectedItem = selectedItem;
                this.UpdateSelectedItem(force);
            }

            this.data = array;
            this.tableView.reloadData();
        },

        UpdateSelectedItem:function(force){
            var itemForgeC = this.selectedItem;

            this.imgBg1.visible = false;
            this.imgBg.visible = false;
            if(!itemForgeC) return;

            /// 隐藏已有的特效
            var beStone = itemForgeC.q_main_type == EnumItemForgeType.STONE;
            if(force || this.beStone !== beStone){
                this.StopEffect();
                this.StartEffect(beStone);
                this.beStone = beStone;
            }

            beStone ? this.UpdateSelectedStone(itemForgeC) : this.UpdateSelectedEquip(itemForgeC);
        },

        UpdateSelectedStone:function(itemForgeC){
            this.imgBg1.visible = true;

            this.labCue1.visible = true;
            this.labCue.SetText("合成高级宝石可增加大量战力");
            var itemC = Q_item.Get(itemForgeC.q_item_id);
            this._SetHecheng(itemC.q_location, itemC.q_rank);
        },
        UpdateSelectedEquip:function(itemForgeC){
            this.imgBg.visible = true;

            this.labCue1.visible = false;
            this.labCue.SetText("三件相同装备可合成更高级的装备");

            var bind = false;
            var condition = DuanzaoUtil.GetItemForgeCondition(itemForgeC);
            for(var k in condition){
                var itemList = Mgr.backpack.GetItemsByMid(k, true);
                for (var j = 0; j != itemList.length; j++) {
                    if (itemList[j].itemBind == 1){
                        bind = true;
                        break;
                    }
                }
            }

            // 目标
            do{
                var itemC = Q_item.Get(itemForgeC.q_item_id);
                if(!itemC) break;

                UIUtil.ConnectLabelHtmlText(this.labName,[itemC.q_name]);
                UIUtil.ConnectLabelHtmlText(this.labLv211,[itemC.q_rank]);

                var item = ItemUtil.ItemIdToItem(itemC.q_id, 1, bind ? 1 : 0);

                GridUtil.SetItemGrid(this.gridItem11,   item, null, null, null, false,false);
            }while(false);
            // 材料1
            do{
                var requiredItemC1 = Q_item.Get(itemForgeC.q_material_main);
                if(!itemC) break;

                UIUtil.ConnectLabelHtmlText(this.labGgongji111,[requiredItemC1.q_name]);
                UIUtil.ConnectLabelHtmlText(this.labLv2111,[requiredItemC1.q_rank]);
                var hold1 = Mgr.backpack.GetItemNumber(itemForgeC.q_material_main);
                UIUtil.ConnectLabelHtmlText(this.labNumber11,[hold1,itemForgeC.q_material_main_num]);
                var item1 = ItemUtil.ItemIdToItem(requiredItemC1.q_id, 1, bind ? 1 : 0);
                GridUtil.SetItemGrid(this.gridItem111,  item1, null, null, null, false,false);
            }while(false);

            // 材料2
            do{
                var requiredItemC2 = Q_item.Get(itemForgeC.q_material_minor_one);
                if(!requiredItemC2){
                    this.gridItem2.Clean();
                    this.labGgongji2.visible = false;
                    this.labLv22.visible = false;
                    this.labNumber2.visible = false;
                    break;
                }
                this.labGgongji2.visible = true;
                this.labLv22.visible = true;
                this.labNumber2.visible = true;

                UIUtil.ConnectLabelHtmlText(this.labGgongji2,[requiredItemC2.q_name]);
                UIUtil.ConnectLabelHtmlText(this.labLv22,[requiredItemC2.q_rank]);
                var hold2 = Mgr.backpack.GetItemNumber(itemForgeC.q_material_minor_one);
                UIUtil.ConnectLabelHtmlText(this.labNumber2,[hold2,itemForgeC.q_material_minor_one_num]);

                var item2 = ItemUtil.ItemIdToItem(requiredItemC2.q_id, 1, bind ? 1 : 0);
                GridUtil.SetItemGrid(this.gridItem2,    item2, null, null, null, false,false);
            }while(false);

            // 材料3
            do{
                var requiredItemC3 = Q_item.Get(itemForgeC.q_material_minor_two);
                if(!requiredItemC3){
                    this.gridItem3.Clean();
                    this.labGgongji3.visible = false;
                    this.labLv23.visible = false;
                    this.labNumber3.visible = false;
                    break;
                }
                this.labGgongji3.visible = true;
                this.labLv23.visible = true;
                this.labNumber3.visible = true;

                UIUtil.ConnectLabelHtmlText(this.labGgongji3,[requiredItemC3.q_name]);
                // 等级
                UIUtil.ConnectLabelHtmlText(this.labLv23,[requiredItemC3.q_rank]);
                // 数量
                var hold3 = Mgr.backpack.GetItemNumber(itemForgeC.q_material_minor_two);
                UIUtil.ConnectLabelHtmlText(this.labNumber3,[hold3,itemForgeC.q_material_minor_two_num]);

                var bind = false;
                var item3 = ItemUtil.ItemIdToItem(requiredItemC3.q_id, 1, bind ? 1 : 0);
                GridUtil.SetItemGrid(this.gridItem3,    item3, null, null, null, false,false);
            }while(false);

            //attr
            var attrV = DuanzaoUtil.GetAttributeV(itemC.q_id, itemC.q_rank);

            str = String(attrV.str) + "+" + String(attrV.value);
            this.labGgongji11.SetString(str);
        },

        Init: function() {
            var self = this;
            HechengMain.prototype.Init.call(this);
            this.AddEffect();

            // init
            this.labLv211.setLocalZOrder(0xFFFFFFF);
            this.labLv2111.setLocalZOrder(0xFFFFFFF);
            this.labLv22.setLocalZOrder(0xFFFFFFF);
            this.labLv23.setLocalZOrder(0xFFFFFFF);
            this.labNumber11.setLocalZOrder(0xFFFFFFF);
            this.labNumber2.setLocalZOrder(0xFFFFFFF);
            this.labNumber3.setLocalZOrder(0xFFFFFFF);

            this.btnHpGem.visible = false;
            this.btnFangyuGem.visible = false;
            this.btnGongjiGem.visible = false;

            /// MMP 为啥子策划那么日白
            var tableView = new cc.TableView(this, cc.size(this.imgShade.uiWidth, this.imgShade.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            this.imgShade.addChild(tableView);
            this.tableView = tableView;

            this.btnShengji.addClickEventListener(function(event) {
                // 一键合成,是把当前选择的全部合成
                self._Compose(true);
            })

            // 合成
            this.btnXiangqian.addClickEventListener(function(event) {
                self._Compose();
            })

            // label链接
            this.labCue1.setTouchEnabled(true);
            this.labCue1.addTouchEventListener(function(sender, type) {
                if (type == ccui.Widget.TOUCH_BEGAN) {
                    sender.setScale(1.01);
                } else if (type == ccui.Widget.TOUCH_ENDED) {
                    sender.setScale(1.0);
                    Mgr.uiMgr.ShowPanelByType(QianghuaMetrialGetRouteExt.PanelName);
                } else if (type == ccui.Widget.TOUCH_CANCELED) {
                    sender.setScale(1.0);
                }
            });
        },
        InitSubTabConfig:function(){
            return [
                { type : EnumItemForgeType.STONE	,text : "宝石列表" },
                { type : EnumItemForgeType.EQUIP_PLAYER	,text : "角色装备" },
                { type : EnumItemForgeType.EQUIP_SHUTONG	,text : "书童装备" },
            ]
        },
        OnShow:function(){
            this._super();
            this.AddEffect();

            GameEventMgr.AddEventListener(this,EnumEventType.GAME_REFINING_RESULT,function(){
               this.SetData();
            })
        },
        OnHide:function(){
            this._super();
            this.StopEffect();

            GameEventMgr.RemoveEventListener(this);
        },
        _Compose:function(allin){
            var itemForgeC = this.selectedItem;

            if(!itemForgeC){
                Mgr.tips.ShowNotice("请选则要合成的物品！！！");
                return;
            }
            if (!DuanzaoUtil.IsItemComposableWithConfig(itemForgeC)) {
                Mgr.tips.ShowNotice("合成材料不足！！！");
                return;
            }

            var condition = DuanzaoUtil.GetItemForgeCondition(itemForgeC);
            var itemModel = itemForgeC.q_item_id;
            var itemIdList = [];

            var handleType = (this.forgeType == EnumItemForgeType.STONE ? 0 : 2); // 0普通合成(后端自己检测) 1装备合成装备(手动放置)

            var mixCompose = 0; ////全绑
            var num = 0xFFFFFF;
            for(var kk in condition){
                var bagList = Mgr.backpack.GetItemsByMid(kk, true);
                var count = 0;
                var bindCount = 0;
                var normalCount = 0;
                for (var j = 0; j != bagList.length; j++) {
                    var v = bagList[j];
                    count += v.itemNum;
                    if (v.itemBind == 1) {
                        bindCount += v.itemNum;
                    } else {
                        normalCount += v.itemNum;
                    }
                }

                var needCount = condition[kk];
                if(bindCount % needCount != 0){
                    if( bindCount % needCount + normalCount >= needCount
                        && (!allin || (allin && Math.floor(bindCount / needCount) < 1)))
                        mixCompose = 2;
                }
                else{
                    mixCompose = 1; //全不绑
                }

                num  = Math.min(num,Math.floor(count / needCount));
                if( handleType ){
                    for (var j = 0; j != bagList.length && j != num * needCount; j++) {
                        var v = bagList[j];
                        if (v.itemBind == 1 || mixCompose > 0) {
                            itemIdList.push(bagList[j].itemId);
                        }
                    }
                }
            }

            // 全部合成
            num = allin ? num : 1;

            if(mixCompose == 2){
                var str = "当前合成的物品中有绑定物品，合成新的物品也将成为绑定物品，是否进行合成？";
                AlertExt.Show(str, TipsEnum.BUTTON_SURE_AND_FALSE, {
                    _onFunc: function() {
                        this.Compose(handleType, itemModel,num,itemIdList);
                    }.bind(this),
                    _offFunc: function() {}
                });
            }else{
                this.Compose(handleType, itemModel,num,itemIdList);
            }
        },

        Compose: function(handleType, itemModel,count,itemIdList) {
            Mgr.refining.SendReqComposeGodEquipMessage(handleType, itemModel, count, itemIdList);
        },

        AddEffect: function() {
            if(this.effects_stone.length) return;

            // effect
            var url = "other/duanzhao/image/effect/compose/star.png";
            var effect_star = ParticleEffect.Create(this.imgEffect, url, 1, 300, 90, 120);
            effect_star.SetRotate(1.0, 30);
            effect_star.SetFade(0.2, 0.6);
            effect_star.SetRadiusRandomShow();
            this.effects_stone.push(effect_star);

            url = "other/duanzhao/image/effect/compose/fog.png";
            var effect_flog = ParticleEffect.Create(this.imgEffect1, url, 4, 1500, 0, 180);
            effect_flog.SetFade(0.3, 0.7);
            effect_flog.SetMove(1);
            effect_flog.SetRadiusRandomShow();
            effect_flog.SetAngle(30, 0);
            this.effects_stone.push(effect_flog);

            effect_flog = ParticleEffect.Create(this.imgEffect1, url, 4, 1500, 0, 180);
            effect_flog.SetFade(0.3, 0.7);
            effect_flog.SetMove(1);
            effect_flog.SetRadiusRandomShow();
            effect_flog.SetAngle(160, 0);
            this.effects_stone.push(effect_flog);

            // effect
            var url = "other/duanzhao/image/effect/compose/star.png";
            var effect_star = ParticleEffect.Create(this.imgEffect11, url, 1, 300, 90, 120);
            effect_star.SetRotate(1.0, 30);
            effect_star.SetFade(0.2, 0.6);
            effect_star.SetRadiusRandomShow();
            this.effects_equip.push(effect_star);

            url = "other/duanzhao/image/effect/compose/fog.png";
            var effect_flog = ParticleEffect.Create(this.imgEffect111, url, 4, 1500, 0, 180);
            effect_flog.SetFade(0.3, 0.7);
            effect_flog.SetMove(1);
            effect_flog.SetRadiusRandomShow();
            effect_flog.SetAngle(30, 0);
            this.effects_equip.push(effect_flog);

            effect_flog = ParticleEffect.Create(this.imgEffect111, url, 4, 1500, 0, 180);
            effect_flog.SetFade(0.3, 0.7);
            effect_flog.SetMove(1);
            effect_flog.SetRadiusRandomShow();
            effect_flog.SetAngle(160, 0);
            this.effects_equip.push(effect_flog);
        },

        StartEffect:function(beStone){
            var list = beStone ? this.effects_stone : this.effects_equip;
            for (var i = 0; i != list.length; i++) {
                list[i].Play();
            }
        },

        StopEffect: function() {
            for (var i = 0; i != this.effects_stone.length; i++) {
                this.effects_stone[i].Dispose();
            }
            for (var i = 0; i != this.effects_equip.length; i++) {
                this.effects_equip[i].Dispose();
            }
        },

        SetData: function(forgeType) {
            this.forgeType = forgeType || this.forgeType
            this.ReloadData(true);
        },

        //基础逻辑
        _SetHecheng: function(stoneType, lv) {
            var MetrialStoneC = null;
            var stoneC = null;
            var list = DuanzaoUtil.GetStoneByType(EnumItemType.GEM, stoneType);
            for (var i = 0; i != list.length; i++) {
                if (list[i].q_rank == (lv - 1)) // lv 最小2级开始
                    MetrialStoneC = list[i];
                else if (list[i].q_rank == lv)
                    stoneC = list[i];
            }
            var stonelist = Mgr.backpack.GetItemsByMid(MetrialStoneC.q_id, true);
            var bind = false;
            for (var j = 0; j != stonelist.length; j++) {
                if (stonelist[j].itemBind == 1)
                    bind = true;
            }

            this._SetMatrialGrid(this.gridItem1, MetrialStoneC, bind);
            this._SetHcGrid(this.gridItem, stoneC, bind);
        },

        _SetMatrialGrid: function(grid, stoneC, bind) {
            grid.Clean();
            if (stoneC) {
                var item = ItemUtil.ItemIdToItem(stoneC.q_id, 1, bind ? 1 : 0);
                GridUtil.SetItemGrid(grid, item, null, null, null, false, false);
                grid.data = stoneC;

                // lv
                grid.reorderChild(this.labLv21, 3);
                var str = (stoneC.q_rank).toString() + "级";
                this.labLv21.SetString(str);

                // number
                grid.reorderChild(this.labNumber, 3);
                grid.reorderChild(this.labNumber1, 3);
                var count = Mgr.backpack.GetItemNumber(stoneC.q_id, true);
                this.labNumber.SetString("/3");

                this.labNumber1.SetString(count);
                if (count < 3)
                    this.labNumber1.SetColor("0xEE0000");
                else
                    this.labNumber1.SetColor("0xffffff");

                //attr
                var attrV = DuanzaoUtil.GetAttributeV(stoneC.q_id, stoneC.q_rank);
                str = String(attrV.str) + "+" + String(attrV.value);
                this.labGgongji1.SetString(str);
            }
        },

        _SetHcGrid: function(grid, stoneC, bind) {
            grid.Clean();
            if (stoneC) {
                var item = ItemUtil.ItemIdToItem(stoneC.q_id, 1, bind ? 1 : 0);
                GridUtil.SetItemGrid(grid, item, null, null, null, false);
                grid.data = stoneC;

                // lv
                var str = (stoneC.q_rank).toString() + "级";
                this.labLv2.SetString(str);
                grid.reorderChild(this.labLv2, 3);

                //attr
                var attrV = DuanzaoUtil.GetAttributeV(stoneC.q_id, stoneC.q_rank);
                str = attrV.str + "+" + String(attrV.value);
                this.labGgongji.SetString(str);
            }
        },
    });

    return HechengMainExt;
}();
HechengMainExt.PanelName = "HechengMainExt";
PanelClassDic["HechengMainExt"] = HechengMainExt;