var QianhuaMainExt = QianhuaMain.extend ( {
	_className:"QianhuaMainExt",

	_gridArr : null,

	_curSelector:null,

	// star
	_lvToStar:5,  // 几级一颗星
	_maxStar : 5,  // 最大星数
	_starArr : null,

	// 自动升级key
	autoUp : null,

	// effect
	effects:null,
	_orginPt:null,

	ctor:function(){
		this._super();

		this._gridArr = [];
		this._starArr = [];
		this.autoUp = false;
		this.effects = [];
		this._orginPt = new cc.p();
	},

	Init:function()
	{
		QianhuaMain.prototype.Init.call(this);

		this._InitParam();
		this._RegisterListeners();

	},
    InitSubTabConfig:function(){
        return [
            { type : EnumItemType.Equip	,text : "角色" },
            { type : EnumItemType.Equip_Shutong	,text : "书童" },
        ]
    },
    OnShow:function(){
        this._super();
        this.AddEffect();
    },
    OnHide:function(){
        this._super();
        this.StopEffect();
    },
	_RegisterListeners:function () {
		var self = this;
		this.btnQianghua.addClickEventListener(function (event){
			self._ChangeAutoUpState(false);
			self.SendEquipStrengh();
		});
		this.btnQianghua1.addClickEventListener(function (event){
			self._ChangeAutoUpState(true);
			self.SendEquipStrengh();
		});
		this.btnQuxiao.addClickEventListener(function (event){
			self._ChangeAutoUpState(false);
		});

		this.sbtnGouxuan.setTouchEnabled(true);
		this.sbtnGouxuan.addTouchEventListener(function (sender, type) {
			if (type == ccui.Widget.TOUCH_ENDED) {
				var boo = self._GetAuoBuyState();
				if (boo)
					sender.SetButtonState("uncheck");
				else
					sender.SetButtonState("check");
				Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).UpDataDuanzhaoWarn(DuanzaoTypeEnum.EQUIP_UP);
			}
		});
	},

	AddEffect:function () {
		// effect
		var url = "other/duanzhao/image/effect/inlay/star.png";
		var effect_star = ParticleEffect.Create(this.imgEffect1,url,1,300,90,120);
		effect_star.SetRotate(1.0 , 30);
		effect_star.SetFade(0.2,0.6);
		effect_star.SetRadiusRandomShow();
		effect_star.Play();
		this.effects.push(effect_star);

		url = "other/duanzhao/image/effect/inlay/fog.png";
		var effect_flog = ParticleEffect.Create(this.imgEffect2,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(30,0);
		effect_flog.Play();
		this.effects.push(effect_flog);

		effect_flog = ParticleEffect.Create(this.imgEffect2,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(160,0);
		effect_flog.Play();
		this.effects.push(effect_flog);

		var effect_ani = new MAnimationObject();
		effect_ani.sResUrlBase = "res/animation/swf/duanzao/1/";
		effect_ani.DoAction("stand5", 0, EnumDefaultResType.NONE);
		this.imgEffect3.addChild(effect_ani,0, 100);
		this.effects.push(effect_ani);

		this.imgRond.setAnchorPoint(0.5,0.5);
		this.imgRond.setPosition(this._orginPt);
		var actLoop=cc.Spawn(cc.ScaleTo(0,0.6),cc.FadeIn(0));
		var actLoop1=cc.Spawn(cc.ScaleTo(1.5,1),cc.FadeOut(1.5));
		var seques=cc.Sequence(cc.DelayTime(2),actLoop,actLoop1);
		this.imgRond.runAction(cc.repeatForever(seques));

		// // animal
		// var effect_ani = AnimationEffect.Create(this.imgEffect,12);
		// effect_ani.Play();
	},

	StopEffect:function () {
		for ( var i = 0; i != this.effects.length; i++ ) {
			this.effects[i].Dispose();
		}
		this.effects = [];
		this.imgRond.stopAllActions();
		for ( var i = 0; i != this._gridArr.length; i++ ) {
			var grid = this._gridArr[i].obj;
			this._EndWarn(grid);
		}
	},

	_InitPosition:function () {
		this.x = 0;
		this.y = 0;
	},

	_SetLabelLink:function () {
		this.labCue5.setTouchEnabled(true);
		this.labCue5.addTouchEventListener(function(sender,type)
		{
			if ( type == ccui.Widget.TOUCH_BEGAN )
			{
				sender.setScale(1.01);
			}
			else if ( type == ccui.Widget.TOUCH_ENDED )
			{
				sender.setScale(1.0);
				Mgr.uiMgr.ShowPanelByType(QianghuaMetrialGetRouteExt.PanelName);
			}
			else if ( type == ccui.Widget.TOUCH_CANCELED )
			{
				sender.setScale(1.0);
			}
		});
	},

	_InitParam:function(){
		this._InitPosition();
		this._SetLabelLink();

		// 默认不勾选
		this.sbtnGouxuan.SetButtonState( "uncheck" );

		this.imgRond.opacity = 0;
		this._orginPt.x = this.imgRond.x + this.imgRond.width/2;
		this._orginPt.y = this.imgRond.y + this.imgRond.height/2;

		this.imgSelect.visible = false;
		this.lab1.visible = false;
		this.imgQianghua.visible = false;

		this._starArr = [this.imgStar11, this.imgStar21, this.imgStar31, this.imgStar41, this.imgStar51];
		this._gridArr = [
			{obj:this.gridEquip1,type:EnumEquipPos.EQUIP_WEAPONS},//武器0
			{obj:this.gridEquip2,type:EnumEquipPos.EQUIP_CLOTHES},//衣服1
			{obj:this.gridEquip3,type:EnumEquipPos.EQUIP_BRACELET_LEFT},//护手
			{obj:this.gridEquip4,type:EnumEquipPos.EQUIP_HUFU_LEFT}, //左护符6
			{obj:this.gridEquip5,type:EnumEquipPos.EQUIP_RING_LEFT}, //左戒指8
			{obj:this.gridEquip6,type:EnumEquipPos.EQUIP_BELT},//腰带3
			{obj:this.gridEquip7,type:EnumEquipPos.EQUIP_HUTUI},//护腿
			{obj:this.gridEquip8,type:EnumEquipPos.EQUIP_SHOES}, //鞋子5
			{obj:this.gridEquip9,type:EnumEquipPos.EQUIP_HUFU_RIGHT}, //右护符7
			{obj:this.gridEquip10,type:EnumEquipPos.EQUIP_RING_RIGHT} //右戒指9
		];
	},

	SetData:function (itemType) {
        itemType = itemType || this._itemType;
        if(this._itemType != itemType){
            this.gridEquipC.equipV = null;
        }
        this._itemType = itemType;

        this.SetEquips();
        if (this.gridEquipC.equipV)
            this.SetCenterEquip();
        else
            this._AutoSelect();   // 每次打开界面均自动选者
	},

	SetEquips:function()
	{
		for ( var i = 0; i < this._gridArr.length; i++ ) {
			var equipV = Mgr.equip.GetEquipByType(this._itemType,this._gridArr[i].type);
			this._SetEquip( this._gridArr[i].obj, equipV );

			// 及时更新部位装备 , 更换装备的情况
			if ( this.gridEquipC.equipV ) {
				var temp = Q_item.Get(this.gridEquipC.equipV.itemModelId);
				if ( temp.q_kind == this._gridArr[i].type )
					this.gridEquipC.equipV = equipV;
			}

		}
		this.UpdataWarn();
	},

	_SetEquip:function ( grid, equipV ) {
		grid.Clean();
        grid.equipV = equipV;

		if ( equipV ) {
			// ico
			// var icon = ItemUtil.GetItemIcon(equipV.itemModelId)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            var coinInfo = {};
            coinInfo.itemModelId = equipV.itemModelId;
            // coinInfo.itemNum = price;
            // coinInfo.itemBind = itemInfo.q_bind;
            GridUtil.SetItemGrid(grid,coinInfo, null, null, null, false);

			// level
			if (equipV.strenthenLv > 0) {
				var level = new MUILabel();
				level.ParseJson(this.lab1.jsonobj);
				level.Init();
				var str = "+" + String(equipV.strenthenLv);
				level.SetString(str);
				level.setPosition(this.lab1.getPosition());
				grid.AddDisplay(level);
			}
		}
		// callback
		var self = this;
		grid.setTouchEnabled(true);
		grid.addTouchEventListener(function (sender, type) {
			if (type == ccui.Widget.TOUCH_ENDED) {
				if ( sender.equipV ) {
					if ( self._curSelector )
						self._SetSelectEffect( self._curSelector, false )

					self._curSelector = sender;
					self._SetSelectEffect( sender, true )

					self.gridEquipC.equipV = sender.equipV;
					self.SetCenterEquip();
				}
				else
					Mgr.tips.ShowNotice( "没有装备!");
			}
		});
	},

	SetCenterEquip:function() {
		var grid = this.gridEquipC;
		grid.Clean();
		if ( grid.equipV ) {
			// ico
			// var icon = ItemUtil.GetItemIcon(grid.equipV.itemModelId)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            var coinInfo = {};
            coinInfo.itemModelId = grid.equipV.itemModelId;
            // coinInfo.itemNum = price;
            // coinInfo.itemBind = itemInfo.q_bind;
            GridUtil.SetItemGrid(grid,coinInfo, null, null, null, false);
			grid.equipV = grid.equipV;
		}

		this._SetCenterEquipAttr();
	},

	_SetSelectEffect:function (grid, visible) {
		if ( !grid.select ) {
			var icon = new MUIImage();
			icon.ParseJson(this.imgSelect.jsonobj);
			icon.Init();
			icon.setPosition(this.imgSelect.getPosition());
			grid.addChild(icon);
			grid.select = icon;
		}
		grid.reorderChild(grid.select, 3);
		grid.select.visible = visible;
	},

	_SetCenterEquipAttr:function () {
		// init param
		{
			// rate
			this.img1.visible = false;
			this.labCue.visible = false;
			this.labCueValue.SetString("");
			// attr
			this.imgBg1.visible = false;
			// maxLevel icon
			this.imgMaxLv.visible = false;
		}

		// set data
		var equipV = this.gridEquipC.equipV;
		if ( equipV ) {
			// star
			this._ShowStars(equipV.strenthenLv);

			// is enable up
			if ( DuanzaoUtil.IsUpGoods(equipV.itemModelId) ) {
				var equipC = Q_item.Get( equipV.itemModelId );
				cc.assert(null != equipC, "data is unexist in Q_item!  mid: " + equipV.itemModelId);
				// max Level
				if ( equipV.strenthenLv >= equipC.q_max_strengthen ) {
					this.imgMaxLv.visible = true;
				}
				else {
					// rate
					this.img1.visible = true;
					this.labCue.setVisible(true);

					var sid = String( String( equipV.itemModelId ) + '_' + String( equipV.strenthenLv + 1 ) );
					var q_attribute_rise = Q_attribute_rise.Get( sid);
					cc.assert(null != q_attribute_rise, "data is unexist in Q_attribute_rise!  sid: " + sid);
					var str = q_attribute_rise ? String( q_attribute_rise.q_success ) + "%" : "";
					this.labCueValue.SetString(str);

					// attr ----------
					this.imgBg1.setVisible(true);
					// lv
					str = "+" + String( equipV.strenthenLv );
					this.labCurLvValue.SetString(str);

					// attack
					var attrV = DuanzaoUtil.GetAttributeV( equipV.itemModelId, equipV.strenthenLv );
					this.labGongji.SetString( attrV.str );

					str = "+" + String( attrV.value );
					this.labGongji1.SetString( str );

					// fighting
					var fighting = 0;
					var fo = Mgr.attributeMgr.GetAttributeRate(attrV.type, 0);
					if ( fo )
						fighting = parseInt(fo * attrV.value);
					this.imgNumber.SetString(fighting);

					//next attr----
					//next_lv
					str = "+" + String( equipV.strenthenLv + 1 );
					this.labNexLvValue.SetString(str);

					//next_attr
					var next_attrV = DuanzaoUtil.GetAttributeV(equipV.itemModelId, equipV.strenthenLv + 1);
					this.labGongji11.SetString( next_attrV.str );

					str = "+" + String( next_attrV.value );
					this.labGongji111.SetString( str );

					//dev_attr
					var dev_attr = next_attrV.value - attrV.value;
					str = "+" + String( dev_attr );
					this.labCue3.SetString(str);

					//next_fighting
					var next_fighting = 0;
					fo = Mgr.attributeMgr.GetAttributeRate(next_attrV.type, 0);
					if ( fo )
						next_fighting = parseInt(fo * next_attrV.value);
					this.imgNumber1.SetString(next_fighting);

					//dev_fingting
					var dev_fighting = next_fighting - fighting;
					str = "+" + String(dev_fighting);
					this.labCue4.SetString(str);

					//set material color
                    if(q_attribute_rise){
                        var mat = Q_item.Get( q_attribute_rise.q_up_item_id );
                        cc.assert(null != mat, "data is unexist in Q_item!  mid: " + q_attribute_rise.q_up_item_id);
                        var num = q_attribute_rise.q_up_item_num;
                        var str_material = mat.q_name + String( num ) + "个";
                        UIUtil.ConnectLabelHtmlText( this.labCue5, [str_material] );
                        this.labCue5.SetColor("0x853d07");
                        if ( Mgr.backpack.GetItemNumber( q_attribute_rise.q_up_item_id, true ) < num )
                            this.labCue5.SetColor("0xEE0000");
                    }
				}
			}
		}
	},

	// 默认选则最优装备
	_AutoSelect:function () {
		var _equipV = null;
		var _grid = null;
		var _bestSelArr = [];
		for ( var i = 0; i < this._gridArr.length; i++ ) {
			var grid = this._gridArr[i].obj;
			var data = grid.equipV;
			// unexist equip
			if ( !data )
				continue;

			// 默认选着一个
			if ( !_equipV ) {
				_equipV = data;
				_grid = grid;
			}

			// unEnable up
			if ( !DuanzaoUtil.IsUpGoods( data.itemModelId ) )
				continue;

			// 选则等级最小的  (目前没有这个需求)
			// 	_equipV = ( _equipV.strenthenLv > date.strenthenLv ) ? data : _equipV;
			// }

			// 升级条件满足
			var autoBuy = this._GetAuoBuyState();
			if ( DuanzaoUtil.IsFullCondition( data, true ) == UpMrakEnum.UP_EN_UP ) {
				_bestSelArr.push( [data, grid] );
			}
		}

		// 如果存在优选装备
		if ( _bestSelArr.length > 0 ) {
			_equipV = _bestSelArr[0][0];
			_grid = _bestSelArr[0][1];

			// //选则等级最小的  (目前没有这个需求)
			// for (var i = 0; i != _bestSelArr.length; i++) {
			// 	_equipV = ( _equipV.strenthenLv > _bestSelArr[i][0].strenthenLv ) ? _bestSelArr[i][0] : _equipV;
			// 	_grid = ( _equipV.strenthenLv > _bestSelArr[i][0].strenthenLv ) ? _bestSelArr[i][1] : _grid;
			// }
		}

		this.gridEquipC.equipV = _equipV;
		this.SetCenterEquip();

		// select effect
		if ( _grid ) {
			// 清除上一次效果
			if ( this._curSelector )
				this._SetSelectEffect(this._curSelector, false)
			this._curSelector = _grid;
			this._SetSelectEffect( _grid, true )
		}
	},

	_ShowStars:function ( lv ) {
		var stars = parseInt( lv / this._lvToStar );
		stars = (stars > this._maxStar) ? this._maxStar : stars;
		for ( var i = 0; i != this._maxStar; i++ ) {
			if (i < stars)
				this._starArr[i].visible = false;
			else
				this._starArr[i].visible = true;
		}
	},

	SendEquipStrengh:function () {
        var errorTip = null;
        do{
            if ( !this.gridEquipC.equipV ) {
                errorTip = "请选者一件装备";
                break;
            }

            //是否达到升级条件
            var mark = DuanzaoUtil.IsFullCondition( this.gridEquipC.equipV, this._GetAuoBuyState() );
            if ( mark == UpMrakEnum.UP_UN_UP ) {
                errorTip = "该装备不可升级";
                break;
            }
            if ( mark == UpMrakEnum.UP_MAX_LEVEL ) {
                this._ChangeAutoUpState(false);
                errorTip = "装备达到最大等级";
                break;
            }
            if ( mark == UpMrakEnum.UP_SHORT_MATERIAL ) {
                this._ChangeAutoUpState(false);
                errorTip = "材料不足";
                break;
            }
        }while(false);

        if(errorTip){
            if(this._lastErrorTip != errorTip
                || Date.now() - this._lastErrorTime > 3000){
                this._lastErrorTip = errorTip;
                this._lastErrorTime = Date.now();
                Mgr.tips.ShowNotice(errorTip);
            }
            return;
        }

		if ( mark == UpMrakEnum.UP_SHORT_GOLD ) {
			// Mgr.tips.ShowNotice( "元宝不足");
			AlertExt.NoEnoughGold();
			this._ChangeAutoUpState(false);
			return;
		}
		if ( mark == UpMrakEnum.UP_EN_UP ) {
			var sid = this.gridEquipC.equipV.itemId;
            var auto = this._GetAuoBuyState();
			var upType = this._itemType;
			Mgr.refining.SendReqStrengthenMessage(sid, auto, upType);
		}
	},

	_ChangeAutoUpState:function (auto) {
		this.btnQianghua.visible = !auto;
		this.btnQianghua1.visible = !auto;
		this.autoUp = auto;
	},

	_GetAuoBuyState:function () {
		return this.sbtnGouxuan.GetState() === "check";
	},

	UpdataWarn:function () {
		// 可强化
		var isExist = false;
		for ( var i = 0; i != this._gridArr.length; i++ ) {
			var boo  = false;
			var grid = this._gridArr[i].obj;
			if ( grid.equipV ) {
				var autoBuy = this._GetAuoBuyState();
				if (DuanzaoUtil.IsFullCondition(grid.equipV, autoBuy) == UpMrakEnum.UP_EN_UP)
					isExist = boo = true;
			}

			this._EndWarn(grid);
			if  ( boo )
				this._StartWarn(grid);
		}
	},

	_EndWarn:function (grid) {
		if (grid.warn) {
			grid.warn.visible = false;
			grid.warn.stopAllActions();
		}
	},

	_StartWarn:function (grid) {
		if ( !grid.warn ) {
			// 可镶嵌
			var icon = new MUILabel();
			icon.ParseJson(this.imgQianghua.jsonobj);
			icon.Init();
			icon.setPosition(this.imgQianghua.getPosition());
			grid.addChild(icon, 1, 20);
			grid.warn = icon;
		}
		grid.warn.visible = true;
		grid.reorderChild(grid.warn, 10);
		grid.warn.setOpacity(255);
		grid.warn.setPosition(this.imgQianghua.getPosition());

		// action
		var actionTo = cc.moveBy(1, cc.p(0, this._gridArr[0].obj.height / 4));
		var trace = cc.callFunc(this._OnTrace, this);
		var out = cc.fadeOut(0.5);
		var ina = cc.fadeIn(0.5);
		var rep = cc.sequence(actionTo, out, trace, ina).repeatForever();
		grid.warn.runAction(rep);
	},

	_OnTrace:function (sender) {
		var pos = this.imgQianghua.getPosition();
		sender.x = pos.x;
		sender.y = pos.y;
	},
} );
QianhuaMainExt.PanelName = "QianhuaMainExt";
PanelClassDic["QianhuaMainExt"] = QianhuaMainExt;
