var RonglianMainExt = RonglianMain.extend ( {
	_className:"RonglianMainExt",

	_gridArr : null,

	// tips
	_tipsPos : null,
	_tips2Pos : null,

	_TempValue : null,
    listView:null,

	selectLevel:4,
    curSelectItem:null,

	// effect
	effects:null,

	ctor:function(){
		this._super();

		this._gridArr = [];
		this._TempValue = [0,0,0];
		this.effects = [];

	},
	Init:function() {
		var self = this;
		RonglianMain.prototype.Init.call(this);

		this.imgGradeView.visible = false;
		//----
		this.sbtnGrade.setVisible(false);
        this.labGrade.setVisible(false);
        this.imgedit.setVisible(false);
		//----
        this.sbtnGrade.SetButtonState("uncheck");

        this.labCue2.SetHtmlText("自动熔炼装备");

        this._CreateListView();
        this.InitListView();
		this._InitParam();

		this.btnRonglian.addClickEventListener(function (event){   // 智能熔炼

			Mgr.melting._isMelted = true;
			var list = DuanzaoUtil.FilterEquip( self._GetAuoSelectState(), this.selectLevel);
			if ( list.length <= 0 )  {
				Mgr.tips.ShowNotice("装备不足，无法熔炼");
				return;
			}
			var aList = [];
			for ( var i = 0; i != list.length; i++ ) {
				aList.push(list[i].item.itemId);
			}

			Mgr.melting.SendReqMeltingToGameMessage( aList );
		});


		this.sbtnGrade.addClickEventListener(function(){
			if(this.GetState() == "check"){
                self.imgGradeView.visible = true;
			}
			else{
                self.imgGradeView.visible = false;
			}
		});
	},

    _CreateListView:function(){
        if(this.listView == null){
            var listView = new ccui.ListView();
            listView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            listView.setTouchEnabled(true);					//触摸开启
            listView.inertiaScrollEnabled = false; 			//滚动惯性
            listView.setScrollBarEnabled(true);				//滚动条
            listView.setBounceEnabled(true);					//边界回弹
            listView.setScrollBarAutoHideTime(1);
            listView.setContentSize(cc.size(this.imgGradeView.width, this.imgGradeView.height));
            listView.setItemsMargin(1);
            listView.addEventListener(this._SelectedItemEvent);
            this.imgGradeView.addChild(listView);
            this.listView = listView;
        }
    },

    InitListView:function(){
    	this.selectLevel = 4;
        // var list = [0,1,2,3,4,5,6];
        for(var i = 0; i != 7; i++) {
            var item = new RonglianPinzhiButtnExt();
            item.LoadPanel();
            item.SetData(i);
            // this.listView.pushBackCustomItem(item);
            item.x = 0;
            item.y = item.imgSelect.height * i;
            item.level = i;
            this.listView.addChild(item);
            if (i == this.selectLevel){
                item.SetSelect(true);
                UIUtil.ConnectLabelHtmlText(this.labGrade, [item.quality]);
                this.curSelectItem = item;
			}
		}
    },

    _SelectedItemEvent: function (sender, type) {
        switch (type) {
            case ccui.ListView.ON_SELECTED_ITEM_END:
                var parent = sender.parent.parent;
                if ( parent.curSelectItem != null) {
                    parent.curSelectItem.SetSelect(false);
                    parent.curSelectItem = null;
                }

                var idx = sender.getCurSelectedIndex();
                var itemSelect = sender.getItem(idx);
                parent.curSelectItem = itemSelect;
                UIUtil.ConnectLabelHtmlText(parent.labGrade, [itemSelect.quality]);
                itemSelect.SetSelect(true);
                parent.imgGradeView.visible = false;
                parent.sbtnGrade.SetButtonState("uncheck");
                parent.selectLevel = itemSelect.level;
                parent._SetEquips();
                Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).UpDataDuanzhaoWarn(DuanzaoTypeEnum.EQUIP_MELTING);
                break;
            default:
                break;
        }
    },

	AddEffect:function () {
		// effect
		var url = "other/duanzhao/image/effect/melt/star.png";
		var effect_star = ParticleEffect.Create(this.imgEffect,url,3,500,40,130);
		effect_star.SetFade(0.1,0.1);
		effect_star.SetMove(2,0.8);
		effect_star.SetAngle(90,70);
		effect_star.Play();
		this.effects.push(effect_star);

		url = "other/duanzhao/image/effect/melt/fog.png";
		var effect_flog = ParticleEffect.Create(this.imgEffect1,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(30,0);
		effect_flog.Play();
		this.effects.push(effect_flog);

		effect_flog = ParticleEffect.Create(this.imgEffect1,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(160,0);
		effect_flog.Play();
		this.effects.push(effect_flog);

		var effect_ani = new MAnimationObject();
		effect_ani.sResUrlBase = "res/animation/swf/duanzao/2/";
		effect_ani.DoAction("stand5", 0, EnumDefaultResType.NONE);
		effect_ani.setAnchorPoint(0,0);
		effect_ani.x = 0;
		effect_ani.y = 0;
		this.imgEffect2.addChild(effect_ani,0, 100);
		this.effects.push(effect_ani);

		// // animal
		// var effect_ani = AnimationEffect.Create(this.imgEffect2,12);
		// effect_ani.Play();
	},

	StopEffect:function () {
		for ( var i = 0; i != this.effects.length; i++ ) {
			this.effects[i].Dispose();
		}
		this.effects = [];
	},

	SetData:function () {
		Mgr.melting.SendReqOpenMeltingToGameMessage();
	},

	// label链接
	_SetLabelLink:function () {
		var self = this;
		// tips说明
		this.labCue3.setTouchEnabled(true);
		this.labCue3.addTouchEventListener(function(sender,type)
		{
			if ( type == ccui.Widget.TOUCH_BEGAN )
			{
				sender.setScale(1.01);
			}
			else if ( type == ccui.Widget.TOUCH_ENDED )
			{
				sender.setScale(1.0);

				var panel = Mgr.uiMgr.ShowPanelByType(RoonglianTipsExt.PanelName);

				// pos
				var pt = cc.p( sender.x + 10, sender.y - 10 );
				pt = UIUtil.LocalToGlobel( sender.parent, pt, Mgr.uiMgr.GetLayerByType(panel.showLayerType) );
				panel.setAnchorPoint(0, 1);
				panel.x = pt.x;
				panel.y = pt.y;
			}
			else if ( type == ccui.Widget.TOUCH_CANCELED )
			{
				sender.setScale(1.0);
			}
		});
	},

	_InitPosition:function()
	{
		this.x = 0;
		this.y = 0;
	},

	_InitParam:function() {
		this._InitPosition();

		this.gridItem1.visible = false;
		this.gridItem11.visible = false;
		this.labNumber3.SetString("0");

		this.labAttack.SetString("0");
		this.labDef.SetString("0");
		this.labHp.SetString("0");

		this.imgUp.visible = false;
		this.labNum.SetString("");

		this.labNumber.SetString("");

		this._SetLabelLink();
		this._SetInitGrid();
		this._SetCheckOut();
	},

	_SetInitGrid:function () {
		for ( var i = 0; i != 7; i++ ) {
			var grid = new MUIGrid();
			grid.ParseJson(this.gridItem1.jsonobj);
			grid.Init();
			var Gx = this.gridItem1.x + i * (this.gridItem1.width + 4) ;
			var Gy = this.gridItem1.y;
			grid.setPosition( Gx, Gy );
			grid.equipV = null;
			this.gridItem1.parent.addChild(grid);
			this._gridArr.push(grid);
		}
	},

	_SetCheckOut:function () {
		var self = this;
		this.sbtnGouxuan.SetButtonState( "uncheck" );
		this.sbtnGouxuan.setTouchEnabled(true);
		this.sbtnGouxuan.addTouchEventListener(function (sender, type) {
			if (type == ccui.Widget.TOUCH_ENDED) {
				var boo = self._GetAuoSelectState();
				if (boo){
                    sender.SetButtonState("uncheck");
                    Mgr.melting.isAutoMelting = false;
				}
				else{
                    sender.SetButtonState("check");
                    Mgr.melting.isAutoMelting = true;
				}

				self._SetEquips();
				Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).UpDataDuanzhaoWarn(DuanzaoTypeEnum.EQUIP_MELTING);
			}
		});
	},

	_SetEquips:function () {
		var list = DuanzaoUtil.GetLowerEquip();
		list.sort(this._SortFunc);
		cc.log("-----------------" + list.length);
		// set grid
		for ( var i = 0; i != this._gridArr.length; i++ ) {
			var item = null;
			if ( i < list.length )
				item = list[i];
			this._SetEquip( this._gridArr[i], item );
		}
	},

	_SetEquip:function ( grid, data ) {
		grid.Clean();
		if ( data ) {
			// ico
			// var icon = ItemUtil.GetItemIcon(data.item.itemModelId, ResUrl.ITEM_SIZE_60)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            // var coinInfo = {};
            var coinInfo = {};
            coinInfo.itemModelId = data.item.itemModelId;
            // coinInfo.itemNum = price;
            // coinInfo.itemBind = itemInfo.q_bind;
            GridUtil.SetItemGrid(grid,coinInfo, null, null, null, false);
			grid.data = data;

			// 装备好坏标志
			if ( data.index != 0 )
			{
				var icon = new MUIImage();
				if (data.index > 0)
					icon.ParseJson(this.imghigh.jsonobj);
				else if (data.index < 0)
					icon.ParseJson(this.imglow.jsonobj);
				icon.Init();
				icon.setPosition(this.imghigh.getPosition());
				grid.AddDisplay(icon);
			}
		}
		// callback
		var self = this;
		grid.setTouchEnabled(true);
		grid.addTouchEventListener(function (sender, type) {
			if (type == ccui.Widget.TOUCH_ENDED) {
				if ( data == null ) {
					Mgr.tips.ShowNotice("没有装备");
					return;
				}

				Mgr.melting._isMelted = true;
				// 请求熔炼
				var sid = sender.data.item.itemId;
				var quality = Q_item.Get(sender.data.item.itemModelId).q_default;
				var isTips = sender.data.index > 0 || quality >= ItemUtil.ITEM_QT_RED;

				if ( isTips && Mgr.melting.isTips ) {
					Mgr.uiMgr.ShowPanelByType( RonglianTips2Ext.PanelName ).SetData(
						function () {
							Mgr.melting.SendReqMeltingToGameMessage( [sid] );
						} );
				}
				else
					Mgr.melting.SendReqMeltingToGameMessage( [sid] );
			}
		});
	},

	UpdateMelting:function ( level, exp ) {
		// set equips
		this._SetEquips();

		// level
		UIUtil.ConnectLabelHtmlText(this.labRonglianzhi, [level]);

		var _attributeArr = [
			{ type:EnumAttribute.ATTACK , label:this.labAttack },
			{ type:EnumAttribute.DEFEND, label:this.labDef },
			{ type:EnumAttribute.MAX_BASEHP, label:this.labHp },
		];
		var melt_attribute = Q_melt_attribute.Get(level);
		cc.assert(null != melt_attribute, "data is unexist in Q_melt_attribute!  level: " + level);
		// attr
		var array = [];
		if ( melt_attribute.q_attribute ) {
			var temp = ParseUtil.FormatFastJsonStr(melt_attribute.q_attribute);
			var jsonData = JSON.parse(temp);
			for (var keyStr in jsonData) {
				array.push([parseInt(keyStr), parseInt(jsonData[keyStr])]);
			}
		}

		var fight = 0;
		for ( var i = 0; i != array.length; i++ ) {
			var type = array[i][0];
			var value = array[i][1];

			for (var j = 0; j != _attributeArr.length; j++) {
				if (type == _attributeArr[j].type) {
					var dexValue = value - this._TempValue[j];
					this._TempValue[j] = value;

					if (Mgr.melting._isMelted && dexValue > 0) {
						var obj = _attributeArr[j].label.parent.getChildByTag(10);
						if (obj)
							obj.removeFromParent();

						var obj1 = _attributeArr[j].label.parent.getChildByTag(11);
						if (obj1)
							obj1.removeFromParent();

						var icon = new MUIImage();
						icon.ParseJson(this.imgUp.jsonobj);
						icon.Init();
						icon.setPosition(this.imgUp.getPosition());
						_attributeArr[j].label.parent.addChild(icon, 0, 10);

						// dextend
						var dexLable = new MUILabel();
						dexLable.ParseJson(this.labNum.jsonobj);
						dexLable.Init();
						dexLable.setPosition(this.labNum.getPosition());
						_attributeArr[j].label.parent.addChild(dexLable, 0, 11);
						dexLable.SetString(dexValue);

						// action
						var out = cc.fadeOut(1);
						var ina = cc.fadeIn(1);
						var out1 = cc.fadeOut(1);
						var ina1 = cc.fadeIn(1);
						var data = {obj:_attributeArr[j].label, value:value};
						var rep = new cc.Sequence(ina, out);
						var rep1 = new cc.Sequence(ina1, out1, new cc.CallFunc(this.OnTweenEnd, this, data));
						icon.runAction(rep);
						dexLable.runAction(rep1);
					}
					else {
						_attributeArr[j].label.SetString(value);
					}
                    //fighting
                    var fo = Mgr.attributeMgr.GetAttributeRate(type, 0);
                    if ( fo ){
                        fight += parseInt(fo * value);
                    }
				}
			}
		}
		this.labNumber3.SetString(fight, LableEffect.UP);

		// 熔炼进度
		var totalExp = melt_attribute.q_exp;
		var str = String(exp) + "/" + String(totalExp);
		this.labNumber.SetString(str);
		var rate = parseFloat( exp / totalExp * 100 );
		this.progJindutiao.setPercent(rate);
	},

	OnTweenEnd:function(taget, data){
		data.obj.SetString(data.value);
	},

	_GetAuoSelectState:function () {
		var auto = false;
		var state = this.sbtnGouxuan.GetState();
		if ( state === "check" )
			auto = true;
		return auto;
	},

	_SortFunc:function(a, b) {
		if (a.index < b.index) {
			return 1;
		}
		return 0;
	},
} );
RonglianMainExt.PanelName = "RonglianMainExt";
PanelClassDic["RonglianMainExt"] = RonglianMainExt;
