var ShenZhuangPanelExt = ShenZhuangPanel.extend ( {
    _className:"ShenZhuangPanelExt",
    ctor:function(){
        this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = 10;

        this.panelMgr = {};
    },

    Init:function(){
        this._super();

        var self = this;
        this.btnClose.addClickEventListener(function (event){
            EngineMgr.uiMgr.HidePanel( self );
        });

        this._btnArr = [
            { text : "神装打造", ignoreItemType : false,type : DuanzaoTypeEnum.EQUIP_GORGE, 	btn: null,warn : null, x : 0,y : -89,panelName: ShenZhuangDaZaoExt.PanelName},			// 神装打造
            { text : "神装升级", ignoreItemType : false,type : DuanzaoTypeEnum.EQUIP_UPGRADE, 	btn: null,warn : null, x : 0,y : -89,panelName: ShenZhuangShengJiMainExt.PanelName},	// 神装升级
            { text : "神装套装", ignoreItemType : false,type : DuanzaoTypeEnum.EQUIP_SUIT,		btn: null,warn : null, x : 0,y : 0,panelName: SuitMakePanelExt.PanelName},				// 神装套装
            { text : "神装分解", ignoreItemType : true,type : DuanzaoTypeEnum.EQUIP_DECOMPOSE, btn: null,warn : null, x : 0,y : -89,panelName: ShenZhuangFenJieMainExt.PanelName},	// 神装分解
        ];

        var imgQianghua = this.imgQianghua;
        this._btnArr.forEach(function(v,k){
            var btn = k === 0 ? imgQianghua : null;
            if(!btn){
                btn = UIUtil.CloneUI(imgQianghua);
                imgQianghua.parent.addChild(btn);
            }else{
                btn.imgTanhao = self.imgTanhao;
            }
            btn.SetText( v.text );
            btn.addClickEventListener(self.ChangePanel.bind(self,v.type));

            v.btn = btn;
            v.warn = btn.imgTanhao;
        });
        // 侧边栏
        this._btnTabArr = [
            { btn : this.sbtnRole,		type : EnumItemType.Equip,			warn: this.imgWarn},
            { btn : this.sbtnShutong,	type : EnumItemType.Equip_Shutong,	warn: this.imgShutong},
        ];

        this._btnTabArr.forEach(function(v){
            v.btn.addClickEventListener(self.OnSelectedItemTypeChanged.bind(self,v.type))
        })
    },

    OnShow:function(){
        this._super();

        this.OnCheckTabOpened();

        this.OnSelectedItemTypeChanged(this.selectedItemType || EnumItemType.Equip);

        this.UpdateWarn();
    },
    OnHide:function(){
        this._super();
    },

    OnCheckTabOpened:function(){
        var initX = this._btnArr[0].btn.x;
        this._btnArr.forEach(function(v){
            var ret = DuanzaoUtil.CheckDuanzaoFuncOpenWithType(v.type);
            v.btn.visible = ret;
            if(ret){
                v.btn.x = initX;
                initX += 160;
            }
        });
    },

    OnSelectedItemTypeChanged:function(type){
        this._btnTabArr.forEach(function(v){
            v.btn.SetButtonState(v.type == type?"check":"uncheck");
        })

        this.selectedItemType = type;
        this.ChangePanel(this.selectedDuanzaoType || this._btnArr[0].type);
    },

    ChangePanel:function(type){
        var ignoreItemType = false;
        this._btnArr.forEach(function(v){
            v.btn.SetButtonState(v.type == type?"check":"uncheck");

            if(v.type == type) ignoreItemType = v.ignoreItemType;
        })
        this._btnTabArr.forEach(function(v){
            v.btn.visible = !ignoreItemType;
        })

        this.selectedDuanzaoType = type;

        this.UpdateSecondWarn();

        var curPanel = this._curPanel;
        if(curPanel){
            curPanel.visible = false;
            if(curPanel.OnHide) curPanel.OnHide();
            if(curPanel.StopEffect) curPanel.StopEffect();
        }

        var config = this._btnArr.find(function(v){
            return v.type == type;
        });

        if(config){
            if ( !this.panelMgr[type] ) {
                var panel = new PanelClassDic[config.panelName]();
                panel.LoadPanel();
                panel.x = config.x;
                panel.y = config.y;
                this.imgTitleBg.addChild(panel);
                this.panelMgr[type] = panel;
            }
            curPanel = this.panelMgr[type];
        }

        if(curPanel){
            this._curPanel = curPanel;
            curPanel.visible = true;
            if(curPanel.SetData) curPanel.SetData(this.selectedItemType);
            if(curPanel.OnShow) curPanel.OnShow();
            if(curPanel.AddEffect) curPanel.AddEffect();
        }
    },

    UpdateWarn:function(){
        this._btnArr.forEach(function(v){
            if(v.btn.visible){
                v.warn.visible = DuanzaoUtil.IsMarkBySubType2(v.type);
            }
        });
        this.UpdateSecondWarn();
    },

    UpdateSecondWarn:function(){
        for ( var i = 0; i != this._btnTabArr.length; i++ ) {
            var v = this._btnTabArr[i];
            v.warn.visible = DuanzaoUtil.IsMarkBySubType2(this.selectedDuanzaoType,v.type);
        }
    },
} );
ShenZhuangPanelExt.PanelName = "ShenZhuangPanelExt";
PanelClassDic["ShenZhuangPanelExt"] = ShenZhuangPanelExt;


var ShenZhuangPanelExt = DuanzaoPanelExt.extend ( {
    _className:"ShenZhuangPanelExt",
    ctor:function(){
        this._super();
    },

    InitMarkCondition:function(){
        return DuanzaoUtil.IsMarkBySubType2.apply(DuanzaoUtil,arguments)
    },

    InitTabConfig:function(){
       return config = [
//           { text : "装备合成",	type : DuanzaoTypeEnum.EQUIP_COMPOSE_NEW, 	panelName: ZhuangBeiHeChengExt.PanelName},	// 装备合成
           { text : "神装打造",	type : DuanzaoTypeEnum.EQUIP_GORGE,		y : -89,	panelName: ShenZhuangDaZaoExt.PanelName},
           { text : "神装升级",	type : DuanzaoTypeEnum.EQUIP_UPGRADE, 	y : -89,	panelName: ShenZhuangShengJiMainExt.PanelName},
           { text : "神装套装",	type : DuanzaoTypeEnum.EQUIP_SUIT,		panelName: SuitMakePanelExt.PanelName},
           { text : "神装分解",	type : DuanzaoTypeEnum.EQUIP_DECOMPOSE, y : -89,		panelName: ShenZhuangFenJieMainExt.PanelName},
       ];
    },
} );
ShenZhuangPanelExt.PanelName = "ShenZhuangPanelExt";
PanelClassDic["ShenZhuangPanelExt"] = ShenZhuangPanelExt;