var ShenZhuangShengJiMainExt = ShenZhuangShengJiMain.extend ( {
    _className:"ShenZhuangShengJiMainExt",
    ctor:function(){
        this._super();
    },
    Init:function(){
        this._super();

        this.lab1.visible = false;
        this.labQiangHua.visible = false;
        this.imgSelect.visible = false;


        this._gridArr = [
            {obj:this.grid1,type:EnumEquipPos.EQUIP_WEAPONS},//武器0
            {obj:this.grid2,type:EnumEquipPos.EQUIP_CLOTHES},//衣服1
            {obj:this.grid3,type:EnumEquipPos.EQUIP_BRACELET_LEFT},//护手
            {obj:this.grid4,type:EnumEquipPos.EQUIP_HUFU_LEFT}, //左护符6
            {obj:this.grid5,type:EnumEquipPos.EQUIP_RING_LEFT}, //左戒指8
            {obj:this.grid6,type:EnumEquipPos.EQUIP_BELT},//腰带3
            {obj:this.grid7,type:EnumEquipPos.EQUIP_HUTUI},//护腿
            {obj:this.grid8,type:EnumEquipPos.EQUIP_SHOES}, //鞋子5
            {obj:this.grid9,type:EnumEquipPos.EQUIP_HUFU_RIGHT}, //右护符7
            {obj:this.grid10,type:EnumEquipPos.EQUIP_RING_RIGHT} //右戒指9
        ];

        this.btnHeCheng.addClickEventListener(this.OnBtnClicked_Hecheng.bind(this));
    },
    InitSubTabConfig:function(){
        var config = [
            { type : EnumItemType.Equip	,text : "角色" },
            { type : EnumItemType.Equip_Shutong	,text : "书童" },
        ];

        return config;
    },

    OnShow:function(){
        this._super();
        GameEventMgr.AddEventListener(this,EnumEventType.GAME_REFINING_RESULT,function(){
            this.SetData();
        })
    },
    OnHide:function(){
        GameEventMgr.RemoveEventListener(this);
        this._super();
    },
    OnBtnClicked_Hecheng:function(){
        if(!this._selectedEquip || !this._targetItemC) return;

        Mgr.refining.SendReqUpOrDismantlrEquipMessage(0,this._targetItemC.q_type,[this._selectedEquip.itemId]);
    },
    SetData:function(itemType) {
        itemType = itemType || this._itemType;

        var force = itemType != this._itemType;
        this._itemType = itemType;

        this.SetEquips();
        if (!force && this._selectedEquip)
            this.SetCenterEquip(this._selectedEquip);
        else
            this._AutoSelect();   // 每次打开界面均自动选者
    },
    _AutoSelect:function () {
        var _equipV = null;
        var _grid = null;
        var _bestSelArr = [];
        for ( var i = 0; i < this._gridArr.length; i++ ) {
            var grid = this._gridArr[i].obj;
            var data = grid.equipV;

            if ( !data ) continue;

            // 默认选着一个
            if ( !_equipV ) {
                _equipV = data;
                _grid = grid;
            }

            // 升级条件满足
            if (DuanzaoUtil.IsShenZhuangCanUpgrade(data)) {
                _bestSelArr.push( [data, grid] );
                break;
            }
        }

        // 如果存在优选装备
        if ( _bestSelArr.length > 0 ) {
            _equipV = _bestSelArr[0][0];
            _grid = _bestSelArr[0][1];
        }

        this.SetCenterEquip(_equipV);

        // select effect
        if ( _grid ) {
            this._SetSelectEffect( _grid, true )
        }
    },

    SetEquips:function(){
        var temp;
        if ( this._selectedEquip ) {
            temp = Q_item.Get(this._selectedEquip.itemModelId);
        }
        for ( var i = 0; i < this._gridArr.length; i++ ) {
            var equipV = Mgr.equip.GetEquipByType(this._itemType,this._gridArr[i].type);
            this._SetEquip( this._gridArr[i].obj, equipV );

            // warn
            if(DuanzaoUtil.IsShenZhuangCanUpgrade(equipV)){
                this._StartWarn(this._gridArr[i].obj);
            }else{
                this._EndWarn(this._gridArr[i].obj);
            }
            // 及时更新部位装备 , 更换装备的情况
            if (temp && temp.q_kind == this._gridArr[i].type)
                this._selectedEquip = equipV;
        }

    },

    _SetEquip:function ( grid, equipV ) {
        grid.Clean();
        grid.equipV = equipV;

        if ( equipV ) {
            var item = ItemUtil.ItemIdToItem(equipV.itemModelId);
            GridUtil.SetItemGrid(grid,item, null, null, null, false);

            // level
            if (equipV.strenthenLv > 0) {
                var level = new MUILabel();
                level.ParseJson(this.lab1.jsonobj);
                level.Init();
                var str = "+" + String(equipV.strenthenLv);
                level.SetString(str);
                level.setPosition(this.lab1.getPosition());
                grid.AddDisplay(level);
            }
        }
        // callback
        var self = this;
        grid.setTouchEnabled(true);
        grid.addTouchEventListener(function (sender, type) {
            if (type == ccui.Widget.TOUCH_ENDED) {
                if ( sender.equipV ) {
                    self._SetSelectEffect(sender, true);
                    self.SetCenterEquip(sender.equipV);
                }
                else
                    Mgr.tips.ShowNotice( "没有装备!");
            }
        });
    },

    _SetSelectEffect:function (grid, visible) {
        if(visible){
            if(this._selectedGrid){
                this._SetSelectEffect(this._selectedGrid,false);
            }
            this._selectedGrid = grid;
        }

        if ( !grid.select ) {
            var icon = new MUIImage();
            icon.ParseJson(this.imgSelect.jsonobj);
            icon.Init();
            icon.setPosition(this.imgSelect.getPosition());
            grid.addChild(icon);
            grid.select = icon;
        }
        grid.reorderChild(grid.select, 3);
        grid.select.visible = visible;
    },

    SetCenterEquip:function(equip) {
        this._selectedEquip = equip;
        this._targetItemC = null;

        var textName = "";
        var textName1 = "";
        var textCondition = "";
        var textOwn = "";
        var textFightPower = "";

        var attrV1,attrV2,textConditionName;

        this.grid11.Clean();
        this.grid12.Clean();
        do{
            if(!equip) break;
            var item1 = ItemUtil.ItemInfoToItem(equip);
            GridUtil.SetItemGrid(this.grid11, item1, null, null, null, false);

            var itemC = Q_item.Get(equip.itemModelId);
            if(!itemC) break;

            var level = 1; // equip.strenthenLv
            attrV1 = DuanzaoUtil.GetAttributeV( equip.itemModelId, level);

            textName = itemC.q_name;

            /// 合成物品
            var equipHolyC = Q_equip_holy.Get(equip.itemModelId);
            if(!equipHolyC) break;

            var itemC_get = Q_item.Get(equipHolyC.q_item_get);
            if(!itemC_get) break;

            this._targetItemC = itemC_get;

            textName1 = itemC_get.q_name;
            textFightPower = DuanzaoUtil.GetEquipFighting(itemC_get.q_id,level);
            attrV2 = DuanzaoUtil.GetAttributeV(itemC_get.q_id, level);

            var item = ItemUtil.ItemIdToItem(itemC_get.q_id);
            GridUtil.SetItemGrid(this.grid12,item, null, null, null, true);

            var q_item_cost = JSON.parse(equipHolyC.q_item_cost);
            if(!q_item_cost) break;

            var itemC_cost = Q_item.Get(q_item_cost[0]);
            if(!itemC_cost) break;

            textCondition = itemC_cost.q_name + "x" + q_item_cost[1];
            textOwn = Mgr.backpack.GetItemNumber(q_item_cost[0]);
            textConditionName = itemC_cost.q_name;
        }while(false);

        this.labNum1.visible = attrV1;
        this.labNum2.visible = attrV2;
        this.labGet.visible = textConditionName;
        if(attrV1) UIUtil.ConnectLabelHtmlText(this.labNum1,[attrV1.str,attrV1.value]);
        if(attrV2) UIUtil.ConnectLabelHtmlText(this.labNum2,[attrV2.str,attrV2.value]);
        if(textConditionName) UIUtil.ConnectLabelHtmlText(this.labGet,[textConditionName]);

        UIUtil.ConnectLabelHtmlText(this.labWord,[textName]);
        UIUtil.ConnectLabelHtmlText(this.labWord1,[textName1]);
        UIUtil.ConnectLabelHtmlText(this.labDaZao,[textCondition]);
        UIUtil.ConnectLabelHtmlText(this.labDaZao1,[textOwn]);
        UIUtil.ConnectLabelHtmlText(this.labNum,[textFightPower]);
    },

    _EndWarn:function (grid) {
        if (grid.warn) {
            grid.warn.visible = false;
            grid.warn.stopAllActions();
        }
    },

    _StartWarn:function (grid) {
        if ( !grid.warn ) {
            // 可镶嵌
            grid.warn = UIUtil.CloneUI(this.labQiangHua);
            grid.addChild(grid.warn, 1, 20);
        }

        grid.warn.SetString("可升级")

        grid.warn.visible = true;
        grid.warn.setOpacity(255);
        grid.warn.setPosition(this.labQiangHua.getPosition());
        grid.reorderChild(grid.warn, 10);

        // action
        var actionTo = cc.moveBy(1, cc.p(0, grid.height / 4));
        var trace = cc.callFunc(this._OnTrace, this);
        var out = cc.fadeOut(0.5);
        var ina = cc.fadeIn(0.5);
        var rep = cc.sequence(actionTo, out, trace, ina).repeatForever();
        grid.warn.stopAllActions();
        grid.warn.runAction(rep);
    },

    _OnTrace:function (sender) {
        var pos = this.labQiangHua.getPosition();
        sender.x = pos.x;
        sender.y = pos.y;
    },
} );
ShenZhuangShengJiMainExt.PanelName = "ShenZhuangShengJiMainExt";
PanelClassDic["ShenZhuangShengJiMainExt"] = ShenZhuangShengJiMainExt;
