var XiangqianBagExt = XiangqianBag.extend ( {
	_className:"XiangqianBagExt",

	_gridArr : null,
	_itemsHash : null,

	//5个一页
	_maxCount : 5,
	_curPage : 1,
	_maxPage : 1,

	_equipType : null,
	_stoneType : null,
	modelPanelType:2,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
		this._itemsHash = new HashMap();
	},

	Init:function()
	{
		XiangqianBag.prototype.Init.call( this );

		this.labNumer.visible = false;
		this._gridArr = [this.gridItem, this.gridItem1,this.gridItem2,this.gridItem3,this.gridItem4];

		var self = this;
		this.btnLeft.addClickEventListener(function (event){
			if ( self._curPage > 1 ) {
				self._curPage -= 1;
				self._UpdateGrids();
			}
		});

		this.btnRight.addClickEventListener(function (event){
			if ( self._curPage < self._maxPage ) {
				self._curPage += 1;
				self._UpdateGrids();
			}
		});

		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});
	},

	SetData:function (itemType, equipType, stoneType, operationType) {
        this._curPage = 1;
		this._itemType = itemType;
		this._equipType = equipType;
		this._stoneType = stoneType;
        var objStone = Mgr.gem.GetInlayStoneExt(itemType,equipType, stoneType);
        this._objStone = objStone;

		var sortV = [];
		var bagList = Mgr.backpack.GetItemsByType(EnumItemType.GEM, true);
		for ( var i = 0; i != bagList.length; i++ ) {
			var itemC = Q_item.Get( bagList[i].itemModelId );
			cc.assert(null != itemC, "data is unexist in Q_item!  mid: " + bagList[i].itemModelId);
			if ( itemC.q_location == stoneType ) {
				sortV.push( bagList[i] );
			}
		}

		this._itemsHash.Clear();
		if ( sortV.length > 0 ) {
			sortV.sort(function(a,b){return Q_item.Get( b.itemModelId ).q_rank - Q_item.Get( a.itemModelId ).q_rank;});
			var length = sortV.length;
			//5个一页
			this._maxPage = parseInt(length / this._maxCount);
			var rest = length % this._maxCount;
			if (rest > 0)
				++this._maxPage;

			for (var p = 0; p != this._maxPage; p++) {
				var items = [];
				for (var i = 0; i != this._maxCount; i++) {
					var idx = p * 5 + i;
					if (idx + 1 > length)
						break;
                    if(operationType == StoneGridMarkEnum.REPLACE){
                    	var itemK = Q_item.Get( sortV[idx].itemModelId );
                        if ( itemK.q_location == stoneType && itemK.q_rank > (Q_item.Get(objStone.mid).q_rank))
                            items.push(sortV[idx]);
                    }
                    else
                        items.push(sortV[idx]);
				}
				this._itemsHash.Put(p + 1, items);
			}
		}
		this._UpdateGrids(operationType);
	},

	_UpdateGrids:function () {
		cc.log("---------_UpdateGrids--------" + this._itemsHash.Size());
		for ( var i = 0; i!= this._gridArr.length; i++ ) {
			var grid = this._gridArr[i];
            grid.Clean();
			var stoneV = null;
			var stones =  this._itemsHash.Get( this._curPage );
			if ( stones && (i + 1) <= stones.length ) {
				stoneV = stones[i];
			}

			this.SetGrid( grid, stoneV);
		}

		// page
		var str = String(this._curPage) + "/" + String(this._maxPage);
		this.labNum.SetString(str);
	},

	SetGrid:function ( grid, stoneV ) {
		if (stoneV) {
			// icon
			var icon = ItemUtil.GetItemIcon(stoneV.itemModelId);
			icon.x = (grid.uiWidth - icon.width) / 2;
			icon.y = (grid.uiHeight - icon.height) / 2;
			if(stoneV.itemBind)
                GridUtil.AddLock(grid);
			grid.SetGridIcon(icon);
			grid.stoneV = stoneV;

            /// 战力提升标记,虽然没求用
            var objStone = this._objStone;
            var itemK = Q_item.Get( stoneV.itemModelId );
            if ( objStone == null
                || (objStone && itemK.q_location == this._stoneType && itemK.q_rank > (Q_item.Get(objStone.mid).q_rank))){
                var image = cc.Sprite( EngineMgr.uiMgr.GetResByUrl("public/image/jiantou.png") );
                image.setAnchorPoint(cc.p(0.5,0.5));
                image.x = this.labNumer.x + 70;
                image.y = this.labNumer.y + 80;
                grid.AddDisplay(image);
            }

			// num
			// stone level
			var numLable = new MUILabel();
			numLable.ParseJson( this.labNumer.jsonobj );
			numLable.Init();
			numLable.setPosition( this.labNumer.getPosition() );
			grid.AddDisplay(numLable);
			var str = String(stoneV.itemNum) + "个";
			numLable.SetString(str);

			// callback
			var self = this;
			grid.setTouchEnabled(true);
			grid.addTouchEventListener(function (sender, type) {
				if (type == ccui.Widget.TOUCH_ENDED) {

					var page = sender.parent.parent;
                    var operate = 0;    //操作类型(0是穿戴 1是升级)
                    var itemType = page._itemType;  //宝石系统类型（其实就是资源线类型 -1为人物装备）
                    var equipType = page._equipType;
                    var sid = sender.stoneV.itemId;

                    var pos = 1;
                    var stoneEnum = DuanzaoUtil.GetStoneCondition();
                    for ( var i = 0; i != stoneEnum.length; i++ )  {
                        if ( page._stoneType == stoneEnum[i].type ) {
                            pos = stoneEnum[i].pos;
                            break;
                        }
                    }
                    Mgr.gem.SendReqGemChangeToGameMessage(operate, itemType, equipType, sid, pos);
                    EngineMgr.uiMgr.HidePanel( self );
					// if (Q_item.Get(sender.stoneV.itemModelId).q_rank <= 1) {  //只有1级才能镶嵌
					// }
					// else
					// 	Mgr.tips.ShowNotice( "只有1级宝石才可镶嵌");
				}
			});
		}
	}
} );
XiangqianBagExt.PanelName = "XiangqianBagExt";
PanelClassDic["XiangqianBagExt"] = XiangqianBagExt;
