var AwardZhanshiExt = AwardZhanshi.extend ( {
	_className:"AwardZhanshiExt",

    gridList:null,
    _listView:null,

	ctor:function(){
		this._super();
		this.gridList = [];
        this.layoutCom.layoutOffx = 257;
        this.setLocalZOrder(888);   //开启礼包显示在最上层

        var touchNode = new cc.Node();
        this.addChild(touchNode,0xffffff);
        this.touchNode = touchNode;
	},

    Init:function () {
        AwardZhanshi.prototype.Init.call( this );

        this.InitListView();

        var self=this;
        this.gridItem.visible = false;
        this.btnClose.addClickEventListener(function () {
            if (this.timerId)
                TimerUtil.ClearTimeUpdate(this.timerId, this);
            EngineMgr.uiMgr.HidePanel(self);
        });

        this.btnConfirm.addClickEventListener(function(){
            EngineMgr.uiMgr.HidePanel(self);
        })
    },

    OnShow:function(){
        this._super();

        var self=this;
        this._listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            onTouchBegan: function(){
                return true;
            },
            onTouchCancelled:function(){
                EngineMgr.uiMgr.HidePanel(self);
            },
            onTouchEnded:function(){
                EngineMgr.uiMgr.HidePanel(self);
            },
        });
        this._listener.setSwallowTouches(true);
        cc.eventManager.addListener(this._listener, this.touchNode);
    },

    OnHide:function(){
        this._super();

        if(this._listener){
            cc.eventManager.removeListener(this._listener);
            this._listener = null;
        }
    },

    InitListView:function(){
	    if(!this._listView){
            this._listView = new ccui.ListView();
            this._listView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);//视图滚动方向
            this._listView.setTouchEnabled(true);					//触摸开启
            this._listView.inertiaScrollEnabled = false; 			//滚动惯性
            this._listView.setScrollBarEnabled(false);				//滚动条
            this._listView.setBounceEnabled(true);					//边界回弹
            this.imgFrame.addChild(this._listView);
        }
    },

    SetData:function (itemList,id,num){
        this.btnConfirm.visible = false;
        this.labCue2.visible = true;
        this.labCue21.visible = true;
        var _height = 0;

        this.labCue.SetString("开启礼包");
	    var str = TextUtil.AddColor(Q_item.Get(id).q_name, "2ed515");
	    this.labCue1.SetText("获得" + str + "物品");
	    var i = 0;
	    for(; i < itemList.length; i++){
	        if(!this.gridList[i]){
	            var grid = new MUIGrid();
                grid.ParseJson(this.gridItem.jsonobj);
                grid.Init();
                _height = grid.uiHeight;
                this._listView.pushBackCustomItem(grid);
                this.gridList.push(grid);
            }
            this.gridList[i].visible = true;
            // this.gridList[i].x = this.imgBg.uiWidth/2 - this.gridItem.uiWidth/2*itemList.length + this.gridItem.uiWidth * i;
            var coinInfo = {};
            coinInfo.itemModelId = itemList[i].itemModelId || items[i].mod;
            coinInfo.itemNum = itemList[i].num;
            coinInfo.itemBind = itemList[i].bind;
            GridUtil.SetItemGrid(this.gridList[i],coinInfo);
        }
        for(; i < this.gridList.length; i++){
            this.gridList[i].visible = false;
        }
        this.time = 6;
        this.labCue2.SetText(TextUtil.FormatStr(this.labCue2.GetHtmlText(), [this.time]));
        if (this.timerId)
            TimerUtil.ClearTimeUpdate(this.timerId, this);
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
        this._listView.setSize(cc.size(this.imgFrame.uiWidth, this.imgFrame.uiHeight));
        this._listView.setInnerContainerSize(cc.size(this.imgFrame.uiWidth, itemList.length * _height));

        if(id >= 130 && id < 140){
            var img = new MUIImage();
            img.retain();
            var imageRes="other/zhujiemian/image/num6/exp.png";
            EngineMgr.uiMgr.GetAsynResByUrl(imageRes, function(){
                img.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
                // img.x = img.width/2;
                // img.y = img.height/2;
                img.release();
            }, img);
            this.addChild(img);
            img.x = this.uiWidth + 10;
            img.y = 150;
            var imglabel = new MUIImageLabel();
            imglabel.SetImageUrl("other/zhujiemian/image/num6/0.png");
            var expNum = this.GetExp(id) * num;
            imglabel.SetString(expNum);
            imglabel.x = 45;
            imglabel.y = 2;
            img.addChild(imglabel);

            var action = cc.sequence([new cc.MoveBy(1, cc.p(0, 100)),
                new cc.CallFunc(function(){
                    img.removeFromParent();
                }, this)
            ]);
            img.runAction(action);
        }
	},

    GetExp:function(id){
        switch (id){
            case 130:
                return 100000;
            case 131:
                return 500000;
            case 132:
                return 1000000;
            case 133:
                return 2000000;
            case 134:
                return 5000000;
            case 135:
                return 10000000;
            case 136:
                return 20000000;
            case 137:
                return 50000000;
            case 138:
                return 100000000;
        }
    },

    UpdateWithItemDisplay:function(data){
        data = data || {};
        var type = data.type || 0;
        var title = data.title || "标题";
        var content = data.content || "内容";
        var items = data.items || [];
        var  _height = 0;

        this.labCue.SetString(title);
        this.labCue1.SetString(content);

        var i = 0;
        for(; i < items.length; i++){
            if(!this.gridList[i]){
                var grid = new MUIGrid();
                grid.ParseJson(this.gridItem.jsonobj);
                grid.Init();
                _height = grid.uiHeight;
                this._listView.pushBackCustomItem(grid);
                this.gridList.push(grid);
            }
            this.gridList[i].visible = true;
            // this.gridList[i].x = this.imgBg.uiWidth/2 - this.gridItem.uiWidth/2*items.length + this.gridItem.uiWidth * i;
            var coinInfo = {};
            coinInfo.itemModelId = items[i].itemModelId || items[i].mod;
            coinInfo.itemNum = items[i].num;
            coinInfo.itemBind = items[i].bind;
            GridUtil.SetItemGrid(this.gridList[i],coinInfo);
        }
        for(; i < this.gridList.length; i++){
            this.gridList[i].visible = false;
        }

        this.btnConfirm.visible = type;
        this.labCue2.visible = !type;
        this.labCue21.visible = !type;
        if(!type){
            this.time = 6;
            this.labCue2.SetText(TextUtil.FormatStr(this.labCue2.GetHtmlText(), [this.time]));
            if (this.timerId)
                TimerUtil.ClearTimeUpdate(this.timerId, this);
            this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
        }
        this._listView.setSize(cc.size(this.imgFrame.uiWidth, this.imgFrame.uiHeight));
        this._listView.setInnerContainerSize(cc.size(this.imgFrame.uiWidth, items.length * _height));
    },

    OnTimer:function(){
        this.time--;
        if(this.time <= 0){
            TimerUtil.ClearTimeUpdate(this.timerId, this);
            EngineMgr.uiMgr.HidePanel(this);
        }
        this.labCue2.SetText(TextUtil.FormatStr(this.labCue2.GetHtmlText(), [this.time]));
    },
} );
AwardZhanshiExt.PanelName = "AwardZhanshiExt";
PanelClassDic["AwardZhanshiExt"] = AwardZhanshiExt;
