﻿var EquipModMgr = cc.Class.extend({

    ctor:function() {
        this._equips = [];
    },

    InitEquip:function(equips){
        this._equips = equips.concat();
    },

    ChangEquip:function(equipType, equip){
        var equips = this.GetEquipsByType(equipType);

        var itemC = Q_item.Get(equip.itemModelId);
        var index = equips.findIndex(function(v){
            var itemCV = Q_item.Get(v.itemModelId);
            return itemCV.q_kind == itemC.q_kind;
        })

        if(index >= 0){
            equips.splice(index,1);
        }
        equips.push(equip);

        GameEventMgr.DispatchEvent(EnumEventType.GAME_EQUIP_CHANGED);
    },

    UnWearEquip:function(equipType, equipId){
        var equips = this.GetEquipsByType(equipType);

        var gid = equipId.toGID();
        var index = equips.findIndex(function(v){
            return v.itemId.toGID() == gid;
        })

        if(index < 0) return;
        equips.splice(index,1);

        GameEventMgr.DispatchEvent(EnumEventType.GAME_EQUIP_CHANGED);
    },

    GetEquipsByType:function(equipType){
        var equips = this._equips.find(function(v){
            return v.equipType == equipType;
        });
        if(!equips){
            equips = { equipType : equipType, equips : []};
            this._equips.push(equips);
        }
        equips = equips.equips;
        return equips;
    },

    //根据部位获取穿戴的装备
    GetEquipByType:function(type,kind){
        var resT = Mgr.resline.GetResTypeByEquipType(type);
        var equips = resT ? Mgr.resline.GetMgrByType( resT ).GetEquip() : this.GetEquipsByType(type);
        if(equips) {
            var len = equips.length;
            for (var i = 0; i < len; ++i) {
                if (equips[i] && equips[i].itemModelId) {
                    var equip = Q_item.Get(equips[i].itemModelId);
                    if (kind == equip.q_kind && type == equip.q_type) return equips[i];
                }
            }
        }
        return null;
    },

    /**
     * 获得基础属性
     * @param atype  要获得的属性的类型 从这个枚举获取 AttributeEnum
     * @param eqInfo 裝備信息
     */
    GetAttribute:function( atype, itemModelId, refineLv )
    {
        refineLv = arguments[2] ? arguments[2] : -1;//设置参数refineLv的默认值为-1
        var iteminfo = Q_item_simpact.Get(itemModelId);
        if( !iteminfo )
            return 0;
        var baseAtt ;
        switch(atype) {
            case EnumAttribute.ATTACK:
                baseAtt = Mgr.attributeMgr.GetAttribute( EnumAttribute.ATTACK, iteminfo.q_attack, refineLv );
                break;
            case EnumAttribute.DEFEND:
                baseAtt = Mgr.attributeMgr.getAttribute( EnumAttribute.DEFEND, iteminfo.q_defence, refineLv );
                break;
            case EnumAttribute.CRIT:
                baseAtt = Mgr.attributeMgr.getAttribute( EnumAttribute.CRIT, iteminfo.q_crit, refineLv );
                break;
            case EnumAttribute.DODGE:
                baseAtt = Mgr.attributeMgr.getAttribute( EnumAttribute.DODGE, iteminfo.q_dodge, refineLv );
                break;
            case EnumAttribute.MAX_BASEHP:
                baseAtt = Mgr.attributeMgr.getAttribute( EnumAttribute.MAX_BASEHP, iteminfo.q_max_hp, refineLv );
                break;
            case EnumAttribute.MAX_BASEMP:
//					baseAtt = Mgr.attributeMgr.getAttribute( EnumAttribute.MAX_BASEMP, iteminfo.q_max_mp );
                break;
            case EnumAttribute.MAX_BASESP:
//					baseAtt = Mgr.attributeMgr.getAttribute( EnumAttribute.MAX_BASESP, iteminfo.q_max_sp );
                break;
            case EnumAttribute.ATTACK_SPEED:
                baseAtt = Mgr.attributeMgr.getAttribute( EnumAttribute.ATTACK_SPEED, iteminfo.q_attackspeed, refineLv );
                break;
            case EnumAttribute.MOVE_SPEED:
                baseAtt = Mgr.attributeMgr.getAttribute( EnumAttribute.MOVE_SPEED, iteminfo.q_speed, refineLv );
                break;
            case EnumAttribute.ANTI_CRIT:
                baseAtt = Mgr.attributeMgr.getAttribute( EnumAttribute.ANTI_CRIT, iteminfo.q_antiCrit, refineLv );
                break;
            default:
        }
        return baseAtt;
    },

    /**
     * 获得附加属性
     * @param atype  要获得的属性的类型 从这个枚举获取 AttributeEnum
     * @param equ 裝備信息Item
     */
    GetAddAttribute:function( atype, equ ) {
        var addNum = 0;
        const attrs = equ.GetItemAttributes().concat();
        for( var i = 0; i < attrs.length; i++ )
        {
            if( attrs[i].type == atype )
                addNum += attrs[i].value;
        }
        return addNum;
    },

    RecvWearEquipItemMessage:function(msg) {
        this.ChangEquip(msg.itemType,msg.equip);

        // 更新装备界面
        var equipUI = Mgr.uiMgr.GetPanelByType(PlayerPanelExt.PanelName);
        if ( equipUI && equipUI.visible )
        {
            equipUI._equipPanel.UpdateInfo();
        }

        // 强化不需提示
        if ( Mgr.refining.qianhua_mark ) {
            Mgr.refining.qianhua_mark = false;
            return;
        }
        //装备提示
        // var panel = Mgr.uiMgr.ShowPanelByType(NewEquipCueExt.PanelName, UIMgr.PANEL_LAYER_POP);
        // panel.ShowNewEquipment(msg);
        // var panel = Mgr.uiMgr.GetPanelByType(BackpackPanelExt.PanelName);	这里应该是不需要的 背包那边删除物品自行处理
        // if(Mgr.uiMgr.IsPanelShow(panel)){
        // 	panel.SetItemShow();
        // }

         // 刷新包裹装备的战力提示状态
         var panel = Mgr.uiMgr.GetPanelByType(BackpackPanelExt.PanelName);
         if(Mgr.uiMgr.IsPanelShow(panel)){
            panel.UpdateShowItem();
         }
    },

    RecvUnwearEquipItemMessage:function(msg) {
        this.UnWearEquip(msg.itemType,msg.itemId);

        var equipUI = Mgr.uiMgr.GetPanelByType(PlayerPanelExt.PanelName);
        if ( equipUI && equipUI.visible )
        {
            equipUI._equipPanel.UpdateInfo();
        }

        // 刷新包裹装备的战力提示状态
        var panel = Mgr.uiMgr.GetPanelByType(BackpackPanelExt.PanelName);
        if(Mgr.uiMgr.IsPanelShow(panel)){
            panel.UpdateShowItem();
        }
    },
    SendWearEquipMessage:function(itemId) {
        var msg = new WearEquipMessage();
        msg.itemId = itemId;
        Mgr.msgMgr.Send(msg);
    },
    //卸下装备
    SendUnwearEquipMessage:function(itemId, cellId, type) {
        var msg = new UnwearEquipMessage();
        msg.itemId = itemId;
        msg.cellId = cellId?cellId:0;
        msg.itemType = type;
        Mgr.msgMgr.Send(msg);
    },

    GetEquips:function()
    {
        //装备信息
        var equips = this.GetEquipsByType(EnumItemType.Equip);
        var equipArr = [];
        for ( var i = 0; i < equips.length; i++ )
        {
            //获取装备类别
            var typeObj = Q_item.Get(equips[i].itemModelId);
            if (typeObj)
            {
                //获取装备属性
                var propObj = Q_item_simpact.Get(equips[i].itemModelId);
                var obj = {item:equips[i],typeObj:typeObj, propObj:propObj};
                equipArr.push(obj);
            }
        }
        return equipArr;
    }
});