/**
 * Created by merlin on 2016/6/6.
 */
var BloodSpr = BloodSpr || cc.Node.extend({
    _sprites:null,
    _specicalImg:null,
    ctor:function(){
        this._super();
        this._sprites = [];
        this._specicalImg = new cc.Sprite();
        this.addChild(this._specicalImg, -1);
        this.setCascadeOpacityEnabled (true);
    },

    SetData:function(damage, type, isMainPlayer ){
        var str = damage.toString();
        var num = [];
        var i;
        var len;
        var path;
        if( type != EnumResultType.JUMPMISS && type != EnumResultType.MISS && type != EnumResultType.HOLYSHIT ){
        	var path = BloodSpr.NORMAL_PATH;
            if( type == EnumResultType.RECOVER ){
            	path = BloodSpr.RECOVER_PATH;
            	str = "+" + str;
            }
            else{
            	if( type == EnumResultType.CRIT )
            		path = BloodSpr.CRIT_PATH;
            	else if( isMainPlayer )
            		path = BloodSpr.SELF_PATH;
                else if( type == EnumResultType.PET )
                    path = BloodSpr.PET_PATH;
            	else
            		path = BloodSpr.NORMAL_PATH;
            	str = "-" + str;
            }
            len = str.length;
            var startL = -len * 0.5;
            for( i = 0; i < len; i++ ){
                var spr;
                if( this._sprites.length > i ){
                    spr = this._sprites[i];
                }
                else{
                    spr = new cc.Sprite();
                    this._sprites.push(spr);
                    this.addChild(spr);
                }
                var imgUrl = path + str.substr( i, 1 ) + ".png"
                spr.setSpriteFrame( EngineMgr.uiMgr.GetResByUrl( imgUrl ) );
                spr.x = ( i + startL ) * spr.getContentSize().width;
                spr.visible = true;
            }
            len = this._sprites.length;
            for( ; i < len; i++ ){
                this._sprites[i].visible = false;
            }
        }
        var sPath;
        if( type == EnumResultType.CRIT )
        	sPath = BloodSpr.CRIT_BG;
        else if( type == EnumResultType.MISS )
        	sPath = BloodSpr.MISS;
        else if( type == EnumResultType.JUMPMISS )
        	sPath = BloodSpr.JUMPMISS;
        else if( type == EnumResultType.HOLYSHIT )
        	sPath = BloodSpr.HOLYSHIT;
        
        if( sPath ){
        	this._specicalImg.setSpriteFrame( EngineMgr.uiMgr.GetResByUrl( sPath ) );
        	if( type == EnumResultType.CRIT ){
        		this._specicalImg.x = this._sprites[0].x - 30;
        		this._specicalImg.y = -8;
        	}
        	else {
        		this._specicalImg.x = 0;
        		this._specicalImg.y = 0;
        	}
            this._specicalImg.visible = true;
        }
        else{
        	this._specicalImg.visible = false;
        }
    },
    OnRecycle:function(){
        this.setOpacity(255);
        this.setScale(1);
        this.removeFromParent(true);
    },
    OnRevert:function(){
    },
    Dispose:function () {
        this._specicalImg = null;
        this.removeFromParent(true);
        this.release();
    },
});

BloodSpr.oPool = new MCachePool();
BloodSpr.oPool.SetSize( 100 );
BloodSpr.Create = function(){
    var o = BloodSpr.oPool.Gain();
    if( !o ){
        o = new BloodSpr();
        o.retain();
    }
    return o;
};
BloodSpr.Delete = function(o){
    if( o ){
        BloodSpr.oPool.Recycle(o);
    }
};

BloodSpr.NORMAL_PATH = "public/image/num/yellow_shangxue/";
BloodSpr.CRIT_PATH = "public/image/num/baoji/";
BloodSpr.SELF_PATH = "public/image/num/red_shangxue/";
BloodSpr.RECOVER_PATH = "public/image/num/brue_shangxue/";
BloodSpr.PET_PATH = "public/image/num/zi_shangxue/";

BloodSpr.CRIT_BG = "public/image/num/baoji/bj.png";
BloodSpr.MISS = "public/image/num/miss.png";
BloodSpr.JUMPMISS = "public/image/num/tiaosan.png";
BloodSpr.HOLYSHIT = "public/image/num/wudi.png";

