
var DropGoodsModMgr = DropGoodsModMgr || cc.Class.extend({
    _sprMap:null,

    // type
    _gold_type:1,

    ctor:function(){
       // this._super();
        this._sprMap = {};
    },

    _filterSpr:function (type, dropNum) {
        var list = [];
        if ( !this._sprMap[type] ) {
            this._sprMap[type] = [];
        }
        for ( var i = 0; i != dropNum; i++ ) {
            var spr = this._sprMap[type][i];
            if ( !spr || spr.ifWorking ) {
                var spr = new cc.Sprite();
                var imgUrl = DropGoodsModMgr.GOLDURL;   // 默认元宝
                if ( type == this._gold_type )
                    imgUrl = DropGoodsModMgr.GOLDURL;
                spr.setSpriteFrame( EngineMgr.uiMgr.GetResByUrl( imgUrl ) );
                spr.retain();
                this._sprMap[type].push(spr);
            }
            spr.ifWorking = true;
            list.push(spr);
        }
        return list;
    },

    _CreateParabolaAnimal:function (t, startPoint,endPoint, height, angle) {

        // zz.Error("----------------------------   move: " + startPt.x + ", " + startPt.y + "     endPt: " + endPt.x + ", " + endPt.y)
        // var move1 = new cc.MoveTo(times*0.5,cc.p(endPt.x-startPt.x, startPt.y));
        // var move2 = new cc.MoveTo(times,cc.p(startPt.x, endPt.y-startPt.y));
        // var act1 = move1/*.easing(cc.easeOut(times*0.3))*/;
        // var act2 = move2/*.easing(cc.easeOut(times*0.2))*/;
        // return cc.Spawn(act1,act2);


        // 把角度转换为弧度
        var radian = angle * Math.PI / 180.0;
        // 第一个控制点为抛物线左半弧的中点
        var q1x = startPoint.x + (endPoint.x - startPoint.x) / 4.0;
        var q1 = cc.p(q1x, height + startPoint.y + Math.cos(radian) * q1x);
        // 第二个控制点为整个抛物线的中点
        var q2x = startPoint.x + (endPoint.x - startPoint.x)/2.0;
        var q2 = cc.p(q2x, height + startPoint.y + Math.cos(radian) * q2x);

        //曲线配置
        //zz.Error("**************************   q1:" + q1.x + " " + q1.y + "   q2: "+ q2.x + " " + q2.y + "   endPoint: "+ endPoint.x + " " + endPoint.y)
        var bezier2 = [q1, q2, endPoint];
        return cc.bezierTo(t,bezier2).easing(cc.easeIn(t*0.3));
    },

    _ShowDropEffect:function (target, spr) {
        spr.x = 0;
        spr.y = 0;
       // spr.opacity = 0;
        spr.scale = 0.5;
        if ( !spr.parent )
            target.addChild( spr );
        //var spawn1=cc.Spawn(cc.ScaleTo(0.3,1.0),cc.FadeOut(0.3));

        var times = Math.random() * 1.5;
        times = times < 0.9 ? 0.9 : times;
        var startPt = cc.p(Math.random() * 100 - 50, Math.random()*0);
        var end_x = Math.random() * 300 - 150;
        var end_y = Math.random() * 100 ;
        end_x = Math.abs(end_x) < 30 ? (end_x>0?30:-30) : end_x;
        end_y = end_y > -40 ? -40 : end_y;
        var endPt = cc.p(end_x, end_y);
        var height = Math.random() * 50 + 300;
        var angle = Math.random() * 50 + 10;

        var action = this._CreateParabolaAnimal( times, startPt, endPt, height, angle );
        var spawn2=cc.Spawn(cc.ScaleTo(times*0.5,1.2),cc.FadeIn(times*0.5), action);
        var callback = new cc.CallFunc( this.OnShowDamageEnd, spr );
        var seques=cc.Sequence(spawn2, callback);
        spr.runAction(seques);

    },

    OnShowDamageEnd:function( spr ){
        spr.ifWorking = false;
        //spr.opacity = 0;
        spr.stopAllActions();
        if ( spr.parent )
            spr.removeFromParent(true);
        spr = null;
    },

    Show:function (target, type, dropNum) {
        var self = this;
        var sprs = this._filterSpr(type, dropNum);
        if ( sprs.length > 0 ) {
            for ( var i = 0; i != sprs.length; i++ ) {
                (function (spr,tar, self) {
                    var sec = Math.random() * 200 + 200;
                    TimerUtil.SetTimeout( self, self._ShowDropEffect, sec,tar,spr);
                })(sprs[i],target, self)
            }
        }
        else {
            zz.Error("funk!!! 掉落展示数量小于1了!!!!");
        }
    },
});

DropGoodsModMgr.GOLDURL = "public/image/yuanbao.png";

