///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//AttackResultInfo 游戏实体战斗结果

// 请求消息
//102201,ReqAttackMonster 攻击怪物请求
//102202,ReqAttackPlayer 攻击玩家请求
//102203,ReqChangeAttackTarget 切换攻击锁定目标
//102204,ReqAttackPet 攻击侍宠请求
//102205,ReqAttackVentToGame 攻击地面空放魔法
//102206,ReqAttackSingingToGame 请求吟唱
//102207,ReqAttackBreakSingingToGame 前端发起打断吟唱(预留,一般情况后端主动打断)
//102212,ReqReslineAttack 各种资源线跟宠请求攻击

// 接收消息
//102101,ResFightBroadcast 战斗广播
//102102,ResAttackResult 攻击结果
//102103,ResAttackRange 攻击范围(测试专用)
//102104,ResEffectBroadcast 特效广播
//102105,ResFightFailedBroadcast 战斗失败广播
//102106,ResFightFinishBroadcast 行进魔法,攻击结束广播
//102107,ResAttackVentToClient 攻击地面坐标广播(应该和战斗广播是一样的,收到这个消息表示技能成功)
//102108,ResAttackSingingToClient 广播吟唱(前端收到这个消息后开始吟唱,吟唱结束后,选目标,发攻击请求)
//102109,ResAttackBreakSingingToClient 广播打断吟唱,如果前端已经发了攻击请求,后端还有验证当前吟唱时间到达没
//102111,ResSkillClickFly 击飞技能效果
//102113,ResClearSkillCD 清除技能cd
//102114,ResRepel 怪物被击退
//102117,ResreslineAttackResult 跟宠资源线攻击结果
//102118,ResreslineAttackFaliedResult 跟宠资源线攻击结果


var AttackResultInfo = cc.Class.extend({
	ctor:function(){
		this.entityId = null; // 实体Id
        this.sourceId = null; // 攻击来源Id
        this.hit = 0; // 连击伤害
        this.skillLevel = 0; // 攻击技能等级
        this.fightResult = 0; // 攻击结果0-成功 1-MISS 2-跳闪 4-暴击 8-格挡6-跳闪+暴击 12-格挡+暴击
        this.damage = 0; // 伤害
        this.back = 0; // 反伤
        this.skillId = 0; // 攻击技能模板Id
        this.effectsid = 0; // 攻击技能特效ID
	},

	writing:function( _buf ){
		_buf.WriteLong(this.entityId);
        _buf.WriteLong(this.sourceId);
        _buf.WriteVarInt(this.hit);
        _buf.WriteVarInt(this.skillLevel);
        _buf.WriteVarInt(this.fightResult);
        _buf.WriteVarLong(this.damage);
        _buf.WriteVarInt(this.back);
        _buf.WriteVarInt(this.skillId);
        _buf.WriteByte(this.effectsid);
	},
	
	reading:function( _buf ){
		this.entityId = _buf.ReadLong();
        this.sourceId = _buf.ReadLong();
        this.hit = _buf.ReadVarInt();
        this.skillLevel = _buf.ReadVarInt();
        this.fightResult = _buf.ReadVarInt();
        this.damage = _buf.ReadVarLong();
        this.back = _buf.ReadVarInt();
        this.skillId = _buf.ReadVarInt();
        this.effectsid = _buf.ReadByte();
	},
});
////////////////////
// 战斗广播 //
////////////////////
var ResFightBroadcastMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.fightDirection = 0; // 攻击朝向
        this.fightType = 0; // 攻击类型
        this.fightTarget = null; // 攻击目标
        this.effects = 0; // 攻击特效(目前只有平砍有)
	},

	getId:function(){
		return 102101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteByte(this.fightDirection);
        _buf.WriteVarInt(this.fightType);
        _buf.WriteLong(this.fightTarget);
        _buf.WriteByte(this.effects);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.fightDirection = _buf.ReadByte();
        this.fightType = _buf.ReadVarInt();
        this.fightTarget = _buf.ReadLong();
        this.effects = _buf.ReadByte();
	},

	action:function(){
		Mgr.fight.RecvResFightBroadcastMessage(this);
	},

});
////////////////////
// 攻击结果 //
////////////////////
var ResAttackResultMessage = cc.Class.extend( {
	ctor:function(){
		this.state = null; // 攻击结果
	},

	getId:function(){
		return 102102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.state);
	},
	
	reading:function( _buf ){
        this.state = _buf.ReadBean(AttackResultInfo);
	},

	action:function(){
		Mgr.fight.RecvResAttackResultMessage(this);
	},

});
////////////////////
// 攻击范围(测试专用) //
////////////////////
var ResAttackRangeMessage = cc.Class.extend( {
	ctor:function(){
		this.grids = []; // 格子列表 int
	},

	getId:function(){
		return 102103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.grids.length );
        for (var i = 0; i < this.grids.length; i++) {
            _buf.WriteVarInt(this.grids[i]);
        }
	},
	
	reading:function( _buf ){
        var grids_length = _buf.ReadShort();
        for (var i = 0; i < grids_length; i++) {
            this.grids[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.fight.RecvResAttackRangeMessage(this);
	},

});
////////////////////
// 特效广播 //
////////////////////
var ResEffectBroadcastMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.fightDirection = 0; // 攻击朝向
        this.fightType = 0; // 攻击类型
        this.fightTarget = null; // 攻击目标
	},

	getId:function(){
		return 102104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteByte(this.fightDirection);
        _buf.WriteVarInt(this.fightType);
        _buf.WriteLong(this.fightTarget);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.fightDirection = _buf.ReadByte();
        this.fightType = _buf.ReadVarInt();
        this.fightTarget = _buf.ReadLong();
	},

	action:function(){
		Mgr.fight.RecvResEffectBroadcastMessage(this);
	},

});
////////////////////
// 战斗失败广播 //
////////////////////
var ResFightFailedBroadcastMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.fightDirection = 0; // 攻击朝向
        this.fightType = 0; // 攻击类型
	},

	getId:function(){
		return 102105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteByte(this.fightDirection);
        _buf.WriteVarInt(this.fightType);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.fightDirection = _buf.ReadByte();
        this.fightType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.fight.RecvResFightFailedBroadcastMessage(this);
	},

});
////////////////////
// 行进魔法,攻击结束广播 //
////////////////////
var ResFightFinishBroadcastMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 102106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.fight.RecvResFightFinishBroadcastMessage(this);
	},

});
////////////////////
// 攻击地面坐标广播(应该和战斗广播是一样的,收到这个消息表示技能成功) //
////////////////////
var ResAttackVentToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 角色Id
        this.fightType = 0; // 攻击类型(技能ID)
        this.fightDirection = 0; // 攻击朝向
        this.x = 0; // 攻击坐标x(格子坐标)
        this.y = 0; // 攻击坐标y(格子坐标)
        this.effects = 0; // 攻击特效(目前只有平砍有)
	},

	getId:function(){
		return 102107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteVarInt(this.fightType);
        _buf.WriteByte(this.fightDirection);
        _buf.WriteShort(this.x);
        _buf.WriteShort(this.y);
        _buf.WriteByte(this.effects);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
        this.fightType = _buf.ReadVarInt();
        this.fightDirection = _buf.ReadByte();
        this.x = _buf.ReadShort();
        this.y = _buf.ReadShort();
        this.effects = _buf.ReadByte();
	},

	action:function(){
		Mgr.fight.RecvResAttackVentToClientMessage(this);
	},

});
////////////////////
// 广播吟唱(前端收到这个消息后开始吟唱,吟唱结束后,选目标,发攻击请求) //
////////////////////
var ResAttackSingingToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 角色Id
        this.fightType = 0; // 攻击类型(技能ID)
        this.fightDirection = 0; // 攻击朝向
	},

	getId:function(){
		return 102108;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteVarInt(this.fightType);
        _buf.WriteByte(this.fightDirection);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
        this.fightType = _buf.ReadVarInt();
        this.fightDirection = _buf.ReadByte();
	},

	action:function(){
		Mgr.fight.RecvResAttackSingingToClientMessage(this);
	},

});
////////////////////
// 广播打断吟唱,如果前端已经发了攻击请求,后端还有验证当前吟唱时间到达没 //
////////////////////
var ResAttackBreakSingingToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 角色Id
	},

	getId:function(){
		return 102109;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
	},

	action:function(){
		Mgr.fight.RecvResAttackBreakSingingToClientMessage(this);
	},

});
////////////////////
// 击飞技能效果 //
////////////////////
var ResSkillClickFlyMessage = cc.Class.extend( {
	ctor:function(){
		this.skillModel = 0; // 技能model
        this.entityId = null; // 实体id
        this.speed = 0; // 速度
        this.pos = null; // 击退终点
	},

	getId:function(){
		return 102111;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.skillModel);
        _buf.WriteLong(this.entityId);
        _buf.WriteVarInt(this.speed);
        _buf.WriteBean(this.pos);
	},
	
	reading:function( _buf ){
        this.skillModel = _buf.ReadVarInt();
        this.entityId = _buf.ReadLong();
        this.speed = _buf.ReadVarInt();
        this.pos = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.fight.RecvResSkillClickFlyMessage(this);
	},

});
////////////////////
// 清除技能cd //
////////////////////
var ResClearSkillCDMessage = cc.Class.extend( {
	ctor:function(){
		this.skillIds = []; // 被清除冷却的技能id int
	},

	getId:function(){
		return 102113;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.skillIds.length );
        for (var i = 0; i < this.skillIds.length; i++) {
            _buf.WriteVarInt(this.skillIds[i]);
        }
	},
	
	reading:function( _buf ){
        var skillIds_length = _buf.ReadShort();
        for (var i = 0; i < skillIds_length; i++) {
            this.skillIds[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.fight.RecvResClearSkillCDMessage(this);
	},

});
////////////////////
// 怪物被击退 //
////////////////////
var ResRepelMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterid = null; // 怪物ID
        this.position = null; // 怪物后退坐标
	},

	getId:function(){
		return 102114;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.monsterid);
        _buf.WriteBean(this.position);
	},
	
	reading:function( _buf ){
        this.monsterid = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.fight.RecvResRepelMessage(this);
	},

});
////////////////////
// 跟宠资源线攻击结果 //
////////////////////
var ResreslineAttackResultMessage = cc.Class.extend( {
	ctor:function(){
		this.ownerId = null; // 主人Id
        this.targetId = null; // 目标id
        this.resType = 0; // 资源线类型
        this.otherType = 0; // 其他跟宠类型（跟资源线类型互斥）
        this.damage = 0; // 伤害
        this.skillModel = 0; // 使用技能model
        this.fightResult = 0; // 攻击结果0-成功 1-MISS 2-跳闪 4-暴击 8-格挡6-跳闪+暴击 12-格挡+暴击
	},

	getId:function(){
		return 102117;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.ownerId);
        _buf.WriteLong(this.targetId);
        _buf.WriteByte(this.resType);
        _buf.WriteShort(this.otherType);
        _buf.WriteVarInt(this.damage);
        _buf.WriteVarInt(this.skillModel);
        _buf.WriteVarInt(this.fightResult);
	},
	
	reading:function( _buf ){
        this.ownerId = _buf.ReadLong();
        this.targetId = _buf.ReadLong();
        this.resType = _buf.ReadByte();
        this.otherType = _buf.ReadShort();
        this.damage = _buf.ReadVarInt();
        this.skillModel = _buf.ReadVarInt();
        this.fightResult = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.fight.RecvResreslineAttackResultMessage(this);
	},

});
////////////////////
// 跟宠资源线攻击结果 //
////////////////////
var ResreslineAttackFaliedResultMessage = cc.Class.extend( {
	ctor:function(){
		this.resType = 0; // 资源线类型
        this.otherType = 0; // 其他跟宠类型（跟资源线类型互斥）
        this.faliedType = 0; // 失败原因
	},

	getId:function(){
		return 102118;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.resType);
        _buf.WriteShort(this.otherType);
        _buf.WriteVarInt(this.faliedType);
	},
	
	reading:function( _buf ){
        this.resType = _buf.ReadByte();
        this.otherType = _buf.ReadShort();
        this.faliedType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.fight.RecvResreslineAttackFaliedResultMessage(this);
	},

});
////////////////////
// 攻击怪物请求 //
////////////////////
var ReqAttackMonsterMessage = cc.Class.extend( {
	ctor:function(){
		this.fightType = 0; // 攻击类型(技能ID)
        this.fightDirection = 0; // 攻击朝向
        this.effectsid = 0; // 前端自定义信息(动作,状态)
        this.fightTarget = null; // 攻击目标
	},

	getId:function(){
		return 102201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.fightType);
        _buf.WriteByte(this.fightDirection);
        _buf.WriteByte(this.effectsid);
        _buf.WriteLong(this.fightTarget);
	},
	
	reading:function( _buf ){
        this.fightType = _buf.ReadVarInt();
        this.fightDirection = _buf.ReadByte();
        this.effectsid = _buf.ReadByte();
        this.fightTarget = _buf.ReadLong();
	},

});
////////////////////
// 攻击玩家请求 //
////////////////////
var ReqAttackPlayerMessage = cc.Class.extend( {
	ctor:function(){
		this.fightType = 0; // 攻击类型(技能ID)
        this.fightDirection = 0; // 攻击朝向
        this.effectsid = 0; // 前端自定义信息(动作,状态)
        this.fightTarget = null; // 攻击目标
	},

	getId:function(){
		return 102202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.fightType);
        _buf.WriteByte(this.fightDirection);
        _buf.WriteByte(this.effectsid);
        _buf.WriteLong(this.fightTarget);
	},
	
	reading:function( _buf ){
        this.fightType = _buf.ReadVarInt();
        this.fightDirection = _buf.ReadByte();
        this.effectsid = _buf.ReadByte();
        this.fightTarget = _buf.ReadLong();
	},

});
////////////////////
// 切换攻击锁定目标 //
////////////////////
var ReqChangeAttackTargetMessage = cc.Class.extend( {
	ctor:function(){
		this.targetType = 0; // 攻击目标类型 1玩家 2怪物 3侍宠
        this.targetId = null; // 目标唯一标识
	},

	getId:function(){
		return 102203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.targetType);
        _buf.WriteLong(this.targetId);
	},
	
	reading:function( _buf ){
        this.targetType = _buf.ReadVarInt();
        this.targetId = _buf.ReadLong();
	},

});
////////////////////
// 攻击侍宠请求 //
////////////////////
var ReqAttackPetMessage = cc.Class.extend( {
	ctor:function(){
		this.fightType = 0; // 攻击类型(技能ID)
        this.fightDirection = 0; // 攻击朝向
        this.fightTarget = null; // 攻击目标
        this.owherId = null; // 主人ID
	},

	getId:function(){
		return 102204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.fightType);
        _buf.WriteVarInt(this.fightDirection);
        _buf.WriteLong(this.fightTarget);
        _buf.WriteLong(this.owherId);
	},
	
	reading:function( _buf ){
        this.fightType = _buf.ReadVarInt();
        this.fightDirection = _buf.ReadVarInt();
        this.fightTarget = _buf.ReadLong();
        this.owherId = _buf.ReadLong();
	},

});
////////////////////
// 攻击地面空放魔法 //
////////////////////
var ReqAttackVentToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.fightType = 0; // 攻击类型(技能ID)
        this.fightDirection = 0; // 攻击朝向
        this.effectsid = 0; // 前端自定义信息(动作,状态)
        this.x = 0; // 攻击坐标x(格子坐标)
        this.y = 0; // 攻击坐标y(格子坐标)
	},

	getId:function(){
		return 102205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.fightType);
        _buf.WriteByte(this.fightDirection);
        _buf.WriteByte(this.effectsid);
        _buf.WriteShort(this.x);
        _buf.WriteShort(this.y);
	},
	
	reading:function( _buf ){
        this.fightType = _buf.ReadVarInt();
        this.fightDirection = _buf.ReadByte();
        this.effectsid = _buf.ReadByte();
        this.x = _buf.ReadShort();
        this.y = _buf.ReadShort();
	},

});
////////////////////
// 请求吟唱 //
////////////////////
var ReqAttackSingingToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.fightType = 0; // 攻击类型(技能ID)
        this.fightDirection = 0; // 攻击朝向
	},

	getId:function(){
		return 102206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.fightType);
        _buf.WriteVarInt(this.fightDirection);
	},
	
	reading:function( _buf ){
        this.fightType = _buf.ReadVarInt();
        this.fightDirection = _buf.ReadVarInt();
	},

});
////////////////////
// 前端发起打断吟唱(预留,一般情况后端主动打断) //
////////////////////
var ReqAttackBreakSingingToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 102207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 各种资源线跟宠请求攻击 //
////////////////////
var ReqReslineAttackMessage = cc.Class.extend( {
	ctor:function(){
		this.targetType = 0; // 目标类型(0怪物 1玩家)
        this.fightTarget = null; // 攻击目标
        this.skillModel = 0; // 使用技能id
        this.resType = 0; // 资源线类型
        this.otherType = 0; // 其他跟宠类型（跟资源线类型互斥）
	},

	getId:function(){
		return 102212;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.targetType);
        _buf.WriteLong(this.fightTarget);
        _buf.WriteVarInt(this.skillModel);
        _buf.WriteByte(this.resType);
        _buf.WriteShort(this.otherType);
	},
	
	reading:function( _buf ){
        this.targetType = _buf.ReadByte();
        this.fightTarget = _buf.ReadLong();
        this.skillModel = _buf.ReadVarInt();
        this.resType = _buf.ReadByte();
        this.otherType = _buf.ReadShort();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(102101, ResFightBroadcastMessage);
MESSAGE_POOL.Add(102102, ResAttackResultMessage);
MESSAGE_POOL.Add(102103, ResAttackRangeMessage);
MESSAGE_POOL.Add(102104, ResEffectBroadcastMessage);
MESSAGE_POOL.Add(102105, ResFightFailedBroadcastMessage);
MESSAGE_POOL.Add(102106, ResFightFinishBroadcastMessage);
MESSAGE_POOL.Add(102107, ResAttackVentToClientMessage);
MESSAGE_POOL.Add(102108, ResAttackSingingToClientMessage);
MESSAGE_POOL.Add(102109, ResAttackBreakSingingToClientMessage);
MESSAGE_POOL.Add(102111, ResSkillClickFlyMessage);
MESSAGE_POOL.Add(102113, ResClearSkillCDMessage);
MESSAGE_POOL.Add(102114, ResRepelMessage);
MESSAGE_POOL.Add(102117, ResreslineAttackResultMessage);
MESSAGE_POOL.Add(102118, ResreslineAttackFaliedResultMessage);

