﻿var FightModMgr = FightModMgr || cc.Class.extend({ 

	ctor:function() {	
	},

	/**
	 * 根据属性列表获取属性列表增加的战斗力
	 * */
	GetAttrsPowerList:function(list, zhuanshengLv)
	{
		zhuanshengLv = zhuanshengLv?zhuanshengLv:-1;

		if( zhuanshengLv == -1 )
			zhuanshengLv = 0;
		var ret = 0;
		for (var i = 0; i < list.length; i++)
		{
			var reslValue = list[i].value;
			var forValue = Mgr.attributeMgr.GetAttributeRate(list[i].type, zhuanshengLv);
			ret += (reslValue * forValue);
		}

		return Math.round(ret);
	},

	RecvResFightBroadcastMessage:function(msg) {
		var src = Mgr.sceneObj.FindObject(msg.personId.toGID());
		var dst = Mgr.sceneObj.FindObject(msg.fightTarget.toGID());

		if (src == null && dst == null)
			return;

		if (src != null) {
			Profiler.LogFight("RecvResFightBroadcastMessage");
			var dir = msg.fightDirection;// ToolMap.CalcDirSlant(src.gridPt, ToolMap.PixPt2GridPt(msg.x, msg.y));
			if (dst != null){
				dir = ToolMap.CalcDirSlant(src.GetGridPt(), dst.GetGridPt());
			}
			var skillmid = msg.fightType;
			var skillm = GameDataMgr.GetSkillModel(msg.fightType);
			if (src == Mgr.mainPlayer) {
				Mgr.player.UpdateNuqiValue();
                src.oCtrlAutoFight.ClearAttackDelay();
				src.oCtrlAutoFight.AddSkillCooldown(skillmid, msg.effects);
				if( skillm.q_skill_user == 1 || skillm.q_skill_user == 4  && msg.effects != -1){
					Mgr.skill.fightStateId++;
					if( Mgr.skill.fightStateId > SkillUtil.MAX_FIGHT_STATE )
						Mgr.skill.fightStateId = 1;
					if( !Mgr.msgMgr.IsInCross() )
						Mgr.skill.AutoUpdateSkill( skillmid );
				}
			}
			Profiler.LogFight("RecvResFightBroadcastMessage", true);
			TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.DoSkillEffectUser, [src, dst, skillm, dir, msg.effects], FightUtil, 0, TimeTaskMgr.TYPE_SCENE );
		}
	},

	RecvResAttackResultMessage:function(msg) {
		Profiler.LogFight("RecvResAttackResultMessage");
		var result = msg.state;
		var srcgid = result.sourceId.toGID();
		var targetgid = result.entityId.toGID();
		var src = Mgr.sceneObj.FindObject( srcgid );
		var tar = Mgr.sceneObj.FindObject( targetgid );
		if( !src || !tar ){
			//这里如果出现被看不见的怪攻击就把容错加上
			if( !src ){
				cc.error("这里如果出现被看不见的怪攻击就把容错加上src" + srcgid + "   " + targetgid);
				// Mgr.mapObjMgr.sendMonsterInfomsg( result.sourceId );
			}
			if( !tar ){
				// Mgr.mapObjMgr.sendMonsterInfomsg( result.sourceId );
			}
			Profiler.LogFight("RecvResAttackResultMessage", true);
			return;
		}

		//元宝掉落
		if ( tar && tar.nBodyResId == 23 ) {
			var num = Math.floor(Math.random() * 5 + 10);
			Mgr.dropEffect.Show(tar,1,num);
		}

		var finfo = new FightResultInfo( result );
		if( tar == Mgr.mainPlayer && src ){
			if( src instanceof ScenePlayer ){
				// if (finfo.isHolyShit == false && finfo.isJumpMiss == false && finfo.isMiss == false && result.damage != 0)
				// {
				// 	Mgr.pvpMgr.addWaringTable(fightgid, result.damage);
				// 	Mgr.onHookMgr.counterV = src as BasePlayerV;
				// }
                //
				// //显示pk玩家
				// Mgr.headMgr.resumePkRoleTarget( src as BasePlayerV );
			}

			if( Mgr.map.nCurtargetgid == 0 ){
				Mgr.map.SelTarget(src);
			}
			if( src instanceof SceneMonster && !Mgr.mainPlayer.isInFightState ){
				tar.oCtrlAutoFight.CounterAttack( src );
			}
		}

		if( tar && finfo.IsDoWound() ){
			if( tar instanceof SceneMonster ){
				if( src == Mgr.mainPlayer ){
					TimerUtil.SetTimeout( Mgr.gameSoundMgr, Mgr.gameSoundMgr.PlaySoundHit, ToolBase.RamdonRangeInt(100, 400) );
				}
				if( tar.nJobId <= 0 )	//不是玩家造型
					tar.SetStateShow( EnumActionType.WOUND );
			}
		}
		Profiler.LogFight("RecvResAttackResultMessage", true);
		if( tar ){
			//不是同一人 并且有伤害
			if( src != tar && finfo.damage > 0 ){
				var isMyShadow = ( src instanceof SceneMonster && src.IsMyShadow() );
				//主玩家相关
				if( src == Mgr.mainPlayer || tar == Mgr.mainPlayer || isMyShadow ){
					var damage = 0;
					//多次伤害
					if( result.hit != 0 ){
						TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, result.hit, finfo.resultType], FightUtil, 0, TimeTaskMgr.TYPE_SCENE );
						var count = result.damage / result.hit;
						for( var i = 1; i < count; i++ )						{
							TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, result.hit, finfo.resultType], FightUtil, i * 200, TimeTaskMgr.TYPE_SCENE );
							TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, i * 200, TimeTaskMgr.TYPE_SCENE );
						}
					}
					else{
						var attackId = finfo.skillPublic.q_attack_id;
						if( tar instanceof ScenePlayer ){
							TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, finfo.damage, finfo.resultType], FightUtil, 0, TimeTaskMgr.TYPE_SCENE );
							TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 0, TimeTaskMgr.TYPE_SCENE );
							return;
						}
						switch(attackId){
							case 1:
								damage = finfo.damage * 0.2;
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 600, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 600, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 900, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 900, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 1200, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 1200, TimeTaskMgr.TYPE_SCENE );
								break;
							case 2:
								damage = finfo.damage * 0.2;
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 200, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 200, TimeTaskMgr.TYPE_SCENE );
								damage = finfo.damage * 0.2;
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
								damage = finfo.damage * 0.6;
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 700, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 700, TimeTaskMgr.TYPE_SCENE );
								break;
							case 3:
								damage = finfo.damage * 0.2;
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
								damage = finfo.damage * 0.3;
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 500, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 500, TimeTaskMgr.TYPE_SCENE );
								damage = finfo.damage * 0.5;
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 1100, TimeTaskMgr.TYPE_SCENE );
								TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 1100, TimeTaskMgr.TYPE_SCENE );
								break;
							case 4:
								damage = parseInt( finfo.damage / 7 );
								for( var i = 1; i < 8; i++ ){
									TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, i * 80, TimeTaskMgr.TYPE_SCENE );
									if( i % 2 == 0 )
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, i * 80, TimeTaskMgr.TYPE_SCENE );
								}
								break;
							default:
								var useEffid = parseInt( finfo.skillPublic.q_use_effect );
								switch(useEffid){
									case 3:
										damage = finfo.damage * 0.3;
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 200, TimeTaskMgr.TYPE_SCENE );
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 500, TimeTaskMgr.TYPE_SCENE );
										damage = finfo.damage * 0.3;
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 1000, TimeTaskMgr.TYPE_SCENE );
										damage = finfo.damage * 0.4;
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 500, TimeTaskMgr.TYPE_SCENE );
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 1500, TimeTaskMgr.TYPE_SCENE );
										break;
									case 5:
									case 10:
										damage = finfo.damage * 0.3;
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
										damage = finfo.damage * 0.3;
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 700, TimeTaskMgr.TYPE_SCENE );
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 700, TimeTaskMgr.TYPE_SCENE );
										damage = finfo.damage * 0.4;
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 1200, TimeTaskMgr.TYPE_SCENE );
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 1200, TimeTaskMgr.TYPE_SCENE );
										break;
									default:
										damage = finfo.damage * 0.2;
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 0, TimeTaskMgr.TYPE_SCENE );
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 0, TimeTaskMgr.TYPE_SCENE );
										damage = finfo.damage * 0.2;
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 100, TimeTaskMgr.TYPE_SCENE );
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 100, TimeTaskMgr.TYPE_SCENE );
										damage = finfo.damage * 0.6;
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, damage, finfo.resultType], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
										TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowAttackedEffect, [src, tar, finfo.skillm, finfo.skillPublic], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
										break;
								}
								break;
						}
						// FightUtil.CreateFightResultEffect(src, tar, finfo.damage, finfo.resultType);
					}
				}
			}
		}
		// 反伤
		if (result.back != 0 && src != null){
			FightUtil.CreateFightResultEffect(src, src, result.back, EnumResultType.BACK, src == Mgr.mainPlayer);
		}
	},

	RecvResAttackRangeMessage:function(msg) {
	},

	RecvResEffectBroadcastMessage:function(msg) {
	},

	RecvResFightFailedBroadcastMessage:function(msg) {
		if( msg.fightType == -1 ){	//怪物在服务器端已死亡	这个-1服务器取消了 现在直接发 monsterdie 
			var obj = Mgr.sceneObj.FindObject( Mgr.mainPlayer.oCtrlAutoFight.nAutoAttackGID );
			if( obj ){
                obj.DoDeadState();
                Mgr.mainPlayer.oCtrlAutoFight.ClearAttackDelay();
			}
		}
		else if( msg.fightType == -2 ){		//boss每日只能击杀3次  今日次数已满
			Mgr.mainPlayer.oCtrlAutoFight.ClearLockAutoAttackTarget();
			Mgr.mainPlayer.oCtrlAutoFight.ClearAttackDelay();
		}
	},

	RecvResFightFinishBroadcastMessage:function(msg) {
	},

	RecvResAttackVentToClientMessage:function(msg) {
		var src = Mgr.sceneObj.FindObject(msg.playerid.toGID());
		if( src ){
			// src.StopMove();
			if (src == Mgr.mainPlayer) {
				src.oCtrlAutoFight.ClearAttackDelay();
				src.oCtrlAutoFight.AddSkillCooldown(msg.fightType, msg.effects);
			}
			var skillm = GameDataMgr.GetSkillModel(msg.fightType);
			if( skillm.q_skill_user == 1 || skillm.q_skill_user == 4  && msg.effects != -1){
				Mgr.skill.fightStateId++;
				if( Mgr.skill.fightStateId > SkillUtil.MAX_FIGHT_STATE )
					Mgr.skill.fightStateId = 1;
			}
            FightUtil.DoSkillEffectUser(src, null, skillm, src.nCurDirection, msg.effects, cc.p(msg.x, msg.y));
		}
	},

	RecvResAttackSingingToClientMessage:function(msg) {
	},

	RecvResAttackBreakSingingToClientMessage:function(msg) {
	},

	RecvResAttackBeautyMessage:function(msg) {
	},

	RecvResSkillClickFlyMessage:function(msg) {
		//符鬼技能击退
		var obj = Mgr.sceneObj.FindObject(msg.entityId.toGID());
		if( obj ){
			obj.SetBackOutWay([msg.pos], true);
		}
	},
	
	RecvResRepelMessage:function(msg) {
		//普怪击退
		var obj = Mgr.sceneObj.FindObject(msg.monsterid.toGID());
		if( obj ){
			obj.SetBackOutWay([msg.position], true);
		}
	},

	RecvResAttackHorseMessage:function(msg) {
	},

	RecvResClearSkillCDMessage:function(msg) {
		var len = msg.skillIds.length;
		for( var i = 0; i < len; i++ )
		{
			var skillId = msg.skillIds[i];
			Mgr.mainPlayer.oCtrlAutoFight.RemoveSkillCd(mid);
		}
	},
	RecvResreslineAttackFaliedResultMessage:function (msg) {
		switch( msg.faliedType )
		{
			case 1://失败原因，目标不存在
				break;
			case 2://跟宠不存在
				break;
			case 3://跟宠技能不存在
				break;
			case 4://技能冷却中
				break;
			case 5://技能距离不够
				break;
			case 6://人物阵营一类的检查不通过
				break;
		}
	},

	RecvResreslineAttackResultMessage:function (msg) {
		//zz.Error("-----------  跟宠战斗结果  --------------")
		Profiler.LogFight("RecvResreslineAttackResultMessage");
		var result = new AttackResultInfo();
		result.damage = msg.damage;
		result.fightResult = msg.fightResult;
		result.skillId = msg.skillModel;
		result.skillLevel = 1;
		var finfo = new FightResultInfo( result );

		var owner = Mgr.sceneObj.FindObject(msg.ownerId.toGID());
		var tar = Mgr.sceneObj.FindObject(msg.targetId.toGID());
		var src;
		if ( owner ) {
			if ( msg.resType == EnumResline.SHUTONG ) {
				src = Mgr.sceneObj.FindObject(owner.sShutongGid);
			}
			if( owner.oCtrlAutoFight )
				owner.oCtrlAutoFight.AddSkillCooldown(msg.skillModel);		//宠物cd存到玩家身上
		}

		//zz.Error("------------ -跟宠 effect  ----------------------   " + src.nGid + "   " + tar.nGid + "   " + finfo.damage +   "   " + finfo.resultType)

        //var type = Mgr.plugset.GetSysSetInfo().shield//0：都不禁用1：禁玩家2：禁小怪3：都禁
		Profiler.LogFight("RecvResreslineAttackResultMessage", true);
		if ( tar && src ) {
			Profiler.LogFight("RecvResreslineAttackResultMessage - turn");
			src.ClearAttackLock();
			src.TurnToObj( tar );
			src.SetStateShowAttack(1)
			Profiler.LogFight("RecvResreslineAttackResultMessage - turn", true);
			Profiler.LogFight("RecvResreslineAttackResultMessage - ShowBodySkillEffect");
            if(owner == Mgr.mainPlayer)
            {
                TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowBodySkillEffect, [src, 5001, false, true], FightUtil, 0, TimeTaskMgr.TYPE_SCENE );
                TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, finfo.damage, finfo.resultType], FightUtil, 500, TimeTaskMgr.TYPE_SCENE );
                TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowSceneSkillEffect, [tar, 5001, false, false, 0, null, 0, Math.random() > 0.5 ? 1 : -1, 0, EffectUtil.ENUM_TYPE_HIT], FightUtil, 300, TimeTaskMgr.TYPE_SCENE );
            }
			// if(type == 1 || type == 3){//不需要判断（屏蔽掉其他玩家的资源线）
			//
			// }else {
			// 	TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowBodySkillEffect, [src, 5001, false, true], FightUtil, 0, TimeTaskMgr.TYPE_SCENE );
			// 	TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.CreateFightResultEffect, [src, tar, finfo.damage, finfo.resultType], FightUtil, 500, TimeTaskMgr.TYPE_SCENE );
			// 	TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  FightUtil.ShowSceneSkillEffect, [tar, 5001, false, false, 0, null, 0, Math.random() > 0.5 ? 1 : -1, 0, EffectUtil.ENUM_TYPE_HIT], FightUtil, 200, TimeTaskMgr.TYPE_SCENE );
			// }
			Profiler.LogFight("RecvResreslineAttackResultMessage - ShowBodySkillEffect", true);

		}
	},



	SendReqAttackMonsterMessage:function(tarsid, fightskill, dir, effsid) {
		var msg = new ReqAttackMonsterMessage();
		msg.fightType = fightskill; // 攻击类型(技能ID)
		msg.fightDirection = dir; // 攻击朝向
		msg.effectsid =effsid; // 前端自定义信息(动作,状态)
		msg.fightTarget = tarsid; // 攻击目标
		Mgr.msgMgr.Send(msg);
	},

	SendReqAttackPlayerMessage:function(tarsid, fightskill, dir, effsid) {
		var msg = new ReqAttackPlayerMessage();
		msg.fightType = fightskill; // 攻击类型(技能ID)
		msg.fightDirection = dir; // 攻击朝向
		msg.effectsid = 0; // 前端自定义信息(动作,状态)
		msg.fightTarget = tarsid; // 攻击目标
		Mgr.msgMgr.Send(msg);
	},

	SendReqChangeAttackTargetMessage:function(msg) {
	},

	SendReqAttackPetMessage:function(tarsid, fightskill, dir, ownersid) {	
		var msg = new ReqAttackPetMessage();
		msg.fightType = fightskill; // 攻击类型(技能ID)
		msg.fightDirection = dir; // 攻击朝向
		msg.fightTarget = tarsid; // 攻击目标
		msg.owherId = ownersid; // 主人ID
		Mgr.msgMgr.Send(msg);
	},

	SendReqAttackVentToGameMessage:function(fightskill) {
		// 战斗前下马
		if ( Mgr.mainPlayer.nHorseModelId > 0 ) {
			Mgr.resline.UnEquipResline(EnumResline.HORSE);
		}

		var msg = new ReqAttackVentToGameMessage();
		msg.fightType = fightskill;
		msg.effectsid = Mgr.skill.GetFightState();
		msg.fightDirection = Mgr.mainPlayer.nCurDirection;
		var pt = Mgr.mainPlayer.GetGridPt();
		msg.x = pt.x;
		msg.y = pt.y;
		Mgr.msgMgr.Send(msg);
	},

	SendReqReslineAttackMessage:function (tarType, tar, skillId, reslineType) {
		var msg = new ReqReslineAttackMessage();
		msg.targetType = tarType;
		msg.fightTarget = tar;
		msg.skillModel = skillId;
		msg.resType = reslineType;
		Mgr.msgMgr.Send(msg);
	},

	SendReqAttackSingingToGameMessage:function(msg) {
	},

	SendReqAttackBreakSingingToGameMessage:function(msg) {
	},

	SendReqBeautyAttackMessage:function(msg) {
	},

	SendReqHorseAttackMessage:function(msg) {
	},
	
	// 准备发送攻击一个目标的消息，不会有进行距离移动和判断
	FightToTarget:function(src, tar, skillmid){
		var dir = MDirection.UP;
		var tarsid = null;

		if (tar != null) {
			dir = ToolMap.CalcDirSlant(src.GetGridPt(), tar.GetGridPt());
			if (MDirection.IsValid(dir) == false)
				dir = MDirection.UP;

			tarsid = tar.oSid;
		} else {
			zz.Error("FightToTarget but tar == null");
			return;
		}

		if (src == Mgr.mainPlayer) {
			// 战斗前下马
			if ( Mgr.mainPlayer.nHorseModelId > 0 ) {
				Mgr.resline.UnEquipResline(EnumResline.HORSE);
			}
            Mgr.mainPlayer.oCtrlAutoFight.SetAttackDelay();
			var effId = Mgr.skill.GetFightState();
			if (tar instanceof SceneMonster){
				this.SendReqAttackMonsterMessage(tarsid, skillmid, dir, effId);
			} else if (tar instanceof ScenePlayer) {
				this.SendReqAttackPlayerMessage(tarsid, skillmid, dir, effId);
			} else if (tar instanceof ScenePet) {
				this.SendReqAttackPetMessage(tarsid, skillmid, dir, src.oSid);
			}
		}
	},
});

var FightResultInfo = FightResultInfo || cc.Class.extend({
		damage:0,
		resultType:0,
		// 鞭尸
		isDeadBeat:false,
		// 连斩秒怪
		isComboKillMonster:false,
		
		skillm:null,
		skillPublic:null,
		
		ctor:function(info){
			this.damage = info.damage;
		
			if (this.damage >= info.hit)
				this.damage -= info.hit;
		
			this.skillm = GameDataMgr.GetSkillModel(info.skillId, info.skillLevel);
			this.skillPublic = Q_skill_public.Get(info.skillId);
			var type = info.fightResult;
			if((type & 16) == 16)
				this.resultType = EnumResultType.HOLYSHIT;
			else if((type & 0x8) == 8)
				this.resultType = EnumResultType.PARRY;
			else if((type & 0x4) == 4 && this.damage > 1)
				this.resultType = EnumResultType.CRIT;
			else if((type & 0x2) == 2)
				this.resultType = EnumResultType.JUMPMISS;
			else if((type & 0x1) == 1)
				this.resultType = EnumResultType.MISS;

			this.isDeadBeat = ((type & 32) == 32);
			this.isComboKillMonster = ((type & 64) == 64);
		},

		/**
		 * 是否做受伤动作
		 * @return
		 *
		 */
		IsDoWound:function(){
			return (this.resultType == EnumResultType.CRIT || this.resultType == EnumResultType.NORMAL);
		}
	});
var EnumResultType = EnumResultType || {
		NORMAL:0,
		MISS:1,
		CRIT:2,
		PARRY:3,
		JUMPMISS:4,
		// 免疫
		HOLYSHIT:5,
		// 反弹
		BACK:6,
		// 恢复
		RECOVER:7,
		//书童
		PET:8,
	};