var EnumZhanliType = EnumZhanliType || {
    __START: 0,
    ZUOQI: 1,
    GUANGWU: 2,
    SHUTONG: 3,
    BAIQI: 4,
    FAQI: 5,
    EQUIP: 6,
    SKILL: 7,
    YIRONG: 8,
    WUXUE: 9,
    JIANQIAO: 10,
    JIAOYIN: 11,
    JIANZHAO: 12,
    __END: 13,

    MAIN_NAME: {
        1: "坐骑",
        2: "光武",
        3: "书童",
        4: "法器",
        5: "宝骑",
        6: "装备",
        7: "技能",
        8: "易容",
        9: "武学",
        10: "剑鞘",
        11: "脚印",
        12: "剑招",
    },

    RESLINE_DENGJIE: 1,
    RESLINE_EQUIP: 2,
    RESLINE_SKILL: 3,
    RESLINE_SHUXINGDAN: 4,
    RESLINE_CUILIAN: 5,


    EQIUP_BASE: 1,
    EQIUP_QIANGHUA: 2,
    EQIUP_JINGLIAN: 3,
    EQIUP_BAOSHI: 4,
    EQIUP_TAOZHUANG: 5,


    SKILL_ZHUDONG: 1,
    SKILL_BEIDONG: 2,
    SKILL_YIRONG: 3,

    YIRONG_DENGJIE: 1,
    YIRONG_EQUIP: 2,

    RESLINE_NAME_CONFIG: {
        1: "等阶",
        2: "装备",
        3: "技能",
        4: "属性丹",
        5: "淬炼",
    },
    EQUIP_NAME_CONFIG: {
        1: "装备",
        2: "强化",
        3: "精炼",
        4: "宝石",
        5: "套装",
    },
    SKILL_NAME_CONFIG: {
        1: "主动技能",
        2: "被动技能",
        3: "易容产能",
    },
    YIRONG_NAME_CONFIG: {
        1: "等阶",
        2: "装备",
    },
}

var FightPowerUtils = FightPowerUtils || {
    GetSubCategory: function(type) {
        switch (type) {
            case EnumZhanliType.ZUOQI:
            case EnumZhanliType.GUANGWU:
            case EnumZhanliType.SHUTONG:
            case EnumZhanliType.BAIQI:
            case EnumZhanliType.JIANQIAO:
            case EnumZhanliType.JIAOYIN:
            case EnumZhanliType.JIANZHAO:
            case EnumZhanliType.FAQI:
            case EnumZhanliType.WUXUE:
                return [
                    EnumZhanliType.RESLINE_DENGJIE,
                    EnumZhanliType.RESLINE_EQUIP,
                    EnumZhanliType.RESLINE_SKILL,
                    EnumZhanliType.RESLINE_SHUXINGDAN,
                    EnumZhanliType.RESLINE_CUILIAN,
                ];
                break;
            case EnumZhanliType.EQUIP: //装备
                return [
                    EnumZhanliType.EQIUP_BASE,
                    EnumZhanliType.EQIUP_QIANGHUA,
                    EnumZhanliType.EQIUP_JINGLIAN,
                    EnumZhanliType.EQIUP_BAOSHI,
                    EnumZhanliType.EQIUP_TAOZHUANG,
                ];
                break;
            case EnumZhanliType.SKILL:
                return [
                    EnumZhanliType.SKILL_ZHUDONG,
                    EnumZhanliType.SKILL_BEIDONG,
                    EnumZhanliType.SKILL_YIRONG,
                ];
                break;
            case EnumZhanliType.YIRONG:
                return [
                    EnumZhanliType.YIRONG_DENGJIE,
                    EnumZhanliType.YIRONG_EQUIP,
                ];
                break;
        }
        return [];
    },
    GetMainCategoryName: function(type, data) {
        return EnumZhanliType.MAIN_NAME[type] || ""
    },
    GetSubCategoryName: function(main, sub) {
        switch (main) {
            case EnumZhanliType.ZUOQI:
            case EnumZhanliType.GUANGWU:
            case EnumZhanliType.SHUTONG:
            case EnumZhanliType.BAIQI:
            case EnumZhanliType.JIANQIAO:
            case EnumZhanliType.JIAOYIN:
            case EnumZhanliType.JIANZHAO:
            case EnumZhanliType.FAQI:
            case EnumZhanliType.WUXUE:
                return EnumZhanliType.RESLINE_NAME_CONFIG[sub];
                break;
            case EnumZhanliType.EQUIP: //装备
                return EnumZhanliType.EQUIP_NAME_CONFIG[sub];
                break;
            case EnumZhanliType.SKILL:
                return EnumZhanliType.SKILL_NAME_CONFIG[sub];
                break;
            case EnumZhanliType.YIRONG:
                return EnumZhanliType.YIRONG_NAME_CONFIG[sub];
                break;
        }

        return "";
    },
    GetSubFightPower: function(main, sub, data) {
        switch (main) {
            case EnumZhanliType.ZUOQI:
            case EnumZhanliType.GUANGWU:
            case EnumZhanliType.SHUTONG:
            case EnumZhanliType.BAIQI:
            case EnumZhanliType.JIANQIAO:
            case EnumZhanliType.JIAOYIN:
            case EnumZhanliType.JIANZHAO:
            case EnumZhanliType.FAQI:
            case EnumZhanliType.WUXUE:
                return this.getReslineInfo(main, sub, data);
                break;
            case EnumZhanliType.EQUIP: //装备
                return this.getEquipInfo(main, sub, data);
                break;
            case EnumZhanliType.SKILL:
                return this.getSkillInfo(main, sub, data);
                break;
            case EnumZhanliType.YIRONG:
                return this.getDisguiseInfo(main, sub, data);
                break;
        }
        return 0;
    },
    GetMySubFightPower: function(main, sub) {
        switch (main) {
            case EnumZhanliType.ZUOQI:
            case EnumZhanliType.GUANGWU:
            case EnumZhanliType.SHUTONG:
            case EnumZhanliType.BAIQI:
            case EnumZhanliType.JIANQIAO:
            case EnumZhanliType.JIAOYIN:
            case EnumZhanliType.JIANZHAO:
            case EnumZhanliType.FAQI:
            case EnumZhanliType.WUXUE:
                return this.getMyReslineInfo(main, sub);
                break;
            case EnumZhanliType.EQUIP: //装备
                return this.getMyEquipInfo(main, sub);
                break;
            case EnumZhanliType.SKILL:
                return this.getMySkillInfo(main, sub);
                break;
            case EnumZhanliType.YIRONG:
                return this.getMyDisguiseInfo(main, sub);
                break;
        }
        return 0;
    },
    GetMainData: function(other) {
        var result = [];
        for (var main = EnumZhanliType.__START + 1; main < EnumZhanliType.__END; ++main) {
            var data;

            var powerSelf = 0,
                powerOther = 0;
            var category = this.GetSubCategory(main);
            var temp = [];
            for (var sub of category) {
                var pSelf = this.GetMySubFightPower(main, sub);
                var pOther = this.GetSubFightPower(main, sub, other);

                powerSelf += pSelf;
                powerOther += pOther;
                temp.push({
                    main: main,
                    sub: sub,
                    name: this.GetSubCategoryName(main, sub),
                    powerSelf: pSelf,
                    powerOther: pOther,
                })
            }

            result.push({
                name: this.GetMainCategoryName(main),
                main: main,
                sub: temp,
                powerSelf: powerSelf,
                powerOther: powerOther,
            });
        }

        return result;
    },
    convertReslineType: function(main) {
        var reslineType
        switch (main) {
            case EnumZhanliType.ZUOQI:
                reslineType = EnumResline.HORSE;
                break;
            case EnumZhanliType.GUANGWU:
                reslineType = EnumResline.GUANGWU;
                break;
            case EnumZhanliType.SHUTONG:
                reslineType = EnumResline.SHUTONG;
                break;
            case EnumZhanliType.BAIQI:
                reslineType = EnumResline.BAOQI;
                break;
            case EnumZhanliType.JIANQIAO:
                reslineType = EnumResline.SCABBARD;
                break;
            case EnumZhanliType.JIAOYIN:
                reslineType = EnumResline.STEP;
                break;
            case EnumZhanliType.JIANZHAO:
                reslineType = EnumResline.ZHAOSHI;
                break;
            case EnumZhanliType.FAQI:
                reslineType = EnumResline.DRAGON;
                break;
            case EnumZhanliType.WUXUE:
                reslineType = EnumResline.WUXUE;
                break;
        }
        return reslineType;
    },
    /// 获取资源线相关
    getReslineInfo: function(main, sub, data) {
        var reslineType = this.convertReslineType(main);
        var reslineInfo
        for (var v of data.reslineInfo) {
            if (v.reslineType == reslineType) {
                reslineInfo = v;
                break;
            }
        }

        if (!reslineInfo) return 0;
        var v = reslineInfo;


        var power = 0;
        var attrArr = [];
        switch (sub) {
            case EnumZhanliType.RESLINE_DENGJIE: //等阶
                var info = Q_resline_addition.Get(reslineType + "_" + v.reslineModelId + "_" + v.reslineStar)
                attrArr.push(info ? info.q_attribute : "");

                // TODO 这块没用
                //power += Mgr.fightpower.GetFightPower(info.q_attribute_temp) * v.exp / 10;
                break;
            case EnumZhanliType.RESLINE_EQUIP: //装备
                for (var vv of v.equips) {
                    var info = Q_item_simpact.Get(vv.itemModelId);
                    attrArr.push(info ? info.q_attribute : "");
                }
                break;
            case EnumZhanliType.RESLINE_SKILL: //技能
                for (var vv of v.euipSkillInfo) {
                    var q_skill = Q_skill_model.Get(vv.skillModelId + "_" + vv.skillLevel);
                    power += q_skill.q_fight_bonus;
                    if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                }
                break;
            case EnumZhanliType.RESLINE_SHUXINGDAN: //属性丹
                var info = Q_resline_up.Get(reslineType + "_" + v.reslineModelId + "_" + v.reslineStar)
                var array = JSON.parse(info.q_intensify_item);
                if (array) {
                    for (var i = 0; i != array.length; i++) {
                        var itemId = array[i][0];
                        var tmpInfo = Q_item_simpact.Get(itemId);
                        if (tmpInfo) {
                            power += Mgr.fightpower.GetFightPower(tmpInfo.q_attribute) * (v.attList[i] || 0);
                        }
                    }
                }
                // todo 幻化丹写死
                if (v.attList[1] && v.attList[1] > 0) {
                    power += this.getReslineInfo(main, EnumZhanliType.RESLINE_DENGJIE, data) * 0.01 * v.attList[1];
                }
                break;
            case EnumZhanliType.RESLINE_CUILIAN: //淬炼
                var info = Q_resline_cuilian.Get(v.cuilianLv);
                if (info && info.q_attribute) attrArr.push(info.q_attribute);

                break;
        }
        for (var str of attrArr) {
            power += Mgr.fightpower.GetFightPower(str);
        }

        return power
    },
    getEquipInfo: function(main, sub, data) {
        var attrArr = [];
        var power = 0;
        switch (sub) {
            case EnumZhanliType.EQIUP_BASE: //装备
                for (var v of data.equips) {
                    var info = Q_item_simpact.Get(v.itemModelId);
                    attrArr.push(info ? info.q_attribute : "");

                    for (var i = 0; i < v.extraNum; i++) {
                        attrArr.push(info ? info.q_extraAttributes : "");
                    }
                }
                break;
            case EnumZhanliType.EQIUP_QIANGHUA: //强化
                for (var v of data.equips) {
                    var info = Q_attribute_rise.Get(v.itemModelId + "_" + v.strenthenLv);
                    attrArr.push(info ? info.q_attribute : "");
                }
                break;
            case EnumZhanliType.EQIUP_JINGLIAN: // 精炼
                for (var v of data.refineSysInfos) {
                    for (var vv of v.equipRefinelList) {
                        for (var vvv = 0; vvv < vv.refinelList.length / 2; vvv++) {
                            var type = vv.refinelList[vvv * 2];
                            var num = vv.refinelList[vvv * 2 + 1];

                            var info = Q_item_simpact.Get(type);
                            power += Mgr.fightpower.GetFightPower(info ? info.q_attribute : "") * num;
                        }
                    }
                }
                break;
            case EnumZhanliType.EQIUP_BAOSHI: //宝石
                // 线获取百分比
                var map = {};

                for (var v of data.gemInfos) {
                    for (var vv of v.gemModelList) {
                        var info = Q_item_simpact.Get(vv.gemModelId);
                        if (info.q_attributeRatios) {
                            var perattr = ParseUtil.DecodAttribute(info.q_attributeRatios);

                            for (var vvv of perattr) {
                                map[vvv.type] = map[vvv.type] || 0;
                                map[vvv.type] += parseInt(vvv.value);
                            }
                        }
                    }
                }

                for (var v of data.gemInfos) {
                    for (var vv of v.gemModelList) {
                        var info = Q_item_simpact.Get(vv.gemModelId);
                        //                        attrArr.push(info ? info.q_attribute : "");
                        power += Mgr.fightpower.GetFightPowerExt(info ? info.q_attribute : "", map);
                    }
                }
                break;
            case EnumZhanliType.EQIUP_TAOZHUANG: //套装
                var map = {};

                data.equipSuitInfos.forEach(function(v){
                    map[v.itemType] = map[v.itemType] || {};
                    map[v.itemType][v.equipSuit] = map[v.itemType][v.equipSuit] || 0;
                    map[v.itemType][v.equipSuit] ++;
                })

                for (var k in map) {
                    var v = map[k];

                    for(var kk in v){
                        var vv = v[kk];

                        var info = Q_equip_suit_bonus.Get(kk + "_1_" + vv + "_" + k);
                        attrArr.push(info ? info.q_attribute : "");
                    }
                }
                break;
        }

        for (var str of attrArr) {
            power += Mgr.fightpower.GetFightPower(str);
        }

        return power;
    },
    getSkillInfo: function(main, sub, data) {
        var power = 0;
        var attrArr = [];
        switch (sub) {
            case EnumZhanliType.SKILL_ZHUDONG: //主动
                for (var v of data.playerSkillInfos) {
                    var q_skill = Q_skill_model.Get(v.skillModelId + "_" + v.skillLevel);
                    var q_public = Q_skill_public.Get(v.skillModelId)
                    if (q_skill && q_public && q_public.q_index == 1) {
                        power += q_skill.q_fight_bonus;
                        if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                    }
                }
                break;
            case EnumZhanliType.SKILL_BEIDONG: //被动
                for (var v of data.playerSkillInfos) {
                    var q_skill = Q_skill_model.Get(v.skillModelId + "_" + v.skillLevel);
                    var q_public = Q_skill_public.Get(v.skillModelId)
                    if (q_skill && q_public && q_public.q_index == 2) {
                        power += q_skill.q_fight_bonus;
                        if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                    }
                }
                break;
            case EnumZhanliType.SKILL_YIRONG: //易容
                //for (var v of data.disguiseInfoList) {
                //    var info = Q_disguise.Get(v.disguiseId);
                //    var q_skill = Q_skill_model.Get(info.q_skill + "_" + v.disguiseAdvanceUp);
                //    if (q_skill) {
                //        power += q_skill.q_fight_bonus;
                //        if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                //    }
                //}
                //                for (var v of data.playerSkillInfos) {
                //                    var q_skill = Q_skill_model.Get(v.skillModelId + "_" + v.skillLevel);
                //                    var q_public = Q_skill_public.Get(v.skillModelId)
                //                    if (q_skill && q_public && q_public.q_index == 4) {
                //                        power += q_skill.q_fight_bonus;
                //                        if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                //                    }
                //                }
                break;
        }
        for (var str of attrArr) {
            power += Mgr.fightpower.GetFightPower(str || "");
        }

        return power;
    },
    getDisguiseInfo: function(main, sub, data) {
        var attrArr = [];
        switch (sub) {
            case EnumZhanliType.YIRONG_DENGJIE: // 易容等阶
                for (var v of data.disguiseInfoList) {
                    // 基础
                    var base = Q_disguise.Get(v.disguiseId);
                    if (base) attrArr.push(base.q_attribute);

                    // 星图
                    for (var i = 1; i <= v.disguiseUp; ++i) {
                        var ret = false;
                        for (var j = 0; j <= 10; ++j) {
                            var info = Q_disguise_upgrade.Get(v.disguiseId + "_" + i + "_" + j);
                            if (info) attrArr.push(info.q_attribute);

                            if (i == v.disguiseUp && j == v.disguiseStar) {
                                ret = true;
                                break;
                            }
                        }
                        if (ret) break;
                    }
                    // 升阶
                    var info = Q_disguise_advance.Get(v.disguiseId + "_" + v.disguiseAdvanceUp);
                    if (info) attrArr.push(info.q_attribute);
                    // 技能
                    var info = Q_disguise_advance.Get(v.disguiseId + "_" + (v.disguiseAdvanceUp == 0 ? 1 : v.disguiseAdvanceUp));
                    if (info) {
                        var q_skill = Q_skill_model.Get(base.q_skill + "_" + info.q_skill);
                        power += q_skill.q_fight_bonus;
                        if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                    }
                }
                break;
            case EnumZhanliType.YIRONG_EQUIP: // 易容装备
                for (var v of data.disguiseInfoList) {
                    for (var vv of v.equips) {
                        var info = Q_item_simpact.Get(vv.itemModelId);
                        attrArr.push(info ? info.q_attribute : "");
                    }
                }
                break;
        }


        var power = 0;
        for (var str of attrArr) {
            power += Mgr.fightpower.GetFightPower(str);
        }

        return Math.floor(power);
    },
    getMyReslineInfo: function(main, sub) {
        var reslineType = this.convertReslineType(main);

        var aa = Mgr.resline.GetMgrByType(reslineType);
        var v = aa._curReslineDataInfo;
        if (!v) return 0;

        var power = 0;
        var attrArr = [];
        switch (sub) {
            case EnumZhanliType.RESLINE_DENGJIE: //等阶
                var info = Q_resline_addition.Get(reslineType + "_" + v.reslineModelId + "_" + v.reslineStar)
                attrArr.push(info ? info.q_attribute : "");

                //                power += Mgr.fightpower.GetFightPower(info.q_attribute_temp) * v.exp / 10;

                break;
            case EnumZhanliType.RESLINE_EQUIP: //装备
                for (var vv of v.equips) {
                    var info = Q_item_simpact.Get(vv.itemModelId);
                    attrArr.push(info ? info.q_attribute : "");
                }
                break;
            case EnumZhanliType.RESLINE_SKILL: //技能

                for (var vv of v.euipSkillInfo) {
                    var q_skill = Q_skill_model.Get(vv.skillModelId + "_" + vv.skillLevel);
                    power += q_skill.q_fight_bonus;
                    if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                }
                break;
            case EnumZhanliType.RESLINE_SHUXINGDAN: //属性丹

                var info = Q_resline_up.Get(reslineType + "_" + v.reslineModelId + "_" + v.reslineStar)
                var array = JSON.parse(info.q_intensify_item);
                if (array) {
                    for (var i = 0; i != array.length; i++) {
                        var itemId = array[i][0];

                        var tmpInfo = Q_item_simpact.Get(itemId);
                        if (tmpInfo) {
                            power += Mgr.fightpower.GetFightPower(tmpInfo.q_attribute) * (v.attList[i] || 0);
                        }

                        // todo 幻化丹写死
                        if (v.attList[1] && v.attList[1] > 0) {
                            power += this.getMyReslineInfo(main, EnumZhanliType.RESLINE_DENGJIE) * 0.01 * v.attList[1];
                        }
                    }
                }
                break;
            case EnumZhanliType.RESLINE_CUILIAN: //淬炼


                var info = Q_resline_cuilian.Get(v.cuilianLv);
                if (info && info.q_attribute) attrArr.push(info.q_attribute);

                break;
        }
        for (var str of attrArr) {
            power += Mgr.fightpower.GetFightPower(str);
        }

        return power
    },
    getMyEquipInfo: function(main, sub, data) {
        var data = Mgr.player.mainPlayer;
        var attrArr = [];
        var power = 0;
        switch (sub) {
            case EnumZhanliType.EQIUP_BASE: //装备
                for (var v of data.equips) {
                    var info = Q_item_simpact.Get(v.itemModelId);
                    attrArr.push(info ? info.q_attribute : "");

                    for (var i = 0; i < v.extraNum; i++) {
                        attrArr.push(info ? info.q_extraAttributes : "");
                    }
                }
                break;
            case EnumZhanliType.EQIUP_QIANGHUA: //强化
                for (var v of data.equips) {
                    var info = Q_attribute_rise.Get(v.itemModelId + "_" + v.strenthenLv);
                    attrArr.push(info ? info.q_attribute : "");
                }
                break;
            case EnumZhanliType.EQIUP_JINGLIAN: // 精炼

                var temp = Mgr.equipRefine._refineStonesCache.Values();
                for (var v of temp) {

                    for (var vv of v) {

                        for (var vvv = 0; vvv < vv.refinelList.length / 2; vvv++) {
                            var type = vv.refinelList[vvv * 2];
                            var num = vv.refinelList[vvv * 2 + 1];

                            var info = Q_item_simpact.Get(type);
                            power += Mgr.fightpower.GetFightPower(info ? info.q_attribute : "") * num;
                        }
                    }
                }
                break;
            case EnumZhanliType.EQIUP_BAOSHI: //宝石
                var list = Mgr.gem.GetInlayStonesWithinItemType(EnumItemType.Equip);

                var map = {};

                for (var k in list) {
                    var v = list[k];
                    for (var vv of v) {
                        var info = Q_item_simpact.Get(vv.mid);
                        if (info.q_attributeRatios) {
                            var perattr = ParseUtil.DecodAttribute(info.q_attributeRatios);

                            for (var vvv of perattr) {
                                map[vvv.type] = map[vvv.type] || 0;
                                map[vvv.type] += vvv.value;
                            }
                        }
                    }
                }

                for (var k in list) {
                    var v = list[k];
                    for (var vv of v) {
                        var info = Q_item_simpact.Get(vv.mid);
                        power += Mgr.fightpower.GetFightPowerExt(info ? info.q_attribute : "", map);
                    }
                }
                break;
            case EnumZhanliType.EQIUP_TAOZHUANG: //套装
                var map = Mgr.equipRefine.GetAllSuitInfo();

                for (var k in map) {
                    var v = map[k];

                    for(var kk in v){
                        var vv = v[kk];

                        var info = Q_equip_suit_bonus.Get(kk + "_1_" + vv + "_" + k);
                        attrArr.push(info ? info.q_attribute : "");
                    }
                }
                break;
        }

        for (var str of attrArr) {
            power += Mgr.fightpower.GetFightPower(str);
        }

        return power;

    },
    getMySkillInfo: function(main, sub, data) {
        var power = 0;
        var attrArr = [];
        switch (sub) {
            case EnumZhanliType.SKILL_ZHUDONG: //主动
                var skills = Mgr.skill.skillInfos.Values()

                for (var tmp of skills) {
                    var v = tmp._skillInfo;
                    var q_skill = Q_skill_model.Get(v.skillModelId + "_" + v.skillLevel);
                    var q_public = Q_skill_public.Get(v.skillModelId)
                    if (q_skill && q_public && q_public.q_index == 1) {
                        power += q_skill.q_fight_bonus;
                        if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                    }
                }
                break;
            case EnumZhanliType.SKILL_BEIDONG: //被动
                var skills = Mgr.skill.skillInfos.Values()

                for (var tmp of skills) {
                    var v = tmp._skillInfo;
                    var q_skill = Q_skill_model.Get(v.skillModelId + "_" + v.skillLevel);
                    var q_public = Q_skill_public.Get(v.skillModelId)
                    if (q_skill && q_public && q_public.q_index == 2) {
                        power += q_skill.q_fight_bonus;
                        if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                    }
                }
                break;
            case EnumZhanliType.SKILL_YIRONG: //易容
                //for (var v of Mgr.disguise.disguiseList) {
                //    var info = Q_disguise.Get(v.disguiseId);
                //    var q_skill = Q_skill_model.Get(info.q_skill + "_" + v.disguiseAdvanceUp);
                //    if (q_skill) {
                //        power += q_skill.q_fight_bonus;
                //        if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                //    }
                //}
                var skills = Mgr.skill.skillInfos.Values()

                for (var tmp of skills) {
                    var v = tmp._skillInfo;
                    var q_skill = Q_skill_model.Get(v.skillModelId + "_" + v.skillLevel);
                    var q_public = Q_skill_public.Get(v.skillModelId)
                    if (q_skill && q_public && q_public.q_index == 4) {
                        power += q_skill.q_fight_bonus;
                        if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                    }
                }
                break;
        }
        for (var str of attrArr) {
            power += Mgr.fightpower.GetFightPower(str || "");
        }

        return power;
    },
    getMyDisguiseInfo: function(main, sub) {
        var attrArr = [];
        switch (sub) {
            case EnumZhanliType.YIRONG_DENGJIE: // 易容等阶
                for (var v of Mgr.disguise.disguiseList) {
                    // 基础
                    var base = Q_disguise.Get(v.disguiseId);
                    if (base) attrArr.push(base.q_attribute);

                    // 星图
                    for (var i = 1; i <= v.disguiseUp; ++i) {
                        var ret = false;
                        for (var j = 0; j <= 10; ++j) {
                            var info = Q_disguise_upgrade.Get(v.disguiseId + "_" + i + "_" + j);
                            if (info) attrArr.push(info.q_attribute);

                            if (i == v.disguiseUp && j == v.disguiseStar) {
                                ret = true;
                                break;
                            }
                        }
                        if (ret) break;
                    }
                    // 升阶
                    var info = Q_disguise_advance.Get(v.disguiseId + "_" + v.disguiseAdvanceUp);
                    if (info) attrArr.push(info.q_attribute);
                    // 技能
                    var info = Q_disguise_advance.Get(v.disguiseId + "_" + (v.disguiseAdvanceUp == 0 ? 1 : v.disguiseAdvanceUp));
                    if (info) {
                        var q_skill = Q_skill_model.Get(base.q_skill + "_" + info.q_skill);
                        power += q_skill.q_fight_bonus;
                        if (q_skill.q_attribute) attrArr.push(q_skill.q_attribute);
                    }
                }
                break;
            case EnumZhanliType.YIRONG_EQUIP: // 易容装备
                for (var v of Mgr.disguise.disguiseList) {
                    for (var vv of v.equips) {
                        var info = Q_item_simpact.Get(vv.itemModelId);
                        attrArr.push(info ? info.q_attribute : "");
                    }
                }
                break;
        }

        var power = 0;
        for (var str of attrArr) {
            power += Mgr.fightpower.GetFightPower(str);
        }
        return Math.floor(power);
    },
    OpenPanel: function(main, sub) {
        switch (main) {
            case EnumZhanliType.ZUOQI:
            case EnumZhanliType.GUANGWU:
            case EnumZhanliType.BAIQI:
            case EnumZhanliType.JIANQIAO:
            case EnumZhanliType.JIAOYIN:
            case EnumZhanliType.JIANZHAO:
            case EnumZhanliType.WUXUE:
                EngineMgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName);
                break;
            case EnumZhanliType.FAQI:
            case EnumZhanliType.SHUTONG:
                EngineMgr.uiMgr.ShowHidePanelByType(ShuTongPanelExt.PanelName);
                break;
            case EnumZhanliType.EQUIP: //装备
                switch (sub) {
                    case EnumZhanliType.EQIUP_BASE:
                        EngineMgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName);
                        break;
                    case EnumZhanliType.EQIUP_QIANGHUA:
                    case EnumZhanliType.EQIUP_JINGLIAN:
                    case EnumZhanliType.EQIUP_BAOSHI:
                    case EnumZhanliType.EQIUP_TAOZHUANG:
                        EngineMgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName);
                        break;
                    default:
                        EngineMgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName);
                        break;
                }
                break;
            case EnumZhanliType.SKILL:
                switch (sub) {
                    case EnumZhanliType.SKILL_ZHUDONG:
                        EngineMgr.uiMgr.ShowHidePanelByType(SkillPanelExt.PanelName);
                        break;
                    case EnumZhanliType.SKILL_BEIDONG:
                        EngineMgr.uiMgr.ShowHidePanelByType(SkillPanelExt.PanelName);
                        break;

                    case EnumZhanliType.SKILL_YIRONG:
                        EngineMgr.uiMgr.ShowHidePanelByType(SkillPanelExt.PanelName);
                        break;

                    default:
                        EngineMgr.uiMgr.ShowHidePanelByType(SkillPanelExt.PanelName);
                        break;
                }
                break;
            case EnumZhanliType.YIRONG:
                switch (sub) {
                    case EnumZhanliType.YIRONG_DENGJIE:
                    case EnumZhanliType.YIRONG_EQUIP:
                    default:
                        Mgr.disguise.isInit = true;
                        var panel = EngineMgr.uiMgr.ShowPanelByType(YiRongPanelExt.PanelName);
                        panel.Update();
                        break
                }
                break;
        }

        return 0;
    },
}