var AddFriendPanelExt = AddFriendPanel.extend ( {
	_className:"AddFriendPanelExt",
	_searchListview:null,
	ctor:function(){
		this._super();
	},
	Init:function()
	{
		var self = this;
		AddFriendPanel.prototype.Init.call(this);
		this.setPosition(5,3);
		this.setSwallowTouches(false);
		this._SetLocalProperty();
		this._AddSearchListview();
		this._SetBaseProperty();
		this._SetAddList();
		this._HandleButton();
	},
	_SetLocalProperty:function()
	{
		this.addList = [];
		this.isChanged = false;
	},
	_SetBaseProperty:function()
	{
		this.labCue.SetFontSize(24);
		this.labCue.SetColor(EnumFontFormat.COMMON_COLOR02);
		this.labCue.DisableEffect();
		this.lab1.SetFontSize(24);
		this.lab1.SetColor(EnumFontFormat.COMMON_COLOR01);
		this.lab1.DisableEffect();
		this.labNon.SetFontSize(24);
		this.labNon.SetColor("0xac8557");
		this.labNon.DisableEffect();
		this.labFriend.SetFontSize(22);
		this.labFriend.SetColor(EnumFontFormat.COMMON_COLOR04);
		this.labFriend.DisableEffect();
		this.editCue.setPlaceHolder("请输入玩家名字");
		this.editCue.setPlaceholderFontColor(UIUtil.GetCCColor("0x776b5f"));
		this.editCue.setTextColor(UIUtil.GetCCColor("0x776b5f"));
        // FIX 保持居中
        //this.editCue.y = 0;
		this.btn1.SetTitleTextFontSize(EnumFontFormat.FONTSIZE_BUTTON);
		this.btn1.setTitleColor(UIUtil.GetCCColor(EnumFontFormat.COMMON_COLOR02))
		this.imgModel.setLocalZOrder(100);
	},
	_SetAddList:function()
	{
		for ( var i = 0; i < 4; i++ )
		{
			var item = new AddFriendList1Ext();
			item.LoadPanel();
			item.setPosition(20,this.img1.y-item.height*(i+1));
			this.addChild(item);
			item.visible = false;
			this.addList.push(item);
		}
	},
	_AddSearchListview:function()
	{
		var listview = Mgr.crossteam.GetListview(693,460);
		listview.setPosition(-20,-listview.getContentSize().height);
		this.imgXian.addChild(listview);
		this._searchListview = listview;
	},
	_HandleButton:function()
	{
		var self = this;
		this.btn1.addClickEventListener(function()
		{
			if(!self.isChanged)
			{
				self.ChangePlayer();
				self._StartCountDown();
			}
		});
		this.btnFace.addClickEventListener(function()
		{
			if(self.editCue.string.length < 1)
			{
				Mgr.tips.ShowNotice("搜索玩家名字不能为空");
				return;
			}
			Mgr.friend.SendReqSearchFriendInfoMessage(self.editCue.string);
		});
	},
	UpdataSearchedPercenInfo:function(msg)
	{
		var listData = msg.recFriendInfo;
		var items = this._searchListview.getItems();
		this.ClearSearchList();
		for(var i = 0; i < listData.length; i++ )
		{
			if(items[i])
			{
				items[i].UpdateInformation(listData[i]);
				items[i].visible = true;
			}
			else
			{
				var item = new AddFriendList2Ext();
				item.LoadPanel();
				item.UpdateInformation(listData[i]);
				this._searchListview.pushBackCustomItem(item);
			}
		}
	},
	UpdataInfo:function(msg)
	{
		this._ClearAddList();
		var dataList = this._GetRecommendList(msg.recFriendInfos);
		if(dataList.length <=4 )
		{
			for ( var i = 0; i <dataList.length; i++ )
			{
				this.addList[i].visible = true;
				this.addList[i].UpdataInfo(dataList[i]);
			}
		}
		else
		{
			for ( var i = 0; i <this.addList.length; i++ )
			{
				this.addList[i].visible = true;
				this.addList[i].UpdataInfo(dataList[i]);
			}
		}
		for(var i = 0; i < this.addList.length; i++ )
		{
			if(this.addList[i].visible)
			{
				this.labNon.visible = false;
				break;
			}
			else if(i == this.addList.length-1)
			{
				this.labNon.visible = true;
			}
		}
	},
	//换一批
	ChangePlayer:function()
	{
		Mgr.friend.SendReqRecFriendInfoMessage();
	},
	//筛选非好友成员
	_GetRecommendList:function(data)
	{
		var list = [];
		for(var i = 0; i < data.length; i++ )
		{
			if( data[i].playerId.toGID() == Mgr.player.mainPlayer.sid.toGID())
			{
				data.splice(i,1);
				break;
			}
		}
		//换一批的时候将已经成为好友的玩家隐藏
		//var fList = Mgr.friend.friendList;
		//for(var i = 0;i < data.length; i++ )
		//{
		//	if(fList.Get(data[i].playerId))
		//	{
		//		continue;
		//	}
		//	else
		//	{
		//		list.push(data[i]);
		//	}
		//}
		return data;
	},
	_StartCountDown:function()
	{
		var self = this;
		self.isChanged = true;
		var times = 5;
		var count = 5;
		self.btn1.setTitleText("换一批("+count+")");
		Filter.GrayScale(self.btn1);
		this.schedule(function()
		{
			count--;
			self.btn1.setTitleText("换一批("+count+")");
			if(count==0)
			{
				self.btn1.setTitleText("换一批");
				Filter.UnGray(self.btn1);
				self.isChanged = false;
			}

		},1,times-1)
	},
	//点击搜索列表中的添加，与换一批列表玩家状态同步
	CheckAddedPlayer:function(data)
	{
		for(var i = 0; i < this.addList.length; i++ )
		{
			if(this.addList[i].visible)
			{
				if(this.addList[i].data.name == data.name)
				{
					this.addList[i].btnAdd.visible = false;
					this.addList[i].labName1.visible = true;
					break;
				}
			}
		}
	},
	CheckSearchedListPlayer:function(data)
	{
		var items = this._searchListview.getItems();
		for(var i = 0; i < items.length;i++ )
		{
			if (items[i].data.playerId.toGID() == data.playerId.toGID())
			{
				items[i].HandleClicked();
			}
		}
	},
	_ClearAddList:function()
	{
		for(var i = 0; i < this.addList.length; i++ )
		{
			this.addList[i].visible = false;
		}
	},
	ClearSearchList:function()
	{
		var items = this._searchListview.getItems();
		for(var j = 0; j < items.length; j++)
		{
			items[j].visible = false;
		}
	}
} );
AddFriendPanelExt.PanelName = "AddFriendPanelExt";
PanelClassDic["AddFriendPanelExt"] = AddFriendPanelExt;
