///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//FriendRelationInfo 好友信息
//RecFriendInfo 推荐好友简要信息

// 请求消息
//116201,ReqFriendListInfo 请求获取好友信息列表
//116203,ReqChangeSignature 请求更改签名心情
//116204,ReqPlayerFriendSetting 请求或者保存玩家好友设置和相关信息
//116205,ReqApplyFriend 申请添加好友
//116206,ReqAgreeRefuseApplyFriend 同意或者拒绝好友
//116207,ReqAddBlack 添加或者删除黑名单
//116208,ReqDeleteFriend 删除好友
//116209,ReqRecFriendInfo 请求获取推荐好友信息列表
//116210,ReqSearchFriendInfo 请求搜索玩家
//116211,ReqApplyListInfo 请求申请列表
//116212,ReqSendFlowersToGame 送花

// 接收消息
//116101,ResFriendListInfo 发送好友列表信息
//116102,ResOperationFriendResult 发送操作结果给玩家
//116104,ResPlayerFriendSetting 发送好友设置给玩家
//116105,ResApplyMapFriend 发送好友申请列表给玩家（此消息登陆的时候和者申请的时候发送给玩家）
//116106,ResAgreeRefuseApplyFriend 同意或者拒绝好友
//116107,ResRecFriendList 发送推荐好友列表
//116108,ResSearchFriendResult 发送搜索好友结果
//116109,ResSendFlowersResultToClient 发送送花结果给送花对象


var FriendRelationInfo = cc.Class.extend({
	ctor:function(){
		this.playerId = null; // 角色Id
        this.name = null; // 角色名
        this.level = 0; // 等级
        this.vipLevel = 0; // VIP等级
        this.icon = 0; // 人物头像
        this.sex = 0; // 性别
        this.mapId = 0; // 当前所在地图Id
        this.x = 0; // 当前所在地图X
        this.y = 0; // 当前所在地图Y
        this.signature = null; // 签名心情
        this.guildName = null; // 帮会名称
        this.addTime = null; // 添加时间
        this.lastChatTime = null; // 最后聊天时间
        this.state = 0; // 状态0 离线 1在线
        this.relationType = 0; // 关系类型 (1 好友列表  2 黑名单 3陌生人 4最近联系人)
        this.tencentDomain = 0; // 腾讯登陆渠道
        this.tencentVip = 0; // 腾讯登陆渠道对应vipd等级
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.name);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.vipLevel);
        _buf.WriteVarInt(this.icon);
        _buf.WriteByte(this.sex);
        _buf.WriteVarInt(this.mapId);
        _buf.WriteShort(this.x);
        _buf.WriteShort(this.y);
        _buf.WriteString(this.signature);
        _buf.WriteString(this.guildName);
        _buf.WriteLong(this.addTime);
        _buf.WriteLong(this.lastChatTime);
        _buf.WriteByte(this.state);
        _buf.WriteByte(this.relationType);
        _buf.WriteVarInt(this.tencentDomain);
        _buf.WriteVarInt(this.tencentVip);
	},

	reading:function( _buf ){
		this.playerId = _buf.ReadLong();
        this.name = _buf.ReadString();
        this.level = _buf.ReadVarInt();
        this.vipLevel = _buf.ReadVarInt();
        this.icon = _buf.ReadVarInt();
        this.sex = _buf.ReadByte();
        this.mapId = _buf.ReadVarInt();
        this.x = _buf.ReadShort();
        this.y = _buf.ReadShort();
        this.signature = _buf.ReadString();
        this.guildName = _buf.ReadString();
        this.addTime = _buf.ReadLong();
        this.lastChatTime = _buf.ReadLong();
        this.state = _buf.ReadByte();
        this.relationType = _buf.ReadByte();
        this.tencentDomain = _buf.ReadVarInt();
        this.tencentVip = _buf.ReadVarInt();
	},
});
var RecFriendInfo = cc.Class.extend({
	ctor:function(){
		this.playerId = null; // 角色Id
        this.name = null; // 角色名
        this.level = 0; // 等级
        this.icon = 0; // 人物头像
        this.guildName = null; // 帮会名称
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.name);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.icon);
        _buf.WriteString(this.guildName);
	},

	reading:function( _buf ){
		this.playerId = _buf.ReadLong();
        this.name = _buf.ReadString();
        this.level = _buf.ReadVarInt();
        this.icon = _buf.ReadVarInt();
        this.guildName = _buf.ReadString();
	},
});
////////////////////
// 发送好友列表信息 //
////////////////////
var ResFriendListInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.friendList = []; // 好友列表信息 FriendRelationInfo
        this.blackList = []; // 黑名单信息列表 FriendRelationInfo
        this.strangerList = []; // 陌生人信息列表 FriendRelationInfo
        this.latelyList = []; // 最近联系人信息列表 FriendRelationInfo
	},

	getId:function(){
		return 116101;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.friendList.length );
        for (var i = 0; i < this.friendList.length; i++) {
            _buf.WriteBean(this.friendList[i]);
        }
        _buf.WriteUShort( this.blackList.length );
        for (var i = 0; i < this.blackList.length; i++) {
            _buf.WriteBean(this.blackList[i]);
        }
        _buf.WriteUShort( this.strangerList.length );
        for (var i = 0; i < this.strangerList.length; i++) {
            _buf.WriteBean(this.strangerList[i]);
        }
        _buf.WriteUShort( this.latelyList.length );
        for (var i = 0; i < this.latelyList.length; i++) {
            _buf.WriteBean(this.latelyList[i]);
        }
	},

	reading:function( _buf ){
        var friendList_length = _buf.ReadUShort();
        for (var i = 0; i < friendList_length; i++) {
            this.friendList[i] = _buf.ReadBean(FriendRelationInfo);
        }
        var blackList_length = _buf.ReadUShort();
        for (var i = 0; i < blackList_length; i++) {
            this.blackList[i] = _buf.ReadBean(FriendRelationInfo);
        }
        var strangerList_length = _buf.ReadUShort();
        for (var i = 0; i < strangerList_length; i++) {
            this.strangerList[i] = _buf.ReadBean(FriendRelationInfo);
        }
        var latelyList_length = _buf.ReadUShort();
        for (var i = 0; i < latelyList_length; i++) {
            this.latelyList[i] = _buf.ReadBean(FriendRelationInfo);
        }
	},

	action:function(){
		Mgr.friend.RecvResFriendListInfoMessage(this);
	},

});
////////////////////
// 发送操作结果给玩家 //
////////////////////
var ResOperationFriendResultMessage = cc.Class.extend( {
	ctor:function(){
		this.friendRelationInfo = null; // 被操作源的关系信息
        this.operationType = 0; // 操作类型(1 添加 2 删除
        this.result = 0; // 结果(0 成功 1失败)
        this.relationType = 0; // 关系类型
	},

	getId:function(){
		return 116102;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.friendRelationInfo);
        _buf.WriteByte(this.operationType);
        _buf.WriteByte(this.result);
        _buf.WriteByte(this.relationType);
	},

	reading:function( _buf ){
        this.friendRelationInfo = _buf.ReadBean(FriendRelationInfo);
        this.operationType = _buf.ReadByte();
        this.result = _buf.ReadByte();
        this.relationType = _buf.ReadByte();
	},

	action:function(){
		Mgr.friend.RecvResOperationFriendResultMessage(this);
	},

});
////////////////////
// 发送好友设置给玩家 //
////////////////////
var ResPlayerFriendSettingMessage = cc.Class.extend( {
	ctor:function(){
		this.signature = null; // 签名心情
        this.openMapLocation = 0; // 是否公开我的地图位置0显示 1不显示
        this.showRelation = 0; // 是否显示不在线的好友或仇人0显示 1不显示
        this.showIcon = 0; // 是否显示不在线的好友或仇人0显示 1不显示
	},

	getId:function(){
		return 116104;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteString(this.signature);
        _buf.WriteByte(this.openMapLocation);
        _buf.WriteByte(this.showRelation);
        _buf.WriteByte(this.showIcon);
	},

	reading:function( _buf ){
        this.signature = _buf.ReadString();
        this.openMapLocation = _buf.ReadByte();
        this.showRelation = _buf.ReadByte();
        this.showIcon = _buf.ReadByte();
	},

	action:function(){
		Mgr.friend.RecvResPlayerFriendSettingMessage(this);
	},

});
////////////////////
// 发送好友申请列表给玩家（此消息登陆的时候和者申请的时候发送给玩家） //
////////////////////
var ResApplyMapFriendMessage = cc.Class.extend( {
	ctor:function(){
		this.playerIdList = []; // 玩家ID列表 long
        this.applyTypes = []; // 申请类型（1是主动申请 2是被动申请） int
	},

	getId:function(){
		return 116105;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.playerIdList.length );
        for (var i = 0; i < this.playerIdList.length; i++) {
            _buf.WriteLong(this.playerIdList[i]);
        }
        _buf.WriteUShort( this.applyTypes.length );
        for (var i = 0; i < this.applyTypes.length; i++) {
            _buf.WriteVarInt(this.applyTypes[i]);
        }
	},

	reading:function( _buf ){
        var playerIdList_length = _buf.ReadUShort();
        for (var i = 0; i < playerIdList_length; i++) {
            this.playerIdList[i] = _buf.ReadLong();
        }
        var applyTypes_length = _buf.ReadUShort();
        for (var i = 0; i < applyTypes_length; i++) {
            this.applyTypes[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.friend.RecvResApplyMapFriendMessage(this);
	},

});
////////////////////
// 同意或者拒绝好友 //
////////////////////
var ResAgreeRefuseApplyFriendMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 对方Id
        this.type = 0; // 类型（1同意 2是拒绝）
	},

	getId:function(){
		return 116106;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteByte(this.type);
	},

	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.type = _buf.ReadByte();
	},

	action:function(){
		Mgr.friend.RecvResAgreeRefuseApplyFriendMessage(this);
	},

});
////////////////////
// 发送推荐好友列表 //
////////////////////
var ResRecFriendListMessage = cc.Class.extend( {
	ctor:function(){
		this.recFriendInfos = []; // 推荐玩家简要信息列表 RecFriendInfo
	},

	getId:function(){
		return 116107;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.recFriendInfos.length );
        for (var i = 0; i < this.recFriendInfos.length; i++) {
            _buf.WriteBean(this.recFriendInfos[i]);
        }
	},

	reading:function( _buf ){
        var recFriendInfos_length = _buf.ReadUShort();
        for (var i = 0; i < recFriendInfos_length; i++) {
            this.recFriendInfos[i] = _buf.ReadBean(RecFriendInfo);
        }
	},

	action:function(){
		Mgr.friend.RecvResRecFriendListMessage(this);
	},

});
////////////////////
// 发送搜索好友结果 //
////////////////////
var ResSearchFriendResultMessage = cc.Class.extend( {
	ctor:function(){
		this.recFriendInfo = []; // 玩家简要信息 RecFriendInfo
	},

	getId:function(){
		return 116108;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.recFriendInfo.length );
        for (var i = 0; i < this.recFriendInfo.length; i++) {
            _buf.WriteBean(this.recFriendInfo[i]);
        }
	},

	reading:function( _buf ){
        var recFriendInfo_length = _buf.ReadUShort();
        for (var i = 0; i < recFriendInfo_length; i++) {
            this.recFriendInfo[i] = _buf.ReadBean(RecFriendInfo);
        }
	},

	action:function(){
		Mgr.friend.RecvResSearchFriendResultMessage(this);
	},

});
////////////////////
// 发送送花结果给送花对象 //
////////////////////
var ResSendFlowersResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 送花的玩家唯一ID
        this.playerName = null; // 送花玩家的名字
        this.sendNum = 0; // 送花数量
	},

	getId:function(){
		return 116109;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.playerName);
        _buf.WriteVarInt(this.sendNum);
	},

	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.sendNum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.friend.RecvResSendFlowersResultToClientMessage(this);
	},

});
////////////////////
// 请求获取好友信息列表 //
////////////////////
var ReqFriendListInfoMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 116201;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

});
////////////////////
// 请求更改签名心情 //
////////////////////
var ReqChangeSignatureMessage = cc.Class.extend( {
	ctor:function(){
		this.signature = null; // 签名心情
	},

	getId:function(){
		return 116203;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteString(this.signature);
	},

	reading:function( _buf ){
        this.signature = _buf.ReadString();
	},

});
////////////////////
// 请求或者保存玩家好友设置和相关信息 //
////////////////////
var ReqPlayerFriendSettingMessage = cc.Class.extend( {
	ctor:function(){
		this.operationType = 0; // 操作类型(1 请求获取 2是保存 )
        this.openMapLocation = 0; // 是否公开我的地图位置0显示 1不显示
        this.showRelation = 0; // 是否显示不在线的好友或仇人0显示 1不显示
        this.showIcon = 0; // 是否显示不在线的好友或仇人0显示 1不显示
	},

	getId:function(){
		return 116204;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteByte(this.operationType);
        _buf.WriteByte(this.openMapLocation);
        _buf.WriteByte(this.showRelation);
        _buf.WriteByte(this.showIcon);
	},

	reading:function( _buf ){
        this.operationType = _buf.ReadByte();
        this.openMapLocation = _buf.ReadByte();
        this.showRelation = _buf.ReadByte();
        this.showIcon = _buf.ReadByte();
	},

});
////////////////////
// 申请添加好友 //
////////////////////
var ReqApplyFriendMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 对方Id
	},

	getId:function(){
		return 116205;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
	},

	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
	},

});
////////////////////
// 同意或者拒绝好友 //
////////////////////
var ReqAgreeRefuseApplyFriendMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 对方Id
        this.type = 0; // 类型（1同意 2是拒绝）
	},

	getId:function(){
		return 116206;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteByte(this.type);
	},

	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 添加或者删除黑名单 //
////////////////////
var ReqAddBlackMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 对方Id
        this.operationType = 0; // 操作类型(1 添加 2 删除)
	},

	getId:function(){
		return 116207;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteByte(this.operationType);
	},

	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.operationType = _buf.ReadByte();
	},

});
////////////////////
// 删除好友 //
////////////////////
var ReqDeleteFriendMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 对方Id
	},

	getId:function(){
		return 116208;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
	},

	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
	},

});
////////////////////
// 请求获取推荐好友信息列表 //
////////////////////
var ReqRecFriendInfoMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 116209;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

});
////////////////////
// 请求搜索玩家 //
////////////////////
var ReqSearchFriendInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.playerName = null; // 对方玩家名字（不支持模糊搜索）
	},

	getId:function(){
		return 116210;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteString(this.playerName);
	},

	reading:function( _buf ){
        this.playerName = _buf.ReadString();
	},

});
////////////////////
// 请求申请列表 //
////////////////////
var ReqApplyListInfoMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 116211;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

});
////////////////////
// 送花 //
////////////////////
var ReqSendFlowersToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 玩家唯一ID
        this.sendNumIndex = 0; // 送花数量索引（0,1,2,3）
	},

	getId:function(){
		return 116212;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteVarInt(this.sendNumIndex);
	},

	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.sendNumIndex = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(116101, ResFriendListInfoMessage);
MESSAGE_POOL.Add(116102, ResOperationFriendResultMessage);
MESSAGE_POOL.Add(116104, ResPlayerFriendSettingMessage);
MESSAGE_POOL.Add(116105, ResApplyMapFriendMessage);
MESSAGE_POOL.Add(116106, ResAgreeRefuseApplyFriendMessage);
MESSAGE_POOL.Add(116107, ResRecFriendListMessage);
MESSAGE_POOL.Add(116108, ResSearchFriendResultMessage);
MESSAGE_POOL.Add(116109, ResSendFlowersResultToClientMessage);

