var FriendModMgr = FriendModMgr || cc.Class.extend({

	ctor:function() {
		this.mainPanel = null;
		this.applyList = null;
		this.friendList = null;
		this.latelyList = null;
		this.blackList = null;
		this.addList = null;
		this.isStranger = false;
		this.isPlayerHandle = false;
		this._GetApplyList();
	},

    GetFriendById:function(id){
        return this.friendList && this.friendList.Get(id);
    },
    GetFriendByName:function(name){
        var arr = this.friendList && this.friendList.Values();
        return arr.find(v=>v.name == name)
    },

	RecvResFriendListInfoMessage:function(msg) {
		//cc.log("get firend info   " + JSON.stringify(msg));
		var panel = this._GetMainPanel();
		this.strangerList = this.GetStrangerList();
		this.friendList = this.GetFriendList();
		this.strangerList.Clear();
		this.friendList.Clear();
		for(var i = 0; i < msg.strangerList.length; i++){
			if(msg.strangerList[i].playerId.toGID() == Mgr.player.mainPlayer.sid.toGID()){
				continue;
			}
			this.strangerList.Put(msg.strangerList[i].playerId, msg.strangerList[i]);
		}

		for(var i = 0; i < msg.friendList.length; i++ )
		{
			if(msg.friendList[i].playerId.toGID() == Mgr.player.mainPlayer.sid.toGID())
			{
				continue;
			}
			this.friendList.Put(msg.friendList[i].playerId,msg.friendList[i]);
			if(!this.isStranger)
			{
				this.strangerList.Remove(msg.friendList[i].playerId);
			}
		}
		this.blackList = this.GetBlackList();
		this.blackList.Clear();
		for(var i = 0; i < msg.blackList.length; i++ )
		{
			this.blackList.Put(msg.blackList[i].playerId,msg.blackList[i]);
			if(!this.isStranger)
			{
				this.strangerList.Remove(msg.blackList[i].playerId);
			}
		}
		this.latelyList = this._GetLatelyList();
		if(!this.isStranger) {
            this.latelyList.Clear();
            for (var i = 0; i < msg.latelyList.length; i++) {
                if (msg.latelyList[i].playerId.toGID() == Mgr.player.mainPlayer.sid.toGID()) {
                    continue;
                }
                this.latelyList.Put(msg.latelyList[i].playerId, msg.latelyList[i]);
                this.strangerList.Remove(msg.latelyList[i].playerId);
            }
        }

        GameEventMgr.DispatchEvent(msg.getId(),msg)
	},

	RecvResOperationFriendResultMessage:function(msg) {
		var playerInfo = msg.friendRelationInfo;
		var isAddNewFriend = false;
		if(!this.addList)
		{
			this.addList = new HashMap();
		}
		switch (msg.relationType)
		{
			case EnumRelationType.FRIEND_LIST://好友
			{
				if(msg.operationType == EnumRelationType.OPERATION_ADD)
				{
					if(msg.result == EnumRelationType.OPERATION_RESULT_SUCCESS)
					{
						playerInfo.relationType = EnumRelationType.FRIEND_LIST;
						this.friendList.Put(playerInfo.playerId,playerInfo);
						this.blackList.Remove(playerInfo.playerId);
						var panel = this._GetMainPanel();
						if( panel && panel.visible)
						{
							isAddNewFriend = true;
						}
						else
						{
							this.addList.Put(playerInfo.playerId,playerInfo);
						}
					}
				}
				else
				{
					if(msg.result == EnumRelationType.OPERATION_RESULT_SUCCESS)
					{
						this.friendList.Remove(playerInfo.playerId);
						this.addList.Remove(playerInfo.playerId);
					}
				}
				break;
			}
			case EnumRelationType.BLACK_LIST://黑名单
			{
				if(msg.operationType == EnumRelationType.OPERATION_ADD)
				{
					if(msg.result == EnumRelationType.OPERATION_RESULT_SUCCESS)
					{
						this.blackList.Put(playerInfo.playerId,playerInfo);
						this.friendList.Remove(playerInfo.playerId);
					}
				}
				else
				{
					if(msg.result == EnumRelationType.OPERATION_RESULT_SUCCESS)
					{
						this.blackList.Remove(playerInfo.playerId);
					}
				}
				break;
			}
			case EnumRelationType.RECENT_LIST://最近联系人
			{
				if(msg.operationType == EnumRelationType.OPERATION_ADD)
				{
					if(msg.result == EnumRelationType.OPERATION_RESULT_SUCCESS)
					{
						this.latelyList.Put(playerInfo.playerId,playerInfo);
					}
				}
				else
				{
					if(msg.result == EnumRelationType.OPERATION_RESULT_SUCCESS)
					{
						this.latelyList.Remove(playerInfo.playerId);
					}
				}
				break;
			}
			case EnumRelationType.STRANGER_LIST://陌生人
			{
				break;
			}
			default:break;
		}
		var panel = this._GetMainPanel();
		if( panel && panel.visible)
		{
			panel.friendPanel.RefrishListview();
			if(isAddNewFriend)
			{
				panel.friendPanel.AddNewFriendTipsItem(playerInfo);
			}
		}
	},

	RecvResPlayerFriendSettingMessage:function(msg) {
	},

	RecvResApplyMapFriendMessage:function(msg) {
		if(Mgr.plugset.GetSysSetInfo().banAddFriend)
		{
			return;
		}
		this._GetApplyList().Clear();
		var len = 0;
		for ( var i = 0; i < msg.playerIdList.length; i++ )
		{
			if(this.friendList && this.friendList.Get(msg.playerIdList[i]))
			{
				continue;
			}
			if(this.blackList && this.blackList.Get(msg.playerIdList[i]))
			{
				continue;
			}
			this._GetApplyList().Put(msg.playerIdList[i],msg.playerIdList[i])
			len++;
		}
		Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).GetNewFriendApplyNotice(len);
	},

	RecvResAgreeRefuseApplyFriendMessage:function(msg) {
	},

	RecvResRecFriendListMessage:function(msg) {
        this.recommendFriendArr = msg.recFriendInfos
        GameEventMgr.DispatchEvent(msg.getId(),msg)

		var panel = this._GetMainPanel();
		if( panel && panel.visible)
		{
			panel.addfriendPanel.UpdataInfo(msg);
		}
	},
	RecvResSearchFriendResultMessage:function(msg)
	{
		var panel = this._GetMainPanel();
		if( panel && panel.visible)
		{
			panel.addfriendPanel.UpdataSearchedPercenInfo(msg);
		}
	},

    RecvResSendFlowersResultToClientMessage:function(msg){
        if(msg.playerId.Equal(Mgr.player.mainPlayer.sid)){
            Mgr.tips.ShowNotice("送花成功！！！");
            GameEventMgr.DispatchEvent(msg.getId(),msg)
            return
        }
    },
	SendReqSearchFriendInfoMessage:function(name) {
		var msg = new ReqSearchFriendInfoMessage();
		msg.playerName = name;
		Mgr.msgMgr.Send(msg);
	},
	SendReqFriendListInfoMessage:function() {
		var msg = new ReqFriendListInfoMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqChangeSignatureMessage:function(msg) {
	},

	SendReqPlayerFriendSettingMessage:function(msg) {
	},

	SendReqApplyFriendMessage:function(playerId) {
		var friend = this.friendList.Get(playerId);
		if(playerId.toGID() == Mgr.player.mainPlayer.sid.toGID())
		{
			Mgr.tips.ShowNotice("不能添加自己为好友");
			return;
		}
		else if(friend)
		{
			Mgr.tips.ShowNotice("你们已经是好友了");
			return;
		}
		var msg = new ReqApplyFriendMessage();
		msg.playerId = playerId;
		Mgr.msgMgr.Send(msg);
	},
	/**
	 * 同意或者拒绝好友
	 * @param playerId
	 * @param type//类型（1同意 2是拒绝）
	 * @constructor
	 */
	SendReqAgreeRefuseApplyFriendMessage:function(playerId,type) {
		var msg = new ReqAgreeRefuseApplyFriendMessage();
		msg.playerId = playerId;
		msg.type = type;
		Mgr.msgMgr.Send(msg);
	},

	SendReqAddBlackMessage:function(playerId,operationType) {
		var msg = new ReqAddBlackMessage();
		msg.playerId = playerId;
		msg.operationType = operationType;
		Mgr.msgMgr.Send(msg);
	},

	SendReqDeleteFriendMessage:function(playerId) {
		var msg = new ReqDeleteFriendMessage();
		msg.playerId = playerId;
		Mgr.msgMgr.Send(msg);
	},

	SendReqRecFriendInfoMessage:function() {
		var msg = new ReqRecFriendInfoMessage();
		Mgr.msgMgr.Send(msg);
	},
	SendReqApplyListInfoMessage:function()
	{
		var msg = new ReqApplyListInfoMessage();
		Mgr.msgMgr.Send(msg);
	},

    SendReqSendFlowersToGameMessage:function(playerId,index){
        var msg = new ReqSendFlowersToGameMessage();
        msg.playerId = playerId,
        msg.sendNumIndex = index,
        Mgr.msgMgr.Send(msg);

        /// 发好友消息
        var friend = Mgr.friend.GetFriendList().Get(playerId)
        if(friend){
            let extraReqInfo = new ExtraReqInfo();
            extraReqInfo.targetPlayerName = friend ? friend.name : "???";
            extraReqInfo.hyperInfos = [];
            Mgr.chat.ReqChatRequestMessage(
                EnumChatChannelType.PRIVATE
                ,"今天心情不错,送你一朵玫瑰花!"
                ,extraReqInfo
                );
        }
    },
	JugementIsBlacklistPlayer:function(playerId,name)
	{
		if(!this.blackList){return false;}
		var array = this.blackList.Values();
		if(array.length < 1)
		{
			return false;
		}
		if(this.blackList.Get(playerId))
		{
			return true;
		}
		for(var i = 0; i < array.length;i++)
		{
			if(array[i].name == name)
			{
				return true;
			}
		}
		return false;
	},
	_GetMainPanel:function()
	{
		if( !this.mainPanel)
		{
			this.mainPanel = Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName);
		}
		return this.mainPanel;
	},
	_GetApplyList:function()
	{
		if(!this.applyList)
		{
			this.applyList = new HashMap();
		}
		return this.applyList;
	},
	GetFriendList:function()
	{
		if(!this.friendList)
		{
			this.friendList = new HashMap();
		}
		return this.friendList;
	},
	GetStrangerList:function()
	{
		if(!this.strangerList)
		{
			this.strangerList = new HashMap();
		}
		return this.strangerList;
	},
	GetBlackList:function()
	{
		if(!this.blackList)
		{
			this.blackList = new HashMap();
		}
		return this.blackList;
	},
	_GetLatelyList:function()
	{
		if(!this.latelyList)
		{
			this.latelyList = new HashMap();
		}
		return this.latelyList;
	}
});
