var FriendListExt = FriendList.extend ( {
	_className:"FriendListExt",
	_playerState:[0,1,2],
	ctor:function(){
		this._super();
		this.data = null;
		this.isReqRecord = false;
	},
	Init:function()
	{
		FriendList.prototype.Init.call(this);
		this._SetBaseProperty();
		this._HandleButton();
		this.SetNewMessageFlag(false);
	},
	_SetBaseProperty:function()
	{
		this.labName.SetFontSize(22);
		this.labName.SetColor(EnumFontFormat.COMMON_COLOR02);
		this.labName.DisableEffect();
		this.lablevel.SetFontSize(22);
		this.lablevel.SetColor(EnumFontFormat.COMMON_COLOR03);
		this.lablevel.DisableEffect();
		this.labOnline.SetFontSize(22);
		this.labOnline.SetColor(EnumFontFormat.COMMON_COLOR04);
		this.labOnline.DisableEffect();
		this.setContentSize(cc.size(this.width,92));
	},
	_HandleButton:function()
	{
		var self = this;
		this.setTouchEnabled(true);
		this.addClickEventListener(function()
		{
			self._SelfClickEvent();
		});
		this.btnLook.addClickEventListener(function()
		{
			self._ShowFuncPanel();
		});
        this.btnFlower.addClickEventListener(_=>{
            OpenFuncUtil.OpenSendFlowerPanel({
                playerId : this.data.playerId,
                name : this.data.name,
                sex : this.data.icon,
            })
        });
},
	_ShowFuncPanel:function()
	{
		if(this.data.playerId.toGID() != Mgr.player.mainPlayer.sid.toGID())
		{
			Mgr.player.SendReqPlayerBriefMessage([this.data.playerId],EnumBriefType.HEAD_MENUE);
			var pos = this.btnLook.getWorldPosition();
			EngineMgr.uiMgr.ShowHidePanelByType(MenuPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
			Mgr.uiMgr.GetPanelByType(MenuPanelExt.PanelName).SetInformation(this.data,pos);
			Mgr.uiMgr.HidePanelByType(MenuPanelExt.PanelName);
		}
	},
	_SelfClickEvent:function()
	{
		Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName).friendPanel.ChangeSelectedItem(this.data);
		var shortPanel = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName);
		shortPanel.UpdateNewChatPrivateInfo(this.data);
	},
	SetSelected:function(isSelected)
	{
		//this.imgCover.visible = isSelected;
		if(isSelected)
		{
			Mgr.chat.notOnlineList.Remove(this.data.playerId);
			Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName).friendPanel.InitChatInformation(this);
			this.SetNewMessageFlag(false);
			this._SendChatRecordMessage();
			this.TongBu();
			this._ControlImgVisible(this._playerState[2]);
		}
		else
		{
			if(this.data.state)
			{
				this._ControlImgVisible(this._playerState[1]);
			}
			else
			{
				this._ControlImgVisible(this._playerState[0]);
			}
		}
	},
	TongBu:function()
	{
		Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName).friendPanel.TongbuNewMessageFlag(this.data);
		Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName).CheckUnReadChatInfo();
	},
	SetNewMessageFlag:function(isNewFlag)
	{
		this.imgCue.visible = isNewFlag;
	},
	GetNewMessageFlag:function()
	{
		return this.imgCue.visible;
	},
	GetSelectedState:function()
	{
		return this.imgCover.visible;
	},
	//请求聊天记录，只执行一次
	_SendChatRecordMessage:function()
	{
		if(!this.isReqRecord)
		{
			this.isReqRecord = true;
			Mgr.chat.SendReqChatRecordMessage(this.data.playerId);
		}
	},
	SetInfomation:function(data)
	{
		this.data = data;
		this.labName.SetString(data.name);
		this.lablevel.SetString("Lv."+data.level);

        UIUtil.LoadImage(this.imgHead, ResUrl.GetSmallPlayerHeadUrl(data.icon),false,true);

		if(data.state)
		{
			this.labOnline.SetString("在线");
			//this.imgCover1.visible = false;//灰色背景
			//this._ControlImgVisible(this._playerState[1]);
			this.labOnline.SetColor(EnumFontFormat.COMMON_COLOR04);
		}
		else
		{
			this.labOnline.SetString("离线");
			//this.imgCover1.visible = true;//灰色背景
			//this._ControlImgVisible(this._playerState[0]);
			this.labOnline.SetColor(EnumFontFormat.COMMON_COLOR03);
		}
		this.SetSelected(false);
	},
	//0:离线，1：在线，2：选中
	_ControlImgVisible:function(state)
	{
		switch (state)
		{
			case 0:
			{
				this.imgCover1.visible = true;
				this.imgCover.visible = false;
				this.imgList.visible = false;
				break;
			}
			case 1:
			{
				this.imgCover1.visible = false;
				this.imgCover.visible = false;
				this.imgList.visible = true;
				break;
			}
			case 2:
			{
				this.imgCover1.visible = false;
				this.imgCover.visible = true;
				this.imgList.visible = false;
				break;
			}
		}
	}
} );
FriendListExt.PanelName = "FriendListExt";
PanelClassDic["FriendListExt"] = FriendListExt;
