var FriendPanelExt = FriendPanel.extend ( {
	_className:"FriendPanelExt",
	_selectedType:EnumRelationType.RECENT_LIST,
	ctor:function(){
		this._super();
	},
	Init:function()
	{
		FriendPanel.prototype.Init.call(this);
		this.setPosition(5,-100);
		this.setSwallowTouches(false);
		this._SetLocalProperty();
		this._SetBaseProperty();
		this._initProperty();
		this._SetButtonEvent();
		this._AddListview();
	},
	_SetLocalProperty:function()
	{
		this.img2 = this.imgXian;
		this.listItemHeight = 88;
		this.listItemWidth = 370;
		this.recentList = null;
		this.friendList = null;
		this.blackList = null;
		this.friendCount = 0;
		this.blackCount = 0;
		this.recentCount = 0;
		this.chatInfoCount = 0;
		this.chatInfoList = new HashMap();
		this.currentSelectedItem = null;
		this.chatHashmap = new HashMap();
		this.extraReqInfo = new ExtraReqInfo();
		this.btnArr = [
			{btn:this.labZuijin,label:this.labNum},
			{btn:this.labFriend1,label:this.labNum1},
			{btn:this.labChouren,label:this.labNum11}
		];
		this.btnArrLength = this.btnArr.length;
		this.selectedStateFormat = {
			fontsize:24,
			color:EnumFontFormat.COMMON_COLOR01,
		}
		this.normalStateFormat = {
			fontsize:24,
			color:EnumFontFormat.COMMON_COLOR02,
		}
		this._btnStates = [ MUICheckBox.STATE_CHECK , MUICheckBox.STATE_UNCHECK];
	},
	_SetBaseProperty:function()
	{
		this.labFriend.SetFontSize(22);
		this.labFriend.SetColor(EnumFontFormat.COMMON_COLOR04);
		this.labFriend.SetString("");
		this._RefrishBtnFontformat(0);
	},
	_RefrishBtnFontformat:function(type)
	{
		for ( var i = 0; i < this.btnArrLength; i++ )
		{
			if(type == i)
			{
				this.btnArr[i].btn.SetFontSize(this.selectedStateFormat.fontsize);
				this.btnArr[i].btn.SetColor(this.selectedStateFormat.color);
				this.btnArr[i].label.SetFontSize(this.selectedStateFormat.fontsize);
				this.btnArr[i].label.SetColor(this.selectedStateFormat.color);
			}
			else
			{
				this.btnArr[i].btn.SetFontSize(this.normalStateFormat.fontsize);
				this.btnArr[i].btn.SetColor(this.normalStateFormat.color);
				this.btnArr[i].label.SetFontSize(this.normalStateFormat.fontsize);
				this.btnArr[i].label.SetColor(this.normalStateFormat.color);
			}
		}
	},
	_initProperty:function()
	{
		this.editCue.setPlaceHolder("请输入聊天内容");
		this.editCue.setPlaceholderFontColor(UIUtil.GetCCColor(EnumFontFormat.COMMON_COLOR08));
		this.editCue.setFontSize(EnumFontFormat.FONTSIZE_TIP);
		this.editCue.setTextColor(UIUtil.GetCCColor(EnumFontFormat.COMMON_COLOR08));
        // FIX 保持居中
        //this.editCue.y = 6;
		this.labNum.SetString("0/0");
		this.labNum1.SetString("0/0");
		this.labNum11.SetString("0/0");
		this.labCue.visible = false;
	},
	_SetButtonEvent:function()
	{
		var self = this;
		this.sbtn1.addClickEventListener(function()
		{
			self._RefreshListviewPos(EnumRelationType.RECENT_LIST);
			self._InitSelectedItem(EnumRelationType.RECENT_LIST);
		});
		this.sbtn11.addClickEventListener(function()
		{
			self._RefreshListviewPos(EnumRelationType.FRIEND_LIST);
			self._InitSelectedItem(EnumRelationType.FRIEND_LIST);
		});
		this.sbtn111.addClickEventListener(function()
		{
			self._RefreshListviewPos(EnumRelationType.BLACK_LIST);
			self._InitSelectedItem(EnumRelationType.BLACK_LIST);
		});
		this.sbtn2.setTouchEnabled(false);
		this.sbtn21.setTouchEnabled(false);
		this.sbtn211.setTouchEnabled(false);
		this.btnHuSong.addClickEventListener(function()
		{
			self.SendChatInfo();
		});
		this.btnFace.addClickEventListener(function()
		{
			self._HandleFacePanel();
		});
		this.btnVoice.addTouchEventListener(function(target,state)
		{
			Sougou.HandleYuyin(target,state);
		});
	},
	_AddListview:function()
	{
		this.sbtn1.addChild(this._GetListview(this.listItemWidth,0,true),1,1000);
		this.sbtn11.addChild(this._GetListview(this.listItemWidth,0,true),1,1000);
		this.sbtn111.addChild(this._GetListview(this.listItemWidth,0,true),1,1000);
		this.recentList = this.sbtn1.getChildByTag(1000);
		this.friendList = this.sbtn11.getChildByTag(1000);
		this.blackList = this.sbtn111.getChildByTag(1000);
	},
	_GetListview:function(width,height,isJian)
	{
		var listView = new ccui.ListView();
		listView.setContentSize(cc.size(width,height));
		listView.setBounceEnabled(true);
		listView.setSwallowTouches(false);
		listView.setScrollBarEnabled(false);
		listView.setPosition(0,-listView.height);
		if(isJian)
		{
			listView.setPosition(1,-listView.height);
		}
		return listView;
	},
	_InitListviewData:function(type)
	{
		//好友列表
		if(type == EnumRelationType.FRIEND_LIST)
		{
			var fList = Mgr.friend.friendList.Values();
			fList.sort(function(a,b){return b.state- a.state;});
			for(var i = 0; i < fList.length; i++ )
			{
				this.friendList.pushBackCustomItem(this._GetItem(fList[i]));
			}
		}
		else if(type == EnumRelationType.BLACK_LIST)
		{
			//黑名单
			var bList = Mgr.friend.blackList.Values();
			bList.sort(function(a,b){return b.state- a.state;});
			for(var i = 0; i < bList.length; i++ )
			{
				this.blackList.pushBackCustomItem(this._GetItem(bList[i]));
				this._DelateBlackFromFriendRecent(bList[i].playerId);
			}
		}
		else if(type == EnumRelationType.RECENT_LIST)
		{
			//最近联系人
			var lList = Mgr.friend.latelyList.Values();
			lList.sort(function(a,b){return b.state- a.state;});
			for(var i = 0; i < lList.length; i++ )
			{
				this.recentList.pushBackCustomItem(this._GetItem(lList[i]));
			}
		}
	},
	_RefreshListviewContentSize:function()
	{
		var count = 3,gap = 0;
		var lList = Mgr.friend.latelyList.Values();
		var len01 = lList.length;
		var lh	  = len01 <= count ? len01 : count;
		if(lh == 1)
		{
			gap = 5;
		}
		else if(lh == 2)
		{
			gap = 10;
		}
		this.recentList.setContentSize(cc.size(this.listItemWidth,this.listItemHeight*lh+gap));
		var bList = Mgr.friend.blackList.Values();
		var len02 = bList.length;
		var bh	  = len02 <= count ? len02 : count;
		gap = 0
		if(bh == 1)
		{
			gap = 5;
		}
		else if(bh == 2)
		{
			gap = 10;
		}
		this.blackList.setContentSize(cc.size(this.listItemWidth,this.listItemHeight*bh+gap));
		var fList = Mgr.friend.friendList.Values();
		var len03 = fList.length;
		var fh	  = len03 <= count ? len03 : count;
		gap = 0
		if(fh == 1)
		{
			gap = 5;
		}
		else if(fh == 2)
		{
			gap = 10;
		}
		this.friendList.setContentSize(cc.size(this.listItemWidth,this.listItemHeight*fh+gap));
		this._ReSetListCount();
		this._SetOnlineCount();
		var type = this._GetCurrentRelationType();
		this._RefreshListviewPos_Size(type);
		//this._InitSelectedItem(type);
		this._CheckListviewNumber();
	},
	//控制好友列表上限
	_CheckListviewNumber:function()
	{
		var count = 50;
		var fList = this.friendList.getItems();
		if(fList.length > count)
		{
			var lastitem = this.friendList.getItem(fList.length-1);
			this.friendCount--;
			Mgr.friend.friendList.Remove(lastitem.data.playerId);
			this.friendList.removeChild(lastitem);
		}
		var fList = this.recentList.getItems();
		if(fList.length > count)
		{
			var lastitem = this.recentList.getItem(fList.length-1);
			this.recentCount--;
			Mgr.friend.recentList.Remove(lastitem.data.playerId);
			this.recentList.removeChild(lastitem);
		}
		var fList = this.blackList.getItems();
		if(fList.length > count)
		{
			var lastitem = this.blackList.getItem(fList.length-1);
			this.blackCount--;
			Mgr.friend.blackList.Remove(lastitem.data.playerId);
			this.blackList.removeChild(lastitem);
		}
	},
	//收到消息及时更新，将加入黑名单的玩家从好友列表和最近联系人列表删除
	_DelateBlackFromFriendRecent:function(playerId)
	{
		var friend = Mgr.friend.friendList.Get(playerId);
		if(friend)
		{
			Mgr.friend.friendList.Remove(playerId);
		}
		var recent = Mgr.friend.latelyList.Get(playerId);
		if(recent)
		{
			Mgr.friend.latelyList.Remove(playerId);
		}
	},
	RefrishListview:function()
	{
		var count = 3, self = this;
		var bList = Mgr.friend.blackList;
		var bItems = this.blackList.getItems();
		var type = EnumRelationType.BLACK_LIST;
		var countList = this.blackCount;
		var listview = this.blackList;
		(function()
		{
			if(count == 2)
			{
				bList = Mgr.friend.friendList;
				bItems = self.friendList.getItems();
				type = EnumRelationType.FRIEND_LIST;
				countList = self.friendCount;
				listview = self.friendList;
			}
			else if(count == 1)
			{
				bList = Mgr.friend.latelyList;
				bItems = self.recentList.getItems();
				type = EnumRelationType.RECENT_LIST;
				countList = self.recentCount;
				listview = self.recentList;
			}
			var listData = bList.Values();
			listData.sort(function(a,b) {return b.state - a.state;});
			var len01 =  listData.length;
			var len02 =  bItems.length;
			if(len01>=countList)
			{
				if(countList == 0)
				{
					self._InitListviewData(type);
				}
				else
				{
					for(var i = 0; i < len01; i++ )
					{
						if(bItems[i])
						{
							bItems[i].SetInfomation(listData[i]);
						}
						else
						{
							listview.pushBackCustomItem(self._GetItem(listData[i]));
						}
					}
				}
			}
			else if(len01<countList)
			{
				for(var i = 0; i < bItems.length; i++ )
				{
					for ( var j = 0; j < listData.length; j++ )
					{
						if(listData[j].playerId.toGID() == bItems[i].data.playerId.toGID())
						{
							break;
						}
						else if( j == len01 - 1)
						{
							self._RemoveItem(listview,bItems[i]);
						}
					}
					if (len01 == 0)
					{
						self._RemoveItem(listview,bItems[i]);
					}
				}
			}
			count--;
			if(count == 0) {return;}
			arguments.callee();
		})();
		this._RefreshListviewContentSize();
		this._AddNewFriendTipsTxt();
	},
	_GetItem:function(data)
	{
		var item = new FriendListExt();
		item.LoadPanel();
		item.SetInfomation(data);
		return item;
	},
	_RemoveItem:function(listview,item)
	{
		var chatList = this.chatHashmap.Get(item.data.playerId);
		var chatList02 = this.chatHashmap.Get(item.data.targetPlayerId);
		if(chatList)
		{
			chatList.removeFromParent();
			this.chatHashmap.Remove(item.data.playerId);
		}
		if(chatList02)
		{
			chatList02.removeFromParent();
			this.chatHashmap.Remove(item.data.targetPlayerId);
		}
		listview.removeChild(item);
	},
	_ReSetListCount:function()
	{
		this.friendCount = this.friendList.getItems().length;
		this.recentCount = this.recentList.getItems().length;
		this.blackCount  = this.blackList.getItems().length;
	},
	_InitSelectedItem:function(type)
	{
		this._selectedType = type;
		var items = this.friendList.getItems();
		switch (type)
		{
			case EnumRelationType.FRIEND_LIST://好友
			{
				if(items.length>0 && !this._CheckSelectedItemExist(items))
				{
					this.ChangeSelectedItem(items[0].data);
				}
				else if (items.length<1)
				{
					this.labFriend.SetString("");
				}
				break;
			}
			case EnumRelationType.BLACK_LIST://黑名单
			{
				items = this.blackList.getItems();
				if(items.length>0 && !this._CheckSelectedItemExist(items))
				{
					this.ChangeSelectedItem(items[0].data);
				}
				else if (items.length<1)
				{
					this.labFriend.SetString("");
				}
				break;
			}
			case EnumRelationType.RECENT_LIST://最近联系人
			{
				items = this.recentList.getItems();
				if(items.length>0 && !this._CheckSelectedItemExist(items))
				{
					this.ChangeSelectedItem(items[0].data);
				}
				else if (items.length<1)
				{
					this.labFriend.SetString("");
				}
				break;
			}
			default: break;
		}
		Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName).CheckUnReadChatInfo();
	},
	_SetOnlineCount:function()
	{
		var friend = this.friendList.getItems();
		var num = 3,self = this;
		(function()
		{
			if(num == 2)
			{
				friend = self.recentList.getItems();
			}
			if(num == 1)
			{
				friend = self.blackList.getItems();
			}
			var len = friend.length;
			var count = 0;
			if(len > 0)
			{
				count = 0;
				for (var i = 0; i < len; i++ )
				{
					if(friend[i].data.state)
					{
						count++;
					}
				}
				if(num == 3)self.labNum1.SetString(count+"/"+len);
				if(num == 2)self.labNum.SetString(count+"/"+len);
				if(num == 1)self.labNum11.SetString(count+"/"+len);
			}
			else
			{
				if(num == 3)self.labNum1.SetString(count+"/"+len);
				if(num == 2)self.labNum.SetString(count+"/"+len);
				if(num == 1)self.labNum11.SetString(count+"/"+len);
			}
			num--;
			if(num == 0) {return;}
			arguments.callee();
		})()
	},
	_RefreshListviewPos_Size:function(listType)
	{
		//switch(listType)
		//{
		//	case EnumRelationType.RECENT_LIST://最近联系人
		//	{
		//		this._RefrishBtnFontformat(0);
         //       this.recentList.visible = true;
         //       this.sbtn2.SetButtonState(this.sbtn2._btnStates[1]);
         //       this.sbtn11.y = this.sbtn1.y-this.recentList.height-this.sbtn11.height;
		//		this.friendList.visible = false;
		//		this.blackList.visible = false;
		//		this.sbtn21.SetButtonState(this.sbtn21._btnStates[0]);
		//		this.sbtn211.SetButtonState(this.sbtn211._btnStates[0]);
		//		this.sbtn111.y = this.sbtn11.y-this.sbtn111.height;
		//		//this.recentList.setPosition(0,-this.recentList.height);
		//		this.recentList. y = -this.recentList.height;
		//		break;
		//	}
		//	case EnumRelationType.FRIEND_LIST://好友列表
		//	{
		//		this._RefrishBtnFontformat(1);
		//		this.sbtn11.y = this.sbtn1.y-this.sbtn11.height;
         //       this.friendList.visible = true;
         //       this.sbtn21.SetButtonState(this.sbtn21._btnStates[1]);
         //       this.sbtn111.y = this.sbtn11.y-this.friendList.height-this.sbtn111.height;
		//		this.recentList.visible = false;
		//		this.blackList.visible = false;
		//		this.sbtn2.SetButtonState(this.sbtn2._btnStates[0]);
		//		this.sbtn211.SetButtonState(this.sbtn211._btnStates[0]);
		//		//this.friendList.setPosition(0,-this.friendList.height);
		//		this.friendList.y = -this.friendList.height;
		//		break;
		//	}
		//	case EnumRelationType.BLACK_LIST://黑名单
		//	{
		//		this._RefrishBtnFontformat(2);
         //       this.blackList.visible = true;
         //       this.sbtn211.SetButtonState(this.sbtn211._btnStates[1]);
		//		this.recentList.visible = false;
		//		this.friendList.visible = false;
		//		this.sbtn2.SetButtonState(this.sbtn2._btnStates[0]);
		//		this.sbtn21.SetButtonState(this.sbtn21._btnStates[0]);
		//		this.sbtn11.y = this.sbtn1.y-this.sbtn11.height;
		//		this.sbtn111.y = this.sbtn11.y-this.sbtn111.height;
		//		//this.blackList.setPosition(0,-this.blackList.height);
		//		this.blackList.y = -this.blackList.height;
		//		break;
		//	}
		//	default:break;
		//}
		this._RefreshListviewPos(listType);
	},
    _RefreshListviewPos:function(listType)
	{
		switch(listType)
		{
			case EnumRelationType.RECENT_LIST://最近联系人
			{
				this._RefrishBtnFontformat(0);
				if(this.sbtn2.GetState() != this._btnStates[0])
				{
					this.recentList.visible = true;
					this.sbtn2.SetButtonState(this._btnStates[0]);
					this.sbtn11.y = this.sbtn1.y-this.recentList.height-this.sbtn11.height;
				}
				else
				{
					this.recentList.visible = false;
					this.sbtn2.SetButtonState(this._btnStates[1]);
					this.sbtn11.y = this.sbtn1.y-this.sbtn11.height;
				}
				this.friendList.visible = false;
				this.blackList.visible = false;
				this.sbtn21.SetButtonState(this._btnStates[1]);
				this.sbtn211.SetButtonState(this._btnStates[1]);
				this.sbtn111.y = this.sbtn11.y-this.sbtn111.height;
				this.recentList.y = -this.recentList.height;
				this.sbtn1.SetButtonState(this._btnStates[0]);
				this.sbtn11.SetButtonState(this._btnStates[1]);
				this.sbtn111.SetButtonState(this._btnStates[1]);
				break;
			}
			case EnumRelationType.FRIEND_LIST://好友列表
			{
				this._RefrishBtnFontformat(1);
				this.sbtn11.y = this.sbtn1.y-this.sbtn11.height;
				if(this.sbtn21.GetState() != this._btnStates[0])
				{
					this.friendList.visible = true;
					this.sbtn21.SetButtonState(this._btnStates[0]);
					this.sbtn111.y = this.sbtn11.y-this.friendList.height-this.sbtn111.height;
				}
				else
				{
					this.friendList.visible = false;
					this.sbtn21.SetButtonState(this._btnStates[1]);
					this.sbtn111.y = this.sbtn11.y-this.sbtn111.height;
				}
				this.recentList.visible = false;
				this.blackList.visible = false;
				this.sbtn2.SetButtonState(this._btnStates[1]);
				this.sbtn211.SetButtonState(this._btnStates[1]);
				this.friendList.y = -this.friendList.height;
				this.sbtn1.SetButtonState(this._btnStates[1]);
				this.sbtn11.SetButtonState(this._btnStates[0]);
				this.sbtn111.SetButtonState(this._btnStates[1]);
				break;
			}
			case EnumRelationType.BLACK_LIST://黑名单
			{
				this._RefrishBtnFontformat(2);
				if(this.sbtn211.GetState() != this._btnStates[0])
				{

					this.blackList.visible = true;
					this.sbtn211.SetButtonState(this._btnStates[0]);
				}
				else
				{
					this.blackList.visible = false;
					this.sbtn211.SetButtonState(this._btnStates[1]);
				}
				this.recentList.visible = false;
				this.friendList.visible = false;
				this.sbtn2.SetButtonState(this._btnStates[1]);
				this.sbtn21.SetButtonState(this._btnStates[1]);
				this.sbtn11.y = this.sbtn1.y-this.sbtn11.height;
				this.sbtn111.y = this.sbtn11.y-this.sbtn111.height;
				this.blackList.y = -this.blackList.height;
				this.sbtn1.SetButtonState(this._btnStates[1]);
				this.sbtn11.SetButtonState(this._btnStates[1]);
				this.sbtn111.SetButtonState(this._btnStates[0]);
				break;
			}
			default:break;
		}
	},
	ChangeSelectedItem:function(data)
	{
		switch (data.relationType)
		{
			case EnumRelationType.FRIEND_LIST://好友
			{
				this._SetSelectedItem(this.friendList, data);
				break;
			}
			case EnumRelationType.BLACK_LIST://黑名单
			{
				this._SetSelectedItem(this.blackList, data);
				break;
			}
			case EnumRelationType.RECENT_LIST://最近联系人
			{
				this._SetSelectedItem(this.recentList, data);
				break;
			}
			default: break;
		}
	},
	_SetSelectedItem:function(list,data)
	{
		var items = list.getItems();
		for ( var i = 0; i < items.length;i++ )
		{
			if(items[i].data.playerId.toGID() == data.playerId.toGID())
			{
				items[i].SetSelected(true);
				this.InitChatInformation(items[i]);
			}
			else
			{
				items[i].SetSelected(false);
			}
		}
	},
	_CheckSelectedItemExist:function(list)
	{
		var items = list;
		for ( var i = 0; i < items.length;i++ )
		{
			if(items[i].GetSelectedState())
			{
				this.TongbuNewMessageFlag(items[i].data);
				return true;
			}
		}
		return false;
	},
	_GetCurrentRelationType:function()
	{
		return this._selectedType;
	},
	InitChatInformation:function(item)
	{
		if(!item){return;}
		this.currentSelectedItem = item;
		this.labFriend.SetString("与"+item.data.name+"对话");
		var isFriend = Mgr.friend.friendList.Get( item.data.playerId );
		var isBlack = Mgr.friend.blackList.Get( item.data.playerId );
		if( !isFriend && !isBlack)
		{
			this.labFriend.SetString("与"+item.data.name+"对话(陌生人)");
		}
		var lists = this.chatHashmap.Values();
		for ( var i = 0; i < lists.length; i++ )
		{
			lists[i].visible = false;
		}
		var currentListview = this.chatHashmap.Get(item.data.playerId);
		if(currentListview)
		{
			currentListview.visible = true;
			this._SetCurrentListviewTime(currentListview);
		}
	},
	SendChatInfo:function(content)
	{
		var str = content?content:this.editCue.string;
		if (str.length > Mgr.chat.MAXCHATTEXTLENGTH)
		{
			Mgr.tips.ShowNotice("输入的字数过多");
			return;
		}
		if(!this.currentSelectedItem)
		{
			Mgr.tips.ShowNotice("请选择聊天好友");
            return
		}
		var playerId = this.currentSelectedItem.data.playerId;
		if(str.length>0 && this.currentSelectedItem && !Mgr.friend.blackList.Get(playerId))
		{
			var playerId = this.currentSelectedItem.data.playerId;
			var type = EnumChatChannelType.PRIVATE;
			var extraReqInfo = this._GetExtraReqInfo();
			extraReqInfo.targetPlayerName = this.currentSelectedItem.data.name;
			Mgr.chat.ReqChatRequestMessage(type,this.editCue.string,extraReqInfo);
		}
		else if(Mgr.friend.blackList.Get(playerId))
		{
			Mgr.tips.ShowNotice("不能与黑名单玩家聊天");
		}
		else
		{
			Mgr.tips.ShowNotice("聊天内容不能为空");
		}
		this.editCue.string = "";
		this.SetExtraReqInfo();
	},
	_GetExtraReqInfo:function()
	{
		return this.extraReqInfo;
	},
	SetExtraReqInfo:function(showvo)
	{
		if(showvo)
		{
			var itemreq = new HyperInfo();
			itemreq.hyperType = showvo.type;//EnumLinkType.ITEM_HTML;
			itemreq.params_ = showvo.hexsid;
			itemreq.index = showvo.pos;
			itemreq.clientUseText = showvo.str;
			this.extraReqInfo.hyperInfos.push( itemreq );
		}
		else
		{
			this.extraReqInfo = new ExtraReqInfo();
		}
	},
	_GetTextItem:function(data)
	{
		var item = new ccui.Layout();
		item.setContentSize(cc.size(this.img2.width,30));
		var txt = new MUILabel();
		txt.SetFontSize(EnumFontFormat.FONTSIZE_TIP);

		txt.SetColor("0x3a2707");
		txt.SetString("你已添加"+data.name+"为好友，现在可以聊天");
		txt.setPosition((item.width-txt.GetWidth())/2,0);
		item.addChild(txt);
		return item;
	},
	//"你已添加"+item.data.name+"为好友，现在可以聊天"
	AddNewFriendTipsItem:function(playerInfo)
	{
		var playerId = playerInfo.playerId;
		var listview = this.chatHashmap.Get(playerId);
		if(listview)
		{
			if(listview.isAddedTips){return;}
			var item = this._GetTextItem(playerInfo);
			listview.insertCustomItem(item,0);
		}
		else
		{
			var item = this._GetTextItem(playerInfo);
			listview = this._GetListview(this.img2.width,420);
			listview.insertCustomItem(item,0);
			this.img2.addChild(listview);
			this.chatHashmap.Put(playerId,listview);
			if(!this.currentSelectedItem || this.currentSelectedItem.data.playerId.toGID() != playerId.toGID)
			{
				listview.visible = false;
			}
		}
		listview.isAddedTips = true;
	},
	//todo
	//收到聊天消息
	ReceiveChatInfomation:function(data)
	{
		var listview = null;
		if(data.playerId.toGID() == Mgr.player.mainPlayer.sid.toGID())
		{
			var item = Mgr.chat.GetChatItem(data);
			listview = this._GetCurrentChatPlayer(data);
			if( !listview )
				return;
			listview.pushBackCustomItem(item);
		}
		else
		{
			listview = this.chatHashmap.Get(data.playerId);
			if(listview)
			{
				var item = Mgr.chat.GetChatItem(data);
				listview.pushBackCustomItem(item);
			}
			else
			{
				var item = Mgr.chat.GetChatItem(data);
				listview = this._GetListview(this.img2.width,420);
				listview.pushBackCustomItem(item);
				this.img2.addChild(listview);
				this.chatHashmap.Put(data.playerId,listview);
				if(!this.currentSelectedItem || this.currentSelectedItem.data.playerId.toGID() != data.playerId.toGID)
				{
					listview.visible = false;
				}
			}
		}
		this._SetCurrentListviewTime(listview,true);
		listview.isSetTimes = false;
		listview.jumpToBottom();
		this.chatInfoCount++;
		this.chatInfoList.Put(data.__instanceId,data);
		this._CheckNewUnreadInfo(data);
		Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName).CheckUnReadChatInfo();
	},
	_SetCurrentListviewTime: function (listview,isRefresh)
	{
		var currentTime = Math.floor((+new Date())/1000);//秒
		if(listview.times)
		{
			if(currentTime - listview.times >120 && !listview.isSetTimes)//isSetTimes两分钟不说话已提示时间的标志（避免重复提示）
			{
				var item = new ChatTimeExt(this.img2.width,listview.times);
				item.LoadPanel();
				listview.pushBackCustomItem(item);
				listview.isSetTimes = true;
			}
		}
		if(isRefresh)
		{
			listview.times = currentTime;
		}
		listview.jumpToBottom();
	},
	//检查是否有未读消息
	_CheckNewUnreadInfo:function(data)
	{
		if(!data){return;}
		var count = 3,self = this;
		var fList = self.friendList.getItems();
		(function()
		{
			if(count == 2)
			{
				fList = self.recentList.getItems();
			}
			if(count == 1)
			{
				fList = self.blackList.getItems();
			}
			var len01 = fList.length;
			for ( var i = 0; i < len01; i++ )
			{
				if(fList[i].data.playerId.toGID() == data.playerId.toGID())
				{
					if(!fList[i].GetSelectedState())
					{
						fList[i].SetNewMessageFlag(true);
					}
					else
					{
						fList[i].TongBu();
					}
					break;
				}
			}
			count--;
			if(count == 0) {return;}
			arguments.callee();
		})();
	},
	TongbuNewMessageFlag:function(data)
	{
		if(!data){return;}
		var count = 3,self = this;
		var fList = self.friendList.getItems();
		(function()
		{
			if(count == 2)
			{
				fList = self.recentList.getItems();
			}
			if(count == 1)
			{
				fList = self.blackList.getItems();
			}
			var len01 = fList.length;
			for ( var i = 0; i < len01; i++ )
			{
				if(fList[i].data.playerId.toGID() == data.playerId.toGID())
				{
					fList[i].SetNewMessageFlag(false);
					break;
				}
			}
			count--;
			if(count == 0) {return;}
			arguments.callee();
		})();
	},
	//离线信息，只执行一次
	SetNotOnlineInfoOnce:function()
	{
		var count = 3,self = this;
		var fList = self.friendList.getItems();
		(function()
		{
			if(count == 2)
			{
				fList = self.recentList.getItems();
			}
			if(count == 1)
			{
				fList = self.blackList.getItems();
			}
			var len01 = fList.length;
			for ( var i = 0; i < len01; i++ )
			{
				if(Mgr.chat.notOnlineList.Get(fList[i].data.playerId))
				{
					fList[i].SetNewMessageFlag(true);
					break;
				}
			}
			count--;
			if(count == 0) {return;}
			arguments.callee();
		})();
	},
	//获取当前聊天对象
	_GetCurrentChatPlayer:function(data)
	{
		//var otherName = data.extraResInfo.targetPlayerName;
		var otherName = data.targetPlayerId
		var fList = this._GetCCP(this.friendList.getItems(),otherName);
		if(fList){return fList;}
		var bList = this._GetCCP(this.blackList.getItems(),otherName);
		if(bList){return bList;}
		var lList = this._GetCCP(this.recentList.getItems(),otherName);
		if(lList){return lList;}
	},
	_GetCCP:function(list,name)
	{
		for(var i = 0; i < list.length; i++ )
		{
			if(list[i].data.playerId.toGID() == name.toGID())
			{
				var lv = this.chatHashmap.Get(list[i].data.playerId);
				if(lv)
				{
					return lv;
				}
				else
				{
					var listview = this._GetListview(this.img2.width,420);
					this.img2.addChild(listview);
					this.chatHashmap.Put(list[i].data.playerId,listview);
					return listview;
				}
			}
		}
		return false;
	},
	//聊天记录
	HandleChatRecordInfo:function(msg)
	{
		var chatlist = msg.chatRecordList;
		if(chatlist.length < 1){return;}
		chatlist.reverse();
		var listview = this.chatHashmap.Get(msg.playerId);
		if(!listview)
		{
			listview = this._GetListview(this.img2.width,420);
			this.img2.addChild(listview);
			this.chatHashmap.Put(msg.playerId,listview);
		}
		listview.isSetTimes = true;
		//who =  0 发送者 1接收者
		var sender   = this.currentSelectedItem.data;
		var receiver = Mgr.player.mainPlayer;
		var time = null;
		//TimeUtil.GetTimeStrForword(time.ToNumber()/1000);
		for ( var i = 0; i < chatlist.length; i++)
		{
			var tt = TimeUtil.GetTimeStrForword(chatlist[i].time.ToNumber()/1000);
		}
		for (var i = 0;i<chatlist.length;i++)
		{
			var cl = chatlist[i];
			time = cl.time;
			if(i > 0)
			{
				var forwaid = TimeUtil.GetTimeStrForword(chatlist[i-1].time.ToNumber()/1000);
				var behand =TimeUtil.GetTimeStrForword(chatlist[i].time.ToNumber()/1000);
				if(forwaid!=behand)
				{
					var item = new ChatTimeExt(this.img2.width,chatlist[i-1].time.ToNumber()/1000);
					item.LoadPanel();
					listview.pushBackCustomItem(item);
				}
			}
			if(cl.who == 1)
			{
				var item = this._GetChatRecordItem(cl,receiver.sid,receiver.name,cl.content,sender.playerId,sender.name,cl.time, receiver.attributeData.level)
				listview.pushBackCustomItem(item);
			}
			else
			{
				var item = this._GetChatRecordItem(cl,sender.playerId,sender.name,cl.content,receiver.sid,receiver.name,cl.time, sender.level);
				listview.pushBackCustomItem(item);
			}
		}
		var item = new ChatTimeExt(this.img2.width,time.ToNumber()/1000);
		item.LoadPanel();
		listview.pushBackCustomItem(item);
	},
	_GetChatRecordItem:function(data,playerId,name,content,targetId,targetName,time, lv)
	{
		var info = {};
		info.playerId = playerId;
		info.name = name;
		info.type = EnumChatChannelType.PRIVATE;
		info.chatText = content;//+TimeUtil.GetTimeStrForword(time.ToNumber()/1000);
		info.j_content = content;//+TimeUtil.GetTimeStrForword(time.ToNumber()/1000);
		info.targetPlayerId = targetId;
		info.extraResInfo = new ExtraReqInfo();
		info.extraResInfo.targetPlayerName = targetName;
		info.extraResInfo.sendlevel = lv;
		info.extraResInfo.job = data.who == 1 ? Mgr.player.mainPlayer.job : this.currentSelectedItem.data.icon;
		var item = Mgr.chat.GetChatItem(info);
		return   item;
	},
	//face panel
	_HandleFacePanel:function()
	{
		EngineMgr.uiMgr.ShowHidePanelByType(FacePanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
		var pos = this.btnFace.getWorldPosition();
		Mgr.uiMgr.GetPanelByType(FacePanelExt.PanelName).ShowFacePanel(pos,this);
	},
	OnShow:function()
	{
		Mgr.chat.curChatChannel = EnumChatChannelType.PRIVATE;
		this.currentSelectedItem = false;
		Mgr.friend.SendReqApplyListInfoMessage();
		var privateList = Mgr.chat.privateList;
		if(privateList.length > this.chatInfoCount)
		{
			for ( var i = 0; i < privateList.length; i++ )
			{
				if(!this.chatInfoList.Get(privateList[i].__instanceId))
				{
					this.ReceiveChatInfomation(privateList[i]);
				}
				if(i == privateList.length-1)
				{
					var playerId = privateList[i].playerId;
					if(Mgr.friend.friendList.Get(playerId))
					{
						this._selectedType = EnumRelationType.FRIEND_LIST;
					}
					else if(Mgr.friend.blackList.Get(playerId))
					{
						this._selectedType = EnumRelationType.BLACK_LIST;
					}
					else if(Mgr.friend.latelyList.Get(playerId))
					{
						this._selectedType = EnumRelationType.RECENT_LIST;
					}
					this._RefreshListviewPos(this._selectedType);
					this._InitSelectedItem(this._selectedType);
				}
			}
		}
	},
	//新加好友提示（已添加好友，开始聊天）
	_AddNewFriendTipsTxt:function()
	{
		if(Mgr.friend.addList)
		{
			var list = Mgr.friend.addList.Values();
			if ( list.length > 0)
			{
				for(var i = 0; i < list.length; i++)
				{
					this.AddNewFriendTipsItem(list[i]);
				}
			}
			Mgr.friend.addList.Clear();
		}
	},
	//TODO
	//陌生人处理
	SetStranger:function(data) {
		Mgr.friend.isStranger = true;
		var isRecent = Mgr.friend.latelyList.Get( data.playerid );
		var isFriend = Mgr.friend.friendList.Get( data.playerid );
		var isBlack = Mgr.friend.blackList.Get( data.playerid );
		if ( /*!isRecent &&*/ ! isFriend && ! isBlack )
		{
			var stranger = {
				playerId: data.playerid ,
				name: data.playerName ,
				level: data.level ,
				state: 1 ,
				relationType: EnumRelationType.RECENT_LIST ,
			}
			this.labFriend.SetString("与"+stranger.name+"对话(陌生人)");
			Mgr.friend.latelyList.Put( stranger.playerId , stranger );
			Mgr.friend.strangerList.Put( stranger.playerId , stranger );
			this.RefrishListview();
			this._RefreshListviewPos( EnumRelationType.RECENT_LIST );
			this._SetSelectedItem( this.recentList , stranger );
		}
		else if ( isRecent )
		{
			this._RefreshListviewPos( EnumRelationType.RECENT_LIST );
			this._SetSelectedItem( this.recentList , isRecent );
			this.labFriend.SetString("与"+isRecent.name+"对话");
		}
		else if ( isFriend )
		{
			this._RefreshListviewPos( EnumRelationType.FRIEND_LIST );
			this._SetSelectedItem( this.friendList , isFriend );
			this.labFriend.SetString("与"+isFriend.name+"对话");
		}
		else if ( isBlack )
		{
			this._RefreshListviewPos( EnumRelationType.BLACK_LIST );
			this._SetSelectedItem( this.blackList , isBlack );
			this.labFriend.SetString("与"+isBlack.name+"对话");
		}
	}
});
FriendPanelExt.PanelName = "FriendPanelExt";
PanelClassDic["FriendPanelExt"] = FriendPanelExt;
