///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//GodArmDataInfo 单个神兵类型数据信息

// 请求消息
//239201,ReqGodArmDataInfoToGame 请求神兵数据信息
//239202,ReqUpGodArmToGame 请求升级这个神兵

// 接收消息
//239101,ResAllGodArmDataInfoToClient 发送整个神兵系统数据信息 
//239102,ResGodArmDataInfoToClient 发送单个神兵数据信息 
//239103,ResUpGodArmResultToClient 发送升级神兵结果信息 


var GodArmDataInfo = cc.Class.extend({
	ctor:function(){
		this.skillInfo = []; // 技能信息 SkillInfo
        this.exp = 0; // 当前经验值
        this.level = 0; // 当前等级
        this.godarmId = 0; // 神兵ID
	},

	writing:function( _buf ){
		_buf.WriteShort( this.skillInfo.length );
        for (var i = 0; i < this.skillInfo.length; i++) {
            _buf.WriteBean(this.skillInfo[i]);
        }
        _buf.WriteVarInt(this.exp);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.godarmId);
	},
	
	reading:function( _buf ){
		var skillInfo_length = _buf.ReadShort();
        for (var i = 0; i < skillInfo_length; i++) {
            this.skillInfo[i] = _buf.ReadBean(SkillInfo);
        }
        this.exp = _buf.ReadVarInt();
        this.level = _buf.ReadVarInt();
        this.godarmId = _buf.ReadVarInt();
	},
});
////////////////////
// 发送整个神兵系统数据信息  //
////////////////////
var ResAllGodArmDataInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.godArmDataInfoList = []; // 整个神兵数据信息 GodArmDataInfo
	},

	getId:function(){
		return 239101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.godArmDataInfoList.length );
        for (var i = 0; i < this.godArmDataInfoList.length; i++) {
            _buf.WriteBean(this.godArmDataInfoList[i]);
        }
	},
	
	reading:function( _buf ){
        var godArmDataInfoList_length = _buf.ReadShort();
        for (var i = 0; i < godArmDataInfoList_length; i++) {
            this.godArmDataInfoList[i] = _buf.ReadBean(GodArmDataInfo);
        }
	},

	action:function(){
		Mgr.godarm.RecvResAllGodArmDataInfoToClientMessage(this);
	},

});
////////////////////
// 发送单个神兵数据信息  //
////////////////////
var ResGodArmDataInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.godarmId = 0; // 神兵ID
        this.godArmDataInfo = null; // 神兵数据信息
	},

	getId:function(){
		return 239102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.godarmId);
        _buf.WriteBean(this.godArmDataInfo);
	},
	
	reading:function( _buf ){
        this.godarmId = _buf.ReadVarInt();
        this.godArmDataInfo = _buf.ReadBean(GodArmDataInfo);
	},

	action:function(){
		Mgr.godarm.RecvResGodArmDataInfoToClientMessage(this);
	},

});
////////////////////
// 发送升级神兵结果信息  //
////////////////////
var ResUpGodArmResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.godarmId = 0; // 神兵ID
        this.result = 0; // 神兵升级结果（1升级0失败）
        this.exp = 0; // 本次操作后的经验值
	},

	getId:function(){
		return 239103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.godarmId);
        _buf.WriteVarInt(this.result);
        _buf.WriteVarInt(this.exp);
	},
	
	reading:function( _buf ){
        this.godarmId = _buf.ReadVarInt();
        this.result = _buf.ReadVarInt();
        this.exp = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.godarm.RecvResUpGodArmResultToClientMessage(this);
	},

});
////////////////////
// 请求神兵数据信息 //
////////////////////
var ReqGodArmDataInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.godarmId = 0; // 神兵ID
	},

	getId:function(){
		return 239201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.godarmId);
	},
	
	reading:function( _buf ){
        this.godarmId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求升级这个神兵 //
////////////////////
var ReqUpGodArmToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.godarmId = 0; // 神兵ID
        this.itemModelIdlist = []; // 升级材料list（道具ID,数量,道具ID,数量....） int
	},

	getId:function(){
		return 239202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.godarmId);
        _buf.WriteShort( this.itemModelIdlist.length );
        for (var i = 0; i < this.itemModelIdlist.length; i++) {
            _buf.WriteVarInt(this.itemModelIdlist[i]);
        }
	},
	
	reading:function( _buf ){
        this.godarmId = _buf.ReadVarInt();
        var itemModelIdlist_length = _buf.ReadShort();
        for (var i = 0; i < itemModelIdlist_length; i++) {
            this.itemModelIdlist[i] = _buf.ReadVarInt();
        }
	},

});
// 接收消息注册
MESSAGE_POOL.Add(239101, ResAllGodArmDataInfoToClientMessage);
MESSAGE_POOL.Add(239102, ResGodArmDataInfoToClientMessage);
MESSAGE_POOL.Add(239103, ResUpGodArmResultToClientMessage);

