///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//GossipTaskInfo 太极任务信息

// 请求消息
//106201,ReqGossipInfo 请求太极面板
//106202,ReqGossipLevelUp 请求太极升级
//106203,ReqGossipReward 请求太极奖励
//106204,ReqGossipChange 请求切换佩戴的太极阵
//106251,ReqGossipVitalityFightToGame 活跃度同步原服

// 接收消息
//106101,ResGossipInfo 发送太极面板
//106102,ResGossipTaskChange 单个太极面板改变信息（单个任务改变的时候发送）
//106103,ResGossipLevelUp 升级成功消息
//106104,ResGossipExpChange 太极经验变化消息
//106105,ResBroadcastGossipLevelChange 场景内广播等级变化


var GossipTaskInfo = cc.Class.extend({
	ctor:function(){
		this.model = 0; // 任务ModelId
        this.count = 0; // 完成次数
        this.countMax = 0; // 次数上限
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.model);
        _buf.WriteVarInt(this.count);
        _buf.WriteVarInt(this.countMax);
	},
	
	reading:function( _buf ){
		this.model = _buf.ReadVarInt();
        this.count = _buf.ReadVarInt();
        this.countMax = _buf.ReadVarInt();
	},
});
////////////////////
// 发送太极面板 //
////////////////////
var ResGossipInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.beadLevel = 0; // 太极等级
        this.waerLevel = 0; // 太极佩戴等级
        this.beadExp = 0; // 经验
        this.dailyExp = 0; // 今日已获得经验
        this.rewardIds = []; // 已经领取过的奖励索引 int
        this.gossipTaskInfos = []; // 任务信息 GossipTaskInfo
	},

	getId:function(){
		return 106101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.beadLevel);
        _buf.WriteVarInt(this.waerLevel);
        _buf.WriteVarInt(this.beadExp);
        _buf.WriteVarInt(this.dailyExp);
        _buf.WriteShort( this.rewardIds.length );
        for (var i = 0; i < this.rewardIds.length; i++) {
            _buf.WriteVarInt(this.rewardIds[i]);
        }
        _buf.WriteShort( this.gossipTaskInfos.length );
        for (var i = 0; i < this.gossipTaskInfos.length; i++) {
            _buf.WriteBean(this.gossipTaskInfos[i]);
        }
	},
	
	reading:function( _buf ){
        this.beadLevel = _buf.ReadVarInt();
        this.waerLevel = _buf.ReadVarInt();
        this.beadExp = _buf.ReadVarInt();
        this.dailyExp = _buf.ReadVarInt();
        var rewardIds_length = _buf.ReadShort();
        for (var i = 0; i < rewardIds_length; i++) {
            this.rewardIds[i] = _buf.ReadVarInt();
        }
        var gossipTaskInfos_length = _buf.ReadShort();
        for (var i = 0; i < gossipTaskInfos_length; i++) {
            this.gossipTaskInfos[i] = _buf.ReadBean(GossipTaskInfo);
        }
	},

	action:function(){
		Mgr.gossip.RecvResGossipInfoMessage(this);
	},

});
////////////////////
// 单个太极面板改变信息（单个任务改变的时候发送） //
////////////////////
var ResGossipTaskChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.gossipTaskInfo = null; // 太极任务信息
	},

	getId:function(){
		return 106102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.gossipTaskInfo);
	},
	
	reading:function( _buf ){
        this.gossipTaskInfo = _buf.ReadBean(GossipTaskInfo);
	},

	action:function(){
		Mgr.gossip.RecvResGossipTaskChangeMessage(this);
	},

});
////////////////////
// 升级成功消息 //
////////////////////
var ResGossipLevelUpMessage = cc.Class.extend( {
	ctor:function(){
		this.gossipLevel = 0; // 太极等级
	},

	getId:function(){
		return 106103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.gossipLevel);
	},
	
	reading:function( _buf ){
        this.gossipLevel = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.gossip.RecvResGossipLevelUpMessage(this);
	},

});
////////////////////
// 太极经验变化消息 //
////////////////////
var ResGossipExpChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.gossipExp = 0; // 太极经验
	},

	getId:function(){
		return 106104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.gossipExp);
	},
	
	reading:function( _buf ){
        this.gossipExp = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.gossip.RecvResGossipExpChangeMessage(this);
	},

});
////////////////////
// 场景内广播等级变化 //
////////////////////
var ResBroadcastGossipLevelChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 玩家id
        this.gossipLevel = 0; // 太极等级
	},

	getId:function(){
		return 106105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteVarInt(this.gossipLevel);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.gossipLevel = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.gossip.RecvResBroadcastGossipLevelChangeMessage(this);
	},

});
////////////////////
// 请求太极面板 //
////////////////////
var ReqGossipInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 106201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求太极升级 //
////////////////////
var ReqGossipLevelUpMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 106202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求太极奖励 //
////////////////////
var ReqGossipRewardMessage = cc.Class.extend( {
	ctor:function(){
		this.gossipId = 0; // id
	},

	getId:function(){
		return 106203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.gossipId);
	},
	
	reading:function( _buf ){
        this.gossipId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求切换佩戴的太极阵 //
////////////////////
var ReqGossipChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.gossipLevel = 0; // id
	},

	getId:function(){
		return 106204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.gossipLevel);
	},
	
	reading:function( _buf ){
        this.gossipLevel = _buf.ReadVarInt();
	},

});
////////////////////
// 活跃度同步原服 //
////////////////////
var ReqGossipVitalityFightToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.vitalityType = 0; // 活跃度类型
        this.num = 0; // 数量
	},

	getId:function(){
		return 106251;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.vitalityType);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
        this.vitalityType = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(106101, ResGossipInfoMessage);
MESSAGE_POOL.Add(106102, ResGossipTaskChangeMessage);
MESSAGE_POOL.Add(106103, ResGossipLevelUpMessage);
MESSAGE_POOL.Add(106104, ResGossipExpChangeMessage);
MESSAGE_POOL.Add(106105, ResBroadcastGossipLevelChangeMessage);

