//太极面板类型
var EnumGrossipType = EnumGrossipType || {
	/**
	 *日常
	 */
	TYPE_DAY : 1,
	/**
	 *活动
	 */
	TYPE_ACTIVITY : 2,
	/**
	 *找回
	 */
	TYPE_FIND : 3,
    /**
	 * 帮会争霸
     */
    TYPE_GUILD : 4,
    /**
	 * 江湖英雄榜
     */
    TYPE_JIANGHU : 5,
		
	TYPE_JIANGLI:6,
		
	TYPE_TOUZI:7,
	
	TYPE_CHANGWAN:8,
	
	TYPE_TEQUAN:9,
};

//太极任务id类型
var EnumGrossipTaskType = EnumGrossipTaskType || {
	/**
	 *日常任务
	 */
	TYPE_DAY : 1,
	/**
	 *帮会任务
	 */
	TYPE_GUILD : 2,
	/**
	 *经验副本
	 */
	TYPE_EXPZONE : 3,
	/**
	 *剧情副本
	 */
	TYPE_STORYZONE : 4,
	/**
	 *进阶副本
	 */
	TYPE_JINJIEZONE : 5,
	/**
	 *组队副本
	 */
	TYPE_TEAMZONE : 6,
	/**
	 *世界boss
	 */
	TYPE_WORLDBOSS : 7,
	/**
	 *护送绿巨人
	 */
	TYPE_HUSONG : 8,
    TYPE_JIANGHU : 9,   // 江湖英雄/竞技场
};

var GossipModMgr = GossipModMgr || cc.Class.extend({
		taijiPanel:null,
		gossipRewardIds:null,
		gossipTaskInfoHash:null,
		gossipWearHash:null,//[key:q_show value:q_id] 根据q_show随便取一个对应的q_id
		_reqTime:0,
		canUpTaiji:false,
		taijiExp:0,
		taijiLevel:0,

		ctor:function() {
		},
        // 获取每日奖励列表
        GetDailyReward:function(){
            if(!this._dailyRewardConfig){
                var data  = Q_global.Get(1132);
                this._dailyRewardConfig = JSON.parse(data.q_string_value);
            }
            return this._dailyRewardConfig;
        },
        // 获取每日总经验
        GetDailyExpTotal:function(){
            if(!this._dailyExpTotal){
                var total = 0;
                var config = this.GetDailyReward();
                for(var k=0;k!=config.length;++k){
                    total = Math.max(total,config[k][0]);
                }

                this._dailyExpTotal = total;
            }

            return this._dailyExpTotal;
        },

		GetAttackAdd:function(addStr){
            addStr = addStr || ""
			var curStr, idB, idEnd;
			var typeArray = {};
			var nextStr = addStr.substring(1, addStr.length - 1);
			while(parseInt(nextStr.indexOf("{")) >= 0){
                idB = nextStr.indexOf("{");
                idEnd = nextStr.indexOf("}");
                curStr = nextStr.substring(idB + 1, idEnd - 1);
				var type = nextStr[idB - 2];
				var array = curStr.split(",");
				for(var i = 0; i < array.length; i++){
					array[i] = array[i].split(":");
				}
				if(parseInt(nextStr.indexOf("},")) >= 0)
                	nextStr = nextStr.substring(nextStr.indexOf("},") + 2, nextStr.length);
				else
					nextStr = " ";
                typeArray.type = type;
                typeArray.array = array;
			}
			return typeArray;
		},
	
	GetIdbyShowId:function(showid){
		if(this.gossipWearHash == null){
			this.gossipWearHash = new HashMap();
			var list = Q_taijizhidian.GetList();
			for(var i = 0; i < list.length; i++){
				if(this.gossipWearHash.Get(list[i].q_show))
					continue;
				else
					this.gossipWearHash.Put(list[i].q_show, list[i].q_id)
			}
		}
		return this.gossipWearHash.Get(showid);
	},

	RecvResGossipInfoMessage:function(msg) {
		this.gossipRewardIds = msg.rewardIds;
		this.gossipTaskInfoHash = new HashMap();
		for(var i = 0; i < msg.gossipTaskInfos.length; i++){
			this.gossipTaskInfoHash.Put( msg.gossipTaskInfos[i].model, msg.gossipTaskInfos[i] );
		}
		
		var curData = Q_taijizhidian.Get(msg.beadLevel);
		this.canUpTaiji = (msg.beadExp >= curData.q_exp && curData.q_exp != 0);
		ElseStrongUtil.OnConditionChanged();

        // 如果可以升级提示
//        if(this.canUpTaiji && !EngineMgr.uiMgr.IsPanelShowByName(TaijiPanelExt.PanelName)){
//            var panel = EngineMgr.uiMgr.ShowPanelByType(GuildBossMarkExt.PanelName,UIMgr.PANEL_LAYER_POP);
//            panel.ShowTaijiUpgradeTips(function(){
//                OpenFuncUtil.OpenDailyTask();
//            });
//        }
		this.taijiExp = msg.beadExp;
		this.taijiLevel = msg.beadLevel;
		this.dailyExp = msg.dailyExp;
		if(this.taijiPanel && Mgr.uiMgr.IsPanelShow( this.taijiPanel ) ){
			this.taijiPanel.UpdateDaylyCircle();
			if(this.taijiPanel.curView == EnumGrossipType.TYPE_DAY){
				this.taijiPanel.dailyPanel.UpdataCellShow();
				this.taijiPanel.dailyPanel.UpdateData(msg.beadLevel, msg.beadExp, msg.waerLevel );
			}
		}
		Mgr.map.miniMapPanel.UpdateGossip();
	},

	RecvResGossipTaskChangeMessage:function(msg) {
		if(!this.gossipTaskInfoHash)
			this.gossipTaskInfoHash = new HashMap();
		this.gossipTaskInfoHash.Put( msg.gossipTaskInfo.model, msg.gossipTaskInfo );
		if( this.taijiPanel && Mgr.uiMgr.IsPanelShow( this.taijiPanel ) )
			this.taijiPanel.dailyPanel.UpdataCellShow();
	},

	RecvResGossipLevelUpMessage:function(msg) {	
		if(this.taijiPanel && Mgr.uiMgr.IsPanelShow( this.taijiPanel ) && this.taijiPanel.curView == EnumGrossipType.TYPE_DAY ){
			this.taijiPanel.dailyPanel.UpdateLevel(msg.gossipLevel);
			Mgr.tips.ShowNotice("升级成功！");
			this.taijiLevel = msg.gossipLevel;
			var curData = Q_taijizhidian.Get(msg.gossipLevel);
			this.canUpTaiji = (this.taijiExp >= curData.q_exp && curData.q_exp != 0);
			ElseStrongUtil.OnConditionChanged();

			this.taijiPanel.UpdateDaylyCircle();
		}
	},

	RecvResGossipExpChangeMessage:function(msg) {	
		this.taijiExp = msg.gossipExp;
		if(this.taijiPanel && Mgr.uiMgr.IsPanelShow( this.taijiPanel ) && this.taijiPanel.curView == EnumGrossipType.TYPE_DAY ){
			this.taijiPanel.dailyPanel.UpdateExp();
		}
		Mgr.map.miniMapPanel.UpdateGossip();
	},

	RecvResBroadcastGossipLevelChangeMessage:function(msg) {	
		var gid = msg.playerId.toGID();
		var player = Mgr.sceneObj.FindObject( gid );//ScenePlayer
		if ( player != null )
		{
			player.UpdateReslineModelid( EnumResline.TAIJI, msg.gossipLevel );
			var resfreshBody = player.RefreshResline( EnumResline.TAIJI );
			if ( resfreshBody )
				player.RefreshShowBody();
		}
	},

	// 请求太极面板
	SendReqGossipInfoMessage:function() {	
		if(new Date().getTime() - this._reqTime > 500){
			this._reqTime = new Date().getTime();
			var msg = new ReqGossipInfoMessage();
			Mgr.msgMgr.Send( msg );
		}
	},

	// 请求太极升级
	SendReqGossipLevelUpMessage:function() {	
		var msg = new ReqGossipLevelUpMessage();
		Mgr.msgMgr.Send( msg );
	},

	// 请求太极奖励
	SendReqGossipRewardMessage:function(gossipId) {	
		var msg = new ReqGossipRewardMessage();
		msg.gossipId = gossipId;
		Mgr.msgMgr.Send( msg );
	},

	//请求切换太极阵幻化
	SendReqGossipVitalityFightToGameMessage:function(gossipId) {
		var msg = new ReqGossipChangeMessage();
		msg.gossipLevel = gossipId;
		Mgr.msgMgr.Send( msg );
	},
    GetGossipTaskInfo:function(modelId){
        return this.gossipTaskInfoHash.Get(modelId);
    },
});