//副本类型
var EnumZoneActiveType = EnumZoneActiveType || {
    /**
     *京城守卫
     */
    TYPE_GUARDCPITAL: 3,
    /**
     *华山论剑
     */
    TYPE_SWORD: 4,
    /**
     *帮会答题
     */
    TYPE_GUILD: 2,
    /**
     *跨服多人副本
     */
    TYPE_ZONE: 1,
    /**
     *护送
     */
    TYPE_HUSONG: 5,
    /**
     * 阻击后援
     */
    TYPE_STOPKEEP: 6,
    /**
     *阻击后援（精英）
     */
    TYPE_GUILDBOSS_JY: 7,
    // 王城战
    TYPE_KINGNEUTRAL: 9,
    /**
     * 世界首领
     */
    TYPE_WORLDBOSS: 10,
    /**
     * 铸剑天下
     */
    TYPE_ZHUJIANTIANXIA: 11,
    /**
     * 挂机双倍
     */
    TYPE_DOUBLEGUAJI: 12,
    // 帮派争霸
    TYPE_KINGGUID: 14,
    ///掌门斗宝
    TYPE_MASTERBUCKET: 15,
    /**
     * 帮会BOSS
     */
    TYPE_GUILDBOSS: 16,
    /**
     * 恶人谷
     */
    TYPE_ERENGU: 17,
};

var GuardcpitalModMgr = GuardcpitalModMgr || cc.Class.extend({
    _activeTimeHash: null, //key:开始时间  value:结束时间
    _monsterNumHash: null, //key:波数-1 value:hashmap{key:怪物id value:怪物数量}
    _npcPosArr: null,
    challengNum: 0, //波数
    mapId: 116,
    isGoToActive: false, //是否前端主动参加活动（只有通过活动面板或者右边提示面板进）
    ctor: function() {
        this.__killList = [];
        this.__round = 0;
        this.__nextRoundTime = 0;
        this.__endTime = 0;
    },

    /// fix 修改不再依靠RecvResGuardCpitalTimeInfoToClientMessage判断。
    /// 因为如果没有在活动地图没内不会同步RecvResGuardCpitalTimeInfoToClientMessage.会丢失结束状态
    CheckActivityIsOpen: function() {
        if (!this.CheckPlayerInActivityMap()) return false;

        var data = Mgr.majorevents.GetActivityInfoByType(EnumZoneActiveType.TYPE_GUARDCPITAL);
        if (!data) return false;

        var curTime = Mgr.login.GetServerTime() / 1000;

        if (curTime < data.startTime || curTime > data.startTime + data.endTime) return false;

        return data;
    },

    AutoPath2ActivityRange: function(index) {
        var conf = Q_global.Get(1028);

        if (!conf) return;
        var mapId = parseInt(conf.q_int_value);
        var data = JSON.parse(conf.q_string_value);
        var map = data ? data[index] : null;

        if (!map) return;

        // 走过去
        Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(mapId, cc.p(map[1], map[2]),
            AutoPathParam.CreateAutoFight(), true);

        /// 飞过去
        //        var targetPixel = ToolMap.GridPt2PixPt(map[1],map[2], true);
        //        if(Mgr.sceneMap.nMapId == mapId){
        //            Mgr.map.SendReqSameMapFlyMoveMessage(new Position(targetPixel.x, targetPixel.y));
        //        }else{
        //            Mgr.map.SendReqSmallFlyShoesMessage(mapId, targetPixel );
        //        }
    },

    CheckPlayerInActivityMap: function() {
        var conf = Q_global.Get(1028);
        var mapId = parseInt(conf.q_int_value);

        return Mgr.sceneMap.nMapId == mapId;
    },

    CheckAutoCollectChests: function() {
        if (!this.CheckActivityIsOpen()) return false;
        if (Mgr.npc.isCollection) return false;

        if (this.nLastTime && this.nLastTime + 1000 > TimerUtil.GetGameTimer()) return false;

        this.nLastTime = TimerUtil.GetGameTimer();

        var arr = Mgr.guardcpital.GetNpcIdList();
        var tar = Mgr.sceneObj.GetNearestNpc(arr);
        if (!tar) return false;

        Mgr.mainPlayer.oCtrlAutoPath.RunToPt(tar.GetGridPt(), AutoPathParam.CreateSelectNpcInfo(tar));
        return true;
    },

    /// 飞到活动区域，如果在同一地图内，寻优
    Fly2ActivityArea: function() {
        var conf = Q_global.Get(1028);
        var mapId = parseInt(conf.q_int_value);
        var data = JSON.parse(conf.q_string_value);

        if (!data) return;

        if (Mgr.sceneMap.nMapId == mapId) {
            var index = null;
            var curPos = Mgr.mainPlayer.GetGridPt();
            for (var k = 0, length = data.length, v = data[k]; k != length; v = data[++k]) {
                if (index != null) {
                    if (ToolMap.CalcDistance(curPos, cc.p(v[1], v[2])) <
                        ToolMap.CalcDistance(curPos, cc.p(data[index][1], data[index][2]))) {
                        index = k;
                    }
                } else {
                    index = k;
                }
            }
            if (index != null) this.AutoPath2ActivityRange(index);
        } else {
            this.AutoPath2ActivityRange(Math.floor(Math.random() * data.length));
        }
    },

    GetNpcIdList: function() {
        var arr = JSON.parse(Q_global.Get(1023).q_string_value);
        var result = [];
        for (var k = 0, len = arr.length, v = arr[k]; k != len; v = arr[++k]) {
            result.push(v[0]);
        }

        return result;
    },

    GetMonsterConfigHashMap: function() {
        if (this._monsterNumHash == null) {
            this._monsterNumHash = new HashMap();
            var arr = JSON.parse(Q_global.Get(1018).q_string_value);
            this.challengNum = arr.length;

            for (var i = 0; i < arr.length; i++) {
                if (this._monsterNumHash.Get(i) == null) {
                    var monsterHash = new HashMap();
                    this._monsterNumHash.Put(i, monsterHash);
                }
                this._monsterNumHash.Get(i).Put(parseInt(arr[i][0]), parseInt(arr[i][1]));
            }
            var arr1 = JSON.parse(Q_global.Get(1019).q_string_value);
            for (var j = 0; j < arr1.length; j++) {
                if (this._monsterNumHash.Get(j) == null) {
                    var monsterHash = new HashMap();
                    this._monsterNumHash.Put(j, monsterHash);
                }
                this._monsterNumHash.Get(j).Put(parseInt(arr1[j][0]), parseInt(arr1[j][1]));
            }
        }
        return this._monsterNumHash;
    },

    GetCurrentRound: function GetCurrentRound() {
        return this.__round;
    },

    GetKillTargetList: function() {
        return this.__killList;
    },

    RecvResGuardCpitalInfoToClientMessage: function(msg) {
        this.__round = msg.round;
        this.__killList = msg.killList;

        Mgr.task._taskTrackPanel.UpdateView();
    },

    RecvResGuardCpitalTimeInfoToClientMessage: function(msg) {
        cc.log("收到R=========>>>>>ecvResGuardCpitalTimeInfoToClientMessage", msg.nextRoundTime);
        if (msg.nextRoundTime == -1) { //活动开始
            var markPanel = Mgr.activeMark.GetPanelByType(EnumZoneActiveType.TYPE_GUARDCPITAL);
            if (!this.CheckPlayerInActivityMap() &&
                (!markPanel || !markPanel.visible)) {
                Mgr.activeMark.Show(EnumZoneActiveType.TYPE_GUARDCPITAL);
            }
        } else if (msg.nextRoundTime == -2) { //活动结束
            Mgr.task._taskTrackPanel.UpdateView();
            this.isGoToActive = false;
        } else { //活动中
            this.__nextRoundTime = msg.nextRoundTime;
            this.__endTime = msg.endTime;

            Mgr.task._taskTrackPanel.UpdateView();
        }
    },
});