var CreateGuildPanelExt = CreateGuildPanel.extend ( {
	_className:"CreateGuildPanelExt",

	_costGold:0,
	_preLevel:0,

	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
	},

	Init:function() {
		var self = this;
		CreateGuildPanel.prototype.Init.call(this);

		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});

		this.btnCreate.addClickEventListener(function (event){
			var str = self.editCue.getString();
			if ( str == "" ) {
				Mgr.tips.ShowNotice("请输入帮会名");
				return;
			}
			else if(str.length > 5){
                Mgr.tips.ShowNotice("帮会名长度超出");
                return;
			}

			// 检测是否汉字
			for(var i=0; i != str.length; i++){
				var newCharNum = str.charCodeAt(i);
				if (newCharNum < 0x4E00 || newCharNum > 0x9FA5 ) {   // 非汉子
					Mgr.tips.ShowNotice("帮会名字只可输入汉字");
					return;
				}
			}

			var totalGold = Mgr.mainPlayer.attributeData.TotalGold();
			if ( self._costGold > totalGold ) {
				// Mgr.tips.ShowNotice("元宝不足");
				AlertExt.NoEnoughGold( self._costGold - totalGold );
				return;
			}
			// var level = Mgr.player.mainPlayer.attributeData.level;
			// if ( self._preLevel > level ) {
			// 	Mgr.tips.ShowNotice("角色等级不够");
			// 	return;
			// }
			Mgr.guild.SendReqGuildCreateMessage(str);
		});

		this.btnRecharge.addClickEventListener(function (event){
			OpenFuncUtil.OpenRecharge();
		});

		this._InitPanel();
	},

	_InitPanel:function () {
		this._InitParam();
		this.SetInfo();
	},

	_InitParam:function () {
		this.editCue.setPlaceHolder( "请输入帮会名称(只可输入汉字)" );
		//this.editCue.setMaxLengthEnabled(true);
		// this.editCue.setMaxLength(5);
		//this.editCue.addEventListener(this.Listener);
		this.editCue.setDelegate(this);
		this.editCue.setTextColor(UIUtil.GetCCColor(0x853d07));
	},

	// 只可输入汉字 (别删)
	// editBoxTextChanged: function (editBox, text) {
	// 	cc.log("editBox "  + ", TextChanged, text: " + text);
	// 	var ediText = editBox.getString();
	// 	if (this.editCue == editBox) {
	// 		if (ediText != "" ) {
	// 			var newCharNum = ediText.charCodeAt(ediText.length - 1);
	// 			if (newCharNum < 0x4E00 || newCharNum > 0x9FA5 ) {
	// 				ediText = ediText.substring(0, ediText.length - 1);
	// 				editBox.setString(ediText);
	// 			}
	// 		}
	// 	}
	// },

	Listener:function(sender,type){
		var ediText = sender.getString();
		if (ediText != "" ) {
			if(type==ccui.TextField.EVENT_INSERT_TEXT) {
				var newCharNum = ediText.charCodeAt(ediText.length - 1);
				if (newCharNum < 0x4E00 || newCharNum > 0x9FA5 ) {
					ediText = ediText.substring(0, ediText.length - 1);
					sender.setString(ediText);
				}
			}
		}
	},

	SetInfo:function () {
		var guildC = Q_guild.Get(1);  // 只能创建1级帮会
		cc.assert(null != guildC, "Q_guild Item can't be nil!  level: " + 1);

		this._costGold = guildC.q_gold;
		this._preLevel = 54;

		var str = "(花费" +  guildC.q_gold + "元宝)" ;
		this.labCondition.SetString(str);
	},
} );
CreateGuildPanelExt.PanelName = "CreateGuildPanelExt";
PanelClassDic["CreateGuildPanelExt"] = CreateGuildPanelExt;
