﻿var GuildModMgr = GuildModMgr || cc.Class.extend({

	// 帮会列表 info
	guildMap:null,
	// 帮会成员 member
	guildMembers:null,
	// 帮会的技能
	guildSkillMap:null,

	// 申请入帮的玩家列表
	guildAppliedHash:null,
	// 本人已申请帮会列表 id
	appliedGuildList:null,
	// 帮会的配置信息
	guildConfig:null,
	// 帮会删除倒计时
	deleteCountdown:0,

    isGeted:null,

	// 是否存在禁地boss
	isExistGuildBoss:null,

	ctor:function() {
		this.guildMap = new HashMap();
		this.guildSkillMap = new HashMap();
		this.guildMembers = new HashMap();
		this.guildAppliedHash = new HashMap();
		this.appliedGuildList = [];
		this.deleteCountdown = 0;
		this.isExistGuildBoss = false;
	},

	Clean:function () {
		this.guildMap.Clear();
		this.guildSkillMap.Clear();
		this.deleteCountdown = 0;
		this.isExistGuildBoss = false;
		this.guildMembers.Clear();
		this.guildAppliedHash.Clear();
		this.appliedGuildList = [];
		this.guildConfig = null;
		Mgr.player.mainPlayer.guildId.IntValue(0);
		Mgr.mainPlayer.guildId.IntValue(0);
	},

	RecvResGuildGetGuildListToClientMessage:function(msg) {
		cc.log("------------------------- 返回帮会列表信息 "+ "  " + Mgr.player.mainPlayer.name + "   "+JSON.stringify(msg));
		this.guildMap.Clear();
		for (var i = 0; i != msg.guildList.length; i++) {
			var info = msg.guildList[i];
			var id = info.guildId;
			this.guildMap.Put(id, info);
		}
		this.appliedGuildList = msg.appliedGuildList;

		// 帮会
		var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
		if ( panel && panel.showType == GuildEnum.PANEL_LIST )
            panel.showPanel.CallBackProp();

	},

	RecvResGuildApplyAddMessage:function(msg) {
		this.guildAppliedHash.Clear();
		var list = msg.applyPlayerInfoList;
		for ( var i = 0; i != list.length; i++ ) {
			var id = list[i].applyerId;
			this.guildAppliedHash.Put(id, list[i]);
		}

		// 刷新申请界面
		var panel = Mgr.uiMgr.GetPanelByType(GuildApplyListExt.PanelName);
		if (panel) {
			panel.CallBackProp();
		}

		// warn
		Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).UpDataGuildWarn(GuildEnum.PANEL_MEMBER);
	},

	RecvResGuildInviteAddMessage:function(msg) {
		cc.log("------------------------- 邀请加入帮会发给被操作玩家 "+ "  " + Mgr.player.mainPlayer.name + "   "+JSON.stringify(msg));
		if(Mgr.plugset.GetSysSetInfo().banInviteGuild)
		{
			return;
		}
		var str = msg.inviteName + "邀请你加入帮派 【" + msg.guildName + "】";
		AlertExt.Show( str, TipsEnum.BUTTON_SURE_AND_FALSE, {
			_onFunc:function(){
				Mgr.guild.SendReqAgreeInviteMessage(1, msg.guildId);
			},
			_offFunc:function(){
				Mgr.guild.SendReqAgreeInviteMessage(0, msg.guildId);
			}
		});
	},

	RecvResGuildGetMemberListMessage:function(msg) {
		cc.log("------------------------- 返回成员列表  "+ "  " + Mgr.player.mainPlayer.name + "   "+  JSON.stringify(msg));
		this.guildMembers.Clear();
		for ( var i = 0; i != msg.memberList.length; i++ )
		{
			this.guildMembers.Put( msg.memberList[i].playerId, msg.memberList[i] );
		}

		// 帮会成员
		var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
		if ( panel && panel.showType == GuildEnum.PANEL_MEMBER )
			panel.showPanel.CallBackProp();

		var panel = Mgr.uiMgr.GetPanelByType(YaoqingMainExt.PanelName);
		if ( panel && panel.visible)
		{
			panel.GetInvisiteGuildList(msg);
		}
	},

	RecvResGuildGetEventListMessage:function(msg) {
		cc.log("======RecvResGuildGetEventListMessage=======")
	},
	RecvResConquestPanelMessage:function(msg)
	{
		cc.log("这是啥--- "+JSON.stringify(msg));
	},
	RecvResGuildGuildInfoMessage:function(msg) {
		cc.log("------------------------- 返回单独帮会信息  "+ "  " + Mgr.player.mainPlayer.name + "   "+ JSON.stringify(msg));

		// 更新数据
		this.guildMap.Put(msg.guildInfo.guildId.hexValue, msg.guildInfo);
		this.guildMembers.Put( msg.memberInfo.playerId, msg.memberInfo );
		this.guildConfig = msg.guildConfig;
		this.deleteCountdown = msg.deleteCountdown;
		Mgr.mainPlayer.guildId = Mgr.player.mainPlayer.guildId = msg.guildInfo.guildId;


		// 角色头顶公会名显示
		var guildName = msg.guildInfo.guildName;
		Mgr.mainPlayer.SetGuildNameShow( guildName );

		// 刷新显示界面
		var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
		if ( panel )
			panel.OnShow();

		// 刷新vip加入状态
		var panel = Mgr.uiMgr.GetPanelByType(GuildApplyListExt.PanelName);
		if ( panel && panel.visible )
			panel.SetVipState();
	},

	RecvResGuildHandleResultMessage:function(msg) {
		cc.log("------------------------- 返回帮会创建 "+ "  " + Mgr.player.mainPlayer.name + "   "+ JSON.stringify(msg));
		if ( msg.handleType == 0 ) {  //拥有帮会
			// 拥有创建，打开帮会默认界面
			Mgr.uiMgr.ShowPanelByType( GuildPanelExt.PanelName ).ChangePanel(GuildEnum.PANEL_INFO);
			Mgr.uiMgr.HidePanelByType( CreateGuildPanelExt.PanelName );

			// 拥有帮会时，应该获取的信息  (后端不会主动推送，需手动获取)
			TimerUtil.SetTimeout( Mgr.guild, Mgr.guild.SendReqGuildGetMemberListMessage, 300);
			TimerUtil.SetTimeout( Mgr.guild, Mgr.guild.SendReqGuildSkillInfoMessage, 300);
			TimerUtil.SetTimeout( Mgr.guild, Mgr.guild.SendReqApplyListMessage, 300);
		}
		else if ( msg.handleType == 1 ) {  // 失去帮会
			Mgr.guild.Clean();
			var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
			if (panel && panel.visible)
				panel.OnShow();
		}
		else if ( msg.handleType == 2 ) {  // 申请帮派成功
			// 帮会列表信息   (刷新帮会列表已申请标记)
			TimerUtil.SetTimeout( Mgr.guild, Mgr.guild.SendReqGuildGetGuildListMessage, 300);
		}
		Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName ).ShowOrHideGuildChatButton();
	},

	RecvResNoticeGuildBossApplyMessage:function(msg) {
		this.guildAppliedHash.Put(msg.applyerId, msg.applyPlayerInfo);

		// 刷新申请界面
		var panel = Mgr.uiMgr.GetPanelByType(GuildApplyListExt.PanelName);
		if (panel && panel.visible) {
			panel.CallBackProp();
		}

		// warn
		Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).UpDataGuildWarn(GuildEnum.PANEL_MEMBER);
	},

	RecvResRoundGuildChangeMessage:function(msg) {
		cc.log("------------------------- 广播周围玩家帮会信息变化"+ "  " + Mgr.player.mainPlayer.name + "   "+ JSON.stringify(msg));
		// 刷新头顶公会显示
		var obj = Mgr.sceneObj.FindObject(msg.playerId.toGID());
		if ( obj ){
			obj.guildId = msg.guildId;
			obj.SetGuildNameShow( msg.guildName );
		}

		// 刷新子页面
		var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
		if ( panel )
			panel.OnShow();
	},

	RecvResGuildForbiddenBossInfoMessage:function(msg) {
		cc.log("------------------------- 返回BOSS信息 "+ "  " + Mgr.player.mainPlayer.name + "   "+JSON.stringify(msg));
		var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
		if ( panel && panel.showType == GuildEnum.PANEL_BOSS )
			panel.showPanel.CallBackProp(msg);
	},

	RecvResWelfareStateMessage:function(msg) {
		cc.log("------------------------- 返回帮会福利状态 "+ "  " + Mgr.player.mainPlayer.name + "   "+JSON.stringify(msg));
		this.isGeted = msg.state == 1 ? true : false;
		var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
        Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).UpDataGuildWarn(GuildEnum.PANEL_INFO);
		if ( panel && panel.showType == GuildEnum.PANEL_INFO )
			panel.showPanel.SetDailyWelfare( this.isGeted );
	},

	RecvResGuildForbiddenDamageInfoMessage:function(msg) {
		cc.log("------------------------- 返回BOSS伤害信息 "+JSON.stringify(msg));
	},

	RecvResGuildForbiddenZonePanelInfoMessage:function(msg) {
		cc.log("------------------------- 返回BOSS副本追踪面板   "+JSON.stringify(msg));
		var restTime = 0;
		this.isExistGuildBoss = false;
		if (msg.countdowm > 0) {
			this.isExistGuildBoss = true;
			restTime = msg.countdowm
		}
		Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName).ShowFightTime(restTime)

		// hide
		// Mgr.uiMgr.HidePanelByType(GuildPanelExt.PanelName);

        if(this.isExistGuildBoss){
			var list = [];
			list.push({monsterId: (200 + this.guildMap.Get( Mgr.player.mainPlayer.guildId.hexValue ).level), killNums: msg.killNums, countdowm: msg.countdowm});

			// cc.log("======monsterId=====" +list[0].monsterId)
			var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
			panel.visible = true;
			panel.__panel.InitView(list);
		}

		// Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName).SetZoneData(msg.countdowm);
		// if(!Mgr.uiMgr.IsPanelShowByName(FubenTimeCueExt.PanelName)){
		// 	Mgr.uiMgr.ShowPanelByType(FubenTimeCueExt.PanelName);
		// }
		// cc.log("Mgr.uiMgr.GetPanelByType(FubenTimeCueExt.PanelName):"+Mgr.uiMgr.GetPanelByType(FubenTimeCueExt.PanelName));
		// Mgr.uiMgr.GetPanelByType(FubenTimeCueExt.PanelName).ShowBeginTime(msg.countdowm);
	},

	RecvResGuildForbiddenZoneRewardInfoMessage:function(msg) {
		cc.log("------------------------- 返回BOSS副本在线奖励 "+JSON.stringify(msg));
	},

	RecvResBroadcastGuildForbiddenBossRefreshMessage:function(msg) {
		cc.log("------------------------- 广播禁地boss召唤 " + "   "+JSON.stringify(msg) );
		if ( Mgr.zone.IsInZoneMap() )
			return;

		Mgr.activeMark.Show(EnumZoneActiveType.TYPE_GUILDBOSS);
	},

	RecvResGuildBossAwardListMessage:function(msg) {
		cc.log("------------------------- 返回帮会BOSS奖励 "+JSON.stringify(msg));
	},

	RecvResGuildDeleteCountdownTimeMessage:function(msg) {
		cc.log("------------------------- 返回删除倒计时 "+ "  " + Mgr.player.mainPlayer.name + "   "+JSON.stringify(msg));
		this.deleteCountdown  = msg.countdownTime;
		// 界面
		var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
		if ( panel && panel.showType == GuildEnum.PANEL_MEMBER )
			panel.showPanel.SetJiesanState();
	},

	RecvResGuildSkillInfoMessage:function(msg) {
		// 初始技能
		if ( this.guildSkillMap.IsEmpty() ) {
			var skills = Q_guild_skill.GetList();
			for ( var i = 0; i != skills.length; i++ ) {
				var isLearn = false;
				var level = 0;
				var mid = skills[i].q_skill_id;
				// 同类技能排除
				if (this.guildSkillMap.Get(mid))
					continue;
				var obj = {mid:mid, level:level, isLearn:isLearn};
				this.guildSkillMap.Put( mid, obj);
			}
		}

		var list = this.guildSkillMap.Values();
		for ( var i = 0; i != list.length; i++ ) {
			var mid = list[i].mid;
			for ( var j = 0; j != msg.skills.length; j++ ) {
				var info = msg.skills[j];
				if ( info.skillModel == mid ) {
					var obj = {mid:mid, level:info.level, isLearn:true};
					this.guildSkillMap.Put( mid, obj);
					break;
				}
			}
		}

		var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
		if ( panel && panel.showType == GuildEnum.PANEL_SKILL )
			panel.showPanel.CallBackProp();
	},

	RecvResGuildSkillLevelUpResultMessage:function(msg) {
		if ( msg.result == 0 ) {// 失败
			// 目前没有失败的可能
		}
		else if ( msg.result == 1 ) {  //成功
			Mgr.tips.ShowNotice( "技能升级成功!");

			var list = this.guildSkillMap.Values();
			for ( var i = 0; i != list.length; i++ ) {
				var mid = list[i].mid;
				if ( msg.skill.skillModel == mid ) {
					var obj = {mid:mid, level:msg.skill.level, isLearn:true};
					this.guildSkillMap.Put( mid, obj);
					break;
				}
			}
		}

		var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
		if ( panel && panel.showType == GuildEnum.PANEL_SKILL )
			panel.showPanel.CallBackProp( );
	},

	RecvResSendGuildStoreInfoMessage:function(msg) {	
	},

	RecvResGuildItemAddMessage:function(msg) {	
	},

	RecvResGuildItemChangeMessage:function(msg) {	
	},

	RecvResGuildItemRemoveMessage:function(msg) {	
	},
	//可以领取日常奖励（活动期间计入地图发送 收到此消息说明可以领奖励）
	//TODO
	RecvResGuildAnswerDailyRewardMessage:function(msg) {
		EngineMgr.uiMgr.ShowPanelByType(TopicBoxExt.PanelName);
		var panel = Mgr.uiMgr.GetPanelByType(TopicBoxExt.PanelName);
		if(panel)
		{
			panel.SetTime(5,ENUM_TOPICBOX.LINGQU);
		}
	},

	RecvResRoundGuildAnnouncementChangeMessage:function (msg) {
		var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
		if ( panel && panel.showType == GuildEnum.PANEL_INFO )
			panel.showPanel.BrushGuildNotice( msg.announcement);
	},

	RecvResRejectApplicationGuildToPlayerMessage:function (msg) {
		var panel = Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName);
		if ( panel && panel.showType == GuildEnum.PANEL_LIST )
			panel.showPanel.BrushGuildAppliedMark( msg.guildId);
	},
		
    CheckGuildBossActivityIsOpen: function() {
        var data = Mgr.majorevents.GetActivityInfoByType(EnumZoneActiveType.TYPE_GUILDBOSS);
        if (!data) return false;
        var curTime = Mgr.login.GetServerTime() / 1000;
        if (curTime < data.startTime || curTime > data.startTime + data.endTime) return false;
        return data;
    },

    CheckGuildActivityIsOpen: function() {
        var data = Mgr.majorevents.GetActivityInfoByType(EnumZoneActiveType.TYPE_GUILD);
        if (!data) return false;
        var curTime = Mgr.login.GetServerTime() / 1000;
        if (curTime < data.startTime || curTime > data.startTime + data.endTime) return false;
        return data;
    },

	RecvResGuildAnswerRankMessage:function(msg){
        if(this.CheckGuildActivityIsOpen()){
            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
			if( panel.__panel.UpdateLabel )
           		panel.__panel.UpdateLabel(msg.sum);
            panel.__teamPanel.RefreshRanking(msg.ranks);
        }
	},

	SendReqGuildCreateMessage:function(name) {
		cc.log("------------------------- 创建公会 ");
		var msg = new ReqGuildCreateMessage();
		msg.guildName = name;
		msg.costType = 1;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildGetGuildListMessage:function() {
		cc.log("------------------------- 发送帮会列表 ");
		var msg = new ReqGuildGetGuildListMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildApplyAddMessage:function(id) {
		cc.log("------------------------- 发送申请加入帮会 ");
		var msg = new ReqGuildApplyAddMessage();
		msg.guildId = id;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildInviteAddMessage:function(playerId) {
		cc.log("------------------------- 邀请加入帮会 ");
		var msg = new ReqGuildInviteAddMessage();
		msg.InvitedPlayerId = playerId;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildGetMemberListMessage:function() {
		cc.log("------------------------- 发送帮会成员 ");
		var msg = new ReqGuildGetMemberListMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildAddMemberMessage:function( guildId, playerId, argee ) {
		cc.log("------------------------- 发送同意拒绝申请 ");
		var msg = new ReqGuildAddMemberMessage();
		msg.guildId = guildId;
		msg.playerId = playerId;
		msg.argee = argee;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildQuitMessage:function() {
		cc.log("------------请求退出帮会------------- ");
		var msg = new ReqGuildQuitMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildChangePowerLevelMessage:function(personId, job ) {
		cc.log("------------请求修改成员职称------------- ");
		var msg = new ReqGuildChangePowerLevelMessage();
		msg.userId = personId;
		msg.newPowerLevel = job;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildDeleteMemberMessage:function(personId) {
		cc.log("------------删除帮会成员------------- ");
		var msg = new ReqGuildDeleteMemberMessage();
		msg.playerId = personId;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildConfigMessage:function(config) {
		cc.log("------------修改帮会配置------------- ");
		var msg = new ReqGuildConfigMessage();
		msg.config = config;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildChangeAnnouncementMessage:function(notice) {
		cc.log("------------修改公告------------- ");
		var msg = new ReqGuildChangeAnnouncementMessage();
		msg.guildBulletin = notice;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildDeleteGuildMessage:function(type) {
		cc.log("------------解散帮会------------- ");
		var msg = new ReqGuildDeleteGuildMessage();
		msg.type = type;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildGetEventListMessage:function(msg) {	
	},

	SendReqUpdateGuildInfoMessage:function() {
		cc.log("------------请求刷新guildInfo------------- ");
		var msg = new ReqUpdateGuildInfoMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqApplyListMessage:function() {
		cc.log("------------发送申请入帮列表信息------------- ");
		var msg = new ReqApplyListMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqLevelUpGuildMessage:function(msg) {
		cc.log("------------请求升级帮会------------- ");
		var msg = new ReqLevelUpGuildMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqChangeGuildFlagMessage:function(id) {
		cc.log("------------请求更换帮旗------------- ");
		var msg = new ReqChangeGuildFlagMessage();
		msg.flagModel = id;
		Mgr.msgMgr.Send(msg);
	},

	SendReqAgreeInviteMessage:function(type, guildId) {
		cc.log("------------同意帮会邀请------------- ");
		var msg = new ReqAgreeInviteMessage();
		msg.isAgree = type;
		msg.inviteGuildId = guildId;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildAutoDistributionMessage:function(msg) {	
	},

	SendReqGuildForbiddenBossInfoMessage:function() {
		cc.log("------------发送boss信息------------- ");
		var msg = new ReqGuildForbiddenBossInfoMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildEnterForbiddenMessage:function() {
		cc.log("------------进入禁地------------- ");
		var msg = new ReqGuildEnterForbiddenMessage();
		Mgr.msgMgr.Send(msg);

		// hide
		Mgr.uiMgr.HidePanelByType(GuildPanelExt.PanelName);
	},

	SendReqRefreshGuildForbiddenBossMessage:function(type) {
		cc.log("------------召唤boss------------- ");
		var msg = new ReqRefreshGuildForbiddenBossMessage();
		msg.refreshType = type;
		Mgr.msgMgr.Send(msg);
	},

	SendReqDispatchItemMessage:function(msg) {	
	},

	SendReqGuildSkillInfoMessage:function() {
		cc.log("------------请求帮会技能------------- ");
		var msg = new ReqGuildSkillInfoMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqGuildSkillLevelUpMessage:function(id) {
		cc.log("------------请求升级帮会技能------------- ");
		var msg = new ReqGuildSkillLevelUpMessage();
		msg.skillModelId = id;
		Mgr.msgMgr.Send(msg);
	},

	SendReqSendGuildStoreItemsMessage:function(msg) {	
	},

	SendReqDevoteItemMessage:function(msg) {	
	},

	SendReqExchangeItemMessage:function(msg) {	
	},

	SendReqGuildDeleteItemMessage:function(msg) {	
	},

	SendReqWelfareStateMessage:function(msg) {
		cc.log("------------请求帮会福利领取状态------------- ");
		var msg = new ReqWelfareStateMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqWelfareRewardStateMessage:function(msg) {
		cc.log("------------请求领取帮会福利奖励------------- ");
		var msg = new ReqWelfareRewardStateMessage();
		Mgr.msgMgr.Send(msg);
	},
	//请求领取帮会答题日常奖励
	SendReqGuildAnswerDailyReward:function()
	{
		var msg = new ReqGuildAnswerDailyRewardMessage();
		Mgr.msgMgr.Send(msg);
	},

	IsMarkBySubType:function (type) {
		if(Mgr.player.mainPlayer.guildId.IsZero())
			return false;
		if(type == GuildEnum.PANEL_INFO && this.isGeted != null)
			return !this.isGeted;
		if ( type == undefined || type == GuildEnum.PANEL_MEMBER ) {
			if ( Mgr.guild.guildAppliedHash.Values().length > 0 && ( Mgr.guild.IsGuilder() || Mgr.guild.IsSecondGuilder() ) ) {
				return true;
			}
		}
		if ( type == undefined || type == GuildEnum.PANEL_SKILL ) {

			// 玩家贡献度
			var offer = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumMoney.GUILDDEVOTE, AttributeData.Money);

			var list = this.guildSkillMap.Values();
			for ( var i = 0; i != list.length; i++ ) {
				var mid = list[i].mid;
				var lv = list[i].level;
				var guildSkillC = Q_guild_skill.Get( mid.toString() + "_" + lv.toString() );
				if ( guildSkillC ) {
					var needOffer = guildSkillC.q_levelup;
					if ( offer >= needOffer && !this.IsFullGuildSkill(mid,lv) )
						return true;
				}
				else {
					zz.Error("帮会技能（Q_guild_skill）读取出错， key：" + mid.toString() + "_" + lv.toString());
				}
			}
		}
		if ( type == undefined || type == GuildEnum.PANEL_FLAG ) {
			return false;
		}
		return false;
	},

		/***
		 * 是否是帮主
		 * @returns {boolean}
         * @constructor
         */
	IsGuilder:function () {
		var playerId = Mgr.player.mainPlayer.sid;
		var memberInfo = Mgr.guild.guildMembers.Get( playerId );
		if ( memberInfo ) {
			if ( memberInfo.guildPowerLevel == GuildEnum.MEMBER_GUILDER ) {
				return true;
			}
		}
		return false;
	},

	/***
	 * 是否副帮主
	 * @returns {boolean}
	 * @constructor
	 */
	IsSecondGuilder:function () {
		var playerId = Mgr.player.mainPlayer.sid;
		var memberInfo = Mgr.guild.guildMembers.Get( playerId );
		if ( memberInfo ) {
			if ( memberInfo.guildPowerLevel == GuildEnum.MEMBER_SECONDGUILDER ) {
				return true;
			}
		}
		return false;
	},

	/***
	 * 帮会技能是否满级
	 * @param mid
	 * @param level
	 * @returns {boolean}
	 * @constructor
	 */
	IsFullGuildSkill:function (mid, level) {
		var sid = mid + "_" + (level + 1);
		var next_info = Q_guild_skill.Get(sid);
		if (!next_info)
			return true;
		return false;
	},
});