var GuildFlagPanelExt = GuildFlagPanel.extend ( {
	_className:"GuildFlagPanelExt",

	_maxLevel:10,
	_minLevel:1,
	_changeLevel:0,

	_guildInfo:null,

	_TempValue:null,

	_sended:null,

	ctor:function(){
		this._super();
		this._TempValue = new Object();
		this._sended = false;
	},

	Init:function() {
		var self = this;
		GuildFlagPanel.prototype.Init.call(this);

		this.btnUp.addClickEventListener(function (event){
			if ( !Mgr.guild.IsGuilder() ) {
				Mgr.tips.ShowNotice( "只能由帮主升级!" );
				return;
			}
			Mgr.guild.SendReqLevelUpGuildMessage();
		});

		// 不用手动切换
		// this.btnLeft.addClickEventListener(function (event){
		// 	if ( self._changeLevel > self._minLevel ) {
		// 		--self._changeLevel;
		// 		self.SetPageByLevel( self._changeLevel );
		// 	}
		// });
		// this.btnRight.addClickEventListener(function (event){
		// 	if ( self._changeLevel  < self._maxLevel ) {
		// 		++self._changeLevel;
		// 		self.SetPageByLevel( self._changeLevel );
		// 	}
		// });

		this._InitPanel();
	},

	_InitPanel:function () {
		// pos
		this.x = 0;
		this.y = 0;

		this._InitParam();
	},

	_InitParam:function () {
		this.labLevelMin.SetString("");
		this.labLevelMax.SetString("");
		this.prog1.setPercent(0);

		this.labFightValue.SetString("");
		this.imgUpFight.setVisible(false);
		this.labUpFight.SetString("");

		this.labAtkValue.SetString("");
		this.imgUpAtk.setVisible(false);
		this.labUpAtk.SetString("");

		this.labDefValue.SetString("");
		this.imgUpDef.setVisible(false);
		this.labUpDef.SetString("");

		this.labHpValue.SetString("");
		this.imgUpHp.setVisible(false);
		this.labUpHp.SetString("");

		this.labBangZhu.SetString("");

		this.labAtkValue1.SetString( "" );
	},

	_SetData:function () {
		var guildId = Mgr.player.mainPlayer.guildId;
		var guildInfo = Mgr.guild.guildMap.Get( guildId.hexValue );
		cc.assert(null != guildInfo, "guildInfo can't be nil!  guildId: " + guildId);
		this._guildInfo = guildInfo;

		this.SetPageByLevel( guildInfo.level );
	},

	SetPageByLevel:function ( lv ) {
		this._changeLevel = lv;

		// 按钮状态
		// this.btnLeft.setVisible(true);
		// this.btnRight.setVisible(true);
		// if ( lv <= this._minLevel )
			this.btnLeft.setVisible(false);
		// else if ( lv >= this._maxLevel )
			this.btnRight.setVisible(false);

		var guildC = Q_guild.Get( lv );
		cc.assert(null != guildC, "guildC can't be nil!  level: " + lv);

		// flagIcon
		var url = "other/banghui/image/flag/";
		url = url + lv + ".png";
		// var url = this.imgModel.jsonobj.images[0];
		// url = url.substring( 0 , url.lastIndexOf( "/")) + "/";
		// url = url + lv + ".png";
		var imgModel = this.imgModel;
		EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
			imgModel.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
		}, imgModel);

		// flag name
		this.labName.SetString("帮会旗帜");

		// curLv
		var str = "Lv" + lv;
		this.labLevelMin.SetString( str );

		// next lv
		if ( lv >= this._maxLevel ) {
			str = "Lv" + this._maxLevel;
			this.labLevelMax.SetString(str);
			this.prog1.setPercent( 100 );

			var curExp = guildC.q_exp;
			var needExp = guildC.q_exp;
			str = curExp + "/" + needExp;
			this.labRate.SetString( str )
		}
		else {
			var nextLv = lv + 1;
			str = "Lv" + nextLv;
			this.labLevelMax.SetString( str );

			var curExp = this._guildInfo.exp;
			var needExp = guildC.q_exp;

			str = curExp + "/" + needExp;
			this.labRate.SetString( str )

			var rate = parseFloat( curExp / needExp * 100 );
			this.prog1.setPercent( rate );
		}

		// attr
		var array = [];
		if ( guildC.q_attribute_member ) {
			var temp = ParseUtil.FormatFastJsonStr(guildC.q_attribute_member);
			var jsonData = JSON.parse(temp);
			for (var keyStr in jsonData) {
				array.push([parseInt(keyStr), parseInt(jsonData[keyStr])]);
			}
		}

		var fight = 0;
		for ( var i = 0; i != array.length; i++ ) {
			var type = array[i][0];
			var value = array[i][1];
			// 增加值
			var lastValue = 0;
			if ( this._TempValue[type] )
				lastValue = this._TempValue[type];
			var dexValue = value - lastValue;
			this._TempValue[type] = value;

			if ( type == EnumAttribute.ATTACK ) {
				this.labAtkValue.SetString( value );
				//this.labUpAtk.SetString( dexValue );
			}
			else if ( type == EnumAttribute.DEFEND ) {
				this.labDefValue.SetString( value );
				//this.labUpDef.SetString( dexValue );
			}
			else if ( type == EnumAttribute.MAX_BASEHP ) {
				this.labHpValue.SetString( value );
				//this.labUpHp.SetString( dexValue );
			}
			else if ( type == EnumAttribute.DAMAGE_REDUCE ) {
				// 伤害减免
				str =  parseFloat(value/100);
				UIUtil.ConnectLabelHtmlText( this.labBangZhu, [str] );
			}

			//fighting
			var fo = Mgr.attributeMgr.GetAttributeRate(type, 0);
			if ( fo )
				fight = parseInt(fo * value);
		}

		// fighting
		this.labFightValue.SetString(fight, LableEffect.UP);

		// 帮主额外属性加成
		var exArray = [];
		if ( guildC.q_attribute_leader ) {
			var temp = ParseUtil.FormatFastJsonStr(guildC.q_attribute_leader);
			var jsonData = JSON.parse(temp);
			for (var keyStr in jsonData) {
				exArray.push([parseInt(keyStr), parseInt(jsonData[keyStr])]);
			}
		}

		var exValue = exArray[0][1];
		if ( exArray[0][0] == EnumAttribute.ATTACK )
			str = "攻击：";
		else if ( exArray[0][0] == EnumAttribute.DEFEND )
			str = "防御：";
		else if ( exArray[0][0] == EnumAttribute.MAX_BASEHP )
			str = "生命：";

		this.labAtk1.SetString(str);
		this.labAtkValue1.SetString( exValue );
	},

	OnShow:function () {
		// 刷新帮会
		if ( this._sended ) {   // 避免死循环
			this._sended = false;
			this._SetData();
		}
		else {
			this._sended = true;
			Mgr.guild.SendReqUpdateGuildInfoMessage();
		}
	},
} );
GuildFlagPanelExt.PanelName = "GuildFlagPanelExt";
PanelClassDic["GuildFlagPanelExt"] = GuildFlagPanelExt;
