var GuildPanelExt = GuildPanel.extend ( {
	_className:"GuildPanelExt",

	panelMgr:null,
	showPanel:null,
	showType:null,

	//起始位置
	_guilListButtonPt:null,
	_guildInfoButtonPt:null,

	_btnArr:null,

	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = -28;
		this.panelMgr = {};
		this.showType = GuildEnum.PANEL_INFO;
	},
	Init:function() {
		GuildPanel.prototype.Init.call(this);
		this.SetPendantMovie(this.imgJian);
		this._InitParam();

		var self = this;
		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});
		this.sbtnGuildInfo.addClickEventListener(function (event){
			self.ChangePanel(GuildEnum.PANEL_INFO );
		});
		this.sbtnChengyuan.addClickEventListener(function (event){
			self.ChangePanel(GuildEnum.PANEL_MEMBER );
		});
		this.sbtnGuildList.addClickEventListener(function (event){
			self.ChangePanel(GuildEnum.PANEL_LIST );
		});
		this.sbtnGuildSkill.addClickEventListener(function (event){
			self.ChangePanel(GuildEnum.PANEL_SKILL );
		});
		this.sbtnGuildBoss.addClickEventListener(function (event){
			self.ChangePanel(GuildEnum.PANEL_BOSS );
		});
		this.sbtnGuildQizhi.addClickEventListener(function (event){
			self.ChangePanel(GuildEnum.PANEL_FLAG );
		});
	},

	_InitParam:function () {
		this.imgWarn.visible = false;
		this._guildInfoButtonPt = this.sbtnGuildInfo.getPosition();
		this._guilListButtonPt = this.sbtnGuildList.getPosition();

		this._btnArr = [
			{type:GuildEnum.PANEL_INFO, btn:this.sbtnGuildInfo},
			{type:GuildEnum.PANEL_MEMBER, btn:this.sbtnChengyuan},
			{type:GuildEnum.PANEL_LIST, btn:this.sbtnGuildList},
			{type:GuildEnum.PANEL_SKILL, btn:this.sbtnGuildSkill},
			{type:GuildEnum.PANEL_BOSS, btn:this.sbtnGuildBoss},
			{type:GuildEnum.PANEL_FLAG, btn:this.sbtnGuildQizhi},
		];
	},

	LayOutButton:function () {
		var isGuild = !Mgr.player.mainPlayer.guildId.IsZero();
		this.sbtnGuildInfo.setVisible(isGuild);
		this.sbtnChengyuan.setVisible(isGuild);
		this.sbtnGuildSkill.setVisible(isGuild);
		this.sbtnGuildBoss.setVisible(isGuild);
		this.sbtnGuildQizhi.setVisible(isGuild);
		this.sbtnGuildList.setPosition( isGuild == true?this._guilListButtonPt:this._guildInfoButtonPt );
		this.showType = isGuild == true?this.showType:GuildEnum.PANEL_LIST;
	},

	ChangePanel:function ( type ){
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			if ( this._btnArr[i].type == type )
				this._btnArr[i].btn.SetButtonState( "check" );
			else
				this._btnArr[i].btn.SetButtonState( "uncheck" );
		}

		if ( this.showPanel ){
			this.showPanel.visible = false;
			this.showPanel.OnHide();
		}


		switch( type ){
			case GuildEnum.PANEL_INFO:
				if ( !this.panelMgr[type] ) {
					var panel = new GuildInfoPanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case GuildEnum.PANEL_MEMBER:
				if ( !this.panelMgr[type] ) {
					var panel = new GuildMemberExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case GuildEnum.PANEL_LIST:
				if ( !this.panelMgr[type] ) {
					var panel = new GuildListExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case GuildEnum.PANEL_SKILL:
				if ( !this.panelMgr[type] ) {
					var panel = new GuildSkillPanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case GuildEnum.PANEL_BOSS:
				if ( !this.panelMgr[type] ) {
					var panel = new GuildBossMainExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case GuildEnum.PANEL_FLAG:
				if ( !this.panelMgr[type] ) {
					var panel = new GuildFlagPanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			default:
				break;
		}
		this.showType = type;
		this.showPanel = this.panelMgr[type];
		if ( this.showPanel ) {
			this.showPanel.visible = true;
			this.showPanel.OnShow();
		}
	},

	UpdataWarn:function (type) {
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			var _type = this._btnArr[i].type;
			var _button = this._btnArr[i].btn;
			if ( type == undefined ||  _type == type ) {
				// main
				this.SetButtonWarn(_button, Mgr.guild.IsMarkBySubType( _type ));

				// sub
				var page = this.showPanel;
				if ( page && page.visible && page.UpdataWarn )
					page.UpdataWarn();
			}
		}
	},

	SetButtonWarn:function ( widget, warn ) {
		if ( !widget.warn ) {
			var icon = new MUIImage();
			icon.ParseJson(this.imgWarn.jsonobj);
			icon.Init();
			icon.setPosition(this.imgWarn.getPosition());
			widget.addChild(icon);
			widget.warn = icon
		}
		widget.warn.visible = warn;
	},

	OnShow:function () {
		this.LayOutButton();
		this.ChangePanel(this.showType);
		this.UpdataWarn();
	},
} );
GuildPanelExt.PanelName = "GuildPanelExt";
PanelClassDic["GuildPanelExt"] = GuildPanelExt;
