var GuildSkillPanelExt = GuildSkillPanel.extend ( {
	_className:"GuildSkillPanelExt",

	// 链表三件套
	_listView : null,
	_itemList:null,
	_curSelectItem:null,

	ctor:function(){
		this._super();
		this._itemList = [];
	},

	Init:function() {
		var self = this;
		GuildSkillPanel.prototype.Init.call(this);

		this.btnSkillUp.addClickEventListener(function (event){
			var offer = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumMoney.GUILDDEVOTE, AttributeData.Money);
			var needOffer = self._curSelectItem.GetData().q_levelup;
			if ( offer < needOffer ) {
				Mgr.tips.ShowNotice( "帮贡度不足");
				return;
			}

			var id = self._curSelectItem.GetData().q_skill_id;
			Mgr.guild.SendReqGuildSkillLevelUpMessage( id )
		});

		this._InitPanel()
	},

	_InitPanel:function () {
		// pos
		this.x = 0;
		this.y = 0;

		this._InitParam();
	},

	_InitParam:function () {
		// listView
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgLeft.width, this.imgLeft.height));
		list.setTouchEnabled(true);
		list.setScrollBarEnabled(false)
		list.setBounceEnabled(true);
		list.setItemsMargin(0);
		list.setAnchorPoint(0, 0);
		list.setPosition(0,0);

		list.addEventListener(this._SelectedItemEvent);
		this.imgLeft.addChild(list);
		this._listView = list;
	},

	CallBackProp:function () {
		this._SetData();
		this.UpdataWarn();
	},

	_SetData:function () {
		this._LaodItems();
	},

	_LaodItems:function () {
		// 加载item
		var i;
		var len = this._itemList.length;
		var list = Mgr.guild.guildSkillMap.Values();
		for ( i = 0; i != list.length; i++ ) {
			var info = list[i];

			var item
			if ( i < len )
				item = this._itemList[i];
			else {
				item = new GuildSkillItemExt();
				item.LoadPanel();
				item.retain();
				this._itemList.push(item);
			}
			item.SetData( info );
			if (this._listView.getIndex(item) == -1)
				this._AddItem(item);

			// 默认第一个
			if ( !this._curSelectItem )
				this._curSelectItem = item;
		}
		for ( ;i < this._itemList.length; i++ ) {
			var item = this._itemList[i];
			if ( item.parent )
				item.removeFromParent();
		}

		// select
		if ( this._curSelectItem ) {
			this._curSelectItem.SetSelect(true);
			this._SetPageByItem( this._curSelectItem );
		}
		else {
			this._AutoSelect();
		}
	},

	_AutoSelect:function () {
		var item = null;
		var items = this._listView.getItems();
		for ( var i = 0; i != items.length; i++ ) {
			if ( i == 0 )
				item = items[i];

			var info = items[i].GetData();
			if ( info.q_levelup <= Mgr.player.mainPlayer.attributeData.GetAttribute(EnumMoney.GUILDDEVOTE, AttributeData.Money) ) {
				item = items[i];
				break;
			}
		}
		this._curSelectItem = item;
		this._curSelectItem.SetSelect(true);
		this._SetPageByItem( this._curSelectItem );
	},

	_SelectedItemEvent: function (sender, type) {
		switch (type) {
			case ccui.ListView.ON_SELECTED_ITEM_END:
				var parent = sender.parent.parent;
				if ( parent._curSelectItem != null) {
					parent._curSelectItem.SetSelect(false);
					parent._curSelectItem = null;
				}

				var idx = sender.getCurSelectedIndex();
				var itemSelect = sender.getItem(idx);
				itemSelect.SetSelect(true);
				parent._SetPageByItem( itemSelect );
				parent._curSelectItem = itemSelect;
				break;

			default:
				break;
		}
	},

	_SetPageByItem:function ( item ) {
		var info = item.GetData();
		if ( !info )
			return;

		// level
		var str = info.q_name + info.q_level + "级";
		this.labLevel.SetString( str );

		var mid = info.q_skill_id;
		// icon
		var url = this.imgSkill.jsonobj.images[0];
		url = url.substring( 0 , url.lastIndexOf( "/")) + "/";
		url = url + mid + ".png";
		var imgSkill = this.imgSkill;
		EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
			imgSkill.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
		}, imgSkill);

		// attr
		var curRateValue, nextRateValue, curAttrValue = 0;
		curRateValue = parseFloat(info.q_attribute_rate / 100);

		var nextLevel = info.q_level + 1;
		var sid = info.q_skill_id + "_" + nextLevel;
		var next_info = Q_guild_skill.Get( sid );
		if ( next_info ) {
			this.lab1.visible = true;
			nextRateValue = parseFloat(next_info.q_attribute_rate / 100);

			// 未满级
			this.labNextRateMax.visible = false;
			this.labNextRate.visible = true;
			this.labNextRateValue.visible = true;
		}
		else {
			this.lab1.visible = false;
			nextRateValue = "0%";

			// 已满级
			this.labNextRateMax.visible = true;
			this.labNextRate.visible = false;
			this.labNextRateValue.visible = false;
		}

		var type = info.q_attribute;
		var str1 = ParseUtil.FormatFastJsonStr(Q_character.Get(Mgr.player.mainPlayer.attributeData.level).q_attribute);
		var jsonData = JSON.parse(str1);
		for (var keyStr in jsonData) {
			if ( parseInt(keyStr) == type ) {
				curAttrValue = parseInt(jsonData[keyStr]);
				break;
			}
		}
		curAttrValue += parseInt(curAttrValue * parseFloat(curRateValue/100));

		var str;
		if ( type == EnumAttribute.ATTACK )
			str = "攻击";
		else if ( type == EnumAttribute.DEFEND )
			str = "防御";
		else if ( type == EnumAttribute.MAX_BASEHP )
			str = "生命";

		// cur rate
		UIUtil.ConnectLabelHtmlText( this.labCurRate, [str] );
		UIUtil.ConnectLabelHtmlText( this.labCurRateValue, [curRateValue] );

		// next rate
		UIUtil.ConnectLabelHtmlText( this.labNextRate, [str] );
		UIUtil.ConnectLabelHtmlText( this.labNextRateValue, [nextRateValue] );

		// cur value
		UIUtil.ConnectLabelHtmlText( this.labCurAttr, [str] );
		UIUtil.ConnectLabelHtmlText( this.labCurAttrValue, [curAttrValue] );

		// 贡献
		var labGx = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumMoney.GUILDDEVOTE, AttributeData.Money);
		var needGx = info.q_levelup;
		UIUtil.ConnectLabelHtmlText( this.labNum, [labGx,needGx] );
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	UpdataWarn:function () {
		var offer = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumMoney.GUILDDEVOTE, AttributeData.Money);;
		var items = this._listView.getItems();
		for ( var i = 0; i != items.length; i++ ) {
			var info = items[i].GetData();

			var warn = offer >= info.q_levelup;
			if ( Mgr.guild.IsFullGuildSkill(info.q_skill_id, info.q_level) )
				warn = false;
			items[i].imgWarn.visible = warn;
		}
	},

	OnShow:function () {
		// 帮会技能信息
		Mgr.guild.SendReqGuildSkillInfoMessage();
	},
} );
GuildSkillPanelExt.PanelName = "GuildSkillPanelExt";
PanelClassDic["GuildSkillPanelExt"] = GuildSkillPanelExt;
