var IllusionModMgr = IllusionModMgr || cc.Class.extend({

    petPanel:null,
	illusionGoodInfo:[],
        
    illusionDataHash:null,

	ctor:function() {	
        this.illusionDataHash = new HashMap();
        this.onIllusionDataChange = new signals.Signal();
        this.onIllusionShowChange = new signals.Signal();
	},

    /// 获取易融信息
    GetIllusionByItemItem:function(itemId){
        var list = Q_illusion.GetList();
        return list.find(v=>{
            if(v.q_activate_need){
                var arr = JSON.parse(v.q_activate_need);
                return arr && arr[0] == itemId
            }
        })
    },

	RecvResAllIllusionDataInfoToClientMessage:function(msg) {
        for(var i = 0; i < msg.illusionDataInfoList.length; i++){
            this._SortIllusionData(msg.illusionDataInfoList[i]);
        }
        this.CheckWarn();
	},

	RecvResIllusionDataInfoToClientMessage:function(msg) {
        this._SortIllusionData(msg.illusionDataInfo);
        this.CheckWarn(msg.illusionType);
        this.onIllusionDataChange.dispatch(msg.illusionDataInfo);
	},

    CheckWarn:function(type){
        type = type || 0;
        if( type == 0 || type == HuanhuaType.TYPE_PET ) {
            Mgr.player.shortPanel.UpdatePetWarn( this.GetWarnType(HuanhuaType.TYPE_PET) );
        }
        if( type == 0 || type == HuanhuaType.TYPE_WEAPON || type == HuanhuaType.TYPE_CLOAK ){
            Mgr.player.shortPanel.UpdateShizhuangWarn( this.GetWarnType(HuanhuaType.TYPE_WEAPON) || this.GetWarnType(HuanhuaType.TYPE_CLOAK) );
        }
    },

    _SortIllusionData:function(illusionDataInfo){
        this.illusionDataHash.Put(illusionDataInfo.illusionType, illusionDataInfo);
        this._SortIllusion(illusionDataInfo);
    },

    _SortIllusion:function(illusionDataInfo){
        if( !illusionDataInfo.typeHash )
            illusionDataInfo.typeHash = new HashMap();
        for( var i = 0; i < illusionDataInfo.illusionInfoList.length; i++ ){
            var info = illusionDataInfo.illusionInfoList[i];
            illusionDataInfo.typeHash.Put( info.illusionType + "_" + info.illusionId, info );
        }
    },

    IsShowIllusion:function(type, q_id){
        var illusionData = this.illusionDataHash.Get(type);
        if( illusionData ){
            return (type + "_" + illusionData.illusionShowId) == q_id;
        }
        return false;
    },

    GetIllusion:function(type, q_id){
        var illusionData = this.illusionDataHash.Get(type);
        var typeHash;
        if( illusionData && illusionData.typeHash )
            typeHash = illusionData.typeHash;
        else
            typeHash = new HashMap();

        return typeHash.Get(q_id);
    },

	GetWarnType:function(type){
        var list = Q_illusion.GetList();
        for( var i = 0, len = list.length; i < len; i++ ){
            var data = list[i];
            if( type == data.q_type && this.IsCanActivate( type, data.q_id ) )
                return true;
        }
        return false;
    },

    IsCanActivate:function(type, q_id){
        if( !this.GetIllusion(type, q_id) ){
            var data = Q_illusion.Get(q_id);
            var item = Mgr.backpack.GetItemsByMid(JSON.parse(data.q_activate_need)[0]);
            if(item.length)
                return true;
        }
        return false;
    },

	RecvResChangeIllusionShowToClientMessage:function(msg) {
        var gid = msg.playerId.toGID();
        var player = Mgr.sceneObj.FindObject( gid );
        if(player){
            Mgr.mainPlayer.UpdateIllusionModelId(msg.illusionType, msg.illusionId);
            Mgr.mainPlayer.RefreshIllusion(msg.illusionType);
		}
        if( gid == Mgr.mainPlayer.nGid ){
            /// 更新界面
            let illusion = Mgr.player.mainPlayer.showIllusionInfo.find(v=>v.illusionType == msg.illusionType)
            if(illusion){
                illusion.illusionId = msg.illusionId
            }

            var info = this.illusionDataHash.Get(msg.illusionType);
            if( info ){
                info.illusionShowId = msg.illusionId;
            }
            this.onIllusionShowChange.dispatch(msg.illusionId);
        }
	},

	InitGoodsInfo:function(){
    	var list = Q_illusion.GetList();
    	for(var i = 0; i < list.length; i++){
    		var needGoodsId = JSON.parse(list[i].q_activate_need)[0];
    		var id = parseInt(list[i].q_id.substring(list[i].q_id.indexOf("_") + 1, list[i].q_id.length));
    		var type = list[i].q_type;
    		var map = {};
    		map.id = id;
    		map.type = type;
            map.needGoodsId = needGoodsId;
    		this.illusionGoodInfo.push(map);
		}
	},

	ActivaByItemId:function(needGoodsId){
    	if(!this.illusionGoodInfo.length)
    		this.InitGoodsInfo();
    	for(var i = 0; i < this.illusionGoodInfo.length; i++){
    		if(this.illusionGoodInfo[i].needGoodsId == needGoodsId){
                this.SendReqAddIllusionToGameMessage(this.illusionGoodInfo[i].id, this.illusionGoodInfo[i].type)
                break;
            }
		}
	},

	RecvResAddIllusionResultToClientMessage:function(msg) {
	},

	SendReqIllusionDataInfoToGameMessage:function(type) {
		var msg = new ReqIllusionDataInfoToGameMessage();
		msg.illusionType = type;
		Mgr.msgMgr.Send(msg);
	},

	SendReqUseIllusionToGameMessage:function(id, type) {
        var msg = new ReqUseIllusionToGameMessage();
        msg.illusionId = id;
        msg.illusionType = type;
        Mgr.msgMgr.Send(msg);
	},

	SendReqAddIllusionToGameMessage:function(id, type) {
        var msg = new ReqAddIllusionToGameMessage();
        msg.illusionId = id;
        msg.illusionType = type;
        Mgr.msgMgr.Send(msg);
	}
});