///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ImperialWarInfo 皇城战及时信息
//WarRewardInfo 皇城战个人在线奖励信息
//ImperialGuildPositionInfo 皇城战职位信息

// 请求消息
//126201,ReqImperialWarPanelInfo 请求皇城战面板
//126202,ReqEnterImperialWarMap 请求进入皇城战地图
//126203,ReqQuitImperialWarMap 请求退出皇城战地图
//126204,ReqGetImperialWarReward 请求领奖
//126205,ReqImperialWarCarInAdvanceToGame 战车攻击提前移动镜像观察
//126206,ReqImperialWarCarFightToGame 玩家使用战车攻击
//126207,ReqSetImperialGuildPosition 设置皇帮成员职位

// 接收消息
//126101,ResImperialWarPanelInfo 发送求皇城战面板信息 
//126102,ResImperialWarFightInfo 发送求皇城战及时信息(进图和每5秒发一次)
//126103,ResWarRewardInfo 奖励信息
//126104,ResImperialWarYuxPos 玉玺坐标(每秒广播)
//126105,ResImperialWarCarFightResultToClinet 攻城车发射结果广播
//126106,ResImperialWarYuxTeXiaoToClinet 玉玺被拔和归为特效


var ImperialWarInfo = cc.Class.extend({
	ctor:function(){
		this.guildId = null; // 玉玺持者帮会id
        this.holdername = null; // 玉玺持有人名字
        this.holderId = null; // 玉玺持有人Id
        this.holdertime = 0; // 玉玺持有时间（秒）
        this.warendtime = 0; // 攻城战结束剩余时间（秒）
	},

	writing:function( _buf ){
		_buf.WriteLong(this.guildId);
        _buf.WriteString(this.holdername);
        _buf.WriteLong(this.holderId);
        _buf.WriteVarInt(this.holdertime);
        _buf.WriteVarInt(this.warendtime);
	},
	
	reading:function( _buf ){
		this.guildId = _buf.ReadLong();
        this.holdername = _buf.ReadString();
        this.holderId = _buf.ReadLong();
        this.holdertime = _buf.ReadVarInt();
        this.warendtime = _buf.ReadVarInt();
	},
});
var WarRewardInfo = cc.Class.extend({
	ctor:function(){
		this.zhenqi = 0; // 奖励真气
        this.exp = 0; // 奖励经验
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zhenqi);
        _buf.WriteVarInt(this.exp);
	},
	
	reading:function( _buf ){
		this.zhenqi = _buf.ReadVarInt();
        this.exp = _buf.ReadVarInt();
	},
});
var ImperialGuildPositionInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 职位（1-6 帮主 帮主配偶 太师 丞相 尚书 太尉）
        this.playerId = null; // 玩家id
        this.playerName = null; // 玩家名
        this.rewardstate = 0; // 奖励领取状态 大于0已领取 0未领
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteLong(this.playerId);
        _buf.WriteString(this.playerName);
        _buf.WriteVarInt(this.rewardstate);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadVarInt();
        this.playerId = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.rewardstate = _buf.ReadVarInt();
	},
});
////////////////////
// 发送求皇城战面板信息  //
////////////////////
var ResImperialWarPanelInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.guildId = null; // 皇城帮会Id
        this.guildName = null; // 皇城帮会名字
        this.occupyTime = 0; // 占领时间(天)
        this.imperialGuildPositionInfos = []; // 皇帮职位信息 ImperialGuildPositionInfo
	},

	getId:function(){
		return 126101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.guildId);
        _buf.WriteString(this.guildName);
        _buf.WriteVarInt(this.occupyTime);
        _buf.WriteShort( this.imperialGuildPositionInfos.length );
        for (var i = 0; i < this.imperialGuildPositionInfos.length; i++) {
            _buf.WriteBean(this.imperialGuildPositionInfos[i]);
        }
	},
	
	reading:function( _buf ){
        this.guildId = _buf.ReadLong();
        this.guildName = _buf.ReadString();
        this.occupyTime = _buf.ReadVarInt();
        var imperialGuildPositionInfos_length = _buf.ReadShort();
        for (var i = 0; i < imperialGuildPositionInfos_length; i++) {
            this.imperialGuildPositionInfos[i] = _buf.ReadBean(ImperialGuildPositionInfo);
        }
	},

	action:function(){
		Mgr.imperialwar.RecvResImperialWarPanelInfoMessage(this);
	},

});
////////////////////
// 发送求皇城战及时信息(进图和每5秒发一次) //
////////////////////
var ResImperialWarFightInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.warInfo = null; // 皇城战及时信息
	},

	getId:function(){
		return 126102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.warInfo);
	},
	
	reading:function( _buf ){
        this.warInfo = _buf.ReadBean(ImperialWarInfo);
	},

	action:function(){
		Mgr.imperialwar.RecvResImperialWarFightInfoMessage(this);
	},

});
////////////////////
// 奖励信息 //
////////////////////
var ResWarRewardInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.warRewardInfo = null; // 奖励信息
	},

	getId:function(){
		return 126103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.warRewardInfo);
	},
	
	reading:function( _buf ){
        this.warRewardInfo = _buf.ReadBean(WarRewardInfo);
	},

	action:function(){
		Mgr.imperialwar.RecvResWarRewardInfoMessage(this);
	},

});
////////////////////
// 玉玺坐标(每秒广播) //
////////////////////
var ResImperialWarYuxPosMessage = cc.Class.extend( {
	ctor:function(){
		this.mx = 0; // 玉玺持有人坐标X
        this.my = 0; // 玉玺持有人坐标Y
	},

	getId:function(){
		return 126104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort(this.mx);
        _buf.WriteShort(this.my);
	},
	
	reading:function( _buf ){
        this.mx = _buf.ReadShort();
        this.my = _buf.ReadShort();
	},

	action:function(){
		Mgr.imperialwar.RecvResImperialWarYuxPosMessage(this);
	},

});
////////////////////
// 攻城车发射结果广播 //
////////////////////
var ResImperialWarCarFightResultToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.modelId = 0; // 攻城车model
        this.x = 0; // 坐标X
        this.y = 0; // 坐标Y
        this.playerId = null; // 使用者id
	},

	getId:function(){
		return 126105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.modelId);
        _buf.WriteShort(this.x);
        _buf.WriteShort(this.y);
        _buf.WriteLong(this.playerId);
	},
	
	reading:function( _buf ){
        this.modelId = _buf.ReadVarInt();
        this.x = _buf.ReadShort();
        this.y = _buf.ReadShort();
        this.playerId = _buf.ReadLong();
	},

	action:function(){
		Mgr.imperialwar.RecvResImperialWarCarFightResultToClinetMessage(this);
	},

});
////////////////////
// 玉玺被拔和归为特效 //
////////////////////
var ResImperialWarYuxTeXiaoToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 0被拔 1归位
        this.name = null; // 玩家名字
	},

	getId:function(){
		return 126106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteString(this.name);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.name = _buf.ReadString();
	},

	action:function(){
		Mgr.imperialwar.RecvResImperialWarYuxTeXiaoToClinetMessage(this);
	},

});
////////////////////
// 请求皇城战面板 //
////////////////////
var ReqImperialWarPanelInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 126201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求进入皇城战地图 //
////////////////////
var ReqEnterImperialWarMapMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 126202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求退出皇城战地图 //
////////////////////
var ReqQuitImperialWarMapMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 126203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领奖 //
////////////////////
var ReqGetImperialWarRewardMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 126204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 战车攻击提前移动镜像观察 //
////////////////////
var ReqImperialWarCarInAdvanceToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.npcid = 0; // NPCid
        this.type = 0; // 战车类型
        this.x = 0; // 攻击坐标X
        this.y = 0; // 攻击坐标Y
	},

	getId:function(){
		return 126205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.npcid);
        _buf.WriteByte(this.type);
        _buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
	},
	
	reading:function( _buf ){
        this.npcid = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
        this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
	},

});
////////////////////
// 玩家使用战车攻击 //
////////////////////
var ReqImperialWarCarFightToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.npcid = 0; // NPCid
        this.type = 0; // 战车类型
        this.x = 0; // 攻击坐标X
        this.y = 0; // 攻击坐标Y
	},

	getId:function(){
		return 126206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.npcid);
        _buf.WriteByte(this.type);
        _buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
	},
	
	reading:function( _buf ){
        this.npcid = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
        this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
	},

});
////////////////////
// 设置皇帮成员职位 //
////////////////////
var ReqSetImperialGuildPositionMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 职位（1-6 帮主 帮主配偶 太师 丞相 尚书 太尉）
        this.playerId = null; // 玩家id
	},

	getId:function(){
		return 126207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteLong(this.playerId);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.playerId = _buf.ReadLong();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(126101, ResImperialWarPanelInfoMessage);
MESSAGE_POOL.Add(126102, ResImperialWarFightInfoMessage);
MESSAGE_POOL.Add(126103, ResWarRewardInfoMessage);
MESSAGE_POOL.Add(126104, ResImperialWarYuxPosMessage);
MESSAGE_POOL.Add(126105, ResImperialWarCarFightResultToClinetMessage);
MESSAGE_POOL.Add(126106, ResImperialWarYuxTeXiaoToClinetMessage);

