var GoldenInvestPanelExt = GoldenInvestPanel.extend ( {
	_className:"GoldenInvestPanelExt",
	cellPanel:null,
	cellList:null,
    msgDate:null,
    investGold:0,
	isInvest:null,

	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		GoldenInvestPanel.prototype.Init.call(this);
		this.btnExplain.visible = false;

		this.btnInvest.addClickEventListener(function (event) {
			if(self.isInvest){
                Mgr.tips.ShowNotice("你已投资过此档位");
                return;
			}

			if ( Mgr.mainPlayer.attributeData.Allgold() < self.investGold ){
				// Mgr.tips.ShowNotice("元宝不足");
				AlertExt.NoEnoughGold( self.investGold - Mgr.mainPlayer.attributeData.Allgold() );
				return;
			}
			Mgr.bank.SendReqBankBuyLevelToGameMessage(self.investGold);
		});

		this.btnExplain.addClickEventListener(function (event) {
			Mgr.uiMgr.ShowPanelByType(GoldenInvestCueExt.PanelName);
		});
	},


	GetSortList:function () {
		// sort
		var _sortList = [];
		var list = Q_investment.GetList();
		for ( var i = 0; i != list.length; i++ ) {
			var map = this.GetItemParam( list[i] );
			_sortList.push(map);
		}
		_sortList.sort(this._SortFunc);
		return _sortList;
	},

	// 获取相关item参数
	GetItemParam:function (info) {
		// 实际领取金额
		var _realGetValue = 0;
		for ( var i = 0; i != this.msgDate.levels.length; i++ ) {
			if ( this.msgDate.levels[i] == info.q_level) {
				_realGetValue = this.msgDate.getLevelGold[i];
				break;
			}
		}

		// 应该领取金额(取第一档)
        var array = JSON.parse( info.q_reward );
        var _testGetValue = parseInt(array[0]);

		// statues
		var _status = null;
		if ( this.isInvest ) {
			if ( Mgr.player.mainPlayer.attributeData.level >= info.q_level ) {
				if ( _testGetValue == _realGetValue )
					_status = InvestTypeEnum.INVEST_STATUS_GETED;
				else
					_status = InvestTypeEnum.INVEST_STATUS_ENGET;
			}
			else
				_status = InvestTypeEnum.INVEST_STATUS_UNREACH;
		}
		else {
			_status = InvestTypeEnum.INVEST_STATUS_UNREACH;
		}
		// else if ( this.msgDate.buyLevelGold < this.investGold )
		// 	_status = InvestTypeEnum.INVEST_STATUS_UNREACH;
		// else if ( this.msgDate.buyLevelGold > this.investGold ) {
		// 	_status = InvestTypeEnum.INVEST_STATUS_LOSE;
		// }

		return { info:info, realGet:_realGetValue, testGet:_testGetValue, status:_status };
	},

	_SortFunc:function(a, b) {
		if (a.status > b.status) {
			return 1;
		}
		else if ( a.status == b.status ) {
			if ( a.info.q_level > b.info.q_level ) {
				return 1;
			}
		}
		return 0;
	},

	OnShow:function () {
		Mgr.bank.SendReqBankInfoToGameMessage(1);
	},

	SetData:function (msg) {
		this.msgDate = msg;
		if(msg.buyLevelGold > 0){
			Filter.GrayScale(this.btnInvest);
			this.isInvest = true;
			this.labInvested1.visible = true;
			this.labInvested.visible = false;
			this.labInvestNeed.visible = false;
			this.labInvested1.SetText(TextUtil.FormatStr(this.labInvested1.GetHtmlText(), [msg.buyLevelGold]));
		}else {
			this.isInvest = false;
            this.labInvested1.visible = false;
            this.labInvested.visible = true;
            this.labInvestNeed.visible = true;
            var goldArr = JSON.parse( Q_global.Get( 1015 ).q_string_value );
            this.labInvestNeed.SetText(TextUtil.FormatStr(this.labInvestNeed.GetHtmlText(), [goldArr[0]]));
            this.investGold = goldArr[0];
		}

		this.cellList = this.GetSortList();

		if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.imgBg1.uiWidth, this.imgBg1.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
            tableView.uiWidth=this.imgBg1.uiWidth;
            tableView.uiHeight=this.imgBg1.uiHeight;
            this.cellPanel = tableView;
            this.imgBg1.addChild(tableView);
		}
		this.cellPanel.reloadData();
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(1042,115);
    },

    tableCellAtIndex: function (table, idx) {
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item=new GoldenInvestRewardItemExt();
            item.LoadPanel();
            cell.item=item;
            cell.addChild(item);
        }
        cell.item.SetData(this.cellList[idx]);
        return cell;
    },

    numberOfCellsInTableView: function (table) {
        return this.cellList.length;
    }
} );
GoldenInvestPanelExt.PanelName = "GoldenInvestPanelExt";
PanelClassDic["GoldenInvestPanelExt"] = GoldenInvestPanelExt;
