var jingjichangExt = jingjichang.extend ( {
    _className:"jingjichangExt",
    ctor:function(){
        this._super();
    },

    Init:function(){
        this._super();

        this.imgBg.setAnchorPoint(cc.p(0.5,0.5));
        this.imgBg.x = this.width / 2;
        this.imgBg.y = this.height / 2;

        this.imgBg.setScale(Math.max(1,cc.winSize.width / this.imgBg.width,cc.winSize.height / this.imgBg.height));
        this.progZuo1.setDirection(1);
    },

    OnShow:function(){
        this._super();
        TimerUtil.ClearTimeout(Mgr.gameSoundMgr.musicTimeId);
        Mgr.gameSoundMgr.PlaySound( "106", SoundType.BGM, true );
    },

    OnHide:function(){
        this._super();
        Mgr.gameSoundMgr.PlayBGM();
    },

    createPlayerModel:function A_FPE__CPM(info){
        var player = new ArenaFightPlayer();
        this.imgBg.addChild(player);
        return player;
    },
    createPetModel:function(){
        var pet = new ArenaFightPet();
        this.imgBg.addChild(pet);
        return pet;
    },
    ///计算假战斗结果
    calcFightResult:function(leftPower,rightPower,leftWin){
        var count = 5;
        var fightResult = [];

        var ratio = leftPower / rightPower;
        if(ratio > 1) ratio = 1 / ratio;
        // 避免差距太大了，往上提高0.2
        ratio *= 0.8;
        ratio += 0.2;


        var leftRatio = leftWin ? ratio : 1;
        var rightRatio = leftWin ? 1 : ratio;
        var interval = 1 / count;
        var left = 1,right = 1,factor = 0;
        for(var i=0;i<count;i++){
            /// 添加随机因子，最终结果由于小数原因，不精准，不过无所谓
            var temp = i == count - 1 ? factor : factor + Math.random() * 0.2 - 0.1;

            var preL = left,preR = right;
            left -= leftRatio * interval * (1 + temp);
            right -= rightRatio * interval * (1 + temp);
            factor-=temp

            fightResult.push({
                preL : Math.floor(preL * 100),
                preR : Math.floor(preR * 100),
                left : Math.floor(left * 100),
                right : Math.floor(right * 100),
            });
        }
        return fightResult;
    },

    doAction_StartRun:function(){
        this._playerL.SetStateShow(EnumActionType.RUN);
        this._playerR.SetStateShow(EnumActionType.RUN);
        this._petL.SetStateShow(EnumActionType.RUN);
        this._petR.SetStateShow(EnumActionType.RUN);


        var widthGame =  this.imgBg.width;

        var interval =  50;
        this._playerL.runAction(cc.sequence([
            cc.moveTo(1,cc.p(widthGame / 2 - interval,this._playerL.y)),
            cc.callFunc(function(){
                this.doAction_StartFight();
            },this)
        ]))

        this._playerR.runAction(cc.sequence([
            cc.moveTo(1,cc.p(widthGame / 2+ interval,this._playerR.y))
        ]));

        this._petL.runAction(cc.sequence([
            cc.moveTo(1,cc.p(widthGame / 2- interval,this._petL.y))
        ]));
        this._petR.runAction(cc.sequence([
            cc.moveTo(1,cc.p(widthGame/ 2+ interval,this._petR.y))
        ]));
    },

    doAction_StartFight:function(){
        var countdown = this.fightResult.length + 1;
        TimerUtil.TimeUpdate(function(){

            --countdown;
            if(countdown == 0){
                this.doAction_EndFight();
            }else{
                var data = this.fightResult[this.fightResult.length - countdown];
                this.progZuo.runAction(new LoadingBarFromTo(0.8,data.preL,data.left, this.progZuo));
                this.progZuo1.runAction(new LoadingBarFromTo(0.8,data.preR,data.right, this.progZuo1));
            }
        },this,1,countdown,0);


        this._playerL.Attack();
        this._playerR.Attack();
        this._petL.Attack();
        this._petR.Attack();

    },
    doAction_EndFight:function(){
        Mgr.arena.SendReqArenaFightOverMessage();
        Mgr.arena.SendReqArenaInfoMessage();
        Mgr.arena.SendReqArenalistToGameMessage({
            type : 0,
            start : 0,
            length : 4,
        });

        this._playerL.EndAttack();
        this._playerR.EndAttack();
        this._petL.EndAttack();
        this._petR.EndAttack();

        if(this.data.result){
            this._playerR.SetStateShow(EnumActionType.DEAD);
            var p = Mgr.uiMgr.ShowPanelByType(ArenaWinExt.PanelName,UIMgr.PANEL_LAYER_TOP);
            if(p) p.SetData(this.data,function(){
                this.doAction_ClosePanel();
            },this);
        }else{
            this._playerL.SetStateShow(EnumActionType.DEAD);
            var p = Mgr.uiMgr.ShowPanelByType(ArenaDefeatedExt.PanelName,UIMgr.PANEL_LAYER_TOP);
            if(p) p.SetData(this.data,function(){
                this.doAction_ClosePanel();
            },this);
        }
    },

    doAction_ClosePanel:function(){
         EngineMgr.uiMgr.HidePanel(this);
    },

    update:function A_FPE__U(){
        var now = TimerUtil.GetTimer();
        if(this._playerL) this._playerL.OnFrame(now);
    },

    UpdateView:function A_FPE__UV(data,player){
        this.data = data;

        this.UpdatePlayerInfo(player);

        this.fightResult = this.calcFightResult(Mgr.fightpower.fightPower,
            player.fightpower,data.result);

        if(!this._playerL) {this._playerL = this.createPlayerModel();}
        if(!this._playerR) {this._playerR = this.createPlayerModel();}
        if(!this._petL) {this._petL = this.createPetModel();}
        if(!this._petR) {this._petR = this.createPetModel();}

        this._playerL.UpdateWithMainPlayer();
        this._playerR.UpdateWithData(player);
        this._petL.UpdateWithMainPlayer();
        this._petR.UpdateWithData(player);


        var interval = 468;
        var intervalY = 450;
        var xPet = 427
        var yPet = 270
        var widthGame =  this.imgBg.width;
        this._playerL.nCurDirection = 2;
        this._playerL.x = interval;
        this._playerL.y = intervalY;

        this._playerR.nCurDirection = 6;
        this._playerR.x = widthGame - interval;
        this._playerR.y = intervalY;

        this._petL.nCurDirection = 2;
        this._petL.x = xPet;
        this._petL.y = yPet;

        this._petR.nCurDirection = 6;
        this._petR.x = widthGame - xPet;
        this._petR.y = yPet;

        this._playerL.SetStateShow(EnumActionType.STAND);
        this._playerR.SetStateShow(EnumActionType.STAND);
        this._petL.SetStateShow(EnumActionType.STAND);
        this._petR.SetStateShow(EnumActionType.STAND);

        var countdown = 3;
        this.labTime.SetString(countdown);
        TimerUtil.TimeUpdate(function(){
            --countdown;
            this.labTime.SetString(countdown);
            this.labTime.visible = countdown != 0;
            if(countdown == 0){
                this.doAction_StartRun();
            }
        },this,1,countdown,0);
    },

    // 更新玩家信息
    UpdatePlayerInfo:function(player){
        // left
        UIUtil.ConnectLabelHtmlText(this.labMingCheng,[Mgr.player.mainPlayer.name]);
        UIUtil.ConnectLabelHtmlText(this.labZhanDouLi,[Mgr.fightpower.fightPower]);
        UIUtil.LoadImage( this.imgHead, ResUrl.GetPlayerHeadUrl(Mgr.player.mainPlayer.job));

        // right
        UIUtil.ConnectLabelHtmlText(this.labMingCheng1,[player.name]);
        UIUtil.ConnectLabelHtmlText(this.labZhanDouLi1,[player.fightpower]);
        UIUtil.LoadImage( this.imgHead1, ResUrl.GetPlayerHeadUrl(player.job));

        this.progZuo.runAction(new LoadingBarFromTo(0.5,0,100, this.progZuo));
        this.progZuo1.runAction(new LoadingBarFromTo(0.5,0,100, this.progZuo1));
    },
} );
jingjichangExt.PanelName = "jingjichangExt";
PanelClassDic["jingjichangExt"] = jingjichangExt;
