﻿var EnumLoginType = EnumLoginType || {
    Normal:0,
    ShowLoginPanel:1,
    App:2,
};

var LoginModMgr = LoginModMgr || cc.Class.extend({ 
	
	isLoginSuccess:false,
	line:0,
	loginPanel:null,
	
	ctor:function() {	
//		this._super();
		this._serverTime = 0;
		this._clientTimeCheck = 0;
		this._serverTimeCheck = 0;
		this._lastHeartTime = 0;
	},

	GetServerTime:function () {
		return this._serverTime;
	},
	
	GetServerDate:function () {//返回当前服务器时间
		var date = new Date(this._serverTime);
		return date;
	},

    // 开服天数
    GetOpenServerDays:function(){
        var onlineTime = Mgr.player.TotalOnlineTime;
        if(!onlineTime) return 1;

        var date = this.GetServerDate();
		var openDate = new Date(onlineTime.openTime * 1000);
		openDate.setHours(0);
		openDate.setMinutes(0);
		openDate.setSeconds(0);
		return Math.ceil((date.getTime() - openDate.getTime()) / 86400000)
    },

	// 组合服务器过来的时间,用于检测外挂
	ServerTimeCheck:function(){
		if ( this._serverTimeCheck != 0 )
			return this._serverTimeCheck + this._clientTimeCheck;
		return 0;
	},

	//太长时间没收到心跳的话 考虑掉线
	ConnectionCheck:function(){
		if( this._lastHeartTime != 0 ){
			if( Date.now() - this._lastHeartTime > 30 * 60 * 1000 ){
				this._lastHeartTime = Date.now();
				cc.game.restart();	//30分钟未收到心跳  直接重启
			}
			else if( Date.now() - this._lastHeartTime > 5 * 60 * 1000 ){
				Mgr.msgMgr.OnClose(false);		//切后台超过5分钟 断开连接  自己重连
				this._lastHeartTime = Date.now();
			}

		}
	},

	OnFrame:function(){
		this.ConnectionCheck();
		if (this._clientTimeCheck != 0)
		{
			var curTime = TimerUtil.GetTimer();
			var diff = ( curTime - this._clientTimePass );
			this._clientTimeCheck += diff;
			this._serverTime += diff;
			this._clientTimePass = curTime;
		}
	},
	
	// 定时发送心跳给服务器
	OnHeartCheck:function(){
		var msg = new ReqHeartMessage();
		if (this._serverTimeCheck != 0)
			msg.time = this._serverTimeCheck + this._clientTimeCheck;
		// cc.log( "send heart to server! time:" + msg.time );
		Mgr.msgMgr.Send( msg );
		this.CheckPingStart();
	},

	CheckPingStart:function(){
		this._heartStartTime = TimerUtil.GetTimer();
	},
	CheckPingEnd:function(){
		if(this._heartStartTime){
			this.heartCostTime = TimerUtil.GetTimer() - this._heartStartTime;
			if( Mgr.player.shortPanel )
				Mgr.player.shortPanel.UpdatePing();
			this._heartStartTime = 0;
		}
	},

	RecvResCreateCharacterMessage:function(msg) {
		//zz.Log("RecvResCreateCharacterMessage+++++++++++++++++++++++++");
		this.isLoginSuccess = true;
		//这里要显示创建界面

		Mgr.uiMgr.ShowPanelByType( CreateRolePanelExt.PanelName );

		this.CheckPingEnd();
		//Mgr.login.SendReqCreateCharacterMessage(  );
	},

	RecvResLoginSuccessMessage:function(msg) {
        // 后续数据分多个消息同步发过来，延迟提交记录吧
        // TODO 重连算不算进去呢

		zz.Log("RecvResLoginSuccessMessage");
		zz.Log("这里是  "+msg.line+ "  准备进入mapId:" + msg.mapModelId );
		this.line=msg.line;
		this.isLoginSuccess = true;

		if( ConnectMgr.isReconnect && Mgr.sceneMap.nMapId == msg.mapModelId ){
			Mgr.sceneMap.DoChangeMap(msg.mapModelId, -2);
		}
		else{
			//如果是重连 这里应该直接切换		--merlin
			GameMain.oStageLayer.loadBg.setTexture("res/ui/image/load/bg.jpg");
			GameMain.oStageLayer.loadBg.parts.visible = true;
			this.loginPanel = Mgr.uiMgr.ShowPanelByType( DengLuPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP );
			this.loginPanel.ShowProgress(8);

			if( Mgr.uiMgr.IsPanelShowByName(CreateRolePanelExt.PanelName)){
				Mgr.uiMgr.HidePanelByType(CreateRolePanelExt.PanelName);
				Mgr.uiMgr.ReleasePanel( CreateRolePanelExt.PanelName);
			}
			EnterGameMgr.SetConnectLoginReady(msg.mapModelId);
		}

		this.CheckPingEnd();
//		this.SendReqLoadFinishMessage();
	},

	RecvResSubstituteMessage:function(msg) {	
		Mgr.msgMgr.replaceIp = msg.ip;
	},

	RecvResErrorMessage:function(msg) {	
		var info = "创建失败";
		var needClose = false;
		switch(msg.reason)
		{
		case -1:
			info = "未知错误";
			break;
		case 10202:
		case 10203:
			info = "名字长度错误";
			break;
		case 10205:
		case 10206:
			info = "名字中含有非法字符";
			break;
		case 10204:
			info = "角色名字重复";
			break;
		case 10000:
			info = "服务器未到开服时间";
			needClose = true;
			break;
		case 10001:
			info = "登录读取帐号失败";
			break;
		case 10002:
			info = "帐号禁止登录";
			break;
		case 10003:
			info = "登录玩家数量达到上限";
			break;
		case 10004:
			info = "登录密钥验证失败";
			break;
		case 10006:
			info = "登录没有此Gm帐号";
			break;
		case 10007:
			info = "登录时，玩家正在退出中";
			break;
		case 10008:
			info = "登录区服错误，无此区";
			needClose = true;
			break;
		case 10050:
			info = "加载角色失败";
			break;
		case 10051:
			info = "角色帐号错误";
			break;
		case 10100:
			info = "进入地图时，玩家正在退出";
			break;
		case 10200:
			info = "创建角色过多";
			break;
		case 10201:
			info = "角色创建数据库错误";
			break;
		default:
			break;
		}
		AlertExt.Show( info );
		if( needClose ){
			Mgr.msgMgr.CloseSocket();
		}
	},

	RecvResQuitMessage:function(msg) {	
		zz.Log("RecvResQuitMessage");
	},

	RecvResHeartMessage:function(msg) {	

		if ( this._serverTime == 0 ){
			TimerUtil.TimeUpdate(this.OnHeartCheck, this, 10 );
		}
		this._lastHeartTime = Date.now();
		this._serverTime = msg.time * 1000;
		var needReset = ( msg.reset == 1 || ( msg.reset == 0 && msg.time2 >= this.ServerTimeCheck() ) );
		if (msg.time2 != 0 && needReset ){

			this._serverTimeCheck = msg.time2;
			this._clientTimeCheck = 1;
			this._clientTimePass = TimerUtil.GetTimer();
		}
		this.CheckPingEnd();
	},
	
	RecvResSessionCreateMessage:function(msg){
		zz.Log("RecvResSessionCreateMessage");
	},

	RecvResDontLoginMessage:function(msg){
		Mgr.msgMgr.isCanReconnect = false;	//服务器不允许重连
		if( msg.type == 2 ){	//踢下线
			Mgr.msgMgr.CloseSocket();
		}
	},

	SendReqLoginMessage:function( sAccount, sPlatfrom, nServerId ) {	
		var msg = new ReqLoginMessage();
		msg.name = sAccount;
		msg.password = "123456";
		msg.agent = sPlatfrom;
		msg.serverId = nServerId;
		msg.win_high = MGameDefine.SCREEN_HEIGHT;
		msg.win_width = MGameDefine.SCREEN_WIDTH;
		Mgr.msgMgr.Send( msg );
		this.CheckPingStart();
	},

	SendReqCreateCharacterMessage:function(job, name) {
		var msg = new ReqCreateCharacterMessage();
		msg.job = job;
		msg.name = name;
		msg.auto = 1; // 是否自动生成
		msg.win_high = Mgr.uiMgr.stageHeight; // 窗口高像素
		msg.win_width = Mgr.uiMgr.stageWidth; // 窗口宽像素
		Mgr.msgMgr.Send( msg );
		this.CheckPingStart();
		this.j_createRole = true;
	},

	SendReqLoadFinishMessage:function(msg) {
		cc.log("ReqLoadFinishMessage");
		var msg = new ReqLoadFinishMessage();
		Mgr.msgMgr.Send( msg );
	},

	SendReqLoginForPlatformMessage:function(msg) {	
	},
    SendReqLoginForAppMessage:function(msg){
        var msg = new ReqLoginForAppMessage();

        // TODO 改成正式的
        var u8login = GameConfig.u8login;
        var number = Number(u8login.timestamp);

        msg.serverId = GameConfig.current.SERVER_ID.toString();
        msg.agent = ChannelUtil.GetChannelId().toString();//GameConfig.current.PLATFORM;
        // for u8
        msg.userId = u8login.userID;
        msg.userName = u8login.username;
        msg.sdkUserId = u8login.sdkUserID;
        msg.sdkUserName = u8login.sdkUsername;
        msg.timestamp = new Long(number.toString(16));
        msg.extension = u8login.extension;
        msg.token = u8login.token;
        cc.log("SendReqLoginForAppMessage",JSON.stringify(msg));
        Mgr.msgMgr.Send( msg );
		GameConfig.current.USER_NAME = msg.sdkUserId + "|" + msg.agent;
		GameConfig.current.PLATFORM = msg.agent;
        this.CheckPingStart();
    },

	ShowLogin:function (){
		// 显示登录面
		Mgr.uiMgr.ShowPanelByType( DengLuPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP );
	},
	AddProgress:function(value){
		value = value || 1;
		if( this.loginPanel )
			this.loginPanel.SetProgress(value);
	}
});