﻿var MapTypeEnum = MapTypeEnum || {
    /**
     * 世界地图
     */
    TYPE_WORLD:0,
    /**
     *区域地图
     */
    TYPE_AREA:1,
};


var MapModMgr = MapModMgr || cc.Class.extend({

	miniMapPanel:null,
	ctor:function() {
		TimerUtil.TimeUpdate(this.CheckHide,this,1);//创建检测隐藏的定时器
	},

	UpdatePanelPos:function( gid, x, y ){
		if( gid == Mgr.mainPlayer.nGid && this.miniMapPanel )
			this.miniMapPanel.UpdatePos(gid, x, y);
	},

	RecvResRoundPlayerMessage:function(msg) {
		Mgr.sceneObj.CreatePlayer(msg.player);
		if(!Mgr.monster.IsInMonsterMap())
		{
			var player = Mgr.sceneObj.FindObject( msg.player.personId.toGID());
			if(player)
			{
				var guishu = player.getChildByTag(Mgr.monster.GUISHU_TAG);
				if(guishu)
				{
					player.removeChildByTag(Mgr.monster.GUISHU_TAG);
				}
			}
		}
	},

	RecvResRoundMonsterMessage:function(msg) {
		Mgr.sceneObj.CreateMonster(msg.monster);
	},

	RecvResMonsterRefreshSpecialEffectsMessage:function(msg){
		var info = msg.monsterInfo;
		var end;
		if( msg.type == 1 ){
			end = cc.p(info.x, info.y);
			info.x = msg.start.x;
			info.y = msg.start.y;
		}
		Mgr.sceneObj.CreateMonster(info);
		var obj = Mgr.sceneObj.FindObject( info.monsterId.toGID() );
		if( obj ){
			obj.SetJumpWay( [cc.p(info.x, info.y), end], false );
		}
	},

	RecvResRoundGoodsMessage:function(msg) {
		cc.log("=====周围掉落物品======")
		Mgr.sceneObj.CreateItem(msg.goods);

	},

	RecvResRoundPetMessage:function(msg) {
		cc.log("RecvResRoundPetMessage");
	},

	RecvResRoundPlayerDisappearMessage:function(msg) {
		Mgr.sceneObj.DeleteObjects(msg.playerIds);
	},

	RecvResRoundMonsterDisappearMessage:function(msg) {
		TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  Mgr.sceneObj.DeleteObjects, [msg.monstersIds], Mgr.sceneObj, 0, TimeTaskMgr.TYPE_SCENE );
	},

	RecvResRoundGoodsDisappearMessage:function(msg) {	
		Mgr.sceneObj.DeleteObjects(msg.goodsIds);
	},

	RecvResRoundPetDisappearMessage:function(msg) {
		cc.log("RecvResRoundPetDisappearMessage");
	},

	RecvResSetPositionMessage:function(msg) {
		var obj = Mgr.sceneObj.FindObject(msg.personId.toGID());
		if( obj ){
			msg.position.y = -msg.position.y;
			obj.SetPixPt( msg.position );
			obj.SetStateShowStand();
			if( obj == Mgr.mainPlayer )
				this.ServerCheckReset();
		}
	},

	RecvResRunPositionsMessage:function(msg) {	
		this.SynWaySPath( msg.personId, msg.position, msg.positions );

		var player = Mgr.sceneObj.FindObject( msg.personId.toGID() );
		if ( player.sShutongGid > 0 ) {
			var way = ToolMap.PathToWay( msg.positions, msg.position);
			var pt = way.pop();
			pt.x += 2;
			pt.y += 2;
			way.push(pt);

			var pet = Mgr.sceneObj.FindObject( player.sShutongGid );
			pet.SetRunWay( way );
		}
	},

	RecvResMonsterRunPositionsMessage:function(msg) {
		this.SynWaySPath( msg.monsterId, msg.position, msg.positions );
	},

	RecvResPlayerJumpPositionsMessage:function(msg) {
		var obj = Mgr.sceneObj.FindObject(msg.personId.toGID());
		if(obj && (msg.state==3 || msg.state==1)){
			var isFly = msg.state == 3;
			if( isFly && obj == Mgr.mainPlayer )
				this.ServerCheckReset();
			obj.SetJumpWay( msg.positions, isFly );
		}
	},
	
	
	SynWaySPath:function( sid, curpos, positions ){
		var way = ToolMap.PathToWay( positions, curpos);
		if( way )
			this.SynWayPath(sid, curpos, way);
	},
	
	SynWayPath:function( sid, curpos, path ){

		var obj = Mgr.sceneObj.FindObject( sid.toGID() );
		if( obj ){
			if( path.length == 0 ){
				obj.StopMove();
				return;
			}

			if( obj.CheckState(EnumActionType.DEAD) )
				return;
			
			if( obj.nGid == Mgr.mainPlayer.nGid && Mgr.mainPlayer.IsMoving() )
				return;
			obj.SetRunWay( path );
		}

	},

	RecvResStartBlockMessage:function(msg) {
		cc.log("RecvResStartBlockMessage");
	},

	RecvResStopBlockMessage:function(msg) {	
		cc.log("RecvResStopBlockMessage");
	},

	RecvResMonsterStopMessage:function(msg) {	
		this.OnObjectStop( msg.monsterId, msg.position, true);
	},

	RecvResPlayerStopMessage:function(msg) {
		this.OnObjectStop( msg.personId, msg.position, false);
	},
	
	OnObjectStop:function( sid, pos, skipMainplayer ){
		var obj = Mgr.sceneObj.FindObject(sid.toGID());
		if( obj ){
			if( skipMainplayer ){
				if( obj instanceof SceneMainPlayer )// 主玩家忽略这个消息
					return;
				if( obj.CheckState( EnumActionType.MOVEMOMENT ) )	//在跳跃传送点的时候忽略
					return;
			}	
//			if ( lifeV.uid == Mgr.mainPlayerV.uid && Mgr.mainPlayerV.autoFindPath && !Mgr.sceneMgr.isChangeMap )
//			{
//			Mgr.sceneMgr.setObjPos(lifeV, pt.x, pt.y);
//			Mgr.mainPlayerV.PlayerMoveByCourseMap( Mgr.mainPlayerV.autoFindPathMap, Mgr.mainPlayerV.mapCrossTraget, Mgr.mainPlayerV.findNpcMID );
//			return;
//			}
			if( obj.nGid == Mgr.mainPlayer.nGid ){
				var dis = ToolBase.Distance(pos, Mgr.mainPlayer.GetPixPt());
				Mgr.map.ServerCheckReset();
				if( dis <= 100 ){	//距离小 不拉 但是要停下
					obj.StopMove();
					return;
				}
			}
			obj.StopMove(!obj.IsAttackAction());	//攻击中就不切站立了 瞬移估计有点快了 前端攻击了 后端还没停 会打断动作
			pos.y = -pos.y;
			obj.SetPixPt( pos );
		}
	},

	enterMapTimer:0,
	flyInMapEndTimer:0,
	flyInMapTimer:0,
	RecvResChangeMapMessage:function(msg) {	
		cc.log("RecvResChangeMapMessage" );
        Mgr.kingneutral.OnMapStartChanged(msg.mapId, msg.type);
        Mgr.kingguild.OnMapStartChanged(msg.mapId, msg.type);

		//先播放飞走动画 再清空场		复活就不飞了,复活会停止移动 就卡住了.
		if( Mgr.mainPlayer.IsDeadState()){
			Mgr.sceneMap.DoChangeMap( msg.mapId, msg.type );
		}
		else{
            // 对于重复的优化
            if(this.waitChangeMapTimer){
                TimerUtil.ClearTimeout(this.waitChangeMapTimer);
                this.waitChangeMapTimer = TimerUtil.SetTimeout( Mgr.sceneMap, Mgr.sceneMap.DoChangeMap, 600, msg.mapId, msg.type );
		        return;
		    }
			Mgr.sceneMap.bChangingState = true;
			Mgr.sceneMap.SetLookMapMiddle(cc.p(Mgr.mainPlayer.x, Mgr.mainPlayer.y));
			//与进地图同理
            var gridOffset = cc.director.getWinSize().height/(2*ToolMap.dgh) + 1;//动态改变偏差值
            var action = cc.EaseCircleActionIn.create(cc.MoveBy.create(0.6,cc.p(0,gridOffset*ToolMap.dgh)));
            Mgr.mainPlayer.runAction(action);
            Mgr.mainPlayer.SetStateShow(EnumActionType.JUMP_SKY2);
            if(this.enterMapTimer){
                TimerUtil.ClearTimeout(this.enterMapTimer);
				this.enterMapTimer = 0;
            }
            if(this.flyInMapEndTimer){
                TimerUtil.ClearTimeout(this.flyInMapEndTimer);
				this.flyInMapEndTimer = 0;
			}
			if(this.flyInMapTimer){
                TimerUtil.ClearTimeout(this.flyInMapTimer);
				this.flyInMapTimer = 0;
			}

            this.waitChangeMapTimer = TimerUtil.SetTimeout( Mgr.sceneMap, Mgr.sceneMap.DoChangeMap, 600, msg.mapId, msg.type );
		}
	},

	RecvResWeaponChangeMessage:function(msg) {
		cc.log("RecvResWeaponChangeMessage");
	},

	RecvResArmorChangeMessage:function(msg) {
		cc.log("RecvResArmorChangeMessage");
	},

	RecvResEnterMapMessage:function(msg) {
		cc.log("RecvResEnterMapMessage  line: " + msg.line + "  pos: " + msg.pos.x + "  "  + msg.pos.y) ;
		Mgr.sceneMap.EnterMap(msg.line, ToolMap.PixPt2GridPt(msg.pos.x, msg.pos.y));
        if(Mgr.guild.CheckGuildActivityIsOpen() && Mgr.zone.IsInGuildMap()){
        	var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
        	if(panel){
                panel.UpdateTrackWithData("huodong",GuildDatiTaskPaneExt.PanelName,true);
                panel.UpdateTeamWithData("paiming", false, GuildDatiAwardPanelExt.PanelName);
                panel.__panel.InitView();
                panel.__teamPanel.InitView();
        	}
        }
	},

	RecvResPetStopMessage:function(msg) {	
		cc.log("RecvResPetStopMessage");
	},

	RecvResPetRunPositionsMessage:function(msg) {
		cc.log("RecvResPetRunPositionsMessage");
	},

	RecvResPlayerRunEndMessage:function(msg) {
		this.OnObjectStop( msg.personId, msg.position, true);
	},

	RecvResSendLinesMessage:function(msg) {	
		var panel = Mgr.uiMgr.GetPanelByType(WorldMapMainExt.PanelName);
		if(panel && panel.panelMgr[MapTypeEnum.TYPE_AREA]){
            panel.panelMgr[MapTypeEnum.TYPE_AREA].RefreshLines(msg.lines);
		}
	},

	RecvResRoundObjectsMessage:function(msg) {	
		var len = msg.player.length;
		for( var i = 0; i < len; i++ ){
            Mgr.sceneObj.CreatePlayer(msg.player[i]);
		}
		
		len = msg.monster.length;
		for( var i = 0; i < len; i++ ){
            Mgr.sceneObj.CreateMonster(msg.monster[i]);
		}
		
		len = msg.goods.length;
		for( var i = 0; i < len; i++ ){
			Mgr.sceneObj.CreateItem(msg.goods[i]);
		}

		len = msg.npcs.length;
		for( var i = 0; i < len; i++ ){
			Mgr.sceneObj.CreateNpc(msg.npcs[i]);
		}
		
		len = msg.Effect.length;
		for( var i = 0; i < len; i++ ){
			Mgr.sceneObj.CreateEffect(msg.Effect[i]);
		}
		TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  Mgr.sceneObj.DeleteObjects, [msg.monstersIds], Mgr.sceneObj, 0, TimeTaskMgr.TYPE_SCENE );
		Mgr.sceneObj.DeleteObjects( msg.playerIds.concat( msg.goodsIds, msg.npcid, msg.effectid ) );
	},

	showPlayerCount:10,
	isShowDragon:true,
	isShowPet:true,
	isShowSkill:true,//技能暂时不单独屏蔽 就先随着人物显示吧
	isShowTitle:false,
	CheckHide:function () {
		var playerList = Mgr.sceneObj.oRoundPlayerList.oHashList.aList;
		var monsterList = Mgr.sceneObj.oRoundMonsterList.oHashList.aList;

		var setting = Mgr.plugset.GetSysSetInfo();
		var isHidePlayer = (( setting.shield & SettingConstant._SYS_SHIELDER_PLAYER ) > 0 );
		var isHideMonster = (( setting.shield & SettingConstant._SYS_SHIELDER_MONSTER ) > 0 );
		this.isShowDragon = playerList.length < 5;
		this.isShowPet = playerList.length < 8;
		this.isShowTitle = (( setting.shield & SettingConstant._SYS_SHIELDER_TITLE ) <= 0 );
		this.showPlayerCount = 10;
		if(( setting.performance & SettingConstant._SYS_PROPERTY_LL ) > 0 ){
			this.showPlayerCount = 5;
		}
		else if(( setting.performance & SettingConstant._SYS_PROPERTY_L ) > 0 ){
			this.showPlayerCount = 10;
		}
		else if(( setting.performance & SettingConstant._SYS_PROPERTY_M ) > 0 ){
			this.showPlayerCount = 15;
		}
		else if(( setting.performance & SettingConstant._SYS_PROPERTY_H ) > 0 ){
			this.showPlayerCount = 30;
			this.isShowDragon = playerList.length < 10;
			this.isShowPet = playerList.length < 16;
		}

        for(var i=0,length=playerList.length; i<length;i++){
			var player = playerList[i];
			if(player == Mgr.mainPlayer)
				return;
			player.SetPartHide(!isHidePlayer && (i < this.showPlayerCount), this.isShowDragon, this.isShowPet, this.isShowTitle);
        }

		if( Mgr.zone.IsInZoneMap() )
			return;
        for(var i=0,length=monsterList.length;i<length;i++){
			var monster = monsterList[i];
			monster.SetHide(!monster.IsNormalMonster() || !isHideMonster);
        }
    },

	IsPlayerAndPetHide:function (obj) {
		if(obj == Mgr.mainPlayer) {
			return false;
		}

		var playerList = Mgr.sceneObj.oRoundPlayerList.oHashList.aList;
		if( playerList.length >= this.showPlayerCount )
			return true;

		var shield = Mgr.plugset.GetSysSetInfo().shield;
		var temp = SettingConstant._SYS_SHIELDER_PLAYER;

		if((shield & temp) > 0){
			return true;
		}
		return false;
	},

	IsMonsterHide:function (obj) {
		if(Mgr.zone.IsInZoneMap() || !obj.IsNormalMonster()){
			return false;
		}
		var shield = Mgr.plugset.GetSysSetInfo().shield;
		var temp = SettingConstant._SYS_SHIELDER_MONSTER;

		if((shield & temp) > 0){
			return true;
		}
		return false;
	},

	RecvResChangeMapFailedMessage:function(msg) {	
		if( Mgr.mainPlayer )
			Mgr.mainPlayer.StopAutoPath();
	},

	RecvResChangeDirectMessage:function(msg) {	
		var obj = Mgr.sceneObj.FindObject(msg.personId.toGID());
		if( obj )
			obj.SetDirection(msg.dir);
	},

	RecvResChangePositionMessage:function(msg) {	
		var obj = Mgr.sceneObj.FindObject(msg.personId.toGID());
		if( obj ){
			obj.StopMove();
			msg.position.y = -msg.position.y;
			obj.SetPixPt( msg.position );
			if( obj instanceof SceneMainPlayer ){
				Mgr.map.ServerCheckReset();
                Mgr.convoy.OnMainPlayerChangePosition();
				Mgr.mainPlayer.oCtrlAutoPath.MoveToNextMap();
			}
		}
	},

	RecvResRoundNpcMessage:function(msg) {	
		Mgr.sceneObj.CreateNpc(msg.npc);
	},

	RecvResRoundNpcDisappearMessage:function(msg) {	
		Mgr.sceneObj.DeleteObjects(msg.npcids);
	},

	RecvResRoundEffectMessage:function(msg) {	
		Mgr.sceneObj.CreateEffect(msg.Effect);
	},

	RecvResRoundEffectDisappearMessage:function(msg) {	
		Mgr.sceneObj.DeleteObjects(msg.effectid);
	},

	RecvResPetJumpPositionsMessage:function(msg) {	
		cc.log("RecvResPetJumpPositionsMessage");
	},

	RecvResPetTranMoveMessage:function(msg) {	
		cc.log("RecvResPetTranMoveMessage");
	},

	RecvResJumpSetPositionMessage:function(msg) {	
		var obj = Mgr.sceneObj.FindObject( msg.personId.toGID() );
		if( obj ){
			if( obj == Mgr.mainPlayer ){
				this.ServerCheckReset();
				Mgr.mainPlayer.SetMoveMoment([msg.position]);	//修正就直接走setMoveMoment 不然容易死循环
			}
			else{
				obj.SetMoveMoment([msg.position]);
			}
		}
	},

	RecvResDynamicgridsMessage:function(msg) {
		cc.log("RecvResDynamicgridsMessage");
	},

	RecvResNewRunPositionsMessage:function(msg) {
		this.SynWayPath( msg.personId, msg.position, msg.positions );
	},

	RecvResChangeSexMessage:function(msg) {	
		cc.log("RecvResChangeSexMessage");
	},

	RecvResMoveSpeedCorrectionPercentMessage:function(msg) {	
		cc.log("RecvResMoveSpeedCorrectionPercentMessage");
	},

	RecvResShowEffectToClientMessage:function(msg) {	
		cc.log("RecvResShowEffectToClientMessage");
	},

	RecvResDoubleRepairInfosToClientMessage:function(msg) {	
		cc.log("RecvResDoubleRepairInfosToClientMessage");
	},

	RecvResTaskMoveToClientMessage:function(msg) {	
		cc.log("RecvResTaskMoveToClientMessage");
		//Mgr.mainPlayer.serverCheckReset();
	},

	RecvResRoundPlayerFashionMessage:function(msg) {
		var obj = Mgr.sceneObj.FindObject(msg.pid.toGID());
		if( obj ){
			obj.UpdateFashionId(msg.fashionId);
			obj.RefreshShowBody();
			obj.RefreshShowWep();
		}
	},

	RecvResRoundPlayerChangeNameMessage:function(msg) {
		var playerModelId = msg.pid.toGID();
		var obj = Mgr.sceneObj.FindObject(playerModelId);
		if( obj ){
			var pId = Mgr.player.mainPlayer.sid;
			if(pId.toGID() == playerModelId)
			{
				Mgr.player.mainPlayer.name = msg.name;
			}
			obj.SetNameShow(msg.name);
			Mgr.tips.ShowNotice("改名成功");
			EngineMgr.uiMgr.HidePanelByType(ChangeNamePanelExt.PanelName);
			EngineMgr.uiMgr.HidePanelByType(PlayerPanelExt.PanelName);
		}
	},

	RecvResRoundPlayerChangeJobMessage:function(msg) {	
		cc.log("RecvResRoundPlayerChangeJobMessage");
        var obj = Mgr.sceneObj.FindObject( msg.pid.toGID() );
        if( obj ){
            if( obj == Mgr.mainPlayer ){
                Mgr.mainPlayer.nJobId = msg.job;
                Mgr.mainPlayer.nBodyModelId = msg.job;
                Mgr.player.mainPlayer.job = msg.job;
                Mgr.uiMgr.GetPanelByType(RoleHeadPanelExt.PanelName).UpdateHead();
                Mgr.mainPlayer.RefreshShowBody();
                Mgr.mainPlayer.RefreshShowWep();
            }
            else{
                obj.nJobId = msg.job;
                obj.nBodyModelId = msg.job;
                obj.RefreshShowBody();
                obj.RefreshShowWep();
            }
        }
	},

	SendReqRunningMessage:function(msg) {
		cc.log("SendReqRunningMessage");
	},

	SendReqJumpMessage:function(path) {
		this.preActionPostion = path[0];
		this.preActionTime = Mgr.login.ServerTimeCheck();
		this.preActionSpeed = MMoveRule.JUMP_MAX_SPEED;//Mgr.mainPlayer.nMoveSpeed;
		this.preActionCoolDown = 0;
		this.preActionType = 0;//1;

		Mgr.mainPlayer.oCtrlAutoPath.SetMoveSendLock();
		var msg = new ReqJumpMessage();
		msg.type = 1;
		var posArr = [];
		for (var i = 0; i != path.length; i++) {
			posArr.push( new Position( path[i].x, path[i].y ) );
		}
		msg.positions = posArr;
		Mgr.msgMgr.Send( msg );
	},

	SendReqJumpTransMessage:function(transId){
		var msg = new ReqJumpTransMessage();
		msg.transId = transId;
		Mgr.msgMgr.Send( msg );
	},

	SendReqStartBlockMessage:function(msg) {	
		cc.log("SendReqStartBlockMessage");
	},

	SendReqStopBlockMessage:function(msg) {	
		cc.log("SendReqStopBlockMessage");
	},

	SendReqPlayerStopMessage:function() {
		var msg = new ReqPlayerStopMessage();
		msg.position = new Position( Mgr.mainPlayer.x, -Mgr.mainPlayer.y );
		Mgr.msgMgr.Send( msg );
	},

	SendReqChangeMapByMoveMessage:function(msg) {
		cc.log("SendReqChangeMapByMoveMessage");
	},

	SendReqLoadFinishForChangeMapMessage:function(msg) {
		cc.log("ReqLoadFinishForChangeMapMessage");
		var msg = new ReqLoadFinishForChangeMapMessage();
		msg.width = 0; // 屏幕宽度
		msg.height = 0; // 屏幕高度
		Mgr.msgMgr.Send(msg);
	},

	SendReqEnterMapMessage:function(msg) {	
		cc.log("SendReqEnterMapMessage");
	},

	SendReqNpcTransMessage:function(msg) {	
		cc.log("SendReqNpcTransMessage");
	},

	SendReqGoldMapTransMessage:function(id) {
		var msg=new ReqGoldMapTransMessage();
		msg.mapId=id;
		Mgr.msgMgr.Send( msg );
	},
	
	SendReqSameMapFlyMoveMessage:function(position) {
		this.ServerCheckReset();
		Mgr.mainPlayer.oCtrlAutoFight.SetAttackDelay();	//加个延迟 主要是自动攻击引起的飞行会一直发消息
		var msg=new ReqSameMapFlyMoveMessage();
		msg.position=position;
		Mgr.msgMgr.Send( msg );
	},

	SendReqReturnToPreviousMapMessage:function(){
		var msg = new ReqReturnToPreviousMapMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqGetLinesMessage:function() {
        var msg = new ReqGetLinesMessage();
        Mgr.msgMgr.Send(msg);
	},

	SendReqSelectLineMessage:function(line) {
		var msg = new ReqSelectLineMessage();
		msg.line = line;
        Mgr.msgMgr.Send(msg);
	},

	SendReqChangeDirectMessage:function(dir) {
		var msg = new ReqChangeDirectMessage();
		msg.dir = dir;
		Mgr.msgMgr.Send( msg );
	},

	SendReqMonsterInfoMessage:function(sid) {	
		var msg = new ReqMonsterInfoMessage();
		msg.monsterId = sid;
		Mgr.msgMgr.Send( msg );
	},

	bFight:false,
	nLastMoveTime:0,
	SendReqNewRunningMessage:function(ptx, pty, Paths) {
		// if( !this.ServerCheck() )
		// 	return;

		var gridPoint = Mgr.mainPlayer.GetGridPt();
		this.preActionPostion = ToolMap.GridPt2PixPt(gridPoint.x, gridPoint.y, true);
		this.preActionTime = Mgr.login.ServerTimeCheck();
		this.preActionSpeed = this.bFight ? MMoveRule.JUMP_MAX_SPEED : Mgr.mainPlayer.nMoveSpeed;
		this.preActionCoolDown = 0;
		this.preActionType = 0;

		Mgr.mainPlayer.oCtrlAutoPath.SetMoveSendLock();
		var msg = new ReqNewRunningMessage();
		msg.position = new Position(ptx, -pty);
		var posArr = [];
		for (var i = 0; i != Paths.length; i++) {
			posArr.push( new Position( Paths[i].x, -Paths[i].y ) );
		}
		msg.positions = posArr;
		msg.test = this.bFight ? 1 : 0;	//打怪时寻路服务器会飞过去
		Mgr.msgMgr.Send( msg );		
	},

	SendReqSmallFlyShoesMessage:function(mapId, pos) {
		var msg = new ReqSmallFlyShoesMessage();
		msg.mapModel = mapId;
		msg.position = new Position(pos.x, pos.y);
		Mgr.msgMgr.Send(msg);
	},

	SendReqTaskMoveToGameMessage:function(taskmid, type) {
		var msg = new ReqTaskMoveToGameMessage();
		msg.type = type;
		msg.taskModelID = taskmid;
		Mgr.msgMgr.Send( msg );
	},

	serverSpr:null,
	clientSpr:null,
	RecvResSynPlayerPositionMessage:function(msg) {
		if( !this.serverSpr ){
			this.serverSpr = new cc.DrawNode();
			this.serverSpr.retain();
			this.serverSpr.drawDot(cc.p(0,0), 15, cc.color(0,255,0,150));
			this.clientSpr = new cc.DrawNode();
			this.clientSpr.retain();
			this.clientSpr.drawRect(cc.p(-20,20), cc.p(20, -20), cc.color(255,255,0,50));
			Mgr.mainPlayer.AddTopChild(this.clientSpr);
		}
		if( !this.serverSpr.parent )
			Mgr.sceneLayer.AddTop(this.serverSpr);
		this.serverSpr.x = msg.position.x;
		this.serverSpr.y = -msg.position.y;
	},

	RecvResSynMonsterPositionMessage:function(msg) {	
		cc.log("RecvResSynMonsterPositionMessage");
	},

	RecvResMapBlocksMessage:function(msg) {	
		cc.log("RecvResMapBlocksMessage");
	},

	RecvResMomentMoveMessage:function(msg)	{
		var obj = Mgr.sceneObj.FindObject( msg.personId.toGID() );
		if( obj ){
			obj.SetMoveMoment([msg.position]);
		}
	},

	RecvResRoundJumpTransMessage:function(msg){
		var obj = Mgr.sceneObj.FindObject( msg.personId.toGID() );
		if( obj ){
			if( obj == Mgr.mainPlayer ){
				this.ServerCheckReset();
				Mgr.mainPlayer.oCtrlAutoPath.FlyToPath([msg.position], null, 0.6);
			}
			else{
				obj.SetMoveMoment([msg.position], 0.6);
			}
		}
	},
	
	////////////////////////////////////////////////////
	nCurtargetgid:0,
	
	CheckTargetOnRemove:function(o){
		if (o != null){
			if (o.nGid == this.nCurtargetgid) {
				this.SelTarget(null);
			}
			Mgr.sceneObj._selectedMonsterHash.Remove(o.nGid);
			if (Mgr.sceneAction.oCtrlObject != null)
				Mgr.sceneAction.oCtrlObject.oCtrlAutoFight.CheckClearAutoLock(o.nGid);
		}
	},

	SelTarget:function(mouseObj) {
		if (mouseObj == null || mouseObj.nGid != this.nCurtargetgid) {
			if (this.nCurtargetgid != 0) {
				var o = Mgr.sceneObj.FindObject(this.nCurtargetgid);
				if (o != null){
					o.SetSelShow(false);
				}
				Mgr.player.roleHeadPanel.SetTarget(null);
				this.nCurtargetgid = 0;
			}
		}

		if (mouseObj != null){
			this.nCurtargetgid = mouseObj.nGid;
			mouseObj.SetSelShow(true);
			Mgr.player.roleHeadPanel.SetTarget(mouseObj);
		}
	},

	//UpdateTarget:function(checkobj){
	//	if (checkobj != null && checkobj.nGid == this.nCurtargetgid){
	//		Mgr.player.roleHeadPanel.UpdateTarget(checkobj);
	//	}
	//},

	UpdateHp:function(checkobj){
		if (checkobj != null && checkobj.nGid == this.nCurtargetgid){
			Mgr.player.roleHeadPanel.UpdateTargetHp(checkobj);
		}
	},

	UpdateBuff:function(checkobj){
        if (checkobj != null && checkobj.nGid == this.nCurtargetgid){
            Mgr.player.roleHeadPanel.UpdateTargeBuff(checkobj);
        }
	},
	
	/**
	 * 服务器规则验证移动
	 */
	preActionPostion:null,
	preActionCoolDown:0,
	preActionSpeed:0,
	preActionTime:0,
	ServerCheck:function(){
		if ( this.preActionPostion != null )
		{
			var between = Mgr.login.ServerTimeCheck() - this.preActionTime;
			
			// 判断冷却
//			if ( isFirstJump == 1 && between < preActionCoolDown )
//			{
//				Mgr.logMgr.addClientLog( "冷却没到, " 
//				+ " preActionCoolDown：" + preActionCoolDown 
//				+ " between：" + between 
//				+ " pretime：" + preActionTime
//				+ " time：" + MainApp.getInstance().serverTimeCheck );
//	
//				Mgr.promptMgr.addPersonInfo( PersIconTypeEnum.Wrong, "跳跃冷却中！" );
//				return false;	
//			}
	
			var ratio = ( this.preActionType == 0 ) ? 1.0 : 1.5;
			var gridPoint = Mgr.mainPlayer.GetGridPt();
			var pixPoint = ToolMap.GridPt2PixPt(gridPoint.x, gridPoint.y, true);
			var start_distance = ToolBase.Distance(pixPoint, this.preActionPostion );
			var maxSpeed = Math.max( this.preActionSpeed, Mgr.mainPlayer.nMoveSpeed );	
			var start_allow_distance = Math.round( maxSpeed * ( between / 1000 ) * ratio);
			if ( start_distance > ( start_allow_distance + 50 ) ) // 12个像素  绝对不会超  超了就是算法有问题
			{
				zz.Log( "起始点距离过远, " 
						+ " 类型：" + this.preActionType
						+ " dis：" + start_distance 
						+ " allowdis：" + start_allow_distance
						+ " diff：" + ( start_distance - start_allow_distance )
						+ " preStart：" + this.preActionPostion.x + "," + this.preActionPostion.y
						+ " start：" + Mgr.mainPlayer.GetPixPt().x + "," + Mgr.mainPlayer.GetPixPt().y
						+ " pretime：" + this.preActionTime
						+ " time：" + Mgr.login.ServerTimeCheck()
						+ " prespeed：" + this.preActionSpeed
						+ " speed：" + Mgr.mainPlayer.nMoveSpeed );
				return false;
			}
			else
			{
//				if ( isFirstJump == 1 )
//				{
//					Mgr.logMgr.addClientLog( "两次跳跃间隔, " 
//					+ " preActionCoolDown：" + preActionCoolDown 
//					+ " between：" + between 
//					+ " pretime：" + preActionTime
//					+ " time：" + MainApp.getInstance().serverTimeCheck );
//				}
			}
		}
		return true;
	},
	
	ServerCheckReset:function(){
		this.preActionPostion = null;
		this.preActionCoolDown = 0;
		this.preActionSpeed = 0;
		this.preActionTime = 0;
	},

	
	CheckJumTransfer:function( pos ){
		if( Mgr.mainPlayer.CheckState(EnumActionType.MOVEMOMENT) || Mgr.mainPlayer.CheckState(EnumActionType.JUMP_FLY) )
			return false;
		var len = Mgr.sceneMap.jumpTransferArr.length;
		for( var i = 0; i < len; i++ ){
			var model = Mgr.sceneMap.jumpTransferArr[i];
			if( model && model.q_tran_from_x == pos.x && model.q_tran_from_y == pos.y ){
				this.SendReqJumpTransMessage( model.q_tran_id );
				return true;
			}
		}
		return false;
	}
});