var WorldMapMainExt = WorldMapMain.extend ( {
	_className:"WorldMapMainExt",

    choiceType:null,

	showPanel:null,
    panelMgr:null,

    _timeId:-1,

    oldPosX:null,
    oldPosY:null,

	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.panelMgr = {};
	},

	Init:function(){
        WorldMapMain.prototype.Init.call( this );

        // this.InitSubPanel();

        this._InitParm();

        var self = this;
        this.btnclose.addClickEventListener(function(event){
            EngineMgr.uiMgr.HidePanelByType( WorldMapMainExt.PanelName );
		});

        this.sbtnQuyu.addClickEventListener(function(event){
            self.ChangePanel(MapTypeEnum.TYPE_AREA);
        });

        this.sbtnWorld.addClickEventListener(function(event){
            self.ChangePanel(MapTypeEnum.TYPE_WORLD);
        });
	},

    OnShow:function(){
        this.ChangePanel(MapTypeEnum.TYPE_AREA);
        this.RefreshMapInfo();
        this._timeId = TimerUtil.TimeUpdate(this.Updata, this, 0.2);
        if(this.showPanel)
            this.showPanel.OnShow();
    },

    Updata:function(){
        if(this.oldPosX != Mgr.mainPlayer.x || this.oldPosY != Mgr.mainPlayer.y){
            this.oldPosX = Mgr.mainPlayer.x;
            this.oldPosY = Mgr.mainPlayer.y;
            // this.labZuobiao.SetHtmlText(TextUtil.FormatStr(this.labZuobiao.GetHtmlText(),[parseInt(Mgr.mainPlayer.x) + ","+ parseInt(-Mgr.mainPlayer.y)]));
            if(this.showPanel && this.showPanel.Updata)
                this.showPanel.Updata();
        }
    },

    RefreshMapInfo:function(){
      if(MapUtil.isMapCanPK(Mgr.sceneMap.nMapId)){
          this.labPK.visible = false;
          this.labPK1.visible = true;
      }
      else{
          this.labPK.visible = true;
          this.labPK1.visible = false;
      }
      this.labMapName.SetHtmlText("当前地图：" + Q_map.Get(Mgr.sceneMap.nMapId).q_map_name);
      // this.labZuobiao.SetHtmlText(TextUtil.FormatStr(this.labZuobiao.GetHtmlText(),[parseInt(Mgr.mainPlayer.x) + ","+ parseInt(-Mgr.mainPlayer.y)]));
    },

    _InitParm:function(){
		this.choiceType = MapTypeEnum.TYPE_AREA;

        this._btnArray = [
            {btn:this.sbtnQuyu,   type:MapTypeEnum.TYPE_AREA},
            {btn:this.sbtnWorld,   type:MapTypeEnum.TYPE_WORLD}
        ];

        this._btnPosArray = [
            this.sbtnQuyu.getPosition(),
            this.sbtnWorld.getPosition()
        ]
    },

	ChangePanel:function(type){

        if(this.showPanel && type == this.showPanel.type)
            return;

        for(var i = 0; i != this._btnArray.length; i++){
            if(this._btnArray[i].type == type)
                this._btnArray[i].btn.SetButtonState("check");
            else
                this._btnArray[i].btn.SetButtonState("uncheck");
        }

        if(this.showPanel){
            this.showPanel.visible = false;
            // this.showPanel.OnHide();
            // this.removeChild(this.showPanel);
            // this.panelMgr[this.showPanel.type] = null;
            this.showPanel = null;
        }

    	switch(type){
			case MapTypeEnum.TYPE_AREA:
				if(!this.panelMgr[type]){
                    // cc.log("-------------create MapMainExt");
                    var pos = this.imgBg.getPosition();
                    var panel = new MapMainExt();
                    panel.LoadPanel();
                    panel.setPosition(pos);
                    this.addChild(panel);
                    this.panelMgr[type] = panel;
				}
                this.panelMgr[type].OnShow();
				break;
            case MapTypeEnum.TYPE_WORLD:
                if(!this.panelMgr[type]){
                    // cc.log("-------------create WorldMapPanelExt");
                    var pos = this.imgBg.getPosition();
                    var panel = new WorldMapPanelExt();
                    panel.LoadPanel();
                    panel.setPosition(pos);
                    this.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                this.panelMgr[type].OnShow();
                break;
            default:
                break;
		}
        this.showPanel = this.panelMgr[type];
        this.showPanel.type = type;
    	if(this.showPanel)
            this.showPanel.setVisible(true);
	},

    OnHide:function(){
        this._super();
        // for(var i = 0; i != this._btnArray.length; i++){
        // 	if(this.panelMgr[this._btnArray[i].type]){
        //         this.panelMgr[this._btnArray[i].type].OnHide();
        //         this.panelMgr[this._btnArray[i].type] = null;
			// }
        // }
        if(this.panelMgr[MapTypeEnum.TYPE_AREA])
            this.panelMgr[MapTypeEnum.TYPE_AREA].OnHide();
        if(this.panelMgr[MapTypeEnum.TYPE_WORLD])
            this.panelMgr[MapTypeEnum.TYPE_WORLD].OnHide();
        TimerUtil.ClearTimeUpdate(this._timeId, this);
    }
} );
WorldMapMainExt.PanelName = "WorldMapMainExt";
PanelClassDic["WorldMapMainExt"] = WorldMapMainExt;
