var BiaoBaiFrameExt = (function(){
    var Cell = cc.TableViewCell.extend({
        ctor:function(){
            this._super();
        },
        SetData:function(){
            if(!this.container){
                let c = new BiaoBaiFrameItemExt();
                c.LoadPanel();
                this.addChild(c)
                this.container = c
            }

            this.container.SetData.apply(this.container,arguments)
        },
    })
    var ENUM_FUNC = {
        MARRIAGE : 1,
        CONFESSION : 2,
    }
    var ENUM_TAB = {
        FRIEND : 1,
        RECOMMEND : 2,
    }
    return BiaoBaiFrame.extend ( {
        _className:"BiaoBaiFrameExt",
        ctor:function(){
            this._super();
            this.modelPanelType = 2
        },
        Init:function(){
            this._super();

            this.btnClose.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this));

            this.btnArr = [
                { type : ENUM_TAB.FRIEND	, btn : this.sbtnXinXi		, warn : this.imgWarn	,},
                { type : ENUM_TAB.RECOMMEND	, btn : this.sbtnTuiJian	, warn : this.imgWarn1	,},
            ]
            this.btnArr.forEach(v=>{
                v.btn.addClickEventListener(this.OnTabChanged.bind(this,v.type));
                v.warn.visible = false
            })

            this.btnShuaXin.addClickEventListener(this.OnBtn_Refresh.bind(this))
            this.btnTongyi.addClickEventListener(this.OnBtn_Confirm.bind(this))

            /// tab tableView
            var size = this.imgBg1.getContentSize();
            var contentSize = cc.size(size.width, this.CELL_HEIGHT * 5)
            var tableView = new cc.TableView(this,size);
            tableView.setDirection(ccui.ScrollView.DIR_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.reloadData();

            this.imgBg1.addChild(tableView);
            this.tableView = tableView;
        },

        OnShow:function(){
            this._super();

            GameEventMgr.AddEventListener(this,new ResFriendListInfoMessage().getId(),_=>{
                this.OnTabChanged()
            })
            GameEventMgr.AddEventListener(this,new ResRecFriendListMessage().getId(),_=>{
                this.OnTabChanged()
            })

            this.OnTabChanged(ENUM_TAB.FRIEND)
            Mgr.friend.SendReqFriendListInfoMessage()
            Mgr.friend.SendReqRecFriendInfoMessage()
        },
        OnHide:function(){
            this._super();
            GameEventMgr.RemoveEventListener(this);
        },
        OnBtn_Refresh:function(){
            switch(this.$type){
                case ENUM_TAB.FRIEND:{
                    Mgr.friend.SendReqFriendListInfoMessage()
                    break;
                }
                case ENUM_TAB.RECOMMEND:{
                    Mgr.friend.SendReqRecFriendInfoMessage()
                    break;
                }
            }
        },
        OnBtn_Confirm:function(){
            var data = this.data[this.selectedIndex]
            if(this.callback) this.callback(data)

            EngineMgr.uiMgr.HidePanel(this)
        },
        OnTabChanged:function(type){
            type = type || this.$type
            this.$type = type
            this.selectedIndex = null

            this.btnArr.forEach(v=>v.btn.SetButtonState(v.type == type?"check":"uncheck"));

            switch(type){
                case 1://好友
                    var fList = Mgr.friend.friendList.Values();
                    // 异性筛选
                    if(this.$funcType == ENUM_FUNC.MARRIAGE){
                        fList = fList.filter(v=>{
                            return v.icon != Mgr.player.mainPlayer.job
                        })
                    }
                    this.ReloadData(fList)
                    break
                case 2://推荐
                    var fList = Mgr.friend.recommendFriendArr || [];
                    //TODO
                    this.ReloadData(fList)
                    break
            }
        },
        ReloadData:function(data){
            this.data = data//[1,2,3,4,5,]
            this.tableView.reloadData();
        },
        SetCallback:function(callback,type){
            this.callback = callback
            this.$funcType = type

            switch(type){
                case 1:
                    UIUtil.ConnectLabelHtmlText(this.lab1	,["结婚选择"])
                    this.btnArr.forEach(v=>{
                        v.btn.visible = v.type != ENUM_TAB.RECOMMEND
                    })
                    break;
                default:
                    UIUtil.ConnectLabelHtmlText(this.lab1	,["表白选择"])
                    this.btnArr.forEach(v=>v.btn.visible = true)
                    break;
            }
        },
        tableCellSizeForIndex:function(sender,index){
            return cc.size(sender.width,65);
        },
        tableCellAtIndex:function(sender,index){
            var cell = sender.dequeueCell();
            if (!cell) {
                cell = new Cell();
            }

            cell.SetData(this.data[index],this.selectedIndex == index);
            return cell;
        },
        numberOfCellsInTableView:function(sender){
            return this.data ? this.data.length : 0;
        },
        tableCellTouched:function(sender,cell){
            this.selectedIndex = cell.getIdx()
            this.tableView.reloadData();
        },
    } );
})()
BiaoBaiFrameExt.PanelName = "BiaoBaiFrameExt";
PanelClassDic["BiaoBaiFrameExt"] = BiaoBaiFrameExt;
