///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//OfflineResZoneBackInfo 离线资源追回Info
//OfflineResAwardInfo 离线收益
//OfflineBackInfo 离线补回信息

// 请求消息
//209201,ReqGetOfflineAward 请求领取离线收益
//209202,ReqGetOfflineResZoneBack 请求领取离线资源追回
//209203,ReqGetOfflineOneKey 一键请求领取离线收益
//209204,ReqOpenOfflineResPanel 请求离线资源面板信息
//209205,ReqOpenOfflineAwardPanel 请求离线收益面板信息

// 接收消息
//209101,ResOfflineAwardPanel 离线收益面板信息
//209102,ResOfflineResPanel 离线资源追回面板信息
//209103,ResGetOfflineSuc 领奖成功


var OfflineResZoneBackInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 类型Id
        this.count = 0; // 可追回次数
        this.state = 0; // 领取状态(0为未开启 1可领取 2已领取)
        this.exp = 0; // 可找回状态下能找回的经验
	},

	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteVarInt(this.count);
        _buf.WriteByte(this.state);
        _buf.WriteVarInt(this.exp);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadByte();
        this.count = _buf.ReadVarInt();
        this.state = _buf.ReadByte();
        this.exp = _buf.ReadVarInt();
	},
});
var OfflineResAwardInfo = cc.Class.extend({
	ctor:function(){
		this.totalTime = 0; // 累计时间(分钟)
        this.exp = 0; // 经验
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.totalTime);
        _buf.WriteVarLong(this.exp);
	},
	
	reading:function( _buf ){
		this.totalTime = _buf.ReadVarInt();
        this.exp = _buf.ReadVarLong();
	},
});
var OfflineBackInfo = cc.Class.extend({
	ctor:function(){
		this.modelid = 0; // 道具modelid
        this.num = null; // 累计的数量
        this.state = 0; // 0是未完成，1是未领取，2是领取
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.modelid);
        _buf.WriteLong(this.num);
        _buf.WriteVarInt(this.state);
	},
	
	reading:function( _buf ){
		this.modelid = _buf.ReadVarInt();
        this.num = _buf.ReadLong();
        this.state = _buf.ReadVarInt();
	},
});
////////////////////
// 离线收益面板信息 //
////////////////////
var ResOfflineAwardPanelMessage = cc.Class.extend( {
	ctor:function(){
		this.offlineAward = null; // 离线收益面板
	},

	getId:function(){
		return 209101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.offlineAward);
	},
	
	reading:function( _buf ){
        this.offlineAward = _buf.ReadBean(OfflineResAwardInfo);
	},

	action:function(){
		Mgr.offlineres.RecvResOfflineAwardPanelMessage(this);
	},

});
////////////////////
// 离线资源追回面板信息 //
////////////////////
var ResOfflineResPanelMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneBackInfo = []; // 副本追回面板 OfflineResZoneBackInfo
	},

	getId:function(){
		return 209102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.zoneBackInfo.length );
        for (var i = 0; i < this.zoneBackInfo.length; i++) {
            _buf.WriteBean(this.zoneBackInfo[i]);
        }
	},
	
	reading:function( _buf ){
        var zoneBackInfo_length = _buf.ReadShort();
        for (var i = 0; i < zoneBackInfo_length; i++) {
            this.zoneBackInfo[i] = _buf.ReadBean(OfflineResZoneBackInfo);
        }
	},

	action:function(){
		Mgr.offlineres.RecvResOfflineResPanelMessage(this);
	},

});
////////////////////
// 领奖成功 //
////////////////////
var ResGetOfflineSucMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 成功类型
        this.rewards = []; // 领取的奖励 SimpleItemInfo
	},

	getId:function(){
		return 209103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteShort( this.rewards.length );
        for (var i = 0; i < this.rewards.length; i++) {
            _buf.WriteBean(this.rewards[i]);
        }
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        var rewards_length = _buf.ReadShort();
        for (var i = 0; i < rewards_length; i++) {
            this.rewards[i] = _buf.ReadBean(SimpleItemInfo);
        }
	},

	action:function(){
		Mgr.offlineres.RecvResGetOfflineSucMessage(this);
	},

});
////////////////////
// 请求领取离线收益 //
////////////////////
var ReqGetOfflineAwardMessage = cc.Class.extend( {
	ctor:function(){
		this.multiple = 0; // 领取倍数
	},

	getId:function(){
		return 209201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.multiple);
	},
	
	reading:function( _buf ){
        this.multiple = _buf.ReadByte();
	},

});
////////////////////
// 请求领取离线资源追回 //
////////////////////
var ReqGetOfflineResZoneBackMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型
        this.costType = 0; // 0免费 1 绑定元宝
	},

	getId:function(){
		return 209202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteByte(this.costType);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.costType = _buf.ReadByte();
	},

});
////////////////////
// 一键请求领取离线收益 //
////////////////////
var ReqGetOfflineOneKeyMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 0 一键 1 三界
	},

	getId:function(){
		return 209203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 请求离线资源面板信息 //
////////////////////
var ReqOpenOfflineResPanelMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 209204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求离线收益面板信息 //
////////////////////
var ReqOpenOfflineAwardPanelMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 209205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(209101, ResOfflineAwardPanelMessage);
MESSAGE_POOL.Add(209102, ResOfflineResPanelMessage);
MESSAGE_POOL.Add(209103, ResGetOfflineSucMessage);

