var OtherRolePanelExt = OtherRolePanel.extend ( {
	_className:"OtherRolePanelExt",

	// 分页两件套
	curSubType:null,
	curSubPanel:null,

	_rolePanel:null,
	_zanjiaPanel:null,
	_ridePanel:null,

	panelMgr:null,
	showPanel:null,
	showType:0,

	// 开启方式
	_openMode:null,

	// 玩家信息
	_roleBriefInfo:null,
	_reslineDataHash:null,

	_btnArr:null,
	_btnPosArr:null,

	// 按钮容器
	_powerButtonPos:null,
	_powerButtonList:null,
	modelPanelType:2,
	isClosePanel:true,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;

		this._powerButtonList = [];
		this._powerButtonPos = [];
		this.panelMgr = {};
		this._reslineDataHash = new HashMap();
	},

	Init:function() {
		var self = this;
		OtherRolePanel.prototype.Init.call(this);
		this.SetDragEnable(true);

		this.btnClose.addClickEventListener(function (event) {
			EngineMgr.uiMgr.HidePanel(self);
		});

		this._InitPanel();
	},

	_InitPanel:function () {
		this._InitParam();
	},

	_InitParam:function () {
		this._btnArr = [
			{type:-1, btn:this.sbtnRole, btnStr:this.labJiaose},
			{type:EnumResline.HORSE, btn:this.sbtnRide, btnStr:this.labRide},
			{type:EnumResline.GUANGWU, btn:this.sbtnGuangWu, btnStr:this.labGuangWu},
			{type:EnumResline.DRAGON, btn:this.sbtnWing, btnStr:this.labWing},
			{type:EnumResline.SHUTONG, btn:this.sbtnShuTong, btnStr:this.labShuTong},
			{type:EnumResline.BAOQI, btn:this.sbtnBaoqi, btnStr:this.labBaoqi},
		];
		this._btnPosArr = [
			this.sbtnRole.getPosition(), this.sbtnRide.getPosition(),
			this.sbtnGuangWu.getPosition(), this.sbtnWing.getPosition(),
			this.sbtnShuTong.getPosition(),this.sbtnBaoqi.getPosition(),
		];
		var powerButton = [
			this.btnAddFriend,this.btnShanrang, this.btnRenming,this.btnChezhi, this.btnOut, this.btnDuibi
		];
		for (var i = 0; i < powerButton.length; i++ )
		{
			powerButton[i].visible = false;
			this._powerButtonPos.push(powerButton[i].getPosition());
		}

		for (var i = 0; i < this._btnArr.length; i++ )
		{
			var self = this;
			this._btnArr[i].btn.type = this._btnArr[i].type;
			this._btnArr[i].btn.addTouchEventListener(function(target,state)
			{
				if(state == ccui.Widget.TOUCH_ENDED)
				{
					self._ChangePanel(target.type)
				}
			})
			if ( this._btnArr[i].btn.parent ) {
				this._btnArr[i].btn.retain();
				this._btnArr[i].btn.removeFromParent();
			}
		}
	},

	SetData:function (briefInfo, openMode) {
		this._roleBriefInfo = briefInfo;
		this._openMode = openMode;

		this._GetReslineData();
		this._ResetPowerButton( openMode );
		this.showType = -2;
		var types = this._ReposBtns();
		if ( types.length > 0 )
			this._ChangePanel( types[0] );
		else
			zz.Error("没有子功能开放!");
	},

	// 获取角色的操作权限
	_GetRolePowers:function ( openMode ) {
		var powerList = [];
		if ( openMode == EnumDetails.OPEN_MODE_NORMAL ) {
			// var data = Mgr.friend.GetFriendList().Get(this._roleBriefInfo.playerid);
			// if ( !data )
				powerList.push(EnumDetails.POWER_ADD_FRIEND);
				powerList.push(EnumDetails.POWER_COMBAT_POWER)
		}
		else if ( openMode == EnumDetails.OPEN_MODE_FRIEND ) {
		}
		else if ( openMode == EnumDetails.OPEN_MODE_GUILD_MEMBER ) {

			var data = Mgr.friend.GetFriendList().Get(this._roleBriefInfo.playerid);
			if ( !data )
				powerList.push(EnumDetails.POWER_ADD_FRIEND);

			// 本人职位
			var personId = Mgr.player.mainPlayer.sid;
			var myMemberInfo = Mgr.guild.guildMembers.Get( personId );
			cc.assert(null != myMemberInfo, "myMemberInfo can't be nil!  personId: " + personId);
			var myJob = myMemberInfo.guildPowerLevel;

			// 查询的角色职位
			var otherPlayerId = this._roleBriefInfo.playerid;
			var memberInfo = Mgr.guild.guildMembers.Get( otherPlayerId );
			var otherJob = memberInfo.guildPowerLevel;

			switch (myJob) {
				case GuildEnum.MEMBER_GUILDER:
					if (otherJob == GuildEnum.MEMBER_GUILDER) {
					}
					else if (otherJob == GuildEnum.MEMBER_SECONDGUILDER) {
						powerList.push(EnumDetails.POWER_GUILD_BZCR);
						powerList.push(EnumDetails.POWER_GUILD_CZ);
						powerList.push(EnumDetails.POWER_GUILD_TCBP);
					}
					else if (otherJob == GuildEnum.MEMBER_ELITE) {
						powerList.push(EnumDetails.POWER_GUILD_BZCR);
						powerList.push(EnumDetails.POWER_GUILD_RMFBZ);
						powerList.push(EnumDetails.POWER_GUILD_CZ);
						powerList.push(EnumDetails.POWER_GUILD_TCBP);
					}
					else if (otherJob == GuildEnum.MEMBER_MENBER) {
						powerList.push(EnumDetails.POWER_GUILD_BZCR);
						powerList.push(EnumDetails.POWER_GUILD_RMJY);
						powerList.push(EnumDetails.POWER_GUILD_TCBP);
					}
					break;
				case GuildEnum.MEMBER_SECONDGUILDER:
					if (otherJob == GuildEnum.MEMBER_GUILDER) {
					}
					else if (otherJob == GuildEnum.MEMBER_SECONDGUILDER) {
					}
					else if (otherJob == GuildEnum.MEMBER_ELITE) {
						powerList.push(EnumDetails.POWER_GUILD_CZ);
						powerList.push(EnumDetails.POWER_GUILD_TCBP);
					}
					else if (otherJob == GuildEnum.MEMBER_MENBER) {
						powerList.push(EnumDetails.POWER_GUILD_RMJY);
						powerList.push(EnumDetails.POWER_GUILD_TCBP);
					}
					break;
			}
		}
		return powerList;
	},

	// 布局按钮
	_ResetPowerButton:function ( openMode ) {
		// 获取权限
		var powerList = this._GetRolePowers(openMode);
		var i = 0;
		for (  ; i != powerList.length; i++ ) {
			var power = powerList[i];
			var button;
			if ( i < this._powerButtonList.length) {
				button = this._powerButtonList[i];
			}
			else {
				button = new MUIButton();
				button.ParseJson(this.btnAddFriend.jsonobj);
				button.Init();
				button.retain();
				this._powerButtonList.push(button);
			}
			button.setTitleText( power );
			button.openMode = openMode;
			button.power = power;
			button.addClickEventListener(this._PowerHander);
			button.setPosition(this._powerButtonPos[i]);
			if ( !button.getParent() )
				this.addChild( button,1000 );//层级设高点避免被遮挡
		}
		for ( ; i < this._powerButtonList.length; i++ ) {
			var btn = this._powerButtonList[i];
			if ( btn.getParent() )
				btn.removeFromParent();
		}
	},

	_PowerHander:function (event) {
		switch( event.openMode ){
			case EnumDetails.OPEN_MODE_NORMAL:
				var id = event.parent._roleBriefInfo.playerid;
				if ( event.power == EnumDetails.POWER_ADD_FRIEND ) {
					Mgr.friend.SendReqApplyFriendMessage(id);
				}
				else if(event.power == EnumDetails.POWER_COMBAT_POWER){
					var panel = Mgr.uiMgr.ShowPanelByType(PHBDuiBiExt.PanelName);
					panel.InitPlayerInfo(event.parent._roleBriefInfo);
				}

				break;
			case EnumDetails.OPEN_MODE_GUILD_MEMBER:
				var id = event.parent._roleBriefInfo.playerid;
				if ( event.power == EnumDetails.POWER_ADD_FRIEND ) {
					Mgr.friend.SendReqApplyFriendMessage(id);
				}
				else if ( event.power == EnumDetails.POWER_GUILD_TCBP ) {
					Mgr.guild.SendReqGuildDeleteMemberMessage( id );
				}
				else {
					var job;
					if ( event.power == EnumDetails.POWER_GUILD_BZCR ) {
						job = GuildEnum.MEMBER_GUILDER;
					}
					else if ( event.power == EnumDetails.POWER_GUILD_RMFBZ ) {
						job = GuildEnum.MEMBER_SECONDGUILDER;
					}
					else if ( event.power == EnumDetails.POWER_GUILD_RMJY ) {
						job = GuildEnum.MEMBER_ELITE;
					}
					else if ( event.power == EnumDetails.POWER_GUILD_CZ ) {
						job = GuildEnum.MEMBER_MENBER;
					}
					Mgr.guild.SendReqGuildChangePowerLevelMessage( id, job )
				}
				break;
			case EnumDetails.OPEN_MODE_FRIEND:
				break;
			default:
				break;
		}
	},

	_ChangePanel:function ( type ){
		if( this.showType == type )
			return;
		for (var i = 0; i < this._btnArr.length; i++ )
		{
			if(this._btnArr[i].type == type)
			{
				this._btnArr[i].btn.SetButtonState("check");
				this._btnArr[i].btnStr.SetColor(EnumFontFormat.COMMON_COLOR01);
			}
			else
			{
				this._btnArr[i].btn.SetButtonState("uncheck");
				this._btnArr[i].btnStr.SetColor(EnumFontFormat.COMMON_COLOR06);
			}
		}

		if ( this.showPanel ){
			this.showPanel.visible = false;
			this.showPanel.OnHide();
		}


		var data;
		switch( type ){
			case -1:
				if ( !this.panelMgr[type] ) {
					var panel = new OtherRoleItemExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				data = this._roleBriefInfo;
				break;
			case EnumResline.HORSE:
			case EnumResline.DRAGON:
			case EnumResline.GUANGWU:
			case EnumResline.SHUTONG:
			case EnumResline.BAOQI:
				if ( !this.panelMgr[type] ) {
					var panel = new OtherRoleItem2Ext();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				data = this._reslineDataHash.Get(type);
				data.job = this._roleBriefInfo.job;
				break;
			default:
				break;
		}
		this.showType = type;
		this.showPanel = this.panelMgr[type];
		if ( this.showPanel ) {
			this.showPanel.SetData(data);
			this.showPanel.visible = true;
		}
	},

	_RepanelType:function (showType,openTyps) {
		var type = null;
		if ( openTyps.length == 0 )
			return type;

		for ( var i = 0; i != openTyps.length; i++ ) {
			if ( openTyps[i] == showType ){
				type = showType;
				break;
			}
		}
		if ( type == null ) {
			type = openTyps[0];
		}
		return type;
	},

	/**按钮重排*/
	_ReposBtns:function(){
		var buttons = [];
		var types = [];
		for (var i = 0; i < this._btnArr.length; i++ ) {
			var type = this._btnArr[i].type;
			var button = this._btnArr[i].btn;
			// 移除
			if ( button.parent )
				button.removeFromParent();

			// 角色
			if ( this._btnArr[i].type == -1 ) {
				buttons.push(button);
				types.push(type);
			}

			// // 战甲
			// if ( this._btnArr[i].type == 0  && this._roleBriefInfo.armorShowId > 0)
			// 	//attr.push(this._btnArr[i]);

			// 资源线
			for ( var j = 0; j != this._roleBriefInfo.reslineInfo.length; j++ ) {
				var reslineType = this._roleBriefInfo.reslineInfo[j].reslineType;
				if ( type == reslineType && this._roleBriefInfo.reslineInfo[j].reslineModelId > 0 ) {
					buttons.push(button);
					types.push(type);
					break;
				}
			}
		}
		
		for (var i = 0; i < buttons.length; i++ ) {
			buttons[i].setPosition(this._btnPosArr[i]);
			this.addChild(buttons[i]);
		}
		return types;
	},

	_GetReslineData:function () {
		this._reslineDataHash.Clear();
		for ( var i = 0; i != this._roleBriefInfo.reslineInfo.length; i++ ) {
			var reslineType = this._roleBriefInfo.reslineInfo[i].reslineType;
			var data = this._roleBriefInfo.reslineInfo[i];
			this._reslineDataHash.Put( reslineType, data );
		}
	},

	OnHide:function(){
		this._super();
		if( this.showPanel ){
			this.showPanel.OnHide();
			this.showPanel.visible = false;
		}
	}
} );
OtherRolePanelExt.PanelName = "OtherRolePanelExt";
PanelClassDic["OtherRolePanelExt"] = OtherRolePanelExt;
