var ShutongEquipPanelExt = ShutongEquipPanel.extend ( {
    _className:"ShutongEquipPanelExt",
    ctor:function(){
        this._super();
        ShutongEquipPanelExt._instance = this;
    },

    Init:function(){
        this._super();

        this.InitEquipGrids();

        this.btn1.addClickEventListener(function(){
            var mid = this._mgr.GetEquipModelId() ? 0 : this._mgr.GetModeIdByLayer(this._mgr.curShowLayer);
            this._mgr.SendReqReslineIllusionToGameMessage( mid );
        }.bind(this));
        this.btnShuxing.visible = false;
        this.btnShuxing.addClickEventListener(function(){
            //Mgr.uiMgr.HidePanelByType(ShuTongPanelExt.PanelName);
            OpenFuncUtil.OpenShenzhuang();
        }.bind(this));

        this.imgModel.y += 100;

        this._mgr = Mgr.resline.GetMgrByType(EnumResline.SHUTONG);
        //this._mgr.SetPanel( this );
    },

    InitEquipGrids:function(){
        this._gridEquipArr = [
            {obj: this.gridEquip,  type: EnumEquipPos.EQUIP_WEAPONS,    lab:this.labWuqi,},//武器0
            {obj: this.gridEquip2, type: EnumEquipPos.EQUIP_CLOTHES,    lab:this.labYifu,},//衣服1
            {obj: this.gridEquip3, type: EnumEquipPos.EQUIP_BRACELET_LEFT,      lab:this.labHushou ,},//护腿4
            {obj: this.gridEquip7, type: EnumEquipPos.EQUIP_HUFU_LEFT,  lab:this.labHufu,}, //左护符6
            {obj: this.gridEquip8, type: EnumEquipPos.EQUIP_RING_LEFT,  lab:this.labJiezhi,}, //左戒指8

            {obj: this.gridEquip4, type: EnumEquipPos.EQUIP_BELT,       lab:this.labToukui,},//头盔3
            {obj: this.gridEquip5, type: EnumEquipPos.EQUIP_SHOES,      lab:this.labXiezi,},//手镯2
            {obj: this.gridEquip6, type: EnumEquipPos.EQUIP_HUTUI,      lab:this.labHutui,}, //鞋子5
            {obj: this.gridEquip9, type: EnumEquipPos.EQUIP_HUFU_RIGHT, lab:this.labHufu1,}, //右护符7
            {obj: this.gridEquip10, type: EnumEquipPos.EQUIP_RING_RIGHT,lab:this.labJiezhi1,}, //右戒指9

            {obj: this.gridEquip11, type: EnumEquipPos.EQUIP_YITIAN,    lab:this.labYitian,}, //倚天
            {obj: this.gridEquip13, type: EnumEquipPos.EQUIP_TULONG,    lab:this.labTulong,}, //屠龙
            {obj: this.gridEquip12, type: EnumEquipPos.EQUIP_TAIJI,     lab:this.labTaiji,}, //太极
            {obj: this.gridEquip14, type: EnumEquipPos.EQUIP_QIANKUN,   lab:this.labQiankun,}, //乾坤
        ];
        var addFunc = function (nn) {
            nn.obj.InitGrid(GridTypeEnum.EQUIPWARED);
            nn.obj.setTouchEnabled(true);
            nn.obj.addClickEventListener(function (target) {
                if(!target.gridData){
                    return;
                }
                var gem = Mgr.gem.GetInlayStones(nn.type);
                var refine = DuanzaoUtil.GetRefineStoneHash(nn.obj.gridData.itemModelId);
                var equips = Mgr.equip.GetEquipsByType(EnumItemType.Equip_Shutong);
                var suit = SuitMakeUtil.GetSuitAttr(equips);

                var panel = Mgr.uiMgr.ShowPanelByType(EquipTipsPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
                panel.setLocalZOrder(10000);
                panel.Updatedata(nn.obj.gridData, nn.obj.gridType, {gem: gem, refine: refine, suit: suit});
            })
        };
        for (var i = 0; i < this._gridEquipArr.length; ++i) {
            addFunc(this._gridEquipArr[i]);
        }
    },

    OnShow:function(){
        this._super();
        GameEventMgr.AddEventListener(this,EnumEventType.GAME_EQUIP_CHANGED,function(){
            this.UpdateEquip();
            this.UpdateAttr();
        })

        this.UpdateView();
    },
    OnHide:function(){
        GameEventMgr.RemoveEventListener(this);
        this._super();
    },
    UpdateView:function(){
        this.UpdateEquip();
        this.UpdateAttr();
        this.UpdateModel();
        this.UpdateBtnState();
    },

    /// 更新装备栏
    UpdateEquip:function(){
        var equips = Mgr.equip.GetEquips();
        for (var i = 0; i < this._gridEquipArr.length; i++) {
            var v = this._gridEquipArr[i];
            v.obj.gridData = null;
            v.obj.Clean();
            v.lab.visible = true;

            var equip = Mgr.equip.GetEquipByType(EnumItemType.Equip_Shutong,v.type);
            if(equip){
                GridUtil.SetItemGrid(v.obj, equip, equip.itemModelId, false, null, false, false, false, false, null, true);
                v.lab.visible = false;
            }
        }
    },

    /// 更新属性栏
    UpdateAttr:function(){
        var reslineType = EnumResline.SHUTONG;
        var showkey = reslineType + "_" + Math.max(this._mgr.curShowLayer, 1) + "_" + this._mgr.GetCurShowStars();
        var psychicData = Q_resline_up.Get( showkey );
        var textName = psychicData ? psychicData.q_name : "???";

        var attr	= Mgr.attributeMgr.GetShutongAttributeData();
        var a		= attr.GetAttribute(EnumAttribute.ATTACK,			AttributeData.Fight) || 0;
        var d		= attr.GetAttribute(EnumAttribute.DEFEND,			AttributeData.Fight) || 0;
        var hp		= attr.GetAttribute(EnumAttribute.MAX_BASEHP,		AttributeData.Fight) || 0;
        var c		= attr.GetAttribute(EnumAttribute.CRIT,				AttributeData.Fight) || 0;
        var cb		= attr.GetAttribute(EnumAttribute.CRIT_DAMAGE_BONUS,AttributeData.Fight) || 0;
        var db		= attr.GetAttribute(EnumAttribute.DAMAGE_BONUS,		AttributeData.Fight) || 0;
        var dr		= attr.GetAttribute(EnumAttribute.DAMAGE_REDUCE,	AttributeData.Fight) || 0;
        cb = (cb / 100).toFixed(2) + "%";
        db = (db / 100).toFixed(2) + "%";
        dr = (dr / 100).toFixed(2) + "%";

        var fightPower = Mgr.attributeMgr.GetFightPowerWithAttrData(attr);

        UIUtil.ConnectLabelHtmlText(this.labName,[textName]);	// 名字
        UIUtil.ConnectLabelHtmlText(this.labNumber,[fightPower]);	// 战斗力
        UIUtil.ConnectLabelHtmlText(this.labAttack,[a]);	// 攻击
        UIUtil.ConnectLabelHtmlText(this.labDef,[d]);	// 防御
        UIUtil.ConnectLabelHtmlText(this.labHp,[hp]);	// 生命
        UIUtil.ConnectLabelHtmlText(this.labBaoji_Value,[c]);	// 暴击
        UIUtil.ConnectLabelHtmlText(this.labBaoji1_Value,[cb]);	// 暴击伤害
        UIUtil.ConnectLabelHtmlText(this.labJiacheng_Value,[db]);	// 伤害加成
        UIUtil.ConnectLabelHtmlText(this.labJianmian_Value1,[dr]);	// 伤害减免
    },
    /// 更新模型
    UpdateModel:function(){
        var showLayer = this._mgr.curShowLayer;
        if( !this._uiModel ){
            this._uiModel = new UIModel(showLayer, EnumResline.SHUTONG);
            this.imgModel.addChild(this._uiModel);
        }
        else{
            this._uiModel.SetModelId(showLayer);
        }
    },

    UpdateBtnState:function(){
        var str = this._mgr.GetEquipModelId() ? "休息" : "出战";
        this.btn1.setTitleText( str );
    },
} );
ShutongEquipPanelExt.getInstance = function(){
    var instance = ShutongEquipPanelExt._instance;
    if(instance && sys.isObjectValid(instance) && instance.visible){
        return instance;
    }
    return null;
};
ShutongEquipPanelExt.PanelName = "ShutongEquipPanelExt";
PanelClassDic["ShutongEquipPanelExt"] = ShutongEquipPanelExt;
