var GuajiSettingMainExt = GuajiSettingMain.extend ( {
	_className:"GuajiSettingMainExt",

	// // 自动拾取  (最高位-开关)
	// _PICKUP_EQUIP         :0x1,
	// _PICKUP_METARIAL      :0x2,
	// _PICKUP_TUJIAN        :0x4,
	// _PICKUP_STONE         :0x8,
	// _PICKUP_OTHER         :0x10,
    //
	// // 挂机范围
	// _HOOK_RANGE_SCREEN    :0x1,
	// _HOOK_RANGE_POINT     :0x2,
    //
	// // 脱机组队
	// _OFF_TEAM_INVITE      :0x1,
	// _OFF_TEAM_ACCEPT      :0x2,

	_pickBoxList:null,
	_hookBoxList:null,
	_offTeamBoxList:null,

	ctor:function(){
		this._super();
		this._pickBoxList = [];
		this._offTeamBoxList = [];
	},

	Init:function() {
		var self = this;
		GuajiSettingMain.prototype.Init.call(this);
		this._InitParam();
		// 自动拾取
		this.btnOFF.addClickEventListener(function (event){
			self.UsePickOnOff(0);  // 关闭全选
		});
		this.btnON.addClickEventListener(function (event){
			self.UsePickOnOff(1);  // 开启全选
		});
		var len = this._pickBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._pickBoxList[i].btn;
			button.type = this._pickBoxList[i].type;
			button.addClickEventListener(function (event){
				self.UsePickUp(event.type);
			});
		}

		// 挂机范围 -- 当前屏
		var len = this._hookBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._hookBoxList[i].btn;
			button.type = this._hookBoxList[i].type;
			button.addClickEventListener(function (event){
				self.UseHookRange(event.type);
			});
		}

		//自动释放技能
		this.sbtnGouxuan9.addClickEventListener(function (target) {
			self.UseAutoSkill();
        });

		// 自动买活
		this.btnOFF1.addClickEventListener(function (event){
			self.UseBuyRevive(1);
		});
		this.btnON1.addClickEventListener(function (event){
			self.UseBuyRevive(0);
		});

		// 脱机时间
		this.btnJia.addClickEventListener(function (event){
			self.UseTimeItem();
		});

		// 脱机队伍
		var len = this._offTeamBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._offTeamBoxList[i].btn;
			button.type = this._offTeamBoxList[i].type;
			button.addClickEventListener(function (event){
				var state = (event.GetState() == "check") ? 1 : 0;
				self.UseOffTeam(event, state);
			});
		}
	},

	_InitParam:function () {
		this._pickBoxList = [
			{btn:this.sbtnGouxuan,type:SettingConstant._PICKUP_EQUIP},
			{btn:this.sbtnGouxuan1,type:SettingConstant._PICKUP_METARIAL},
			{btn:this.sbtnGouxuan2,type:SettingConstant._PICKUP_TUJIAN},
			{btn:this.sbtnGouxuan3,type:SettingConstant._PICKUP_STONE},
			{btn:this.sbtnGouxuan4,type:SettingConstant._PICKUP_OTHER}
		];
		this._hookBoxList = [
			{btn:this.sbtnGouxuan5,type:SettingConstant._HOOK_RANGE_SCREEN},
			{btn:this.sbtnGouxuan6,type:SettingConstant._HOOK_RANGE_POINT}
		];
		this._offTeamBoxList = [
			{btn:this.sbtnGouxuan7,type:SettingConstant._OFF_TEAM_INVITE},
			{btn:this.sbtnGouxuan8,type:SettingConstant._OFF_TEAM_ACCEPT}
		];
	},
	UsePickOnOff:function (on_off) {
		this._ShowPickOnOff(on_off);

		var old_pick = Mgr.plugset.GetPlugSetInfo().pickup;
		var info = Mgr.plugset.GetPlugSetInfo();
		info.pickup = ((old_pick & 0x7f) | (on_off<<7));
		Mgr.plugset.SendReqPlugSetInfoMessage(info);
	},

	UsePickUp:function (pick) {
		//pick = parseInt(pick,2)
		var old_pick = Mgr.plugset.GetPlugSetInfo().pickup;
		var on_off = (old_pick>>7);
		var mark = (old_pick & 0x7f);
		if ( (mark & pick) > 0 ) // 取消勾选
			pick = mark - pick;
		else
			pick = mark + pick; // 勾选
		pick = (pick | (on_off<<7));

		this._ShowPickUp(pick);
		var info = Mgr.plugset.GetPlugSetInfo();
		info.pickup = pick;
		Mgr.plugset.SendReqPlugSetInfoMessage(info);
	},
	UseHookRange:function (range) {
		//range = parseInt(range,2).toString(10);

		this._ShowHookRange(range);
		var info = Mgr.plugset.GetPlugSetInfo();
		info.range = range;
		Mgr.plugset.SendReqPlugSetInfoMessage(info);
	},
	UseBuyRevive:function (auto) {
		this._ShowBuyRevive(auto);
		var info = Mgr.plugset.GetPlugSetInfo();
		info.autoBuyRevive = auto;
		Mgr.plugset.SendReqPlugSetInfoMessage(info);
	},
	UseTimeItem:function (){
		var item = ItemUtil.ItemIdToItem(102,1,1);
		ItemUtil.ShowTips(item,GridTypeEnum.BACKPACK);
	},
	UseOffTeam:function (button, state) {
		var info = Mgr.plugset.GetPlugSetInfo();
		if ( button.type == SettingConstant._OFF_TEAM_INVITE ) {
			info.autoInvite = state;
			this._ShowOffTeamInvite(state);
		}
		else if ( button.type == SettingConstant._OFF_TEAM_ACCEPT ) {
			info.autoAgree = state;
			this._ShowOffTeamAccept(state);
		}
		Mgr.plugset.SendReqPlugSetInfoMessage(info);
	},

    UseAutoSkill:function () {
        var info = Mgr.plugset.GetPlugSetInfo();
        var state = this.sbtnGouxuan9.GetState();
        cc.log("state      " + state);
        info.skillauto = state == MUICheckBox.STATE_CHECK ? 1 : 0;
        Mgr.plugset.SendReqPlugSetInfoMessage(info);
    },

	_ShowPickOnOff:function (on_off) {
		var visible = (on_off > 0)?true:false;
		this.btnON.visible = !visible;
		this.btnOFF.visible = visible;
	},

	// 自动拾取
	_ShowPickUp:function (pick) {
		var count = 0;
		var len = this._pickBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._pickBoxList[i].btn;
			var type = this._pickBoxList[i].type;
			//var sample = parseInt(type,2).toString(10);

			var mark = (pick & 0x7f);
			if ( (mark & type) > 0 )
			{
				button.SetButtonState("check");
				count++;
			}
			else
			{
				button.SetButtonState( "uncheck" );
			}
		}
		if(count == len)
		{
			this._ShowPickOnOff(0);
		}
	},

	// 挂机范围
	_ShowHookRange:function (range) {
		for ( var i = 0; i != this._hookBoxList.length; i++ ) {
			var button = this._hookBoxList[i].btn;
			var type = this._hookBoxList[i].type;
			//var sample = parseInt(type,2).toString(10);
			if ( (range & type) > 0 )
				button.SetButtonState( "check" );
			else
				button.SetButtonState( "uncheck" );
		}
	},

	//自动释放技能
	_ShowAutoSkill:function (state) {
        if ( state > 0 )
            this.sbtnGouxuan9.SetButtonState( "check" );
        else
            this.sbtnGouxuan9.SetButtonState( "uncheck" );
    },

	// 自动买活
	_ShowBuyRevive:function (state) {
		var auto = (state > 0) ? true : false;
		this.btnOFF1.visible = !auto;
		this.btnON1.visible = auto;
	},
	// 更新脱机挂时间
	_ShowOffHookTime:function () {
		 UIUtil.ConnectLabelHtmlText(this.labNumber, [TextUtil.SecondToHMS2( Mgr.player._exitRemainTime )])
	},
	// 脱机组队邀请
	_ShowOffTeamInvite:function (state) {
		if ( state > 0 )
			this.sbtnGouxuan7.SetButtonState( "check" );
		else
			this.sbtnGouxuan7.SetButtonState( "uncheck" );
	},
	// 脱机队伍接受邀请
	_ShowOffTeamAccept:function (state) {
		if ( state > 0 )
			this.sbtnGouxuan8.SetButtonState( "check" );
		else
			this.sbtnGouxuan8.SetButtonState( "uncheck" );
	},

	OnShow:function () {
		var info = Mgr.plugset.GetPlugSetInfo();
		// 自动拾取
		this._ShowPickUp(info.pickup);
		// 挂机范围
		this._ShowHookRange(info.range);
		this._ShowAutoSkill(info.skillauto);
		// 自动买活
		this._ShowBuyRevive(info.autoBuyRevive);
		//脱机挂时间
		this._ShowOffHookTime();
		//脱机组队
		this._ShowOffTeamInvite(info.autoInvite);
		this._ShowOffTeamAccept(info.autoAgree);
	},
} );
GuajiSettingMainExt.PanelName = "GuajiSettingMainExt";
PanelClassDic["GuajiSettingMainExt"] = GuajiSettingMainExt;
