var SetTypeEnum = SetTypeEnum || {};
SetTypeEnum.SETTING_HOOK = 1;
SetTypeEnum.SETTING_SYSTERM = 2;
SetTypeEnum.SETTING_CHAT = 3;
SetTypeEnum.SETTING_ACCOUNT = 4;

var SettingConstant = SettingConstant || {};
// 频道显示
SettingConstant._CHAT_CHANNEL_SYS = 0x1;
SettingConstant._CHAT_CHANNEL_WORLD = 0x2;
SettingConstant._CHAT_CHANNEL_GUILD = 0x4;
SettingConstant._CHAT_CHANNEL_TEAM = 0x8;
SettingConstant._CHAT_CHANNEL_PRIVATE = 0x10;

// 自动播放 -- wifi
SettingConstant._CHAT_WIFI_PRIVATE = 0x1;
SettingConstant._CHAT_WIFI_WORLD = 0x2;
SettingConstant._CHAT_WIFI_GUILD = 0x4;
SettingConstant._CHAT_WIFI_TEAM = 0x8;

// 自动播放 -- 4g
SettingConstant._CHAT_4G_PRIVATE = 0x1;
SettingConstant._CHAT_4G_WORLD = 0x2;
SettingConstant._CHAT_4G_GUILD = 0x4;
SettingConstant._CHAT_4G_TEAM = 0x8;

// 自动拾取  (最高位-开关)
SettingConstant._PICKUP_EQUIP = 0x1;
SettingConstant._PICKUP_METARIAL= 0x2;
SettingConstant._PICKUP_TUJIAN = 0x4;
SettingConstant._PICKUP_STONE = 0x8;
SettingConstant._PICKUP_OTHER = 0x10;

// 挂机范围
SettingConstant._HOOK_RANGE_SCREEN = 0x1;
SettingConstant._HOOK_RANGE_POINT = 0x2;

// 脱机组队
SettingConstant._OFF_TEAM_INVITE = 0x1;
SettingConstant._OFF_TEAM_ACCEPT = 0x2;

// 音量、音效
SettingConstant._SYS_MUSIC = 0x1;
SettingConstant._SYS_SOUND = 0x2;

// 性能
SettingConstant._SYS_PROPERTY_H = 0x1;
SettingConstant._SYS_PROPERTY_M = 0x2;
SettingConstant._SYS_PROPERTY_L = 0x4;
SettingConstant._SYS_PROPERTY_LL = 0x8;

// 屏蔽玩家
SettingConstant._SYS_SHIELDER_PLAYER = 0x1;
SettingConstant._SYS_SHIELDER_MONSTER = 0x2;
SettingConstant._SYS_SHIELDER_TITLE = 0x4;

// 交互
SettingConstant._SYS_REFUSE_FRIEND = 0x1;
SettingConstant._SYS_REFUSE_CHAT = 0x2;
SettingConstant._SYS_REFUSE_TEAM = 0x4;
SettingConstant._SYS_REFUSE_GUILD = 0x8;


var SettingPanelExt = SettingPanel.extend ( {
	_className:"SettingPanelExt",

	panelMgr:null,
	showPanel:null,
	showType:null,

	_btnArr:null,

	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = -28;
		this._btnArr = [];
		this.panelMgr = {};
		this.showType = SetTypeEnum.SETTING_HOOK;
	},

	Init:function() {
		var self = this;
		SettingPanel.prototype.Init.call(this);
		this._InitParam();

		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});

		this.sbtnGuaji.addClickEventListener(function (event){
			self.ChangePanel( SetTypeEnum.SETTING_HOOK );
		});
		this.sbtnXitong.addClickEventListener(function (event){
			self.ChangePanel( SetTypeEnum.SETTING_SYSTERM );
		});
		this.sbtnChat.addClickEventListener(function (event){
			self.ChangePanel( SetTypeEnum.SETTING_CHAT );
		});
		this.sbtnZhanghao.addClickEventListener(function (event){
			self.ChangePanel( SetTypeEnum.SETTING_ACCOUNT );
		});
	},

	_InitParam:function () {
		this._btnArr = [
			{btn:this.sbtnGuaji,type:SetTypeEnum.SETTING_HOOK},
			{btn:this.sbtnXitong,type:SetTypeEnum.SETTING_SYSTERM},
			{btn:this.sbtnChat,type:SetTypeEnum.SETTING_CHAT},
			{btn:this.sbtnZhanghao,type:SetTypeEnum.SETTING_ACCOUNT},
		];
	},

	ChangePanel:function ( type ){
		// statues
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			if ( this._btnArr[i].type == type )
				this._btnArr[i].btn.SetButtonState( "check" );
			else
				this._btnArr[i].btn.SetButtonState( "uncheck" );
		}

		if ( this.showPanel ) {
			this.showPanel.visible = false;
		}

		switch( type ){
			case SetTypeEnum.SETTING_HOOK:
				if ( !this.panelMgr[type] ) {
					var panel = new GuajiSettingMainExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case SetTypeEnum.SETTING_SYSTERM:
				if ( !this.panelMgr[type] ) {
					var panel = new SystemSettingMainExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case SetTypeEnum.SETTING_CHAT:
				if ( !this.panelMgr[type] ) {
					var panel = new ChatSettingMainExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case SetTypeEnum.SETTING_ACCOUNT:
				if ( !this.panelMgr[type] ) {
					var panel = new AccountSettingMainExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			default:
				break;
		}
		this.showType = type;
		this.showPanel = this.panelMgr[type];
		if ( this.showPanel ) {
			this.showPanel.OnShow();
			this.showPanel.visible = true;
		}
	},

	OnShow:function () {
		this.ChangePanel( this.showType );
	},
} );
SettingPanelExt.PanelName = "SettingPanelExt";
PanelClassDic["SettingPanelExt"] = SettingPanelExt;