var SystemSettingMainExt = SystemSettingMain.extend ( {
	_className:"SystemSettingMainExt",

	// // 音量、音效
	// _SYS_MUSIC                 		:0x1,
	// _SYS_SOUND                		:0x2,
    //
	// // 性能
	// _SYS_PROPERTY_H                 :0x1,
	// _SYS_PROPERTY_M                 :0x2,
	// _SYS_PROPERTY_L                 :0x4,
	// _SYS_PROPERTY_LL                :0x8,
    //
	// // 屏蔽玩家
	// _SYS_SHIELDER_PLAYER            :0x1,
    // _SYS_SHIELDER_MONSTER           :0x2,
    //
	// // 交互
	// _SYS_REFUSE_FRIEND              :0x1,
	// _SYS_REFUSE_CHAT                :0x2,
	// _SYS_REFUSE_TEAM                :0x4,
	// _SYS_REFUSE_GUILD               :0x8,

	_propertyBoxList:null,
	_shielderBoxList:null,
	_refuseBoxList:null,

	ctor:function(){
		this._super();
		this._propertyBoxList = [];
		this._shielderBoxList = [];
		this._refuseBoxList = [];
	},

	Init:function() {
		var self = this;
		SystemSettingMain.prototype.Init.call(this);
		this._InitParam();

		// 音乐
		this.sbtnGouxuan.addClickEventListener(function (event){
			self.UseMusic();
		});
		// 音效
		this.sbtnGouxuan1.addClickEventListener(function (event){
			self.UseMusicSound();
		});

		// 性能
		var len = this._propertyBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._propertyBoxList[i].btn;
			button.type = this._propertyBoxList[i].type;
			button.addClickEventListener(function (event){
				self.UseProperty(event.type);
			});
		}

		// 屏蔽
		var len = this._shielderBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._shielderBoxList[i].btn;
			button.type = this._shielderBoxList[i].type;
			button.addClickEventListener(function (event){
				self.UseShield(event.type);
			});
		}

		// 交互
		var len = this._refuseBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._refuseBoxList[i].btn;
			button.type = this._refuseBoxList[i].type;
			button.addClickEventListener(function (event){
				self.UseRefuse(event.type);
			});
		}

		// slider
		this._CreateSlider(this.img1,this.progJindutiao);
		this._CreateSlider(this.img2,this.progJindutiao1);

	},

	_InitParam:function () {
		this.labRate1.visible = false;
		this.img1.type = SettingConstant._SYS_MUSIC;
		this.img2.type = SettingConstant._SYS_SOUND;
		this._propertyBoxList = [
			{btn:this.sbtnGouxuan2, type:SettingConstant._SYS_PROPERTY_H},
			{btn:this.sbtnGouxuan3, type:SettingConstant._SYS_PROPERTY_M},
			{btn:this.sbtnGouxuan4, type:SettingConstant._SYS_PROPERTY_L},
			{btn:this.sbtnGouxuan5, type:SettingConstant._SYS_PROPERTY_LL},
		];
		this._shielderBoxList = [
			{btn:this.sbtnGouxuan6, type:SettingConstant._SYS_SHIELDER_PLAYER},
			{btn:this.sbtnGouxuan7, type:SettingConstant._SYS_SHIELDER_MONSTER},
			{btn:this.sbtnGouxuan71, type:SettingConstant._SYS_SHIELDER_TITLE},
		];
		this._refuseBoxList = [
			{btn:this.sbtnGouxuan9, type:SettingConstant._SYS_REFUSE_FRIEND},
			{btn:this.sbtnGouxuan10, type:SettingConstant._SYS_REFUSE_CHAT},
			{btn:this.sbtnGouxuan11, type:SettingConstant._SYS_REFUSE_TEAM},
			{btn:this.sbtnGouxuan12, type:SettingConstant._SYS_REFUSE_GUILD},
		];
	},

	// 音乐
	UseMusic:function () {
		var music = Mgr.plugset.GetSysSetInfo().music;

		// 最高位--总开关
		var on_off = (music>>7);
		// 低位--音量数值
		var volume = music & 0x7f
		on_off = (on_off > 0) ? 0 : 1;  // 取反
		music = (on_off<<7)|volume;

		this._ShowMusic( music );
		var info = Mgr.plugset.GetSysSetInfo();
		info.music = music;
		Mgr.plugset.SendReqSetMenuStatusMessage(info);
	},
	_ShowMusic:function (music) {
		var on_off = (music>>7);
		var volume = music & 0x7f;
		var state = on_off > 0 ? "check" : "uncheck";
		this.sbtnGouxuan.SetButtonState(state);

		Mgr.gameSoundMgr.StartMusic(on_off > 0);
	},

	// 音效
	UseMusicSound:function () {
		var sound = Mgr.plugset.GetSysSetInfo().sound;

		// 最高位--总开关
		var on_off = (sound>>7);
		// 低位--音量数值
		var volume = sound & 0x7f
		on_off = (on_off > 0) ? 0 : 1;  // 取反
		sound = (on_off<<7)|volume;

		this._ShowMusicSound( sound );
		var info = Mgr.plugset.GetSysSetInfo();
		info.sound = sound;
		Mgr.plugset.SendReqSetMenuStatusMessage(info);
	},
	_ShowMusicSound:function (sound) {
		var on_off = (sound>>7);
		var volume = sound & 0x7f;
		var state = on_off > 0 ? "check" : "uncheck";
		this.sbtnGouxuan1.SetButtonState(state);

		Mgr.gameSoundMgr.StartSound(on_off > 0);
	},

	// 性能
	UseProperty:function (property) {
		//property = parseInt(property,2).toString(10);

		this._ShowProperty(property);
		var info = Mgr.plugset.GetSysSetInfo();
		info.performance = property;
		Mgr.plugset.SendReqSetMenuStatusMessage(info);
	},
	_ShowProperty:function (property) {
		for ( var i = 0; i != this._propertyBoxList.length; i++ ) {
			var button = this._propertyBoxList[i].btn;
			var type = this._propertyBoxList[i].type;
			//var sample = parseInt(type,2).toString(10);
			if ( (property & type) > 0 )
				button.SetButtonState( "check" );
			else
				button.SetButtonState( "uncheck" );
		}
	},

	// 屏蔽
	UseShield:function (shield) {
		//shield = parseInt(shield,2)
		var old_shield = Mgr.plugset.GetSysSetInfo().shield;
		if ( (old_shield & shield) > 0 ) // 取消勾选
            shield = old_shield - shield;

		else
            shield = old_shield + shield; // 勾选


		this._ShowShield(shield);
		var info = Mgr.plugset.GetSysSetInfo();
		info.shield = shield;
		Mgr.plugset.SendReqSetMenuStatusMessage(info);
	},
	_ShowShield:function (shield) {
		var len = this._shielderBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._shielderBoxList[i].btn;
			var type = this._shielderBoxList[i].type;

			if ( (shield & type) > 0 )
				button.SetButtonState("check");
			else
				button.SetButtonState( "uncheck" );
		}
	},

	// 交互
	UseRefuse:function (type) {
		var refuse;
		var info = Mgr.plugset.GetSysSetInfo();
		if ( type == SettingConstant._SYS_REFUSE_FRIEND ) {
			refuse = Mgr.plugset.GetSysSetInfo().banAddFriend;
			refuse = (refuse > 0) ? 0 : 1;  // 取反
			info.banAddFriend = refuse;
		}
		else if ( type == SettingConstant._SYS_REFUSE_CHAT ) {
			refuse = Mgr.plugset.GetSysSetInfo().banPrivateChat;
			refuse = (refuse > 0) ? 0 : 1;  // 取反
			info.banPrivateChat = refuse;
		}
		else if ( type == SettingConstant._SYS_REFUSE_TEAM ) {
			refuse = Mgr.plugset.GetSysSetInfo().banInviteTeam;
			refuse = (refuse > 0) ? 0 : 1;  // 取反
			info.banInviteTeam = refuse;
		}
		else if ( type == SettingConstant._SYS_REFUSE_GUILD ) {
			refuse = Mgr.plugset.GetSysSetInfo().banInviteGuild;
			refuse = (refuse > 0) ? 0 : 1;  // 取反
			info.banInviteGuild = refuse;
		}
		this._ShowRefuse( type,refuse );
		Mgr.plugset.SendReqSetMenuStatusMessage(info);
	},
	_ShowRefuse:function (type,refuse) {
		var button;
		var len = this._refuseBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			if ( type ==  this._refuseBoxList[i].type) {
				button = this._refuseBoxList[i].btn;
				break;
			}
		}
		var state = refuse > 0 ? "check" : "uncheck";
		if ( button )
			button.SetButtonState(state);
	},

	_ShowSerRole:function () {
		var name = GameConfig.current.NAME + "_" + GameConfig.current.USER_NAME + "_ID:" + Mgr.player.mainPlayer.sid.toGID().toString() ;
		UIUtil.ConnectLabelHtmlText(this.labCue, [name]);
	},

	OnShow:function () {
		var info = Mgr.plugset.GetSysSetInfo();
		this._ShowMusic(info.music);
		var volume = (info.music)&0x7f;
		this._SetPercent(volume, this.img1,this.progJindutiao);
		volume = (info.sound)&0x7f;
		this._ShowMusicSound(info.sound);
		this._SetPercent(volume, this.img2,this.progJindutiao1);

		this._ShowProperty(info.performance);
		this._ShowShield(info.shield);
		this._ShowRefuse( SettingConstant._SYS_REFUSE_FRIEND, info.banAddFriend);
		this._ShowRefuse(SettingConstant._SYS_REFUSE_TEAM, info.banInviteTeam);
		this._ShowRefuse(SettingConstant._SYS_REFUSE_GUILD, info.banInviteGuild);
		this._ShowRefuse(SettingConstant._SYS_REFUSE_CHAT, info.banPrivateChat);
		this._ShowSerRole();
	},

	//****************  滑动条相关  *********************
	_CreateSlider:function (imgbar,prossbar) {
		var self = this;
		imgbar.setTouchEnabled(true);
		imgbar.setSwallowTouches(true);
		imgbar.addTouchEventListener( function (target,state)
		{
			if (state == ccui.Widget.TOUCH_BEGAN)
			{
				target.pp = target.getTouchBeganPosition();
				self._ShowVolume(true, imgbar);
			}
			else if(state == ccui.Widget.TOUCH_ENDED)
			{
				self._ShowVolume(false, imgbar);
				self._StoreVolume(imgbar);
			}
			else if(state == ccui.Widget.TOUCH_CANCELED)
			{
				self._ShowVolume(false, imgbar);
				self._StoreVolume(imgbar);
			}
			else if(state == ccui.Widget.TOUCH_MOVED)
			{
				var pos= target.getTouchMovePosition();
				var distance = pos.x - target.pp.x ;
				imgbar.x += distance;
				target.pp.x += distance;
				if ( imgbar.x + imgbar.width/2 > imgbar.parent.width )
					imgbar.x = imgbar.parent.width - imgbar.width/2;
				if ( imgbar.x + imgbar.width/2 < 0 )
					imgbar.x = 0 - imgbar.width/2;
				self._ShowVolume(true, imgbar);

				var prossLen = imgbar.x + imgbar.width/2;
				var rate = parseFloat(prossLen / imgbar.parent.width) * 100;
				prossbar.setPercent(rate);
			}
		} );

		prossbar.setTouchEnabled(true);
		prossbar.addTouchEventListener( function (target,state)
		{
			if (state == ccui.Widget.TOUCH_BEGAN)
			{
				target.pp = target.getTouchBeganPosition();
				target.pp = imgbar.parent.convertToNodeSpace(target.pp);
				var prossLen = target.pp.x;
				var rate = parseFloat(prossLen / imgbar.parent.width) * 100;
				self._SetPercent(rate, imgbar, prossbar);
				self._ShowVolume(true, imgbar);
			}
			else if(state == ccui.Widget.TOUCH_ENDED)
			{
				self._ShowVolume(false, imgbar);
				self._StoreVolume(imgbar);
			}
			else if(state == ccui.Widget.TOUCH_CANCELED)
			{
				self._ShowVolume(false, imgbar);
				self._StoreVolume(imgbar);
			}
		} );
	},

	/***
	 * 设置_SetMusicPercent
	 * @param rate  (0-100)
	 * @private
	 */
	_SetPercent:function (rate, imgbar, prossbar) {
		if ( rate < 0 )
			rate = 0;
		if ( rate > 100 )
			rate = 100;
		var len = imgbar.parent.width;
		var bar_x = len * rate / 100;
		imgbar.x = bar_x - imgbar.width/2;
		prossbar.setPercent(rate);
	},

	_ShowVolume:function (visible, imgbar) {
		if ( !imgbar.label ) {
			var icon = new MUILabel();
			icon.ParseJson(this.labRate1.jsonobj);
			icon.Init();
			icon.setPosition(this.labRate1.getPosition());
			imgbar.addChild(icon, 1, 20);
			imgbar.label = icon;
		}
		imgbar.label.visible = visible;
		if ( visible ) {
			var prossLen = imgbar.x + imgbar.width / 2;
			var rate = parseFloat(prossLen / imgbar.parent.width) * 100;
			this._SetSystemVolume(imgbar,rate);
			rate = Math.floor(rate) + "%";
			imgbar.label.SetString(rate);
		}
	},
	_SetSystemVolume:function(target, rate)
	{
		var value = rate/100;
		if(target.type == SettingConstant._SYS_MUSIC)//背景音乐
		{
			Mgr.gameSoundMgr.SetBackgroundVolume(value);
		}
		else
		{
			Mgr.gameSoundMgr.SetEffectVolume(value);
		}
	},
	_StoreVolume:function (imgbar) {
		// 保存音量
		var prossLen = imgbar.x + imgbar.width/2;
		var volume = parseFloat(prossLen / imgbar.parent.width) * 100;

		var ifSame = false;
		var info = Mgr.plugset.GetSysSetInfo();
		if ( imgbar.type == SettingConstant._SYS_MUSIC ) {
			var music = info.music;
			var on_off = (music>>7);
			info.music = (on_off<<7)|volume;
			if ( (music & 0x7f) == volume )
				ifSame = true;
		}
		else if ( imgbar.type == SettingConstant._SYS_SOUND ) {
			var sound = info.sound;
			var on_off = (sound>>7);
			info.sound = (on_off<<7)|volume;
			if ( (sound & 0x7f) == volume )
				ifSame = true;
		}
		if ( !ifSame )
			Mgr.plugset.SendReqSetMenuStatusMessage(info);
	},

} );
SystemSettingMainExt.PanelName = "SystemSettingMainExt";
PanelClassDic["SystemSettingMainExt"] = SystemSettingMainExt;
