var ShopUtil={
    OnQuickBuyItemCallback:function(callback){
        GameEventMgr.RemoveEventListener(this.$target);
        this.$target.removeFromParent()
        this.$target = null

        callback()
    },
    /// 快速购买
    QuickBuyItem:function(itemId,auto,callback,failCb){
        var shopType = EnumShopType.GOLD_SHOP
        var list = Mgr.shop.GetGoodsByHs(shopType)

        var goodsInfo = list.find(v=>v.itemModelId == itemId)

        if(!goodsInfo){
            if(failCb) failCb("商品不存在")
            return
        }
        goodsInfo.shopNum = shopType

        if(callback){
            if(!sys.isObjectValid(this.$target)){
                this.$target = new cc.Node()
                cc.director.getRunningScene().addChild(this.$target)
            }
            GameEventMgr.AddEventListener(this.$target,new ResBuyItemResultMessage().getId(),this.OnQuickBuyItemCallback.bind(this,callback))
        }

        /// 自动购买
        if(auto){
            let num = 1

            let moneyType = EnumShopType.BINDGOLD_SHOP
            let bindMoney = ShopUtil.GetMoneyByShop(EnumShopType.BINDGOLD_SHOP);
            let money = ShopUtil.GetMoneyByShop(EnumShopType.GOLD_SHOP);
            /// 优先绑定
            if(bindMoney >= goodsInfo.price){
                moneyType = EnumShopType.BINDGOLD_SHOP
            }else{
                moneyType = EnumShopType.GOLD_SHOP
            }

            money = moneyType == EnumShopType.GOLD_SHOP ? money : bindMoney;

            if(goodsInfo.price > money){
                if(failCb && failCb("钱不够")) return;
                //TODO
                AlertExt.NoEnoughGold(goodsInfo.price - money);
                return
            }

            Mgr.shop.SendReqBuyItemMessage(
                goodsInfo.shopNum,
                goodsInfo.itemModelId,
                goodsInfo.shopItemId,
                goodsInfo.shopItemSid,
                goodsInfo.moneyInfo,
                ShopUtil.GetMoneyTypeByShop(moneyType),
                num
            );
        }else{
            let p = Mgr.uiMgr.ShowPanelByType( BuyPanelExt.PanelName,UIMgr.PANEL_LAYER_POP);
            if(p) p.SetData(goodsInfo);
        }
    },
	//ShopUtil
	SHOP_TYPE_LIST:[1,2,3,4,5,7],
		GetImageRes:function(type) {
			var str ="";
			switch (type)
			{
			case 1:
                str =ResUrl.GetItemIconKey(-1);
				return str;
			case 2:
                str =ResUrl.GetItemIconKey(-2);
				return str;
			case 3:
				str =ResUrl.GetItemIconKey(-4);
				return str;
			case 4:
				str =ResUrl.GetItemIconKey(-8);
				return str;
			case  5:
				str = ResUrl.GetItemIconKey(-5);
				return str;
			case  6:
				str = ResUrl.GetItemIconKey(-12);
				return str;
			case  7:
				str = ResUrl.GetItemIconKey(-1);
				return str;
			case  8:
				str = ResUrl.GetItemIconKey(509011);
				return str;
			}
		},

	//GetGoodsInfo
	ParseMoneyInfo:function(goods)
	{
		var goosInfo=Q_item.Get(goods.item.mod);

		if(goosInfo) {
			for ( var key in goods ){
				if ( key == "moneyInfo" || key == "_instanceId" )
					continue;
				if (typeof goods[key] == "function")
					continue;

				goosInfo[key] = goods[key];
			}

			goosInfo.moneyType = [];
			goosInfo.originalPrice = [];
			goosInfo.actualPrice = [];
			var arry = JSON.parse(goods.moneyInfo);
			for (var i = 0; i < arry.length; i++)
			{
				goosInfo.moneyType.push(arry[i][0]);
				goosInfo.originalPrice.push(arry[i][1]);
				goosInfo.actualPrice.push(arry[i][1] * (10000 - goosInfo.discount)/10000);
			}
			return goosInfo;
		}
		return goosInfo;
	},
	GetMoneyByShop:function(id){
		if(id == EnumShopType.EXCHANGE_SHOP) // 兑换商城使用背包中的物品  不是货币
			return Mgr.backpack.GetItemNumber(EnumMoney.EXCHANGE);
		else
			return Mgr.player.mainPlayer.attributeData.GetAttribute(ShopUtil.GetMoneyTypeByShop(id),AttributeData.Money);
	},
    GetMoneyByType:function(type){
        return Mgr.player.mainPlayer.attributeData.GetAttribute(type,AttributeData.Money);
    },
    GetMoneyTypeByShop:function (id) {
        switch (id){
            case 1:
                return EnumMoney.GOLD;
                break;
            case 2:
                return EnumMoney.TIME_GOLD;
                break;
            case 3:
                return EnumMoney.PRESTIGE;
                break;
            case 4:
                return EnumMoney.GONGXUN;
                break;
			case 5:
				return EnumMoney.HONOR;
                break;
            case 6:
                return EnumMoney.CRYSTAL;
                break;
            case 7:
                return EnumMoney.GOLD;
                break;
            case 8:
                return EnumMoney.EXCHANGE;
                break;
            case 9:
                return EnumMoney.TIME_GOLD;
                break;
        }
    },
    GetMoneyNameByType:function (type) {
        switch (type){
            case EnumMoney.GOLD:
                return "充值元宝";
            case EnumMoney.BIND_GOLD:
                return "元宝";
            case EnumMoney.EXP:
                return "经验";
            case EnumMoney.PRESTIGE:
                return "声望";
            case EnumMoney.HONOR:
                return "荣誉";
            case  EnumMoney.GONGXUN:
                return "功勋";
            case EnumMoney.TIME_GOLD:
                return "元宝";
            case EnumMoney.GUILDDEVOTE:
                return "帮会贡献度";
            case EnumMoney.CRYSTAL:
                return "水晶";
            case EnumMoney.EXCHANGE:
                return "红色装备兑换券";
        }
    },
}

var EnumShopType = EnumShopType || {
		GOLD_SHOP:1,		//充值元宝商城
		BINDGOLD_SHOP:2,	//元宝商城
		PRESTIGE_SHOP:3,	//声望商城
		GONGXUN_SHOP:4,     //功勋商城
    	HONOR_SHOP:5,		//荣誉商城
		CRYSTAL_SHOP:6,		//水晶商城
		TIME_SHOP:7,		//限时商城
		EXCHANGE_SHOP:8,	//兑换商城
		TIMEGOLD_SHOP:9,	//元宝商城
	}