///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//OnlineRewardInfo 在线奖励信息

// 请求消息
//154201,ReqSignInfoToGame 请求签到信息 
//154202,ReqSignToGame 请求签到(签到就发奖励)
//154203,ReqRepairSignToGame 请求补签(签到就发奖励)
//154204,ReqRechargeSignToGame 请求充值签到
//154206,ReqGetOnlineRewardsToGame 请求领取在线奖励 
//154207,ReqOpenOnlineRewardsToGame 请求打开在线奖励面板 
//154208,ReqGetActivityOffLineRewardsToGame 请求领取离线活动奖励

// 接收消息
//154101,ResSendSignInfoToClient 发送签到信息 
//154102,ResSendRechargeSignInfoToClient 发送充值签到信息 
//154104,ResOnlineRewardsToClient 发送在线奖励信息
//154105,ResExtractRewardToClient 发送本次抽奖的结果
//154106,ResActivityOffLineToClient 发送离线活动信息


var OnlineRewardInfo = cc.Class.extend({
	ctor:function(){
		this.timetype = 0; // 时间类型,索引（300s，900s。。。。）
        this.itemModelid = 0; // 获取的奖励id
        this.itemnum = 0; // 获取的奖励数量num
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.timetype);
        _buf.WriteVarInt(this.itemModelid);
        _buf.WriteVarInt(this.itemnum);
	},
	
	reading:function( _buf ){
		this.timetype = _buf.ReadVarInt();
        this.itemModelid = _buf.ReadVarInt();
        this.itemnum = _buf.ReadVarInt();
	},
});
////////////////////
// 发送签到信息  //
////////////////////
var ResSendSignInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.signNum = 0; // 累计签到天数
        this.isSign = 0; // 今天是否签到(0没有1签过了)
        this.rechargeSign = 0; // 今天是否充值签到(0没有1签过了)
        this.signSumAward = 0; // 累计奖励信息(1代表第1天已领取)
        this.repairNums = 0; // 本月已补签次数
	},

	getId:function(){
		return 154101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.signNum);
        _buf.WriteByte(this.isSign);
        _buf.WriteByte(this.rechargeSign);
        _buf.WriteByte(this.signSumAward);
        _buf.WriteByte(this.repairNums);
	},
	
	reading:function( _buf ){
        this.signNum = _buf.ReadByte();
        this.isSign = _buf.ReadByte();
        this.rechargeSign = _buf.ReadByte();
        this.signSumAward = _buf.ReadByte();
        this.repairNums = _buf.ReadByte();
	},

	action:function(){
		Mgr.sign.RecvResSendSignInfoToClientMessage(this);
	},

});
////////////////////
// 发送充值签到信息  //
////////////////////
var ResSendRechargeSignInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.mark = 0; // 已领取奖励天数(位运算，1第一天已领取)
        this.allRechargeDays = 0; // 本月总充值天数
	},

	getId:function(){
		return 154102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.mark);
        _buf.WriteByte(this.allRechargeDays);
	},
	
	reading:function( _buf ){
        this.mark = _buf.ReadVarInt();
        this.allRechargeDays = _buf.ReadByte();
	},

	action:function(){
		Mgr.sign.RecvResSendRechargeSignInfoToClientMessage(this);
	},

});
////////////////////
// 发送在线奖励信息 //
////////////////////
var ResOnlineRewardsToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.onlinetime = 0; // 今日在线的累计时间（秒）
        this.infos = []; // 已抽取奖励 OnlineRewardInfo
	},

	getId:function(){
		return 154104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.onlinetime);
        _buf.WriteShort( this.infos.length );
        for (var i = 0; i < this.infos.length; i++) {
            _buf.WriteBean(this.infos[i]);
        }
	},
	
	reading:function( _buf ){
        this.onlinetime = _buf.ReadVarInt();
        var infos_length = _buf.ReadShort();
        for (var i = 0; i < infos_length; i++) {
            this.infos[i] = _buf.ReadBean(OnlineRewardInfo);
        }
	},

	action:function(){
		Mgr.sign.RecvResOnlineRewardsToClientMessage(this);
	},

});
////////////////////
// 发送本次抽奖的结果 //
////////////////////
var ResExtractRewardToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.infos = []; // 本次抽取的奖励内容 OnlineRewardInfo
	},

	getId:function(){
		return 154105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.infos.length );
        for (var i = 0; i < this.infos.length; i++) {
            _buf.WriteBean(this.infos[i]);
        }
	},
	
	reading:function( _buf ){
        var infos_length = _buf.ReadShort();
        for (var i = 0; i < infos_length; i++) {
            this.infos[i] = _buf.ReadBean(OnlineRewardInfo);
        }
	},

	action:function(){
		Mgr.sign.RecvResExtractRewardToClientMessage(this);
	},

});
////////////////////
// 发送离线活动信息 //
////////////////////
var ResActivityOffLineToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.offLineTime = 0; // 活动期间累计离线时间（秒）
        this.awardState = 0; // 0不能领取，1已领取
	},

	getId:function(){
		return 154106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.offLineTime);
        _buf.WriteVarInt(this.awardState);
	},
	
	reading:function( _buf ){
        this.offLineTime = _buf.ReadVarInt();
        this.awardState = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.sign.RecvResActivityOffLineToClientMessage(this);
	},

});
////////////////////
// 请求签到信息  //
////////////////////
var ReqSignInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 0普通签到1充值签到(天天返利)
	},

	getId:function(){
		return 154201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 请求签到(签到就发奖励) //
////////////////////
var ReqSignToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型(0普通签到1累计签到2再签一次普通签到)
        this.signNum = 0; // 签到天数
	},

	getId:function(){
		return 154202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteByte(this.signNum);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.signNum = _buf.ReadByte();
	},

});
////////////////////
// 请求补签(签到就发奖励) //
////////////////////
var ReqRepairSignToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 154203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求充值签到 //
////////////////////
var ReqRechargeSignToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.signDay = 0; // 签到第几天
	},

	getId:function(){
		return 154204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.signDay);
	},
	
	reading:function( _buf ){
        this.signDay = _buf.ReadByte();
	},

});
////////////////////
// 请求领取在线奖励  //
////////////////////
var ReqGetOnlineRewardsToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.time = 0; // 在线时长(秒)
	},

	getId:function(){
		return 154206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.time);
	},
	
	reading:function( _buf ){
        this.time = _buf.ReadVarInt();
	},

});
////////////////////
// 请求打开在线奖励面板  //
////////////////////
var ReqOpenOnlineRewardsToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 154207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取离线活动奖励 //
////////////////////
var ReqGetActivityOffLineRewardsToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型(1领取经验奖励2领取元宝奖励3领取道具奖励)
	},

	getId:function(){
		return 154208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(154101, ResSendSignInfoToClientMessage);
MESSAGE_POOL.Add(154102, ResSendRechargeSignInfoToClientMessage);
MESSAGE_POOL.Add(154104, ResOnlineRewardsToClientMessage);
MESSAGE_POOL.Add(154105, ResExtractRewardToClientMessage);
MESSAGE_POOL.Add(154106, ResActivityOffLineToClientMessage);

