///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//SkillInfo 技能信息类
//SkillCooldownInfo 技能冷却时间信息

// 请求消息
//123201,ReqLevelUpSkill 升级技能
//123202,ReqSetDefaultSkill 设置默认技能

// 接收消息
//123101,ResSkillInfos 技能信息列表
//123102,ResSkillAdd 技能增加
//123103,ResSkillStartLevelUp 技能开始升级
//123104,ResSkillRemove 技能移除
//123105,ResSkillResetEffectsid 重置技能动作编号
//123107,ResSkillChange 技能变更消息
//123108,ResSkillCooldownInfo 技能冷却信息
//123109,ResSkillCooldownCorrection 技能冷却修正


var SkillInfo = cc.Class.extend({
	ctor:function(){
		this.skillId = null; // 技能唯一Id
        this.skillModelId = 0; // 技能模板Id
        this.skillLevel = 0; // 技能等级
        this.skillExp = 0; // 技能经验
	},

	writing:function( _buf ){
		_buf.WriteLong(this.skillId);
        _buf.WriteVarInt(this.skillModelId);
        _buf.WriteVarInt(this.skillLevel);
        _buf.WriteVarInt(this.skillExp);
	},
	
	reading:function( _buf ){
		this.skillId = _buf.ReadLong();
        this.skillModelId = _buf.ReadVarInt();
        this.skillLevel = _buf.ReadVarInt();
        this.skillExp = _buf.ReadVarInt();
	},
});
var SkillCooldownInfo = cc.Class.extend({
	ctor:function(){
		this.skillModelId = 0; // 技能模板Id
        this.remain = 0; // 技能冷却剩余时间
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.skillModelId);
        _buf.WriteVarInt(this.remain);
	},
	
	reading:function( _buf ){
		this.skillModelId = _buf.ReadVarInt();
        this.remain = _buf.ReadVarInt();
	},
});
////////////////////
// 技能信息列表 //
////////////////////
var ResSkillInfosMessage = cc.Class.extend( {
	ctor:function(){
		this.defaultSkill = 0; // 默认技能模板Id
        this.skills = []; // 技能信息列表 SkillInfo
	},

	getId:function(){
		return 123101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.defaultSkill);
        _buf.WriteShort( this.skills.length );
        for (var i = 0; i < this.skills.length; i++) {
            _buf.WriteBean(this.skills[i]);
        }
	},
	
	reading:function( _buf ){
        this.defaultSkill = _buf.ReadVarInt();
        var skills_length = _buf.ReadShort();
        for (var i = 0; i < skills_length; i++) {
            this.skills[i] = _buf.ReadBean(SkillInfo);
        }
	},

	action:function(){
		Mgr.skill.RecvResSkillInfosMessage(this);
	},

});
////////////////////
// 技能增加 //
////////////////////
var ResSkillAddMessage = cc.Class.extend( {
	ctor:function(){
		this.skillInfo = null; // 技能增加信息
	},

	getId:function(){
		return 123102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.skillInfo);
	},
	
	reading:function( _buf ){
        this.skillInfo = _buf.ReadBean(SkillInfo);
	},

	action:function(){
		Mgr.skill.RecvResSkillAddMessage(this);
	},

});
////////////////////
// 技能开始升级 //
////////////////////
var ResSkillStartLevelUpMessage = cc.Class.extend( {
	ctor:function(){
		this.skillModelId = 0; // 技能模板Id
	},

	getId:function(){
		return 123103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.skillModelId);
	},
	
	reading:function( _buf ){
        this.skillModelId = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.skill.RecvResSkillStartLevelUpMessage(this);
	},

});
////////////////////
// 技能移除 //
////////////////////
var ResSkillRemoveMessage = cc.Class.extend( {
	ctor:function(){
		this.skillModelId = 0; // 技能模板Id
	},

	getId:function(){
		return 123104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.skillModelId);
	},
	
	reading:function( _buf ){
        this.skillModelId = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.skill.RecvResSkillRemoveMessage(this);
	},

});
////////////////////
// 重置技能动作编号 //
////////////////////
var ResSkillResetEffectsidMessage = cc.Class.extend( {
	ctor:function(){
		this.skilleffectsid = 0; // 未分离的技能动作编号
	},

	getId:function(){
		return 123105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.skilleffectsid);
	},
	
	reading:function( _buf ){
        this.skilleffectsid = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.skill.RecvResSkillResetEffectsidMessage(this);
	},

});
////////////////////
// 技能变更消息 //
////////////////////
var ResSkillChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.skillInfo = null; // 技能信息列表
	},

	getId:function(){
		return 123107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.skillInfo);
	},
	
	reading:function( _buf ){
        this.skillInfo = _buf.ReadBean(SkillInfo);
	},

	action:function(){
		Mgr.skill.RecvResSkillChangeMessage(this);
	},

});
////////////////////
// 技能冷却信息 //
////////////////////
var ResSkillCooldownInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.skillCooldownInfos = []; // 技能冷却信息 SkillCooldownInfo
	},

	getId:function(){
		return 123108;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.skillCooldownInfos.length );
        for (var i = 0; i < this.skillCooldownInfos.length; i++) {
            _buf.WriteBean(this.skillCooldownInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var skillCooldownInfos_length = _buf.ReadShort();
        for (var i = 0; i < skillCooldownInfos_length; i++) {
            this.skillCooldownInfos[i] = _buf.ReadBean(SkillCooldownInfo);
        }
	},

	action:function(){
		Mgr.skill.RecvResSkillCooldownInfoMessage(this);
	},

});
////////////////////
// 技能冷却修正 //
////////////////////
var ResSkillCooldownCorrectionMessage = cc.Class.extend( {
	ctor:function(){
		this.skillModelId = 0; // 技能模板Id
        this.cd = 0; // cd时间秒
	},

	getId:function(){
		return 123109;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.skillModelId);
        _buf.WriteVarInt(this.cd);
	},
	
	reading:function( _buf ){
        this.skillModelId = _buf.ReadVarInt();
        this.cd = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.skill.RecvResSkillCooldownCorrectionMessage(this);
	},

});
////////////////////
// 升级技能 //
////////////////////
var ReqLevelUpSkillMessage = cc.Class.extend( {
	ctor:function(){
		this.skillModelId = 0; // 技能模板Id
	},

	getId:function(){
		return 123201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.skillModelId);
	},
	
	reading:function( _buf ){
        this.skillModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 设置默认技能 //
////////////////////
var ReqSetDefaultSkillMessage = cc.Class.extend( {
	ctor:function(){
		this.defaultskillModelId = 0; // 技能模板Id
	},

	getId:function(){
		return 123202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.defaultskillModelId);
	},
	
	reading:function( _buf ){
        this.defaultskillModelId = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(123101, ResSkillInfosMessage);
MESSAGE_POOL.Add(123102, ResSkillAddMessage);
MESSAGE_POOL.Add(123103, ResSkillStartLevelUpMessage);
MESSAGE_POOL.Add(123104, ResSkillRemoveMessage);
MESSAGE_POOL.Add(123105, ResSkillResetEffectsidMessage);
MESSAGE_POOL.Add(123107, ResSkillChangeMessage);
MESSAGE_POOL.Add(123108, ResSkillCooldownInfoMessage);
MESSAGE_POOL.Add(123109, ResSkillCooldownCorrectionMessage);

