var SkillPanelType = SkillPanelType || {};
SkillPanelType.PANEL_ACTIVE = "panel_active";
SkillPanelType.PANEL_STATIC = "panel_static";

var SkillPanelExt = SkillPanel.extend ( {
	_className:"SkillPanelExt",

	panelMgr:null,
	showPanel:null,
	showType:null,

	_skillZDIds:null,
	_skillXFIds:null,
	_skillBDIds:null,
	curSkillIds:null,

	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = -28;

		this.panelMgr = {};
		this._skillZDIds = [];
		this._skillXFIds = [];
		this._skillBDIds = [];
		this.curSkillIds = [];
	},

	Init:function() {
		var self = this;
		SkillPanel.prototype.Init.call(this)
		this.SetPendantMovie(this.imgGuajian);

		this._InitParam();

		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});
		this.sbtnActiveSkill.addClickEventListener(function (event){
			self.ChangePanel(SkillPanelType.PANEL_ACTIVE );
		});

		this.sbtnStaticSkill.addClickEventListener(function (event){
			self.ChangePanel(SkillPanelType.PANEL_STATIC );
		});
		this.ChangePanel( SkillPanelType.PANEL_ACTIVE );
	},

	_InitParam:function () {
		this._btnArr = [
			{btn:this.sbtnActiveSkill,type:SkillPanelType.PANEL_ACTIVE, btnStr:this.labZd},
			{btn:this.sbtnStaticSkill,type:SkillPanelType.PANEL_STATIC, btnStr:this.labBd},
		];

		// 筛选技能
		var skill_public = Q_skill_public.GetList();
		for ( var i = 0; i != skill_public.length; i++ ) {
			var mid = skill_public[i].q_skillID;
			var index = skill_public[i].q_index;
			if ( Mgr.player.mainPlayer.job == skill_public[i].q_job || skill_public[i].q_job == 0 ) {
				if ( !index )
					continue;
				else if ( index == 1 || index == 3 ) {  // 主动
					if ( this._skillZDIds >= 4 ) { // 大于4个自动放在心法栏，相当于没有心法这个分类
						this._skillXFIds.push( mid );
					}
					else
						this._skillZDIds.push(mid);
				}
				else if ( index == 2 )   //被动
					this._skillBDIds.push( mid );
			}
		}
		this._skillZDIds = this._skillZDIds.concat(this._skillXFIds)

		// 模拟数据
		// this._skillZDIds = [11, 12, 10001, 10002, 10011, 10012, 10021, 10022];
		// this._skillXFIds = [10041, 10042];
		// this._skillBDIds = [11001, 11002, 11003];
	},

	ChangePanel:function ( type ){
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			if ( this._btnArr[i].type == type ) {
				this._btnArr[i].btn.SetButtonState("check");
				this._btnArr[i].btnStr.SetColor("0xffffff");
			}
			else {
				this._btnArr[i].btn.SetButtonState("uncheck");
				this._btnArr[i].btnStr.SetColor("0xcbb386");
			}
		}

		if ( this.showPanel )
			this.showPanel.visible = false;

		switch( type ){
			case SkillPanelType.PANEL_ACTIVE:
				if ( !this.panelMgr[type] ) {
					var panel = new SkillActivePanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				this.curSkillIds = this._skillZDIds
				break;
			case SkillPanelType.PANEL_STATIC:
				if ( !this.panelMgr[type] ) {
					var panel = new SkillStaticPanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				this.curSkillIds = this._skillBDIds
				break;
			default:
				break;
		}
		this.showType = type;
		this.showPanel = this.panelMgr[type];
		if ( this.showPanel ) {
			this.showPanel.SetData( this.curSkillIds );
			this.showPanel.visible = true;
		}
	},

	OnShow:function () {
		if ( this.showPanel ) {
			this.showPanel.SetData(this.curSkillIds);
			this.showPanel.visible = true;
		}
		this.UpdataWarn();
	},

	UpdataWarn:function () {
		this.imgWarn.visible = false;
		for ( var i = 0; i != this._skillBDIds.length; i++ ) {
			var mid = this._skillBDIds[i];
			var lv = 0;
			if ( Mgr.skill.skillInfos.Get(mid) ){
				lv = Mgr.skill.skillInfos.Get(mid).FullLevel();
			}
			if ( !Mgr.skill.ShortMetarial( mid, lv ) ) {
				this.imgWarn.visible = true;
				break;
			}
		}

		if (this.panelType == SkillPanelType.PANEL_STATIC )
			this.showPanel.SetData(this.curSkillIds);
	},
} );
SkillPanelExt.PanelName = "SkillPanelExt";
PanelClassDic["SkillPanelExt"] = SkillPanelExt;
