///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//105200,ReqStoreGetItems 仓库物品请求
//105201,ReqStoreMoveItem 移动物品
//105202,ReqStoreClearUp 整理物品
//105203,ReqBagToStore 物品存入仓库
//105204,ReqStoreToBag 物品从仓库取出
//105205,ReqStoreSplitItem 拆分仓库道具
//105206,ReqGetOutStoreAllItems 请求一键取出仓库道具

// 接收消息
//105100,ResStoreItemInfos 物品信息列表..
//105101,ResStoreItemAdd 物品信息增加
//105102,ResStoreItemChange 物品信息修正
//105103,ResStoreItemRemove 物品删除


////////////////////
// 物品信息列表.. //
////////////////////
var ResStoreItemInfosMessage = cc.Class.extend( {
	ctor:function(){
		this.cellnum = 0; // 已开格子数量
        this.items = []; // 物品信息列表 ItemInfo
        this.type = 0; // 仓库类型（0是正常仓库，1，2，3是其他的）
	},

	getId:function(){
		return 105100;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.cellnum);
        _buf.WriteShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.cellnum = _buf.ReadVarInt();
        var items_length = _buf.ReadShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(ItemInfo);
        }
        this.type = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.store.RecvResStoreItemInfosMessage(this);
	},

});
////////////////////
// 物品信息增加 //
////////////////////
var ResStoreItemAddMessage = cc.Class.extend( {
	ctor:function(){
		this.item = null; // 物品信息
        this.type = 0; // 仓库类型（0是正常仓库，1，2，3是其他的）
	},

	getId:function(){
		return 105101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.item);
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.item = _buf.ReadBean(ItemInfo);
        this.type = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.store.RecvResStoreItemAddMessage(this);
	},

});
////////////////////
// 物品信息修正 //
////////////////////
var ResStoreItemChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.item = null; // 物品信息
        this.type = 0; // 仓库类型（0是正常仓库，1，2，3是其他的）
	},

	getId:function(){
		return 105102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.item);
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.item = _buf.ReadBean(ItemInfo);
        this.type = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.store.RecvResStoreItemChangeMessage(this);
	},

});
////////////////////
// 物品删除 //
////////////////////
var ResStoreItemRemoveMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.type = 0; // 仓库类型（0是正常仓库，1，2，3是其他的）
	},

	getId:function(){
		return 105103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.type = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.store.RecvResStoreItemRemoveMessage(this);
	},

});
////////////////////
// 仓库物品请求 //
////////////////////
var ReqStoreGetItemsMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 仓库类型（0是正常仓库，1，2，3是其他的）
	},

	getId:function(){
		return 105200;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 移动物品 //
////////////////////
var ReqStoreMoveItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.toGridId = 0; // 移动到格子Id
        this.num = 0; // 移动数量
        this.type = 0; // 仓库类型（0是正常仓库，1，2，3是其他的）
	},

	getId:function(){
		return 105201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.toGridId);
        _buf.WriteVarInt(this.num);
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.toGridId = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 整理物品 //
////////////////////
var ReqStoreClearUpMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 仓库类型（0是正常仓库，1，2，3是其他的）
	},

	getId:function(){
		return 105202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 物品存入仓库 //
////////////////////
var ReqBagToStoreMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.toCellId = 0; // 仓库目标格子
        this.type = 0; // 仓库类型（0是正常仓库，1，2，3是其他的）
	},

	getId:function(){
		return 105203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.toCellId);
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.toCellId = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 物品从仓库取出 //
////////////////////
var ReqStoreToBagMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.toCellId = 0; // 背包目标格子
        this.type = 0; // 仓库类型（0是正常仓库，1，2，3是其他的）
	},

	getId:function(){
		return 105204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.toCellId);
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.toCellId = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 拆分仓库道具 //
////////////////////
var ReqStoreSplitItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.num = 0; // 拆分数量
        this.type = 0; // 仓库类型（0是正常仓库，1，2，3是其他的）
	},

	getId:function(){
		return 105205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.num);
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.num = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 请求一键取出仓库道具 //
////////////////////
var ReqGetOutStoreAllItemsMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 仓库类型（0是正常仓库，1，2，3是其他的）
	},

	getId:function(){
		return 105206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(105100, ResStoreItemInfosMessage);
MESSAGE_POOL.Add(105101, ResStoreItemAddMessage);
MESSAGE_POOL.Add(105102, ResStoreItemChangeMessage);
MESSAGE_POOL.Add(105103, ResStoreItemRemoveMessage);

