var SuitMakeFrameExt = SuitMakeFrame.extend ( {
	_className:"SuitMakeFrameExt",

	_equipV:null,
	_stars:0,
	_kind:null,

	_ownSuitNum:0,
	_totalSuitNum:0,

	_isReachMax:false,
	_shortMetar:true,
	_shortRank:true,
	_shortSuits:true,   // 没有集齐一套


	_mark:0,

	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		SuitMakeFrame.prototype.Init.call(this);

		this.imgStar.visible = false;
		this.imgDikuang.visible = false;
		this.imgDianji.visible = false;
		this.gridIcon.InitGrid(GridTypeEnum.SUITEQUIP);
	},

	SetData:function (equipV) {
		this.SetSelect(false);

		this._equipV = equipV;
		//var equipC = Q_item.Get(equipV.itemModelId);
		var equipC = Q_item.Get(equipV.itemModelId);
		if ( !equipC ) {
			zz.Error("data is unexist in Q_item!  mid: " + equipV.itemModelId);
			return;
		}

		// data
		this._kind = equipC.q_kind;
		this._stars = Mgr.equipRefine.GetSuitByLocation(equipC.q_type,this._kind);
		this._ownSuitNum = SuitMakeUtil.GetOwnSuit( this._kind, this._stars ).length;
		this._totalSuitNum = SuitMakeUtil.GetEquipTypeList(this._kind).length;

        this._shortSuits = !SuitMakeUtil.CheckCycleSuits(this._kind,this._stars,equipC.q_type);
        this._isReachMax = SuitMakeUtil.IsMaxSuitStars(this._stars,this._kind,equipC.q_type);
        this._shortMetar = SuitMakeUtil.IsShortMaterial(this._stars,this._kind,equipC.q_type);
        this._shortRank = SuitMakeUtil.IsShortRank(equipC.q_id);

        // grid
        this._SetEquip(equipV, this._stars);
        this._shortRank ? Filter.GrayScale(this.gridIcon) : Filter.UnGray(this.gridIcon);

        // name
        var name = equipC.q_name;
        var mid_cur = (this._stars ).toString() + "_" +  (this._kind).toString()+ "_" +  equipC.q_type;
        var equip_forge = Q_equip_forge.Get( mid_cur );
        if ( this._stars > 0 && equip_forge ) {
            name = equip_forge.q_name + equipC.q_name;
        }
        this.labName.SetString(name);

        var color=ItemUtil.GetNameColorById(equipV.itemModelId);
        if(color) this.labName.SetColor(color[0]);

        cc.log("-------------_ownSuitNum------------" + this._ownSuitNum.toString());
        cc.log("-------------_totalSuitNum------------" + this._totalSuitNum.toString());
        var str = this._ownSuitNum.toString() + "/" + this._totalSuitNum.toString();
        this.labCue2.SetString(str);
	},

	_SetEquip:function (equipV, starNum) {
		var grid = this.gridIcon;
		grid.Clean();
		if ( equipV ) {
			// ico
			// var icon = ItemUtil.GetItemIcon(equipV.itemModelId, ResUrl.ITEM_SIZE_60)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            var coinInfo = ItemUtil.ItemIdToItem(equipV.itemModelId);
            GridUtil.SetItemGrid(grid,coinInfo);
			grid.equipV = equipV;

			// star
			for ( var i = 0; i != starNum; i++ ) {
				var star = new MUIImage();
				star.ParseJson(this.imgStar.jsonobj);
				star.Init();
				var detend = (this.imgStar.width + 2)*i;
				star.x = this.imgStar.x + detend;
				star.y = this.imgStar.y;
				grid.AddDisplay(star);

			}
		}
	},

	SetSelect:function (boo) {
		this.imgDianji.visible = boo;
	},

	GetData:function () {
		return this._equipV;
	},

	GetStars:function () {
		return this._stars;
	},

	GetKind:function () {
		return this._kind;
	},

	GetCurSuitNum:function () {
		return this._ownSuitNum;
	},

	GetMaxSuitNum:function () {
		return this._totalSuitNum;
	},

	GetMark:function () {
		return this._mark;
	},

	IsReachMax:function () {
		return this._isReachMax;
	},

	IsShortRank:function () {
		return this._shortRank;
	},

	IsShortMetar:function () {
		return this._shortMetar;
	},

	IsShortSuits:function () {
		return this._shortSuits;
	},

	IsEnableUp:function () {
		if ( this._shortRank )
			return false;
		if ( this._isReachMax )
			return false;
		if ( this._shortSuits )
			return false;
		if ( this._shortMetar )
			return false;
		return true;
	},
} );
SuitMakeFrameExt.PanelName = "SuitMakeFrameExt";
PanelClassDic["SuitMakeFrameExt"] = SuitMakeFrameExt;
