var SuitMakePanelExt = SuitMakePanel.extend ( {
	_className:"SuitMakePanelExt",

	// list
	_listView : null,
	curSelectItem : null,
	_itemList:null,

	_materialGridArr:null,

	_labGradeList:null,
	_labAttrList:null,

	_light:"0x01ab25",
	_gray:"0x897d71",

	_touchBeginPt:null,
	// 零时星级
	_curShowStars:null,

	ctor:function(){
		this._super();
		this._itemList = [];
		this._materialGridArr = [];
		this._labAttrList = [];
		this._labGradeList = [];
		this._curShowStars = 0;
	},

	Init:function()
	{
		var self = this;
		SuitMakePanel.prototype.Init.call(this);

		this._InitParam();

		this.btnShengji.addClickEventListener(function (event){
			var equipV = null;
			if ( self.curSelectItem )
				equipV = self.curSelectItem.GetData();

			if ( !equipV ) {
				Mgr.tips.ShowNotice("请选择一件装备！");
				return;
			}

			if (self.curSelectItem.IsShortRank()) {
				Mgr.tips.ShowNotice("装备等阶不足，无法打造");
				return;
			}
			if (self.curSelectItem.IsReachMax()) {
				Mgr.tips.ShowNotice("装备套装等级已是最高级！");
				return;
			}
			if (self.curSelectItem.IsShortSuits()) {
				Mgr.tips.ShowNotice("必须集齐一套才可继续下一阶打造！");
				return;
			}
			if (self.curSelectItem.IsShortMetar()) {
				Mgr.tips.ShowNotice("材料不足！");
				return;
			}

			var kind = self.curSelectItem.GetKind();
			Mgr.equipRefine.SendReqEquipPosSuitChangeToGameMessage(self._itemType,kind);
		});

        var size = cc.size(this.imgBg3.width - 60,this.imgBg3.height - 84)
        var scrollView = ccui.ScrollView.create();
        scrollView.setContentSize(size);
        scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        scrollView.setInnerContainerSize(size);
        scrollView.setScrollBarEnabled(false);
        scrollView.setBounceEnabled(true);
        scrollView.setPosition( 30,20);
        this.imgBg3.addChild(scrollView);
        this.scrollView = scrollView;


//imgBg3
		this.listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			onTouchBegan: function (touch, event) {
				var target = event.getCurrentTarget();
				var locationInNode = target.convertToNodeSpace(touch.getLocation());
				if ( self.visible && self._CheckInBox( locationInNode.x,  locationInNode.y) ) {
					self._touchBeginPt = locationInNode;
					return true;
				}
				return false;
			},
			onTouchMoved: function (touch, event) {
			},
			onTouchEnded: function (touch, event) {
				var target = event.getCurrentTarget();
				var endPt = target.convertToNodeSpace(touch.getLocation());
				if ( endPt.x < 10 )
					endPt.x = 10;
				if ( endPt.x > self.imgBg3.width - 10)
					endPt.x = self.imgBg3.width - 10;
				if ( endPt.y < 10 )
					endPt.y = 10;
				if ( endPt.y > self.imgBg3.height - 60)
					endPt.x = self.imgBg3.height - 60;

				var detend = endPt.x - self._touchBeginPt.x;
				if ( Math.abs(detend) > 50 && self.curSelectItem ) {
					// 获取可以显示的最大星级
					var kind = self.curSelectItem.GetKind();
					var curStars = self.curSelectItem.GetStars();
					var angle = 180;
					var maxStars = SuitMakeUtil.GetShowMaxStars(curStars, kind,this._itemType);
					if ( detend > 0 ) {
						angle = -180;
						if ( self._curShowStars >= maxStars ) {
							self._curShowStars = maxStars;
						}
						else {
							++self._curShowStars;
							self._SetSuitAttr(self._curShowStars, kind);

							var orbit1 = cc.orbitCamera(0.2, 1, 0, 0, angle, 0, 0);
							var orbit2 = cc.orbitCamera(0.2, 1, 0, 0, 0, 0, 0);
							var action1 = cc.sequence(
								orbit1,
								orbit2);
							self.imgBg3.runAction(action1);
						}

						self._curShowStars = self._curShowStars > maxStars ? maxStars : self._curShowStars;
					}
					else if ( detend < 0 ) {
						angle = 180;
						if ( self._curShowStars <= 1 ) {
							self._curShowStars = 1;
						}
						else {
							--self._curShowStars;
							self._SetSuitAttr(self._curShowStars, kind);

							var orbit1 = cc.orbitCamera(0.2, 1, 0, 0, angle, 0, 0);
							var orbit2 = cc.orbitCamera(0.2, 1, 0, 0, 0, 0, 0);
							var action1 = cc.sequence(
								orbit1,
								orbit2);
							self.imgBg3.runAction(action1);
						}
						self._curShowStars = self._curShowStars < 1 ? 1 : self._curShowStars;
					}

				}
			}
		});
		cc.eventManager.addListener( this.listener ,this.imgBg3);


	},
    InitSubTabConfig:function(){
        var config = [
            { type : EnumItemType.Equip	,text : "角色" },
            { type : EnumItemType.Equip_Shutong	,text : "书童" },
        ];

        return config;
    },
    OnShow:function(){
        this._super();
        GameEventMgr.AddEventListener(this,EnumEventType.GAME_EQUIP_REFINING_SUIT_CHANGED,function(){
            this.SetData();
        })
    },
    OnHide:function(){
        GameEventMgr.RemoveEventListener(this);
        this._super();
    },
	_CheckInBox:function (x,y) {
		if ( x > 10 && x < (this.imgBg3.width - 10) && y > 10 && y < (this.imgBg3.height - 60) )
			return true;
		return false;
	},

	_InitPosition:function () {
		this.x = 0;
		this.y = 0;
	},

	_InitParam:function() {
		this._InitPosition();
		this._CreateListView();
		this.gridItem.InitGrid(GridTypeEnum.SUITEQUIP);

		this.labName.SetString("");
        this.labName.setAnchorPoint(cc.p(0.5,0.5));
        this.labName.x = this.labName.x + this.labName.GetWidth() / 2 - 5;
        this.labName.y = this.labName.y + this.labName.GetHeight() / 2;
		this.imgStar.visible = false;

		this.imgLock1.visible = false;
		this.labNeedNum1.SetString("");

		this.labSuitName.SetString("");
		this.labSuitNum.SetString("");

		this.labSuitGrade1.visible = false;
		this.labAttr1.visible = false;
		this.labAttrValue1.visible = false;
		this.labAttr2.visible = false;
		this.labAttrValue2.visible = false;
		this.labAttr3.visible = false;
		this.labAttrValue3.visible = false;

		this._materialGridArr = [this.gridItem1, this.gridItem2, this.gridItem3];


		var pt = cc.p(this.imgBg3.x + this.imgBg3.width/2, this.imgBg3.y + this.imgBg3.height/2)
		this.imgBg3.setAnchorPoint(cc.p(0.5,0.5));
		this.imgBg3.setPosition(pt)
	},

	_CreateListView:function () {
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg.width, this.imgBg.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setItemsMargin(0);
		list.setAnchorPoint(0, 0);
		list.setPosition(0, 0);
		list.setScrollBarEnabled(false)
		list.addEventListener(this._SelectedItemEvent);
		this._innerContainer = list.getInnerContainer();
		this.imgBg.addChild(list);
		this._listView = list;
	},

	_SelectedItemEvent: function (sender, type) {
		switch (type) {
			case ccui.ListView.ON_SELECTED_ITEM_END:
				var parent = sender.parent.parent;
				if ( parent.curSelectItem != null) {
					parent.curSelectItem.SetSelect(false);
					parent.curSelectItem = null;
					parent.gridItem.equipV = null;
				}

				var idx = sender.getCurSelectedIndex();
				var itemSelect = sender.getItem(idx);
				itemSelect.SetSelect(true);
				parent.curSelectItem = itemSelect;

				parent.SetCenterEquip();
				break;
			default:
				break;
		}
	},

	_SetList:function () {
		var list = [];
		var locations = SuitMakeUtil.GetEquipTypeList();
        var equips = Mgr.equip.GetEquipsByType(this._itemType);
		for ( var i = 0; i < locations.length; i++ ) {
			for ( var j = 0; j < equips.length; j++ ) {
				var equipC = Q_item.Get(equips[j].itemModelId);
				cc.assert(null != equipC, "data is unexist in Q_item!  itemModelId: " + equips[j].itemModelId);
				if ( locations[i] == equipC.q_kind ) {
					list.push(equips[j]);
					break;
				}
			}
		}

		var i;
		for ( i = 0; i != list.length; i++ ) {
			var item;
			if ( i < this._itemList.length )
				item = this._itemList[i];
			else {
				item = new SuitMakeFrameExt();
				item.LoadPanel();
				item.retain();
				this._itemList.push(item);
			}
			item.SetData(list[i]);
			if ( this._listView.getIndex(item) == -1 )
				this._AddItem(item);
		}
		var items = this._listView.getItems();
		for ( ; i < items.length; i++ ) {
			this._listView.removeChild(items[i]);
		}

		this._BrushCurItem();
		if ( !this.curSelectItem )
			this._AutoSelect();
		else {
			this.curSelectItem.SetSelect(true);
			this.SetCenterEquip();
		}
	},

	_BrushCurItem:function () {
		if ( this.curSelectItem ) {
			var find = false;
			var items = this._listView.getItems();
			for ( var i = 0; i != items.length; i++ ) {
				if ( items[i].GetData().itemModelId == this.curSelectItem.GetData().itemModelId ) {
					find = true;
					break;
				}
			}
			if ( !find ) {
				this.gridItem.equipV = null;
				this.curSelectItem = null;
			}
		}
	},

	_AutoSelect:function () {
		//找到对应 list item
		var item = null;
		var items = this._listView.getItems();
		if ( items.length > 0 )
			item = items[0];

		for ( var i = 0; i != items.length; i++ ) {
			if ( items[i].IsEnableUp() ) {
				item = items[i];
				break;
			}
		}
		if ( item ) {
			item.SetSelect(true);
			this.curSelectItem = item;
		}
		this.SetCenterEquip();
	},

	SetCenterEquip:function () {
		var grid = this.gridItem;
		grid.Clean();
		this._curShowStars = 0;
		if ( this.curSelectItem ) {
			var equipV = this.curSelectItem.GetData();
			// ico
			// var icon = ItemUtil.GetItemIcon(equipV.itemModelId)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            var coinInfo = {};
            coinInfo.itemModelId = equipV.itemModelId;
            // coinInfo.itemNum = price;
            // coinInfo.itemBind = itemInfo.q_bind;
            GridUtil.SetItemGrid(grid,coinInfo);
			grid.equipV = equipV;

			var stars = this.curSelectItem.GetStars();
			if ( this.curSelectItem.IsReachMax() ) {  // 最大星级
				this.btnShengji.setTitleText( "锻造完成" );
				//this.imgFinish.visible = true;
				Filter.GrayScale(this.btnShengji);
			}
			else {  // 中央装备应该显示下一阶信息
				stars += 1;
                if(this.curSelectItem.IsEnableUp()){
                    Filter.UnGray(this.btnShengji);
                }else{
                    Filter.GrayScale(this.btnShengji);
                }
				this.btnShengji.setTitleText( "打造" );
				//this.imgFinish.visible = false;
			}
			this._curShowStars = stars;

			// star
			for ( var i = 0; i != stars; i++ ) {
				var star = new MUIImage();
				star.ParseJson(this.imgStar.jsonobj);
				star.Init();
				var detend = (this.imgStar.width + 2)*i;
				star.x = this.imgStar.x + detend;
				star.y = this.imgStar.y;
				grid.AddDisplay(star);
			}

			var equipC = Q_item.Get(equipV.itemModelId);
			cc.assert(null != equipC, "data is unexist in Q_item!  mid: " + equipV.itemModelId);
			// name
			var mid = stars.toString() + "_" +  (equipC.q_kind).toString()+ "_" + this._itemType;
			var equip_forge = Q_equip_forge.Get( mid );
			var name = equipC.q_name;
			if ( this.curSelectItem.IsShortRank() )
				name = "该装备无法打造";
			else if ( equip_forge )
				name = equip_forge.q_name + equipC.q_name;
			this.labName.SetString(name);
            this.labName.setScale(Math.min(1,190 / this.labName._textWidth));
		}
		else
			this.labName.SetString("");

		this._SetMaterials();

		// 套装属性 根据情况做不同显示
		var curStars = null, curKind = null;
		if ( this.curSelectItem ) {
			curStars = this.curSelectItem.GetStars();
			curKind = this.curSelectItem.GetKind();
			if (this.curSelectItem.IsReachMax() || this.curSelectItem.IsShortSuits()) {  // 最大星级 或 未达到一套的都显示当前星级
			}
			else {  // 中央装备应该显示下一阶信息
				curStars += 1;
			}
		}
		this._SetSuitAttr(curStars, curKind);
	},

	_SetSuitAttr:function (stars, kind) {
		{
			this.labSuitName.SetString("");
			this.labSuitNum.SetString("");
			// remove attr
			for (var i = 0; i != this._labGradeList.length; i++) {
				if (this._labGradeList[i].parent)
					this._labGradeList[i].removeFromParent();
			}
			for (var i = 0; i != this._labAttrList.length; i++) {
				if (this._labAttrList[i].parent)
					this._labAttrList[i].removeFromParent();
			}
		}

		if ( stars != null && kind != null ) {

			// suit num rate
			var curSuitNum = SuitMakeUtil.GetOwnSuit(kind, stars).length;
			var maxSuitNum = SuitMakeUtil.GetEquipTypeList(kind).length;
			this.labSuitNum.SetString(curSuitNum.toString() + "/" + maxSuitNum.toString());

			// 套装类型
			var SuitType = SuitMakeUtil.GetSuitType(kind);

			// 获取属性列表
			var groupArr = [];
			var gradeList = SuitMakeUtil.GetSuitGradeByType(SuitType);  // 套装组合档次
			for (var i = 0; i != gradeList.length; i++) {
				var attrArr = [];
				// 通用属性
				var sid = stars.toString() + "_" + SuitType.toString() + "_" + gradeList[i].toString() + "_" + this._itemType;
				var equip_suit_bonus = Q_equip_suit_bonus.Get(sid);
				if (equip_suit_bonus) {
					var str = ParseUtil.FormatFastJsonStr(equip_suit_bonus.q_attribute);
					var jsonData = JSON.parse(str);
					for (var keyStr in jsonData) {

						var type = parseInt(keyStr);
						var dexValue = parseInt(jsonData[keyStr]);

						// 减去上一个档次属性值  (当前值为叠加值)
						var sid_last = stars.toString() + "_" + SuitType.toString() + "_" + (gradeList[i] - 1).toString() + "_" + this._itemType;
						var equip_suit_bonus_last = Q_equip_suit_bonus.Get(sid_last);
						if (equip_suit_bonus_last) {
							var str_last = ParseUtil.FormatFastJsonStr(equip_suit_bonus_last.q_attribute);
							var jsonData_last = JSON.parse(str_last);
							if (jsonData_last[keyStr])
								dexValue -= parseInt(jsonData_last[keyStr]);
						}
						if (dexValue > 0) {
							var obj = {type: type, value: dexValue, suitType: SuitTypeEnum.SUIT_TYPE_EQUIP};
							attrArr.push(obj);
						}
					}
					// name
					this.labSuitName.SetString(equip_suit_bonus.q_name);
				}
				//// 额外属性
				//if (SuitType == SuitTypeEnum.SUIT_TYPE_HUFU) {
				//	var idArr = JSON.parse(Q_global.Get(1016).q_string_value);
				//	for (var m = 0; m != idArr.length; m++) {
				//		// 获取对应星级套装的额外属性
				//		if (m + 1 == stars) {
				//			var assert = idArr[m];
				//			for (var n = 0; n != assert.length; n++) {
				//				var value = parseInt(assert[n][1]);
				//				var rate = parseFloat(value / 100).toString() + "%";
				//				var obj = {
				//					type: parseInt(assert[n][0]),
				//					value: rate,
				//					suitType: SuitTypeEnum.SUIT_TYPE_HUFU
				//				};
				//				attrArr.push(obj);
				//			}
				//		}
				//	}
				//}
				//else if (SuitType == SuitTypeEnum.SUIT_TYPE_RING) {
				//	var idArr = JSON.parse(Q_global.Get(1017).q_string_value);
				//	for (var m = 0; m != idArr.length; m++) {
				//		// 获取对应星级套装的额外属性
				//		if (m + 1 == stars) {
				//			var assert = idArr[m];
				//			for (var n = 0; n != assert.length; n++) {
				//				var value = parseInt(assert[n][1]);
				//				var rate = parseFloat(value / 100).toString() + "%";
				//				var obj = {
				//					type: parseInt(assert[n][0]),
				//					value: rate,
				//					suitType: SuitTypeEnum.SUIT_TYPE_RING
				//				};
				//				attrArr.push(obj);
				//			}
				//		}
				//	}
				//}
				groupArr.push({grade: gradeList[i], attr: attrArr});
			}

			// 设置属性
			var _idx = 0;   //缓存计数标签

            // 设置scrollview 内容高度
            var height = 0,lineHeight = 33;
            for (var i = 0; i != groupArr.length; i++) {

                height += groupArr[i].attr.length * lineHeight;
                height += 10;
            }
            this.scrollView.setTouchEnabled(height > this.scrollView.height);
            height = Math.max(height,this.scrollView.height);
            this.scrollView.setInnerContainerSize(cc.size(this.scrollView.width,height));

            height -= lineHeight;
			for (var i = 0; i != groupArr.length; i++) {
				if (groupArr[i].attr.length <= 0)   // 不存在属性不显示
					continue;

				// 判断是否存在（高亮）
				var isLight = curSuitNum >= groupArr[i].grade;

				// 套装组合档次
				var _labGrade;
				if (i < this._labGradeList.length)
					_labGrade = this._labGradeList[i];
				else {
					_labGrade = new MUILabel();
					_labGrade.ParseJson(this.labSuitGrade1.jsonobj);
					_labGrade.Init();
					_labGrade.retain();
					this._labGradeList.push(_labGrade);
				}
				_labGrade.x = this.labSuitGrade1.x - this.scrollView.x;
				_labGrade.y = height;//this.labSuitGrade1.y + this._offY;
//				this.labSuitGrade1.parent.addChild(_labGrade);
				this.scrollView.addChild(_labGrade);
				var str = "【" + String(groupArr[i].grade) + "件】";
				_labGrade.SetString(str);
				if (isLight)
					_labGrade.SetColor(this._light);
				else
					_labGrade.SetColor(this._gray);

				// 属性
				for (var j = 0; j != groupArr[i].attr.length; j++) {
					var type = groupArr[i].attr[j].type;
					var value = groupArr[i].attr[j].value;
					var suitType = groupArr[i].attr[j].suitType;

					var str;

					var result = Mgr.attributeMgr.GetAttrDes(type,value);
                    str = result[0],value = result[1];

					// 属性str
					var _labAttr;
					if (_idx < this._labAttrList.length)
						_labAttr = this._labAttrList[_idx];
					else {
						_labAttr = new MUILabel();
						_labAttr.ParseJson(this.labAttr1.jsonobj);
						_labAttr.Init();
						_labAttr.retain();
						this._labAttrList.push(_labAttr);
					}
					++_idx;
					_labAttr.x = this.labAttr1.x - this.scrollView.x;
					_labAttr.y = height;//this.labAttr1.y + this._offY;

                    this.scrollView.addChild(_labAttr);
//					this.labAttr1.parent.addChild(_labAttr);
					_labAttr.SetString(str);
					if (isLight)
						_labAttr.SetColor(this._light);
					else
						_labAttr.SetColor(this._gray);

					// 属性 value
					var _labValue;
					if (_idx < this._labAttrList.length)
						_labValue = this._labAttrList[_idx];
					else {
						_labValue = new MUILabel();
						_labValue.ParseJson(this.labAttrValue1.jsonobj);
						_labValue.Init();
						_labValue.retain();
						this._labAttrList.push(_labValue);
					}
					++_idx;
					_labValue.x = this.labAttrValue1.x - this.scrollView.x;
					_labValue.y = height //this.labAttrValue1.y + this._offY;

//					if (suitType != SuitTypeEnum.SUIT_TYPE_EQUIP) {   // 护符 戒指 属性名太长，单独排列
//						_labValue.x = this.labAttrValue3.x;
//						_labValue.y = this.labAttrValue3.y + this._offY;
//					}

                    this.scrollView.addChild(_labValue);

//					this.labAttrValue1.parent.addChild(_labValue);
					str = "+" + value.toString();
					_labValue.SetString(str);
					if (isLight)
						_labValue.SetColor(this._light);
					else
						_labValue.SetColor(this._gray);


					// 位移
					var interval = this.labAttr2.y - this.labAttr1.y;
					height-= lineHeight;
				}

				height-= 10;
			}
		}
	},

	_SetMaterials:function () {
		var _material = [];

		// 获取材料信息
		if ( this.curSelectItem ) {
			var stars =  this.curSelectItem.GetStars();
			var kind = this.curSelectItem.GetKind();
			var mid = (stars+1).toString() + "_" +  kind.toString()+ "_" + this._itemType;
			var equip_forge = Q_equip_forge.Get( mid );
			if ( equip_forge && equip_forge.q_material ) {
				var idArr = JSON.parse( equip_forge.q_material );
				for ( var i = 0; i != idArr.length; i++ ) {
					var dat = { id:parseInt(idArr[i][0]), num:parseInt(idArr[i][1]) };
					_material.push(dat);
				}
			}
		}

		// set material
		for ( var i = 0; i != this._materialGridArr.length; i++ ) {
			var data = null;
			if ( i < _material.length )
				data = _material[i];

			this._SetMaterial(this._materialGridArr[i], data);
		}
	},

	_SetMaterial:function (grid, data) {
		grid.Clean();
		if ( data ) {
			// ico
			// var icon = ItemUtil.GetItemIcon(data.id)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            var coinInfo = {};
            coinInfo.itemModelId = data.id;
            // coinInfo.itemNum = price;
            // coinInfo.itemBind = itemInfo.q_bind;
            GridUtil.SetItemGrid(grid,coinInfo);
			grid.materialId = data.id;

			// num rate
			var _labNeed = new MUILabel();
			_labNeed.ParseJson(this.labNeedNum1.jsonobj);
			_labNeed.Init();
			_labNeed.setPosition(this.labNeedNum1.getPosition());
			var curNum = Mgr.backpack.GetItemNumber( data.id, true );
			var needNum = data.num;
			var str;
			if ( curNum < needNum )
				str = "<font color='#FF1B4B'>{@}</font><font color='#1ab25'>/{@}</font>";
			else
				str = "<font color='#1ab25'>{@}</font><font color='#1ab25'>/{@}</font>";
			_labNeed.SetHtmlText(UIUtil._ConectParam(str, [curNum,needNum]));
			grid.AddDisplay(_labNeed);

			var item = ItemUtil.ItemIdToItem(data.id);
			GridUtil.SetGridInteraction( grid, GridInteractionType.ITEMSHOW, item );
		}
		else if (this.gridItem.equipV) {
			var img = new MUIImage();
			img.ParseJson( this.imgLock1.jsonobj );
			img.Init();
			img.setPosition(this.imgLock1.getPosition());
			grid.AddDisplay(img);
		}
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	SetData:function (itemType) {
        this._itemType = itemType || this._itemType;

		this._SetList();
		this.UpdataWarn();
	},

	UpdataWarn:function () {
		var items = this._listView.getItems();
		for ( var i = 0; i != items.length; i++ ) {
			var warn = false;

			var ifRank = !items[i].IsShortRank();  //品阶是否足够
			var ifMax = items[i].IsReachMax();  // 是否满星
			var ifSuit = !items[i].IsShortSuits();  // 是否集齐一套
			var ifMaterial = !items[i].IsShortMetar();  // 材料是否足够
			if ( ifRank && !ifMax && ifSuit && ifMaterial )
				warn = true;
			items[i].imgWarn.visible = warn;
		}
	},
} );
SuitMakePanelExt.PanelName = "SuitMakePanelExt";
PanelClassDic["SuitMakePanelExt"] = SuitMakePanelExt;
