///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//SwordRankInfo 华山论剑排行信息

// 请求消息
//125201,ReqEnterSwordZone 请求进入华山论剑副本
//125202,ReqEnterSwordZoneNextLayer 请求进入华山论剑副本下一层
//125203,ReqSwordRankInfo 请求华山论剑排名信息

// 接收消息
//125101,ResSendSwordZoneOpen 发送华山论剑开启
//125102,ResSwordZonePanelInfo 华山论剑副本内面板信息
//125103,ResSwordZoneSuccessInfo 华山论剑本层副挑战成功
//125104,ResSwordRankInfo 发送华山论剑排行榜信息


var SwordRankInfo = cc.Class.extend({
	ctor:function(){
		this.playerId = null; // 玩家id
        this.playerName = null; // 玩家名字
        this.score = 0; // 积分
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.playerName);
        _buf.WriteVarInt(this.score);
	},
	
	reading:function( _buf ){
		this.playerId = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.score = _buf.ReadVarInt();
	},
});
////////////////////
// 发送华山论剑开启 //
////////////////////
var ResSendSwordZoneOpenMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 125101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.sword.RecvResSendSwordZoneOpenMessage(this);
	},

});
////////////////////
// 华山论剑副本内面板信息 //
////////////////////
var ResSwordZonePanelInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.score = 0; // 玩家积分(累计)
        this.layer = 0; // 层数
        this.maxLayer = 0; // 本次活动玩家达到的最大层数
        this.killNums = 0; // 杀人数
        this.npcOwnerId = null; // Npc拥有者id
        this.npcOwnerName = null; // Npc拥有者名字
	},

	getId:function(){
		return 125102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.score);
        _buf.WriteByte(this.layer);
        _buf.WriteByte(this.maxLayer);
        _buf.WriteVarInt(this.killNums);
        _buf.WriteLong(this.npcOwnerId);
        _buf.WriteString(this.npcOwnerName);
	},
	
	reading:function( _buf ){
        this.score = _buf.ReadVarInt();
        this.layer = _buf.ReadByte();
        this.maxLayer = _buf.ReadByte();
        this.killNums = _buf.ReadVarInt();
        this.npcOwnerId = _buf.ReadLong();
        this.npcOwnerName = _buf.ReadString();
	},

	action:function(){
		Mgr.sword.RecvResSwordZonePanelInfoMessage(this);
	},

});
////////////////////
// 华山论剑本层副挑战成功 //
////////////////////
var ResSwordZoneSuccessInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.layer = 0; // 层数
	},

	getId:function(){
		return 125103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.layer);
	},
	
	reading:function( _buf ){
        this.layer = _buf.ReadByte();
	},

	action:function(){
		Mgr.sword.RecvResSwordZoneSuccessInfoMessage(this);
	},

});
////////////////////
// 发送华山论剑排行榜信息 //
////////////////////
var ResSwordRankInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.swordRankInfo = []; // 华山论剑排行榜信息 SwordRankInfo
        this.myRankInfo = null; // 我的排名信息
        this.myRank = 0; // 我的排名
	},

	getId:function(){
		return 125104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.swordRankInfo.length );
        for (var i = 0; i < this.swordRankInfo.length; i++) {
            _buf.WriteBean(this.swordRankInfo[i]);
        }
        _buf.WriteBean(this.myRankInfo);
        _buf.WriteVarInt(this.myRank);
	},
	
	reading:function( _buf ){
        var swordRankInfo_length = _buf.ReadShort();
        for (var i = 0; i < swordRankInfo_length; i++) {
            this.swordRankInfo[i] = _buf.ReadBean(SwordRankInfo);
        }
        this.myRankInfo = _buf.ReadBean(SwordRankInfo);
        this.myRank = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.sword.RecvResSwordRankInfoMessage(this);
	},

});
////////////////////
// 请求进入华山论剑副本 //
////////////////////
var ReqEnterSwordZoneMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 125201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求进入华山论剑副本下一层 //
////////////////////
var ReqEnterSwordZoneNextLayerMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 125202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求华山论剑排名信息 //
////////////////////
var ReqSwordRankInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 125203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(125101, ResSendSwordZoneOpenMessage);
MESSAGE_POOL.Add(125102, ResSwordZonePanelInfoMessage);
MESSAGE_POOL.Add(125103, ResSwordZoneSuccessInfoMessage);
MESSAGE_POOL.Add(125104, ResSwordRankInfoMessage);

