///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//TaskSubRateInfo 任务完成进度消息
//TaskInfo 任务消息

// 请求消息
//124201,ReqTaskList 获取任务列表
//124202,ReqAcceptTask 请求接受任务
//124203,ReqfinishTask 请求完成任务
//124204,ReqQuickfinishTask 请求一键完成任务
//124205,ReqSkipTask 跳过剧情任务

// 接收消息
//124101,ResTaskInformation 返回玩家身上当前所有任务信息
//124102,ResTaskAccepted 任务接受后返回前端消息
//124103,ResTaskChange 任务进度改变
//124104,ResTaskSubmited 任务已完成消息


var TaskSubRateInfo = cc.Class.extend({
	ctor:function(){
		this.modelId = 0; // 任务对象模板id(可能是道具ID,也可能是怪物ID,这个要看任务子类型是什么)
        this.num = 0; // 完成进度
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.modelId);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
		this.modelId = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
	},
});
var TaskInfo = cc.Class.extend({
	ctor:function(){
		this.taskId = null; // 任务唯一id
        this.taskModelId = 0; // 任务模板id
        this.taskSubType = 0; // 任务子类型
        this.remainTiime = 0; // 剩余时间(秒),-1 无限 0过期 大于0有剩余时间
        this.taskSubRateInfolist = []; // 子类型完成进度 TaskSubRateInfo
	},

	writing:function( _buf ){
		_buf.WriteLong(this.taskId);
        _buf.WriteVarInt(this.taskModelId);
        _buf.WriteVarInt(this.taskSubType);
        _buf.WriteVarInt(this.remainTiime);
        _buf.WriteShort( this.taskSubRateInfolist.length );
        for (var i = 0; i < this.taskSubRateInfolist.length; i++) {
            _buf.WriteBean(this.taskSubRateInfolist[i]);
        }
	},
	
	reading:function( _buf ){
		this.taskId = _buf.ReadLong();
        this.taskModelId = _buf.ReadVarInt();
        this.taskSubType = _buf.ReadVarInt();
        this.remainTiime = _buf.ReadVarInt();
        var taskSubRateInfolist_length = _buf.ReadShort();
        for (var i = 0; i < taskSubRateInfolist_length; i++) {
            this.taskSubRateInfolist[i] = _buf.ReadBean(TaskSubRateInfo);
        }
	},
});
////////////////////
// 返回玩家身上当前所有任务信息 //
////////////////////
var ResTaskInformationMessage = cc.Class.extend( {
	ctor:function(){
		this.acceptedList = []; // 已接任务列表 TaskInfo
        this.taskModelId = 0; // 最后完成主线任务id
        this.dailyTaskTimes = 0; // 当天已经完成日常任务的次数
        this.rewardTaskTimes = 0; // 当天已经完成悬赏任务的次数
        this.guildTaskTimes = 0; // 当天已经完成帮会任务的次数
	},

	getId:function(){
		return 124101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.acceptedList.length );
        for (var i = 0; i < this.acceptedList.length; i++) {
            _buf.WriteBean(this.acceptedList[i]);
        }
        _buf.WriteVarInt(this.taskModelId);
        _buf.WriteVarInt(this.dailyTaskTimes);
        _buf.WriteVarInt(this.rewardTaskTimes);
        _buf.WriteVarInt(this.guildTaskTimes);
	},
	
	reading:function( _buf ){
        var acceptedList_length = _buf.ReadShort();
        for (var i = 0; i < acceptedList_length; i++) {
            this.acceptedList[i] = _buf.ReadBean(TaskInfo);
        }
        this.taskModelId = _buf.ReadVarInt();
        this.dailyTaskTimes = _buf.ReadVarInt();
        this.rewardTaskTimes = _buf.ReadVarInt();
        this.guildTaskTimes = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.task.RecvResTaskInformationMessage(this);
	},

});
////////////////////
// 任务接受后返回前端消息 //
////////////////////
var ResTaskAcceptedMessage = cc.Class.extend( {
	ctor:function(){
		this.taskInfo = null; // 当前任务消息
	},

	getId:function(){
		return 124102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.taskInfo);
	},
	
	reading:function( _buf ){
        this.taskInfo = _buf.ReadBean(TaskInfo);
	},

	action:function(){
		Mgr.task.RecvResTaskAcceptedMessage(this);
	},

});
////////////////////
// 任务进度改变 //
////////////////////
var ResTaskChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.taskInfo = null; // 当前任务消息
	},

	getId:function(){
		return 124103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.taskInfo);
	},
	
	reading:function( _buf ){
        this.taskInfo = _buf.ReadBean(TaskInfo);
	},

	action:function(){
		Mgr.task.RecvResTaskChangeMessage(this);
	},

});
////////////////////
// 任务已完成消息 //
////////////////////
var ResTaskSubmitedMessage = cc.Class.extend( {
	ctor:function(){
		this.taskId = null; // 任务id
	},

	getId:function(){
		return 124104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.taskId);
	},
	
	reading:function( _buf ){
        this.taskId = _buf.ReadLong();
	},

	action:function(){
		Mgr.task.RecvResTaskSubmitedMessage(this);
	},

});
////////////////////
// 获取任务列表 //
////////////////////
var ReqTaskListMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 124201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求接受任务 //
////////////////////
var ReqAcceptTaskMessage = cc.Class.extend( {
	ctor:function(){
		this.taskModelId = 0; // 任务id
	},

	getId:function(){
		return 124202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.taskModelId);
	},
	
	reading:function( _buf ){
        this.taskModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求完成任务 //
////////////////////
var ReqfinishTaskMessage = cc.Class.extend( {
	ctor:function(){
		this.taskId = null; // 任务唯一id
	},

	getId:function(){
		return 124203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.taskId);
	},
	
	reading:function( _buf ){
        this.taskId = _buf.ReadLong();
	},

});
////////////////////
// 请求一键完成任务 //
////////////////////
var ReqQuickfinishTaskMessage = cc.Class.extend( {
	ctor:function(){
		this.taskId = null; // 任务唯一id
	},

	getId:function(){
		return 124204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.taskId);
	},
	
	reading:function( _buf ){
        this.taskId = _buf.ReadLong();
	},

});
////////////////////
// 跳过剧情任务 //
////////////////////
var ReqSkipTaskMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 124205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(124101, ResTaskInformationMessage);
MESSAGE_POOL.Add(124102, ResTaskAcceptedMessage);
MESSAGE_POOL.Add(124103, ResTaskChangeMessage);
MESSAGE_POOL.Add(124104, ResTaskSubmitedMessage);

