﻿/*
*任务管理器
*/
var TaskModMgr = TaskModMgr || cc.Class.extend({

	aLastTaskId : 0,		//上一个完成的主线任务
	aCurTaskId : 0,			//当前主线任务
	aNextTaskId : 0,		//下一个主线任务(完成任务时接取任务用 自动接取用不上)

	dailyTaskTimes : 0,
	guildTaskTimes : 0,
    rewardTaskTimes:0,
	_npcTaskPanel : null,

	// _mainTaskList : [],
	// _dailyTaskList : [],
	// _guildTaskList : [],
	allTaskHash : null,

	//任务追踪面板
	_taskTrackPanel : null,

	//监听回调
	listerCallBack:false,

	zoneWaitTaskId:-1,		//副本中任务需出副本后再继续
	isAutoTask:true,
	waitTaskId:0,			//刚执行了跑或者攻击 不能马上执行跑 需等待
	ctor:function() {	
//		this._super();
		this.allTaskHash  = new HashMap();
	},

	SetPanel:function (Panel)
	{
		this._taskTrackPanel = Panel;
	},

	IsCompleteTask:function(id)
	{
		return this.aLastTaskId >= id;
	},

	RecvResTaskInformationMessage:function(msg) {
		this.aLastTaskId = msg.taskModelId;
		this.dailyTaskTimes = msg.dailyTaskTimes;
		this.guildTaskTimes = msg.guildTaskTimes;
		this.rewardTaskTimes = msg.rewardTaskTimes;

		this.allTaskHash.Clear();
		//this._mainTaskList.length = 0;
		//this._dailyTaskList.length = 0;
		//this._guildTaskList.length = 0;

		var taskData = null;
		//缓存所有任务
		for (var i = 0; i != msg.acceptedList.length; i++) {
			var taskInfo = msg.acceptedList[i];
			cc.log("======PutTaskInfo====" + taskInfo.taskId)
			this.PutTaskInfo(taskInfo);
			//this.PutTaskInfoInList(bean.q_mission_mainType,msg.acceptedList[i]);
		}

		if (!this.aCurTaskId && this.aLastTaskId){
			taskData = Q_mission_base.Get(this.aLastTaskId);
			this.aNextTaskId = taskData ? taskData.q_next_task : 0;
		}
		cc.log( "上一个完成任务: " + this.aLastTaskId + "   当前任务: " + this.aCurTaskId + "    下一任务: " + this.aNextTaskId );
		//任务追踪面板
		//Mgr.uiMgr.ShowPanelByType( TaskTrackPanelExt.PanelName, UIMgr.PANEL_LAYER_FIX);
		if (this._taskTrackPanel && !Mgr.zone.IsInZoneMap())
			this._taskTrackPanel.UpdateTaskTrack();

		// 新功能开放初始化
		BtnGroupUtil.CheckInit();
		Mgr.npc.UpdateTaskState();
	},

	RecvResTaskAcceptedMessage:function(msg) {
		if( !this.aCurTaskId && !this.aNextTaskId )
			return;
		cc.log("接受任务: " + msg.taskInfo.taskModelId );
		//更新
		this.PutTaskInfo( msg.taskInfo );
		if (this._taskTrackPanel)
			this._taskTrackPanel.UpdateTaskTrack();

		//自动任务
		var taskData = Q_mission_base.Get( msg.taskInfo.taskModelId );
		if( taskData ) {
			switch (taskData.q_mission_mainType) {
				case EnumTaskType.TYPE_MAIN:
					if( Mgr.sceneMap.ZoneType() )	//出副本在继续任务
						Mgr.task.zoneWaitTaskId = msg.taskInfo.taskModelId;
					else if( this.isAutoTask )
						Mgr.task.AutoTask(this.aCurTaskId);
					break;
				case EnumTaskType.TYPE_DAY:
					Mgr.task.AutoTask(msg.taskInfo.taskModelId);
					break;
				case EnumTaskType.TYPE_GUILD:
					Mgr.task.AutoTask(msg.taskInfo.taskModelId);
					break;
                case EnumTaskType.CONQUER:
                    TaskUtil.ShowConquerMissionPanel(msg.taskInfo);
                    break;
			}
		}
		Mgr.npc.UpdateTaskState();
	},

	RecvResTaskChangeMessage:function(msg) {
		//更新任务  满进度后自动提交
		// var taskData = Q_mission_base.Get(msg.taskInfo.taskModelId);
		// if (!taskData || taskData.length == 0)
		// 	return;

		//this.PutTaskInfoInList(taskData.q_mission_mainType,msg.taskInfo);
		this.PutTaskInfo( msg.taskInfo );
		if (this._taskTrackPanel)
			this._taskTrackPanel.UpdateTaskTrack();

        // 更新悬赏任务
        var taskData = Q_mission_base.Get( msg.taskInfo.taskModelId );
        if(taskData && taskData.q_mission_mainType ==  EnumTaskType.CONQUER){
            // 如果界面显示中则更新
            if(Mgr.uiMgr.IsPanelShowByName(TaskXuanShangRenWuExt.PanelName)){
                var p = Mgr.uiMgr.GetPanelByType(TaskXuanShangRenWuExt.PanelName);
                if(p) p.RefreshView(msg.taskInfo);
            }

            // 自动进行下一步
			if( TimerUtil.BlockTime("CONQUER_COMPLETE_AUTO_CHECK", 500))
				return;
            var missionCompleted = TaskUtil.CheckTaskComplate(msg.taskInfo.taskModelId, msg.taskInfo) == EnumTaskState.STATE_UNSUBMIT;
            if(missionCompleted){
                //cc.log("检测到已完成，自动下一步")
                if(taskData.q_mission_type == NpcSubTaskType.TASK_PASS_ZONE && Mgr.sceneMap.ZoneType()){
                    // 副本的情况自动延迟追踪
                    Mgr.task.zoneWaitTaskId = msg.taskInfo.taskModelId;
                }else{
                    Mgr.task.AutoTask(msg.taskInfo.taskModelId);
                }
            }
        }

		// //完成条件
		// var finnishC = taskData.q_finish_information_str.split(",");
		// if (finnishC.length <= 0)
		// 	return;
        //
		// var monsterId = finnishC[0];
		// var needNum = finnishC[1];
        //
		// var list = msg.taskInfo.taskSubRateInfolist;
		// if (!list || list.length == 0)
		// 	return;
        //
		// for (var info in list) {
		// 	if (info.modelId == monsterId) {
		// 		if (info.num < needNum) {
		// 			if (Mgr.map.nCurtargetgid == 0) { //当前攻击对象已经死亡
		// 				//自动下一个
		// 				Mgr.task.AutoTask(this.aCurTaskId);
		// 				break;
		// 			}
		// 		}
		// 	}
		// }
	},

	RecvResTaskSubmitedMessage:function(msg) {
		var taskInfo = this.allTaskHash.Get( msg.taskId );
		this.allTaskHash.Remove( msg.taskId );
		var taskData = Q_mission_base.Get( taskInfo.taskModelId );
		var info = null;
		if( taskData ){
			switch (taskData.q_mission_mainType){
				case EnumTaskType.TYPE_MAIN:
					this.aLastTaskId = this.aCurTaskId;
					this.aCurTaskId = 0;	//自动接取清空就行了
					// this.aCurTaskId = this.aNextTaskId;
                    info = JSON.parse(Q_mission_reword.Get(taskData.q_reword_id).q_reward);
					break;
				case EnumTaskType.TYPE_DAY:
					this.dailyTaskTimes++;
					break;
                case EnumTaskType.TYPE_BRANCH:
                	info = JSON.parse(Q_mission_reword.Get(taskData.q_reword_id).q_reward);
                    break;
				case EnumTaskType.TYPE_GUILD:
					this.guildTaskTimes++;
					break;
                case EnumTaskType.CONQUER:
                    this.rewardTaskTimes++;
                	break;
			}
		}
		Mgr.gameSoundMgr.PlaySound("mission_complete",SoundType.UI);
		if (this._taskTrackPanel)
			this._taskTrackPanel.UpdateTaskTrack(true, info);
		BtnGroupUtil.MainPlayerLevelUpHandler();//检查新功能开放
		Mgr.npc.UpdateTaskState();
	},
	SendReqTaskListMessage:function(msg) {	
	},

	SendReqAcceptTaskMessage:function(mid) {
		// var msg = new ReqAcceptTaskMessage();
		// msg.taskModelId = mid;
		// Mgr.msgMgr.Send(msg);
	},

	SendReqfinishTaskMessage:function(mid) {
		var taskV = this.GetTaskInfo(mid);

		var msg = new ReqfinishTaskMessage();
		msg.taskId = taskV.taskId;
		Mgr.msgMgr.Send(msg);
	},

	SendReqQuickfinishTaskMessage:function(msg) {
	},

	PutTaskInfo:function( taskInfo ){
		var taskData = Q_mission_base.Get( taskInfo.taskModelId );
		if( taskData ){
			switch( taskData.q_mission_mainType ){
				case EnumTaskType.TYPE_MAIN:
					this.aCurTaskId = taskInfo.taskModelId;
					taskData = Q_mission_base.Get( this.aCurTaskId );
					this.aNextTaskId = taskData ? taskData.q_next_task : 0;
					break;
			}
			this.allTaskHash.Put( taskInfo.taskId, taskInfo );
		}
	},

	/**
	 * 获取某一个任务的状态
	 * @param taskID
	 * @return
	 *
	 */
	GetTaskState:function ( taskmid ) {
		var allTaskList =  Mgr.task.allTaskHash.Values();
		for ( var i = 0; i != allTaskList.length; i++) {
			if (taskmid == allTaskList[i].taskModelId)
				return TaskUtil.CheckTaskComplate(taskmid, allTaskList[i]);
		}

		return EnumTaskState.STATE_UNGET; //未领取
	},

	/**
	 * 获取任务数据
	 * @param taskMid
	 * @return
	 *
	 */
	GetTaskInfo:function ( taskmid ) {
		var allTaskList = Mgr.task.allTaskHash.Values();
		for ( var i = 0; i != allTaskList.length; i++ ) {
			if ( allTaskList[i].taskModelId == taskmid )
				return allTaskList[i];
		}
		return null;
	},
	/**
	 * 获取任务列表
	 * @constructor
	 */
	GetAllTaskInfo:function()
	{
		var list = Mgr.task.allTaskHash.Values();
		var comList = [];
		var mainTask = null;
        for(var i = list.length - 1; i >= 0; i--){
        	if(Q_mission_base.Get(list[i].taskModelId).q_mission_mainType == EnumTaskType.TYPE_MAIN){
                mainTask = list[i];
                list.splice(i, 1);
                continue;
			}
            if(TaskUtil.CheckTaskComplate(list[i].taskModelId, list[i]) == EnumTaskState.STATE_UNSUBMIT
                //特殊处理悬赏任务位置不跳动
                && Q_mission_base.Get(list[i].taskModelId).q_mission_mainType != EnumTaskType.CONQUER
            ){
                comList.push(list[i]);
            	list.splice(i, 1);
			}
        }
        comList.sort(function(a,b){
            return  Q_mission_base.Get( b.taskModelId ).q_mission_mainType - Q_mission_base.Get( a.taskModelId ).q_mission_mainType;
        });
		list.sort(function(a,b){
			return  Q_mission_base.Get( b.taskModelId ).q_mission_mainType - Q_mission_base.Get( a.taskModelId ).q_mission_mainType;
		});
		if(mainTask)
			comList.unshift(mainTask);
		comList.push.apply(comList, list);

        /// 客户端特殊处理护送任务
        var taskInfo = Mgr.convoy.GetConvoyTaskInfo();
        if(taskInfo) comList.unshift({
            taskInfo: taskInfo,
            clientOnly : true,
        })

		return comList;
	},
	AutoTask:function (taskmid) {
		if (taskmid == 0)
			return;

		if( Mgr.sceneMap.bChangingState )
			return;

		Mgr.mainPlayer.StopAutoPath();

		//清除自动打怪状态
		if (Mgr.player.isAutoFight)
			Mgr.player.TryStopAutoFight();

		Mgr.mainPlayer.oCtrlAutoFight.ClearLockAutoAttackTarget();

		var taskData = Q_mission_base.Get(taskmid);
		if (!taskData || taskData.length == 0)
			return;
		if( TaskUtil.DoSpecialTask(taskmid) )
			return;

		var subTaskType = taskData.q_mission_type;
		//完成条件
		var condition = TaskUtil.GetTaskCondition(taskmid);
		if (subTaskType == NpcSubTaskType.TASK_ZONE || subTaskType == NpcSubTaskType.TASK_PASS_ZONE) {  //副本

			// Mgr.task.SendReqBarrierEnterZoneMessage();

			if( taskData.q_mission_mainType == EnumTaskType.TYPE_MAIN ){
				Mgr.zone.SendReqZoneEnterToGameMessage( condition.conditionId );	//直接飞进去
				return;
			}

			var fbData = Q_zone.Get(condition.conditionId);
			if (fbData == null)
				return;
			if (fbData.q_zone_type == EnumZoneType.TYPE_JQ || fbData.q_zone_type == EnumZoneType.TYPE_JJ || fbData.q_zone_type == EnumZoneType.TYPE_JY || fbData.q_zone_type == EnumZoneType.TYPE_WD )//副本
			{
				if(!Mgr.uiMgr.IsPanelShowByName(BattlePanelExt.PanelName)){
					Mgr.uiMgr.ShowPanelByType(BattlePanelExt.PanelName);
				}
				
				Mgr.zone.battleZoneBackGroundPanel.ChangeView(fbData.q_zone_type, null, fbData.q_id);
            }else if(fbData.q_zone_type == EnumZoneType.TYPE_XINGMO){
                Mgr.zone.SendReqZoneEnterToGameMessage(fbData.q_id);
            }
		}else if( subTaskType == NpcSubTaskType.TASK_MONSTER ){
			if( Mgr.mainPlayer.IsCanDoRun(true) ){
				Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(condition.mapId, condition.pos, AutoPathParam.CreateAutoFight(), taskData.q_coordinate ? taskData.q_coordinate : "", taskData.q_mission_mainType ==  EnumTaskType.CONQUER); // ""表明是任务寻路
			}
			else{
				this.waitTaskId = taskmid;
			}
		}
		else if( subTaskType == NpcSubTaskType.TASK_COLLECT_PROPS ){
			if( Mgr.mainPlayer.IsCanDoRun(true) ){
				Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(condition.mapId, condition.pos, AutoPathParam.CreateSelectNpc(condition.conditionId), taskData.q_coordinate ? taskData.q_coordinate : "");
			}
			else{
				this.waitTaskId = taskmid;
			}
		}
		else{
			var npcId = TaskUtil.GetNpcIdByTask(taskmid, EnumTaskState.STATE_UNSUBMIT);
			if( npcId ){	//subTaskType == NpcSubTaskType.TASK_TALK
				var npc = Q_npc.Get(npcId);
				if( Mgr.mainPlayer.IsCanDoRun(true) ) {
					Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(condition.mapId, new cc.p( npc.q_x, npc.q_y), AutoPathParam.CreateSelectNpc(npcId), taskData.q_coordinate ? taskData.q_coordinate : "");
				}
				else{
					this.waitTaskId = taskmid;
				}
			}
		}
	},
	StopAutoTask:function(){
		this.isAutoTask = false;
		Mgr.map.SendReqPlayerStopMessage();
	},
	StartAutoTask:function(){
		this.isAutoTask = true;
		this.AutoTask(this.aCurTaskId);
	},
	CheckAutoTask:function(){
		if(this.waitTaskId){
			if( Mgr.mainPlayer.IsCanDoRun(true) ) {
				this.AutoTask(this.waitTaskId);
				this.waitTaskId = 0;
			}
		}
	},

	// //任务分类存放
	// PutTaskInfoInList:function(type, info) {
	// 	switch (type) {
	// 		case EnumTaskType.TYPE_MAIN:
	// 		{
	// 			this._mainTaskList.push(info);
	// 			Mgr.task.allTaskHash.Put(info.taskId, info);
	// 			break;
	// 		}
	// 		case EnumTaskType.TYPE_DAY:
	// 		{
	// 			this._dailyTaskList.push(info);
	// 			Mgr.task.allTaskHash.Put(info.taskId, info);
	// 			break;
	// 		}
	// 		case EnumTaskType.TYPE_GUILD:
	// 		{
	// 			this._guildTaskList.push(info);
	// 			Mgr.task.allTaskHash.Put(info.taskId, info);
	// 			break;
	// 		}
	// 		default:
	// 		{
	// 			break;
	// 		}
	// 	}
	// },
    //
	// //移除分类中的指定任务
	// RemoveTaskById:function (taskId) {
	// 	for (var ts in this._mainTaskList) {
    //
	// 	}
	// }
});