var TaskTrackPanelExt = TaskTrackPanel.extend ( {
	_className:"TaskTrackPanelExt",

	_panel_type_task:0,
	_panel_type_team:1,
    oldTaskListHeight:0,
	_panelType:null,

    _textTeam:"",
	_textTask:"",

	teamOtherNode:null,

	_playerHeadPanelArr:[],
	_timerIndex:0,
	_headers:null,
    _allowToggleTaskTrack: false,
    _showTaskTrack: true,
	taskListview:null,
	_btnStates : [ MUICheckBox.STATE_CHECK , MUICheckBox.STATE_UNCHECK],
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_LU;
		this.layoutCom.layoutOffx = 0;
		this.layoutCom.layoutOffy = -120;
		this._headers = [];

        this._cacheItems1 = [];
        this._cacheItems2 = [];
    },

    onExit:function(){
        for(var i=0;i!=this._cacheItems1.length;++i){
            this._cacheItems1[i].release();
        }
        for(var i=0;i!=this._cacheItems2.length;++i){
            this._cacheItems2[i].release();
        }
        this._cacheItems1.length = 0;
        this._cacheItems2.length = 0;

        this._super();
    },

	Init:function()
	{
		Mgr.task.SetPanel(this);
		var self = this;
		TaskTrackPanel.prototype.Init.call( this );
        //this.imgOtherBg.setTouchEnabled(true);
        this.imgOtherBg.setAnchorPoint(cc.p(0,1));
        this.imgOtherBg.y = this.imgOtherBg.y + this.imgOtherBg.height;

        this.imgMonsterBg.visible = false;
        this.imgActiveBg.visible = false;
        this.imgTaskBg.visible = false;

        this.imgHeadBg.x+=2;

		this._AddTaskListview();
		this.imgDi.setTouchEnabled(true);
        this.imgDi.setSwallowTouches(true);
		this.imgGuide.visible = false;
		this.labTips.visible = false;

		this.teamOtherNode = new cc.Node();
        this.teamOtherNode.x = this.imgHeadBg.x;
        this.teamOtherNode.y = this.imgHeadBg.y;
		this.imgDi.addChild(this.teamOtherNode);


		this.UpdataTeamWarn();
		this.btnLeft.addClickEventListener(function (event){
			self._HidePanel(self.btnLeft.GetState() == "check");
		});
		this.ShowRightPanel(true);


		this.sbtnTask.addClickEventListener(function (event){
			self.ChangePage(self._panel_type_task);
		});
		this.sbtnTeam.addClickEventListener(function (event){
            if(self.isTeam)
				self._DoubleClickTeamPageBtn();
			self.ChangePage(self._panel_type_team);
		});

		this.btnQuit.addClickEventListener(function (event){
			if ( event.type == 0 )
			{  // 匹配
				//Mgr.team.SendReqDismissTeamToGameMessage();//解散
				Mgr.uiMgr.ShowPanelByType(TeamPanelExt.PanelName).ChangePanel(TeamEnum.PANEL_TEAM_QUICK_TEAM);
			}
			else if ( event.type == 1 )
			{  // 退对
				Mgr.team.SendReqLeaveTeamMessage(1);
			}
			else if (event.type == 2)
			{// 退出
				Mgr.zone.ShowOutZonePanel();
			}
		});

		// 跟随
		this.btnFollow.addClickEventListener(function (event) {
			if ( event.type == 1 ){  // 跟随
				Mgr.team.StartFollow();
			}
			else {

				if (Mgr.zone.IsInZoneMap()) {
					if (Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_LFDR) {
						Mgr.zoneteam.SendReqZoneTeamFollowClientToGameMessage();
					}
					else if (Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_KFDR) {
						Mgr.player.StartOrStopAutoFight();
					}
				}
				else {
					//Mgr.team.StartFollow();
					var teamPlayerNum = Mgr.team.teamInfo.memberinfo.length;
					if (teamPlayerNum < Mgr.team.teamTopPlayerNum) {
						Mgr.uiMgr.ShowPanelByType(TeamYaoqingPanelExt.PanelName);
					}
					else {
						Mgr.tips.ShowNotice("您的队伍已满员，无法邀请新成员");
					}
				}
			}
		});
		this.imgDi.setTouchEnabled(false);
		this.imgTaskBg.setTouchEnabled(true);
		//this.imgTaskBg.addTouchEventListener(function(sender, type){
		//	if ( type == ccui.Widget.TOUCH_BEGAN )
		//		Mgr.task.AutoTask(Mgr.task.aCurTaskId);
		//});

		this.imgClickLayer.setTouchEnabled(true);
        this.imgClickLayer.setSwallowTouches(false);
		this.imgClickLayer.addTouchEventListener(function(sender, type)
        {
			if ( type == ccui.Widget.TOUCH_ENDED )
            {
                var len = Mgr.task._taskTrackPanel.imgHeadBg.getChildren().length;
                if(len<1)
                {
                    self._ShowTeamPanel();
                }
			}
		});
		// 默认界面
		this.sbtnTask.SetButtonState( "check" );
		this.ChangePage(this._panel_type_task);

        // TODO maybe those should be called;
        //this.UpdateTrackShow();
        //this.UpdateTeamTrack();

		this.labTeamDes.visible = false;
	},
	UpdataTeamWarn:function () {
		var warn = Mgr.team.applyList.Values().length > 0 ? true : false;
		this.imgTaskCue.visible = warn;
	},

	UpdateAwardWarn:function(bool){
        this.imgTaskCue.visible = bool;
	},

	_ShowTeamPanel:function()
	{
		Mgr.uiMgr.ShowPanelByType( TeamPanelExt.PanelName );
	},
	_AddTaskListview:function()
	{
		var listview = Mgr.crossteam.GetListview(300,this.imgTrackItem.height);
        listview.setItemsMargin(2);
		listview.x = 2;
		this.imgTrackItem.addChild(listview);
		this.taskListview = listview;
	},
	_DoubleClickTeamPageBtn:function()
	{
		if(this._panelType == this._panel_type_team && this.sbtnTeam.GetState() == this._btnStates[0])
		{
			this._ShowTeamPanel();
		}
	},
	ChangePage:function (type)
	{
        var dirty = this._panelType == type;
        this._panelType = type;
        var isTask = this._panelType == this._panel_type_task;
        //这里只做展示界面切换
        this.imgTrackItem.visible = isTask
        this.imgClickLayer.visible = !isTask;
        this.imgHeadBg.visible = !isTask;
        this.teamOtherNode.visible = !isTask;
        if(isTask)
        {
            this.labTeamDes.visible = false;
            this.sbtnTask.SetButtonState(this._btnStates[0]);
            this.sbtnTeam.SetButtonState(this._btnStates[1]);
            if(this._textTeam)
            	UIUtil.LoadImage(this.labTask1, "other/zhujiemian/word/" + this._textTeam + "11.png");
            this.UpdateTrackShow(dirty);
        }
        else
        {
            this.labTeamDes.visible = true;
            this.sbtnTask.SetButtonState(this._btnStates[1]);
            this.sbtnTeam.SetButtonState(this._btnStates[0]);
            if(this._textTeam)
            	UIUtil.LoadImage(this.labTask1, "other/zhujiemian/word/" + this._textTeam + "01.png");
            if(this._textTask)
            	UIUtil.LoadImage(this.labTask, "other/zhujiemian/word/" + this._textTask + "11.png");
            //组队每次刷新都调的ChangePage 这里先刷新吧 后面应该组队直接调UpdateTeamTrack 只有自己进队才ChangePage
            this.UpdateTeamTrack();
        }
	},

    UpdateTrackWithData:function(title,panelName,allowToggle,noToggle){
        this._showTaskTrack = noToggle;
        this._allowToggleTaskTrack = allowToggle;
        this.UpdateTrackShow();

        if(sys.isObjectValid(this.__panel) && this.__panel._className == panelName){
            this.__panel.UpdateView();
            return;
        }

        this._textTaskTrack = title || "";

        this.imgOtherBg.removeAllChildren(true);

        this.imgOtherBg.width = this.imgOtherBg.uiWidth;
        this.imgOtherBg.height = this.imgOtherBg.uiHeight;

        // this.labTask.SetHtmlText(title);
        var isTask = this._panelType == this._panel_type_task;
        if(isTask)
        	UIUtil.LoadImage(this.labTask, "other/zhujiemian/word/" + title + "01.png");
        else
            UIUtil.LoadImage(this.labTask, "other/zhujiemian/word/" + title + "11.png");

        var classObj = PanelClassDic[panelName];
        if(classObj != null){
            var panel = new classObj(this.imgOtherBg,this);
            panel.LoadPanel();
            this.imgOtherBg.addChild(panel);
            // 标记该控件能否切换
            panel.__allowToggleTaskTrack = allowToggle;
            this.__panel = panel;
            return panel;
        }
    },

	UpdateTeamWithData:function(title, isTeam, panelName){
        // this.labTask1.SetHtmlText(title);
        var isTask = this._panelType == this._panel_type_task;
        if(isTask)
        	UIUtil.LoadImage(this.labTask1, "other/zhujiemian/word/" + title + "11.png");
        else
            UIUtil.LoadImage(this.labTask1, "other/zhujiemian/word/" + title + "01.png");
        this._textTeam = title;
        this.isTeam = isTeam;
        if(this._panelType != this._panel_type_task)
        	this.UpdateTeamTrack();

        if(sys.isObjectValid(this.__teamPanel) && this.__teamPanel._className == panelName){
            this.__teamPanel.UpdateView();
            return;
        }
        if(this.__teamPanel)
        	this.teamOtherNode.removeChild(this.__teamPanel);
        this.__teamPanel = null;

        this.teamOtherNode.width = this.imgHeadBg.uiWidth;
        this.teamOtherNode.height = this.imgHeadBg.uiHeight;

        if(!this.isTeam){
            var classObj = PanelClassDic[panelName];
            if(classObj != null){
                var panel = new classObj(this.teamOtherNode);
                panel.LoadPanel();
                this.teamOtherNode.addChild(panel);
                this.__teamPanel = panel;
            }
		}
	},

	UpdateTrackShow:function(dirty){
        // 在选中状态下多次点击可以切换
        if(this._allowToggleTaskTrack && dirty) this._showTaskTrack = !this._showTaskTrack;
        this.imgMonsterBg.visible = false;
        this.imgActiveBg.visible = false;

        if(this._showTaskTrack){
            // this.labTask.SetHtmlText("任\n务");
			if(this.labTask)
            	UIUtil.LoadImage(this.labTask, "other/zhujiemian/word/renwu01.png");
            this._textTask = "renwu";
            this.taskListview.visible = true;
            this.imgOtherBg.visible = false;
        }else{
            // this.labTask.SetHtmlText(this._textTaskTrack || "");
            if(this._textTaskTrack)
            	UIUtil.LoadImage(this.labTask, "other/zhujiemian/word/" + this._textTaskTrack + "01.png");
            this._textTask = this._textTaskTrack;
            this.taskListview.visible = false;
            this.imgOtherBg.visible = true;
        }
	},

	/************************************ track show control end ***********************************/
	isTeamZone:false,
	isInBoss:false,
	UpdateTeamZoneTeamHead:function()
	{
		this.isTeamZone = true;
		for ( var i = 0; i < this._headers.length; i++ ) {
			this._headers[i].removeFromParent();
		}
		if(Mgr.crossteam.myTeam)
		{
			this.imgTrackItem.visible = true;
			this.btnQuit.visible = true;
			this.btnQuit.setTitleText("退出");
            this.btnFollow.setTitleText("跟随");
			this.btnQuit.type = 2;
			this.btnFollow.visible = true;
			this.labTeamDes.visible = false;
			this.ChangePage(this._panelType);
			// this._ShowZoneTeamHeader();
		}
	},
	UpdateTeamTrack:function () {
		if(!this.isTeam){
            this.btnQuit.visible = false;
            this.btnFollow.visible = false;
            this.labTeamDes.visible = false;
            this.imgClickLayer.visible = false;
            this.imgActiveBg.visible = true;
            this.imgHeadBg.visible = false;

		}
		else{
            if(this.isTeamZone)	//多人副本不更新组队
            {
                return;
            }
            if ( Mgr.team.teamInfo )
            {
                this.imgHeadBg.visible = true;
                this.labTeamDes.visible = false;
                this.imgClickLayer.visible = true;
                this.btnQuit.visible = true;
                this.btnFollow.visible = true;
                if ( Mgr.team.leaderId.Equal( Mgr.player.mainPlayer.sid ))
                {
                    this.btnQuit.setTitleText("匹配");
                    this.btnFollow.setTitleText("邀请");
                    this.btnFollow.type = 0;
                    this.btnQuit.type = 0;
                }
                else
                {
                    this.btnQuit.setTitleText("退队");
                    this.btnFollow.setTitleText("跟随");
                    this.btnFollow.type = 1;
                    this.btnQuit.type = 1;
                }
                if(Mgr.zone.IsInZoneMap())
                {
                    this.btnQuit.visible = false;
                    if ( this.btnFollow.type != 1 ) //跟随状态不隐藏
                        this.btnFollow.visible = false;
                }
            }
            else
            {
                this.labTeamDes.visible = true;
                this.btnQuit.visible = false;
                this.btnFollow.visible = false;
            }
            if(this.isInBoss){
                for ( var i = 0; i < this._headers.length; i++ ) {
                    this._headers[i].removeFromParent();
                }
            }else {
                this._showTeamHeader();
			}
		}
	},
	_ShowZoneTeamHeader:function()
	{
		if( Mgr.crossteam.myTeam ){
			var list = Mgr.crossteam.myTeam.memberinfo;
			for(var i = 0,len = list.length; i < len; i++ )
			{
				if( i >= this._playerHeadPanelArr.length ){
					var pPanel = new TeamHeadpanelExt();
					pPanel.LoadPanel();
					pPanel.retain();
					var pos = cc.p(0,0);
					pos.x = 0;
					pos.y = this.imgTrackItem.height - (pPanel.height + 10) * i;
					pPanel.setAnchorPoint(0,1);
					pPanel.setPosition(pos);
					this._playerHeadPanelArr.push(pPanel);
				}
			}
			this._timerIndex = TimerUtil.TimeUpdate(this.OnUpdateZoneTeamPlayerInfo, this, 1.5);
		}
	},
	OnUpdateZoneTeamPlayerInfo:function()
	{
		if( Mgr.crossteam.myTeam )
		{
			var list = Mgr.crossteam.myTeam.memberinfo;
			var count = 0;
			for(var i = 0; i < this._playerHeadPanelArr.length; i++ )
			{
				var player = null;
				if(list[i])
				{
					player = Mgr.sceneObj.FindObject(list[i].memberId.toGID());
				}
				if(player)
				{
					count++;
					this._playerHeadPanelArr[i].RefreshPlayerInformation(player,i,list[i]);
					if( !this._playerHeadPanelArr[i].parent )
					{
						this.imgHeadBg.addChild(this._playerHeadPanelArr[i]);
					}
				}
				else
				{
					this._playerHeadPanelArr[i].removeFromParent();
				}
			}
		}
		//if(count <= 1)
		//{
		//	this.btnFollow.visible = false;
		//}
		//else
		//{
		//	this.btnFollow.visible = true;
		//}
	},
	ClearPlayerInZoneTeam:function()
	{
        // cc.log("=======ClearPlayerInZoneTeam=======")
		this.isTeamZone = false;
		TimerUtil.ClearTimeUpdate(this._timerIndex, this);
		for(var i = 0,len = this._playerHeadPanelArr.length; i < len; i++ )
		{
			this._playerHeadPanelArr[i].removeFromParent();
		}
		// this.UpdateTeamTrack();
		Mgr.uiMgr.GetPanelByType(RoleHeadPanelExt.PanelName ).SetTarget();
	},
	_showTeamHeader:function () {
		var list = [];
		if ( Mgr.team.teamInfo )
			list = Mgr.team.teamInfo.memberinfo;

		var offy = 0;
		var i = 0;
		for (; i != list.length; i++) {
			var info = list[i];
			var model;
			if ( i < this._headers.length )
				model = this._headers[i];
			else {
				model = new TeamHeadpanelExt();
				model.LoadPanel();
				model.retain();
				this._headers.push(model);
			}
			if ( !model.getParent() )
				this.imgHeadBg.addChild(model);
			model.SetData(info);
			// pos
			var pos = cc.p(0,0);
			pos.x = 0;
			if ( i == 0 ) {
				pos.y = this.imgTrackItem.height - 20;
			}
			else {
				//pos.y = offy - (model.height + 10) * i;
                pos.y = this.imgTrackItem.height - (model.height + 10) * i - 20;
			}

			model.setAnchorPoint(0,1);
			model.setPosition(pos);

			offy = pos.y;
		}
		for ( ; i < this._headers.length; i++ ) {
			if (this._headers[i].getParent())
				this._headers[i].removeFromParent();
		}
	},

    GetTaskItem:function(data,isNextTask){
        var item = null;
        if(data.clientOnly){
            item = this._cacheItems1.pop();
            if(!item){
                item = new TaskInfoItemExtClientOnly(data.taskInfo);
                item.LoadPanel();
                item.retain();
            }else{
                item.UpdateData(data);
            }
        }else{
            item = this._cacheItems2.pop();
            if(!item){
                item = new TaskInfoItemExt(data,isNextTask);
                item.LoadPanel();
                item.retain();
            }else{
                item.UpdateData(data,isNextTask);
            }
        }
        return item;
    },

	//已接任务列表处理
	HandleAcceptedList:function()
	{
        var offset = this.taskListview.getInnerContainerPosition();
        var oldinnerSize = this.taskListview.getInnerContainerSize();

        // 回收 start
        var items = this.taskListview.getItems();
        for(var i=0;i!=items.length;++i){
            var v = items[i];
            v.retain();

            if(v instanceof TaskInfoItemExtClientOnly){
                this._cacheItems1.push(v);
            }else{
                this._cacheItems2.push(v);
            }
        }
        this.taskListview.removeAllChildren();
        // 回收 end

        var listdata = Mgr.task.GetAllTaskInfo();
        var j = 0;
        if(listdata.length>0){
            taskData = Q_mission_base.Get( listdata[0].taskModelId );
            if(taskData && EnumTaskType.TYPE_MAIN != taskData.q_mission_mainType){
                var taskData = {taskModelId:Mgr.task.aNextTaskId};

                var taskitem = this.GetTaskItem(taskData,true);
                this.taskListview.insertCustomItem(taskitem,0);
                taskitem.release();

                j++;
            }

            for(var i = 0; i < listdata.length; i++)
            {
                var taskitem = this.GetTaskItem(listdata[i]);
                this.taskListview.pushBackCustomItem(taskitem);
                taskitem.release();

                j++;
            }
        }else{
            var taskData = {taskModelId:Mgr.task.aNextTaskId};
            var taskitem = this.GetTaskItem(taskData,true);
            this.taskListview.insertCustomItem(taskitem,0);
            taskitem.release();

            j++;
        }

        // 上一次位置的适配
        this.taskListview.doLayout();
        var size = this.taskListview.getContentSize();
        var innerSize = this.taskListview.getInnerContainerSize();
		if(!this.oldTaskListHeight)
            this.oldTaskListHeight = innerSize.height;
        if(offset.y > 0 || offset.y < (size.height - innerSize.height)){
            offset.y =  size.height - innerSize.height + 1;//应该是浮点数计算误差什么的   反正加一个1  让y略大一点  防止出现listView  jump的时候超出导致的跳动（回弹）
        }
        this.taskListview.setInnerContainerPosition(offset);
        this.oldTaskListHeight = innerSize.height;
	},
	UpdateTaskTrack:function (isTaskFinish, info) {
		if( isTaskFinish ){
			var eff = EffectUtil.GetShowEffect(EnumEffectId.TASK_FINISH, EffectUtil.ENUM_TYPE_UI, false );
			eff.x = 300;
			eff.y = 240;
			this.addChild(eff);
			if(info){
				var img = new MUIImage();
                img.retain();
                var imageRes="other/zhujiemian/image/num6/exp.png";
                EngineMgr.uiMgr.GetAsynResByUrl(imageRes, function(){
                    img.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
                    // img.x = img.width/2;
                    // img.y = img.height/2;
                    img.release();
                }, img);
                this.imgDi.addChild(img);
                img.x = this.imgDi.uiWidth;
                img.y = 75;
				var imglabel = new MUIImageLabel();
                imglabel.SetImageUrl("other/zhujiemian/image/num6/0.png");
                var expNum = 0;
                for(var i = 0; i < info.length; i++){
                	if(info[i].mod == -3){
                        expNum = info[i].num;
                        break;
					}
				}
                imglabel.SetString(expNum);
                imglabel.x = 45;
                imglabel.y = 2;
                img.addChild(imglabel);

                var action = cc.sequence([new cc.MoveBy(1, cc.p(0, 100)),
                    new cc.CallFunc(function(){
                    	img.removeFromParent();
					}, this)
                ]);
                img.runAction(action);
			}
			// return;
		}
		this.HandleAcceptedList()
	},

    ShowRightPanel:function(isshow){
        var state = isshow ? "check" : "uncheck";
        this.btnLeft.SetButtonState(state);
        this._HidePanel(this.btnLeft.GetState() == "check");
    },
    _HidePanel:function(boo)
    {
        this.imgDi.stopAllActions();
        if(boo)
        {
            this._PlayAction(0);
        }
        else
        {
            this._PlayAction(-this.imgDi.width);
        }
    },
    _PlayAction:function(xOffset)
    {
        this.imgDi.stopAllActions();
        var moveTo = cc.moveTo(0.2,xOffset,this.imgDi.y);
        this.imgDi.runAction(moveTo);
    },
    // 更新触发特殊任务追踪
    UpdateView:function(){
        this.UpdataTeamWarn();
        this.UpdateTeamWithData("duiwu", true);
        if(Mgr.zone.IsInZoneMap()){
            var zoneType = Mgr.sceneMap.ZoneType();
            switch(zoneType){
                case  EnumZoneType.TYPE_JQ:
                    this.UpdateTrackWithData("tiaozhan",FBTaskPanelExt.PanelName,true);
                    this.UpdateTeamWithData("jiangli", false, FBAwardPanelExt.PanelName);
                    break;
                case  EnumZoneType.TYPE_JJ:
                    this.UpdateTrackWithData("tiaozhan",FBTaskPanelExt.PanelName,true);
                    this.UpdateTeamWithData("jiangli", false, FBAwardPanelExt.PanelName);
                    break;
                case  EnumZoneType.TYPE_JY:
                    this.UpdateTrackWithData("tiaozhan",FBTaskPanelExt.PanelName,true);
                    this.UpdateTeamWithData("jiangli", false, FBAwardPanelExt.PanelName);
                    break;
                case  EnumZoneType.TYPE_WD:
                    this.UpdateTrackWithData("tiaozhan",FBTaskPanelExt.PanelName,true);
                    this.UpdateTeamWithData("jiangli", false, FBAwardPanelExt.PanelName);
                    break;
                case  EnumZoneType.TYPE_VIP:
                    this.UpdateTrackWithData("tiaozhan",FBTaskPanelExt.PanelName,true);
                    this.UpdateTeamWithData("jiangli", false, FBAwardPanelExt.PanelName);
                    break;
                case  EnumZoneType.TYPE_KFDR:
                    this.UpdateTrackWithData("tiaozhan",FBTaskPanelExt.PanelName,true);
                    this.UpdateTeamWithData("paiming", false, FBAwardMainExt.PanelName);
                    break;
                case  EnumZoneType.TYPE_LFDR:
                    this.UpdateTrackWithData("tiaozhan",FBTaskPanelExt.PanelName,false);
                    this.UpdateTeamWithData("paiming", false, FBAwardMainExt.PanelName);
                    break;
                case  EnumZoneType.TYPE_XINGMO:
                    this.UpdateTrackWithData("tiaozhan",FBTaskPanelExt.PanelName,true);
                    // this.UpdateTeamWithData("paiming", false, FBAwardMainExt.PanelName);
                    break;
                case  EnumZoneType.TYPE_KINGGUID:
                    this.UpdateTrackWithData("huodong",KingGuildTaskTrackPanelExt.PanelName,true);
                    break;
                case  EnumZoneType.TYPE_KINGNEUTRAL:
                   this.UpdateTrackWithData("huodong",KingNeutralTaskTrackPanelExt.PanelName,true);
                   break;
                case EnumZoneType.TYPE_SWORD:
                    this.UpdateTrackWithData("huodong",HuashanTaskPaneExt.PanelName,true);
                    this.UpdateTeamWithData("jiangli", false, HuashanAwardPanelExt.PanelName);
                    this.__panel.InitView();
                    this.__teamPanel.InitView();
                    break;
                case EnumZoneType.TYPE_ERENGU:
                    this.UpdateTrackWithData("huodong",FBTaskPanelExt.PanelName,true);
                    break;
                case EnumZoneType.TYPE_GUILDBOSS:
                    this.UpdateTrackWithData("huodong",GuildTaskPaneExt.PanelName,true);
                    this.UpdateTeamWithData("jiangli", false, GuildBossAwardPanelExt.PanelName);
                    this.__teamPanel.InitView();
                    break;
                case  EnumZoneType.TYPE_QINGYUAN:
                    this.UpdateTrackWithData("qingyuan",MarriageZoneTrackPanelExt.PanelName,true);
                    break;
                default:
                    this.UpdateTrackWithData("fuben",ZoneTaskTrackPanelExt.PanelName);
                break;

            }
            return;
        }else{
            //进入世界BOSS打怪
            if(Mgr.monster.IsInMonsterMap()){
                if(Mgr.sceneMap.nMapId == 1002 || Mgr.sceneMap.nMapId == 1003){
                    this.UpdateTrackWithData("huodong",FBTaskPanelExt.PanelName,true);
                    this.UpdateTeamWithData("paiming", false, BossAwardPanelExt.PanelName);
                    this.__teamPanel.InitView();
                }
                else{
                    // this.UpdateTrackWithData("活\n动",WorldBossTaskTrackPanelExt.PanelName,true);
                    // this.UpdateTeamWithData("队\n伍", true);
                    this.UpdateTrackWithData("tiaozhan",FBTaskPanelExt.PanelName,true);
                    this.UpdateTeamWithData("jiangli", false, BossAwardPanelExt.PanelName);
                    this.__panel.InitView();
                    this.__teamPanel.InitView();
				}
                return;
            }
        }
        // 守卫京城
        if(Mgr.guardcpital.CheckActivityIsOpen()){
            this.UpdateTrackWithData("huodong",GuardCapitalTaskTrackPanelExt.PanelName,true);
            this.UpdateTeamWithData("duiwu", true);
            return;
        }

        /// 掌门斗宝
        if(MasterBucketUtil.CheckActivityIsOpen()){
            this.UpdateTrackWithData("huodong",BoxTaskPanelExt.PanelName,true);
            this.UpdateTeamWithData("duiwu", true);
            this.__panel.InitView();
            return;
        }

        // 帮会答题
        if(Mgr.guild.CheckGuildActivityIsOpen() && Mgr.zone.IsInGuildMap()){
            this.UpdateTrackWithData("huodong",GuildDatiTaskPaneExt.PanelName,true);
            this.UpdateTeamWithData("paiming", false, GuildDatiAwardPanelExt.PanelName);
            this.__panel.InitView();
            this.__teamPanel.InitView();
            return;
		}

        // set the default
        this._showTaskTrack = true;
        this._allowToggleTaskTrack = false;
        this.UpdateTrackShow();
        // should clean it?
        this.imgOtherBg.removeAllChildren(true);
    },

    /// 为特殊追踪提供，隐藏自身用
    HideOtherTrack:function(){
        this._showTaskTrack = true;
        this._allowToggleTaskTrack = false;
        this.UpdateTrackShow();
    },

    ShowOtherTrack:function(){
        if(!sys.isObjectValid(this.__panel)) return;

        this._showTaskTrack = false;
        this._allowToggleTaskTrack = this.__panel.__allowToggleTaskTrack;
        this.UpdateTrackShow();
    },
} );
TaskTrackPanelExt.PanelName = "TaskTrackPanelExt";
PanelClassDic["TaskTrackPanelExt"] = TaskTrackPanelExt;
