///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//TeamMemberInfo 队员信息
//TeamMemberBriefInfo 队员简要信息
//TeamInfo 组队信息类
//MapTeamInfo 当前地图队伍信息类
//MapPlayerInfo 当前地图玩家信息类

// 请求消息
//109201,ReqCreateTeam 创建队伍
//109202,ReqJoinTeam 玩家申请加入队伍
//109203,ReqLeaveTeam 玩家离队
//109204,ReqApplyGameSelect 申请入队-队长选择
//109205,ReqInviteTeamSelect 邀请加入队伍--玩家选择
//109207,ReqKickTeam 踢出队伍
//109208,ReqInviteTeam 发出邀请玩家加入队伍
//109209,ReqAppointGame 任命新队长
//109210,ReqAppointGameSelect 任命新队长-玩家选择
//109211,ReqMapSearchTeamInfoGame 前端请求本地图队伍信息
//109212,ReqMapSearchPlayerInfoGame 前端请求搜索本地图玩家信息
//109213,ReqSetTeamOptionsGame 组队选项
//109214,ReqGenericSearchToGame 全服搜索玩家
//109215,ReqTeamInfoToGame 获取当前队伍信息
//109216,ReqDismissTeamToGame 请求解散队伍
//109217,ReqMoveToTeamLeader 请求移动到队长身旁
//109218,ReqNotifyWorldTeamInfo 请求世界频道广播组队信息

// 接收消息
//109101,ResTeamInfo 更新队伍信息
//109102,ResApplyClient 入队申请-通知队长做选择
//109103,ResLeaveTeam 玩家离队
//109104,ResInviteTeam 邀请加入队伍
//109105,ResTeamExteriorClient 更新人物组队信息（视野内群发）
//109106,ResAppointClient 任命新队长-通知玩家做选择
//109111,ResMapSearchTeamInfoClient 本地图队伍信息
//109112,ResMapSearchPlayerInfoClient 本地图玩家信息
//109113,ResTeamSynPosClient 同步同地图同队伍玩家位置
//109114,ResTeamSynMemberinfoClient 同步队员简要信息
//109115,ResSetTeamOptionsClient 组队选项
//109116,ResGenericSearchToClient 返回搜索玩家
//109117,ResNotifyWorldTeamInfo 返回世界频道组队信息广播


var TeamMemberInfo = cc.Class.extend({
	ctor:function(){
		this.memberId = null; // 队员ID
        this.memberName = null; // 队员名字
        this.memberLevel = 0; // 队员等级
        this.memberMapLine = 0; // 队员所在地图线路
        this.memberMapUniqueID = null; // 队员所在地图唯一ID(区分副本用)
        this.memberMapModelID = 0; // 队员所在地图模组ID
        this.x = 0; // 像素坐标x
        this.y = 0; // 像素坐标y
        this.maxhp = 0; // 队员最大血量
        this.guildName = null; // 帮会名
        this.fightPower = 0; // 战斗力
        this.platVip = 0; // 平台vip等级
        this.tencentDomain = 0; // 腾讯登录渠道
        this.appearanceInfo = null; // 造型信息
	},

	writing:function( _buf ){
		_buf.WriteLong(this.memberId);
        _buf.WriteString(this.memberName);
        _buf.WriteVarInt(this.memberLevel);
        _buf.WriteVarInt(this.memberMapLine);
        _buf.WriteLong(this.memberMapUniqueID);
        _buf.WriteVarInt(this.memberMapModelID);
        _buf.WriteShort(this.x);
        _buf.WriteShort(this.y);
        _buf.WriteVarLong(this.maxhp);
        _buf.WriteString(this.guildName);
        _buf.WriteVarLong(this.fightPower);
        _buf.WriteVarInt(this.platVip);
        _buf.WriteVarInt(this.tencentDomain);
        _buf.WriteBean(this.appearanceInfo);
	},
	
	reading:function( _buf ){
		this.memberId = _buf.ReadLong();
        this.memberName = _buf.ReadString();
        this.memberLevel = _buf.ReadVarInt();
        this.memberMapLine = _buf.ReadVarInt();
        this.memberMapUniqueID = _buf.ReadLong();
        this.memberMapModelID = _buf.ReadVarInt();
        this.x = _buf.ReadShort();
        this.y = _buf.ReadShort();
        this.maxhp = _buf.ReadVarLong();
        this.guildName = _buf.ReadString();
        this.fightPower = _buf.ReadVarLong();
        this.platVip = _buf.ReadVarInt();
        this.tencentDomain = _buf.ReadVarInt();
        this.appearanceInfo = _buf.ReadBean(PlayerAppearanceInfo);
	},
});
var TeamMemberBriefInfo = cc.Class.extend({
	ctor:function(){
		this.memberId = null; // 队员ID
        this.hp = 0; // 当前血量
        this.mp = 0; // 当前灵力
        this.debufflist = []; // debuff列表 int
	},

	writing:function( _buf ){
		_buf.WriteLong(this.memberId);
        _buf.WriteVarInt(this.hp);
        _buf.WriteVarInt(this.mp);
        _buf.WriteShort( this.debufflist.length );
        for (var i = 0; i < this.debufflist.length; i++) {
            _buf.WriteVarInt(this.debufflist[i]);
        }
	},
	
	reading:function( _buf ){
		this.memberId = _buf.ReadLong();
        this.hp = _buf.ReadVarInt();
        this.mp = _buf.ReadVarInt();
        var debufflist_length = _buf.ReadShort();
        for (var i = 0; i < debufflist_length; i++) {
            this.debufflist[i] = _buf.ReadVarInt();
        }
	},
});
var TeamInfo = cc.Class.extend({
	ctor:function(){
		this.teamId = null; // 队伍Id
        this.autoIntoteamapply = 0; // 自动接受入队申请 ,1自动
        this.memberinfo = []; // 队伍列表 TeamMemberInfo
	},

	writing:function( _buf ){
		_buf.WriteLong(this.teamId);
        _buf.WriteByte(this.autoIntoteamapply);
        _buf.WriteShort( this.memberinfo.length );
        for (var i = 0; i < this.memberinfo.length; i++) {
            _buf.WriteBean(this.memberinfo[i]);
        }
	},
	
	reading:function( _buf ){
		this.teamId = _buf.ReadLong();
        this.autoIntoteamapply = _buf.ReadByte();
        var memberinfo_length = _buf.ReadShort();
        for (var i = 0; i < memberinfo_length; i++) {
            this.memberinfo[i] = _buf.ReadBean(TeamMemberInfo);
        }
	},
});
var MapTeamInfo = cc.Class.extend({
	ctor:function(){
		this.teamid = null; // 队伍Id
        this.captainid = null; // 队长Id
        this.captainname = null; // 队长名字
        this.captainGuildName = null; // 队长帮会名字
        this.teamnum = 0; // 队伍人数
        this.captainlv = 0; // 队长等级
        this.highestlv = 0; // 最高等级
        this.averagelv = 0; // 平均等级
        this.line = 0; // 所在线路
	},

	writing:function( _buf ){
		_buf.WriteLong(this.teamid);
        _buf.WriteLong(this.captainid);
        _buf.WriteString(this.captainname);
        _buf.WriteString(this.captainGuildName);
        _buf.WriteByte(this.teamnum);
        _buf.WriteShort(this.captainlv);
        _buf.WriteShort(this.highestlv);
        _buf.WriteShort(this.averagelv);
        _buf.WriteByte(this.line);
	},
	
	reading:function( _buf ){
		this.teamid = _buf.ReadLong();
        this.captainid = _buf.ReadLong();
        this.captainname = _buf.ReadString();
        this.captainGuildName = _buf.ReadString();
        this.teamnum = _buf.ReadByte();
        this.captainlv = _buf.ReadShort();
        this.highestlv = _buf.ReadShort();
        this.averagelv = _buf.ReadShort();
        this.line = _buf.ReadByte();
	},
});
var MapPlayerInfo = cc.Class.extend({
	ctor:function(){
		this.playerid = null; // 玩家Id
        this.playerlv = 0; // 玩家等级
        this.teamstate = 0; // 组队状态，0未组队，1已组队
        this.playername = null; // 玩家名字
        this.guildname = null; // 帮会名字
        this.line = 0; // 所在线路
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteShort(this.playerlv);
        _buf.WriteByte(this.teamstate);
        _buf.WriteString(this.playername);
        _buf.WriteString(this.guildname);
        _buf.WriteByte(this.line);
	},
	
	reading:function( _buf ){
		this.playerid = _buf.ReadLong();
        this.playerlv = _buf.ReadShort();
        this.teamstate = _buf.ReadByte();
        this.playername = _buf.ReadString();
        this.guildname = _buf.ReadString();
        this.line = _buf.ReadByte();
	},
});
////////////////////
// 更新队伍信息 //
////////////////////
var ResTeamInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.teamInfo = null; // 队伍信息
	},

	getId:function(){
		return 109101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.teamInfo);
	},
	
	reading:function( _buf ){
        this.teamInfo = _buf.ReadBean(TeamInfo);
	},

	action:function(){
		Mgr.team.RecvResTeamInfoMessage(this);
	},

});
////////////////////
// 入队申请-通知队长做选择 //
////////////////////
var ResApplyClientMessage = cc.Class.extend( {
	ctor:function(){
		this.teamid = null; // 队伍Id
        this.newmemberinfo = null; // 新队员信息
	},

	getId:function(){
		return 109102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.teamid);
        _buf.WriteBean(this.newmemberinfo);
	},
	
	reading:function( _buf ){
        this.teamid = _buf.ReadLong();
        this.newmemberinfo = _buf.ReadBean(TeamMemberInfo);
	},

	action:function(){
		Mgr.team.RecvResApplyClientMessage(this);
	},

});
////////////////////
// 玩家离队 //
////////////////////
var ResLeaveTeamMessage = cc.Class.extend( {
	ctor:function(){
		this.leaveplayerId = null; // 离队玩家Id
	},

	getId:function(){
		return 109103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.leaveplayerId);
	},
	
	reading:function( _buf ){
        this.leaveplayerId = _buf.ReadLong();
	},

	action:function(){
		Mgr.team.RecvResLeaveTeamMessage(this);
	},

});
////////////////////
// 邀请加入队伍 //
////////////////////
var ResInviteTeamMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 邀请人Id
        this.playerName = null; // 邀请人姓名
        this.guildName = null; // 邀请人姓名
        this.playerLevel = 0; // 邀请人等级
        this.teamId = null; // 队伍Id
        this.fightpower = 0; // 队伍Id
	},

	getId:function(){
		return 109104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.playerName);
        _buf.WriteString(this.guildName);
        _buf.WriteVarInt(this.playerLevel);
        _buf.WriteLong(this.teamId);
        _buf.WriteVarLong(this.fightpower);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.guildName = _buf.ReadString();
        this.playerLevel = _buf.ReadVarInt();
        this.teamId = _buf.ReadLong();
        this.fightpower = _buf.ReadVarLong();
	},

	action:function(){
		Mgr.team.RecvResInviteTeamMessage(this);
	},

});
////////////////////
// 更新人物组队信息（视野内群发） //
////////////////////
var ResTeamExteriorClientMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 玩家Id
        this.teamid = null; // 队伍Id
	},

	getId:function(){
		return 109105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteLong(this.teamid);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
        this.teamid = _buf.ReadLong();
	},

	action:function(){
		Mgr.team.RecvResTeamExteriorClientMessage(this);
	},

});
////////////////////
// 任命新队长-通知玩家做选择 //
////////////////////
var ResAppointClientMessage = cc.Class.extend( {
	ctor:function(){
		this.teamid = null; // 队伍Id
        this.captaininfo = null; // 队长信息
	},

	getId:function(){
		return 109106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.teamid);
        _buf.WriteBean(this.captaininfo);
	},
	
	reading:function( _buf ){
        this.teamid = _buf.ReadLong();
        this.captaininfo = _buf.ReadBean(TeamMemberInfo);
	},

	action:function(){
		Mgr.team.RecvResAppointClientMessage(this);
	},

});
////////////////////
// 本地图队伍信息 //
////////////////////
var ResMapSearchTeamInfoClientMessage = cc.Class.extend( {
	ctor:function(){
		this.mapteaminfo = []; // 当前地图队伍列表 MapTeamInfo
	},

	getId:function(){
		return 109111;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.mapteaminfo.length );
        for (var i = 0; i < this.mapteaminfo.length; i++) {
            _buf.WriteBean(this.mapteaminfo[i]);
        }
	},
	
	reading:function( _buf ){
        var mapteaminfo_length = _buf.ReadShort();
        for (var i = 0; i < mapteaminfo_length; i++) {
            this.mapteaminfo[i] = _buf.ReadBean(MapTeamInfo);
        }
	},

	action:function(){
		Mgr.team.RecvResMapSearchTeamInfoClientMessage(this);
	},

});
////////////////////
// 本地图玩家信息 //
////////////////////
var ResMapSearchPlayerInfoClientMessage = cc.Class.extend( {
	ctor:function(){
		this.mapplayerinfo = []; // 当前地图玩家列表 MapPlayerInfo
	},

	getId:function(){
		return 109112;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.mapplayerinfo.length );
        for (var i = 0; i < this.mapplayerinfo.length; i++) {
            _buf.WriteBean(this.mapplayerinfo[i]);
        }
	},
	
	reading:function( _buf ){
        var mapplayerinfo_length = _buf.ReadShort();
        for (var i = 0; i < mapplayerinfo_length; i++) {
            this.mapplayerinfo[i] = _buf.ReadBean(MapPlayerInfo);
        }
	},

	action:function(){
		Mgr.team.RecvResMapSearchPlayerInfoClientMessage(this);
	},

});
////////////////////
// 同步同地图同队伍玩家位置 //
////////////////////
var ResTeamSynPosClientMessage = cc.Class.extend( {
	ctor:function(){
		this.memberid = null; // 队员ID
        this.x = 0; // 像素坐标x
        this.y = 0; // 像素坐标y
	},

	getId:function(){
		return 109113;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.memberid);
        _buf.WriteShort(this.x);
        _buf.WriteShort(this.y);
	},
	
	reading:function( _buf ){
        this.memberid = _buf.ReadLong();
        this.x = _buf.ReadShort();
        this.y = _buf.ReadShort();
	},

	action:function(){
		Mgr.team.RecvResTeamSynPosClientMessage(this);
	},

});
////////////////////
// 同步队员简要信息 //
////////////////////
var ResTeamSynMemberinfoClientMessage = cc.Class.extend( {
	ctor:function(){
		this.teamMemberBriefInfolist = []; // 队员简要信息列表 TeamMemberBriefInfo
	},

	getId:function(){
		return 109114;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.teamMemberBriefInfolist.length );
        for (var i = 0; i < this.teamMemberBriefInfolist.length; i++) {
            _buf.WriteBean(this.teamMemberBriefInfolist[i]);
        }
	},
	
	reading:function( _buf ){
        var teamMemberBriefInfolist_length = _buf.ReadShort();
        for (var i = 0; i < teamMemberBriefInfolist_length; i++) {
            this.teamMemberBriefInfolist[i] = _buf.ReadBean(TeamMemberBriefInfo);
        }
	},

	action:function(){
		Mgr.team.RecvResTeamSynMemberinfoClientMessage(this);
	},

});
////////////////////
// 组队选项 //
////////////////////
var ResSetTeamOptionsClientMessage = cc.Class.extend( {
	ctor:function(){
		this.autoJoinTeam = 0; // 队员选择 是否自动接受邀请,1同意，0拒绝
        this.autoIntoTeamApply = 0; // 当你是队长时,自动接受他人入队申请 ,1同意，0拒绝
	},

	getId:function(){
		return 109115;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.autoJoinTeam);
        _buf.WriteByte(this.autoIntoTeamApply);
	},
	
	reading:function( _buf ){
        this.autoJoinTeam = _buf.ReadByte();
        this.autoIntoTeamApply = _buf.ReadByte();
	},

	action:function(){
		Mgr.team.RecvResSetTeamOptionsClientMessage(this);
	},

});
////////////////////
// 返回搜索玩家 //
////////////////////
var ResGenericSearchToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.mapplayerinfo = []; // 当前地图玩家列表 MapPlayerInfo
	},

	getId:function(){
		return 109116;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.mapplayerinfo.length );
        for (var i = 0; i < this.mapplayerinfo.length; i++) {
            _buf.WriteBean(this.mapplayerinfo[i]);
        }
	},
	
	reading:function( _buf ){
        var mapplayerinfo_length = _buf.ReadShort();
        for (var i = 0; i < mapplayerinfo_length; i++) {
            this.mapplayerinfo[i] = _buf.ReadBean(MapPlayerInfo);
        }
	},

	action:function(){
		Mgr.team.RecvResGenericSearchToClientMessage(this);
	},

});
////////////////////
// 返回世界频道组队信息广播 //
////////////////////
var ResNotifyWorldTeamInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.playerName = null; // 玩家名
        this.teamId = null; // 队伍唯一id
	},

	getId:function(){
		return 109117;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.playerName);
        _buf.WriteLong(this.teamId);
	},
	
	reading:function( _buf ){
        this.playerName = _buf.ReadString();
        this.teamId = _buf.ReadLong();
	},

	action:function(){
		Mgr.team.RecvResNotifyWorldTeamInfoMessage(this);
	},

});
////////////////////
// 创建队伍 //
////////////////////
var ReqCreateTeamMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 109201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 玩家申请加入队伍 //
////////////////////
var ReqJoinTeamMessage = cc.Class.extend( {
	ctor:function(){
		this.teamid = null; // 队伍Id
	},

	getId:function(){
		return 109202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.teamid);
	},
	
	reading:function( _buf ){
        this.teamid = _buf.ReadLong();
	},

});
////////////////////
// 玩家离队 //
////////////////////
var ReqLeaveTeamMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 1 自己离开 ，2下线
	},

	getId:function(){
		return 109203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 申请入队-队长选择 //
////////////////////
var ReqApplyGameSelectMessage = cc.Class.extend( {
	ctor:function(){
		this.teamid = null; // 队伍Id
        this.playerid = null; // 玩家ID
        this.select = 0; // 1同意，0拒绝
	},

	getId:function(){
		return 109204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.teamid);
        _buf.WriteLong(this.playerid);
        _buf.WriteByte(this.select);
	},
	
	reading:function( _buf ){
        this.teamid = _buf.ReadLong();
        this.playerid = _buf.ReadLong();
        this.select = _buf.ReadByte();
	},

});
////////////////////
// 邀请加入队伍--玩家选择 //
////////////////////
var ReqInviteTeamSelectMessage = cc.Class.extend( {
	ctor:function(){
		this.teamid = null; // 队伍Id
        this.select = 0; // 1同意，0拒绝
	},

	getId:function(){
		return 109205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.teamid);
        _buf.WriteByte(this.select);
	},
	
	reading:function( _buf ){
        this.teamid = _buf.ReadLong();
        this.select = _buf.ReadByte();
	},

});
////////////////////
// 踢出队伍 //
////////////////////
var ReqKickTeamMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 被踢的玩家Id
	},

	getId:function(){
		return 109207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
	},

});
////////////////////
// 发出邀请玩家加入队伍 //
////////////////////
var ReqInviteTeamMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 被邀请的玩家Id
	},

	getId:function(){
		return 109208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
	},

});
////////////////////
// 任命新队长 //
////////////////////
var ReqAppointGameMessage = cc.Class.extend( {
	ctor:function(){
		this.teamid = null; // 队伍Id
        this.playerid = null; // 玩家ID
	},

	getId:function(){
		return 109209;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.teamid);
        _buf.WriteLong(this.playerid);
	},
	
	reading:function( _buf ){
        this.teamid = _buf.ReadLong();
        this.playerid = _buf.ReadLong();
	},

});
////////////////////
// 任命新队长-玩家选择 //
////////////////////
var ReqAppointGameSelectMessage = cc.Class.extend( {
	ctor:function(){
		this.teamid = null; // 队伍Id
        this.select = 0; // 1同意，0拒绝
	},

	getId:function(){
		return 109210;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.teamid);
        _buf.WriteByte(this.select);
	},
	
	reading:function( _buf ){
        this.teamid = _buf.ReadLong();
        this.select = _buf.ReadByte();
	},

});
////////////////////
// 前端请求本地图队伍信息 //
////////////////////
var ReqMapSearchTeamInfoGameMessage = cc.Class.extend( {
	ctor:function(){
		this.searchcontent = null; // 搜索内容,空就展示全部
	},

	getId:function(){
		return 109211;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.searchcontent);
	},
	
	reading:function( _buf ){
        this.searchcontent = _buf.ReadString();
	},

});
////////////////////
// 前端请求搜索本地图玩家信息 //
////////////////////
var ReqMapSearchPlayerInfoGameMessage = cc.Class.extend( {
	ctor:function(){
		this.searchcontent = null; // 搜索内容,空就展示全部
	},

	getId:function(){
		return 109212;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.searchcontent);
	},
	
	reading:function( _buf ){
        this.searchcontent = _buf.ReadString();
	},

});
////////////////////
// 组队选项 //
////////////////////
var ReqSetTeamOptionsGameMessage = cc.Class.extend( {
	ctor:function(){
		this.autoIntoTeamApply = 0; // 队长选择 自动通过申请 ,1同意，0拒绝
        this.autoJoinTeam = 0; // 队员选择 是否自动接受邀请,1同意，0拒绝
	},

	getId:function(){
		return 109213;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.autoIntoTeamApply);
        _buf.WriteByte(this.autoJoinTeam);
	},
	
	reading:function( _buf ){
        this.autoIntoTeamApply = _buf.ReadByte();
        this.autoJoinTeam = _buf.ReadByte();
	},

});
////////////////////
// 全服搜索玩家 //
////////////////////
var ReqGenericSearchToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.searchcontent = null; // 搜索内容,空就展示本地图的玩家
	},

	getId:function(){
		return 109214;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.searchcontent);
	},
	
	reading:function( _buf ){
        this.searchcontent = _buf.ReadString();
	},

});
////////////////////
// 获取当前队伍信息 //
////////////////////
var ReqTeamInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.teamid = null; // 队伍Id
	},

	getId:function(){
		return 109215;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.teamid);
	},
	
	reading:function( _buf ){
        this.teamid = _buf.ReadLong();
	},

});
////////////////////
// 请求解散队伍 //
////////////////////
var ReqDismissTeamToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 109216;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求移动到队长身旁 //
////////////////////
var ReqMoveToTeamLeaderMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 109217;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求世界频道广播组队信息 //
////////////////////
var ReqNotifyWorldTeamInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 109218;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(109101, ResTeamInfoMessage);
MESSAGE_POOL.Add(109102, ResApplyClientMessage);
MESSAGE_POOL.Add(109103, ResLeaveTeamMessage);
MESSAGE_POOL.Add(109104, ResInviteTeamMessage);
MESSAGE_POOL.Add(109105, ResTeamExteriorClientMessage);
MESSAGE_POOL.Add(109106, ResAppointClientMessage);
MESSAGE_POOL.Add(109111, ResMapSearchTeamInfoClientMessage);
MESSAGE_POOL.Add(109112, ResMapSearchPlayerInfoClientMessage);
MESSAGE_POOL.Add(109113, ResTeamSynPosClientMessage);
MESSAGE_POOL.Add(109114, ResTeamSynMemberinfoClientMessage);
MESSAGE_POOL.Add(109115, ResSetTeamOptionsClientMessage);
MESSAGE_POOL.Add(109116, ResGenericSearchToClientMessage);
MESSAGE_POOL.Add(109117, ResNotifyWorldTeamInfoMessage);

