﻿var TeamModMgr = TeamModMgr || cc.Class.extend({
	// 队长Id
	leaderId:null,
	// 自身队伍信息
	teamInfo:null,
	// 申请入队列表
	applyList:null,
	teamTopPlayerNum:3,

	// 跟随
	followState:null,
	lastActiveTime:null,
	_timerId:null,

	ctor:function() {
		this.applyList = new HashMap();
		this.followState = false;
		this._timerId = 0;
		this.lastActiveTime = 0;
	},

	RecvResTeamInfoMessage:function(msg) {
		cc.log("------- 更新队伍信息 ------- " +  Mgr.player.mainPlayer.name + "   " +  JSON.stringify(msg));
		var ifFirstOwn = false;
		if ( this.teamInfo == null )
			ifFirstOwn = true;

		this.leaderId = msg.teamInfo.memberinfo[0].memberId;   //  默认第一个为队长
		this.teamInfo = msg.teamInfo;

		// 只有创建队伍时，才主动弹出
		if ( ifFirstOwn && Mgr.player.mainPlayer.sid.Equal( this.leaderId ) )
			Mgr.uiMgr.ShowPanelByType(TeamPanelExt.PanelName).ChangePanel(TeamEnum.PANEL_TEAM_TEAM);

		// 跟随监听
		if ( ifFirstOwn )
			this.StartFollowListen();

		// 更新任务面板
		var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
		if ( ifFirstOwn )
			panel.ChangePage(panel._panel_type_team);
		// else // 刷新team面板导致错误   屏蔽了
		// 	panel.UpdateTeamTrack();
		//刷新队伍面板
		var teamPanel = Mgr.uiMgr.GetPanelByType(TeamPanelExt.PanelName);
		if(Mgr.uiMgr.IsPanelShow(teamPanel)){
			var teamTeamPanel = teamPanel.panelMgr[TeamEnum.PANEL_TEAM_TEAM];
			teamTeamPanel._UpdataPanel();
		}

		Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName ).ShowOrHideTeamChatButton();
	},

	RecvResApplyClientMessage:function(msg) {
		cc.log("------- 入队申请-通知队长做选择 ------- " + JSON.stringify(msg));
		if ( msg.teamid.Equal( this.teamInfo.teamId ))
			this.applyList.Put( msg.newmemberinfo.memberId,msg.newmemberinfo);

		var panel = Mgr.uiMgr.GetPanelByType(TeamPanelExt.PanelName);
		if (panel && panel.visible)
		{
			if (panel.curSubType == TeamEnum.PANEL_TEAM_APPLY)
				panel.curSubPanel.OnShow();
		}
		Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).UpdataTeamWarn();
	},

	RecvResLeaveTeamMessage:function(msg) {
		cc.log("------- 玩家离队 ------- " + JSON.stringify(msg));
		if ( msg.leaveplayerId.Equal( Mgr.player.mainPlayer.sid ) ) {
			this.leaderId = null;
			this.teamInfo = null;
			this.applyList.Clear();

			// 结束跟随监听
			if ( this._timerId != 0 ) {
				this.ClearFollowListen();
			}

			// 隐藏相关界面
			Mgr.uiMgr.HidePanelByType(TeamPanelExt.PanelName);
			Mgr.uiMgr.HidePanelByType(TeamYaoqingPanelExt.PanelName);
			Mgr.uiMgr.HidePanelByType(TeamMemberInfoPanelExt.PanelName);
			Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName ).ShowOrHideTeamChatButton();
		}
		else {
			for ( var i = 0; i != this.teamInfo.memberinfo.length; i++ ) {
				var id = this.teamInfo.memberinfo[i].memberId;
				if ( msg.leaveplayerId.Equal( id ) ) {
					this.teamInfo.memberinfo.splice(i, 1);
					break;
				}
			}
			this.leaderId = this.teamInfo.memberinfo[0].memberId;

			// 刷新成员显示
			var panel = Mgr.uiMgr.GetPanelByType(TeamPanelExt.PanelName);
			if (panel && panel.curSubType == TeamEnum.PANEL_TEAM_TEAM)
				panel.curSubPanel.OnShow();
		}

		// 更新任务面板
		var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
		panel.ChangePage(panel._panel_type_team);
	},

	RecvResInviteTeamMessage:function(msg) {
		cc.log("------- 邀请加入队伍 ------- " +  JSON.stringify(msg));
		if(Mgr.plugset.GetSysSetInfo().banInviteTeam)
		{
			return;
		}
		var self = this;
		var str = msg.playerName + "邀请你加入队伍";
		AlertExt.Show( str, TipsEnum.BUTTON_SURE_AND_FALSE, {
			_onFunc:function(){
				self.SendReqInviteTeamSelectMessage(msg.teamId, 1);
			},
			_offFunc:function(){
				self.SendReqInviteTeamSelectMessage(msg.teamId, 0);
			},
			_offTime:30,
		},1);
		AlertExt.SetButtonTitle("同意", "拒绝");
	},

	RecvResTeamExteriorClientMessage:function(msg) {
		cc.log("------- 更新人物组队信息（视野内群发） ------- " + Mgr.player.mainPlayer.name + "  " + msg.playerid + "  " + msg.teamid + "  "+ JSON.stringify(msg));
		// if ( !this.teamInfo )
		// 	return;
        //
		// if (msg.teamid.IsZero()) {  // 删除
		// 	// 是否当属自己的队伍
		// 	for (var i = 0; i != this.teamInfo.memberinfo.length; i++) {
		// 		var info = this.teamInfo.memberinfo[i];
		// 		if (info.memberId.Equal(msg.playerid)) {
		// 			this.teamInfo.memberinfo.splice(i, 1);
		// 			break;
		// 		}
		// 	}
		// 	// 队长变更
		// 	if ( msg.teamInfo.memberinfo.length > 0 )
		// 		this.leaderId = msg.teamInfo.memberinfo[0].memberId;
		// }
		// else {   // 增加
		// 	// 维护申请列表
		// 	for ( var i = 0; i != this.applyList.length; i++ ) {
		// 		if ( this.applyList[i].memberId.Equal( msg.playerid ) ) {
		// 			this.applyList.splice(i, 1);
        //
		// 			// 刷新申请列表
		// 			var panel = Mgr.uiMgr.GetPanelByType(TeamPanelExt.PanelName);
		// 			if (panel) {
		// 				if ( panel.curSubType == TeamEnum.PANEL_CREATE_APPLY )
		// 					panel.curSubPanel.OnShow();
		// 			}
        //
		// 			break;
		// 		}
		// 	}
		// }
        //
		// // 刷新成员显示
		// var panel = Mgr.uiMgr.GetPanelByType(TeamPanelExt.PanelName);
		// if (panel && panel.curSubType == TeamEnum.PANEL_TEAM_MEMBER)
		// 		panel.curSubPanel._SetMembers();
	},

	RecvResAppointClientMessage:function(msg) {
		cc.log("------- 任命新队长-通知玩家做选择） ------- " + JSON.stringify(msg));
	},

	RecvResMapSearchTeamInfoClientMessage:function(msg) {
		cc.log("------- 本地图队伍信息 ------- " + JSON.stringify(msg));

		var panel = Mgr.uiMgr.GetPanelByType(TeamPanelExt.PanelName);
		if ( panel && panel.curSubType == TeamEnum.PANEL_TEAM_QUICK_TEAM )
			panel.curSubPanel.SetCurMap(msg.mapteaminfo);
	},

	RecvResMapSearchPlayerInfoClientMessage:function(msg) {
		cc.log("------- 本地图玩家信息 ------- " + JSON.stringify(msg));
		var p = Mgr.uiMgr.GetPanelByType(TeamYaoqingPanelExt.PanelName);
		if(p)
		{
			p.ShowMapPlayerList(msg);
		}
		var panel = Mgr.uiMgr.GetPanelByType(YaoqingMainExt.PanelName);
		if(panel && panel.visible)
		{
			panel.SetMapSearchedPlayerInfo(msg);
		}
	},

	RecvResTeamSynPosClientMessage:function(msg) {
		if ( this.followState == true ) {
			Mgr.mainPlayer.oCtrlAutoPath.RunToPt( ToolMap.Pos2GridPt(cc.p( msg.x, msg.y )), AutoPathParam.CreateCallBack(
				function(){
					Mgr.player.TryStartAutoFight();
				},Mgr.player));
		}
	},

	RecvResTeamSynMemberinfoClientMessage:function(msg) {
		cc.log("------- 同步队员简要信息 ------- " + JSON.stringify(msg));
	},

	RecvResSetTeamOptionsClientMessage:function(msg) {
		cc.log("------- 组队选项 ------- " + JSON.stringify(msg));
	},

	RecvResGenericSearchToClientMessage:function(msg) {
		cc.log("------- 返回搜索玩家 ------- " + JSON.stringify(msg));
	},

	SendReqCreateTeamMessage:function() {
		cc.log("---- 创建队伍 ----");
		var msg = new ReqCreateTeamMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqJoinTeamMessage:function(teamId) {
		cc.log("---- 玩家申请加入队伍 ----");
		var msg = new ReqJoinTeamMessage();
		msg.teamid = teamId;
		Mgr.msgMgr.Send(msg);
	},

	SendReqLeaveTeamMessage:function(type) {
		cc.log("---- 退出队伍 ----   "  + type);
		var msg = new ReqLeaveTeamMessage();
		msg.type = type;
		Mgr.msgMgr.Send(msg);
	},

	SendReqDismissTeamToGameMessage:function(type) {
		cc.log("---- 解散队伍 ----");
		var msg = new ReqDismissTeamToGameMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqApplyGameSelectMessage:function(teamId,palyerId, select) {
		cc.log("---- 申请入队-队长选择 ----");
		var msg = new ReqApplyGameSelectMessage();
		msg.teamid = teamId;
		msg.playerid = palyerId;
		msg.select = select;
		Mgr.msgMgr.Send(msg);
	},

	SendReqInviteTeamSelectMessage:function(teamId, select) {
		cc.log("---- 邀请加入队伍--玩家选择 ----");
		var msg = new ReqInviteTeamSelectMessage();
		msg.teamid = teamId;
		msg.select = select;
		Mgr.msgMgr.Send(msg);
	},

	SendReqKickTeamMessage:function(playerId) {
		cc.log("---- 踢出队伍 ----");
		var msg = new ReqKickTeamMessage();
		msg.playerid = playerId;
		Mgr.msgMgr.Send(msg);
	},

	SendReqInviteTeamMessage:function(playerId) {
		cc.log("---- 发出邀请玩家加入队伍 ----");
		var msg = new ReqInviteTeamMessage();
		msg.playerid = playerId;
		Mgr.msgMgr.Send(msg);
	},

	SendReqAppointGameMessage:function( teamId, playerId ) {
		cc.log("---- 任命新队长 ----");
		var msg = new ReqAppointGameMessage();
		msg.teamid = teamId;
		msg.playerid = playerId;
		Mgr.msgMgr.Send(msg);
	},

	SendReqAppointGameSelectMessage:function(msg) {	
	},

	SendReqMapSearchTeamInfoGameMessage:function(content) {
		cc.log("---- 请求所有队伍信息 ----  ");
		var msg = new ReqMapSearchTeamInfoGameMessage();
		msg.searchcontent = content || null;
		Mgr.msgMgr.Send(msg);
	},

	SendReqMapSearchPlayerInfoGameMessage:function(content) {
		cc.log("---- 前端请求搜索本地图玩家信息 ----");
		var msg = new ReqMapSearchPlayerInfoGameMessage();
		msg.searchcontent = content || null;
		Mgr.msgMgr.Send(msg);
	},

	SendReqSetTeamOptionsGameMessage:function(msg) {	
	},

	SendReqGenericSearchToGameMessage:function(msg) {	
	},

	SendReqTeamInfoToGameMessage:function(msg) {	
	},

	IsTeamMember:function(playerId){
		if( this.teamInfo ){
			for( var i = 0; i != this.teamInfo.memberinfo.length; i++ ){
				if( this.teamInfo.memberinfo[i].memberId.Equal( playerId ) )
					return true;
			}
		}
		return false;
	},

	// *************************** 跟随 ********************************
	StartFollowListen:function () {
		this.lastActiveTime = TimerUtil.GetTimer();
		this._timerId = TimerUtil.TimeUpdate(this._OnTimer, this, 1);
	},

	ClearFollowListen:function () {
		if ( this._timerId != 0 )
			TimerUtil.ClearTimeUpdate(this._timerId, this);
		this._timerId = 0;
		this.lastActiveTime = 0;
		this.followState = false;
	},

	_OnTimer:function () {
		if ( Mgr.mainPlayer.oSid.Equal(this.leaderId) )  // 队长永不跟随
			return;

		if ( this.followState )
			return;

		if ( Mgr.mainPlayer.IsMoving() )
			return;

		if ( TimerUtil.GetTimer() - this.lastActiveTime >= 20000 ) {   // 20s
			Mgr.team.StartFollow();
		}
	},

	StartFollow:function () {
		Mgr.team.followState = true;
		this._AutoFollow();
	},

	_AutoFollow:function () {
		if ( this.teamInfo ) {
			var info = this.teamInfo.memberinfo[0];   // 第一个为队长
			if ( Mgr.mainPlayer.oSid.Equal(info.memberId) )
				return;

			var gridPt = ToolMap.PixPt2GridPt(info.x, info.y);
			if (Mgr.sceneMap.nMapId != info.memberMapModelID) {
				Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(info.memberMapModelID, gridPt, AutoPathParam.CreateCallBack(this._AutoHook,this));
			}
			else {
				var playerList = Mgr.sceneObj.oRoundPlayerList.oHashList.aList;
				for (var i = 0; i < playerList.length; i++) {
					var player = playerList[i];
					if ( player.oSid.Equal( info.memberId ) ) {
						gridPt = player.GetGridPt();
						break;
					}
				}
			}

			// 检测距离
			var dis = ToolMap.CalcDistance( Mgr.mainPlayer.GetGridPt(), gridPt);
			if ( dis > 2 )  // 超出距离，跟随
				Mgr.mainPlayer.oCtrlAutoPath.RunToPt(gridPt, AutoPathParam.CreateCallBack(this._AutoHook,this));
			else              // 在距离内， 自动打怪
				this._AutoHook();
		}
	},

	_AutoHook:function () {
		Mgr.player.TryStartAutoFight();
	},
});