var TeamPanelExt = TeamPanel.extend ( {
	_className:"TeamPanelExt",

	panelMgr:null,
	curSubType:null,
	curSubPanel:null,

	_btnArr:null,


	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
        this.modelPanelType = MUIPanelModelType.BLUR;
		this.panelMgr = {};
	},

	Init:function() {
		var self = this;
		TeamPanel.prototype.Init.call(this);
        this.layoutCom.layoutOffy = -28;
		this._btnArr = [
			{type:TeamEnum.PANEL_TEAM_TEAM, btn:this.sbtnTeam, btnStr:this.labTeam},
			{type:TeamEnum.PANEL_TEAM_APPLY , btn:this.sbtnApply, btnStr:this.labTeam1},
		];

		this.btnClose.addClickEventListener(function (event) {
			EngineMgr.uiMgr.HidePanel(self);
			Mgr.uiMgr.HidePanelByType(TeamMemberInfoPanelExt.PanelName);
		});

		this.sbtnTeam.addClickEventListener(function (event) {
			self.ChangePanel( TeamEnum.PANEL_TEAM_TEAM );
		});
		this.sbtnApply.addClickEventListener(function (event) {
			self.ChangePanel( TeamEnum.PANEL_TEAM_APPLY );
		});
	},

	ChangePanel:function ( type ) {
		// btn state
		this.sbtnTeam.setVisible(false);
		this.sbtnApply.setVisible(false);

		this.labTitle1.SetString("队伍");
		if ( type == TeamEnum.PANEL_TEAM_APPLY )
			this.labTitle1.SetString("申请");
		else if ( type == TeamEnum.PANEL_TEAM_QUICK_TEAM )
			this.labTitle1.SetString("调整");

		if ( type == TeamEnum.PANEL_TEAM_TEAM || type == TeamEnum.PANEL_TEAM_APPLY) {
			if ( Mgr.player.mainPlayer.sid.Equal( Mgr.team.leaderId ) ) {
				this.sbtnTeam.setVisible(true);
				this.sbtnApply.setVisible(true);

				for ( var i = 0; i != this._btnArr.length; i++ ) {
					if ( this._btnArr[i].type == type ) {
						this._btnArr[i].btn.SetButtonState("check");
						this._btnArr[i].btnStr.SetColor(EnumFontFormat.COMMON_COLOR01);
					}
					else {
						this._btnArr[i].btn.SetButtonState("uncheck");
						this._btnArr[i].btnStr.SetColor(EnumFontFormat.COMMON_COLOR06);
					}
				}
			}
		}

		if ( this.curSubPanel)
			this.curSubPanel.visible = false;

		switch( type ){
			case TeamEnum.PANEL_TEAM_CREATE:
				if ( !this.panelMgr[type] ) {
					var panel = new TeamCreatePanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case TeamEnum.PANEL_TEAM_TEAM:
				if ( !this.panelMgr[type] ) {
					var panel = new TeamTeamPanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case TeamEnum.PANEL_TEAM_APPLY:
				if ( !this.panelMgr[type] ) {
					var panel = new TeamShenqingPanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case TeamEnum.PANEL_TEAM_QUICK_TEAM:
				if ( !this.panelMgr[type] ) {
					var panel = new TeamQuickTeamPanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			default:
				break;
		}
		this.curSubType = type;
		this.curSubPanel = this.panelMgr[type];
		if ( this.curSubPanel ) {
			this.curSubPanel.visible = true;
			if ( this.curSubPanel.OnShow )
				this.curSubPanel.OnShow();
		}
	},

	UpdataWarn:function () {
		var warn = Mgr.team.applyList.Values().length > 0 ? true : false;
		this.imgWarn.visible = warn;
	},

	OnShow:function () {
		this.UpdataWarn();
		var type = TeamEnum.PANEL_TEAM_CREATE;
		if ( Mgr.team.teamInfo ) {
			type = TeamEnum.PANEL_TEAM_TEAM;
			if ( Mgr.team.applyList.Values().length > 0 )
				type = TeamEnum.PANEL_TEAM_APPLY;
		}
		this.ChangePanel( type );
	},
} );
TeamPanelExt.PanelName = "TeamPanelExt";
PanelClassDic["TeamPanelExt"] = TeamPanelExt;
