var TeamQuickTeamPanelExt = TeamQuickTeamPanel.extend ( {
	_className:"TeamQuickTeamPanelExt",

	_listView : null,
	curSelectItem:null,

	_listView1: null,
	_btnArr:null,

	_idShow:null,
	_curType:null,
	_curTeams:null,

	_activeZoneHash:null,
	_restChallengeTimes:null,

	ctor:function(){
		this._super();
		this._idShow = false;
		this._restChallengeTimes = 0;
		this._curTeams = [];
		this._btnArr = [];
	},

	Init:function() {
		var self = this;
		TeamQuickTeamPanel.prototype.Init.call(this);

		this._InitPanel();

		this.btnShuaxin.addClickEventListener(function (event) {
			self.ChangePanel(self._curType);
		});
		this.btnChuangjian.addClickEventListener(function (event) {
			if ( self._curType != TeamEnum.PANEL_RAID_FB )
			{
			
			Mgr.team.SendReqCreateTeamMessage();
				}
			else {
				Mgr.uiMgr.HidePanelByType(TeamPanelExt.PanelName);
				EngineMgr.uiMgr.ShowPanelByType(DuorenPanelExt.PanelName).ShowContentByType(EnumZoneType.TYPE_KFDR);
			}
		});
		this.btnEquip1.addClickEventListener(function (event) {
			self._idShow = false;
			self._BrushRaidFbShow();
			self.ChangePanel(TeamEnum.PANEL_ALL_FB);
		});
		this.btnCurMap.addClickEventListener(function (event) {
			self._idShow = false;
			self._BrushRaidFbShow();
			self.ChangePanel(TeamEnum.PANEL_CURMAP_FB);
		});
		this.btnGem.addClickEventListener(function (event) {
			self._SetGemButtonEvent();
		});
	},
	_SetGemButtonEvent:function()
	{
		var self = this;
		self._idShow = !self._idShow;
		self._BrushRaidFbShow();
		self.ChangePanel(TeamEnum.PANEL_RAID_FB);
	},
	_BrushRaidFbShow:function () {
		var state = this._idShow ? "check" : "uncheck";
		this.sbtnSort.SetButtonState( state );
		this.imgBg.visible = this._idShow;
		if ( this.curSelectItem != null ) {
			this.curSelectItem.SetSelect(false);
			this.curSelectItem = null;
		}
	},

	_InitPanel:function()
	{
		// pos
		this.x = 0;
		this.y = 0;

		this._InitParam();
	},

	_InitParam:function() {
		this.imgBg.visible = false;
		// listView
		this._CreateListView();
		this._CreateListView1();

		this.sbtnSort.SetButtonState( "uncheck" );
		this.imgModel.visible = false;
		this.sbtnSort.setTouchEnabled(false);

		this._btnArr = [{type:TeamEnum.PANEL_ALL_FB, btn:this.btnEquip1},
			{type:TeamEnum.PANEL_CURMAP_FB, btn:this.btnCurMap},
			{type:TeamEnum.PANEL_RAID_FB, btn:this.btnGem}];
	},

	_CreateListView:function () {
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg.width, this.imgBg.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false)
		list.setItemsMargin(0);
		list.setAnchorPoint(0, 0);
		list.addEventListener(this._SelectedItemEvent);
		list.retain();
		this.imgBg.addChild(list);
		this._listView = list;
		this.imgBg.visible = false;

		var list = Mgr.dataMgr.GetZoneList().sort(this._sortFunc);
		for ( var i = 0; i != list.length; i++ ) {
			if ( list[i].q_zone_type == EnumZoneType.TYPE_KFDR ) {
				var item = new TeamQuickTeamItemExt();
				item.LoadPanel();
				item.SetData(list[i]);
				this._AddItem(item);
			}
		}
	},

	ChangePanel:function (type) {
		// statues
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			if ( this._btnArr[i].type == type )
				this._btnArr[i].btn.SetButtonState( "check" );
			else
				this._btnArr[i].btn.SetButtonState( "uncheck" );
		}

		this._curType = type;

		if ( type == TeamEnum.PANEL_ALL_FB ) {
			// 获取当前地图队伍
			Mgr.team.SendReqMapSearchTeamInfoGameMessage();
		}
		else if ( type == TeamEnum.PANEL_CURMAP_FB ) {
			// 获取当前地图队伍
			Mgr.team.SendReqMapSearchTeamInfoGameMessage();
		}
		else if ( type == TeamEnum.PANEL_RAID_FB ) {
			// 多人副本
			Mgr.crosszone.SendReqCrossZonePanelMessage();
		}
	},

	SetCurMap:function (list) {
		this._listView1.removeAllItems();
		this._curTeams = [];
		for ( var i = 0; i != list.length; i++ )
		{
			this._curTeams.push({type:TeamEnum.PANEL_CURMAP_FB, teamInfo:list[i]});
		}
		this._LoadItems();
		if ( this._curType == TeamEnum.PANEL_ALL_FB ) {
			// 多人副本
			Mgr.crosszone.SendReqCrossZonePanelMessage();
		}
		this._BrushNoTeamMark();
	},

	_BrushNoTeamMark:function () {
		var items = this._listView1.getItems();
		if ( items.length > 0 )
			this.imgModel.visible = false;
		else
			this.imgModel.visible = true;
	},

	SetCrossFbRestTimes:function (msg) {
		this._restChallengeTimes = msg.remainCount;
		// 获取多人副本队伍
		var id = 0;
		if ( this.curSelectItem != null ) {
			this.curSelectItem.SetSelect(true);
			id = this.curSelectItem.GetData().q_id;
		}

		var data = new Object();
		data.zoneModelId = id; // 绑定副本模版(0表示所有副本)
		data.startNum = 0; // 第几个开始
		data.num = 30; // 需要显示几个
		data.type = 1; // 0所有 1允许加入的队伍
		Mgr.crossteam.SendReqCrossTeamsForZoneModelClientToGameMessage(data);
	},

	SetCrossTeamData:function (list) {
		if ( this._curType == TeamEnum.PANEL_RAID_FB )
			this._listView1.removeAllItems();
		else if ( this._curType == TeamEnum.PANEL_ALL_FB ) {
			// 删除已存在 PANEL_RAID_FB 类型的items
			var items = this._listView1.getItems();
			for ( var i = 0; i != items.length; i++ ) {
				var type = items[i].GetType();
				if ( type == TeamEnum.PANEL_RAID_FB )
					this._listView1.removeChild(items[i], true);
			}
		}

		var crossTeams = [];
		for ( var i = 0; i != list.length; i++ )
		{
			crossTeams.push({type:TeamEnum.PANEL_RAID_FB, teamInfo:list[i]});
		}
		this._curTeams = crossTeams;
		this._LoadItems();
		this._BrushNoTeamMark();
	},

	_SelectedItemEvent: function (sender, type) {
		switch (type) {
			case ccui.ListView.ON_SELECTED_ITEM_END:

				var parent = sender.parent.parent;
				if ( parent.curSelectItem != null) {
					parent.curSelectItem.SetSelect(false);
					parent.curSelectItem = null;
				}

				var idx = sender.getCurSelectedIndex();
				var itemSelect = sender.getItem(idx);
				itemSelect.SetSelect(true);
				parent.curSelectItem = itemSelect;

				// 获取多人zone队列
				// var data = new Object();
				// data.zoneModelId = itemSelect.GetData().q_id; // 绑定副本模版(0表示所有副本)
				// data.startNum = 0; // 第几个开始
				// data.num = 30; // 需要显示几个
				// data.type = 1; // 0所有 1允许加入的队伍
				// Mgr.crossteam.SendReqCrossTeamsForZoneModelClientToGameMessage(data);
				parent.ChangePanel(TeamEnum.PANEL_RAID_FB);

				break;

			default:
				break;
		}
	},

	_CreateListView1:function () {
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg1.width, this.imgBg1.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false)
		list.setItemsMargin(0);
		list.setAnchorPoint(0, 0);
		list.retain();
		this.imgBg1.addChild(list);
		this._listView1 = list;
	},

	IsActiveZone:function (id) {
		if ( this._activeZoneHash[id] )
			return true;
		return false;
	},

	_LoadItems:function () {
		var teams = this._curTeams;
		for (var i = 0; i != teams.length; i++) {
			var item = new TeamQuickTeamListExt();
			item.LoadPanel();
			this._AddItem1(item);
			item.SetData(teams[i].teamInfo, teams[i].type, this._restChallengeTimes);
		}
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	_AddItem1:function( item ){
		item.setTouchEnabled(true);
		this._listView1.pushBackCustomItem(item);
	},

	_sortFunc:function(p1,p2) {
		if (p1.q_level < p2.q_level)
			return -1;
		else if (p1.q_level == p2.q_level)
			return 0;
		else return 1;
	},
	UpdateInfo:function()
	{
		if ( Mgr.team.leaderId && Mgr.team.leaderId.Equal( Mgr.player.mainPlayer.sid ))
		{
			this.btnChuangjian.setTitleText("挑战副本");
			this._idShow = false;
			this._SetGemButtonEvent();
		}
		else
		{
			this.btnChuangjian.setTitleText("创建队伍");
		}
	},

	OnShow:function () {
		this.UpdateInfo();
		this.ChangePanel(TeamEnum.PANEL_ALL_FB);
	},
} );
TeamQuickTeamPanelExt.PanelName = "TeamQuickTeamPanelExt";
PanelClassDic["TeamQuickTeamPanelExt"] = TeamQuickTeamPanelExt;
