var TeamYaoqingPanelExt = TeamYaoqingPanel.extend ( {
	_className:"TeamYaoqingPanelExt",

	// 链表三件套
	_listView : null,
	_itemContainer:null,
	_curSelectItem:null,

	curSubType:null,
	curSubPanel:null,

	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
		this._itemContainer = [];
		this.curSubType = TeamEnum.PANEL_FRIEND
	},

	Init:function() {
		var self = this;
		TeamYaoqingPanel.prototype.Init.call(this);

		this.btnClose.addClickEventListener(function (event) {
			EngineMgr.uiMgr.HidePanel(self);
			Mgr.uiMgr.ShowPanelByType( TeamPanelExt.PanelName ).ChangePanel( TeamEnum.PANEL_TEAM_TEAM );
		});

		this.sbtnFriend.addClickEventListener(function (event) {
			self.ChangePanel(TeamEnum.PANEL_FRIEND);
		});
		this.sbtnGroup.addClickEventListener(function (event) {
			self.ChangePanel(TeamEnum.PANEL_GROUP);
		});
		this.sbtnSearch.addClickEventListener(function (event) {
			self.ChangePanel(TeamEnum.PANEL_SEARCH);
		});

		this._InitParam();
	},

	_InitParam:function () {
		this.imgModel.setVisible(false);

		this._btnArr = [{type:TeamEnum.PANEL_FRIEND, btn:this.sbtnFriend, title:this.labFriend},
			{type:TeamEnum.PANEL_GROUP, btn:this.sbtnGroup, title:this.labGroup},
			{type:TeamEnum.PANEL_SEARCH, btn:this.sbtnSearch, title:this.labSearch}];

		// listView
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg.width, this.imgBg.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false)
		list.setItemsMargin(0);
		list.setAnchorPoint(0, 0);
		list.setPosition(0,0);

		//list.addEventListener(this._SelectedItemEvent);
		this.imgBg.addChild(list);
		this._listView = list;
	},

	ChangePanel:function (type) {
		// statues
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			if ( this._btnArr[i].type == type ) {
				this._btnArr[i].title.SetColor( "0xe5ffff" );
				this._btnArr[i].btn.SetButtonState("check");
			}
			else {
				this._btnArr[i].title.SetColor( "0x3a2707" );
				this._btnArr[i].btn.SetButtonState("uncheck");
			}
		}

		this.curSubType = type;
		switch( type ) {
			case TeamEnum.PANEL_FRIEND:
				this.ShowFriendList();
				break;
			case TeamEnum.PANEL_GROUP:
				this.ShowGuildMemberList();
				break;
			case TeamEnum.PANEL_SEARCH:
				// 获取本地图玩家信息
				Mgr.team.SendReqMapSearchPlayerInfoGameMessage();
				break;
		}
	},

	ShowFriendList:function () {
		var list = [];
		var friends = Mgr.friend.GetFriendList().Values();
		for ( var i = 0; i != friends.length; i++ ) {
			if ( friends[i].state == 1 && !Mgr.team.IsTeamMember(friends[i].playerId) ) // 在线
				list.push(friends[i]);
		}
		this._LaodItems( list, TeamEnum.PANEL_FRIEND );
	},

	ShowGuildMemberList:function () {
		var list = [];
		var members = Mgr.guild.guildMembers.Values();
		for ( var i = 0; i != members.length; i++ ) {
			if ( members[i].isOnline == 1 && !Mgr.team.IsTeamMember(members[i].playerId) )
				list.push(members[i]);
		}
		this._LaodItems( list, TeamEnum.PANEL_GROUP );
	},

	ShowMapPlayerList:function (msg) {
		var list = [];
		var players = msg.mapplayerinfo;
		for ( var i = 0; i != players.length; i++ ) {
			if ( players[i].teamstate == 0 )
				list.push(players[i]);
		}
		this._LaodItems( list, TeamEnum.PANEL_SEARCH );
	},

	_LaodItems:function (list, type) {
		// list
		this._listView.removeAllChildren(true);
		if ( list.length <= 0 ) {
			this.imgModel.setVisible(true);
			var str;
			if ( type == TeamEnum.PANEL_FRIEND )
				str = "似乎没有可以帮助您的好友在线哦";
			else if ( type == TeamEnum.PANEL_GROUP ) {
				if ( Mgr.player.mainPlayer.guildId.IsZero() )
					str = "您还没加入帮派";
				else
					str = "似乎没有可以帮助您的帮会成员在线哦";
			}
			else if ( type == TeamEnum.PANEL_SEARCH )
				str = "似乎没有可以帮助您的玩家在附近哦";
			this.labCue.SetString(str);
		}
		else {
			this.imgModel.setVisible(false);
		}

		for ( var i = 0; i != list.length; i++ ) {
			var item;
			if ( i < this._itemContainer.length ) {
				item = this._itemContainer[i];
			}
			else {
				item = new TeamYaoQingListExt();
				item.LoadPanel();
				item.retain();
				this._itemContainer.push(item);
			}
			item.SetData( list[i], this.curSubType );
			this._AddItem(item);
		}
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	OnShow:function () {
		this.ChangePanel(this.curSubType);

		Mgr.uiMgr.HidePanelByType(TeamPanelExt.PanelName);
		Mgr.uiMgr.HidePanelByType(TeamMemberInfoPanelExt.PanelName);
	},
} );
TeamYaoqingPanelExt.PanelName = "TeamYaoqingPanelExt";
PanelClassDic["TeamYaoqingPanelExt"] = TeamYaoqingPanelExt;
