/***
 * tips 管理类
 * @type {{pnaelType: null}}
 */
var TipsModMgr = TipsModMgr || cc.Class.extend({

		// slipping 对象池
		slippingPool:null,

		lastStaticTime:0,
		staticStrArr:null,

		// 跑马灯
		marqueeStrArr:null,
		marqueePanel:null,


		getHtmlStr_Pattern:/0x/gi,
		fightPowerImg:null,
		fightPowerText:null,
		ctor:function() {
			this.slippingPool = new MCachePool();
			this.slippingPool.SetSize( 20 );
			this.marqueeStrArr = [];
			this.staticStrArr = [];
			this.runningStaticTip = [];
			//TimerUtil.TimeUpdate(this.UpdateStaticTimer, this, 0.1);
		},
		/***
		 * --------------- 浮动条Tips 、 跑马灯 ---------------
		 * @param html
		 * @param showtype
		 * @param where
		 * @param color
		 * @param size
         * @returns {number}
         * @constructor
         */
	ShowNotice:function(html, showtype, where, color, size)
	{
		showtype = showtype || TipsEnum.TYPE_STATIC;
		where = where || null;

		var htmlStr = html;

		if( color || size ){
			color = color || 0xececec;
			size = size || 20;

			// 字体编排
			htmlStr = "<font ";

			var toCol = color.toString(16);
			toCol = toCol.replace(this.getHtmlStr_Pattern,"#");
			if(toCol.charAt(0)!='#'){
				toCol="#"+toCol;
			}

			if (size != -1)
				htmlStr += "size = '" + size.toString() + "' ";

			if (toCol != null)
				htmlStr += "color='" + toCol.toString() +  "'";

			htmlStr += ">";
			htmlStr += html;
			htmlStr += "</font>";
		}

		if ( showtype == TipsEnum.TYPE_MARQUEE )
		{
			if ( !this.marqueePanel ){
				this.marqueePanel = new SlippingTipsPanelExt();
			}

			if( this.marqueePanel.parent )
				this.marqueeStrArr.push( htmlStr );
			else{
				this.marqueePanel.SetData( htmlStr, showtype );
				Mgr.uiMgr.GetTipsLayer().addChild(this.marqueePanel);
			}
		}
		else {
			if ( showtype == TipsEnum.TYPE_STATIC ) {
				//this.staticStrArr.push(html);
				//if( this.staticStrArr.length >= 3 )
				//	this.staticStrArr.shift();

                //this.UpdateStaticTimer();
                this.DirectShowStaticTimer(html);
			}
			else {
				var ft = this.slippingPool.Gain();
				if( !ft ){
					ft = new SlippingTipsPanelExt();
					ft.retain();
				}
				ft.SetData(html, showtype, where);
				Mgr.uiMgr.GetTipsLayer().addChild(ft);
			}
		}
	},

    DirectShowStaticTimer:function(html){
        // 预清理，因为复用
        for(var i=0;i!= this.runningStaticTip.length;++i){
            var v = this.runningStaticTip[i];
            if(!v.getParent()){
                v.j_startTime = null;
                break;
            }
        }
        this.runningStaticTip.splice(i,this.runningStaticTip.length - i);

        // add
        var ft = this.slippingPool.Gain();
        if( !ft ){
            ft = new SlippingTipsPanelExt();
            ft.retain();
        }

        ft.SetData(html, TipsEnum.TYPE_STATIC);
        Mgr.uiMgr.GetTipsLayer().addChild(ft);

        var now = TimerUtil.GetGameTimer();
        ft.j_startTime = now;
        this.runningStaticTip.unshift(ft)


        var maxNum = 3;
        for(var i=1;i!= this.runningStaticTip.length;++i){
            var v = this.runningStaticTip[i];

            if(i >= maxNum){
                v.j_startTime = null;
                v.destory();
            }else{
                var action = v.getActionByTag(9527);
                if(action){
                    var dt = now - (v.j_startTime || 0)
                    var interval = 2000 / maxNum * (i) - dt;

                    if(interval >= 0){
                        v.j_startTime -= interval;

                        action.step(0)
                        action.step(interval / 1000);
                    }
                }
            }
        }

        this.runningStaticTip.splice(3,this.runningStaticTip.length - 3);
    },

    UpdateStaticTimer:function(){
		var now = TimerUtil.GetTimer();
		if( now - this.lastStaticTime > 600 && this.staticStrArr.length > 0 ) {
			this.lastStaticTime = now;
			var ft = this.slippingPool.Gain();
			if( !ft ){
				ft = new SlippingTipsPanelExt();
				ft.retain();
			}
			ft.SetData(this.staticStrArr.shift(), TipsEnum.TYPE_STATIC);
			Mgr.uiMgr.GetTipsLayer().addChild(ft);
		}
	},
	ShowFightpowerChange:function(changePower)
	{
		var eff = EffectUtil.GetShowEffect(EnumEffectId.FIGHT_POWER_ADD, EffectUtil.ENUM_TYPE_UI, false );
		eff.x = cc.winSize.width/2 + 130;
		eff.y = 190;
		Mgr.uiMgr.GetTipsLayer().addChild(eff,1000);
		var self = this;
		var time = 2.2;
		//数字效果还没实现
		if(!this.fightPowerImg)
		{
			Mgr.uiMgr.LoadOtherRes( "other/duanzhao" ,
			{
				Callback:function()
				{
					if(!self.fightPowerImg)
					{
						var imgLable = new MUIImageLabel();
						imgLable.SetImageUrl("public/image/num/zhandouli/num/0.png");
						imgLable.SetString("+"+changePower);
						imgLable.x = eff.x+90;
						imgLable.y = 175;
						imgLable.scale = 1.2;
						self.fightPowerImg = imgLable;
						Mgr.uiMgr.GetTipsLayer().addChild(imgLable,10000);
						TimerUtil.TimeUpdate(function()
						{
							self.fightPowerImg.visible = false;
						},this,time,0);
					}
				},
				ErrCallback:function(){
					// complete();
				}
			});
		}
        else
        {
			this.fightPowerImg.SetString("+"+changePower);
			self.fightPowerImg.visible = true;
			TimerUtil.TimeUpdate(function()
			{
				self.fightPowerImg.visible = false;
			},this,time,0);
        }

	},
	ChangeSize: function (aa, y, size) {
		aa.y = y;
		return y + size;
	}
});