///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//TopInfo 玩家排行信息 

// 请求消息
//141201,ReqToplistToGame 前端请求排行榜列表
//141203,ReqTopSearchToGame 前端请求搜索玩家排行

// 接收消息
//141101,ResToplistToClient 返回前端排行榜列表


var TopInfo = cc.Class.extend({
	ctor:function(){
		this.playerid = null; // 玩家Id
        this.playername = null; // 玩家名字
        this.guildname = null; // 帮会名字
        this.job = 0; // 职业
        this.rank = 0; // 排名
        this.toptype = 0; // 排行类型 1等级 2坐骑 3 战斗力 ....
        this.param = null; // 排行参数(等级榜对应等级 战力对应战斗力)
        this.otherParamList = []; // 排行榜其他参数 long
        this.tencentDomain = 0; // 腾讯登陆渠道
        this.tencentVip = 0; // 腾讯登陆渠道对应vip等级
        this.viplevel = 0; // 系统VIP等级
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteString(this.playername);
        _buf.WriteString(this.guildname);
        _buf.WriteByte(this.job);
        _buf.WriteVarInt(this.rank);
        _buf.WriteVarInt(this.toptype);
        _buf.WriteLong(this.param);
        _buf.WriteUShort( this.otherParamList.length );
        for (var i = 0; i < this.otherParamList.length; i++) {
            _buf.WriteLong(this.otherParamList[i]);
        }
        _buf.WriteVarInt(this.tencentDomain);
        _buf.WriteVarInt(this.tencentVip);
        _buf.WriteVarInt(this.viplevel);
	},
	
	reading:function( _buf ){
		this.playerid = _buf.ReadLong();
        this.playername = _buf.ReadString();
        this.guildname = _buf.ReadString();
        this.job = _buf.ReadByte();
        this.rank = _buf.ReadVarInt();
        this.toptype = _buf.ReadVarInt();
        this.param = _buf.ReadLong();
        var otherParamList_length = _buf.ReadUShort();
        for (var i = 0; i < otherParamList_length; i++) {
            this.otherParamList[i] = _buf.ReadLong();
        }
        this.tencentDomain = _buf.ReadVarInt();
        this.tencentVip = _buf.ReadVarInt();
        this.viplevel = _buf.ReadVarInt();
	},
});
////////////////////
// 返回前端排行榜列表 //
////////////////////
var ResToplistToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.meTopInfo = null; // 当前玩家的排行信息
        this.topInfolist = []; // 排行榜列表 TopInfo
        this.type = 0; // 类型0是翻页,1搜索
        this.length = 0; // 总长度
	},

	getId:function(){
		return 141101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.meTopInfo);
        _buf.WriteUShort( this.topInfolist.length );
        for (var i = 0; i < this.topInfolist.length; i++) {
            _buf.WriteBean(this.topInfolist[i]);
        }
        _buf.WriteByte(this.type);
        _buf.WriteVarInt(this.length);
	},
	
	reading:function( _buf ){
        this.meTopInfo = _buf.ReadBean(TopInfo);
        var topInfolist_length = _buf.ReadUShort();
        for (var i = 0; i < topInfolist_length; i++) {
            this.topInfolist[i] = _buf.ReadBean(TopInfo);
        }
        this.type = _buf.ReadByte();
        this.length = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.top.RecvResToplistToClientMessage(this);
	},

});
////////////////////
// 前端请求排行榜列表 //
////////////////////
var ReqToplistToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.totaltype = 0; // 排行榜总类型(0本国,1连服)
        this.toptype = 0; // 排行榜子类型,(等级,战斗力,资源线)
        this.start = 0; // 开始位置
        this.length = 0; // 长度
        this.type = 0; // 类型0是翻页,1搜索
	},

	getId:function(){
		return 141201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.totaltype);
        _buf.WriteVarInt(this.toptype);
        _buf.WriteVarInt(this.start);
        _buf.WriteVarInt(this.length);
        _buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.totaltype = _buf.ReadVarInt();
        this.toptype = _buf.ReadVarInt();
        this.start = _buf.ReadVarInt();
        this.length = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 前端请求搜索玩家排行 //
////////////////////
var ReqTopSearchToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.toptype = 0; // 排行榜类型
        this.name = null; // 玩家名字
        this.totaltype = 0; // 排行榜总类型(0本国,1连服)
	},

	getId:function(){
		return 141203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.toptype);
        _buf.WriteString(this.name);
        _buf.WriteVarInt(this.totaltype);
	},
	
	reading:function( _buf ){
        this.toptype = _buf.ReadVarInt();
        this.name = _buf.ReadString();
        this.totaltype = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(141101, ResToplistToClientMessage);

