///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//RoleModeInfo 角色造型信息

// 请求消息
//122201,ReqTransactionsLaunch A玩家发起交易
//122202,ReqTransactionsAccept B玩家接受交易请求
//122203,ReqTransactionsRefuse B玩家拒绝交易请求,给A发文字消息
//122204,ReqTransactionsCanceled 取消（打断）交易
//122205,ReqTransactionsIntoItem 往交易框放入道具
//122206,ReqTransactionsRemoveItem 移除交易框道具
//122207,ReqTransactionsChangeGold 金币改变
//122208,ReqTransactionsChangeYuanbao 元宝改变
//122209,ReqTransactionsSetState 设置交易状态
//122211,ReqAutorefusaldeal 自动拒绝交易

// 接收消息
//122101,ResTransactionsLaunch 发给B玩家交易请求
//122102,ResTransactionsCanceled 取消（打断）交易
//122103,ResTransactionsStart B玩家同意，开始交易
//122104,ResTransactionsIntoItem 放入道具
//122105,ResTransactionsRemoveItem 移除交易框道具
//122106,ResTransactionsChangeGold 发送金币改变
//122107,ResTransactionsChangeYuanbao 发送元宝改变
//122108,ResTransactionsSetState 设置交易状态
//122109,ResTransactionsSuccess 交易成功
//122111,ResTransactionsError 错误消息


var RoleModeInfo = cc.Class.extend({
	ctor:function(){
		this.playerid = null; // 玩家ID
        this.playername = null; // 玩家名字
        this.playerlv = 0; // 玩家等级
        this.appearanceInfo = null; // 造型信息
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteString(this.playername);
        _buf.WriteVarInt(this.playerlv);
        _buf.WriteBean(this.appearanceInfo);
	},
	
	reading:function( _buf ){
		this.playerid = _buf.ReadLong();
        this.playername = _buf.ReadString();
        this.playerlv = _buf.ReadVarInt();
        this.appearanceInfo = _buf.ReadBean(PlayerAppearanceInfo);
	},
});
////////////////////
// 发给B玩家交易请求 //
////////////////////
var ResTransactionsLaunchMessage = cc.Class.extend( {
	ctor:function(){
		this.rolemodeinfo = null; // A交易玩家造型信息
        this.launchtime = 0; // 发起交易时间
        this.transid = null; // 交易ID
	},

	getId:function(){
		return 122101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.rolemodeinfo);
        _buf.WriteVarInt(this.launchtime);
        _buf.WriteLong(this.transid);
	},
	
	reading:function( _buf ){
        this.rolemodeinfo = _buf.ReadBean(RoleModeInfo);
        this.launchtime = _buf.ReadVarInt();
        this.transid = _buf.ReadLong();
	},

	action:function(){
		Mgr.transactions.RecvResTransactionsLaunchMessage(this);
	},

});
////////////////////
// 取消（打断）交易 //
////////////////////
var ResTransactionsCanceledMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 122102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.transactions.RecvResTransactionsCanceledMessage(this);
	},

});
////////////////////
// B玩家同意，开始交易 //
////////////////////
var ResTransactionsStartMessage = cc.Class.extend( {
	ctor:function(){
		this.arolemodeinfo = null; // A交易玩家造型信息
        this.brolemodeinfo = null; // B交易玩家造型信息
	},

	getId:function(){
		return 122103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.arolemodeinfo);
        _buf.WriteBean(this.brolemodeinfo);
	},
	
	reading:function( _buf ){
        this.arolemodeinfo = _buf.ReadBean(RoleModeInfo);
        this.brolemodeinfo = _buf.ReadBean(RoleModeInfo);
	},

	action:function(){
		Mgr.transactions.RecvResTransactionsStartMessage(this);
	},

});
////////////////////
// 放入道具 //
////////////////////
var ResTransactionsIntoItemMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 放入道具的玩家ID
        this.itemposition = 0; // 放入交易框的位置
        this.iteminfo = null; // 道具信息
	},

	getId:function(){
		return 122104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteShort(this.itemposition);
        _buf.WriteBean(this.iteminfo);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
        this.itemposition = _buf.ReadShort();
        this.iteminfo = _buf.ReadBean(ItemInfo);
	},

	action:function(){
		Mgr.transactions.RecvResTransactionsIntoItemMessage(this);
	},

});
////////////////////
// 移除交易框道具 //
////////////////////
var ResTransactionsRemoveItemMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 移除交易的玩家ID
        this.itemid = null; // 道具唯一ID
	},

	getId:function(){
		return 122105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteLong(this.itemid);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
        this.itemid = _buf.ReadLong();
	},

	action:function(){
		Mgr.transactions.RecvResTransactionsRemoveItemMessage(this);
	},

});
////////////////////
// 发送金币改变 //
////////////////////
var ResTransactionsChangeGoldMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 玩家ID
        this.gold = 0; // 金币数量
	},

	getId:function(){
		return 122106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteVarInt(this.gold);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
        this.gold = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.transactions.RecvResTransactionsChangeGoldMessage(this);
	},

});
////////////////////
// 发送元宝改变 //
////////////////////
var ResTransactionsChangeYuanbaoMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 玩家ID
        this.yuanbao = 0; // 元宝数量
	},

	getId:function(){
		return 122107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteVarInt(this.yuanbao);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
        this.yuanbao = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.transactions.RecvResTransactionsChangeYuanbaoMessage(this);
	},

});
////////////////////
// 设置交易状态 //
////////////////////
var ResTransactionsSetStateMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 玩家ID
        this.state = 0; // 0交易中，1锁定，2确定交易
	},

	getId:function(){
		return 122108;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteByte(this.state);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
        this.state = _buf.ReadByte();
	},

	action:function(){
		Mgr.transactions.RecvResTransactionsSetStateMessage(this);
	},

});
////////////////////
// 交易成功 //
////////////////////
var ResTransactionsSuccessMessage = cc.Class.extend( {
	ctor:function(){
		this.tsexp = null; // 交易获得经验
	},

	getId:function(){
		return 122109;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.tsexp);
	},
	
	reading:function( _buf ){
        this.tsexp = _buf.ReadLong();
	},

	action:function(){
		Mgr.transactions.RecvResTransactionsSuccessMessage(this);
	},

});
////////////////////
// 错误消息 //
////////////////////
var ResTransactionsErrorMessage = cc.Class.extend( {
	ctor:function(){
		this.errorid = 0; // 错误id（1放入道具异常，2金币量超出，3元宝量超出）
	},

	getId:function(){
		return 122111;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.errorid);
	},
	
	reading:function( _buf ){
        this.errorid = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.transactions.RecvResTransactionsErrorMessage(this);
	},

});
////////////////////
// A玩家发起交易 //
////////////////////
var ReqTransactionsLaunchMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // B交易玩家ID
	},

	getId:function(){
		return 122201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
	},

});
////////////////////
// B玩家接受交易请求 //
////////////////////
var ReqTransactionsAcceptMessage = cc.Class.extend( {
	ctor:function(){
		this.transid = null; // 交易ID
	},

	getId:function(){
		return 122202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.transid);
	},
	
	reading:function( _buf ){
        this.transid = _buf.ReadLong();
	},

});
////////////////////
// B玩家拒绝交易请求,给A发文字消息 //
////////////////////
var ReqTransactionsRefuseMessage = cc.Class.extend( {
	ctor:function(){
		this.transid = null; // 交易ID
	},

	getId:function(){
		return 122203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.transid);
	},
	
	reading:function( _buf ){
        this.transid = _buf.ReadLong();
	},

});
////////////////////
// 取消（打断）交易 //
////////////////////
var ReqTransactionsCanceledMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 122204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 往交易框放入道具 //
////////////////////
var ReqTransactionsIntoItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemposition = 0; // 放入交易框的位置
        this.itemid = null; // 道具唯一ID
	},

	getId:function(){
		return 122205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort(this.itemposition);
        _buf.WriteLong(this.itemid);
	},
	
	reading:function( _buf ){
        this.itemposition = _buf.ReadShort();
        this.itemid = _buf.ReadLong();
	},

});
////////////////////
// 移除交易框道具 //
////////////////////
var ReqTransactionsRemoveItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemid = null; // 道具唯一ID
	},

	getId:function(){
		return 122206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemid);
	},
	
	reading:function( _buf ){
        this.itemid = _buf.ReadLong();
	},

});
////////////////////
// 金币改变 //
////////////////////
var ReqTransactionsChangeGoldMessage = cc.Class.extend( {
	ctor:function(){
		this.gold = 0; // 金币数量
	},

	getId:function(){
		return 122207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.gold);
	},
	
	reading:function( _buf ){
        this.gold = _buf.ReadVarInt();
	},

});
////////////////////
// 元宝改变 //
////////////////////
var ReqTransactionsChangeYuanbaoMessage = cc.Class.extend( {
	ctor:function(){
		this.yuanbao = 0; // 元宝数量
	},

	getId:function(){
		return 122208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.yuanbao);
	},
	
	reading:function( _buf ){
        this.yuanbao = _buf.ReadVarInt();
	},

});
////////////////////
// 设置交易状态 //
////////////////////
var ReqTransactionsSetStateMessage = cc.Class.extend( {
	ctor:function(){
		this.state = 0; // 0交易中，1锁定，2确定交易
	},

	getId:function(){
		return 122209;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.state);
	},
	
	reading:function( _buf ){
        this.state = _buf.ReadByte();
	},

});
////////////////////
// 自动拒绝交易 //
////////////////////
var ReqAutorefusaldealMessage = cc.Class.extend( {
	ctor:function(){
		this.state = 0; // 0默认不拒绝，1自动拒绝
	},

	getId:function(){
		return 122211;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.state);
	},
	
	reading:function( _buf ){
        this.state = _buf.ReadByte();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(122101, ResTransactionsLaunchMessage);
MESSAGE_POOL.Add(122102, ResTransactionsCanceledMessage);
MESSAGE_POOL.Add(122103, ResTransactionsStartMessage);
MESSAGE_POOL.Add(122104, ResTransactionsIntoItemMessage);
MESSAGE_POOL.Add(122105, ResTransactionsRemoveItemMessage);
MESSAGE_POOL.Add(122106, ResTransactionsChangeGoldMessage);
MESSAGE_POOL.Add(122107, ResTransactionsChangeYuanbaoMessage);
MESSAGE_POOL.Add(122108, ResTransactionsSetStateMessage);
MESSAGE_POOL.Add(122109, ResTransactionsSuccessMessage);
MESSAGE_POOL.Add(122111, ResTransactionsErrorMessage);

