///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//TujianMonsterInfo 单个图鉴信息

// 请求消息
//235201,ReqTujianInfoToGame 请求图鉴信息
//235202,ReqTujianUpToGame 请求图鉴升级

// 接收消息
//235101,ResTujianInfoToClient 发送图鉴信息 
//235102,ResTujianUpToClient 发送单个图鉴升级信息 


var TujianMonsterInfo = cc.Class.extend({
	ctor:function(){
		this.nums = 0; // 升级进度(使用道具个数)
        this.level = 0; // 当前等级
        this.tujianId = 0; // 图鉴Id
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.nums);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.tujianId);
	},
	
	reading:function( _buf ){
		this.nums = _buf.ReadVarInt();
        this.level = _buf.ReadVarInt();
        this.tujianId = _buf.ReadVarInt();
	},
});
////////////////////
// 发送图鉴信息  //
////////////////////
var ResTujianInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.tujianMonsterInfo = []; // 图鉴信息 TujianMonsterInfo
        this.tujianType = 0; // 图鉴类型(1野外图鉴2联服图鉴)
	},

	getId:function(){
		return 235101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.tujianMonsterInfo.length );
        for (var i = 0; i < this.tujianMonsterInfo.length; i++) {
            _buf.WriteBean(this.tujianMonsterInfo[i]);
        }
        _buf.WriteByte(this.tujianType);
	},
	
	reading:function( _buf ){
        var tujianMonsterInfo_length = _buf.ReadShort();
        for (var i = 0; i < tujianMonsterInfo_length; i++) {
            this.tujianMonsterInfo[i] = _buf.ReadBean(TujianMonsterInfo);
        }
        this.tujianType = _buf.ReadByte();
	},

	action:function(){
		Mgr.tujian.RecvResTujianInfoToClientMessage(this);
	},

});
////////////////////
// 发送单个图鉴升级信息  //
////////////////////
var ResTujianUpToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.success = 0; // 是否升级成功(0不成功1成功)
        this.tujianMonsterInfo = null; // 升级的图鉴信息
	},

	getId:function(){
		return 235102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.success);
        _buf.WriteBean(this.tujianMonsterInfo);
	},
	
	reading:function( _buf ){
        this.success = _buf.ReadByte();
        this.tujianMonsterInfo = _buf.ReadBean(TujianMonsterInfo);
	},

	action:function(){
		Mgr.tujian.RecvResTujianUpToClientMessage(this);
	},

});
////////////////////
// 请求图鉴信息 //
////////////////////
var ReqTujianInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.tujianType = 0; // 图鉴类型(1野外图鉴2联服图鉴)
	},

	getId:function(){
		return 235201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.tujianType);
	},
	
	reading:function( _buf ){
        this.tujianType = _buf.ReadByte();
	},

});
////////////////////
// 请求图鉴升级 //
////////////////////
var ReqTujianUpToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.tujianType = 0; // 图鉴类型(1野外图鉴2联服图鉴)
        this.tujianId = 0; // 图鉴Id
	},

	getId:function(){
		return 235202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.tujianType);
        _buf.WriteVarInt(this.tujianId);
	},
	
	reading:function( _buf ){
        this.tujianType = _buf.ReadByte();
        this.tujianId = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(235101, ResTujianInfoToClientMessage);
MESSAGE_POOL.Add(235102, ResTujianUpToClientMessage);

