var WendingCueExt = WendingCue.extend ( {
	_className:"WendingCueExt",
	_rawardCon:null,
	_timerNum:0,
	_time:0,
	_rawards:null,
	_layer:0,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;

		this.setSwallowTouches(true);
	},
	
	Init:function(){
		WendingCue.prototype.Init.call( this );
		var rawardStr = Q_global.Get(1034).q_string_value;
		this._rawards = JSON.parse( rawardStr );
		var self = this;
		this.btnGo.addClickEventListener(function (event){
			if(Mgr.sword._curlayer <= 7)
				self.NextZone();
			else
				self.OutZone();
		});
		this.btnOk.addClickEventListener(function (event){
			self.OutZone();
		});
	},

	SetInfo:function(layer){
		this._layer = layer;
		this.UpdateRaward();

		this._time = 10;
		this.OnTimer();
		if(this._timerNum>0)
			TimerUtil.ClearTimeUpdate(this._timerNum, this);
		this._timerNum = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
		
		this.imglabNumber.SetText(layer+1);
		this.labCue1.SetText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [layer+1] ));
		
		this.UpdateBtnState();
	},

	SetSwordZoneInfo:function(layer){
        this._layer = layer;
        this.UpdateRaward();

        this._time = 10;
        this.OnTimer();
        if(this._timerNum>0)
            TimerUtil.ClearTimeUpdate(this._timerNum, this);
        this._timerNum = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.imglabNumber.SetText(layer+1);
        this.labCue1.SetText("您可继续接受更高挑战，进入华山论剑第" + (layer + 1) + "层");

        this.UpdateBtnState();
    },
	
	NextZone:function(){
		Mgr.uiMgr.HidePanel(this);
		Mgr.drop.ClearZoneDrop();
		Mgr.sword.SendReqEnterSwordZoneNextLayerMessage();
	},

	OutZone:function(){
		Mgr.zone.SendReqZoneOutToGameMessage();
		Mgr.uiMgr.HidePanel(this);
		Mgr.drop.ClearZoneDrop();
	},

	UpdateRaward:function(){
		if(this._rawardCon == null){
			UIUtil.UIRemoveSelf(this.gridItem);
			this._rawardCon = new TaskRewardsGridCon();
			this.imgBg.addChild(this._rawardCon);
		}
		this._rawardCon.Clear();
		var dropRawards = Mgr.drop.GetDropSimpleItemInfos(this._zoneModelId);
		this.labJiangli.setVisible(true);
		var rawards = null;
		if(this._layer <= 7){
			rawards = this._rawards[0][Mgr.sword._curlayer - 1];
		}else{
			if(Mgr.sword._myscore > 0){
				if(Mgr.sword._myscore >= Mgr.sword.GetBindGold())
					rawards = this._rawards[Mgr.sword._curlayer - 1];
				if(!rawards)
					rawards = new Array();
				var obj = new Object();
				obj["mod"] = -2;
				obj["num"] = Mgr.sword._myscore;
				rawards.push(obj);
			}
		}
		var count = 0;
		var i = 0;
		if( rawards ){
			for ( i = 0; i < rawards.length ; i ++){
				var item = ItemUtil.ItemIdToItem(rawards[ i ].mod,rawards[ i ].num,rawards[ i ].bind);
				this._rawardCon.AddComItem(item,this.gridItem);
				count++;
			}
		}

		if( dropRawards ){
			for ( i = 0; i < dropRawards.length ; i ++){
				var item = ItemUtil.ItemIdToItem(dropRawards[ i ].itemModelId,dropRawards[ i ].num);
				this._rawardCon.AddComItem(item,this.gridItem);
				count++;
			}
		}

		if ( count > 0 ){
			this._rawardCon.Layout( this.gridItem.uiWidth * count, this.gridItem.uiHeight, this.gridItem.uiWidth, this.gridItem.uiHeight );
			this._rawardCon.x = ( this.imgBg.uiWidth - this.gridItem.uiWidth * count ) / 2 + 35;
			this._rawardCon.y = this.gridItem.y;
		}
	},

	UpdateBtnState:function(){
		this.labTime.setVisible(Mgr.sword._curlayer <= 7);
		this.labCue1.setVisible(Mgr.sword._curlayer <= 7);
	},

	OnTimer:function () {
		if( this._time == 0 ){
            this.NextZone();
		}
		this._time--;
		this.labTime.SetHtmlText(TextUtil.FormatStr( this.labTime.GetHtmlText(), [ this._time ] ));
	},

	OnHide:function(){
		this._super();
		TimerUtil.ClearTimeUpdate(this._timerNum, this);
		this._rawardCon.Clear();
		this._zoneModelId = 0;
	}
} );
WendingCueExt.PanelName = "WendingCueExt";
PanelClassDic["WendingCueExt"] = WendingCueExt;
