///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ZoneTeamMemberInfo 队员信息
//ZoneTeamInfo 组队信息
//MemberZoneInfo 队伍玩家状态信息（副本中）

// 请求消息
//215201,ReqZoneTeamClientToGame 请求组队队伍面板信息
//215202,ReqZoneTeamCreatClientToGame 创建队伍
//215203,ReqZoneTeamChangeConfigToGame 请求改变队伍设置
//215204,ReqZoneTeamJoinClientToGame 加入队伍
//215205,ReqZoneTeamInvitePlayerToGame 请求邀请玩家进入多人副本队伍
//215206,ReqZoneTeamReadyClientToGame 改变准备状态
//215207,ReqZoneTeamLeaveClientToGame 玩家离队
//215208,ReqZoneTeamPickClientToGame 提出玩家
//215209,ReqZoneTeamStarClientToGame 请求开始多人副本
//215210,ReqZoneTeamInviteResultToGame 被邀请玩家回复邀请
//215211,ReqZoneTeamFollowClientToGame 前端请求跟队
//215212,ReqZoneTeamInviteNoticeClinetToGame 前端请求跟队
//215213,ReqZoneTeamBuyClinetToGame 前端请求购买次数

// 接收消息
//215101,ResZoneTeamInfoGameToClinet 发送多人组队面板信息
//215102,ResZoneTeamInfoRefreshGameToClinet 刷新队伍信息
//215103,ResTeamMemberStatusGameToClinet 发送副本中的队伍状态
//215104,ResZoneTeamInvitePlayerToClinet 邀请玩家加入队伍信息到前段


var ZoneTeamMemberInfo = cc.Class.extend({
	ctor:function(){
		this.memberId = null; // 队员ID
        this.name = null; // 队员名字
        this.job = 0; // 队员职业
        this.level = 0; // 队员等级
        this.fightPower = 0; // 队员战力
        this.isReady = 0; // 是否准备 （0未准备 1准备）
	},

	writing:function( _buf ){
		_buf.WriteLong(this.memberId);
        _buf.WriteString(this.name);
        _buf.WriteByte(this.job);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarLong(this.fightPower);
        _buf.WriteByte(this.isReady);
	},

	reading:function( _buf ){
		this.memberId = _buf.ReadLong();
        this.name = _buf.ReadString();
        this.job = _buf.ReadByte();
        this.level = _buf.ReadVarInt();
        this.fightPower = _buf.ReadVarLong();
        this.isReady = _buf.ReadByte();
	},
});
var ZoneTeamInfo = cc.Class.extend({
	ctor:function(){
		this.teamId = null; // 队伍Id
        this.autoStart = 0; // 是否满员自动开始（0否 1是）
        this.onlyInvite = 0; // 是否只允许邀请的玩家加入
        this.memberinfo = []; // 队伍列表 ZoneTeamMemberInfo
	},

	writing:function( _buf ){
		_buf.WriteLong(this.teamId);
        _buf.WriteByte(this.autoStart);
        _buf.WriteByte(this.onlyInvite);
        _buf.WriteUShort( this.memberinfo.length );
        for (var i = 0; i < this.memberinfo.length; i++) {
            _buf.WriteBean(this.memberinfo[i]);
        }
	},

	reading:function( _buf ){
		this.teamId = _buf.ReadLong();
        this.autoStart = _buf.ReadByte();
        this.onlyInvite = _buf.ReadByte();
        var memberinfo_length = _buf.ReadUShort();
        for (var i = 0; i < memberinfo_length; i++) {
            this.memberinfo[i] = _buf.ReadBean(ZoneTeamMemberInfo);
        }
	},
});
var MemberZoneInfo = cc.Class.extend({
	ctor:function(){
		this.memberId = null; // 队员ID
        this.name = null; // 队员名字
        this.job = 0; // 队员职业
        this.level = 0; // 队员等级
        this.hp = 0; // 血量
        this.isfollow = 0; // 是否为跟随（队长不需要）
	},

	writing:function( _buf ){
		_buf.WriteLong(this.memberId);
        _buf.WriteString(this.name);
        _buf.WriteByte(this.job);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarLong(this.hp);
        _buf.WriteByte(this.isfollow);
	},

	reading:function( _buf ){
		this.memberId = _buf.ReadLong();
        this.name = _buf.ReadString();
        this.job = _buf.ReadByte();
        this.level = _buf.ReadVarInt();
        this.hp = _buf.ReadVarLong();
        this.isfollow = _buf.ReadByte();
	},
});
////////////////////
// 发送多人组队面板信息 //
////////////////////
var ResZoneTeamInfoGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
        this.teamInfo = []; // 队伍信息 ZoneTeamInfo
        this.teamid = null; // 玩家所在队伍id，0表示没有队伍
        this.leftnum = 0; // 剩余挑战次数
        this.buynum = 0; // 已购买次数
	},

	getId:function(){
		return 215101;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteUShort( this.teamInfo.length );
        for (var i = 0; i < this.teamInfo.length; i++) {
            _buf.WriteBean(this.teamInfo[i]);
        }
        _buf.WriteLong(this.teamid);
        _buf.WriteVarInt(this.leftnum);
        _buf.WriteVarInt(this.buynum);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        var teamInfo_length = _buf.ReadUShort();
        for (var i = 0; i < teamInfo_length; i++) {
            this.teamInfo[i] = _buf.ReadBean(ZoneTeamInfo);
        }
        this.teamid = _buf.ReadLong();
        this.leftnum = _buf.ReadVarInt();
        this.buynum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zoneteam.RecvResZoneTeamInfoGameToClinetMessage(this);
	},

});
////////////////////
// 刷新队伍信息 //
////////////////////
var ResZoneTeamInfoRefreshGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
        this.teamInfo = null; // 队伍信息
	},

	getId:function(){
		return 215102;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteBean(this.teamInfo);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        this.teamInfo = _buf.ReadBean(ZoneTeamInfo);
	},

	action:function(){
		Mgr.zoneteam.RecvResZoneTeamInfoRefreshGameToClinetMessage(this);
	},

});
////////////////////
// 发送副本中的队伍状态 //
////////////////////
var ResTeamMemberStatusGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
        this.teamcaptain = null; // 队长id
        this.teamInfos = []; // 队伍信息 MemberZoneInfo
	},

	getId:function(){
		return 215103;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteLong(this.teamcaptain);
        _buf.WriteUShort( this.teamInfos.length );
        for (var i = 0; i < this.teamInfos.length; i++) {
            _buf.WriteBean(this.teamInfos[i]);
        }
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        this.teamcaptain = _buf.ReadLong();
        var teamInfos_length = _buf.ReadUShort();
        for (var i = 0; i < teamInfos_length; i++) {
            this.teamInfos[i] = _buf.ReadBean(MemberZoneInfo);
        }
	},

	action:function(){
		Mgr.zoneteam.RecvResTeamMemberStatusGameToClinetMessage(this);
	},

});
////////////////////
// 邀请玩家加入队伍信息到前段 //
////////////////////
var ResZoneTeamInvitePlayerToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
        this.name = null; // 发起邀请的玩家名
        this.zonemodelid = 0; // 邀请参与的副本id
        this.teamId = null; // 队伍Id
	},

	getId:function(){
		return 215104;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteString(this.name);
        _buf.WriteVarInt(this.zonemodelid);
        _buf.WriteLong(this.teamId);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        this.name = _buf.ReadString();
        this.zonemodelid = _buf.ReadVarInt();
        this.teamId = _buf.ReadLong();
	},

	action:function(){
		Mgr.zoneteam.RecvResZoneTeamInvitePlayerToClinetMessage(this);
	},

});
////////////////////
// 请求组队队伍面板信息 //
////////////////////
var ReqZoneTeamClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
	},

	getId:function(){
		return 215201;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
	},

});
////////////////////
// 创建队伍 //
////////////////////
var ReqZoneTeamCreatClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
        this.onlyInvite = 0; // 是否只允许邀请的玩家加入 1是 0否
        this.autoStart = 0; // 是否满员自动开始（0否 1是）
	},

	getId:function(){
		return 215202;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteByte(this.onlyInvite);
        _buf.WriteByte(this.autoStart);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        this.onlyInvite = _buf.ReadByte();
        this.autoStart = _buf.ReadByte();
	},

});
////////////////////
// 请求改变队伍设置 //
////////////////////
var ReqZoneTeamChangeConfigToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
        this.onlyInvite = 0; // 是否只允许邀请的玩家加入 1是 0否
        this.autoStart = 0; // 是否满员自动开始（0否 1是）
	},

	getId:function(){
		return 215203;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteByte(this.onlyInvite);
        _buf.WriteByte(this.autoStart);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        this.onlyInvite = _buf.ReadByte();
        this.autoStart = _buf.ReadByte();
	},

});
////////////////////
// 加入队伍 //
////////////////////
var ReqZoneTeamJoinClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
        this.teamid = null; // 队伍Id（id为0表示快速加入）
        this.autoready = 0; // 是否自动准备
	},

	getId:function(){
		return 215204;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteLong(this.teamid);
        _buf.WriteByte(this.autoready);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        this.teamid = _buf.ReadLong();
        this.autoready = _buf.ReadByte();
	},

});
////////////////////
// 请求邀请玩家进入多人副本队伍 //
////////////////////
var ReqZoneTeamInvitePlayerToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
        this.invitePlayerId = null; // 邀请玩家的唯一id
	},

	getId:function(){
		return 215205;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteLong(this.invitePlayerId);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        this.invitePlayerId = _buf.ReadLong();
	},

});
////////////////////
// 改变准备状态 //
////////////////////
var ReqZoneTeamReadyClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
	},

	getId:function(){
		return 215206;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
	},

});
////////////////////
// 玩家离队 //
////////////////////
var ReqZoneTeamLeaveClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
	},

	getId:function(){
		return 215207;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
	},

});
////////////////////
// 提出玩家 //
////////////////////
var ReqZoneTeamPickClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
        this.playerid = null; // 被踢的玩家Id
	},

	getId:function(){
		return 215208;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteLong(this.playerid);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        this.playerid = _buf.ReadLong();
	},

});
////////////////////
// 请求开始多人副本 //
////////////////////
var ReqZoneTeamStarClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
	},

	getId:function(){
		return 215209;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
	},

});
////////////////////
// 被邀请玩家回复邀请 //
////////////////////
var ReqZoneTeamInviteResultToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
        this.teamId = null; // 队伍Id
        this.result = 0; // 1同意。2拒绝
	},

	getId:function(){
		return 215210;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteLong(this.teamId);
        _buf.WriteByte(this.result);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        this.teamId = _buf.ReadLong();
        this.result = _buf.ReadByte();
	},

});
////////////////////
// 前端请求跟队 //
////////////////////
var ReqZoneTeamFollowClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
	},

	getId:function(){
		return 215211;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
	},

});
////////////////////
// 前端请求跟队 //
////////////////////
var ReqZoneTeamInviteNoticeClinetToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
	},

	getId:function(){
		return 215212;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
	},

});
////////////////////
// 前端请求购买次数 //
////////////////////
var ReqZoneTeamBuyClinetToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本类型
	},

	getId:function(){
		return 215213;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
	},

	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(215101, ResZoneTeamInfoGameToClinetMessage);
MESSAGE_POOL.Add(215102, ResZoneTeamInfoRefreshGameToClinetMessage);
MESSAGE_POOL.Add(215103, ResTeamMemberStatusGameToClinetMessage);
MESSAGE_POOL.Add(215104, ResZoneTeamInvitePlayerToClinetMessage);

