///quick {
//    f@exit
//    f@init
//    f@login
//    f@logout
//    f@pay
//    f@submitData
//}
var QuickImpl = ChannelImpl.extend({
    getPlatform:function(){
        //return "alidwd";
        //return "kuaiyou";
        return this.GetQuickDevInfo("QUICK_PLATFORM");
    },

    getChannelId:function(){
        return quick.getChannelType()
    },
    getGameId:function(){
        return "27"
    },

    GetQuickDevInfo: function(key) {
        key = key || "";

        var result;
        try{
            if (cc.sys.os == cc.sys.OS_ANDROID) {
                result = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getApplicationMetaData", "(Ljava/lang/String;)Ljava/lang/String;", key);
            } else if (cc.sys.os == cc.sys.OS_IOS) {
                result = jsb.reflection.callStaticMethod("QuickImpl", "GetQuickDevInfo:",key);
            }
        }catch(e){
            cc.log("==============",e)
        }

        return result && result != "" ? result : null
    },


    init:function(){
        if (typeof quick == "undefined") return false;

        quick.init(this.OnSDKCallBack.bind(this));

        return true;
    },

    login:function(){
        quick.login();
    },

    logout:function() {
        quick.logout();
    },
    exit:function(){
        if (quick.channelHasExitDialog()){
            quick.exit();
        }
        else{
            AlertExt.Show( "你确定要退出游戏吗？", TipsEnum.BUTTON_SURE_AND_FALSE, {
                _onFunc:function(){
                    quick.exit();
                },
            });
        }
    },
    pay:function(data){

        var roleBalance = 0,
            guildName = "";

        var mainPlayer = Mgr.player.mainPlayer;
        if(mainPlayer){
            roleBalance = mainPlayer.attributeData.GetAttribute(EnumMoney.GOLD, AttributeData.Money) || "";

            var guildInfo = Mgr.guild.guildMap.Get(mainPlayer.guildId);
            if(guildInfo){
                guildName = guildInfo ? guildInfo.guildName : "";
            }
        }

        quick.pay({
            amount			: data.price 		,
            count			: data.buyNum		,
            cpOrderID		: data.orderID		,
            extrasParams	: data.extension		,
            goodsID			: data.productId	,
            goodsName		: data.productName	,

            roleBalance		: roleBalance.toString(),

            roleId			: data.roleId		,
            roleLevel		: data.roleLevel.toString()	,
            roleName		: data.roleName		,
            guildName		: guildName	,
            serverName		: data.serverName	,
            serverId		: data.serverId.toString()		,

            vipLevel		: data.vip.toString()			,
        })
    },

    onLogin:function(new_role){
        new_role = new_role || false;
        var roleName
            ,roleId
            ,roleLevel
            ,roleBalance
            ,guildId
            ,guildName
            ,serverId
            ,serverName
            ,vipLevel;

        var mainPlayer = Mgr.player.mainPlayer;
        if(mainPlayer){
            roleId = mainPlayer.sid ? mainPlayer.sid.hexValue : "0";
            roleName = mainPlayer.name || "";
            roleLevel = mainPlayer.attributeData.level || "";
            roleBalance = mainPlayer.attributeData.GetAttribute(EnumMoney.GOLD, AttributeData.Money) || "";

            guildId = mainPlayer.guildId;
            var guildInfo = Mgr.guild.guildMap.Get(guildId);
            if(guildInfo){
                guildName = guildInfo ? guildInfo.guildName : "";
            }

            serverId = GameConfig.current.SERVER_ID.toString();
            serverName = GameConfig.current.NAME;
            vipLevel = mainPlayer.VIP;
        }
       quick.updateRoleInfo({
            roleBalance	: roleBalance.toString(),
            roleId		: roleId,
            roleLevel	: roleLevel.toString(),
            roleName	: roleName,
            guildName	: guildName,
            serverName	: serverName,
            serverId	: serverId.toString(),
            vipLevel	: vipLevel.toString(),
            is_new      : new_role
        })
    },
    onServerSelected:function(){

    },
    onLevelUp:function(){
        this.onLogin(false);
    },
    OnSDKCallBack:function(type, data){
        data = data || {}
        cc.log("=============1", JSON.stringify(type))
        cc.log("=============2", JSON.stringify(data))

        switch(type){
            case "init_success":{
                this.util.OnSDK_Init(0,data)
            }break
            case "init_failed":{
                this.util.OnSDK_Init(1,data)
            }break
            case "login_success":{
                let params = {}
                params.userID = data.uid;
                params.username = data.userName;
                params.sdkUserID = data.uid;
                params.sdkUsername = data.userName;
                params.timestamp = "";
                params.extension = "";
                params.token = data.token
                this.util.OnSDK_Login(0,params)
            }break;
            case "login_cancel":{
                this.util.OnSDK_Login(2,data)
            }break;
            case "login_failed":{
                this.util.OnSDK_Login(1,data)
            }break;
            case "logout_success":{
                this.util.OnSDK_Logout(0,data)
            }break;
            case "logout_failed":{
                this.util.OnSDK_Logout(1,data)
            }break;
            case "switch_account_success":{
                let params = {}
                params.userID = data.uid;
                params.username = data.userName;
                params.sdkUserID = data.uid;
                params.sdkUsername = data.userName;
                params.timestamp = "";
                params.extension = "";
                params.token = data.token
                this.util.OnSDK_SwitchAccount(0,params)
            }break;
            case "switch_account_failed":{
                this.util.OnSDK_SwitchAccount(1,data)
            }break;
            case "switch_account_cancel":{
                this.util.OnSDK_SwitchAccount(2,data)
            }break;
            case "pay_success":{
                this.util.OnSDK_Pay(0,data)
            }break;
            case "pay_cancel":{
                this.util.OnSDK_Pay(2,data)
            }break;
            case "pay_failed":{
                this.util.OnSDK_Pay(1,data)
            }break;
            case "exit_success":{
                this.util.OnSDK_Exit(0,data)
            }break;
            case "exit_failed":{
                this.util.OnSDK_Exit(1,data)
            }break;
        }
    },
})