﻿var TextUtil = TextUtil || {
    getHtmlStr_Pattern: /0x/gi,
    zijieWidthNum: 10,
    HTML_SPILT_PATTERN: /([^>]*)(<[^<]+>)([^<]*)/g,

    // 格式化数字（使用万、亿单位）
    FormatNum: function(num, fixed) {
        if (fixed == null)
            fixed = 1;
        if (num >= 100000000) {
            return (num / 100000000).toFixed(fixed) + TextUtil.FormatStr("亿");
        } else if (num >= 10000) {
            return (num / 10000).toFixed(fixed) + TextUtil.FormatStr("万");
        } else
            return num;
    },
    FormatStr: function(s, params, isServer) {
        if (params == null || s == null)
            return s;

        if (params == null)
            return s;

        var len = params.length;
        var i;
        var ri;
        if (s.indexOf('{@}') == -1) {
            for (i = 0; i < len; ++i) {
                if (isServer) //服务器用的从0开始   处理成一个函数好了
                    ri = i;
                else
                    ri = i + 1;
                s = s.replace("{" + ri + "}", params[i]);
            }
        } else {
            for (i = 0; i < len; ++i) {
                s = s.replace("{@}", params[i]);
            }
        }
        return s;
    },

    LineFeedStr: function(s) {
        s = s.replace(/\|/g, "\n");
        return s;
    },

    AddUnderLine: function(str) {
        return "<u>" + str + "</u>";
    },

    AddHyperlink: function(str, href) {
        return "<a href=\"" + href + "\">" + str + "</a>";
    },

    AddColor: function(s1, c) {
        var s = "<font color='#" + c + "'>" + s1 + "</font>";
        return s;
    },

    AddColorNew: function(s1, c) {
        var s = "<font color=" + c + "'>" + s1 + "</font>";
        return s;
    },

    ConectParam: function(html, param) {
        if (param == null)
            return html;
        if (html == null)
            return null;
        var i;
        if (html.indexOf('{@}') == -1) {
            for (i = 0; i < param.length; i++) {
                html = html.replace("{" + (i + 1) + "}", param[i]);
            }
        } else {
            for (i = 0; i < param.length; i++) {
                html = html.replace("{@}", param[i]);
            }
        }

        return html;
    },
    /**
     * 数字转换为不超过4位数字、万亿为单位字符串
     */
    FormatLimit4Dig: function(num, nocomma) {
        nocomma = nocomma || false;
        var rett = Math.floor((num / 100000000) * 10) / 10;
        if (rett < 1) {
            if (num < 10000) {
                return nocomma ? num.toString() : this.FormatThreeNum(num);
            } else if (num >= 10000 && num < 100000000)
                return (nocomma ? Math.floor(num / 10000).toString() : this.FormatThreeNum(Math.floor(num / 10000))) + "万";
        } else {
            // rett = rett.toFixed(0);
            return (nocomma ? rett.toString() : this.FormatThreeNum(rett)) + "亿";
        }
    },

    /**
     * 数字转换为三位分节字符串     1,000,000
     */
    FormatThreeNum: function(num) {
        var str = "";
        var temp;
        while (num >= 1000) {
            temp = num % 1000;
            num /= 1000;
            str = ','.concat(this.GetNumStr(temp, 3)).concat(str);
        }
        str = num.toString().concat(str);
        return str;
    },

    /**
     * 得到数字字符串
     *
     */
    GetNumStr: function(v, len, limitlarge) {
        limitlarge = limitlarge || true;
        var MAGIC = "0000";
        var ret = MAGIC + v.toString();
        if (!limitlarge) {
            var valueLen = v.toString().length;
            if (valueLen > len)
                len = valueLen;
        }
        return ret.substr(-len);
    },

    /**
     * 删除HTML标签
     *
     */
    RemoveHTMLTag: function(text) {
        if (!text) {
            return ""
        }
        return text.replace(/<.*?>/g, "");
    },

    /**
     * 替换文本中的\N换行
     * @param str
     * @param str1
     * @return
     *
     */
    ReplaceEnter: function(str, isHtmlText) {
        isHtmlText = isHtmlText || false;

        var ret = str;
        var replaceStr = '\n';
        if (isHtmlText)
            replaceStr = '<br>';

        while (ret.indexOf("\\N") != -1) {
            ret = ret.replace("\\N", replaceStr);
        }

        while (ret.indexOf("\\n") != -1) {
            ret = ret.replace("\\n", replaceStr);
        }

        return ret;
    },

    GetHtmlStr: function(str, color, size, isChangeLine, font) {
        color = color != null ? color : "#ffffff";
        size = size || -1;
        isChangeLine = isChangeLine != null ? isChangeLine : false;
        font = font != null ? font : GameFont.DEFAULT;

        if (str == null)
            return "";

        str = TextUtil.ReplaceEnter(str, true);
        // 这个转义字符必须转掉，性能原因，就转第一个吧
        //            if (str.indexOf("<") == 0 && str.length == 1)
        //                str = str.replace("<", "&lt;");

        var htmlStr = "";
        if (typeof color === "String") {
            color = color.replace(TextUtil.getHtmlStr_Pattern, "#");
            if (color.charAt(0) != '#') {
                color = "#" + color;
            }
        } else if (color != null && isNaN(color) == false) {
            color = "#" + parseInt(color).toString(16);
        }
        htmlStr += "<font ";
        htmlStr += "face ='" + font + "'";
        if (size != -1) {
            htmlStr += "size = '" + size.toString() + "' ";
        }

        if (color != null) {
            htmlStr += "color='" + color.toString() + "'";
        }

        htmlStr += ">";
        htmlStr += str;
        htmlStr += "</font>";

        if (isChangeLine)
            htmlStr += "<br>";

        return htmlStr;
    },
    SecondToHMS2: function(s, egZero) {
        var rs = s;
        var d = 3600;

        var m = 60;
        var rd = parseInt(s / d);
        // 剩余秒

        rs = parseInt(rs % d);

        var rm = parseInt(rs / m);

        var rsecond = parseInt(rs % m);
        var re = "";
        // if ( rd != 0 ){
        //  re += this.GetNumStr(rd, 2) + ":";
        //  re += this.GetNumStr(rm, 2) + ":";
        // }else{
        //  if ( rm != 0 )
        //      re += rm + ":";
        // }
        re += this.GetNumStr(rd, 2) + ":";
        re += this.GetNumStr(rm, 2) + ":";
        re += this.GetNumStr(rsecond, 2);
        return re;
    },
    MAGIC: "0000",
    /**
     * 根据拼音排序字符串 by zfs
     * @param s1
     * @param s2
     * @returns {number}
     * @constructor
     */
    CompareStrPinyin: function(s1, s2) {
        for (var i = 0;; i++) {
            //短的排在前
            if (s1.length == i) {
                if (s2.length == i) {
                    return 0;
                } else {
                    return 1;
                }
            } else if (s2.length == i) {
                return -1;
            }
            var char1 = s1.charCodeAt(i);
            var char2 = s2.charCodeAt(i);
            if (char1 > char2) {
                return 1;
            } else if (char1 < char2) {
                return -1;
            }
        }
        return 0;
    },
    StringToArray: function(str) {
        if (!str) {
            return [];
        }
        str = str.substr(1, str.length - 2);
        return str.split(",");
    },
    GetChildStringNum: function(string, string1) {
        var count = 0;
        while (string.indexOf(string1) >= 1) {
            string = string.replace(string1, "");
            count++;
        }
        return count;
    },
    //{1:26,2:44,} 转成数组
    JsonPres: function(str) {
        str = str.substring(1, str.length - 2);
        var array = str.split(",");
        for (var i = 0; i < array.length; ++i) {
            array[i] = array[i].split(":");
        }
        return array;
    },
    //获取字符串字符数
    GetCharactersByString: function(str) {
        var num = 0;
        for (var i = 0; i < str.length; i++) {
            if (/^[a-zA-Z]*$/.test(str.charAt(i))) //这是判断英文的正则表达式
                num += 1;
            else if (/^[\u4e00-\u9fa5]*$/.test(str.charAt(i)) ||
                /^[\u3002\uff1b\uff0c\uff1a\u201c\u201d\uff08\uff09\u3001\uff1f\u300a\u300b]*$/.test(str.charAt(i))) { //这是判断中文和中文符号的正则表达式
                num += 2;
            } else
                num += 1;
        }
        return num;
    },
    AnalyzeHtmlText: function(htmlText) {
        var strArr = null,
            data = [],
            color = null;
        while (strArr = TextUtil.HTML_SPILT_PATTERN.exec(htmlText)) {
            strArr.forEach(function(str, i) {
                if (i > 0 && str) { //html做好标记 文本则创建text
                    var first = str.charAt(0); //这里标签少 随便写了 不用正则也可以
                    if (first == '<') {
                        var second = str.charAt(1);
                        switch (second) {
                            case 'f':
                                var hColor = str.match(/0x.+\d/);
                                if (hColor) {
                                    color = hColor[0];
                                }
                                break;
                        }
                        return; //forEach里return只是continue的作用而已
                    }
                    data.push({
                        str: str,
                        color: color
                    });
                }
            });
        }
        return data[0] ? data[0] : {};
    },
    GetRandomColorFromHtmlText: function(htmlText) {
        var regexp = /0x[a-z A-Z 0-9]+/;
        var color = htmlText.match(regexp);
        if (color) {
            return color[0];
        }
        var regexp = /#[a-z A-Z 0-9]+/;
        var color = htmlText.match(regexp);
        if (color) {
            return "0x" + color[0].substring(1, color[0].length);
        }
        return false;
    },
    NumberCutLength: function(num, len) { //数字转成不超过指定长度的数万亿为单位
        var pp = num.toString();
        var str = "";
        if (pp.length > len) {
            //num=(num / 10000).toFixed();
            num = Math.floor(num / 10000);
            str = "万";
            pp = num.toString();
        }
        if (pp.length > len) {
            //num=(num / 10000).toFixed();
            num = Math.floor(num / 10000);
            str = "亿";
            pp = num.toString();
        }
        if (pp.length > len) {
            pp = TextUtil.NumberCutLength(num, len);
        }
        return pp + str;
    },

    /**
     *用date.day(0是周日)
     * @param week
     * @return
     *
     */
    GetWeekStr: function(week) {
        var str = '';
        switch (week) {
            case 0:
                str = "周日";
                break;
            case 1:
                str = "周一";
                break;
            case 2:
                str = "周二";
                break;
            case 3:
                str = "周三";
                break;
            case 4:
                str = "周四";
                break;
            case 5:
                str = "周五";
                break;
            case 6:
                str = "周六";
                break;
            case 7:
                str = "周日";
                break;
            case 8:
                str = "每日";
                break;
        }
        return str;
    },

    GetReslineLayerName: function(layer) {
        var str = "";
        switch (layer) {
            case 1:
                str = "一阶";
                break;
            case 2:
                str = "二阶";
                break;
            case 3:
                str = "三阶";
                break;
            case 4:
                str = "四阶";
                break;
            case 5:
                str = "五阶";
                break;
            case 6:
                str = "六阶";
                break;
            case 7:
                str = "七阶";
                break;
            case 8:
                str = "八阶";
                break;
            case 9:
                str = "九阶";
                break;
            case 10:
                str = "十阶";
                break;
            case 11:
                str = "十一阶";
                break;
            case 12:
                str = "十二阶";
                break;
            case 13:
                str = "十三阶";
                break;
            case 14:
                str = "十四阶";
                break;
            case 15:
                str = "十五阶";
                break;
            case 16:
                str = "十六阶";
                break;
            case 17:
                str = "十七阶";
                break;
            case 18:
                str = "十八阶";
                break;
        }
        return str;
    },
    /**
         * obj===> {"__instanceId": 24639,"type": 36,"contentId": 0,"content": "恭喜玩家{0}成功将{1}{2}进阶到{3},可喜可贺。<a href=\"event:11_1003_#e25b01\"><font color=\"#e25b01\"><u>【我要进阶】</u></font></a>",
          "values": ["<a href=\"event:1_10197305a03a304_s101.银泰城秀_1\"><font color=\"#26c4eb\"><u>s101.银泰城秀</u></font></a>",null,"<font color=\"#01ab25\">白龙女</font>","<font color=\"#01ab25\">红顶替</font>"]}
         * @param obj
         * @returns {{text: [], color: string, linktext: string, type01: string, type02: string, teamId: string, passwd: string, fPower: string, modelId: string}}
         * @constructor
         */
    AnalyzeHtmlInfo: function(obj) {
        var result = {
            text: [],
            color: "",
            linktext: "",
            lData: null,
            obj: obj
        };

        var content = obj.content;

        var index = content.indexOf("<font color=\"#");
        if(index == 0){
            content = content.replace(/<font color=\"#(.{6})/,"<font color=\"#13db97")
        }

        var values = obj.values;

        var regexp = /\{\d+\}/g;
        var content = content.replace(regexp, function(v) {
            var index = v.substring(1, v.length - 1)
            index = parseInt(index);

            return values[index];
        })

        var tempArr = [];
        var tempData = this._ParseText(content);
        for (var i = 0; i < tempData.length; i++) {
            var lData = null;
            var co = tempData[i].color ? tempData[i].color : EnumFontFormat.COMMON_COLOR05;
            var href = tempData[i].isLink
            if(href){
                var regexp = /event:(.+)/;
                var numstr = href.match(regexp);
                if( numstr ){
                    numstr = numstr[1];
                }

                var ssss = numstr.split("_");
                var linkType = Number(ssss[0]);
                lData = Mgr.chat._GetData(linkType,ssss);
            }
            var tempObj = {
                text: tempData[i].str,
                color: co,
                index: obj.content.indexOf(tempData[i].str),
                isLink: tempData[i].underline,
                newline: tempData[i].newline,
                lData: lData,
            };
            tempArr.push(tempObj);
        }

        // 兼容
        if(tempArr.length == 1){
            result.text = TextUtil.RemoveHTMLTag(content);
        }else{
            result.text = tempArr;
        }

        return result;
    },
    _ParseText: function(_htmlText) {
        var self = this;
        var data = [];
        var colorArr = [];
        var color = EnumFontFormat.COMMON_COLOR05;
        var isUnderline = false;
        var isNewLine = false;
        var isLink = null;
        var strArr;
        while (strArr = TextUtil.HTML_SPILT_PATTERN.exec(_htmlText)) {
            strArr.forEach(function(str, i) {
                if (i > 0 && str) { //html做好标记 文本则创建text
                    var first = str.charAt(0); //这里标签少 随便写了 不用正则也可以
                    if (first == '<') {
                        var second = str.charAt(1);
                        switch (second) {
                            case 'u':
                            case 'U':
                                isUnderline = true;
                                break;
                            case 'f':
                            case 'F':
                                var hColor = str.match(/["']#(.+?)["']/);
                                if (hColor) {
                                    color = "0x" + hColor[1];
                                } else
                                    color = self._color;
                                colorArr.push(color);
                                break;
                            case 'a':
                            case 'A':
                                var href = str.match(/href[ ="']+(.*)[ '"]+/);
                                isLink = href && href[1];
                                break;
                            case 'b':
                            case 'B':
                                if (str.charAt(2) == 'r' || str.charAt(2) == 'R')
                                    isNewLine = true;
                                break;
                            case '/':
                                var third = str.charAt(2);
                                switch (third) {
                                    case 'a':
                                    case 'A':
                                        isLink = null;
                                        break;
                                    case 'u':
                                    case 'U':
                                        isUnderline = false;
                                        break;
                                    case 'f':
                                    case 'F':
                                        colorArr.pop();
                                        color = colorArr.length > 0 ? colorArr[colorArr.length - 1] : null;
                                        break;
                                }
                                break;
                        }
                        return; //forEach里return只是continue的作用而已
                    }
                    data.push({
                        str: str,
                        color: color,
                        underline: isUnderline,
                        newline: isNewLine,
                        isLink: isLink
                    });
                    isNewLine = false;
                }
            });
        }
        if (data.length == 0) {
            data.push({
                str: this.RemoveHTMLTag(_htmlText),
                underline: isUnderline,
                newline: isNewLine,
                isLink: isLink
            });
        }
        return data;
    },
}


var GameFont = GameFont || {
    YAHEI: "Microsoft YaHei", // 黑体
    SIMHEI: "SimHei", // 黑体
    SIMSUN: "SimSun", // 宋体
    LISHU: "LiSu", // 隶书
    SIYUANHEI: "NotoSansHans-DemiLight", //"NotoSansHans-Regular", "NotoSansHans-Normal",   //思源黑体
    OLDANDROIDHEI: "Droid Sans Fallback", //老android默认字体 接近黑体


    DEFAULT: "res/font/dfpyuanw7.ttf", // 默认华康圆体W7
}