var U8Util = U8Util || {
    enabled: false,

    Init: function() {
        if (typeof u8 != "undefined") {
            u8.init(this.OnSDKCallBack.bind(this));
            u8.login();

            var channel = this.GetCurrChannel()
            if (channel == null || channel == "") return false;

            this.enabled = true;

            this._tempServer = GameConfig.serverList;
            GameConfig.serverList = [];
            GameConfig.current = null;

            // 初始化网关地址
            var gateway = this.GetGameGateway();
            cc.log("gateway======>>>>",gateway)
            if(gateway) GameConfig.GATEWAY_URL = gateway;
        }

        // TODO test u8 code
//        if(true){
//            this._tempServer = GameConfig.serverList;
//
//            // TODO 获取服务器列表
//            for(var v of GameConfig.serverList){
//                v.LOGIN_TYPE = 2;
//            }
//            GameConfig.current.LOGIN_TYPE = 2;
//
//            var userId = "1"
//            var sdkUserId = "1"
//            var timestamp = new Date().getTime();
//            var extension = ""
//            var appS = "XMUQ7S4DR69EF5C2KO8VPYLZN3ATIG0WBJH1"
//            var src = userId + "-" + sdkUserId + "-" + timestamp + "-" + extension + appS
//            cc.log("========src",src)
//            var token = cc.MD5.GetMD5OfString(src)
//
//            //http://192.168.51.43
//
//            GameMain.u8login = {
//                serverId : "5",
//                agent : "37",
//                userID : userId,
//                username : "1",
//                sdkUserID : sdkUserId,
//                sdkUsername : "1",
//                timestamp : new Long(timestamp.toString(16)),
//                extension : extension,
//                token : token,
//            }
//
//            this.OnLoginSuc(GameMain.u8login);
//            GameConfig.serverList.length = 0
//            GameConfig.current = null;
//            this.enabled = true;
//        }

        return this.enabled;
    },

    GetDevelopInfo: function(key) {
        key = key || "";

        var result;
        if (cc.sys.os == cc.sys.OS_ANDROID) {
            result = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getU8DevelopInfo", "(Ljava/lang/String;)Ljava/lang/String;", key);
        } else if (cc.sys.os == cc.sys.OS_IOS) {
            result = jsb.reflection.callStaticMethod("AppController", "getU8DevelopInfo:",key);
        }

        return result && result != "" ? result : null
    },
    GetCurrChannel: function() {
        var key
        switch(cc.sys.os){
            case cc.sys.OS_ANDROID: key = "U8_ChannelName"; break;
            case cc.sys.OS_IOS: key = "ChannelName"; break;
        }
        return key && this.GetDevelopInfo(key);
    },
    GetGameId:function(){
        var key
        switch(cc.sys.os){
            case cc.sys.OS_ANDROID: key = "U8_APPID"; break;
            case cc.sys.OS_IOS: key = "AppId"; break;
        }
        return key && this.GetDevelopInfo(key);
    },

    GetGameGateway:function(){
        return this.GetDevelopInfo("GAME_GATEWAY_URL");
    },

    GetGameDebug:function(){
        return this.GetDevelopInfo("GAME_DEBUG") === "true";
    },

    OnSDKCallBack: function(type, data) {
        data = data || {}

        cc.log("=============1", JSON.stringify(type))
        cc.log("=============2", JSON.stringify(data))
        cc.log(data.isSwitchAccount)

        switch (type) {
            case "init_suc":
                this.OnInitSuc(data);
                break;
            case "login_suc":
                this.OnLoginSuc(data);
                break;
            case "switch_login":
                this.OnSwitchLogin(data);
                break;
            case "logout":
                this.OnLogout(data);
                break;
        }
    },
    /// u8初始化成功回调
    /// data={
    ///   @isSupportExit
    ///   @isSupportAccountCenter
    ///   @isSupportLogout
    /// }
    OnInitSuc: function(data) {
        //一般不需要做什么处理
    },
    /// u8登录成功回调
    /// data={
    ///   @isSuc
    ///   @isSwitchAccount
    ///   @userID
    ///   @sdkUserID
    ///   @username
    ///   @sdkUsername
    ///   @timstamp
    ///   @token
    /// }
    OnLoginSuc: function(data) {
        data = data || {};

        if (data.isSwitchAccount) {
            //TODO:这里退回到登录界面，并且SDK是已经登录成功状态，不用再弹出SDK的登录界面
        } else {
            //TODO:登录认证成功，获取服务器列表，进入游戏服...
        }
        cc.log("OnLoginSucOnLoginSucOnLoginSucOnLoginSucOnLoginSuc", this)

        GameConfig.u8login = data;

        // 测试模式，直接拉取服务器列表。否则拉取平台信息
        //this.GetGameDebug() ? this.RequestServerList() : this.RequestPlatformInfo();
        this.RequestServerList();
    },
    OnSwitchLogin: function(data) {
        //TODO:退回到登录界面，并弹出SDK登录界面(调用U8SDKInterface::getInstance()->login())
        EnterGameMgr.Logout();
    },
    OnLogout: function(data) {
        //TODO:退回到登录界面，并弹出SDK登录界面(调用U8SDKInterface::getInstance()->login())
        EnterGameMgr.Logout();
    },

    OnRequestServerFailed:function UU__ORSF(m){
        GameConfig.serverList = this._tempServer;
        Mgr.uiMgr.ShowPanelByType(DengLuPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP).ShowDeluUI();

        m = m || "";
        AlertExt.Show(m + "请重新获取服务器列表！",TipsEnum.BUTTON_SURE, {
            _onFunc:function(){
               this.RequestServerList();
            }.bind(this),
        },1);
    },
    OnRequestRoleFailed:function UU__ORSF(m){
        m = m || "";
        AlertExt.Show(m + "请重新获取角色列表！",TipsEnum.BUTTON_SURE, {
            _onFunc:function(){
               this.RequestRoleList();
            }.bind(this),
        },1);
    },
    OnRequestPlatformInfoFailed:function UU__ORSF(m){
        m = m || "";
        AlertExt.Show(m + "请重新获取网关信息！",TipsEnum.BUTTON_SURE, {
            _onFunc:function(){
               this.RequestPlatformInfo();
            }.bind(this),
        },1);
    },

    /// 拉取网关信息
    RequestPlatformInfo:function(){
        var channelKey = this.GetCurrChannel();
        var url = GameConfig.GATEWAY_URL + "getAllPlatform?pf=" + channelKey;
        cc.log("url==>>",url)
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.open("GET", url, true);
        xhr.setRequestHeader("Accept-Charset", "x-user-defined");
        var self = this;
        xhr.onload = function() {
            cc.log("xhr.readyState",xhr.readyState,xhr.status)
            if (xhr.readyState === 4 && xhr.status === 200) {
                var result = JSON.parse(xhr.response);
                cc.log("result==>>",xhr.response);
                if (result && result.state == 0) {
                    var serverList = [];
                    var data = result.data || {};
                    var version = result.version || {};

                    var cdn = data.cdn;
                    var stresver = version.stresver;
                    var dataver = version.dataresver;
                    if(!cdn){
                        this.OnRequestPlatformInfoFailed("连接网关失败！")
                        return
                    }
                    var fixPath = function(path){
                        if( path.charAt(path.length -1) != "/")
                            path += "/";
                        return path;
                    }
                    GameConfig.CDN_URL = fixPath( cdn );
                    if( dataver )
                        GameConfig.CDN_URL += dataver + "/";
                    GameConfig.WEB_CDN_URL = fixPath( cdn );
                    if( stresver )
                        GameConfig.WEB_CDN_URL += stresver + "/";
                    cc.log("更新GameConfig.CDN_URL" + GameConfig.CDN_URL + "  " + GameConfig.WEB_CDN_URL);

                    this.RequestServerList();
                }else{
                    this.OnRequestPlatformInfoFailed("连接网关失败！！！")
                }
            } else {
                this.OnRequestPlatformInfoFailed("连接网关失败！！！")
            }
        }.bind(this);
        xhr.send();
    },

    /// 拉取服务器列表
    RequestServerList:function UU__RSL(){
        var gameId = this.GetGameId();
        var channelKey = this.GetCurrChannel();
        var url = GameConfig.GATEWAY_URL + "getAllServer?gameId=" + gameId + "&pf=" + channelKey;
        cc.log("url==>>",url)
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.open("GET", url, true);
        xhr.setRequestHeader("Accept-Charset", "x-user-defined");
        var self = this;
        xhr.onload = function() {
            cc.log("xhr.readyState",xhr.readyState,xhr.status)
            if (xhr.readyState === 4 && xhr.status === 200) {
                var result = JSON.parse(xhr.response);
                cc.log("result==>>",xhr.response);
                if (result && result.state == 0) {
                    var serverList = [];
                    var data = result.data || [];

                    if(data.length == 0){
                        this.OnRequestServerFailed("服务器列表为空！")
                        return
                    }
                    cc.log(data.length)
                    for (var k = 0, len = data.length, v = data[k]; k != len; v = data[++k]) {
                        serverList.push({
                            SERVER_IP: v.serverAppIp,
                            SERVER_PORT: v.gateMinaServerPort,
                            LOGIN_TYPE: EnumLoginType.App,
                            USER_NAME: "",
                            PASSWORD: "",
                            PLATFORM: v.platformAlias,

                            SERVER_ID: v.serverId,
                            SCALE: 1,
                            NAME: v.serverName,

                            OPENDAYS: v.openDays,
                            OPEN_TIME: v.openTime,
                            STATE: v.state,
                        });
                    }

                    serverList.sort(function(a,b){
                        return b.OPEN_TIME - a.OPEN_TIME;
                    })

                    GameConfig.serverList = serverList;
                    Mgr.uiMgr.ShowPanelByType(DengLuPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP).ShowDeluUI();
                    this.RequestRoleList();
                }else{
                    this.OnRequestServerFailed("拉取服务器失败！！！")
                }
            } else {
                this.OnRequestServerFailed("拉取服务器失败！！！")
            }
        }.bind(this);
        xhr.send();
    },

    /// 拉取玩家列表
    RequestRoleList:function(){
        cc.log("RequestRoleList")
        var type = 1;
        var pf = this.GetCurrChannel();
        var userName = GameConfig.u8login.sdkUserID;
        var time = Math.floor(Date.now() / 1000);
        var key = "NLyGg0ImuB[zw:Nu=CQ[J{SN@>VEI&}4";
        var url = GameConfig.GATEWAY_URL + "doGetUser?type=" + type
            + "&pf=" + pf
            + "&userName=" + userName
            + "&time=" + time
            + "&sign=" + cc.MD5.GetMD5OfString(pf + userName + time + key)
        cc.log("url==>>",url)
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.open("GET", url, true);
        xhr.setRequestHeader("Accept-Charset", "x-user-defined");
        var self = this;
        xhr.onload = function() {
            cc.log("xhr.readyState",xhr.readyState,xhr.status)
            if (xhr.readyState === 4 && xhr.status === 200) {
                var result = JSON.parse(xhr.response);
                cc.log("result==>>",xhr.response);
                if (result && result.code >= 0) {
                    if(result.code == 0){
                         GameConfig.roleData = null;
                    }else{
                        var data = result.data;
                        // 兼容傻逼后台没给serverid
                        for(var i=0;i!=data.length;++i){
                            var v = data[i];
                            if(!v.serverId){
                                var ret = v.roleName.match(/s(\d+)\..+/);
                                if(ret) data[i].serverId = ret[1];
                            }
                        }

                        GameConfig.roleData = data;
                    }

                    if(Mgr.uiMgr.IsPanelShowByName(ChooseServerPanelExt.PanelName)){
                        Mgr.uiMgr.GetPanelByType(ChooseServerPanelExt.PanelName).UpdateSever();
                    }
                }else{
                    this.OnRequestRoleFailed("拉取玩家列表失败！！！")
                }
            } else {
                this.OnRequestRoleFailed("拉取玩家列表失败！！！")
            }
        }.bind(this);
        xhr.send();
    },

    Recharge: function(param) {
        if (!this.enabled) return;

        var data = {}
        data["productId"] = "" + param.productId;
        data["productName"] = param.productName;
        data["productDesc"] = param.productDesc;

        data["price"] = param.moneys;

        data["buyNum"] = 1;
        data["coinNum"] = param.moneys * 10;

        data["serverId"] = GameConfig.current.SERVER_ID.toString();
        data["serverName"] = GameConfig.current.NAME;
        data["roleId"] = Mgr.mainPlayer.oSid.toString(10);
        data["roleName"] = Mgr.player.mainPlayer.name || "";

        data["roleLevel"] = Mgr.player.mainPlayer.attributeData.level;
        data["vip"] = Mgr.player.mainPlayer.VIP;

        data["orderID"] = param.orderId || "";
        data["extension"] = param.ext || "";

        //          params->productId = "1";
        //          params->productName = "元宝";
        //          params->productDesc = "购买100元宝，赠送20元宝";
        //          params->price = 100;
        //          params->buyNum = 1;
        //          params->coinNum = 300;
        //          params->serverId = "10";
        //          params->serverName = "地狱之恋";
        //          params->roleId = "u8_24532452";
        //          params->roleName = "麻利麻利吼";
        //          params->roleLevel = 15;
        //          params->vip = "v15";
        //
        //          //去服务器获取游戏中商品的订单号以及扩展数据,这里测试
        //          params->orderID = "345435634534";
        //          params->extension = "test111";

        u8.pay(data);
    },

    DATA_TYPE : {
        TYPE_SELECT_SERVER : 1,			//选择服务器
        TYPE_CREATE_ROLE : 2,			//创建角色
        TYPE_ENTER_GAME : 3,			//进入游戏
        TYPE_LEVEL_UP : 4,				//等级提升
        TYPE_EXIT_GAME : 5,				//退出游戏
        TYPE_ENTER_COPY : 6,			//进入副本
        TYPE_EXIT_COPY : 7,				//退出副本
        TYPE_VIP_LEVELUP : 8,			//vip升级

        EVENT_PAY_SUCCESS : 1,				//支付成功
        EVENT_GAME_LOADED : 2,				//游戏加载完
        EVENT_PLATFORM_LOGIN_SUCCESS : 3	// 渠道登录成功
    },


    SubmitExtraData:function(type){
        if (!this.enabled) return;

        var data = {};
        data["dataType"] = type;

        data["roleID"]      = Mgr.player.mainPlayer.sid ?Mgr.player.mainPlayer.sid.toString(10) : "";
        data["roleName"]    = Mgr.player.mainPlayer.name  || "";
        data["roleLevel"]   = Mgr.player.mainPlayer.attributeData.level || "";
        data["moneyNum"]    = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumMoney.GOLD, AttributeData.Money) || "";

        data["serverId"] = GameConfig.current.SERVER_ID.toString();
        data["serverName"] = GameConfig.current.NAME;


        cc.log("SubmitExtraData====>>>",JSON.stringify(data))

        // TODO 后续代码分离
        var channelKey = this.GetCurrChannel();
        if(channelKey === "13yx"){
            // TIP 接口不接受空参数，设置默认0
            var url = "http://logcollect.13yx.com/logcollect/data/get/loginChooseServer"
            var token = "hbb81G19SIibvnFw";
            var param = {}
            param["eventTime"]      = Date.now();
            param["uid"]            = GameConfig.u8login ? GameConfig.u8login.sdkUserID : "0";
            param["gid"]            = NativeUtil.getApplicationMetaData("AppID") || "0";
            param["playerName"]     = data.roleName || "0";
            param["channel"]        = channelKey || "0";
            param["playerId"]       = data.roleID || "0";
            param["playerLevel"]    = data.roleLevel || "0";
            param["packageId"]      = NativeUtil.getAppPackageName() || "0";
            param["eventId"]        = data.roleID + "" + param["eventTime"];
            param["serverId"]       = data.serverId || "0";

            for(var k in param){
                param[k] = encodeURI(param[k]);
            }

            param["sign"]           = ""
                + "channel=" + param.channel
                + "&eventId=" + param.eventId
                + "&eventTime=" + param.eventTime
                + "&gid=" + param.gid
                + "&packageId=" + param.packageId
                + "&playerId=" + param.playerId
                + "&playerLevel=" + param.playerLevel
                + "&playerName=" + param.playerName
                + "&serverId=" + param.serverId
                + "&uid=" + param.uid
                + token;

            param["sign"] = cc.MD5.GetMD5OfString(param.sign);

            url += "?"
                + "channel=" + param.channel
                + "&eventId=" + param.eventId
                + "&eventTime=" + param.eventTime
                + "&gid=" + param.gid
                + "&packageId=" + param.packageId
                + "&playerId=" + param.playerId
                + "&playerLevel=" + param.playerLevel
                + "&playerName=" + param.playerName
                + "&serverId=" + param.serverId
                + "&uid=" + param.uid
                + "&sign=" + param.sign

            cc.log(url)

            var xhr = cc.loader.getXMLHttpRequest();
            xhr.open("POST", url, true);
            xhr.setRequestHeader("Accept-Charset", "x-user-defined");
            var self = this;
            xhr.onload = function() {
                cc.log("xhr.readyState",xhr.readyState,xhr.status)
                if (xhr.readyState === 4 && xhr.status === 200) {
                    var result = JSON.parse(xhr.response);
                    cc.log("result==>>",xhr.response);
                    if (result && result.success >= 0) {

                    }
                }
            }.bind(this);
            xhr.send();
            return;
        }

        u8.submitData(data);
    },
}